

/* файл js. версия 2 */

var mas_obj_init_bbeditor_boxcode = {};

function create_bbeditor_boxcode(name_create,text,setup_editor)
  {
   var obj = new bbeditor_boxcode(name_create,setup_editor);
   if ( typeof( text ) == "undefined" ) text = false;
   if ( text !== false )
     obj.set_value(text);
   return (obj);
  }

function bbeditor_boxcode(name_create,setup_editor)
  {
   
   this.name_form = "";
   this.name_pf_text = "";
   if ( typeof(name_create) == "object" )
     {
      this.name_form = name_create[0];
      this.name_pf_text = name_create[1];
     }
    else
      this.name_pf_text = name_create;
   this.name_create = name_create;
   this.name_editor = (this.name_form ? this.name_form+"_":"") + this.name_pf_text;
   this.on_create_editor = false;
   
   this.obj_main_block = false;
   this.url_editor = "";
   this.obj_pole_text = false;
   
   this.mas_init_button_function = [];
   
   this.is_caretPos = false;// для браузера ie
   this.caretPos = false;// для браузера ie
   this.old_value = "";
   
   this.ver_panel_button = {
     "fullcomplete" : 
      [
       ["size","-","font","-","list1","list"],
       ["b","i","u","s","-","url","email","img","-","left","center","right","justify","-","color","-","code","quote"]
      ],
     "default" : 
      [
       ["b","i","u","s","-","url","email","img","-","left","center","right","justify","-","color","-","list1","list"]
      ]
    };
   
   this.init_panel_button = this.ver_panel_button["default"];
   
   var obj_editor = this;
   
   if ( typeof( setup_editor ) == "undefined" ) setup_editor = {};
   
   this.setup_editor = {
     "width" : setup_editor.width || "500px",
     "height" : setup_editor.height || "200px"
    };
   
   if ( setup_editor.toolbar )
     {
      //alert( typeof( setup_editor.toolbar ) );
      if ( typeof( setup_editor.toolbar ) == "string" )
        {
         if ( typeof( this.ver_panel_button[setup_editor.toolbar] ) != "undefined" )
           this.init_panel_button = this.ver_panel_button[setup_editor.toolbar];
        }
       else
        this.init_panel_button = setup_editor.toolbar;
      
     }
   
   mas_obj_init_bbeditor_boxcode[this.name_editor] = this;
   
   this.set_url_file_script = function()
     {
      this.url_editor = get_src_name_script("bbeditor_boxcode.js");
      //alert("url: "+this.url_editor);
     }
   
   this.get_value = function()
     {
      return (this.obj_pole_text.value);
     }
   
   this.set_value = function(v)
     {
      this.obj_pole_text.value = v;
     }
   
   this.load_file_css_editor = function()
     {
      var css=document.createElement("link");
      css.setAttribute("rel", "stylesheet");
      css.setAttribute("type", "text/css");
      css.setAttribute("href", this.url_editor+"bbeditor_boxcode.css");
      var mas_obj = document.getElementsByTagName("head");
      if ( mas_obj.length )
        {
         mas_obj[0].appendChild(css);
        }
     }
   
   this.check_is_create_editor = function()
     {
      var is_create = false;
      //var obj_mas = document.getElementsByName(this.name_editor);
      var obj = this.get_obj_pf_text();
      if ( obj )//obj_mas.length
        {
         var obj_main_block = document.getElementById("block_button_bbeditor_"+this.name_editor);
         if ( obj_main_block ) is_create = true;
        }
      
      return (is_create);
     }
   
   this.add_value_endpos = function(v,quantity_newline)
     {
      if ( typeof(quantity_newline) == "undefined" ) quantity_newline = 1;
      var v_editor = this.get_value();
      //v =  + "\n" + v;
      var t_newline = "\n";
      if (quantity_newline && quantity_newline > 0) for (var i = 0; i < quantity_newline; i++ ) t_newline += "\n";
      this.obj_pole_text.value = ( v_editor ? v_editor + t_newline : "" ) + v;
     }
   
   this.create_editor = function()
     {
      this.load_file_css_editor();
      this.create_main_block();
      if ( this.on_create_editor )
        {
         this.forming_html_buttons();
         //this.set_function_button();
         this.get_obj_pole();
         this.set_value(this.old_value);
        }
     }
   
   this.create_main_block = function()
     {
      
      //var obj_mas = document.getElementsByName(this.name_editor);
      var obj_pf_text = this.get_obj_pf_text();
      if ( obj_pf_text )//obj_mas.length
        {
         var obj_pole = obj_pf_text;// obj_mas[0];
         this.old_value = obj_pole.value;
         var new_elem = document.createElement("div");
         var new_obj = obj_pole.parentNode.replaceChild(new_elem,obj_pole);
         this.obj_main_block = new_elem;
         
         this.obj_main_block.className = "block_main_bbeditor_boxcode";
         this.obj_main_block.style.maxWidth = this.setup_editor.width;
         
         this.create_html_code_main();
         this.on_create_editor = true;
        }
      
      
     }
   
   this.create_html_code_main = function()
     {
      var t = "";
      
      t += "<div style='max-width: "+this.setup_editor.width+"; '>";
      t += "<div id='block_button_bbeditor_"+this.name_editor+"' class='block_button_bbeditor_boxcode'></div>";
      t += "<div class='block_contr_pole_text_bbeditor_boxcode'>"
         +"<div class='block_contr_pole_text_bbeditor_boxcode_p'>"
         +"<textarea name='"+this.name_pf_text+"' style=' height: "+this.setup_editor.height+";' class='pole_text_bbeditor_boxcode' "+this.forming_event_handler_pole_text()+"></textarea>"
         +"</div></div>";
      t += "</div>";
      
      this.obj_main_block.innerHTML = t;
     }
   
   this.forming_event_handler_pole_text = function()
     {
      var t = "";
      
      if ( document.selection )
       t += " onSelect='is_track_ie_bbeditor_boxcode(\""+this.name_editor+"\")' onClick='is_track_ie_bbeditor_boxcode(\""+this.name_editor+"\")' onKeyUp='is_track_ie_bbeditor_boxcode(\""+this.name_editor+"\")' onChange='is_track_ie_bbeditor_boxcode(\""+this.name_editor+"\")' ";
      
      return (t);
     }
   
   this.get_obj_pf_text = function()
     {
      var obj = false;
      if ( this.name_form )
        {
         obj = (document.forms[this.name_form] ? document.forms[this.name_form].elements[this.name_pf_text] : false);
        }
       else
         {
          var obj_mas = document.getElementsByName(this.name_pf_text);
          if ( obj_mas.length ) obj = obj_mas[0];
         }
      
      return (obj);
     }
   
   this.forming_html_buttons = function()
     {
      var t = "";
      this.mas_init_button_function = [];
      
      t+= "<div class='block_button_bbeditor_boxcode_contr'>";
      var i,j,n,one_collection,mas_collection,name_button,one_button,t_one;
      var t_sep_hr = "<div class='block_separator_hr_button_bbeditor_boxcode'></div>";
      var t_sep_vr = "<div class='block_separator_vr_button_bbeditor_boxcode'></div>";
      var t_on_sep_hr = "";
      //var t_on_sep_vr = "";
      for ( i = 0; i < this.init_panel_button.length; i++ )
        {
         if ( this.init_panel_button[i].length == 0 ) continue;
         t+= t_on_sep_hr;
         t_on_sep_hr = t_sep_hr;
         t+="<div class='block_one_row_button_bbeditor_boxcode'>";
         t+="<div class='block_one_row_button_bbeditor_boxcode_contr'>";
         //t_on_sep_vr = "";
         for ( j = 0; j < this.init_panel_button[i].length; j++ )
           {
            name_button = this.init_panel_button[i][j];
            if ( name_button == "" ) continue;
            //mas_collection = one_collection.split(",");
            //t += t_on_sep_vr;
            if ( name_button == "-" )
              {
               t += t_sep_vr;
               continue;
              }
            //for ( n = 0; n < mas_collection.length; n++ )
              {
               //name_button = mas_collection[n];
               
               t_one = this.forming_one_button(name_button);
               if ( t_one )
                 {
                  this.mas_init_button_function[this.mas_init_button_function.length] = name_button;
                  t += t_one;
                 }
               
              }
            
           }
         t+="<div class='elm_clear_float_bbeditor_boxcode'></div>";
         t+="</div>";
         t+="</div>";
        }
      
      t+= "</div>";
      
      var obj = document.getElementById("block_button_bbeditor_"+this.name_editor);
      if ( obj )
        obj.innerHTML = t;
      //alert(t);
     }
   
   this.forming_one_button = function(name_button)
     {
      var t = "";
      if ( !this.mas_init_button[name_button] ) return ("");
      
      var one_button = this.mas_init_button[name_button];
      t += '<div id = "btn_bbeditor_boxcode_contr_'+this.name_editor+'_'+name_button+'" class="btn_bbeditor_boxcode_contr">';
      if ( one_button.html )
        {
         t += jsStringReplace(one_button.html,"{name_editor}",this.name_editor);
        }
      
      t += '<div id="btn_bbeditor_boxcode_'+this.name_editor+'_'+name_button+'" '
        + ' onclick="processing_bbeditor_boxcode(\''+this.name_editor+'\',\''+name_button+'\')" class="btn_bbeditor_boxcode" '
        + ' style = " background-image: url(\''+this.url_editor+'img_editor/'+one_button.img+'\'); background-position: center center; background-repeat: no-repeat; " '
        + ' title="'+jsCodeHtmlChars(one_button["help"])+'" '
        +'>';
      
      //t += '<img src="'+this.url_editor+'img_editor/'+one_button.img+'" title="'+jsCodeHtmlChars(one_button["help"])+'">';
      t += '</div>';
      t += '</div>';
      return (t);
     }
   /*
   this.set_function_button = function()
     {
      var i,name_button,obj;
      for ( i = 0; i < this.mas_init_button_function.length; i++ )
        {
         name_button = this.mas_init_button_function[i];
         obj = document.getElementById("btn_bbeditor_boxcode_"+this.name_editor+"_"+name_button);
         if ( obj )
           {
            obj.onclick = function (){ obj_editor.on_click_button(name_button); };
           }
         
        }
      
     }
   */
   
   this.get_obj_pole = function ()
     {
      //var mas_obj = document.getElementsByName(this.name_editor);
      var obj = false;
      var obj_pf_text = this.get_obj_pf_text();
      //if ( mas_obj.length ) obj = mas_obj[0];
      if ( obj_pf_text ) obj = obj_pf_text;
      this.obj_pole_text = obj;
      return (obj);
     }
   
   
   this.check_selected_text = function ()
     {
      var is_selected = false;
      var s_text = "";
      this.obj_pole_text.focus();
      
      if ( document.selection )
        {
         // для IE
         if ( this.obj_pole_text.createTextRange && this.caretPos )
           {
            //alert("on");
            //var obj_t = document.selection.createRange().duplicate();
            //s_text = obj_t.text;
            s_text = this.caretPos.text;
            if ( s_text ) is_selected = true;
           }
          else
            {
             //alert("off");
            }
         
        }
       else
         {
          if ( typeof( this.obj_pole_text.selectionStart ) != "undefined" )
            {
             if ( this.obj_pole_text.selectionStart != this.obj_pole_text.selectionEnd )
               {
                is_selected = true;
                s_text = this.obj_pole_text.value.substring(this.obj_pole_text.selectionStart,this.obj_pole_text.selectionEnd);
               }
            }
         }
      //alert(s_text);
      return ( {"selected":is_selected, "text":s_text} );
     }
   
   this.insert_text_pole = function (start_text,end_text)
     {
      this.obj_pole_text.focus();
      
      if ( document.selection )
        {
         // для IE
         if ( this.obj_pole_text.createTextRange && this.caretPos )
           {
            //alert("on");
            //var obj_t = document.selection.createRange().duplicate();
            //var s_text = obj_t.text;
            var s_text = this.caretPos.text;
            var new_text = start_text + s_text + end_text;
            //document.selection.createRange().duplicate().text = new_text;
            this.caretPos.text = new_text;
            //document.selection.createRange().duplicate().select();
            this.caretPos.select();
            
           }
          else
            {
             //alert("off");
             this.obj_pole_text.value = this.obj_pole_text.value + start_text + end_text;
            }
         
        }
       else
         {
          if ( typeof( this.obj_pole_text.selectionStart ) != "undefined" )
            {
             /*
             if ( this.obj_pole_text.selectionStart == this.obj_pole_text.selectionEnd )
               {
                is_selected = true;
                s_text = this.obj_pole_text.value.substring(this.obj_pole_text.selectionStart,this.obj_pole_text.selectionEnd);
               }
             */
             
             var value = this.obj_pole_text.value;
             var s1 = value.substring(0,this.obj_pole_text.selectionStart);
             var s2 = value.substring(this.obj_pole_text.selectionStart,this.obj_pole_text.selectionEnd);
             var s3 = value.substring(this.obj_pole_text.selectionEnd,value.length);
             
             
             value = s1+start_text+s2+end_text+s3;
             this.obj_pole_text.value = value;
             this.obj_pole_text.selectionStart = s1.length;
             this.obj_pole_text.selectionEnd = (s1+start_text+s2+end_text).length;
            }
         }
      
     }
   
   this.on_click_button = function(name_button)
     {
      //alert(name_button);
      
      if ( !this.mas_init_button[name_button] ) return;
      
      var one_button = this.mas_init_button[name_button];
      var d_selected = this.check_selected_text();
      
      //alert(d_selected.selected +" "+ d_selected.text);
      
      if ( one_button.f )
        {
         one_button.f(this.name_editor,this,d_selected);
         return;
        }
      
      this.insert_text_pole(one_button["open"],one_button["close"])
      
     }
   
   this.focus = function()
     {
      this.obj_pole_text.focus();
     }
   
   this.storeCaret = function()
     {
      // для браузера ie
      if ( this.obj_pole_text.createTextRange )
         {
		  this.caretPos = document.selection.createRange().duplicate();
		  
		 }
     }
   
   this.mas_init_button = 
    {
     "b" : { "html": "", "img": "button_b.png", "help":"полужирый", "open":"[b]", "close":"[/b]", "f": false  },
     "i" : { "html": "", "img": "button_i.png", "help":"курсив", "open":"[i]", "close":"[/i]", "f": false },
     "u" : { "html": "", "img": "button_u.png", "help":"подчеркнутый", "open":"[u]", "close":"[/u]", "f": false },
     "s" : { "html": "", "img": "button_s.png", "help":"перечеркнутый", "open":"[s]", "close":"[/s]", "f": false },
     "url" : { "html": "", "img": "button_url.png", "help":"вставить ссылку", "open":"", "close":"", "f": functions_bbeditor_boxcode.fn_bbeditor_boxcode_url },
     "email" : { "html": "", "img": "button_email.png", "help":"вставить E-mail", "open":"", "close":"", "f": functions_bbeditor_boxcode.fn_bbeditor_boxcode_email },
     "img" : { "html": "", "img": "button_img.png", "help":"вставить изображение", "open":"", "close":"", "f": functions_bbeditor_boxcode.fn_bbeditor_boxcode_img },
     
     "left" : { "html": "", "img": "button_left.png", "help":"выравнивание по левому краю", "open":"[left]", "close":"[/left]", "f": false },
     "right" : { "html": "", "img": "button_right.png", "help":"выравнивание по правому краю", "open":"[right]", "close":"[/right]", "f": false },
     "center" : { "html": "", "img": "button_center.png", "help":"выравнивание по центру", "open":"[center]", "close":"[/center]", "f": false },
     "justify" : { "html": "", "img": "button_justify.png", "help":"выравнивание по левому и правому краю", "open":"[justify]", "close":"[/justify]", "f": false },
     
     "list1" : { "html": "", "img": "button_list1.png", "help":"вставить нумерованный список", "open":"", "close":"", "f": functions_bbeditor_boxcode.fn_bbeditor_boxcode_list1 },
     "list" : { "html": "", "img": "button_list.png", "help":"вставить список", "open":"", "close":"", "f": functions_bbeditor_boxcode.fn_bbeditor_boxcode_list },
     
     "size" : { "html": "<div class='block_html_btn_bbeditor_boxcode'> размер <select name='size_bbeditor_boxcode_{name_editor}'>"
                        +"<option value='6'>6</option>"
                        +"<option value='7'>7</option>"
                        +"<option value='8'>8</option>"
                        +"<option value='9'>9</option>"
                        +"<option value='11'>11</option>"
                        +"<option value='12' selected='selected'>12</option>"
                        +"<option value='13'>13</option>"
                        +"<option value='14'>14</option>"
                        +"</select></div>", "img": "button_on.png", "help":"размер шрифта", "open":"", "close":"", "f": functions_bbeditor_boxcode.fn_bbeditor_boxcode_size },
     
     "font" : { "html": "<div class='block_html_btn_bbeditor_boxcode'> шрифт <select name='font_bbeditor_boxcode_{name_editor}'>"
                        +"<option value='sans-serif'>sans-serif</option>"
                        +"<option value='serif'>serif</option>"
                        +"<option value='cursive'>cursive</option>"
                        +"<option value='fantasy'>fantasy</option>"
                        +"<option value='monospace'>monospace</option>"
                        +"</select></div>", "img": "button_on.png", "help":"размер шрифта", "open":"", "close":"", "f": functions_bbeditor_boxcode.fn_bbeditor_boxcode_font },
     
     "code" : { "html": "", "img": "button_code.png", "help":"код", "open":"[code]", "close":"[/code]", "f": false },
     "quote" : { "html": "", "img": "button_quote.png", "help":"цитата", "open":"[quote]", "close":"[/quote]", "f": false },
     "color" : { "html": "", "img": "button_color.png", "help":"цвет шрифта", "open":"", "close":"", "f": functions_bbeditor_boxcode.fn_bbeditor_boxcode_color }
     
    }
   /*
   this.init_panel_button = 
    [
     ["size","-","font","-","list1","list"],
     ["b","i","u","s","-","link","email","img","-","left","center","right","justify","-","color","-","code","quote"]
    ];
   */
   
   
   //alert(this.name_editor);
   //alert(location.href);
   
   this.set_url_file_script();
   this.create_editor();
   //this.create_html_code();
   
   
  }



function processing_bbeditor_boxcode(name_editor,name_button)
  {
   //alert(name_editor+" "+name_button);
   var obj_editor = mas_obj_init_bbeditor_boxcode[name_editor];
   //alert(obj_editor.name_editor);
   obj_editor.on_click_button(name_button);
   
  }


function is_track_ie_bbeditor_boxcode(name_editor)
  {
   //alert(name_editor+" "+name_button);
   var obj_editor = mas_obj_init_bbeditor_boxcode[name_editor];
   //alert(obj_editor.name_editor);
   obj_editor.storeCaret();
   
  }


var functions_bbeditor_boxcode =
  {
   
   fn_bbeditor_boxcode_url : function(name_editor,obj_editor,d_selected)
     {
      //alert(name_editor);
      
      var open = "";
      var close = "";
      
      if ( d_selected.selected )
        {
         var url_link=prompt ("Введите url-ссылки","http://");
         if ( !url_link ) return;
         
         open = "[url="+url_link+"]";
         close = "[/url]";
         
        }
       else
         {
          var url_link=prompt ("Введите url-ссылки","http://");
          if ( !url_link ) return;
          var text_link=prompt ("Введите название ссылки","");
          if ( !text_link ) return;
          open = "[url="+url_link+"]"+text_link+"[/url]";
          close = "";
         }
      
      obj_editor.insert_text_pole(open,close);
     },
   
   fn_bbeditor_boxcode_email : function(name_editor,obj_editor,d_selected)
     {
      //alert(name_editor);
      
      var open = "";
      var close = "";
      
      if ( d_selected.selected )
        {
         var url_email = prompt ("Введите Email адрес","mailto:");
         if ( !url_email ) return;
         
         open = "[email="+url_email+"]";
         close = "[/email]";
         
        }
       else
         {
          var url_email = prompt ("Введите Email адрес","mailto:");
          if ( !url_email ) return;
          var text_email = prompt ("Введите название Email","");
          if ( !text_email ) return;
          open = "[email="+url_email+"]"+text_email+"[/email]";
          close = "";
         }
      
      obj_editor.insert_text_pole(open,close);
     },
   
   fn_bbeditor_boxcode_img : function(name_editor,obj_editor,d_selected)
     {
      //alert(name_editor);
      
      var open = "";
      var close = "";
      
      //if ( d_selected.selected )
        {
         var url_img = prompt ("Введите полный URL изображения","http://");
         if ( !url_img ) return;
         
         open = "";
         close = "[img="+url_img+"][/img]";
         
        }
      /*
       else
         {
          var url_email = prompt ("Введите Email адрес","mailto:");
          if ( !url_email ) return;
          var text_email = prompt ("Введите название Email","");
          if ( !text_email ) return;
          open = "[email="+url_email+"]"+text_email+"[/email]";
          close = "";
         }
      */
      obj_editor.insert_text_pole(open,close);
     },
   
   fn_bbeditor_boxcode_list1 : function(name_editor,obj_editor,d_selected)
     {
      //alert(name_editor);
      
      var open = "";
      var close = "";
      
      var text = "";
      var one = "";
      while ( one = prompt("Введите элемент списка (для прекращения нажмите 'отмена' или оставте поле пустым)","") )
        {
         text+="[*]"+one;
        }
      
      if ( !text ) return;
      
      open = "";
      close = "[list=1]"+text+"[/list]";
      
      obj_editor.insert_text_pole(open,close);
     },
   
   fn_bbeditor_boxcode_list : function(name_editor,obj_editor,d_selected)
     {
      //alert(name_editor);
      
      var open = "";
      var close = "";
      
      var text = "";
      var one = "";
      while ( one = prompt("Введите элемент списка (для прекращения нажмите 'отмена' или оставте поле пустым)","") )
        {
         text+="[*]"+one;
        }
      
      if ( !text ) return;
      
      open = "";
      close = "[list]"+text+"[/list]";
      
      obj_editor.insert_text_pole(open,close);
     },
   
   fn_bbeditor_boxcode_size : function(name_editor,obj_editor,d_selected)
     {
      //alert(name_editor);
      
      var open = "";
      var close = "";
      
      var text = "";
      var one = "";
      
      var mas_obj = document.getElementsByName("size_bbeditor_boxcode_"+name_editor);
      
      var value = mas_obj[0].value;
      //alert(value);
      open = "[size="+value+"]";
      close = "[/size]";
      
      obj_editor.insert_text_pole(open,close);
     },
   
   fn_bbeditor_boxcode_font : function(name_editor,obj_editor,d_selected)
     {
      //alert(name_editor);
      
      var open = "";
      var close = "";
      
      var text = "";
      var one = "";
      
      var mas_obj = document.getElementsByName("font_bbeditor_boxcode_"+name_editor);
      
      var value = mas_obj[0].value;
      //alert(value);
      open = "[font="+value+"]";
      close = "[/font]";
      
      obj_editor.insert_text_pole(open,close);
     },
   
   fn_bbeditor_boxcode_color : function(name_editor,obj_editor,d_selected)
     {
      //alert(name_editor);
      
      var obj_contr_button = document.getElementById("btn_bbeditor_boxcode_contr_"+name_editor+"_color");
      var obj_row = obj_contr_button.offsetParent;
      
      var id_main_block_color = "block_contr_fn_color_bbeditor_boxcode_"+name_editor;
      var obj_main_block_color = document.getElementById(id_main_block_color);
      
      if ( obj_main_block_color )
        {
         obj_main_block_color.style.display = "block";
         
        }
       else
         {
          
          //alert(obj_contr_button);
          
          var new_elem = document.createElement("div");
          
          var new_obj = obj_contr_button.appendChild(new_elem);
          new_obj.id = id_main_block_color;
          new_obj.className = "main_block_fn_color_bbeditor_boxcode";
          
          
          var mas_color =
           [
             ["#FF8080" , "#80FF80" , "#80FFFF" , "#0080FF" , "#FF80C0" , "#FF80FF"],
             ["#FF0000" , "#FFFF00" , "#00FF40" , "#00FFFF" , "#0080C0" , "#8080C0"],
		     ["#804040" , "#FF8040" , "#00FF00" , "#004080" , "#8080FF" , "#FF0080"],
		     ["#800000" , "#FF8000" , "#008000" , "#0000FF" , "#0000A0" , "#8000FF"],
             ["#000000" , "#808040" , "#808080" , "#C0C0C0" , "#400040" , "#FFFFFF"]
	       ];
          
          var t = "";
          
          t += "<div class='contr_block_fn_color_bbeditor_boxcode'>";
          for ( var i = 0; i < mas_color.length; i++ )
            {
             for ( var j = 0; j < mas_color[i].length; j++ )
               {
                t += "<div class='block_one_color_bbeditor_boxcode' style=' background: "+mas_color[i][j]+";' "
                +" onclick = 'functions_bbeditor_boxcode.fn_bbeditor_boxcode_color_on(\""+name_editor+"\",\""+mas_color[i][j]+"\")' "
                +">&nbsp;</div>";
               }
             t += "<div class='elm_clear_float_bbeditor_boxcode'></div>";
            }
          
          t += "<div class='block_cancel_color_bbeditor_boxcode' onclick='functions_bbeditor_boxcode.fn_bbeditor_boxcode_color_cancel(\""+name_editor+"\")'></div>";
          t += "</div>";
          
          new_obj.innerHTML = t;
          obj_main_block_color = new_obj;
         }
      
      if ( obj_row.offsetWidth > obj_contr_button.offsetLeft + 22 + obj_main_block_color.offsetWidth )
        obj_main_block_color.style.left = "0px";
       else
         obj_main_block_color.style.left = "-"+(obj_main_block_color.offsetWidth-22)+"px";
      
     },
   
   fn_bbeditor_boxcode_color_on : function(name_editor,num_color)
     {
      //alert(name_editor+" "+num_color);
      var obj_editor = mas_obj_init_bbeditor_boxcode[name_editor];
      
      var id_main_block_color = "block_contr_fn_color_bbeditor_boxcode_"+name_editor;
      
      if ( document.getElementById(id_main_block_color) )
        {
         document.getElementById(id_main_block_color).style.display = "none";
        }
      
      var open = "";
      var close = "";
      
      open = "[color="+num_color+"]";
      close = "[/color]";
      
      obj_editor.insert_text_pole(open,close);
      
     },
   
   fn_bbeditor_boxcode_color_cancel : function(name_editor)
     {
      var id_main_block_color = "block_contr_fn_color_bbeditor_boxcode_"+name_editor;
      
      if ( document.getElementById(id_main_block_color) )
        {
         document.getElementById(id_main_block_color).style.display = "none";
        }
      
     }
   
  }

