<?php


class tpl_dmk_block_for
  {
   
   function __construct()
     {
      //$this->init();
     }
   
   function init()
     {
      
     }
   
   function init_tegs()
     {
      //возвращаем все дополнительные возможные теги блока, то есть все кроме открывающего и закрывающего
      return ( array() );//"else","elseif"
     }
   
   function driver($name,$str_params,$compiler,$previous_tag)
     {
      $t = "";
      $is = false;
      $is_open_teg = false;
      
      if ( $name === "for" )
        {
         $params = $compiler->parse_str_attribute($str_params);
         //var_dump($params);
         if ( $params === false ) return($compiler->alert_error("синтаксическая ошибка в блоке for."));
         
         if ( empty($params["loop"]) ) return ($compiler->alert_error("в блоке for отсутствует параметр 'loop'"));
         if ( empty($params["value"]) ) return ($compiler->alert_error("в блоке for нужно указать параметр 'value'"));
         
         if ( !isset($params["start"]) )
           $params["start"] = 0;
          else
            $params["start"] = $compiler->parseCodeString($params["start"]);
         /* elseif ( is_numeric(trim($params["start"])) )
            $params["start"] = trim($params["start"]);
           else
             return ($compiler->alert_error("параметр 'start' может быть только числом"));
         */
         
         if ( !isset($params["step"]) )
           $params["step"] = 1;
          else
            $params["step"] = $compiler->parseCodeString($params["step"]);
         /* elseif ( is_numeric(trim($params["step"])) )
            $params["step"] = trim($params["step"]);
           else
             return ($compiler->alert_error("параметр 'step' может быть только числом"));
         */
         
         if ( empty($params["value"]) )
           $params["value"] = "";
          else
            $params["value"] = $compiler->setvarname($params["value"]);
         /*
         if ( is_numeric(trim($params["loop"])) )
           $params["loop"] = trim($params["loop"]);
          else
            return ($compiler->alert_error("в блоке for параметр 'loop' должен быть только числом."));
         */
         
         $params["loop"] = $compiler->parseCodeString($params["loop"]);
         
         $is = true;
         $is_open_teg = true;
         
         $t = ' for ( '.$params["value"].' = '.$params["start"]."; ".$params["value"]." < ".$params["loop"]." ; ".$params["value"].' += '.$params["step"].' ):';
         
        }/*
       elseif ( $name === "foreachelse" )
         {
          $is = true;
          $t = "endforeach; else: ";
          
         }
         /*
        elseif ( $name === "elseif" )
          {
           $params = $compiler->parseCodeString($str_params,false);
           if ( $params === false ) return(false);
           $is = true;
           $t = " elseif ( ".$params." ): ";
           
          }
          */
         elseif ( $name === "close" )
           {
            $is = true;
            //if ( $previous_tag !== "foreachelse" )
            //  $t = "endforeach; ";
            $t .= " endfor;";
           }
      
      if ( $is )
        {
         return (array($t,$is,$is_open_teg));
        }
       else
         return ($compiler->alert_error("Неизвестный оператор"));
     }
   
   
  }





