<?php

include_once("../config/config.php");
include_once(DIR_CMS."/generalscript/init_work_st.php");

$error=0;$error_text="no";
$rez="";


class oper_user_profile
{
  protected $num_user = 0;
  
  protected $on_user = false;
  protected $name_user_authoriz=false;
  protected $data_auth_user=false;
  
  //protected $quantity_basket = 0;
  //protected $data_basket = array();
  //protected $data_promocode = array();
  
  protected $type="";
  protected $image_user_width=200;
  protected $image_user_height=200;
  
  function __construct()
    {
      global $masConfig;
      $this->image_user_width=$masConfig["REGISTR_USER_IMG_WIDTH"];
      $this->image_user_height=$masConfig["REGISTR_USER_IMG_HEIGHT"];
    }
  
  function start()
    {
      $error=0;
      $error_text="";
      
      $this->check_auth_user();
      
      if (!$this->on_user) return ([1,"Вы не авторизованы! Доступ запрещен!",""]);
      
      $contr_code=($_POST["contr_code"] ?? "");
      if (!$contr_code) return ([1,"Не указан ключ безопасности!",""]);
      
      if ( !eng_promote_safety::check_code($this->num_user,$contr_code) ) return ([1,"Неверный ключ безопасности!",""]);
      
      $this->type = ($_POST["type"] ?? "");
      $data=false;
      
      if ($this->type == "upload_image")
        {
          list($error,$error_text,$data)=$this->upload_image();
        }
      elseif ($this->type == "delete_image")
        {
          list($error,$error_text,$data)=$this->action_delete_image();
        }
      
      else
        {
          $error = 1;
          $error_text = "Ошибка с параметрами!";
        }
      
      $rez="";
      
      if ($data)
        $rez="data:{".encode_gen_mas_to_jointext($data,false,true)."} ";
       else
         $rez="data:{}";
      
      return ([$error,$error_text,$rez]);
    }
  
  function check_auth_user()
    {
      if ($GLOBALS["user_to_site"] && $GLOBALS["id_user_to_site"] > 0)
        {
          $this->num_user = $GLOBALS["id_user_to_site"];
          $this->name_user_authoriz = $GLOBALS["name_user_to_site"];
          $this->data_auth_user = $GLOBALS["data_authorize_user"];
          $this->on_user = true;
        }
    }
  
  function upload_image()
    {
      $error=0;
      $error_text="";
      $data=false;
      $name_file="";
      $on_upload=0;
      
      $d_file=save_upload_file("new_image_user",DIR_CMS."/".NAME_DIR_LOADFILES. "/user_image/",true,false,"jpg|jpeg|png|gif","tosize",
        $this->image_user_width,$this->image_user_height,50000000,"","",0,0,"",1,true);
      //write_log_cms($d_file,"d file");
      
      if (!$d_file[0])
        {
          $name_file=$d_file[1];
          $on_upload=1;
          $this->replace_user_image_db($name_file);
          $this->delete_user_image();
        }
       /*else
         {
           //$error=1;
           //$error_text="Ошибка с загрузкой файла!";
         }*/
      
      $data=["on_upload"=>$on_upload,"name_file"=>$name_file];
      
      return ([$error,$error_text,$data]);
    }
  
  function replace_user_image_db($name_file)
    {
      $m_data=["id_user"=>$this->num_user,"image_user"=>$name_file];
      $db_query=forming_db_query_indexmas(DB_PREF."users",$m_data,"edit","id_user");
      
      db_work::query($db_query);
      
    }
  
  function delete_user_image()
    {
      $img_delete=$this->data_auth_user["image_user"];
      if ($img_delete)
        {
          delete_file(DIR_CMS."/".NAME_DIR_LOADFILES."/user_image/", $img_delete);
        }
      
      return (true);
    }
  
  function action_delete_image()
    {
      $error=0;
      $error_text="";
      $data=false;
      
      if ($this->data_auth_user["image_user"] != "")
        {
          $this->delete_user_image();
          $this->replace_user_image_db("");
        }
      
      $data=["on_delete"=>1];
      
      return ([$error,$error_text,$data]);
    }
}


$obj_oper_user_profile=new oper_user_profile();
list($error,$error_text,$rez)=$obj_oper_user_profile->start();


write_ajax_answer_jc($error,$error_text,$rez);
