
/* преобразование из bbcode в html */

mas_obj_bbcode_boxcode_html = {};


function bbcode_html(t_bbcode)
  {
   var t = "";
   if ( typeof( mas_obj_bbcode_boxcode_html["obj_bbcode_html"] ) == "undefined" )
     {
      mas_obj_bbcode_boxcode_html["obj_bbcode_html"] = new bbcode_boxcode();
     }
   t = mas_obj_bbcode_boxcode_html["obj_bbcode_html"].parserBBcode(t_bbcode);
   return (t);
  }



var init_fn_tag_bbcode_boxcode = 
  {
   //каждой функции будет передаваться параметры
   // 0 - массив с данными: 
   //  имя тега (url,email,color),атрибут тега (текст в открывающем теге после знака равно(=)),
   //  полный текст открывающего тега (например [url=www.site.ru]),полный текст закрывающего тега (например [/url])
   // 1 - значение тега, то есть текст между открывающим тегом и закрывающим
   //в случае ошибки функция должна возвратить false, если ошибки нет - то преобразованный текст.
   
   fn_url : function (data_tag)
     {
      var t = false;
      if ( js_trim(data_tag[4]) )
        {
         t = ['<a href="'+jsCodeHtmlChars(js_trim(data_tag[4]))+'" target="_blank">', "</a>", false ];
         
        }
      return (t);
     },
   
   fn_email : function (data_tag)
     {
      var t = false;
      if ( js_trim(data_tag[4]) )
        {
         t = ['<a href="'+jsCodeHtmlChars(js_trim(data_tag[4]))+'" target="_blank">',"</a>", false ];
         
        }
      return (t);
     },
   
   fn_img : function (data_tag)
     {
      var t = false;
      if ( js_trim(data_tag[4]) )
        {
         t = ['<img src="'+jsCodeHtmlChars(js_trim(data_tag[4]))+'" alt="" class="img_bbcode">', false, "fn_img_add" ];
         
        }
      return (t);
     },
   
   fn_img_add : function(text)
     {
      return ("");
     },
   
   fn_color : function (data_tag)
     {
      var t = false;
      if ( js_trim(data_tag[4]) )
        {
         t = ['<span style=" color: '+jsCodeHtmlChars(js_trim(data_tag[4]))+';" >', '</span>', false ];
         
        }
      return (t);
     },
   
   fn_code : function (data_tag)
     {
      var t = false;
      //if ( js_trim(v_text) )
        {
         //t = '<div><div >Код</div><div >'+(v_text)+'</div></div>';
         t = ['<div class="block_code_bbcode_main"><div class="block_code_bbcode_main_contr"><div class="block_code_bbcode_title"><div class="block_code_bbcode_title_contr">Код '
          +'</div></div><div class="block_code_bbcode_content"><div class="block_code_bbcode_content_contr"><div ><div class="block_code_bbcode_content_contr_pole"><div class="block_code_bbcode_content_contr_pole_2">',
          '</div></div></div></div></div></div></div>',
          false ];
        }
      return (t);
     },
   
   fn_quote : function (data_tag)
     {
      var t = false;
      //if ( js_trim(v_text) )
        {
         //t = '<div><div >Цитата</div><div >'+(v_text)+'</div></div>';
         
         var name_user = "";
         var t_date = "";
         var num_post = 0;
         var link = "";
         
         if ( typeof( dir_site_http ) == "undefined" ) dir_site_http = "";
         //alert("atr - "+data_tag[1]);
         if ( js_trim( data_tag[4] ) )
           {
             var mas_param = add_function_bbcode_boxcode.parse_str_params( data_tag[4] );
             if ( typeof( mas_param["name"] ) != "undefined" ) name_user = js_trim(mas_param["name"]);
             if ( typeof( mas_param["date"] ) != "undefined" ) t_date = js_trim( mas_param["date"] );
             if ( typeof( mas_param["post"] ) != "undefined" && check_numeric_value( mas_param["post"] ) && mas_param["post"] )
               {
                num_post = mas_param["post"];
                link = dir_site_http+"/forum/topic"+num_post+".html";
               }
           }
         
         
         
         t = ['<div class="block_quote_bbcode_main"><div class="block_quote_bbcode_main_contr"><div class="block_quote_bbcode_title"><div class="block_quote_bbcode_title_contr">Цитата '
           +( ( name_user || t_date ) ? ( "("+( name_user ? jsCodeHtmlChars(name_user)+" " : "" )+( t_date ? ( name_user ? " @ ":"" ) + jsCodeHtmlChars(t_date) : "" )+")" ) : "")
           +( link ? ' <a href="'+link+'" target="_blank"><img src="'+dir_site_http+'/images/link_go.png"></a>' : "" )
           +'</div></div><div class="block_quote_bbcode_content"><div class="block_quote_bbcode_content_contr">',
           '</div></div></div></div>', false ];
         
         
        }
      return (t);
     },
   
   fn_size : function (data_tag)
     {
      var t = false;
      //if ( js_trim(v_text) )
        {
         var size = js_trim(data_tag[4]);
         size = (size <= 17 && size >= 6) ? size : false;
         t = (size !== false) ? ['<span style=" font-size: '+jsCodeHtmlChars(size)+'px;" >', '</span>', false ] : [false,false,false];
         
        }
      return (t);
     },
   
   fn_font : function (data_tag)
     {
      var t = false;
      //if ( js_trim(v_text) )
        {
         t = ['<span style=" font-family: '+jsCodeHtmlChars(js_trim(data_tag[4]))+';" >', '</span>', false ];
         
        }
      return (t);
     },
   
   fn_list : function (data_tag)
     {
      var t = false;
      //if ( js_trim(v_text) )
        {
         /*
         var mas_elm = v_text.split("[*]");
         t = "";
         var kolvo = 0;
         var teg = "ul";
         if ( js_trim(data_tag[1]) == 1 ) teg = "ol";
         
         t += "<"+teg+">";
         //t = '<span style=" font-family: '.jsCodeHtmlChars().';" >'.(v_text).'</span>';
         
         for ( var one_elm in mas_elm )
           {
            v_elm = js_trim(mas_elm[one_elm]);
            if ( v_elm )
              {
               t += "<li>"+v_elm+"</li>";
               kolvo++;
              }
           }
         t += "</"+teg+">";
         if ( kolvo == 0 ) t = "";
         */
         
         var teg = "ul";
         if ( js_trim(data_tag[4]) == 1 ) teg = "ol";
         
         t = ["<"+teg+">", "</"+teg+">","fn_list_add" ];
         
        }
      return (t);
     },
   
   fn_list_add : function(text)
     {
      var t = "";
      //$t .= "<li>";
      text = js_trim(text);
      /*
      if ( mb_strpos( $text, "[*]" ) === 0 )
        {
         $text = mb_substr($text,3,mb_strlen($text)-3);
         $text = trim($text);
        }
      $text = str_replace("[*]","<li></li>",$text);
      $t .= $text;
      */
      
      var mas_elm = text.split("[*]");
      
      var kolvo = 0;
      var v_elm;
      
      for ( var one_elm in mas_elm )
        {
         v_elm = js_trim(mas_elm[one_elm]);
         if ( v_elm )
           {
            t += "<li>"+v_elm+"</li>";
            kolvo++;
           }
        }
      
      //$t .= "</li>";
      return ( t );
     }
   
  }



function bbcode_boxcode()
  {
   
   this.bbtext = "";
   this.html_text = "";
   
   /*
   this.mas_stack_tag = [];
   this.mas_stack_text = [];
   this.num_mas_stack_tag = 0;
   this.num_mas_stack_text = 0;
   */
   this.mas_init_bbtag = {};
   
   this.mas_structure = [];
   
   this.length_text_url = 35;
   this.mas_not_url = ["url","email","img","code"];
   
   this.__construct = function ()
     {
      this.init();
     }
   
   
   this.init = function ()
     {
      this.init_bbtag();
     }
   
   this.init_bbtag = function ()
     {
      this.mas_init_bbtag = {
        "b" : ["<b>","</b>",false],
        "i" : ["<i>","</i>",false],
        "u" : ["<u>","</u>",false],
        "s" : ["<strike>","</strike>",false],
        
        "center" : ["<div style='text-align: center;'>","</div>",false],
        "left" : ["<div style='text-align: left;'>","</div>",false],
        "right" : ["<div style='text-align: right;'>","</div>",false],
        "justify" : ["<div style='text-align: justify;'>","</div>",false],
        
        "url" : ["","",init_fn_tag_bbcode_boxcode.fn_url],
        "email" : ["","",init_fn_tag_bbcode_boxcode.fn_email],
        "img" : ["","",init_fn_tag_bbcode_boxcode.fn_img],
        "color" : ["","",init_fn_tag_bbcode_boxcode.fn_color],
        
        "code" : ["","",init_fn_tag_bbcode_boxcode.fn_code],
        "quote" : ["","",init_fn_tag_bbcode_boxcode.fn_quote],
        
        "size" : ["","",init_fn_tag_bbcode_boxcode.fn_size],
        "font" : ["","",init_fn_tag_bbcode_boxcode.fn_font],
        
        "list" : ["","",init_fn_tag_bbcode_boxcode.fn_list]
        
       };
      
     }
   
   this.parserBBcode = function (bbtext)
     {
      this.bbtext = bbtext;
      this.html_text = "";
      
      this.compile_proc();
      
      
      return (this.html_text);
     }
   
   this.compile_proc = function ()
     {
      
      this.pos_cursor = 0;
      this.bbtext = js_preob_rn(this.bbtext);//преобразуем все виды переносов строк к одному - \n
      this.all_sim = this.bbtext.length;
      this.sim_cursor = "";
      
      if ( this.all_sim == 0 ) return;
      
      this.is_open_tag = false;//найден открывающий тег ([b]) или закрывающий ([/b])
      this.on_tag = false;
      
      /*
      this.mas_stack_tag = [];
      this.mas_stack_text = [];
      this.mas_stack_text[0] = "";
      this.num_mas_stack_tag = -1;
      this.num_mas_stack_text = 0;
      */
      this.on_search = true;
      
      this.text_stack = "";
      
      this.text_tag = "";
      this.text_atr_tag = "";
      this.is_atr_tag = false;
      
      var error = false;
      
      var v_text = "";
      this.html_text = "";
      
      this.mas_structure = [];
      this.mas_structure[0] = [false,false,"",""];
      
      this.link = [0];
      this.level_link = 0;
      //if ( typeof( this.link_structure ) !== "undefined" ) ( this.link_structure = false );
      this.link_structure = this.mas_structure[0];
      
      var data_elem = false;
      
      do
        {
         error = false;
         
         this.sim_cursor = this.bbtext.substring(this.pos_cursor,this.pos_cursor+1);
         
         if ( !this.on_tag )
           {
            if ( this.sim_cursor === "[" )
              {
               this.on_tag = true;
               this.text_stack = this.sim_cursor;//запоминаем исходный текст после нахождения открывающего символа тега
               this.text_tag = "";
               this.is_open_tag = true;
               this.is_atr_tag = false;
               this.text_atr_tag = "";
               //this.mas_stack_text[this.num_mas_stack_text] .= v_text;
               //v_text = "";
              }
             else
               {
                //this.html_text .= this.sim_cursor;
                //v_text .= this.sim_cursor;
                //this.mas_stack_text[this.num_mas_stack_text] += jsCodeHtmlChars(this.sim_cursor);
                
                this.link_structure[2] += this.sim_cursor;
               }
           }
          else
            {
             this.text_stack += this.sim_cursor;
             
             if ( this.sim_cursor.match(/^[a-zA-Z]$/) )
               {
                if ( !this.is_atr_tag )
                  this.text_tag += this.sim_cursor;
                 else
                   this.text_atr_tag += this.sim_cursor;
               }
              else if ( this.sim_cursor === "]" )
                {
                 if ( this.text_tag == "" )
                   {
                    // неправильный тег, пропускаем его
                    error = true;
                    //this.on_tag = false;
                    //this.html_text .= this.text_stack;
                   }
                  else
                    {
                     if ( typeof( this.mas_init_bbtag[this.text_tag] ) != "undefined" )
                       {
                        if ( this.is_open_tag )
                          {
                           //найден открывающий тег, к примеру [b]
                           /*
                           this.num_mas_stack_tag++;
                           this.num_mas_stack_text++;
                           
                           this.mas_stack_tag[this.num_mas_stack_tag] = [this.text_tag,this.text_atr_tag,this.text_stack,""];
                           this.text_stack = "";
                           this.mas_stack_text[this.num_mas_stack_text] = "";
                           //v_text = "";
                           */
                           
                           this.link[ this.link.length - 1 ]++;
                           this.set_link_element_mas_structure();
                           
                           this.link_structure[2] = [ [false,false,""] ];
                           this.link_structure[3] = this.text_tag;
                           this.link_structure[4] = this.text_atr_tag;
                           this.link_structure[5] = this.text_stack;
                           this.link_structure[6] = "";
                           this.link_structure[7] = false;
                           
                           
                           this.link[this.link.length] = 0;
                           this.set_link_element_mas_structure();
                           
                           this.text_stack = "";
                           
                          }
                         else
                           {
                            //найден закрывающий тег, к примеру [/b]
                            
                            data_elem = this.get_preelement_mas_structure();
                            
                            /*
                            if ( typeof( this.mas_stack_tag[this.num_mas_stack_tag] ) != "undefined" &&
                              this.mas_stack_tag[this.num_mas_stack_tag][0] == this.text_tag )
                            */
                            if ( data_elem && typeof( data_elem[3] ) !== "undefined" &&
                              data_elem[3] == this.text_tag )
                               {
                                /*
                                this.mas_stack_tag[this.num_mas_stack_tag][3] = this.text_stack;
                                this.forming_tag();
                                //v_text = "";
                                this.text_stack = "";
                                */
                                
                                //unset(this.link[sizeof(this.link)-1]);
                                //this.link = array_values(this.link);
                                //alert(this.text_tag);
                                //this.link.length = this.link.length - 1;
                                this.link.pop();
                                
                                this.set_link_element_mas_structure();
                                this.link_structure[6] = this.text_stack;
                                
                                this.forming_tag();
                                
                                this.link[ this.link.length - 1 ]++;
                                this.set_link_element_mas_structure();
                                
                                this.text_stack = "";
                                
                               }
                              else
                                {
                                 //неправильная вложенность закрывающих тегов, пропускаем закрывающий тег.
                                 error = true;
                                }
                            
                           }
                        this.on_tag = false;
                       }
                      else
                        {
                         //такого тега нет
                         error = true;
                        }
                    }
                }
              else if ( this.sim_cursor === "=" || this.sim_cursor === " " )
                {
                 if ( !this.is_atr_tag )
                   {
                    if ( this.text_tag )
                      {
                       this.is_atr_tag = true;
                       this.text_atr_tag = "";
                      }
                     else
                       {
                        error = true;
                       }
                   }
                  else
                    {
                     this.text_atr_tag += this.sim_cursor;
                    }
                 
                }
              else if ( this.sim_cursor === "/" )
                {
                 if ( this.text_tag === "" )
                   this.is_open_tag = false;
                  else if ( this.is_atr_tag )
                    this.text_atr_tag += this.sim_cursor;
                   else
                     {
                      error = true;
                      // неправильный тег, пропускаем его
                      //this.on_tag = false;
                      //this.html_text .= this.text_stack;
                     }
                 
                }
              else
                {
                 if ( this.is_atr_tag )
                   this.text_atr_tag += this.sim_cursor;
                  else
                   {
                    error = true;
                    
                   }
                }
            }
         
         if ( error )
           {
            // неправильный тег, пропускаем его
            this.on_tag = false;
            //this.html_text .= this.text_stack;
            //this.mas_stack_text[this.num_mas_stack_text] += jsCodeHtmlChars(this.text_stack);
            //this.text_stack = "";
            //v_text = "";
            
            this.link_structure[2] += this.text_stack;
            this.text_stack = "";
            
           }
         
         this.pos_cursor++;
         if ( this.pos_cursor >= this.all_sim ) this.on_search = false;
         //echo(this.pos_cursor." ");
        }
      while ( this.on_search );
      
      if ( this.on_tag && this.text_stack )
        {
         this.link_structure[2] += this.text_stack;
        }
      
      /*
      for ( var i = 0; i <= this.num_mas_stack_text; i++ )
        {
         this.html_text += this.mas_stack_text[i];
         
        }
      */
      
      //this.html_text += v_text + this.text_stack;
      
      //this.html_text = str_replace("\n","<br />\n",this.html_text);
      //this.html_text = jsStringReplace(this.html_text,"\n","<br />\n");
      
      this.html_text = this.forming_html_text(this.mas_structure);
      this.html_text = jsStringReplace(this.html_text,"\n","<br />\n");
     }
   
   this.forming_html_text = function (elm_structure, on_smile, on_url)
     {
      if ( typeof( on_smile ) == "undefined" ) on_smile = true;
      if ( typeof( on_url ) == "undefined" ) on_url = true;
      
      var t = "";
      var one_elm, key_elm, vt, on_url1, on_smile1;
      for ( key_elm in elm_structure )
        {
         one_elm = elm_structure[key_elm];
         
         if ( typeof( one_elm[2] ) == "object" )
           {
            if ( one_elm[0] === false && one_elm[1] === false )
              t += one_elm[5];
             else if ( one_elm[0] !== false )
                t += one_elm[0];
            
            on_url1 = on_url;
            on_smile1 = on_smile;
            
            if ( on_search_value_mas( this.mas_not_url, one_elm[3] ) )
              on_url1 = false;
            
            vt = this.forming_html_text( one_elm[2], on_smile1, on_url1 );
            
            if ( one_elm[7] )
              {
               
               //vt = init_fn_tag_bbcode_boxcode::one_elm[7](vt);
               vt = init_fn_tag_bbcode_boxcode[one_elm[7]](vt);
              }
            
            t += vt;
            
            if ( one_elm[1] !== false )
              t += one_elm[1];
            
           }
          else
            t += this.code_text(one_elm[2], on_smile, on_url);
            //t += jsCodeHtmlChars(one_elm[2]);
        }
      
      return ( t );
     }
   
   this.forming_tag = function ()
     {
      //echo(34);
      if ( typeof( this.link_structure ) !== "undefined" && this.link_structure )
        {
         var data_tag = this.link_structure.concat();
         //var_dump(data_tag);
         
         var v = this.forming_html_tag(data_tag);
         if ( v === false )
           {
            //this.mas_stack_text[this.num_mas_stack_text-1] .= data_tag[2] . this.mas_stack_text[this.num_mas_stack_text] . data_tag[3];
            this.link_structure[0] = data_tag[5];
            this.link_structure[1] = data_tag[6];
            this.link_structure[7] = false;
           }
          else
            {
             //this.mas_stack_text[this.num_mas_stack_text-1] .= v;
             this.link_structure[0] = v[0];
             this.link_structure[1] = v[1];
             this.link_structure[7] = v[2];
            }
         //this.num_mas_stack_tag--;
         //this.num_mas_stack_text--;
        }
     }
   
   this.forming_html_tag = function (data_tag)
     {
      var t = false;
      
      //проверка на случай внутренних ошибок
      if ( typeof( this.mas_init_bbtag[data_tag[3]] ) != "undefined" )
        {
         var init_one_tag = this.mas_init_bbtag[data_tag[3]];
         if ( init_one_tag[2] )
           {
            var v = init_one_tag[2](data_tag);
            if ( v === false )
              {
               t = false;
              }
             else
               {
                t = [ v[0],v[1], v[2] ];
               }
           }
          else
            {
             t = [ init_one_tag[0], init_one_tag[1], false ];
            }
        }
       else
         {
          //t .= v_text;
         }
      //echo("<hr>".t."<hr>");
      return (t);
     }
   
   this.set_link_element_mas_structure = function ()
     {
      
      
      this.link_structure = true;
      //this.link_structure = "tit";
      var num = 0;
      var num_lvl, one, is;
      for ( num_lvl in this.link )
        {
         one = this.link[num_lvl];
         if ( num == 0 )
           {
            if ( num == (this.link.length - 1) && typeof( this.mas_structure[one] ) == "undefined" )
              this.mas_structure[one] = [false,false,"", "" ];
            
            this.link_structure = this.mas_structure[one];
            //echo( "\n<br> 0 ". ( this.link_structure === NULL ? "null" : this.link_structure ) );
           }
          else
            {
             is = 0;
             if ( num == ( this.link.length - 1 ) && typeof( this.link_structure[2][one] ) == "undefined" )
               {
                
                this.link_structure[2][one] = [false,false,"", "" ];
                
               }
             
             this.link_structure = this.link_structure[2][one];
             
            }
         num++;
        }
      
      
     }
   
   this.get_preelement_mas_structure = function()
     {
      
      var data_elm = false;
      var links = this.link.concat();
      
      //unset( links[sizeof(links)-1] );
      //links = array_values(links);
      //links.length = (( links.length > 0 ) ? links.length - 1 : 0 );
      if ( links.length > 0 )
        links.pop();
      
      var elm = false;
      var num_lvl, one;
      
      for ( num_lvl in links )
        {
         one = links[num_lvl];
         if ( num_lvl == 0 )
           {
            
            elm = this.mas_structure[one];
            
           }
          else
            {
             
             elm = elm[2][one];
             
            }
         
        }
      
      if ( elm !== false )
        {
         data_elm = elm.concat();
         data_elm[2] = false;
        }
      
      return ( data_elm );
     }
   
   this.code_text = function (text,on_smile,on_url)
     {
      var t = jsCodeHtmlChars(text);
      
      if ( on_url )
        {
         var obj = this;
         t = t.replace( /(http|ftp)(:\/\/[\w.\/\%\-\#\?\=\+\[\]\&\;\:]+)/ig, function (s,s1,s2){ return (obj.forming_link_from_url( s,s1,s2 )) } );
        }
      
      /*
      if ( on_smile )
        {
         t = "";
        }
      */
      
      return (t);
     }
   
   this.forming_link_from_url = function (s,s1,s2)
     {
      var t = "";
      var url = jsDecodeHtmlChars(s1 + s2);
      
      t = "<a href='"+jsCodeHtmlChars(url)+"' target='_blank' title='"+jsCodeHtmlChars(url)+"'>"+jsCodeHtmlChars( url.length > this.length_text_url ? compres_text_middle(url,this.length_text_url) : url )+"</a>";
      return ( t );
     }
   
   
   this.__construct();
   
  }



var  add_function_bbcode_boxcode = 
  {
   parse_str_params : function (t)
     {
      var mas_params = {};
      
      var mas_part = this.parse_str_attribute(t);
      var key_part, one_part,name,v_param;
      
      for ( key_part in mas_part  )
        {
         one_part = mas_part[key_part];
         name = js_trim(key_part);
         v_param = js_trim(one_part);
         
         if ( js_trim(name) && js_trim(v_param) )
           {
            //if ( preg_match("/^[a-zA-Z]$/",$one_param[0]) && preg_match("//",$one_param) )
            
            if ( v_param.substring(0,1) == "'" && v_param.substring(v_param.length-1,v_param.length) == "'" )
              {
               mas_params[name] = v_param.substring(1,v_param.length-1);
              }
             else if ( v_param.substring(0,1) == '"' && v_param.substring(v_param.length-1,v_param.length) == '"' )
               {
                mas_params[name] = v_param.substring(1,v_param.length-1);
               }
            
           }
         
        }
      
      return (mas_params);
     },
   
   parse_str_attribute : function (str)
     {
      //парсим строку типа name1 = "text" key = var value = array()
      //и получаем массив с ключами и значениями array( "name1" => "text , "key" => var , "value" => array() )
      //в случае ошибки вернем false
      if ( !js_trim(str) ) return ( {} );//если пустая строка - возвращаем пустой массив
      
      var mas = this.separator_text_params(str,"=");//var_dump(mas);
      if ( !mas || mas.length < 2 ) return (false);
      
      var params = {};
      var kol = mas.length;
      if ( kol  == 2 )
        params[mas[0]] = mas[1];
       else
         {
          //params[mas[0]] = "";
          var nameKey = mas[0];
          var i,pos_search;
          for ( i = 1; i < kol-1; i++  )
            {
             //alert(mas[i] + "* "+ mas[i].search(/\s[\S]+$/i ));
             //if ( preg_match("/\\s[\\S]+$/uis",mas[i],matches,PREG_OFFSET_CAPTURE) )
             if ( ( pos_search = mas[i].search(/\s[\S]+$/i ) ) != -1 )
               {
                
                params[nameKey] = mas[i].substring(0,pos_search);
                nameKey = js_trim(mas[i].substring(pos_search,mas[i].length));
               }
              else
                return (false);
             
            }
          params[nameKey] = mas[kol-1];
          
         }
      
      return (params);
     },
   
   separator_text_params : function (t,sep)
     {
      if ( typeof( sep ) == "undefined" ) sep = ",";
      var t = js_trim(t);
      var mas = {};
      if ( t )
        {
         mas = this.split_text_sim(t,sep);
         if ( mas === false ) return(false);
         var key,value,v;
         for ( key in mas )
           {
            value = mas[key];
            v = js_trim(value);
            if ( v || v === "0" )
              {
               mas[key]=js_trim(value);
              }
             else
               {
                //echo(" err:".trim(v)." ");
                //return (false);
               }
           }
        }
      return (mas);
     },
   
   split_text_sim : function (t,sep)
     {
      if ( typeof( sep ) == "undefined" ) sep = ",";
      var params = [];
      //t = js_trim(t);
      if ( t )
        {
         var part_t = "";//текст параметра
         var type_t = "";//тип текста: в кавычках ' или "
         var open_bracket = 0;//открывающая скобка "("
         var prev_sim = "";//предыдущий символ
         var len = t.length;
         var sim = "";//текущий символ
         var i;
         for ( i = 0;i<len;i++ )
           {
            sim = t.substring(i,i+1);
            if ( sim === sep )
              {
               //if ( part_t  )
                 {
                  if ( type_t || open_bracket )
                    {
                     //пропускаем разделяющий символ (запятую) если он находится в кавычках или в скобках
                     part_t += sim;
                    }
                   else
                     {
                      params[params.length] = part_t;
                      part_t = "";
                      
                     }
                 }
                //else
                //  return(false);
              }
             else
               {
                part_t += sim;
                if ( (sim === "'" || sim === '"') && prev_sim !== "\\" )
                  {
                   type_t = type_t ? ( type_t === sim ? "":type_t ):sim;
                  }
                 else if ( sim === "(" && !type_t  )
                   {
                    open_bracket++;//обнаружена открывающая скобка вне кавычек
                    
                   }
                  else if ( sim === ")" && !type_t )
                    {
                     if ( open_bracket  )
                       {
                        open_bracket--;
                        
                       }
                      else
                        {
                         //обнаружена закрывающая кавычка, но ранее не было открывающей. 
                         //Синтаксическая ошибка 
                         return (false);
                        }
                     
                    }
                //prev_sim = sim;
                
               }
            prev_sim = sim;
           }
         if ( part_t )
           params[params.length] = part_t;
          else if ( sim === sep )
            params[params.length] = "";
        }
      
      return (params);
     }
  }












