<?php

/*
Архив CMS находится на сайте www.boxcode.ru  
Информацию по установке и использованию CMS можно прочитать на сайте www.boxcode.ru 
*/


setlocale(LC_ALL,"utf-8");
mb_internal_encoding('UTF-8');


//Подключаемые модули, каждый элемент содержит массив: 
// 0 - папка, в которой файл должен быть с тем же именем, и расширением "php" - также имя модуля (в системе)
// 1 - имя объекта, который создается в данном файле
// 2 - использовать данный модуль (1) или нет (0)
// 3 - выводиться ли модулем какая-либо информация:
// если нет - то значение -1
// если да - то значение должно указывать где именно
// 4 - название модуля
// 5 - уникальный номер модуля (повторяться не должен), должен быть больше 10 (остальные зарезервированы для главного модуля)
// 6 - вывод в списке элементов модуля рекламы

$list_modules=array(
  "guest" => array("guest","obj_guest",0,-1,"Гостевая книга",25,false),
  "news" => array("news","obj_news",0,"right","Новости сайта",14,false),
  "subscribe" => array("subscribe","obj_subscribe",0,"left","Рассылка",15,false),
  "htmlbloks" => array("htmlbloks","obj_htmlbloks",0,"left","HTML-блоки",17,false),
  "qonline" => array("qonline","obj_qonline",0,"left","Обратная связь",19,false),
  "backcon" => array("backcon","obj_backcon",0,"left","Заказ звонка",30,false),
  "faq" => array("faq","obj_faq",0,-1,"Вопрос-ответ",20,false),
  //"ishop" => array("ishop","obj_ishop",0,-1,"Интернет-магазин",11,false),
  "article" => array("article","obj_article",0,-1,"Каталог статей",12,true),
  "spacecom" => array("spacecom","obj_spacecom",0,"left","Рекламная система",21,false),
  "slideshow" => array("slideshow","obj_slideshow",0,-1,"Слайдер",23,false),
  );



//Настройка протокола сайта
define("PROTOCOL_URL_CMS","http");//http или https. Соответственно, нужно менять и следующий параметр PORT_SITE
define("PORT_SITE",80);//80 (http) или 443 (https)



//Шаблон
$name_template = "stblue";



//Курсы валют

$init_currency = array(
  "rub" => array("Российский Рубль","руб."),
  "usd" => array("Американский Доллар","дол."),
  "uah" => array("Украинская Гривна","грн."),
  "eur" => array("Европейский Евро","евро"),
 );
$init_base_currency = "rub";



$_dir_main=realpath(dirname(__FILE__)."/../");
require_once($_dir_main."/script/config_base.php");

