
//редактор настроек js


var eng_edit_cfg={
  
  type_work: "",
  use_cache: false,
  dir_server: "./proc_config/",
  
  on_modul:false,//true - если редактируются настройки дополнительного модуля
  name_modul: "",//имя модуля, если редактируются настройки дополнительного модуля или пустая строка, если главного модуля
  dir_moduls: "",
  obj_print: false,
  
  mas_init_params: [],
  mas_actual_vs: [],
  mas_default_vs: [],
  view_param_hide: false,
  contr_code:"",
  
  start_work: function(vv)
    {
      //проверка прав пользователя
      if (!exists_rights_this_modul("setting")) return;
      
      if (operLoad) return;
      
      this.type_work=vv;
      //wconsole(vv);
      
      this.on_modul=cs_use_modul == "on"?true:false;
      this.name_modul=cs_use_name_modul;
      
      this.contr_code=eng_secrt.get_code();
      if (typeof(set_view_param_hide)!="undefined") this.view_param_hide=(set_view_param_hide ? true:false);
      this.load_serv_data();
    },
  
  load_serv_data: function()
    {
      //проверка прав пользователя
      if (!exists_rights_this_modul("setting")) return;
      
      if (operLoad) return;
      var _this=this;
      if (this.use_cache)
        {
          if (this.type_work == "view")
            this.view_settings();
           else
             this.edit_data();
        }
       else
        {
          var url=this.dir_server+"get_settings.php";
          loadHTTPjc(url,function(a,b){ _this.obLoadServData(a,b); },"on_use_modul="+(this.on_modul ? "on":"off")+"&name_use_modul="+this.name_modul+"&"+eng_secrt.get_param_encode());
        }
      
    },
  
  obLoadServData: function(answer,add_param)
    {
      //wconsole(answer);
      
      this.mas_init_params=answer.data.init;
      this.mas_actual_vs=answer.data.actualvs;
      this.mas_default_vs=answer.data.defaultvs;
      
      decode_mas(this.mas_init_params);
      decode_mas(this.mas_actual_vs);
      decode_mas(this.mas_default_vs);
      
      this.use_cache=true;
      
      if (this.type_work == "view")
        this.view_settings();
       else
         this.edit_data();
      
    },
  
  view_settings: function()
    {
      
      var t = "<h2>Просмотр настроек</h2>";
      
      t += this.forming_btn_open_close_all_group();
      
      t += "<div class='cs_block_soder_form'>";
      
      var i=0, j=0;
      var display_block = "";
      var num_block = 0,one_group=[],one_row=[], num_param=0, actual_value="", select_value="", param_hide=false;
      for (j = 0; j < this.mas_init_params.length; j++)
        {
          one_group=this.mas_init_params[j];
          
          if (!this.view_param_hide && one_group[0][1] == 0)
            {
              display_block = " style='display:none;' ";
            }
           else
            {
              num_block++;
              display_block = "";
            }
          
          t += "<div " + display_block + " class='cs_block_one_mas_def_base' id='cs_base_num_mas_" + j + "'>";
          t += this.forming_name_group(one_group[0], j, num_block);
          num_param = 1;
          t += "<div id='cs_block_num_mas_" + j + "' style='overflow: hidden; height: 0px;' class='cs_block_one_mas_def'>"
            + "<div id='cs_block_num_mas_view_" + j + "' class='cs_block_one_view_mas_def'>";
          for (i = 0; i < one_group[1].length; i++)
            {
              one_row = one_group[1][i];
              
              actual_value="";
              if (this.mas_actual_vs[one_row[0]]) actual_value=this.mas_actual_vs[one_row[0]];
              
              param_hide=false;
              if (!this.view_param_hide && typeof(one_row[5]) != "undefined") param_hide=(one_row[5]=="hide" ? true:false);
              
              t += "<div class='cs_one_param'"+(param_hide ? " style='display: none;'":"")+">";
              t += "<div class='cs_name_one_param'>";
              t += num_param + ". ";
              if (!param_hide) num_param++;
              t += one_row[3];
              t += "</div>";
              t += "<div class='cs_value_one_param'>";
              if (one_row[1] == "text" || one_row[1] == "numeric")
                {
                  if (actual_value)
                    t += js_nl2br(jsCodeHtmlChars(actual_value));
                  else
                    t += "<span class='cs_span_not_value'>пустое значение</span>";
                }
              else if (one_row[1] == "select")
                {
                  select_value=search_data_from_mas(one_row[2],0,actual_value,1);
                  t += (select_value !== false ? select_value:"");
                }
              else if (one_row[1] == "array")
                {
                  t += "<div class='cs_title_block_type_data_array'>Массив значений:</div>";
                  
                  t += this.forming_view_data_array(one_row, actual_value);
                }
              
              t += "</div>";
              t += "</div>";
            }
          
          t += "</div></div>";
          t += "</div>";
          
        }
      
      t += "</div>";
      t += this.forming_btn_open_close_all_group();
      //t += "<div style='height: 10px;'></div>";
      t+=this.forming_panel_btn_action();
      
      //cs_obj_print.innerHTML = t;
      engine_elm_html.set_html("block_print",t);
      
      this.check_view_panel_btn_save();
    },
  
  forming_view_data_array: function(one_init,data_mas)
    {
      var t = "";
      var i=0, n=0, d_row, one_value;
      
      if (typeof (data_mas) == "undefined") data_mas = false;
      
      t += "<table border = '0' cellpadding = '0' cellspacing = '0' class='cs_table_view_data_array'>";
      t += "<tr class='cs_title_row_table_view_data_array'>";
      for (n = 0; n < one_init[2].length; n++)
        {
          t += "<td>" + one_init[2][n][1] + "</td>";
        }
      t += "</tr>";
      
      if (data_mas && typeof (data_mas.length) != "undefined" && data_mas.length > 0)
        {
          
          for (i = 0; i < data_mas.length; i++)
            {
              t += "<tr class='cs_data_row_table_view_data_array'>";
              for (n = 0; n < one_init[2].length; n++)
                {
                  t += "<td>";
                  
                  if (typeof (data_mas[i]) != "undefined" && typeof (data_mas[i][n]) != "undefined")
                    {
                      t += data_mas[i][n];
                    }
                  else
                    {
                      t += "<span class='cs_span_not_value'>пустое значение</span>";
                    }
                  
                  t += "</td>";
                }
              t += "</tr>";
            }
          
        }
      else
        {
          t += "<tr>";
          t += "<td colspan='" + one_init[2].length + "'>";
          t += "<span class='cs_span_not_value'>значений нет</span>";
          t += "</td>";
          t += "</tr>";
        }
      
      t += "</table>";
      
      return (t);
    },
  
  forming_name_group: function(init_name,num,num_block)
    {
      var t="";
      t+="<div class='cs_title_one_mas_setting'>"+(num_block)+". <span class='cs_name_one_mas_setting' onclick='eng_edit_cfg.open_close_group_num("+num+",false)'>"+init_name[0]+" <span class='cs_marker_name_one_mas_setting'></span>"+"</span>"
        //+"&nbsp; <span onclick='cs_open_block_num("+num+","+(run_init_view_panel ? "true" : "false") +")' class='cs_link_oper'>развернуть</span><span class='cs_text_small'>/</span><span onclick='cs_close_block_num("+num+","+(run_init_view_panel ? "true" : "false") +")' class='cs_link_oper'>свернуть</span>"
        
        +"</div>";
      return (t);
    },
  
  open_close_group_num: function(num,action)
    {
      //if (typeof (run_init_view_panel) == "undefined") run_init_view_panel = true;
      if (!this.view_param_hide && this.mas_init_params[num][0][1] == 0) return;//выходим, если настройки не отображаются
      
      if (typeof (action) == "undefined") action = false;
      
      var obj_base = engine_elm_html.get_obj("cs_base_num_mas_" + num);
      var obj_block = document.getElementById("cs_block_num_mas_" + num);
      var obj_block_view = document.getElementById("cs_block_num_mas_view_" + num);
      
      var height = obj_block.offsetHeight;//wconsole(height);
      //obj_block.style.height = "auto";
      action = (action === false ? (height > 1 ? "close" : "open") : action);//wconsole(action);
      obj_block.style.height = (action == "open" ? "auto" : "0px");
      if (action == "open")
        change_class_name.add(obj_base, "cs_open_one_mas_def_base");
      else
        change_class_name.delete_cl(obj_base, "cs_open_one_mas_def_base");
      
      //if (this.type_work == "edit")
        {
          this.check_view_panel_btn_save();
        }
    },
  
  open_close_all_group: function(type)
    {
      //if (typeof (run_init_view_panel) == "undefined") run_init_view_panel = false;
      
      var i=0, j=0;
      for (j = 0; j < this.mas_init_params.length; j++)
        {
          this.open_close_group_num(j, type);
        }
      
      //if (this.type_work == "edit")
        this.check_view_panel_btn_save();
    },
  
  forming_btn_open_close_all_group: function()
    {
      var t="";
      t+="<div class='cs_block_elm_oper'>"
        +"<span onclick='eng_edit_cfg.open_close_all_group(\"open\")' class='cs_link_oper'>Развернуть все</span>"
        +"<span onclick='eng_edit_cfg.open_close_all_group(\"close\")' class='cs_link_oper'>Свернуть все</span>"
        +"</div>";
      
      return (t);
    },
  
  forming_panel_btn_action: function()
    {
      var t="";
      
      t += "<div style='height: 10px;'></div>";
      t += "<div id='cs_block_space_for_panel_button_save' style='height: 0px; overflow: hidden;'></div>";
      t += "<div id='cs_block_panel_button_save' class='cs_block_button_save_param'>"
        + "<div>";
      
      if (this.type_work == "edit")
        t += "<input type='button' value='Сохранить' name='pf_button_save_param' onclick='eng_edit_cfg.action_save_edit_settings()' class='cs_button_save_param'> ";
      
      t += " <input type='button' value='Закрыть' name='pf_button_cancel' onclick='eng_edit_cfg.cancel_settings()' class='cs_button_save_param'>"
        + " <label><input type='checkbox' value='on' name='cs_pf_check_view_panel_button' onclick='eng_edit_cfg.check_view_panel_btn_save()'> <span class='cs_elm_info_panel_button_save_param'>в статичном режиме</span></label> "
        + "</div>"
        + "</div>";
      
      return (t);
    },
  
  /*
  Редактирование настроек
  */
  
  edit_data: function()
    {
      var on_link_default = true;
      var one_use_link_default = true;
      var t = "<h2>Редактирование настроек</h2>";
      
      t += "<div class='cs_alert_text'>Внимание! В значениях полей нельзя использовать одинарные кавычки ( ' ) !</div>";
      
      t += this.forming_btn_open_close_all_group();
      
      t += "<form name='edit_data_config' action='' method='' onSubmit='return(false)'>";
      
      t += "<div class='cs_block_soder_form'>";
      
      var i=0, j=0, n=0, m=0;
      var display_block = "";
      var num_block = 0,one_group=[],one_row=[], num_param=0, actual_value="", select_value="", param_hide=false;
      for (j = 0; j < this.mas_init_params.length; j++)
        {
          one_group=this.mas_init_params[j];
          
          if (!this.view_param_hide && one_group[0][1] == 0)
            {
              display_block = " style='display: none; overflow:hidden; height: 0px;' ";
            }
          else
            {
              num_block++;
              display_block = "";
            }
          
          t += "<div " + display_block + " class='cs_block_one_mas_def_base' id='cs_base_num_mas_" + j + "'>";
          
          t += this.forming_name_group(one_group[0], j, num_block);
          num_param = 1;
          t += "<div id='cs_block_num_mas_" + j + "' style='overflow: hidden; height: 0px;' class='cs_block_one_mas_def'>"
            + "<div id='cs_block_num_mas_view_" + j + "' class='cs_block_one_view_mas_def'>";
          for (i = 0; i < one_group[1].length; i++)
            {
              one_use_link_default = true;
              
              one_row = one_group[1][i];
              
              actual_value="";
              if (this.mas_actual_vs[one_row[0]]) actual_value=this.mas_actual_vs[one_row[0]];
              
              param_hide=false;
              if (!this.view_param_hide && typeof(one_row[5]) != "undefined") param_hide=(one_row[5]=="hide" ? true:false);
              
              t += "<div class='cs_one_param'"+(param_hide ? " style='display: none;'":"")+">";
              t += "<div class='cs_name_one_param'>" + num_param + ". " + one_row[3] + "</div>";
              
              if (!param_hide) num_param++;
              
              t += "<div class='cs_edit_value_param'>";
              t += "<div class='cs_block_help_text_edit_param'>Пояснение: " + one_row[4] + "</div>";
              t += "<div class='cs_div_edit_value_param'>";
              if (one_row[1] == "numeric")
                {
                  t += "<input class='cs_pole_numeric' type='text' name='" + one_row[0] + "' value='" + jsCodeHtmlChars(actual_value) + "'>";
                }
              else
                {
                  if (one_row[1] == "text")
                    {
                      var modify=this.get_modify_param(one_row[2]);
                      if (!modify.oneline)
                        t += "<textarea class='cs_pole_textarea' name='" + one_row[0] + "'>" + jsCodeHtmlChars(actual_value) + "</textarea>";
                      else
                        t += "<input class='cs_pole_small_text' type='text' name='" + one_row[0] + "' value='"+jsCodeHtmlChars(actual_value)+"'>";
                    }
                  else if (one_row[1] == "select")
                    {
                      t += "<select name='" + one_row[0] + "' class='cs_pole_select'>";
                      for (n = 0; n < one_row[2].length; n++)
                        {
                          t += "<option value='" + one_row[2][n][0] + "' ";
                          if (actual_value == one_row[2][n][0]) t += " selected='selected' ";
                          t += " >" + one_row[2][n][1] + "</option>";
                        }
                      t += "</select>";
                    }
                  else if (one_row[1] == "array")
                    {
                    
                      one_use_link_default = false;
                      /*
                      for ( n =0; n<one_row["dataselect"].length; n++ )
                        {
                         
                         d_row = one_row["dataselect"][n];
                         t += " " + d_row[0] +" => "+ d_row[1] + " -> ";
                         t += "<input type='text' name='"+one_row["name"]+"["+n+"]"+"' value=''>";
                        }
                      */
                    
                      t += "<div class='cs_title_block_type_data_array'>Массив значений:</div>";
                      //t +="<div id='table_sc_param_"+one_row["name"]+"'>";
                    
                      t += "<table id='table_sc_param_" + one_row[0] + "' border = '0' cellpadding = '0' cellspacing = '0' class='cs_table_edit_data_array'><tbody>";
                      t += "<tr class='cs_title_row_table_edit_data_array'>";
                      for (n = 0; n < one_row[2].length; n++)
                        t += "<td>" + one_row[2][n][1] + "</td>";
                      t += "<td> </td>";
                      t += "</tr>";
                      
                      if (typeof (actual_value) == "object" && typeof (actual_value.length) != "undefined")
                        {
                          for (m = 0; m < actual_value.length; m++)
                            t += this.forming_one_row_edit_array(one_row, actual_value[m], true);
                        }
                    
                      t += "</tbody></table>";
                      //t +="</div>";
                      t += "<div class='marginTop10'><span onclick='eng_edit_cfg.add_new_row_edit_array(" + j + "," + i + ")' class='span_link_t1'>Добавить элемент</span></div>";
                    
                    }
                }
              if (on_link_default && one_use_link_default)
                {
                  t += "<div class='cs_block_link_set_default_value'><span class='cs_link_set_default_value' onclick='eng_edit_cfg.set_pf_default_value(" + j + "," + i + ")'>установить значение по умолчанию</span></div>";
                }
              t += "</div>";
              
              t += "</div>";
              t += "</div>";
            }
          
          t += "</div></div>";
          t += "</div>";
          
        }
      
      t += "</div>";
      
      t += this.forming_btn_open_close_all_group();
      /*
      t += "<div style='height: 10px;'></div>";
      t += "<div id='cs_block_space_for_panel_button_save' style='height: 0px; overflow: hidden;'></div>";
      t += "<div id='cs_block_panel_button_save' class='cs_block_button_save_param'>"
        + "<div>"
        + "<input type='button' value='Сохранить' name='pf_button_save_param' onclick='eng_edit_cfg.action_save_edit_settings()' class='cs_button_save_param'> "
        + " <input type='button' value='Отмена' name='pf_button_cancel' onclick='eng_edit_cfg.cancel_settings()' class='cs_button_save_param'>"
        + " <label><input type='checkbox' value='on' name='cs_pf_check_view_panel_button' onclick='eng_edit_cfg.check_view_panel_btn_save()'> <span class='cs_elm_info_panel_button_save_param'>выводить панель в статичном режиме</span></label> "
        + "</div>"
        + "</div>";
      */
      t += this.forming_panel_btn_action();
      
      t += "</form>";
      
      //cs_obj_print.innerHTML = t;
      
      engine_elm_html.set_html("block_print",t);
      
      this.check_view_panel_btn_save();
    },
  
  set_pf_default_value: function(n_j,n_i)
    {
      if (!confirm("Уверены, что для этого параметра хотите установить значение по умолчанию?")) return;
    
      var obj_form = document.forms.edit_data_config;
      var one_row = this.mas_init_params[n_j][1][n_i];
      var default_value="";
      if (this.mas_default_vs[one_row[0]]) default_value=this.mas_default_vs[one_row[0]];
      
      if (one_row[1] == "numeric" || one_row[1] == "text")
        {
          obj_form[one_row[0]].value = default_value;
          
        }
      else if (one_row[1] == "select")
        {
          //if (obj_form[one_row[0]].options[one_row.default_v])
          //  obj_form[one_row["name"]].options[one_row.default_v].selected = true;
          
          set_value_pole_select(obj_form[one_row[0]],default_value);
        }
    },
  
  forming_one_row_edit_array: function(one_init,data_mas,add_tag_tr)
    {
      var t = "";
      var n=0, d_row=[], one_value="";
      
      if (typeof (data_mas) == "undefined") data_mas = false;
      
      if (add_tag_tr)
        t += "<tr class='cs_data_row_table_edit_data_array'>";
      
      for (n = 0; n < one_init[2].length; n++)
        {
          one_value = "";
          if (data_mas && typeof (data_mas.length) != "undefined" && typeof (data_mas[n]) != "undefined")
            one_value = data_mas[n];
          //d_row = one_init[2][n];
          t += "<td> ";
          //t += d_row[0] +" => "+ d_row[1] + " -> ";
          t += "<input type='text' name='" + one_init[0] + "[" + n + "]" + "' value='" + jsCodeHtmlChars(one_value) + "' class='cs_pole_value_data_array'>";
          t += "</td>";
        }
      t += "<td> <span onclick='eng_edit_cfg.delete_one_row_edit_array(this)' class='span_link_t1'>удалить</span></td>";
    
      if (add_tag_tr)
        t += "</tr>";
    
      return (t);
    },
  
  add_new_row_edit_array: function(nj,ni)
    {
      var one_row=this.mas_init_params[nj][1][ni];//cs_mas_define[nj]["datamasiv"][ni];
      t = this.forming_one_row_edit_array(one_row,false,false);
      
      var id_obj="table_sc_param_"+one_row[0];
      var obj = document.getElementById(id_obj);
      var mas_obj_tbody=obj.getElementsByTagName("tbody");
      
      var elem_new_block=document.createElement("tr");
      elem_new_block.className="cs_data_row_table_edit_data_array";
      var obj_new = mas_obj_tbody[0].appendChild(elem_new_block);
      obj_new.innerHTML = t;
    },
  
  delete_one_row_edit_array: function(obj_span)
    {
      var elem = obj_span;
      
      var search_elem = true;
      var tagName;
      while (search_elem && elem)
        {
          elem = elem.parentNode;
          tagName = elem.tagName;
          if (tagName == "TR" || tagName == "tr")
            {
              
              this.delete_elem_html_obj(elem);
              elem.parentNode.removeChild(elem);
              search_elem = false;
            }
        }
    },
  
  delete_elem_html_obj: function(obj)
    {
      var k = obj.childNodes.length;
      
      var elem_new_block = false;
      for (var i = k - 1; i >= 0; i--)
        {
          //alert(obj.childNodes[i].tagName);
          //alert ( obj.childNodes[i].childNodes );
          if (obj.childNodes[i].childNodes)
            this.delete_elem_html_obj(obj.childNodes[i]);
          
          if (obj.childNodes[i].tagName && obj.childNodes[i].tagName == "INPUT" || obj.childNodes[i].tagName == "input")
            {
              var k = obj.childNodes[i];
              
              obj.childNodes[i].setAttribute("delete", "on");
              //elem_new_block=document.createElement("span");
              //obj.replaceChild( elem_new_block,obj.childNodes[i]);
              
            }
          obj.removeChild(obj.childNodes[i]);
        }
    },
  
  check_view_panel_btn_save: function()
    {
      var v_height_panel = 24;// ориентировочно панель высотой 24 px
      var height_space_top = 10;
      var height_space_bottom = 10;
      
      var obj_block_space = document.getElementById("cs_block_space_for_panel_button_save");
      var obj_block_panel = document.getElementById("cs_block_panel_button_save");
      
      obj_block_panel.style.display = "none";
      obj_block_space.style.display = "none";
      
      var obj_pf = document.getElementsByName("cs_pf_check_view_panel_button");
      obj_pf = obj_pf[0];
      
      if (obj_pf.checked)
        {
          this.set_type_view_panel_btn_save("static");
          return;
        }
      
      var obj_content = document.getElementById("block_page");
      
      var a = {"width": obj_content.offsetWidth, "height": obj_content.offsetHeight};//getDocumentSize(document);
      var b = get_size_window();
      
      var height_page = a.height;
      var height_window = b.height;
      var v_height_window = height_window - v_height_panel - height_space_top - height_space_bottom;
      
      if (a.height > (b.height - v_height_panel - height_space_top - height_space_bottom))
        {
          this.set_type_view_panel_btn_save("panel");
        }
      else
        {
          this.set_type_view_panel_btn_save("static");
        }
      
      return;
    },
  
  set_type_view_panel_btn_save: function(type_view)
    {
      var obj_block_space = document.getElementById("cs_block_space_for_panel_button_save");
      var obj_block_panel = document.getElementById("cs_block_panel_button_save");
      var mas_style = [];
      var mas_style_space = [];
      
      if (type_view == "panel")
        {
          mas_style = [
            ["position", "fixed"],
            ["bottom", "0px"],
            ["left", "10px"],
            ["display", "block"]
          ];
          
          obj_processing_block.set_style_obj(obj_block_panel, mas_style);
          
          mas_style_space = [
            ["display", "block"],
            ["height", "50px"]
          ];
          
          obj_processing_block.set_style_obj(obj_block_space, mas_style_space);
        }
      else
        {
          mas_style = [
            ["position", "static"],
            ["bottom", "auto"],
            ["left", "auto"],
            ["display", "block"]
          ];
          
          obj_processing_block.set_style_obj(obj_block_panel, mas_style);
          
          mas_style_space = [
            ["display", "none"],
            ["height", "0px"]
          ];
          
          obj_processing_block.set_style_obj(obj_block_space, mas_style_space);
          
        }
      
      return;
    },
  
  action_save_edit_settings: function()
    {
      //проверка прав пользователя
      if (!exists_rights_this_modul("write")) return;
      
      var _this=this;
      var obj_form_edit = document.forms.edit_data_config;
      var post_data = "";
      var raz = "";
      var i=0, j=0, n=0, one_row=[], d_row=[], one_value="", name_pf="", obj_pf=false, mas_pf=[], z=0, t_value="", sep1 = "", sep2 = "",
        is_str_param=false,str_param="", name_param="", d_value=[];
      
      for (j = 0; j < this.mas_init_params.length; j++)
        {
          for (i = 0; i < this.mas_init_params[j][1].length; i++)
            {
              one_row = this.mas_init_params[j][1][i];
              is_str_param = false;
              str_param = "";
              
              if (one_row[1] != "array")
                {
                  one_value = obj_form_edit.elements[one_row[0]].value;
                  /*
                  //проверка на пустое значение
                  if (one_value=="")
                    {
                     alert("Введите значение: "+one_row[3]);
                     return;
                    }
                  */
                  if (one_row[1] == "numeric")
                    {
                      //one_value = one_value - 0;
                      if (js_trim(one_value) === "" || !check_numeric_value(one_value))
                        {
                          alert("Должно быть число в поле: " + one_row[3]);
                          obj_form_edit.elements[one_row[0]].focus();
                          return;
                        }
                      
                    }
                  else
                    {
                      if (one_value.indexOf("'") != -1)
                        {
                          alert('В поле "' + one_row[3] + '" обнаружена одинарная кавычка!');
                          obj_form_edit.elements[one_row[0]].focus();
                          return;
                        }
                      
                      if (one_row[1] == "text")
                        {
                          var modify=this.get_modify_param(one_row[2]);
                          if (modify.trim) one_value=js_trim(one_value);
                        }
                    }
                  
                  one_value = encodeURIComponent(one_value);
                }
              else if (one_row[1] == "array")
                {
                  mas_pf = [];
                  for (n = 0; n < one_row[2].length; n++)
                    {
                      mas_pf[n] = [];
                      d_row = one_row[2][n];
                      //t += " " + d_row[0] +" => "+ d_row[1] + " -> ";
                      //t += "<input type='text' name='"+one_row["name"]+"["+n+"]"+"' value=''>";
                      name_pf = one_row[0] + "[" + n + "]";
                      obj_pf = obj_form_edit.elements[name_pf];
                      if (obj_pf)
                        {
                          
                          //alert(typeof(obj_pf.length));
                          if (typeof (obj_pf.length) == "undefined")
                            {
                              //d_value = obj_pf.value;
                              d_value = this.get_value_elm_input(obj_pf, d_row);
                              if (d_value[1]) return;
                              if (d_value[0] === null) continue;
                              mas_pf[n][mas_pf[n].length] = d_value[0];
                              //alert(d_value == null ? "это null" : d_value );
                            }
                          else
                            {
                              for (z = 0; z < obj_pf.length; z++)
                                {
                                  //d_value = obj_pf[z].value;
                                  d_value = this.get_value_elm_input(obj_pf[z], d_row);
                                  if (d_value[1]) return;
                                  if (d_value[0] === null) continue;
                                  mas_pf[n][mas_pf[n].length] = d_value[0];
                                  //alert(d_value == null ? "это null" : d_value );
                                }
                            }
                          
                        }
                      
                    }
                  //wconsole("Данные элемента типа массив",mas_pf);
                  
                  one_value = "";
                  str_param = "";
                  
                  if (!(mas_pf.length > 0 && mas_pf[0].length > 0))
                    {
                      //alert('Нужно создать хоть одну строчку для параметра "'+one_row["description"]+'" !');
                      //return;
                    }
                  else
                    {
                      is_str_param = true;
                      name_param = one_row[0];
                      sep1 = "";
                      sep2 = "";
                      for (n = 0; n < mas_pf[0].length; n++)
                        {
                          //str_param += sep1;
                          for (z = 0; z < mas_pf.length; z++)
                            {
                              str_param += sep2 + name_param + "[" + n + "][" + z + "]=" + encodeURIComponent(mas_pf[z][n]);
                              sep2 = "&";
                            }
                          sep2 = "&";
                        }
                      //alert(str_param);
                    }
                  
                }
              
              post_data += raz + (is_str_param ? str_param : one_row[0] + "=" + one_value);
              //post_data+=raz+one_row["name"]+"="+encodeURIComponent(one_value);
              raz = "&";
            }
        }
      this.use_cache = false;
      if (operLoad) return;
      var url = this.dir_server + "save_settings.php";
      post_data+="&on_use_modul=" + (this.on_modul ? "on":"off") + "&name_use_modul=" + this.name_modul + "&"+eng_secrt.get_param_encode();// "&contr_code="+encodeURIComponent(this.contr_code);
      //wconsole (post_data);
      loadHTTPjc(url, function(a,b){ _this.ob_save_serv_edit_settings(a,b); }, post_data);
    },
  
  get_value_elm_input: function(elem,d_row)
    {
      var v = null;
      var m = null;
      var error = false;
      var type_v = d_row[0];
      //alert();
      //alert(type_v + " " +elem.getAttribute("delete"));
      if (elem.getAttribute("delete") === null)
        {
          m = elem.value;
          if (type_v == "numeric")
            {
              if (!check_numeric_value(m))
                {
                  alert("Должно быть число в поле: " + d_row[1]);
                  elem.focus();
                  error = true;
                }
              m = m - 0;
            }
          else
            {
              if (m.indexOf("'") != -1)
                {
                  alert('В поле "' + d_row[1] + '" обнаружена одинарная кавычка!');
                  elem.focus();
                  error = true;
                }
            }
          //alert(v);
          if (!error) v = m;
        }
  
      return ([v, error]);
    },
  
  ob_save_serv_edit_settings: function(answer,add_param)
    {
      
      alert ("Сохранено!");
      
    },
  
  cancel_settings: function()
    {
      this.use_cache=false;
      engine_elm_html.set_html("block_print","");
    },
  
  get_modify_param: function(vv)
    {
      var modify={};
      
      if (vv && typeof(vv) == "string" && vv != "0")
        {
          var mas_v=vv.split("|");
          for (var i=0;i<mas_v.length;i++)
            {
              modify[mas_v[i]]=true;
            }
        }
      
      return (modify);
    }
  
};