<?php

if (empty($on_include_modul) || $on_include_modul!="on")
  {
    exit();
  }

?>


<h1>Платежные системы</h1>

<div class="block_menu_modul_gsm" id="block_menu_modul_gsm"></div>

<div class="conteiner_content_modul_gs">
<div id="block_print"></div>
</div>


<script type="text/javascript">

mas_init_menu=[
  ["Платежные системы","fn",function(){mas_gl_admin["paysystems"].main('list'); return (false);}],
  //["История","fn",function(){mas_gl_admin["paysystems"].main('log'); return (false);}],
 ];

mas_gl_admin["menu_manager"].set_init_menu(mas_init_menu);  


mas_gl_admin["paysystems"] = {
  "on_main_first_init" : false,
  "main" : function (v_comand)
    {
     if ( !this.on_main_first_init ) this.main_first_init();
     
     if ( v_comand == "list" )
       {
        mas_gl_admin["paysystems"].obj_wk_paysystems.processing_data();
       }
     /*else if ( v_comand == "log" )
       {
        mas_gl_admin["paysystems"].obj_wk_paysystems.view_log();
       }*/
     
    },
  "main_first_init" : function ()
    {
     
     if ( !mas_gl_admin["paysystems"].obj_wk_paysystems )
       mas_gl_admin["paysystems"].obj_wk_paysystems = new mas_gl_admin["paysystems"].wk_paysystems("block_print");
     
     this.on_main_first_init = true;
    }
 };


function gl_pay_systems_wk(elm_block_print)
  {
    this.elm_block_print = elm_block_print;
    this.obj_block_print = false;
    
    this.num_serial_wk = 1;
    
    this.dir_sr = dir_admin_panel_http + "/proc_pay_systems/";
    
    this.data_pay_systems = [];
    
    this.init_first_html = function ()
      {
        this.num_serial_wk = this.num_create_copy;
        this.num_serial_wk++;
        gl_pay_systems_wk.prototype.num_create_copy = this.num_serial_wk;
        
        this.obj_block_print = document.getElementById(this.elm_block_print);
      }
    
    this.processing_data = function ()
      {
        this.load_data_srv();
      }
    
    this.load_data_srv = function ()
      {
        //проверка прав пользователя
        if (!exists_rights_this_modul("read")) return;
        
        var this_obj = this;
        var url = this.dir_sr + "get_pay_systems.php";
        loadHTTPjc(url, function (a, b)
        {
          this_obj.obr_load_data_srv(a, b);
        });
      }
    
    this.obr_load_data_srv = function(answer,add_param)
      {
        //wconsole(answer);
        
        var data=answer.data;
        this.data_pay_systems=data.data_pay_systems;
        decode_mas(this.data_pay_systems);
        
        this.write_list_pay_systems();
      }
    
    this.write_list_pay_systems = function()
      {
        var mas_str = [];
        
        var tt="Инструкция по подключению платежных систем находится в файле payment.html, который лежит в архиве со скриптом";
        
        mas_str.push(["div",[["class","elm_help_info"]],tt]);
        
        if (this.data_pay_systems.length > 0)
          {
            
            var mas_table = ["table",[["cellpadding","0"],["cellspacing","0"],["class","table_control_t3"]],[]];
            
            mas_table[2].push(["thead",false,[
               ["tr",false,[
                 ["td",false,"N"],
                 ["td",false,"Платежная система"],
                 ["td",false,"Описание"],
                 ["td",false,"Использование"],
                ]]
              ]]);
            
            var mas_tbody_tr=[],st_tr=[],one_syst=[];
            var n=1;
            
            for (let i=0; i<this.data_pay_systems.length; i++)
              {
                one_syst=this.data_pay_systems[i];
                
                st_tr=this._forming_one_row_list(one_syst,i,n);
                mas_tbody_tr.push(st_tr);
                n++;
              }
            
            mas_table[2].push(["tbody",false,mas_tbody_tr]);
            mas_str.push(mas_table);
            
          }
        else
          {
            // Нет платежных систем
            mas_str.push(["div",[["class","block_text_alert"]],"Нет модулей платежных систем"])
          }
        
        forming_html_struct_data.write_data(this.obj_block_print,[["div",[["class","marginTB10"]],mas_str]]);
      }
    
    this._forming_one_row_list = function(one_syst,i,n)
      {
        var _this=this;
        var st_tr=["tr",false,[
          ["td",false,[["span",[["class","table_control_t3_name_compact"]],"N:"],n]],
          ["td",false,[
            ["span",[["class","table_control_t3_name_compact"]],"Платежная система:"],
            ["span",[["class","span_link_t1"]],jsCodeHtmlChars(one_syst[0]),[["click",function(){ _this._action_create_one_system(one_syst,i); }]]]
           ]],
          ["td",false,[["span",[["class","table_control_t3_name_compact"]],"Описание:"],one_syst[2]["name_system"] ]],
          ["td",false,[["span",[["class","table_control_t3_name_compact"]],"Использование:"],one_syst[2]["use_pay_system"]== "on" ? "используется":"не используется"]]
        ]];
        
        return (st_tr);
      }
    
    this._action_create_one_system = function(one_syst,i)
      {
        this._forming_form_create_system(one_syst,i);
      }
    
    this._forming_form_create_system = function(one_syst,i)
      {
        //wconsole("one_syst",one_syst,"i",i);
        var _this=this;
        var st_data=[];
        st_data.push(["h2",false,"Платежная система "+one_syst[0]]);
        
        //var param_use=["use_pay_system","checkbox","on","","Использовать платежную систему",""];
        //var mas_scheme=[param_use].concat(one_syst[1]);
        var mas_scheme=one_syst[1];
        
        var st_elms_form=eng_scheme_comp.forming_fields_form_setngs(mas_scheme,{btn_save: {fn_action:function(){ _this.action_user_save_setngs(one_syst,i); }}, btn_cancel: {fn_action:function(){ _this.action_user_cancel_setngs(); }} });
        
        var st_form=["form",[["name","setngs_pay_system_one"],["action",""],["onsubmit","return (false);"]],st_elms_form ];
        
        st_data.push( ["div",[["class","dt_entry_main"]],[
          ["div",[["id","contr_bk_list_errors_create_system"]],""],
          st_form
         ]]);
        
        forming_html_struct_data.write_data(this.obj_block_print,st_data);
        
        this._set_values_form_one_system(one_syst[1],one_syst[2]);
        
      }
    
    this._set_values_form_one_system = function(setngs,values)
      {
        eng_scheme_comp.set_values_form_scheme("setngs_pay_system_one",setngs,values);
      }
    
    this.action_user_save_setngs = function(one_syst,i)
      {
        //проверка прав пользователя
        if (!exists_rights_this_modul("write")) return;
        
        //wconsole(one_syst,i);
        var _this = this;
        
        var obj_form = engine_elm_html.get_obj_form("setngs_pay_system_one");
        
        var verificData=eng_scheme_comp.convert_setngs_data_verific(one_syst[1]);
        //var verificUse=["use_pay_system","use_pay_system","checkbox","text",true,false,"",false,"","off","Обнаружена внутренняя ошибка!",true,"Выбор платежной системы"];
        //verificData=[verificUse].concat(verificData);
        //wconsole("verificData",verificData);
        
        this._write_errors_verific([],[]);
        
        var data_form = processing_data_form(obj_form,verificData,false);
        
        if ( data_form[0] )
          {
            this._write_errors_verific([],data_form[3])
            return (false);
          }
        
        var url = this.dir_sr + "create_pay_system.php";
        var data_send=data_form[1];
        data_send["create_system"]=one_syst[0];
        eng_secrt.add_code_mas(data_send);
        
        var post = encode_assoc_mas_query_ajax(data_send);
        
        loadHTTPjc(url,function(a,b){ _this._obr_srv_query_save_setngs(a,b); },post);
      }
    
    this._write_errors_verific = function(mas_errors,mas_index_errors)
      {
        var on_scroll_first = true;
        if (mas_errors.length > 0) on_scroll_first = false;
        
        eng_status_control_form_cp.write_errors_list(mas_errors,"contr_bk_list_errors_create_system",true);
        eng_status_control_form_cp.write_errors_ident(mas_index_errors,true,on_scroll_first,"block_field_form_");
        
        return (true);
      }
    
    this._obr_srv_query_save_setngs = function(answer,add_param)
      {
        //wconsole(answer,add_param);
        var data=answer.data;
        
        var mas_errors=data.error_proc_mas;
        decode_mas(mas_errors);
        
        if (data.error_proc == 0)
          {
            this.load_data_srv();
          }
        else
          {
            this._write_errors_verific(mas_errors[0],mas_errors[1]);
          }
        
      }
    
    this.action_user_cancel_setngs = function()
      {
        
        this.write_list_pay_systems();
        
      }
    
    
    this.init_first_html();
  }


gl_pay_systems_wk.prototype.num_create_copy = 0;
mas_gl_admin["paysystems"].wk_paysystems = gl_pay_systems_wk;


</script>
