<?php

include_once("../../config/config.php");
$type_rights_access = array("mdgeodata","server","write");
$admin_check_contr_code=true;
include_once(DIR_ADMIN."/init_work.php");

class class_geo_add_list
  {
   
   public $rez_control_data = array();
   public $mas_inbox = array();
   public $mas_status = array();
   
   public $obj_site = false;
   public $mas_name_table = array();
   
   function __construct()
     {
      
      $this->mas_name_table = array( "country" => DB_PREF."country", "region" => DB_PREF."region", "city" => DB_PREF."city" );
      
     }
   
   function work()
     {
      $error=0;
      $error_text="no";
      $rez="";
      
      $d_mas = $this->list_oper();
      $error = $d_mas[0];
      $error_text = $d_mas[1];
      if ( isset($d_mas[2]) ) $rez = $d_mas[2];
      
      write_ajax_answer_jc($error,$error_text,$rez);
     }
   
   function list_oper()
     {
      
      $this->check_post_data();
      if ( !($this->rez_control_data[0] && !$this->rez_control_data[1]) ) return (array(1,"Ошибка с данными!"));
      
      return ($this->save_data());
     }
   
   function check_post_data()
     {
      
      $mas_check = array(
        
        array("data_list","post","data_list","text",true,true,false,"",false,false,false,false),
        //array("translit","post","translit","text",true,true,"hablonrv","/^[a-zA-Z0-9\-_]+$/iu",false,false,false,false),
        array("type_sgeo","post","type_sgeo","text",true,true,"listv","country,region,city",false,false,false,false),
        //array("type_create","post","type_create","text",true,true,"listv","new,edit",false,false,false,false),
        //array("num_create","post","num_create","numeric",true,false,false,"",false,false,"all",0),
        array("n_country","post","country_id","numeric",true,false,false,"",false,false,"all",0),
        array("n_region","post","region_id","numeric",true,false,false,"",false,false,"all",0),
        //array("quick_link","post","quick_link","text",false,true,"listv","on,off",false,false,"all","off"),
        //array("pos","post","pos","numeric",false,false,false,"",false,false,"all",0)
       );
      
      global $obj_control_data;
      
      $this->rez_control_data=$obj_control_data->processing_one_group($mas_check);
      $this->mas_inbox=$this->rez_control_data[3];
      $this->mas_status=$this->rez_control_data[5];
     }
   
   function save_data()
     {
      $error=0;
      $error_text="no";
      $rez="";
      
      $mas_inbox = $this->mas_inbox;
      $mas_status = $this->mas_status;
      
      if ( ($mas_inbox["type_sgeo"] == "region" && $mas_inbox["country_id"] == 0)
       || ($mas_inbox["type_sgeo"] == "city" && ($mas_inbox["country_id"] == 0 || $mas_inbox["region_id"] == 0) ) )
        {
         return (array(1,"Ошибка с данными!"));
        }
      
      
      
      $mas_data_list = $this->proces_data_list($mas_inbox["data_list"],$mas_inbox["type_sgeo"]);
      
      $this->save_data_mas($mas_inbox,$mas_data_list);
      
      updateSettings( array("doska_quick_link_geo" => 0) );//меняем параметр кэша
      
      return (array(0,"no"));
     }
   
   function proces_data_list($text,$type_sgeo)
     {
      $sim_del = "|";
      $sim_del_row = "\n";
      
      $mas_data = array();//получим массив со структурой каждого элемента
      //название, транслит, название_2, название_3, позиция (если есть)
      
      $mas_row = explode($sim_del_row,$text);
      //write_log_cms($mas_row);
      
      $check_num_v = ( $type_sgeo == "country" ? true : false );
      
      foreach ($mas_row as $one_row)
        {
         $data_one = false;
         if ( trim($one_row) )
           {
            $mas_one_row = explode($sim_del,$one_row);
            $name=trim($mas_one_row[0]);
            if ( $name )
              {
               $data_one = array($name);
               
               $translit = "";
               $name_2="";
               $name_3="";
               $num_v = 0;
               
               $elm_1 = $this->check_elm_num($mas_one_row,1);
               $elm_2 = $this->check_elm_num($mas_one_row,2);
               $elm_3 = $this->check_elm_num($mas_one_row,3);
               $elm_4 = $this->check_elm_num($mas_one_row,4);
               
               $d_translit="";
               
               if ($elm_1[1] !== "text")
                 {
                  //указано только название (элемент -> 0)
                  if ($elm_1[1] == "numeric") $num_v=$elm_1[0];
                  
                 }
                elseif ($elm_1[1] == "text" && $elm_2[1] !== "text")
                  {
                   //указано название и url-транслит
                   $d_translit=$elm_1[0];
                   if ($elm_2[1] == "numeric") $num_v=$elm_2[0];
                   
                  }
                elseif ($elm_1[1] == "text" && $elm_2[1] == "text" && $elm_3[1] !== "text")
                  {
                   //указано название (элемент -> 0), название_2, название_3
                   if ($elm_3[1] == "numeric") $num_v=$elm_3[0];
                   $name_2=$elm_1[0];
                   $name_3=$elm_2[0];
                   
                  }
                elseif ($elm_1[1] == "text" && $elm_2[1] == "text" && $elm_3[1] == "text")
                  {
                   //указано название (элемент -> 0), url-транслит, название_2, название_3
                   $d_translit=$elm_1[0];
                   if ($elm_4[1] == "numeric") $num_v=$elm_4[0];
                   $name_2=$elm_2[0];
                   $name_3=$elm_3[0];
                  }
                
               
               if ( $d_translit )
                 {
                  $d_translit = preg_replace("/[^a-zA-Z0-9_-]/iu","",$d_translit);
                  if ( $d_translit ) $translit = $d_translit;
                 }
               
               if ( !$translit )
                 {
                  $translit = encode_text_to_url_name($name,"-");
                 }
               
               $data_one[1] = $translit;
               $data_one[2] = $name_2;
               $data_one[3] = $name_3;
               $data_one[4] = $num_v;
               
               $mas_data[] = $data_one;
              }
           }
         
        }
      //write_log_cms($mas_data);
      return ($mas_data);
     }
   
   function check_elm_num($mas_one_row,$i)
     {
      $type = false;
      $v = "";
      
      if ( !empty($mas_one_row[$i]) )
        {
         $v = trim($mas_one_row[$i]);
         if ( is_numeric($v) )
           {
            $type = "numeric";
            
           }
          elseif ( $v === "on" || $v === "off" )
            {
             $type = "flag";
            }
          else
            {
             $type = "text";
            }
        }
      
      return (array($v,$type));
     }
   
   function save_data_mas($mas_init,$mas_data_list)
     {
      
      $country_id = 0;
      $region_id = 0;
      $city_id = 0;
      
      if ( $mas_init["type_sgeo"] == "region" )
        {
         $country_id = $mas_init["country_id"];
        }
       elseif ( $mas_init["type_sgeo"] == "city" )
        {
         $country_id = $mas_init["country_id"];
         $region_id = $mas_init["region_id"];
        }
      
      if ( sizeof($mas_data_list) == 0 ) return (false);
      
      switch ($mas_init["type_sgeo"])
        {
         case ("country"):
           $db_query = "insert ". $this->mas_name_table[$mas_init["type_sgeo"]]." "
             ." (country_id, city_id, name, translit, use_country, pos, name_2, name_3 ) values ";
           $sep = "";
           foreach ( $mas_data_list as $one_item )
             {
              $db_query .= $sep. " ( ".$country_id.",".$city_id.",'".codeText($one_item[0])."','".codeText($one_item[1])."', "
               ." 'on',".$one_item[4].",'".codeText($one_item[2])."','".codeText($one_item[3])."'" 
               ." ) ";
              $sep = ",";
             }
           //write_log_cms($db_query);
           db_work::query($db_query);
           break;
         
         case ("region"):
           $db_query = "insert ". $this->mas_name_table[$mas_init["type_sgeo"]]." "
             ." (region_id, country_id, city_id, name, translit, name_2, name_3 ) values ";
           $sep = "";
           foreach ( $mas_data_list as $one_item )
             {
              $db_query .= $sep. " ( ".$region_id.",".$country_id.",".$city_id.",'".codeText($one_item[0])."','".codeText($one_item[1])."', "
               ."'".codeText($one_item[2])."','".codeText($one_item[3])."'"
               ." ) ";
              $sep = ",";
             }
           //write_log_cms($db_query);
           db_work::query($db_query);
           break;
         
         case ("city"):
           $db_query = "insert ". $this->mas_name_table[$mas_init["type_sgeo"]]." "
             ." (city_id, country_id, region_id, name, translit, quick_link, name_2, name_3 ) values ";
           $sep = "";
           foreach ( $mas_data_list as $one_item )
             {
              $db_query .= $sep. " ( ".$city_id.",".$country_id.",".$region_id.",'".codeText($one_item[0])."','".codeText($one_item[1])."', "
               ."'off','".codeText($one_item[2])."','".codeText($one_item[3])."' " 
               ." ) ";
              $sep = ",";
             }
           //write_log_cms($db_query);
           db_work::query($db_query);
           break;
        }
      
      return (true);
     }
   
  }



$obj_geo_add_list = new class_geo_add_list();
$obj_geo_add_list->work();

