<!DOCTYPE html>
<html>
<head>
<title>Вход в панель управления</title>
<?php global $dir_site_http_admin; ?>
<link rel="icon" href="<?php echo($dir_site_http_admin); ?>/favicon.png" type="image/png"> 
<!--<link rel="shortcut icon" href="<?php echo($dir_site_http_admin); ?>/favicon.png" type="image/png">-->

<meta name="viewport" content="width=device-width; initial-scale=1.0">
<link rel="stylesheet" href="general_css.css" type="text/css">

<script type="text/javascript" src="../allinclude/js_lib_general.js"></script>
<script type="text/javascript" src="../allinclude/js_start_functions_on_load.js"></script>

<script type="text/javascript">

var eng_secrt_enter={
  
  contr_open_frame: function ()
    {
      var on_open_frame=check_open_site_in_frame();
      if (on_open_frame)
        {
          //alert ("Сайт открыт во фрейме!");
          this.open_block_protect();
        }
    },
  
  open_block_protect: function()
    {
      var obj_bk=obj_processing_block.create_block_div("bk_protect",false,false,false);
      
      var d_style=[
        ["position","fixed"],
        ["width","100%"],
        ["height","100%"],
        ["zIndex","10000"],
        ["opacity","0"],
        ["background","#fff"]
      ];
      
      obj_processing_block.set_style_obj(obj_bk,d_style);
    },
};
add_functions_start_on_load(function(){ eng_secrt_enter.contr_open_frame(); });
</script>

<style type="text/css">


body , td , div { font-family: verdana, sans-serif; font-size: 16px; margin:0px; padding:0px; }

body { 
  
 }

.all_page {
  height: 100%;
  min-height: 100%;
  background: #fefefe;
  /*background-image: linear-gradient( -45deg, #86d78d, #76B77C 20%, #93C197 55%, #80B785 60%, #bbddbe);*/
  /*background-image: linear-gradient( 0deg, #f2f2f2, #fff);*/
  padding: /*70px 0px 70px*/ 0px;
 }

.bk_start_complex {
 display: flex;
 min-height: 100%;
 align-items: stretch;
 }

.bk_start_decor {
 width: 40%;
 background: #444 url("./images/start-security.png") no-repeat center center / contain;
 }

.bk_start_content {
 width: 60%;
 /*padding: 70px 0 20px 0;*/
 display: flex;
 align-items: center;
 }

.block_form_auth_base { text-align:left;
  max-width:340px;
  /*background: #79cc8b;*/
  /*background-image: linear-gradient( -45deg, #e6ebdd, #D9DED1 20%, #C8CCC1 55%, #D9DED1 60%, #e6ebdd);*/
  margin: 0px auto 0px auto; 
  padding: 20px 30px 20px 30px;
  /*border:solid 1px #bbb;
  -moz-border-radius: 3px; 
  -webkit-border-radius: 3px; 
  border-radius: 3px;
  */
  
 }

.block_form_auth_title { text-align:center; padding: 0px 0px 20px 0px; color: #222; font-size: 1.2em; font-weight:bold; }

form { margin:0px; padding:0px; }

.block_form_auth_error { margin: 15px 0px 15px 0px; background: #d97c56; padding:10px; color: #eee; font-size: 0.9em; }

.block_form_auth_pf { width: 100%; /*height: 1.8em;*/ font-weight: normal; font-size: 1em; 
  border:solid 1px #bdbdbd;
  background:#fff;
  color: #555;
  padding: 8px 10px;
  -moz-border-radius: 3px; 
  -webkit-border-radius: 3px; 
  border-radius: 3px;
 }
.block_form_auth_pf:focus { border:solid 1px #5b5b5b; color: #111; }

.block_form_contr_auth_btn_enter {
 margin: 30px 0 0 0;
 }

.block_form_auth_btn_enter { font-weight:normal; height: 2em; font-size: 1em; width: 100%;
  border:solid 1px #444; background: #444;
  -moz-border-radius: 3px; 
  -webkit-border-radius: 3px; 
  border-radius: 3px;
  color: #eee;
 }
.block_form_auth_btn_enter:hover { background: #111; }

.block_form_auth_name { color:#333; margin: 30px 0px 10px 0px; }

.block_form_auth_wrap_pf { margin: 5px 0px 0px 0px; }


.block_form_auth_link { margin: 30px 0px 0px 0px; text-align: center; }
.block_form_auth_link > span { vertical-align: middle;
 line-height: 34px;
 }
.block_form_auth_link img { width: 30px; height: auto; }
.block_form_auth_link a, .block_form_auth_link a:visited { /*font-weight:bold;*/ font-size:90%; color:#4c50ae; }
.block_form_auth_link a:hover { color:#111; }



.block_form_auth_memory_me { color: #333; font-size: 1em; margin: 15px 0px; }
.block_form_auth_memory_me * { vertical-align: bottom; }

@media screen and (max-width: 800px)
 {
 .bk_start_decor {
  width: 10px;
  background: #444;
  }
 
 .bk_start_content {
  width: calc(100% - 10px);
  }
 }

</style>

</head>
<body>
<div class="all_page">

<div class="bk_start_complex">
<div class="bk_start_decor">
</div>
<div class="bk_start_content">
<div class="block_form_auth_base">

<div class="block_form_auth_title">Вход в панель управления</div>
<?php
if ( $text_alert )
  echo ('<div class="block_form_auth_error">'.$text_alert.'</div>');
?>
<form action='mstart.php' method='post' name='forma_enter' >

<div class='block_form_auth_name'>Email</div>
<div class='block_form_auth_wrap_pf'><input type='text' name='entername' value='<?php echo(codeHtmlText($name_user_enter)); ?>' class='block_form_auth_pf' placeholder="Email"></div>

<div class='block_form_auth_name'>Пароль</div>
<div class='block_form_auth_wrap_pf'><input type='password' name='enterpas' value='' class='block_form_auth_pf' placeholder="Пароль"></div>

<div class="block_form_auth_memory_me"><label><input type="checkbox" name="memory" value="on" <?php echo ($on_memory ? ' checked="checked" ': ''); ?>> <span>запомнить меня</span></label></div>

<div class="block_form_contr_auth_btn_enter">
 <input type='submit' value='Войти' class='block_form_auth_btn_enter'>
 <input type='hidden' name='start' value='on'>
</div>

<div class="block_form_auth_link">
 <span>
  <img src="./images/logo_cms.png" alt="cms boxcode.ru">
 </span>
 <span>
  <a href="https://www.boxcode.ru/" target="_blank">CMS www.boxcode.ru</a>
 </span>
</div>

</form>
<script type='text/javascript'>window.onload=function(){ document.forms.forma_enter.entername.focus(); };</script>
       
</div>
</div>

</div>

</div>
</body>
</html>