<?php

include_once("../../config/config.php");
$type_rights_access = array("musers","server","read");
include_once(DIR_ADMIN."/init_work.php");


class get_data_users
{
  
  function getDataUsers($data)
    {
      global $masConfig;
      $answer = " ";
      
      $where_q = " activ_user = ".($data["type"] == "users_action" ? " 'on' " : " 'off' ");
      
      if (trim($data["id_list"])) $where_q .= " and id_user IN (".$data["id_list"].") ";
      if (trim($data["name_user_list"]))
        {
          $mas_user = explode(",", $data["name_user_list"]);
          $where_q .= " and ( ";
          $sep = "";
          foreach ($mas_user as $one_user)
            {
              $where_q .= $sep." name_user LIKE '%".codeText($one_user)."%'";
              $sep = " or ";
            }
          $where_q .= " ) ";
          
        }
      
      if (trim($data["email_user_list"]))
        {
          $mas_email = explode(",", $data["email_user_list"]);
          $where_q .= " and ( ";
          $sep = "";
          foreach ($mas_email as $one_email)
            {
              $where_q .= $sep." email_user LIKE '%".codeText($one_email)."%'";
              $sep = " or ";
            }
          $where_q .= " ) ";
          
        }
      
      if ($data["access_user"] != "all")
        {
          $where_q .= " and access_user = '".$data["access_user"]."' ";
        }
      
      if ($data["access_admin"] != "all")
        {
          if ($data["access_admin"] == "on")
            {
              $where_q .= " and (access_admin = 'on' or access_admin = 'sadmin') ";
            }
          else
            {
              $where_q .= " and access_admin = 'off' ";
            }
        }
      
      if ($data["on_subscribe"] != "all")
        {
          $where_q .= " and on_subscribe = '".$data["on_subscribe"]."' ";
        }
      
      if ($data["operation_1"] != "all")
        {
          $where_q .= " and operation_1 = '".$data["operation_1"]."' ";
        }
      
      if ($data["type_account"] != "all")
        {
          $where_q .= " and type_account = '".$data["type_account"]."' ";
        }
      
      if ($data["time_last_visit"] != "all")
        {
          //write_log_cms($data["time_last_visit"], "time last visit");
          $_c_period = $this->_get_cond_period($data["time_last_visit"]);
          //write_log_cms($_c_period,"условие по времени");
          if ($_c_period)
            {
              $where_q .=  " and " .$_c_period;
            }
        }
      
      $db_query = "select count(*) from ";
      $db_query .= DB_PREF."users where ".$where_q;
      $kol_vsego = obr_db_query_count($db_query);
      
      $answer .= " vsego:".$kol_vsego;
      
      $db_query = "select * from ".DB_PREF."users where ".$where_q." order by id_user DESC limit ".(($data["page"] - 1) * $data["kolvo"])." , ".$data["kolvo"]." ";
      
      list($kolvo, $data_user) = obr_db_query_select_assoc($db_query);
      
      
      $answer .= " , data:[";
      $raz2 = " ";
      
      $answer .= encode_gen_mas_to_jointext($data_user, false, true);
      
      $answer .= " ]";
      
      $answer .= ", setup_registr: { on_use_pole_phone_user :".(isset($masConfig["ON_USE_POLE_PHONE_USER"]) ? $masConfig["ON_USE_POLE_PHONE_USER"] : "0");
      $answer .= ", use_check_active_phone_user : ".(isset($masConfig["USE_CHECK_ACTIVE_PHONE_USER"]) ? $masConfig["USE_CHECK_ACTIVE_PHONE_USER"] : "0");
      $answer .= "}";
      
      return ($answer);
    }
  
  function _get_cond_period($period)
    {
      $t = "";
      
      $mas_period = eng_time::get_interval_timestamp_period($period, $GLOBALS["timeGlobal"]);
      
      //write_log_cms($mas_period,"интервал в timestamp");
      //write_log_cms($mas_period[1]-$mas_period[0],"интервал времени - разница в секундах");
      
      if ($mas_period[0] != 0 || $mas_period[1] != 0)
        {
          $t = " ((date_visit > 0 and date_visit >= ".$mas_period[0]." and date_visit < ".$mas_period[1].") "
            ."or (date_visit = 0 and date_create >= ".$mas_period[0]." and date_create < ".$mas_period[1].")) ";
        }
      
      return ($t);
    }
  
}

$obj_load_users = new get_data_users();


$error=0;$error_text="no";
$text_rez="";

$rez = "";


$mas = array(
     
     array("type","post","type","text",true,true,"listv","users_action,users_not_action",false,false),
     
     array("page","post","page","numeric",true,true,false,false,false,false),
     array("kolvo","post","kolvo","numeric",true,true,false,false,false,false),
     
     array("access_user","post","access_user","text",true,true,"listv","all,on,off",false,false),
     array("operation_1","post","operation_1","text",true,true,"listv","all,on,off",false,false),
     array("id_list","post","id_list","text",true,false,"hablonrv","/^[0-9]+(\,[0-9]+)*$/is",false,false),
     array("name_user_list","post","name_user_list","text",true,false,false,false,false,false),
     array("email_user_list","post","email_user_list","text",true,false,false,false,false,false),
     
     array("access_admin","post","access_admin","text",true,true,"listv","all,on,off",false,false),
     array("on_subscribe","post","on_subscribe","text",true,true,"listv","all,on,off",false,false),
     array("type_account","post","type_account","text",true,true,"listv","all,regular,business",false,false),
     
     array("time_last_visit","post","time_last_visit","text",true,true,"listv","all,today,yesterday,week,numb_days30,numb_month6,numb_year,numb_year2,year_more,year2_more,year3_more",false,false),
     /*
     array("abuse","post","abuse","text",true,true,"listv","all,on,off",false,false),
     
     array("cat","post","cat","numeric",true,false,false,false,false,false),
     array("podcat","post","podcat","numeric",true,false,false,false,false,false),
     */
     
     );

if ($dbcnx)
  {
   
   $rez_control_data=$obj_control_data->processing_one_group($mas);
   
   if ( $rez_control_data[0] &&  !$rez_control_data[1]   )
     {
      //данные обнаружены и ошибок нет
      $mas_inbox=$rez_control_data[3];
      $mas_status = $rez_control_data[5];
      
      $text_rez=$obj_load_users->getDataUsers($mas_inbox);
      
      $rez = $text_rez;
      
     }
    else
      {
       $error=1;$error_text="ошибка с передачей данных!";
      }
   
   
  }
 else
   {
    $error=1;$error_text="ошибка с базой данных!";
   }


write_ajax_answer_jc($error,$error_text,$rez);

