<?php


class classGeoData
  {
   
   public $mas_quick_link_city = array();
   public $on_selected_quick_link_city = false;
   
   public $mas_data_for_extract_geo = array( 0 => array(), 1 => array(), 2 => array());
   public $mas_data_cache_geo = array( 0 => array(), 1 => array(), 2 => array());
   
   function __construct()
     {
      
     }
   
   function selectAllCountry($index_key = true)
     {
      //получаем в массиве все страны
      $mas_country=array();
      $db_query="select * from ".DB_PREF."country where use_country='on' order by pos DESC, name ";
      if ( $index_key )
        list($kol,$mas_country)=obr_db_query_select_assoc_index($db_query,"country_id");
       else
         list($kol,$mas_country)=obr_db_query_select_assoc($db_query);
      
      return ($mas_country);
     }
   
   function selectRegion($num_country,$index_key = true)
     {
      $db_query="select * from ".DB_PREF."region where country_id=".$num_country." order by name ";
      if ( $index_key )
        list($kol,$mas_region) = obr_db_query_select_assoc_index($db_query,"region_id");
       else
         list($kol,$mas_region) = obr_db_query_select_assoc($db_query);
      return ($mas_region);
     }
   
   function selectCity($num_region,$index_key = true)
     {
      $db_query="select * from ".DB_PREF."city where region_id=".$num_region." order by name ";
      if ( $index_key )
        list($kol,$mas_city) = obr_db_query_select_assoc_index($db_query,"city_id");
       else
         list($kol,$mas_city) = obr_db_query_select_assoc($db_query);
      return ($mas_city);
     }
   
   function selectCityQuickLink()
     {
      if ( !$this->on_selected_quick_link_city )
        {
         
         $db_query = "select * from ".DB_PREF."city where quick_link = 'on' "
          ." and country_id IN (select country_id from ".DB_PREF."country where use_country='on') order by name ";
         list($kol,$this->mas_quick_link_city) = obr_db_query_select_assoc($db_query);
         $this->on_selected_quick_link_city = true;
        }
      return ($this->mas_quick_link_city);
     }
   
   function select_name_geo_data($type_geo,$num_id)
     {
      
      $db_query="";
      $rez=false;
      
      switch ($type_geo)
        {
         case ("country"):$db_query="select * from ".DB_PREF."country where country_id = ".$num_id." ";break;
         case ("region"):$db_query="select * from ".DB_PREF."region where region_id = ".$num_id." ";break;
         case ("city"):$db_query="select * from ".DB_PREF."city where city_id = ".$num_id." ";break;
        }
      list($kol,$row)=obr_db_query_select_one_assoc($db_query);
      
      if ($kol > 0)
        {
         $rez=$row["name"];
        }
      
      return($rez);
     }
   
   function select_one_geo_data($type_geo,$num_id)
     {
      
      $db_query="";
      $rez=false;
      
      switch ($type_geo)
        {
         case ("country"):$db_query="select * from ".DB_PREF."country where country_id = ".$num_id." ";break;
         case ("region"):$db_query="select * from ".DB_PREF."region where region_id = ".$num_id." ";break;
         case ("city"):$db_query="select * from ".DB_PREF."city where city_id = ".$num_id." ";break;
        }
      list($kol,$row)= db_work::query_select_one_assoc($db_query);
      
      if ($kol > 0)
        {
         $rez=$row;
        }
      
      return($rez);
     }
   
   function check_name_type_geo($name_geo,$type_geo,$num_country = 0, $num_region = 0)
     {
      $rez = false;
      
      switch ( $type_geo )
        {
         case ("country"): $db_query = "select * from ".DB_PREF."country where name = '".codeText($name_geo)."'  ";break;
         case ("region"): $db_query = "select * from ".DB_PREF."region where country_id = ".$num_country." and name = '".codeText($name_geo)."'  ";break;
         case ("city"): $db_query = "select * from ".DB_PREF."city where country_id = ".$num_country." and region_id = ".$num_region." and name = '".codeText($name_geo)."'  ";break;
         
        }
      list($kol,$row)=obr_db_query_select_one_assoc($db_query);
      
      if ( $kol > 0 ) $rez = $row;
      
      return ( $rez );
     }
   
   function selectGroupRegion($list_country)
     {
      $db_query="select * from ".DB_PREF."region where country_id IN (".$list_country.") order by name ";
      //if ( $index_key )
      list($kol,$mas_region) = obr_db_query_select_assoc_index_group($db_query,"country_id");
      // else
      //   list($kol,$mas_region) = obr_db_query_select_assoc($db_query);
      return ($mas_region);
     }
   
   function selectGroupCity($list_region)
     {
      $db_query="select * from ".DB_PREF."city where region_id IN (".$list_region.") order by name ";
      //if ( $index_key )
      list($kol,$mas_city) = obr_db_query_select_assoc_index_group($db_query,"region_id");
      // else
      //   list($kol,$mas_region) = obr_db_query_select_assoc($db_query);
      return ($mas_city);
     }
   
   public function get_data_geo_translit($data_geo_translit)
     {
      global $masConfig;
      $error = false;
      $mas_geo = array( "country" => 0, "region" => 0, "city" => 0, "d_country" => false, "d_region" => false, "d_city" => false, "error" => false );
      $mas_geo_tmp = array( "country" => 0, "region" => 0, "city" => 0, "d_country" => false, "d_region" => false, "d_city" => false );
      $mas_step = array( "country" => false, "region" => false, "city" => false );
      
      if ( $masConfig["NUM_COUNTRY"] > 0 )
        {
         if ( $masConfig["NUM_REGION"] > 0 )
           {
            if ( $data_geo_translit["city"] )
              {
               
               $mas_step["city"] = array( "country_id" => $masConfig["NUM_COUNTRY"], "region_id" => $masConfig["NUM_REGION"], "translit" => $data_geo_translit["city"] );
               
              }
            
           }
          else
            {
             if ( $data_geo_translit["region"] )
               {
                $mas_step["region"] = array( "country_id" => $masConfig["NUM_COUNTRY"], "translit" => $data_geo_translit["region"] );
                if ( $data_geo_translit["city"] )
                  {
                   $mas_step["city"] = array( "country_id" => $masConfig["NUM_COUNTRY"], "region_id" => 0, "translit" => $data_geo_translit["city"] );
                  }
               }
            }
        }
       else
         {
          if ( $data_geo_translit["country"] )
            {
             $mas_step["country"] = array( "translit" => $data_geo_translit["country"] );
             
             if ( $data_geo_translit["region"] )
               {
                $mas_step["region"] = array( "country_id" => 0, "translit" => $data_geo_translit["region"] );
                if ( $data_geo_translit["city"] )
                  {
                   $mas_step["city"] = array( "country_id" => 0, "region_id" => 0, "translit" => $data_geo_translit["city"] );
                  }
               }
             
            }
          
          
         }
      
      if ( $mas_step["country"] )
        {
         
         $db_query = "select * from ".DB_PREF."country where binary translit = '".codeText($mas_step["country"]["translit"])."' ";
         list($kolvo,$data) = db_work::query_select_one_assoc($db_query);
         if ($kolvo > 0)
           {
            $mas_geo_tmp["country"] = $data["country_id"];
            $mas_geo_tmp["d_country"] = $data;
            if ( $mas_step["region"] ) $mas_step["region"]["country_id"] = $data["country_id"];
            if ( $mas_step["city"] ) $mas_step["city"]["country_id"] = $data["country_id"];
           }
          else
            {
             $mas_step["region"] = false;
             $mas_step["city"] = false;
             $error = true;
            }
         
        }
      
      if ( !$error && $mas_step["region"] )
        {
         $db_query = "select * from ".DB_PREF."region where country_id = ".$mas_step["region"]["country_id"]
           ." and binary translit = '".codeText($mas_step["region"]["translit"])."' ";
         list($kolvo,$data) = db_work::query_select_one_assoc($db_query);
         if ($kolvo > 0)
           {
            $mas_geo_tmp["country"] = $data["country_id"];
            $mas_geo_tmp["region"] = $data["region_id"];
            $mas_geo_tmp["d_region"] = $data;
            if ( $mas_step["city"] ) $mas_step["city"]["region_id"] = $data["region_id"];
           }
          else
            {
             $mas_step["city"] = false;
             //$mas_geo = array( "country" => 0, "region" => 0, "city" => 0 );
             $error = true;
            }
         
        }
      
      if ( !$error && $mas_step["city"] )
        {
         $db_query = "select * from ".DB_PREF."city where country_id = ".$mas_step["city"]["country_id"]
           ." and region_id = ".$mas_step["city"]["region_id"]." and binary translit = '".codeText($mas_step["city"]["translit"])."' ";
         list($kolvo,$data) = db_work::query_select_one_assoc($db_query);
         if ($kolvo > 0)
           {
            $mas_geo_tmp["country"] = $data["country_id"];
            $mas_geo_tmp["region"] = $data["region_id"];
            $mas_geo_tmp["city"] = $data["city_id"];
            $mas_geo_tmp["d_city"] = $data;
            
           }
          else
            {
             
             //$mas_geo = array( "country" => 0, "region" => 0, "city" => 0 );
             $error = true;
            }
         
        }
      
      if ( !$error ) $mas_geo = $mas_geo_tmp;
      $mas_geo["error"] = $error;
      
      return ( $mas_geo );
     }
   
   public static function parse_text_url_from_geo($txt_url)
     {
      // парсим url-адерс, находим названия ГЕО и возвращаем в том числе url-адрес без гео-параметров
      global $masConfig;
      $mas_elem_url=array("");
      $kolvo_elem=1;
      
      if ($txt_url != "")
        {
         $mas_elem_url = explode("/",$txt_url);
         //var_dump($mas_elem_url);
         $kolvo_elem = sizeof($mas_elem_url);
         
         if ( $mas_elem_url[$kolvo_elem-1] == "" )
           {
            array_pop($mas_elem_url);
            $kolvo_elem--;
           }
        }
      
      //далее проверяем количество элементов в массиве (исходя из настроек ГЕО)
      $set_num = 0;
      if ( $mas_elem_url[0] == "allgeo" || $mas_elem_url[0] == "" )
        {
         $set_num = 1;
        }
       elseif ( $masConfig["NUM_COUNTRY"] > 0 )
         {
          if ( $masConfig["NUM_REGION"] > 0 )
            {
             $set_num = 1;
            }
           else
             {
              $set_num = 2;
             }
         }
        else
          {
           $set_num = 3;
          }
      
      $kolvo = $set_num;
      
      if ( $kolvo_elem < $set_num )
        {
         $kolvo = $kolvo_elem;
        }
      
      $mas_num_data_geo = array( 0 => false, 1 => false, 2 => false);
      $mas_data_geo = array("country" => false, "region" => false, "city" => false, "allgeo" => false, "redirect" => false);
      
      $mas_elem_data_geo = array_slice($mas_elem_url,0,$kolvo);
      $mas_add_elem_url = array_slice($mas_elem_url,$kolvo);
      
      //$kol_elem_geo = sizeof($mas_elem_data_geo);
      if ( !($set_num == 1 && ($mas_elem_url[0] == "allgeo" || $mas_elem_url[0] == "")) )
        {
         for ( $i = 0; $i < $kolvo; $i++ )
           {
            $mas_num_data_geo[3-$set_num+$i] = $mas_elem_data_geo[$i];
           }
         
         $mas_data_geo["country"] = $mas_num_data_geo[0];
         $mas_data_geo["region"] = $mas_num_data_geo[1];
         $mas_data_geo["city"] = $mas_num_data_geo[2];
        }
       else
         {
          $mas_data_geo["allgeo"] = true;
          $mas_data_geo["redirect"]=($mas_elem_url[0] == "allgeo" ? true:false);
         }
      
      return ( array($mas_data_geo,$mas_add_elem_url) );
     }
   
   public function forming_geo_in_url_main_setting($on_res_mas=false)
     {
      global $masConfig;
      $t = "";
      $set = true;
      $m_data = array( 0 => array(), 1 => array("country"=>"", "region"=>"", "city"=>""));// 0 - url, 1 - название гео
      
      if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
        {
         if ( !($masConfig["NUM_COUNTRY"] > 0) )
           {
            if ( $GLOBALS["user_view_data_country"] )
              {
               $t .= "/".$GLOBALS["user_view_data_country"]["translit"];
               $m_data[0]["country"]=$GLOBALS["user_view_data_country"]["translit"];
               $m_data[1]["country"]=$GLOBALS["user_view_data_country"]["name"];
              }
             else
               {
                $set = false;
               }
           }
         
         if ( $set && !($masConfig["NUM_REGION"] > 0) )
           {
            if ( $GLOBALS["user_view_data_region"] )
              {
               $t .= "/".$GLOBALS["user_view_data_region"]["translit"];
               $m_data[0]["region"]=$GLOBALS["user_view_data_region"]["translit"];
               $m_data[1]["region"]=$GLOBALS["user_view_data_region"]["name"];
              }
             else
               {
                $set = false;
               }
           }
         
         if ( $set )
           {
            if ( $GLOBALS["user_view_data_city"] )
              {
               $t .= "/".$GLOBALS["user_view_data_city"]["translit"];
               $m_data[0]["city"]=$GLOBALS["user_view_data_city"]["translit"];
               $m_data[1]["city"]=$GLOBALS["user_view_data_city"]["name"];
              }
             else
               {
                $set = false;
               }
           }
         
        }
      
      //write_log_cms($m_data);
      
      return ($on_res_mas ? array($t,$m_data[0],$m_data[1]):$t);
     }
   
   public function check_geo_url_param($txt_geo_param,$on_empty_end_url)
     {
      // $on_empty_end_url - если равен true, то будет проверяться сущестование части после ГЕО: если будет, то это приведет к ошибке
      $mas_data_geo = $this->parse_text_url_from_geo($txt_geo_param);
      $mas_geo = array("country" => 0, "region" => 0, "city" => 0, "d_country" => false, "d_region" => false, "d_city" => false);
      $error = false;
      
      if ( $on_empty_end_url )
        if ( sizeof($mas_data_geo[1]) > 0 ) $error = true;
      
      if (!$error)
        {
         $mas_geo = $this->get_data_geo_translit($mas_data_geo[0]);
         if ( $mas_geo["error"] )
           $error = true;
          else
            {
             
            }
        }
      
      return (array($error,$mas_geo,$mas_data_geo[0],$mas_data_geo[1]));
     }
   
   public function check_geo_mas_data_url_param($txt_geo_param,$mas_check_geo)
     {
      $error = false;
      $txt_end_part = "";
      list($error,$mas_get_data,$mas_parse_geo_part,$mas_parse_end_part) = $this->check_geo_url_param($txt_geo_param,false);
      
      global $masConfig;
      
      if ( !$error )
        {
         
         if ( !($masConfig["NUM_COUNTRY"] > 0) )
           {
            if ( $mas_get_data["country"] != $mas_check_geo[0] )
              {
               $error = true;
              }
           }
         
         if ( !$error && !($masConfig["NUM_REGION"] > 0) )
           {
            if ( $mas_get_data["region"] != $mas_check_geo[1] )
              {
               $error = true;
              }
           }
         
         if ( !$error )
           {
            if ( $mas_get_data["city"] != $mas_check_geo[2] )
              {
               $error = true;
              }
           }
         
         if ( !$error )
           {
            if ( sizeof($mas_parse_end_part) )
              {
               $txt_end_part = implode("/",$mas_parse_end_part);
              }
           }
         
        }
      
      return (array($error,$txt_end_part,$mas_get_data,$mas_parse_geo_part,$mas_parse_end_part));
     }
   
   public function add_data_mas_for_extract_geo($data_mas,$init_v)
     {
      
      foreach ( $data_mas as $one_data )
        {
         $num_country = $one_data[$init_v[0]];
         $num_region = $one_data[$init_v[1]];
         $num_city = $one_data[$init_v[2]];
         
         $this->add_one_data_for_extract_geo(array($num_country,$num_region,$num_city));
        }
      
     }
   
   public function add_one_data_for_extract_geo($data_mas)
     {
      //проверяем, есть ли данные в массиве с данными гео, которые позже нужно будет получить
      // ключи в массиве $data_mas
      // 0 - id страны, 1 - id региона, 2 - id города
      $mas = array("country","region","city");
      for ( $i = 0; $i < 3; $i++ )
        {
         //if ( !in_array($data_mas[$i],$this->mas_data_for_extract_geo[$i]) )
           //{
            //$this->mas_data_for_extract_geo[$i][] = $data_mas[$i];
            $this->add_type_one_data_for_extract_geo($mas[$i],$data_mas[$i]);
           //}
        }
      
     }
   
   public function add_type_one_data_for_extract_geo($type,$data_num)
     {
      $mas = array("country" => 0, "region" => 1, "city" => 2);
      $type_num = false;
      if ( isset($mas[$type]) )
        $type_num = $mas[$type];
      
      if ( $type_num !== false && $data_num )
        {
         if ( !in_array($data_num,$this->mas_data_for_extract_geo[$type_num]) )
           {
            $v = $this->check_data_cache_geo($type,$data_num);
            if ( $v === 0 )
              $this->mas_data_for_extract_geo[$type_num][] = $data_num;
           }
        }
      
     }
   
   public function get_data_geo($data_mas)
     {
      $data_geo = array( 0=> false, 1=> false, 2=> false);
      
      $on_country = false;
      $on_region = false;
      $on_city = false;
      
      $v = $this->check_data_cache_geo("country",$data_mas[0]);
      if ( $v !== 0 )
        {
         $data_geo[0] = $v;
         $on_country = true;
        }
       else
         {
          $this->add_type_one_data_for_extract_geo("country",$data_mas[0]);
          $on_country = false;
         }
      
      $v = $this->check_data_cache_geo("region",$data_mas[1]);
      if ( $v !== 0 )
        {
         $data_geo[1] = $v;
         $on_region = true;
        }
       else
         {
          $this->add_type_one_data_for_extract_geo("region",$data_mas[1]);
          $on_region = false;
         }
      
      $v = $this->check_data_cache_geo("city",$data_mas[2]);
      if ( $v !== 0 )
        {
         $data_geo[2] = $v;
         $on_city = true;
        }
       else
         {
          $this->add_type_one_data_for_extract_geo("city",$data_mas[2]);
          $on_city = false;
         }
      
      if ( !$on_country || !$on_region || !$on_city )
        {
         $this->extract_data_geo();
         
         if ( !$on_country )
           {
            $v = $this->check_data_cache_geo("country",$data_mas[0]);
            $data_geo[0] = ($v ? $v : false);
           }
         
         if ( !$on_region )
           {
            $v = $this->check_data_cache_geo("region",$data_mas[1]);
            $data_geo[1] = ($v ? $v : false);
           }
         
         if ( !$on_city )
           {
            $v = $this->check_data_cache_geo("city",$data_mas[2]);
            $data_geo[2] = ($v ? $v : false);
           }
         
        }
      
      return ($data_geo);
     }
   
   public function check_data_cache_geo($type,$num)
     {
      $data_cache = 0;
      switch ( $type )
        {
         case ("country"):
           if ( isset($this->mas_data_cache_geo[0][$num]) )
             $data_cache = $this->mas_data_cache_geo[0][$num];
           break;
         
         case ("region"):
           if ( isset($this->mas_data_cache_geo[1][$num]) )
             $data_cache = $this->mas_data_cache_geo[1][$num];
           break;
         
         case ("city"):
           if ( isset($this->mas_data_cache_geo[2][$num]) )
             $data_cache = $this->mas_data_cache_geo[2][$num];
           break;
         
        }
      
      return ($data_cache);
     }
   
   public function extract_data_geo()
     {
      
      if ( sizeof($this->mas_data_for_extract_geo[0]) > 0 )
        {
         $db_query = "select * from ".DB_PREF."country where country_id IN (".implode(",",$this->mas_data_for_extract_geo[0]).") ";
         list($kolvo,$data) = db_work::query_select_assoc_index($db_query,"country_id");
         $this->add_data_geo_in_cache($this->mas_data_for_extract_geo[0],$data,0);
         $this->mas_data_for_extract_geo[0] = array();
        }
      
      if ( sizeof($this->mas_data_for_extract_geo[1]) > 0 )
        {
         $db_query = "select * from ".DB_PREF."region where region_id IN (".implode(",",$this->mas_data_for_extract_geo[1]).") ";
         list($kolvo,$data) = db_work::query_select_assoc_index($db_query,"region_id");
         $this->add_data_geo_in_cache($this->mas_data_for_extract_geo[1],$data,1);
         $this->mas_data_for_extract_geo[0] = array();
        }
      
      if ( sizeof($this->mas_data_for_extract_geo[2]) > 0 )
        {
         $db_query = "select * from ".DB_PREF."city where city_id IN (".implode(",",$this->mas_data_for_extract_geo[2]).") ";
         list($kolvo,$data) = db_work::query_select_assoc_index($db_query,"city_id");
         $this->add_data_geo_in_cache($this->mas_data_for_extract_geo[2],$data,2);
         $this->mas_data_for_extract_geo[0] = array();
        }
      
     }
   
   public function add_data_geo_in_cache($mas_num,$mas_data,$type_num)
     {
      
      foreach ( $mas_num as $one_data )
        {
         if ( isset($mas_data[$one_data]) )
           {
            $this->mas_data_cache_geo[$type_num][$one_data] = $mas_data[$one_data];
           }
          else
            {
             $this->mas_data_cache_geo[$type_num][$one_data] = false;
            }
         
        }
      
     }
   
   public function forming_geo_in_url_mas_data($mas_num_data,$data_geo=false,$on_res_mas=false)
     {
      global $masConfig;
      $t = "";
      $set = true;
      $m_data = array( 0 => array(), 1 => array("country"=>"", "region"=>"", "city"=>""));// 0 - url, 1 - название гео
      
      if ( !$data_geo )
        $mas_data = $this->get_data_geo($mas_num_data);
       else
         $mas_data = $data_geo;
      //write_log_cms($mas_data);
      
      if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
        {
         if ( !($masConfig["NUM_COUNTRY"] > 0) )
           {
            if ( $mas_data[0] )
              {
               $t .= "/".$mas_data[0]["translit"];
               $m_data[0]["country"]=$mas_data[0]["translit"];
               $m_data[1]["country"]=$mas_data[0]["name"];
              }
             else
               {
                $set = false;
               }
           }
         
         if ( $set && !($masConfig["NUM_REGION"] > 0) )
           {
            if ( $mas_data[1] )
              {
               $t .= "/".$mas_data[1]["translit"];
               $m_data[0]["region"]=$mas_data[1]["translit"];
               $m_data[1]["region"]=$mas_data[1]["name"];
              }
             else
               {
                $set = false;
               }
           }
         
         if ( $set )
           {
            if ( $mas_data[2] )
              {
               $t .= "/".$mas_data[2]["translit"];
               $m_data[0]["city"]=$mas_data[2]["translit"];
               $m_data[1]["city"]=$mas_data[2]["name"];
              }
             else
               {
                $set = false;
               }
           }
         
        }
      
      return ($on_res_mas ? array($t,$m_data[0],$m_data[1]):$t);
     }
   
   public function get_text_name_view_geo_data($sim = ", ")
     {
      global $masConfig;
      $t = "";
      $mas_d = array();
      
      if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
        {
         if ( !($masConfig["NUM_COUNTRY"] > 0) )
           {
            if ( $GLOBALS["user_view_data_country"] )
              {
               $mas_d[] = $GLOBALS["user_view_data_country"]["name"];
              }
            
           }
         
         if ( !($masConfig["NUM_REGION"] > 0) )
           {
            if ( $GLOBALS["user_view_data_region"] )
              {
               $mas_d[] = $GLOBALS["user_view_data_region"]["name"];
              }
            
           }
         
         if ( $GLOBALS["user_view_data_city"] )
           {
            $mas_d[] = $GLOBALS["user_view_data_city"]["name"];
           }
         
         if ( sizeof($mas_d) > 0 )
           {
            $t = implode($sim,$mas_d);
           }
         
        }
      
      return ($t);
     }
   
   function selectCityQuickLinkFull()
     {
      
      $db_query = "select city.*, region.name as region_name, region.translit as region_translit, country.name as country_name, country.translit as country_translit "
       ." from ".DB_PREF."city city join ".DB_PREF."region region join ".DB_PREF."country country "
       ." where city.quick_link = 'on' and city.region_id = region.region_id and city.country_id = country.country_id and country.use_country='on' ";
      list($kol,$mas_quick_link) = db_work::query_select_assoc($db_query);
      
      return ($mas_quick_link);
     }
   
   public function forming_geo_in_url_quick_link($data_quick_link)
     {
      //$data_quick_link - данные полученные в selectCityQuickLinkFull()
      global $masConfig;
      $t = "";
      
      if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
        {
         foreach ($data_quick_link as $key => $one_link)
           {
            $t="";
            if ( !($masConfig["NUM_COUNTRY"] > 0) )
              {
               $t .= "/".$one_link["country_translit"];
              }
            
            if ( !($masConfig["NUM_REGION"] > 0) )
              {
               $t .= "/".$one_link["region_translit"];
              }
            $t.="/".$one_link["translit"];
            $data_quick_link[$key]["url"]=$t;
           }
        }
      
      return ($data_quick_link);
     }
   
  }

