<?php

class eng_comments
{
  
  //переменные модуля комментариев
  protected $set_comments_page=false;
  protected $page_comment=1;//страница комментариев
  protected $on_submit_message_com=false;//массив с данными для работы модуля
  protected $mas_answer_com=array();
  protected $mas_from_kol_vsego_com=array();
  protected $save_id_comment=-1;
  protected $on_save_message_com=false;
  protected $is_get_email_guest='no';
  protected $new_data_comnt=[];
  protected $data_work=[];
  
  protected $comts_data_form=array();
  protected $comts_error_data_form=false;
  protected $comts_mas_error_data=array();
  protected $comts_on_submit_form=false;
  
  protected $comts_on_save_comnt=false;
  protected $comts_save_answ_num_comnt=0;
  
  protected $comts_save_id_comnt=0;
  
  protected $num_user_authorize=0;
  
  protected $dir_http="";
  protected $dir_cms="";
  protected $dir_template = "";
  protected $dir_http_template="";
  protected $dir_template_components = "";
  
  protected $data_comments=[];
  protected $data_nested_comments=[];
  protected $data_users=[];
  
  function __construct()
    {
      global $dir_http,$dir_cms,$dir_template,$dir_http_template,$dir_template_components;
      $this->dir_http=$dir_http;
      $this->dir_cms=$dir_cms;
      $this->dir_template = $dir_template;
      $this->dir_http_template=$dir_http_template;
      $this->dir_template_components = $dir_template_components;
    }
  
  function work_external()
    {
      $data_res=false;
      
      $type=(!empty($_POST["type_proc"]) && is_string($_POST["type_proc"]) ? $_POST["type_proc"] : "");
      
      if ($type != "")
        {
          if ($type == "add_comment")
            {
              $data_res=$this->save_new_one_comment();
            }
           elseif ($type == "get_more")
             {
               $data_res=$this->_proc_get_more();
             }
        }
      
      if (!$data_res)
        {
          $data_res=[
            "error_comnt"=>1,
            "error_comnt_mas"=>["Ошибка с данными!"],
          ];
        }
      
      return ($data_res);
    }
  
  function write_comments_modul($name_modul,$num_element,$on_write=true,$add_comments=true,$num_user_author_elm=0,$page_num=1,$url_param="pcom")
    {
      //Формируем комментарии (html-код)
      if (!$on_write) return ([0,""]);
      
      $page_num=1;//Сначала выводим только первую страницу, остальные страницы будут выводиться с помощью ajax 
      
      global $moduls_comments;
      $num_modul=$moduls_comments[$name_modul][0];
      
      global $mas_value_template,$tpl,$masConfig;
      $mas_perem = $mas_value_template;
      $mas_perem["masConfig"]=$masConfig;
      
      $mas_perem["comments_name_modul"]=$name_modul;
      $mas_perem["comments_num_modul"]=$num_modul;
      $mas_perem["comments_num_element"]=$num_element;
      $mas_perem["url_param"]=$url_param;
      
      
      $set_necessarily_pole_email=false;
      $set_use_pole_site=true;
      $set_name_author_elm="Автор публикации";
      
      if ( isset($moduls_comments[$name_modul]) )
        {
         $set_necessarily_pole_email=$moduls_comments[$name_modul][2];
         $set_use_pole_site=$moduls_comments[$name_modul][3];
         $set_name_author_elm=$moduls_comments[$name_modul][5];
        }
      
      $on_user_authorize=$GLOBALS["user_to_site"];
      $num_user_authorize=$GLOBALS["id_user_to_site"];
      
      $set_comments_page=false;
      
      if ( ( (COMMENTS_ONLY_AVTORIZ_USER==1 && $on_user_authorize) || COMMENTS_ONLY_AVTORIZ_USER==0 ) && $add_comments)
        $set_comments_page=true;
      
      $this->set_comments_page=$set_comments_page;
      
      
      $mas_perem["num_user_author_elm"] = $num_user_author_elm;
      $mas_perem["add_comments"] = $add_comments;
      $mas_perem["on_user_authorize"] = $on_user_authorize;
      
      $mas_perem["set_necessarily_pole_email"] = $set_necessarily_pole_email;
      $mas_perem["set_use_pole_site"] = $set_use_pole_site;
      $mas_perem["set_name_author_elm"] = $set_name_author_elm;
      
      
      $mas_perem["comts_data_form"]=$this->comts_data_form;
      $mas_perem["error_data_form"]=$this->comts_error_data_form;
      $mas_perem["mas_error_data"]=$this->comts_mas_error_data;
      $mas_perem["on_submit_form"]=$this->comts_on_submit_form;
      
      $mas_perem["on_save_comnt"]=$this->comts_on_save_comnt;
      $mas_perem["save_answ_num_comnt"]=$this->comts_save_answ_num_comnt;
      
      $mas_perem["save_id_comnt"]=$this->comts_save_id_comnt;
      
      
      //$vsego_comments = $this->get_count_comments($num_modul,$num_element,false);
      $vsego_comments = $this->get_count_comments_one_elm($num_modul,$num_element);
      
      $data_comments = array();
      $data_nested_comments = array();
      $vsego_pages = 1;
      $on_page=false;
      $data_users=[];
      
      if ( $vsego_comments > 0)
        {
          
          if ( $page_num <= 0 ) $page_num = 1;
          
          $query_limit="";
          if (SET_PAGES_COMMENTS==1)
            {
              $kolvo_top_comments=$this->get_count_comments($num_modul,$num_element,true);
              $vsego_pages=ceil($kolvo_top_comments/KOL_COMMENTS_TO_PAGE);
              $on_page=true;
              
              //$query_limit=" limit ".(($page_com-1)*KOL_COMMENTS_TO_PAGE).",".KOL_COMMENTS_TO_PAGE;
            }
          /*
          $db_query="select comment.*, users.id_user, users.name_user, users.email_user, users.access_user, users.access_admin, users.get_message_guest "
            ." from ".DB_PREF."comments comment "
            ." left join ".DB_PREF."users users on  comment.num_user=users.id_user "
            ." where hide='show' and "
            ." num_modul=$num_modul and num_element=$num_element and answ_num_comment=0 order by id_comment "
            .$query_limit;
          
          //list($kolvo_comments,$data_comments) = obr_db_query_select_assoc($db_query);
          */
          list($kolvo_comments,$data_comments) = $this->_get_db_data_comments($num_modul,$num_element,true,false,false,$on_page,$page_num);
          
          $mas_id_comnts=array();
          $mas_num_users=[];
          
          //if (SET_PAGES_COMMENTS==1)
            {
             $mas_id_comnts=select_mas1lev_2level($data_comments,"id_comment", false);
            }
          
          $mas_num_users=select_mas1lev_2level($data_comments,"num_user", false);
          $mas_num_users=array_unique($mas_num_users);
          $mas_num_users2=[];
          
          $kolvo_nested=0;
          
          if ($kolvo_comments > 0)
            {
              /*
              $db_query1="select comment.*, users.id_user, users.name_user, users.email_user, users.access_user, users.access_admin, users.get_message_guest from ".DB_PREF."comments comment "
                ." left join ".DB_PREF."users users on  comment.num_user=users.id_user "
                ." where hide='show' "
                ." and num_modul=$num_modul and num_element=$num_element "
                .(sizeof($mas_id_comnts)>0 ? " and answ_num_comment IN (".implode(",",$mas_id_comnts).") ":" and answ_num_comment > 0 ")
                ." order by id_comment ";//limit ".(($page_com-1)*KOL_COMMENTS_TO_PAGE).",".KOL_COMMENTS_TO_PAGE;
              list($kolvo_nested,$data_nested_comments)=db_work::query_select_assoc_index_group($db_query1,"answ_num_comment");
              */
              list($kolvo_nested, $data_nested_comments) = $this->_get_db_data_comments($num_modul, $num_element, false, $mas_id_comnts, false, false, 1);
            }
          
          if ($kolvo_nested > 0)
            {
              $mas_num_users2 = select_mas1lev_3level($data_nested_comments, "num_user");
              $mas_num_users2=array_unique($mas_num_users2);
              
              $mas_num_users=array_merge($mas_num_users,$mas_num_users2);
              $mas_num_users=array_unique($mas_num_users);
            }
          
          //удаляем 0 (нет id_user равным 0)
          $key=array_search("0",$mas_num_users);
          if ($key !== false) unset($mas_num_users[$key]);
          $mas_num_users=array_values($mas_num_users);
          //write_log_cms($mas_num_users,"mas num_user - 2");
          
          if ( sizeof($mas_num_users) > 0 ) $data_users=$this->_get_data_users($mas_num_users);
          //write_log_cms($data_users,"data users");
        }
      
      $mas_perem["set_comments_page"] = $set_comments_page;
      
      $mas_perem["vsego_comments"] = $vsego_comments;
      
      $mas_perem["vsego_pages"] = $vsego_pages;
      $mas_perem["page_com"] = $page_num;
      
      $mas_perem["data_comments"] = $data_comments;
      $mas_perem["data_nested_comments"] = $data_nested_comments;
      $mas_perem["data_users"] = $data_users;
      
      
      $hform="";
      $question_capcha_text = "";
      
      if (COMMENTS_KAPCHA==1 && !$on_user_authorize )
        {
          list($_num_v, $question_capcha_text, $_answer_kapcha) = set_data_capcha("capcha_comments_form", false);
        }
      
      $mas_perem["question_capcha_text"] = $question_capcha_text;
      $mas_perem["contr_code"] = eng_promote_safety::get_code($GLOBALS["id_user_to_site"]);
      /*
      if ($set_comments_page)
        {
         //если комментарии разрешены, то формируем форму 
         
         if (COMMENTS_KAPCHA==1 && !$on_user_authorize )
           {
            list($_num_v,$question_capcha_text,$_answer_kapcha) = set_data_capcha("capcha_comments_form",false);
           }
         
         $mas_perem["question_capcha_text"] = $question_capcha_text;
         $mas_perem["contr_code"] = eng_promote_safety::get_code($GLOBALS["id_user_to_site"]);
         
         $tpl->template_dir = $this->dir_template_components."/";
         $tpl->assign($mas_perem);
         $hform = $tpl->fetch("comments_form.html");
         
        }
       else
         $hform="";//комментарии не разрешены, поэтому формы нет//нет прав комментировать и т.п.
      */
      
      $mas_perem["hcode_form"] = $hform;
      
      
      $tpl->template_dir = $this->dir_template_components."/";
      
      $tpl->assign($mas_perem);
      $text = $tpl->fetch("comments_block.html");

      return ([$vsego_comments,$text]);
    }
  
  function get_count_comments($num_modul,$num_element,$only_first_lvl=true,$mas_ignore=false)
    {
      // Функция подсчитывает количество комментариев для элемента
      // Отличается от метода $this->get_count_comments_one_elm(), что только подсчитывает комментарии, в кэш не добавляет и не извлекает из кэша
       
      $db_ignore="";
      if ($mas_ignore && sizeof($mas_ignore) > 0)
        $db_ignore = " and id_comment NOT IN (". implode(",",$mas_ignore) .")";
      
      if ($only_first_lvl)
        {
          $db_query = "select count(*) from ".DB_PREF."comments "
            ." where hide='show' and num_modul=$num_modul and num_element=$num_element "
            ." and answ_num_comment=0 "
            .$db_ignore;
        }
      else
        {
          $db_query = "select "
           ."(select count(*) from ".DB_PREF."comments "
           ." where hide='show' and num_modul=$num_modul and num_element=$num_element and answ_num_comment=0 "
           .$db_ignore
           .")"
           ." + "
           ." (select count(*) from ".DB_PREF."comments "
           ." where hide='show' and num_modul=$num_modul and num_element=$num_element "
           .$db_ignore
           ." and answ_num_comment IN "
           ." (select id_comment from ".DB_PREF."comments where hide='show' and num_modul=$num_modul and num_element=$num_element and answ_num_comment=0 "
           .$db_ignore
           ." ) )";
        }
      
      $kolvo = db_work::query_count($db_query);
    
      return ($kolvo);
    }
  
  function check_num_page_comments($name_modul,$num_element,$num_page)
    {
      $on_check = false;
      global $moduls_comments;
      $num_modul = $moduls_comments[$name_modul][0];
      /*
      $db_query = "select count(*) from ".DB_PREF."comments where hide='show' "//." and  answ_num_comment=0 ".
      ." and num_modul=$num_modul and num_element=$num_element ";// limit ".(($page_com-1)*KOL_COMMENTS_TO_PAGE).",".KOL_COMMENTS_TO_PAGE."  ";
      // db_work::query_count($db_query);
      */
      $kolvo_top_comments = $this->get_count_comments($num_modul,$num_element,true);
      
      //if ( $kolvo_top_comments == 0 && $page_com == 1 ) $on_check = true;
      if ( ($kolvo_top_comments == 0 && $num_page == 1) || (($num_page - 1) * KOL_COMMENTS_TO_PAGE < $kolvo_top_comments) ) $on_check = true;
      
      return ($on_check);
    }
  
  function save_new_one_comment()
    {
      $this->new_data_comnt=[
        "id_comment"=>0
      ];
      
      $this->data_work=[
        "new_question_capcha"=>""
      ];
      
      list($error,$error_mas)=$this->_save_new_one_comment();
      
      $data_res=[
        "error_comnt"=>$error ? 1:0,
        "error_comnt_mas"=>$error_mas,
        "data_comnt"=>$this->new_data_comnt,
        "data_work"=>$this->data_work
      ];
      
      return ($data_res);
    }
  
  function _save_new_one_comment()
    {
      
      $page_com=1;
      $num_modul="";
      $name_modul="";
      $num_element=0;
      $url_param="";
      $on_write=true;
      $add_comments=true;
      
      $check_name_modul=true;
      $data_res=[];
      
      //COMMENTS_ONLY_AVTORIZ_USER
      global $masConfig,$moduls_comments;
      global $obj_control_data;
      
      $on_submit_form=false;
      $set_comments_page=false;
      
      $on_user_authorize=$GLOBALS["user_to_site"];
      $num_user_authorize=$GLOBALS["id_user_to_site"];
      
      if ((COMMENTS_ONLY_AVTORIZ_USER==1 && $on_user_authorize) || COMMENTS_ONLY_AVTORIZ_USER==0)
        $set_comments_page=true;
      
      $data_res=[];
      
      $v_flag=$_POST["com_on_message"] ?? "";
      
      // Если нет данных комментария или запрещено добавлять комментарии, то выходим
      if ($v_flag!=="moplafk") return ([true,["Ошибка с данными комментария"]]);
      if (!$set_comments_page) return ([true,["Запрещено добавлять комментарии"]]);
      
      
      $on_submit_form=true;
      $error_data_form=false;
      $mas_error_data=array();
      
      $comts_data_form=array(
       "com_name"=>"",
       "com_email"=>"",
       //"com_sait"=>"",
       "com_text"=>"",
       "answ_num_comment"=>0,
       "answ_num_comment2"=>0,
       "num_modul"=>0,
       "num_element"=>0,
       //"is_get_email"=>"no",
      );
      
      $on_save_comnt=false;
      $save_answ_num_comnt=0;
      $save_id_comnt=0;
      
      $main_num_answ_comnt=0;
      $num_answ_comnt2=0;
      
      //Данные элемента (публикации, объявления, компании), к которому добавлен комментарий 
      $data_elm=false;
      
      $mas_init_check = array(
         array("com_text","post","com_text","text",true,true,false,"",true,"tr",false,false,"Не введен текст комментария!",true,true),
         array("answ_num_comment","post","answ_num_comment","numeric:int:positive",true,false,false,"",true,"tr","all",0,"Обнаружена неизвестная ошибка!",true,true),
         array("answ_num_comment2","post","answ_num_comment2","numeric:int:positive",true,false,false,"",true,"tr","all",0,"Обнаружена неизвестная ошибка!",true,true),
         array("com_contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
         array("num_element","post","num_element","numeric:int:positive",true,true,false,"",false,false,"all",0,"Обнаружена неизвестная ошибка!",true,true),
         array("num_modul","post","num_modul","numeric:int:positive",true,true,false,"",false,false,"all",0,"Обнаружена неизвестная ошибка!",true,true),
        );
      
      if (!$on_user_authorize)
        {
          $mas_not_auth_user = array(
            array("com_name", "post", "com_name", "text", true, true, false, "", true, "tr", false, false, "Введите свое имя!", true, true),
            array("com_email", "post", "com_email", "text", true, false, "function", "check_data_email", true, "tr", false, false, "Введите Email!", true, "Указан не верный Email!"),
            //array("com_sait","post","com_sait","text",false,false,false,"",false,"tr","all","",false,false,false),
            //array("is_get_email","post","is_get_email","text",false,true,"listv","yes,no",false,false,"all","no","Обнаружена неизвестная ошибка!",true,true),
          );
          
          $mas_init_check = array_merge($mas_not_auth_user, $mas_init_check);
        }
      
      if ( COMMENTS_KAPCHA == 1 && !$on_user_authorize )
        {
          $mas_init_check[]= array("com_capcha","post","com_capcha","text",true,true,false,"",false,"tr","all","","Не указан ответ на контрольный вопрос!",true,false);
        }
      
      $rez_control_data=$obj_control_data->processing_one_group($mas_init_check);
      
      
      if ( $rez_control_data[0] )
        {
          $error_data_form = $rez_control_data[1];
          $mas_inbox = $rez_control_data[3];
          $mas_status = $rez_control_data[5];
          $mas_error_data = $rez_control_data[4];
          
          $comts_data_form = $mas_inbox;
          
          $on_check_contr = false;
          
          if (eng_promote_safety::check_code($GLOBALS["id_user_to_site"], $mas_inbox["contr_code"]))
            {
              $on_check_contr = true;
            }
          else
            {
              $error_data_form = true;
              $mas_error_data[] = "Неверный ключ безопасности!";
            }
          
          if (COMMENTS_KAPCHA == 1 && !$on_user_authorize)
            {
              if ($mas_inbox["com_capcha"] && !check_data_capcha("capcha_comments_form", $mas_inbox["com_capcha"]))
                {
                  $error_data_form = true;
                  $mas_error_data[] = "Неверный ответ на контрольный вопрос!";
                }
            }
          
        }
       else
         {
           $error_data_form=true;
           $mas_error_data[]="Ошибка с данными сообщения!";
         }
      
      
      if ($check_name_modul)
        {
          if (!$error_data_form)
            {
              $num_modul = $mas_inbox["num_modul"];
              $num_element = $mas_inbox["num_element"];
              $d_search = search_mas_2level($moduls_comments, 0, $num_modul, false);
              if ($d_search[0])
                {
                  $name_modul = $d_search[1];
                  
                }
              else
                {
                  $error_data_form = true;
                  $mas_error_data[] = "Ошибка в параметрах запроса!";
                }
            }
        }
       else
         {
           if ($name_modul)
             $num_modul=$moduls_comments[$name_modul][0];
         }
      
      
      $set_necessarily_pole_email=true;
      $set_use_pole_site=false;
      $set_name_author_elm="Автор публикации";
      $data_modul_comments=false;
      
      if ( $name_modul && isset($moduls_comments[$name_modul]) )
        {
         $data_modul_comments=$moduls_comments[$name_modul];
         $set_necessarily_pole_email=$moduls_comments[$name_modul][2];
         $set_use_pole_site=$moduls_comments[$name_modul][3];
         $set_name_author_elm=$moduls_comments[$name_modul][5];
        }
      
      
      if (!$error_data_form && $set_necessarily_pole_email && !$on_user_authorize)
        {
          if ($mas_inbox["com_email"] == "")
            {
              $error_data_form=true;
              $mas_error_data[]="Не указан Email!";
            }
        }
      
      
      if ($mas_inbox["answ_num_comment2"] > 0 && $mas_inbox["answ_num_comment"] == 0)
        {
          $error_data_form=true;
          $mas_error_data[]="Ошибка с параметрами!";
        }
      
      
      if (!$error_data_form && $mas_inbox["answ_num_comment"] > 0)
        {
          //ошибок при вводе комментария не обнаруженно,
          // проверим, если есть, правильность задания номера комментария,
          // к которому отправленн ответ
          
          $main_num_answ_comnt = $mas_inbox["answ_num_comment"];
          $num_answ_comnt2 = $mas_inbox["answ_num_comment2"];
          
          $db_query = "select * from ".DB_PREF."comments where id_comment=".$main_num_answ_comnt." "
            ." and num_modul=".$num_modul." and num_element=".$num_element." ";
          
          list($kolvo_com1, $data_com1) = db_work::query_select_one_assoc($db_query);
          if ($kolvo_com1 == 1)
            {
              
              if ($data_com1["answ_num_comment"] == 0)
                {
                  //$main_num_answ_comnt = $mas_inbox["answ_num_comment"];
                  
                  if ($num_answ_comnt2 > 0)
                    {
                      $db_query = "select * from ".DB_PREF."comments where id_comment=".$num_answ_comnt2." "
                        ." and num_modul=".$num_modul." and num_element=".$num_element." ";
                      list($kolvo_com2, $data_com2) = db_work::query_select_one_assoc($db_query);
                      
                      if (!($kolvo_com2 == 1 && $data_com2["answ_num_comment"] == $main_num_answ_comnt))
                        {
                          $error_data_form=true;
                          $mas_error_data[]="Обнаружена ошибка с параметрами!";
                        }
                    }
                }
               else
                 {
                   $error_data_form=true;
                   $mas_error_data[]="Обнаружена неизвестная ошибка!";
                 }
            }
          else
            {
              $error_data_form = true;
              $mas_error_data[] = "Обнаружена неизвестная ошибка!";
            }
          
        }
      
      if (!$error_data_form)
        {
          global $obj_site;
          $d_check_modul=false;
          if ($name_modul == "punkt" || $name_modul == "stat")
            {
              $d_check_modul=$obj_site->check_comment_elem($name_modul,$num_element);
            }
           else
             {
               $d_check_modul = $obj_site->intercomLink($name_modul, "check_comment_elem", ["num_element" => $num_element]);
             }
          
          if ($d_check_modul && !empty($d_check_modul["on_add_comment"]) && $d_check_modul["on_add_comment"])
            {
              $data_elm=$d_check_modul["data_elm"] ?? false;
              //write_log_cms($data_elm,"eng comments -> data_elm");
              
            }
           else
            {
              $error_data_form = true;
              $mas_error_data[] = "Обнаружена ошибка с параметрами!";
            }
        }
      
      //$error_data_form=true;
      //$mas_error_data[]="Обнаружена неизвестная ошибка";
      /*
      write_log_cms("- - - - - -","part delim");
      write_log_cms($error_data_form,"error_data_form comnts");
      write_log_cms($comts_data_form,"comts data form");
      write_log_cms($mas_error_data,"mas error data comnts");
      write_log_cms($name_modul.":".$num_modul.":".$num_element,"data modul");
      */
      
      
      
      if (!$error_data_form)
        {
          $mas_index = array("com_text");
          
          if (!$on_user_authorize)
            {
              $mas_index = array_merge($mas_index, array("com_name", "com_email"/*,"com_sait","is_get_email"*/));
            }
          
          $mas_save = copy_mas_to_mas_index($mas_inbox, array(), $mas_index);
          
          $mas_save["answ_num_comment"] = $main_num_answ_comnt;
          $mas_save["answ_num_comment2"] = $num_answ_comnt2;
          
          if ($on_user_authorize)
            {
              $mas_save["com_name"] = "";//Пользователь
              $mas_save["com_email"] = "";
              //$mas_save["com_sait"]="";
              //$mas_save["is_get_email"]="no";
            }
          
          $mas_save["id_comment"] = 0;
          
          $mas_save["type_user"] = "guest";
          $mas_save["num_user"] = 0;
          $mas_save["com_sait"] = "";
          $mas_save["is_get_email"] = "no";
          
          if ($on_user_authorize)
            {
              $mas_save["type_user"] = "user";
              $mas_save["num_user"] = $num_user_authorize;
            }
          
          $mas_save["hide"] = (COMMENTS_PREVIEW == 0 ? "show" : "hide");
          $mas_save["putdate"] = $GLOBALS["timeGlobal"];
          
          /* ip - адрес посетителя*/
          $ip_adr = "";
          global $infoUserAgent;
          $ip_adr = $infoUserAgent[1];
          
          $mas_save["com_ip"] = $ip_adr;
          $mas_save["com_moder"] = "new";
          $mas_save["num_modul"] = $num_modul;
          $mas_save["num_element"] = $num_element;
          
          $db_query = forming_db_query_indexmas(DB_PREF."comments", $mas_save, "new", "id_comment");
          
          db_work::query($db_query);
          
          clear_data_capcha("capcha_comments_form");
          
          $on_save_comnt = true;
          $save_answ_num_comnt = $mas_inbox["answ_num_comment"];
          $new_id_comnt = db_work::get_insert_id();
          
          //if (COMMENTS_PREVIEW == 0) 
          $save_id_comnt = $new_id_comnt;
          
          $this->calc_count_comments_one_elm($num_modul,$num_element);
          
          if (COMMENTS_KAPCHA==1 && !$on_user_authorize )
            {
              list($_num_v, $question_capcha_text, $_answer_kapcha) = set_data_capcha("capcha_comments_form", false);
              $this->data_work=[
                "new_question_capcha"=>$question_capcha_text
              ];
            }
          
          if ($masConfig["COMMENTS_NOTICE_ADMIN_ADD_NEW"] == 1)
            {
              global $url_site;
              $subject = "Уведомление о новом комментарии";
              $message = "Здравствуйте.<br/>\n"
                ."На вашем сайте ".$masConfig["NAME_SITE_TO_EMAIL"]." был добавлен комментарий."
                .($data_modul_comments ? "<br/>\n" ."Модуль &laquo;".$data_modul_comments[1] ."&raquo;.":"")
                .($data_elm ? "<br/>\n" ."Страница <a href='". $url_site.$data_elm["url_page"] ."'>". codeHtmlText($data_elm["name"]) ."</a>, ID - ".$data_elm["id"].".":"")
                ."<br/>\n" ."ID комментария ".$new_id_comnt.", текст комментария:<br/>\n"
                .'<div style="margin: 10px 0px; padding: 10px; background: #eee; color: #444;">'.nl2br(codeHtmlText($mas_save["com_text"])).'</div>'
                .forming_signature_email();
              
              send_email($subject, $message, "", $masConfig["EMAIL_ADMIN"]);
            }
          
          /*
          if ($mas_inbox["answ_num_comment"] == 0 && SET_PAGES_COMMENTS == 1 && COMMENTS_PREVIEW == 0)
            {
              //всего сообщений с answ_num_comment равным 0 
              $db_query = "select count(*) from ".DB_PREF."comments where hide='show' and  answ_num_comment=0 "
                ." and num_modul=".$num_modul." and num_element=".$num_element." ";// limit ".(($page_com-1)*KOL_COMMENTS_TO_PAGE).",".KOL_COMMENTS_TO_PAGE."  ";
              
              $vsego_comments_to_0 = db_work::query_count($db_query);
              $vsego_pages = ceil($vsego_comments_to_0 / KOL_COMMENTS_TO_PAGE);
              if ($page_com < $vsego_pages)
                {
                  $url = "?".$url_param."=".$vsego_pages;
                  $url .= "#commentN".$save_id_comnt;
                  sendheader::location($url);
                  //header ("Location: $url");
                  //echo ("Перенаправление ".$url);
                  exit();
                }
            }
          */
        }
      
      $this->comts_data_form=$comts_data_form;
      $this->comts_error_data_form=$error_data_form;
      $this->comts_mas_error_data=$mas_error_data;
      $this->comts_on_submit_form=$on_submit_form;
      
      $this->comts_on_save_comnt=$on_save_comnt;
      $this->comts_save_answ_num_comnt=$save_answ_num_comnt;
      
      $this->comts_save_id_comnt=$save_id_comnt;
      
      $this->new_data_comnt["id_comment"]=$save_id_comnt;
      
      return (array($error_data_form,$mas_error_data));
    }
  
  function _proc_get_more()
    {
      
      $this->data_comments=[];
      $this->data_nested_comments=[];
      $this->data_users=[];
      
      list($error,$error_mas)=$this->_proc_get_more_page();
      
      $data_res=[
        "error_comnt"=>$error ? 1:0,
        "error_comnt_mas"=>$error_mas,
        "data_comments"=>$this->data_comments,
        "data_nested_comments"=>$this->data_nested_comments,
        "data_users"=>$this->data_users,
      ];
      
      return ($data_res);
    }
  
  function _proc_get_more_page()
    {
      global $obj_control_data;
      
      $error=false;
      $error_mas=[];
      
      $mas_init_check = array(
         //array("com_text","post","com_text","text",true,true,false,"",true,"tr",false,false,"Не введен текст комментария!",true,true),
         array("num_page","post","num_page","numeric:int:positive",true,true,false,"",true,"tr","all",1,"Ошибка с номером страницы!",true,true),
         //array("answ_num_comment2","post","answ_num_comment2","numeric:int:positive",true,false,false,"",true,"tr","all",0,"Обнаружена неизвестная ошибка!",true,true),
         //array("com_contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
         array("num_element","post","num_element","numeric:int:positive",true,true,false,"",false,false,"all",0,"Обнаружена неизвестная ошибка!",true,true),
         array("num_modul","post","num_modul","numeric:int:positive",true,true,false,"",false,false,"all",0,"Обнаружена неизвестная ошибка!",true,true),
         array("mas_ignore","post","mas_ignore","list_int",true,false,false,"",false,false,"all","","Обнаружена ошибка с параметрами!",true,true),
        );
      
      $rez_control_data=$obj_control_data->processing_one_group($mas_init_check);
      
      if ( !($rez_control_data[0] && !$rez_control_data[1]) ) return ([true,["Ошибка с параметрами"]]);
      
      //$error_data_form = $rez_control_data[1];
      $mas_inbox = $rez_control_data[3];
      $mas_status = $rez_control_data[5];
      //$mas_error_data = $rez_control_data[4];
      
      //write_log_cms($mas_inbox,"get more comments");
      
      $num_page=$mas_inbox["num_page"];
      $num_element=$mas_inbox["num_element"];
      $num_modul=$mas_inbox["num_modul"];
      $mas_ignore=($mas_inbox["mas_ignore"]!="" ? explode(",",$mas_inbox["mas_ignore"]):[]);
      
      //$on_page=$this->check_num_page_comments($mas_inbox["num_page"]);
      $on_page=false;
      $kolvo_top_comments = $this->get_count_comments($num_modul,$num_element,true,$mas_ignore);
      $all_num_pages=ceil($kolvo_top_comments/KOL_COMMENTS_TO_PAGE);
      //if ( ($kolvo_top_comments == 0 && $num_page == 1) || (($num_page - 1) * KOL_COMMENTS_TO_PAGE < $kolvo_top_comments) ) $on_page = true;
      if ( ($kolvo_top_comments == 0 && $num_page == 1) || ( $num_page <= $all_num_pages) ) $on_page = true;
      //write_log_cms($all_num_pages. " / ".$num_page,"всего страниц / заданная страница");
      if (!$on_page) return ([true,["Неверно задан номер страницы!"]]);
      
      //Получаем комментарии первого уровня
      list($kolvo_comments,$data_comments) = $this->_get_db_data_comments($num_modul,$num_element,true,false,$mas_ignore,true,$num_page);
      
      $mas_id_comnts=array();
      $mas_num_users=[];
      
      $mas_id_comnts=select_mas1lev_2level($data_comments,"id_comment", false);
      
      $mas_num_users=select_mas1lev_2level($data_comments,"num_user", false);
      $mas_num_users=array_unique($mas_num_users);
      $mas_num_users2=[];
      
      $kolvo_nested=0;
      
      if ($kolvo_comments > 0)
        {
          //Получаем комментарии 2-го уровня (ответы к комментариям 1-го уровня)
          list($kolvo_nested, $data_nested_comments) = $this->_get_db_data_comments($num_modul, $num_element, false, $mas_id_comnts, $mas_ignore, false, 1);
        }
      
      if ($kolvo_nested > 0)
        {
          $mas_num_users2 = select_mas1lev_3level($data_nested_comments, "num_user");
          $mas_num_users2=array_unique($mas_num_users2);
          
          $mas_num_users=array_merge($mas_num_users,$mas_num_users2);
          $mas_num_users=array_unique($mas_num_users);
        }
      
      //удаляем 0 (нет id_user равным 0)
      $key=array_search("0",$mas_num_users);
      if ($key !== false) unset($mas_num_users[$key]);
      $mas_num_users=array_values($mas_num_users);
      //write_log_cms($mas_num_users,"mas num_user - 2");
      
      $data_users=[];
      if ( sizeof($mas_num_users) > 0 ) $data_users=$this->_get_data_users($mas_num_users);
      //write_log_cms($data_users,"load more -> data users");
      $this->data_comments=$data_comments;
      $this->data_nested_comments=$data_nested_comments;
      $this->data_users=$data_users;
      
      return ([$error,$error_mas]);
    }
  
  function _get_db_data_comments($num_modul,$num_element,$top_level,$mas_num_top,$mas_ignore,$on_page,$num_page)
    {
      //Функция получает с базы данных комментарии первого уровня
      // или комментарии второго уровня, в этом случае данные группируются по answ_num_comment
      $kolvo_comments=0;
      $data_comments=[];
      
      if ($top_level)
        {
          $query_limit = "";
          
          if ($on_page)
            {
              $query_limit = " limit ".(($num_page - 1) * KOL_COMMENTS_TO_PAGE).",".KOL_COMMENTS_TO_PAGE;
            }
          
          $db_query="select * "//", users.id_user, users.name_user, users.email_user, users.access_user, users.access_admin, users.get_message_guest "
            ." from ".DB_PREF."comments comment "
            //." left join ".DB_PREF."users users on  comment.num_user=users.id_user "
            ." where hide='show' "
            .($mas_ignore && sizeof($mas_ignore) > 0 ? " and id_comment NOT IN (". implode(",",$mas_ignore) .")" :"")
            ." and num_modul=$num_modul and num_element=$num_element " .($top_level ? " and answ_num_comment=0 ": "")
            ." order by id_comment "
            .$query_limit;
          
          list($kolvo_comments, $data_comments) = db_work::query_select_assoc($db_query);
        }
       elseif ($mas_num_top && sizeof($mas_num_top) > 0)
         {
           $db_query1="select * "//.", users.id_user, users.name_user, users.email_user, users.access_user, users.access_admin, users.get_message_guest "
             ." from ".DB_PREF."comments comment "
             //." left join ".DB_PREF."users users on  comment.num_user=users.id_user "
             ." where hide='show' "
             .($mas_ignore && sizeof($mas_ignore) > 0 ? " and id_comment NOT IN (". implode(",",$mas_ignore) .")" :"")
             ." and num_modul=$num_modul and num_element=$num_element "
             .(sizeof($mas_num_top)>0 ? " and answ_num_comment IN (".implode(",",$mas_num_top).") ":" and answ_num_comment > 0 ")
             ." order by id_comment ";
           list($kolvo_comments,$data_comments)=db_work::query_select_assoc_index_group($db_query1,"answ_num_comment");
         }
      
      return ([$kolvo_comments,$data_comments]);
    }
  
  function _get_data_users($mas_num_users)
    {
      global $obj_site;
      $data_users = $obj_site->select_data_user_to_list_id($mas_num_users,"id_user,name_user,access_admin");
      
      return ($data_users);
    }
  
  function get_count_comments_mas_elm($name_modul,$mas_num_elm)
    {
      $data_count=[];
      $num_modul=work_init_moduls::get_num_modul($name_modul);
      
      if (sizeof($mas_num_elm) > 0)
        {
          $mas_is=[];
          $mas_check_num=[];
          
          list($kolvo_is,$data_is)=$this->_get_count_db_comments_mas_elm($num_modul,$mas_num_elm);
          
          foreach ($data_is as $one_count)
            {
              $data_count[$one_count["num_element"]]=["num_modul"=>$num_modul,"num_element"=>$one_count["num_element"],"count_com"=>$one_count["count_com"]];
              $mas_is[]=$one_count["num_element"];
            }
          //write_log_cms($data_count,"data is count comments");
          
          //if (sizeof($mas_is) > 0)
          $mas_check_num=array_diff($mas_num_elm,$mas_is);
          
          if (sizeof($mas_check_num) > 0)
            {
              $data_calc = $this->_calc_count_comments_mas_elm($num_modul, $mas_check_num);
              //write_log_cms($data_count,"data is count comments");
              //write_log_cms($data_calc, "data calc comments");
              $this->_save_count_comments_mas_elm($data_calc);
              
              $data_count=$data_count + $data_calc;
            }
        }
      
      //write_log_cms($data_count,"data res count comments");
      
      return ($data_count);
    }
  
  function _get_count_db_comments_mas_elm($num_modul,$mas_num_elm)
    {
      $db_query="select * from ".DB_PREF."comments_count "
       ." where num_modul = ".$num_modul." and num_element IN (". implode(",",$mas_num_elm) .")";
      list($kolvo,$data)=db_work::query_select_assoc($db_query);
      
      return ([$kolvo,$data]);
    }
  
  function _calc_count_comments_mas_elm($num_modul,$mas_num_elm)
    {
      $data_count=[];
      
      $db_query = "(select num_modul, num_element, count(*) as count_elm, max(id_comment) as max_id from ".DB_PREF."comments "
       ." where hide='show' and num_modul=". $num_modul ." and num_element IN (". implode(",",$mas_num_elm) .") and answ_num_comment=0 "
       ." group by num_modul, num_element "
       .")"
       ." union "
       ." (select num_modul, num_element, count(*) as count_elem, max(id_comment) as max_id from ".DB_PREF."comments "
       ." where hide='show' and num_modul=". $num_modul ." and num_element IN ( ". implode(",",$mas_num_elm) .")"
       ." and answ_num_comment IN "
       ." (select id_comment from ".DB_PREF."comments where hide='show' and num_modul=". $num_modul ." and num_element IN (". implode(",",$mas_num_elm) .") and answ_num_comment=0 ) "
       ." group by num_modul, num_element "
       ." )";
      
      //write_log_cms($db_query,"count comments mas elm");
      list($kolvo,$data)=db_work::query_select_assoc_index_group($db_query,"num_element");
      //write_log_cms($data,"data select count comments");
      
      foreach ($mas_num_elm as $one_num)
        {
          $data_one_count=["num_modul"=>$num_modul,"num_element"=>$one_num,"count_com"=>0];
          if (!empty($data[$one_num]))
            {
              foreach ($data[$one_num] as $_part_count)
                {
                  $data_one_count["count_com"]+=$_part_count["count_elm"];
                }
            }
          $data_count[$one_num]=$data_one_count;
        }
      
      return ($data_count);
    }
  
  function _save_count_comments_mas_elm($data_count)
    {
      $db_query="";
      if (sizeof($data_count) > 0)
        {
          $db_query .= "insert ".DB_PREF."comments_count (id_count, num_modul, num_element, count_com, put_date) values ";
          $del="";
          foreach ($data_count as $one_count)
            {
              $db_query.=$del."("."0,".$one_count["num_modul"].",".$one_count["num_element"].",".$one_count["count_com"].","
               .$GLOBALS["timeGlobal"].")";
              $del=",";
            }
          
          db_work::query($db_query);
        }
    }
  
  
  function calc_count_comments_one_elm($ident_modul,$num_element)
    {
      // Подсчитываем количество комментариев для одного элемента и сохраняем (обновляем или добавляем новую запись)
      
      $num_modul=$this->_get_num_modul($ident_modul);
      
      $db_query="select * from ".DB_PREF."comments_count "
       ." where num_modul=".$num_modul." and num_element = ".$num_element;
      
      list($kolvo_count,$data_count)=db_work::query_select_one_assoc($db_query);
      
      $count_comnts=$this->get_count_comments($num_modul,$num_element,false);
      
      $this->_save_count_comments_one_elm($num_modul,$num_element,$count_comnts,$kolvo_count > 0 ? $data_count:false);
      
      return ($count_comnts);
    }
  
  function _save_count_comments_one_elm($num_modul,$num_element,$count_comnts,$data_count)
    {
      $save_data=[
        "id_count"=>($data_count ? $data_count["id_count"]:0),
        "num_modul"=>$num_modul,
        "num_element"=>$num_element,
        "count_com"=>$count_comnts,
        "put_date"=>$GLOBALS["timeGlobal"]
      ];
      $db_query=forming_db_query_indexmas(DB_PREF."comments_count",$save_data,$data_count ? "edit":"new","id_count");
      //write_log_cms($db_query,"query comments_count");
      db_work::query($db_query);
    }
  
  function get_count_comments_one_elm($ident_modul,$num_element)
    {
      // Получаем количество комментариев элемента
      // Данные получаем из кэша, если его нет, то добавляем данные в кэш
      // Отличается от метода $this->get_count_comments(), что данные берутся из кэша (и создает), не вычисляет само количество комментариев
      
      $count_comnts=0;
      $num_modul=$this->_get_num_modul($ident_modul);
      
      $db_query="select * from ".DB_PREF."comments_count "
       ." where num_modul=".$num_modul." and num_element = ".$num_element;
      
      list($kolvo_count,$data_count)=db_work::query_select_one_assoc($db_query);
      if ($kolvo_count > 0)
        {
          $count_comnts=$data_count["count_com"];
        }
      else
        {
          //В кэше нет данных о количестве комментариев, подсчитаем комментарии и сохраним в кэш
          $count_comnts=$this->get_count_comments($num_modul,$num_element,false);
          
          $this->_save_count_comments_one_elm($num_modul,$num_element,$count_comnts,false);
        }
      
      return ($count_comnts);
    }
  
  function delete_comments_one_elm($ident_modul,$num_element)
    {
      
      $this->delete_comments_mas_elm($ident_modul,[$num_element]);
    }
  
  function delete_comments_mas_elm($ident_modul,$mas_num_elm)
    {
      $num_modul=$this->_get_num_modul($ident_modul);
      
      $db_query = "delete from ".DB_PREF."comments where num_modul=". $num_modul. " and num_element IN (". implode(",",$mas_num_elm) .") ";
      db_work::query($db_query);
      
      $db_query = "delete from ".DB_PREF."comments_count where num_modul=". $num_modul. " and num_element IN (". implode(",",$mas_num_elm) .") ";
      db_work::query($db_query);
      
    }
  
  function _get_num_modul($ident_modul)
    {
      $num_modul=0;
      if (is_numeric($ident_modul))
        $num_modul=$ident_modul;
       else
         {
           $num_modul=work_init_moduls::get_num_modul($ident_modul);
         }
      
      return ($num_modul);
    }
  
}