<?php

class eng_likes_content
{
  
  protected $num_user = 0;
  protected $on_user = false;
  protected $name_user_authorize=false;
  protected $data_auth_user=false;
  
  protected $oper="";
  
  function __construct()
    {
      
    }
  
  function work_external()
    {
      $data=false;
      
      $error=0;
      $error_text="";
      
      $this->check_auth_user();
      
      $this->oper=((!empty($_POST["oper"]) && is_string($_POST["oper"])) ? $_POST["oper"] : "");
      $data_res=false;
      
      if ($this->oper == "change_status_like")
        {
          list($error,$error_text,$data_res)=$this->change_status_like();
        }
      elseif ($this->oper == "get_statist_likes")
        {
          list($error,$error_text,$data_res)=$this->_get_statist_likes_content();
        }
      /*
      elseif ($this->oper == "change_subscribe_author")
        {
          list($error,$error_text,$data_res)=$this->change_subscribe_author();
        }
      */
      
      $data=["error_proc"=>$error,"error_text_proc"=>$error_text,"data_res"=>($data_res ? $data_res:"")];
      
      return ($data);
    }
  
  function check_auth_user()
    {
      if ($GLOBALS["user_to_site"] && $GLOBALS["id_user_to_site"] > 0)
        {
          $this->num_user = $GLOBALS["id_user_to_site"];
          $this->name_user_authorize = $GLOBALS["name_user_to_site"];
          $this->data_auth_user = $GLOBALS["data_authorize_user"];
          $this->on_user = true;
        }
    }
  
  function change_status_like()
    {
      list($error,$error_text,$data)=$this->_proc_change_status_like();
      
      return ([$error,$error_text,$data]);
    }
  
  function _proc_change_status_like()
    {
      global $obj_control_data,$mas_init_likes_content,$obj_site;
      
      $error=0;
      $error_text="";
      $data=false;
      
      if (!$this->on_user) return ([1,"Нужно авторизоваться!",false]);
      
      $mas_init=array(
        array("num_modul","post","num_modul","numeric:int:positive",true,true,false,"",false,"tr","all",0,"Не указан параметр инициализации модуля!",false,false),
        array("num_elm","post","num_elm","numeric:int:positive",true,true,false,"",false,"tr","all",0,"Не указан параметр инициализации элемента!",false,false),
        array("status","post","status","text",true,true,"listv","plus,minus,off",false,false,"all","off"),
        array("contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
       );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_init);
      
      if ( !($rez_control_data[0] && !$rez_control_data[1]) ) return ([1,"Ошибка с данными",false]);
      
      $mas_inbox = $rez_control_data[3];
      
      if ( !eng_promote_safety::check_code($GLOBALS["id_user_to_site"],$mas_inbox["contr_code"]) ) return ([1,"Неверный ключ безопасности!",false]);
      
      //if ($mas_inbox["num_author"] == $this->num_user) return ([1,"Невозможно подписаться на самого себя!",false]);
      $num_modul=$mas_inbox["num_modul"];
      $num_element=$mas_inbox["num_elm"];
      $status=$mas_inbox["status"];
      
      
      $name_modul=work_init_moduls::get_name_modul($num_modul);
      //write_log_cms($name_modul,"Имя модуля");
      if (!$name_modul || empty($mas_init_likes_content[$name_modul]) ) return ([1,"Не верно указан параметр инициализации модуля!",false]);
      
      $d_check=$obj_site->intercomLink($name_modul,"check_data_many_type",["type"=>"check_elem_likes_content","num_element"=>$num_element]);
      //write_log_cms($d_check,"d_check likes");
      if (!$d_check) return ([1,"Не верно указан параметр инициализации элемента!",false]);
      
      
      $d_vote=$this->_get_vote_one_elm($num_modul,$num_element,$this->num_user);
      
      $this->_set_status_vote_one_elm($num_modul,$num_element,$this->num_user,$status,$d_vote);
      
      $data=$this->get_count_likes_one_elm($num_modul,$num_element,true);
      
      return ([$error,$error_text,$data]);
    }
  
  function _set_status_vote_one_elm($num_modul,$num_elm,$num_user,$status,$data_vote)
    {
      
      global $infoUserAgent;
      $mas_status=["off"=>0,"plus"=>2,"minus"=>1];
      
      $mas_data=[
      "id_vote"=>$data_vote ? $data_vote["id_vote"]:0,
      "num_modul"=>$num_modul,
      "num_element"=>$num_elm,
      "num_user"=>$num_user,
      "status"=>($mas_status[$status] ?? 0),
      "put_date"=>$GLOBALS["timeGlobal"],
      "ip_adr"=>$infoUserAgent[1],
      ];
      
      $db_query=forming_db_query_indexmas(DB_PREF."likes_votes",$mas_data,$data_vote ? "edit":"new","id_vote");
      
      db_work::query($db_query);
      
      return (true);
    }
  
  function _get_vote_one_elm($num_modul,$num_elm,$num_user)
    {
      $db_query="select * from ".DB_PREF."likes_votes where num_modul = ".$num_modul." and num_element = ".$num_elm." and num_user = ".$num_user;
      list($kolvo,$data_vote)=db_work::query_select_one_assoc($db_query);
      
      return ($kolvo>0?$data_vote:false);
    }
  
  function _get_count_all_votes_elm($num_modul,$num_elm,$status=false)
    {
      $db_query="select count(*) from ".DB_PREF."likes_votes "
       ." where num_modul = ".$num_modul." and num_element = ".$num_elm." ".($status ? " and status != 0 ":"");
      
      $kolvo=db_work::query_count($db_query);
      
      return ($kolvo);
    }
  
  function _get_all_votes_elm($num_modul,$num_elm,$num_page=0,$kolvo_page=10,$status=false,$poles=false)
    {
      
      $db_query="select ".($poles?$poles:" * ")." from ".DB_PREF."likes_votes "
       ." where num_modul = ".$num_modul." and num_element = ".$num_elm.($status ? " and status != 0 ":"")
       ." order by put_date DESC "
       .($num_page > 0 ? " limit ".(($num_page - 1) * $kolvo_page).", ".$kolvo_page:"");
      
      list($kolvo,$data_votes)=db_work::query_select_assoc($db_query);
      
      return ([$kolvo,$data_votes]);
    }
  
  function _get_db_count_likes_one_elm($num_modul,$num_elm)
    {
      $db_query="select * from ".DB_PREF."likes_count where num_modul = ".$num_modul." and num_element = ".$num_elm."  ";
      list($kolvo,$data_count)=db_work::query_select_one_assoc($db_query);
      
      return ($kolvo>0?$data_count:false);
    }
  
  function _calc_count_likes_one_elm($num_modul,$num_elm)
    {
      $data_likes=["num_modul"=>$num_modul,"num_element"=>$num_elm,"count_likes"=>0,"count_dislikes"=>0];
      
      $db_query="select votes.num_modul, votes.num_element, votes.status, count(votes.status) as count_status from ".DB_PREF."likes_votes votes "
       ." where num_modul = ".$num_modul." and num_element = ".$num_elm." and ( status = 1 or status = 2 ) "
       ." group by status ";
      
      list($kolvo,$data_count)=db_work::query_select_assoc($db_query);
      //write_log_cms($data_count,"data group");
      if ($kolvo > 0)
        {
          foreach($data_count as $one_count)
            {
              if ($one_count["status"]==2)
                $data_likes["count_likes"]=$one_count["count_status"];
              elseif ($one_count["status"]==1)
                $data_likes["count_dislikes"]=$one_count["count_status"];
              
            }
        }
      //write_log_cms($data_likes,"data likes one elm");
      return ($data_likes);
    }
  
  function _save_count_likes_one_elm($num_modul,$num_elm,$data_count,$count_likes,$count_dislikes)
    {
      $mas_data=[
      "id_count"=>$data_count ? $data_count["id_count"] : 0,
      "num_modul"=>$num_modul,
      "num_element"=>$num_elm,
      "count_likes"=>$count_likes,
      "count_dislikes"=>$count_dislikes,
      "put_date"=>$GLOBALS["timeGlobal"]
      
      ];
      
      $db_query=forming_db_query_indexmas(DB_PREF."likes_count",$mas_data,$data_count ? "edit":"new","id_count");
      
      db_work::query($db_query);
    }
  
  function _save_count_likes_mas_elm($data_count)
    {
      $db_query="";
      if (sizeof($data_count) > 0)
        {
          $db_query .= "insert ".DB_PREF."likes_count (id_count, num_modul, num_element, count_likes, count_dislikes, put_date) values ";
          $del="";
          foreach ($data_count as $one_count)
            {
              $db_query.=$del."("."0,".$one_count["num_modul"].",".$one_count["num_element"].",".$one_count["count_likes"].","
               .$one_count["count_dislikes"].",".$GLOBALS["timeGlobal"].")";
              $del=",";
            }
          
          db_work::query($db_query);
        }
      
    }
  
  function get_count_likes_one_elm($num_modul,$num_elm,$on_refresh=false)
    {
      $data_likes=["num_modul"=>$num_modul,"num_element"=>$num_elm,"count_likes"=>0,"count_dislikes"=>0];
      
      $data_count_cur=$this->_get_db_count_likes_one_elm($num_modul,$num_elm);
      
      $on_calc=false;
      
      if ($data_count_cur)
        {
          if ($on_refresh)
            $on_calc=true;
          else
            {
              $data_likes["count_likes"]=$data_count_cur["count_likes"];
              $data_likes["count_dislikes"]=$data_count_cur["count_dislikes"];
            }
        }
      else
        {
          $on_calc=true;
        }
      
      if ($on_calc)
        {
          $data_count_calc=$this->_calc_count_likes_one_elm($num_modul,$num_elm);
          $data_likes["count_likes"]=$data_count_calc["count_likes"];
          $data_likes["count_dislikes"]=$data_count_calc["count_dislikes"];
          
          $this->_save_count_likes_one_elm($num_modul,$num_elm,$data_count_cur,$data_likes["count_likes"],$data_likes["count_dislikes"]);
        }
      
      return ($data_likes);
    }
  
  function get_status_like_user_one_elm($num_modul,$num_elm,$num_user)
    {
      $status_like_user="";
      if ($num_user > 0)
        {
          $one_vote = $this->_get_vote_one_elm($num_modul, $num_elm, $num_user);
          if ($one_vote)
            {
              if ($one_vote["status"]==2)
                $status_like_user="like";
              elseif ($one_vote["status"]==1)
                $status_like_user="dislike";
            }
        }
      
      return ($status_like_user);
    }
  
  function get_full_data_like_one_elm($name_modul,$num_elm,$num_user)
    {
      $num_modul=work_init_moduls::get_num_modul($name_modul);
      
      $status_like=$this->get_status_like_user_one_elm($num_modul,$num_elm,$num_user);
      $data_count_likes=$this->get_count_likes_one_elm($num_modul,$num_elm,false);
      
      return (["status_like_user"=>$status_like, "data_count_likes"=>$data_count_likes]);
    }
  
  function get_status_likes_user_mas_elm($num_modul,$mas_num_elm,$num_user)
    {
      $mas_status=[];
      
      $db_query="select * from ".DB_PREF."likes_votes where num_modul = ".$num_modul." and num_element IN (".implode(",",$mas_num_elm).") and num_user = ".$num_user;
      list($kolvo,$data_votes)=db_work::query_select_assoc_index($db_query,"num_element");
      
      foreach ($mas_num_elm as $one_num)
        {
          $status_like_user="";
          if (!empty($data_votes[$one_num]))
            {
              $one_vote=$data_votes[$one_num];
              if ($one_vote["status"]==2)
                $status_like_user="like";
              elseif ($one_vote["status"]==1)
                $status_like_user="dislike";
              
            }
          $mas_status[$one_num]=$status_like_user;
        }
      
      return ($mas_status);
    }
  
  function get_full_data_likes_mas_elm($name_modul,$mas_num_elm,$num_user)
    {
      $num_modul=work_init_moduls::get_num_modul($name_modul);
      
      $status_likes_user=[];
      $count_likes=[];
      
      if (sizeof($mas_num_elm) > 0)
        {
          $count_likes=$this->_get_count_likes_mas_elm($num_modul,$mas_num_elm);
          if ($num_user > 0)
            $status_likes_user=$this->get_status_likes_user_mas_elm($num_modul,$mas_num_elm,$num_user);
          
        }
      
      return (["status_likes_user"=>$status_likes_user,"count_likes"=>$count_likes]);
    }
  
  function _get_count_likes_mas_elm($num_modul,$mas_num_elm)
    {
      $data_all=[];
      $mas_check_num=[];
      
      $db_query="select * from ".DB_PREF."likes_count where num_modul = ".$num_modul." and num_element IN (".implode(",",$mas_num_elm).")  ";
      list($kolvo,$data_count)=db_work::query_select_assoc($db_query);
      $mas_is=[];
      if ($kolvo > 0)
        {
          foreach ($data_count as $key => $one_count)
            {
              $data_all[$one_count["num_element"]]=["num_modul"=>$one_count["num_modul"],"num_element"=>$one_count["num_element"],"count_likes"=>$one_count["count_likes"],"count_dislikes"=>$one_count["count_dislikes"]];
              $mas_is[]=$one_count["num_element"];
            }
        }
      
      //if (sizeof($mas_is) > 0)
      $mas_check_num=array_diff($mas_num_elm,$mas_is);
      /*
      write_log_cms($mas_num_elm,"mas num elm");
      write_log_cms($mas_is,"mas is db elm");
      write_log_cms($mas_check_num,"mas check elm");
      */
      if (sizeof($mas_check_num) > 0)
        {
          $data_new = $this->_calc_count_likes_mas_elm($num_modul, /*$mas_num_elm*/$mas_check_num);
          $this->_save_count_likes_mas_elm($data_new);
          $data_all=$data_all + $data_new;
        }
      
      return ($data_all);
    }
  
  function _calc_count_likes_mas_elm($num_modul,$mas_num_elm)
    {
      
      $data=[];
      
      $db_query="select votes.num_modul, votes.num_element, votes.status, count(votes.status) as count_status from ".DB_PREF."likes_votes votes "
       ." where num_modul = ".$num_modul." and num_element IN ( ". implode(",", $mas_num_elm) ." ) and ( status = 1 or status = 2 ) "
       ." group by num_element, status ";
      
      list($kolvo,$data_count)=db_work::query_select_assoc_index_group($db_query,"num_element");
      
      
      foreach ($mas_num_elm as $one_num)
        {
          $data_likes=["num_modul"=>$num_modul,"num_element"=>$one_num,"count_likes"=>0,"count_dislikes"=>0];
          if (!empty($data_count[$one_num]))
            {
              foreach ($data_count[$one_num] as $one_count)
                {
                  if ($one_count["status"]==2)
                    $data_likes["count_likes"]=$one_count["count_status"];
                  elseif ($one_count["status"]==1)
                    $data_likes["count_dislikes"]=$one_count["count_status"];
                }
            }
          $data[$one_num]=$data_likes;
        }
      
      //write_log_cms($data,"data likes mas elm");
      return ($data);
    }
  
  
  function delete_likes_one_elm($name_modul,$num_element)
    {
      $num_modul=$this->_get_num_modul($name_modul);
      $this->_delete_data_likes_mas_elm($num_modul,[$num_element]);
    }
  
  function delete_likes_mas_elm($name_modul,$mas_num_elm)
    {
      $num_modul=$this->_get_num_modul($name_modul);
      $this->_delete_data_likes_mas_elm($num_modul,$mas_num_elm);
    }
  
  function _delete_data_likes_mas_elm($num_modul,$mas_num_elm)
    {
      $db_query = "delete from ".DB_PREF."likes_votes where num_modul=". $num_modul. " and num_element IN (". implode(",",$mas_num_elm) .") ";
      db_work::query($db_query);
      
      $db_query = "delete from ".DB_PREF."likes_count where num_modul=". $num_modul. " and num_element IN (". implode(",",$mas_num_elm) .") ";
      db_work::query($db_query);
    }
  
  
  function _get_num_modul($ident_modul)
    {
      $num_modul=0;
      if (is_numeric($ident_modul))
        $num_modul=$ident_modul;
       else
         {
           $num_modul=work_init_moduls::get_num_modul($ident_modul);
         }
      
      return ($num_modul);
    }
  
  protected function _get_statist_likes_content()
    {
      list($error,$error_text,$data)=$this->_proc_statist_likes_content();
      
      return ([$error,$error_text,$data]);
    }
  
  protected function _proc_statist_likes_content()
    {
      global $obj_control_data,$mas_init_likes_content,$obj_site;
      
      $error=0;
      $error_text="";
      $data=false;
      
      //if (!$this->on_user) return ([1,"Нужно авторизоваться!",false]);
      
      $mas_init=array(
        array("num_modul","post","num_modul","numeric:int:positive",true,true,false,"",false,"tr","all",0,"Не указан параметр инициализации модуля!",false,false),
        array("num_elm","post","num_elm","numeric:int:positive",true,true,false,"",false,"tr","all",0,"Не указан параметр инициализации элемента!",false,false),
        array("num_page","post","num_page","numeric:int:positive",true,true,false,"",false,"tr","all",0,"Не указан параметр инициализации элемента!",false,false),
        //array("status","post","status","text",true,true,"listv","plus,minus,off",false,false,"all","off"),
        //array("contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
       );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_init);
      
      if ( !($rez_control_data[0] && !$rez_control_data[1]) ) return ([1,"Ошибка с данными",false]);
      
      $mas_inbox = $rez_control_data[3];
      
      //if ( !eng_promote_safety::check_code($GLOBALS["id_user_to_site"],$mas_inbox["contr_code"]) ) return ([1,"Неверный ключ безопасности!",false]);
      
      //if ($mas_inbox["num_author"] == $this->num_user) return ([1,"Невозможно подписаться на самого себя!",false]);
      $num_modul=$mas_inbox["num_modul"];
      $num_element=$mas_inbox["num_elm"];
      $num_page=$mas_inbox["num_page"];
      //$status=$mas_inbox["status"];
      $numbers_page=30;
      
      $name_modul=work_init_moduls::get_name_modul($num_modul);
      //write_log_cms($name_modul,"Имя модуля");
      if (!$name_modul || empty($mas_init_likes_content[$name_modul]) ) return ([1,"Не верно указан параметр инициализации модуля!",false]);
      
      $d_check=$obj_site->intercomLink($name_modul,"check_data_many_type",["type"=>"check_elem_likes_content","num_element"=>$num_element]);
      //write_log_cms($d_check,"d_check likes");
      if (!$d_check) return ([1,"Не верно указан параметр инициализации элемента!",false]);
      
      $kolvo_votes=$this->_get_count_all_votes_elm($num_modul,$num_element,true);// получаем общее количество записей
      
      $d_votes=[];
      $data_users=[];
      $all_pages=0;
      
      if ($kolvo_votes > 0)
        {
          $all_pages=ceil($kolvo_votes/$numbers_page);
          if ($num_page <= $all_pages)
            {
              $gen_data = $this->_get_all_votes_elm($num_modul, $num_element, $num_page, $numbers_page, true, "id_vote,num_user,put_date,status");// получаем [количество, данные]
              
              if ($gen_data[0] > 0)
                {
                  $d_votes = $gen_data[1];
                  $mas_num_user = select_mas1lev_2level($gen_data[1], "num_user", false);
                  $data_users = $obj_site->select_data_user_to_list_id($mas_num_user, "id_user,name_user,image_user");
                }
            }
        }
      
      $data=["all_votes"=>$kolvo_votes,"all_pages"=>$all_pages,"d_votes"=>$d_votes,"data_users"=>$data_users];
      
      return ([$error,$error_text,$data]);
    }
  
}

