<?php


// функции для работы с файлами и папками




// удаление папки со всеми вложенными папками и файлами
function remove_dir($path)
  {
   
   $error = false;
   
   if ( file_exists($path) && is_dir($path) )
     {
      $dirHandle = opendir($path);
      while (false !== ($file = readdir($dirHandle)))
        {
         if ($file!='.' && $file!='..')// исключаем папки с назварием '.' и '..'
           {
            $tmpPath=$path.'/'.$file;
            chmod($tmpPath, 0777);
            
            if (is_dir($tmpPath))
              {
               // если папка
               remove_dir($tmpPath);
              } 
             else 
               {
                if(file_exists($tmpPath))
                  {
                   // удаляем файл
                   unlink($tmpPath);
                  }
               }
           }
        }
      
      closedir($dirHandle);
      
      // удаляем текущую папку
      if(file_exists($path))
        {
         rmdir($path);
        }
      
     }
    else
      {
       //echo "Удаляемой папки не существует или это файл!";
       $error = true;
      }
   
   return ( $error );
  }



// удаление файлов по условию
function delete_files_model($path,$pref,$time_delta)
  {
   
   $error = false;
   
   if ( file_exists($path) && is_dir($path) )
     {
      $dirHandle = opendir($path);
      while (false !== ($file = readdir($dirHandle)))
        {
         if ($file!='.' && $file!='..' && (!$pref || $pref && strpos($file,$pref)===0))// исключаем папки с назварием '.' и '..'
           {
            $onePath=$path.'/'.$file;
            chmod($onePath, 0777);
            $stat_file=true;
            if(file_exists($onePath) && is_file($onePath) && ($stat_file=stat($onePath)))
              {
               
               if (!$time_delta || $time_delta && ($GLOBALS["timeGlobal"]-$stat_file["mtime"])>$time_delta)
                 {
                  // удаляем файл
                  unlink($onePath);
                  
                 }
              }
            
           }
        }
      
      closedir($dirHandle);
      
     }
    else
      {
       $error = true;
      }
   
   return ( !$error );
  }







