<?php


function formation_html_select_from_mas($mas,$on_choose_value=false,$choose_value="",$on_add_begin=false,$value_add_begin=-1,$name_add_begin="Выберите...",$return_only_html = false)
  {
   
   $html="";
   $selected=false;
   
   foreach ($mas as $key => $value)
     {
      $element_choose="";
      if ($on_choose_value && $choose_value == $key)
        {
         $element_choose="selected='selected'";
         $selected=true;
        }
      $html.="<option $element_choose value='$key'>$value</option>";
     }
   if ($on_add_begin)
     {
      $html="<option value='$value_add_begin'>$name_add_begin</option>".$html;
     }
   if ( !$return_only_html )
     $rez=array("html"=>$html,"selected"=>$selected);
    else
      $rez = $html;
   return ($rez);
  }


function formation_html_select_from_mas_rows($mas,$key_value,$key_name,$on_choose_value=false,$choose_value="",$on_add_begin=false,$value_add_begin=-1,$name_add_begin="Выберите...",$return_only_html = false)
  {
   // если $key_value равняется false, то для значения option будет браться ключ соответствующей строки массива
   $html="";
   $selected=false;
   
   foreach ($mas as $key_row => $one_row)
     {
      $key= ( ( $key_value === false ) ? $key_row : $one_row[$key_value] );
      $value=$one_row[$key_name];
      $element_choose="";
      if ($on_choose_value && $choose_value == $key)
        {
         $element_choose="selected='selected'";
         $selected=true;
        }
      $html.="<option $element_choose value='$key'>$value</option>";
     }
   if ($on_add_begin)
     {
      $html="<option value='$value_add_begin'>$name_add_begin</option>".$html;
     }
   if ( !$return_only_html )
     $rez=array("html"=>$html,"selected"=>$selected);
    else
      $rez = $html;
   return ($rez);
  }

/* functions time */


function forming_date_from_timestamp($timestamp)
  {
   global $mas_months;
   $t="";
   $d=getdate($timestamp);
   $t=$d["mday"]." ".$mas_months[$d["mon"]]." ".$d["year"];
   
   return ($t);
  }


function forming_time_from_timestamp($timestamp)
  {
   global $mas_months;
   $t="";
   $d=getdate($timestamp);
   $t=$d["mday"]." ".$mas_months[$d["mon"]]." ".$d["year"]." / "
    .( $d["hours"] < 10 ? "0".$d["hours"] : $d["hours"] )
    .":"
    .( $d["minutes"] < 10 ? "0".$d["minutes"] : $d["minutes"] );
   
   return ($t);
  }




function forming_select_f_date($timestamp,$d,$m,$y,$name_pf_day,$name_pf_month,$name_pf_year,$text_begin,$text_raz,$text_end)
  {
   //если не задан $timestamp, то тогда дата будет определяться $d, $m , $y - день, месяц и год
   $mas_day=array();
   $mas_month=array();
   $mas_year=array();
   for ($i=1;$i<=31;$i++) $mas_day[$i]=$i;
   for ($i=1;$i<=12;$i++) $mas_month[$i]=$i;
   for ($i=2010;$i<=2020;$i++) $mas_year[$i]=$i;
   
   $t="";
   
   if ( $timestamp !== false )
     {
      $mas_time=getdate($timestamp);
      $d=$mas_time["mday"];
      $m=$mas_time["mon"];
      $y=$mas_time["year"];
     }
   
   $mas_form_day=formation_html_select_from_mas($mas_day,true,$d,false,-1,"Выберите...");
   $mas_form_month=formation_html_select_from_mas($mas_month,true,$m,false,-1,"Выберите...");
   $mas_form_year=formation_html_select_from_mas($mas_year,true,$y,false,-1,"Выберите...");
   
   $t.=$text_begin;
   $t.="<select name='$name_pf_day'>".$mas_form_day["html"]."</select>";
   $t.=$text_raz;
   $t.="<select name='$name_pf_month'>".$mas_form_month["html"]."</select>";
   $t.=$text_raz;
   $t.="<select name='$name_pf_year'>".$mas_form_year["html"]."</select>";
   $t.=$text_end;
   
   return ($t);
  }



function forming_select_f_oclock($timestamp,$h,$m,$name_pf_hours,$name_pf_minutes,$text_begin,$text_raz,$text_end)
  {
   //если не задан $timestamp, то тогда дата будет определяться $d, $m , $y - день, месяц и год
   $mas_hours=array();
   $mas_minutes=array();
   
   for ($i=0;$i<=23;$i++) $mas_hours[$i]=( $i < 10 ? "0".$i : $i );
   for ($i=0;$i<=59;$i++) $mas_minutes[$i]=( $i < 10 ? "0".$i : $i );
   //for ($i=2010;$i<=2020;$i++) $mas_year[$i]=$i;
   
   $t="";
   
   if ( $timestamp !== false )
     {
      $mas_time=getdate($timestamp);
      $h=$mas_time["hours"];
      $m=$mas_time["minutes"];
      
     }
   
   $mas_form_hours=formation_html_select_from_mas($mas_hours,true,$h,false,-1,"Выберите...");
   $mas_form_minutes=formation_html_select_from_mas($mas_minutes,true,$m,false,-1,"Выберите...");
   //$mas_form_year=formation_html_select_from_mas($mas_year,true,$y,false,-1,"Выберите...");
   
   $t.=$text_begin;
   $t.="<select name='$name_pf_hours'>".$mas_form_hours["html"]."</select>";
   $t.=$text_raz;
   $t.="<select name='$name_pf_minutes'>".$mas_form_minutes["html"]."</select>";
   
   $t.=$text_end;
   
   return ($t);
  }

/* printlistpages */


function printListNumbersPages($select_num_page,$vsego_pages,$hablon_on_link,$hablon_off_link,$kolvo_num_print=3,$razdel_link="",$on_title_text=true,$on_print_first_end_links=true,$openSim = "{::",$closeSim = "::}",$hablon_first_page = false)
  {
   $t="";
   //$hablon_on_link="{::numPage::}  ";
   //$hablon_off_link="<a href='http://cms/page{::numPage::}.html' {::title::}>{::textPage::}</a> ";
   
   
   if ($select_num_page > 1)
     {
      //ссылка на первую страницу
      if ($on_print_first_end_links)
        {
          $h=replacePeremenToHablon($hablon_first_page ? $hablon_first_page : $hablon_off_link,"numPage",1,$openSim,$closeSim);
          $h=replacePeremenToHablon($h,"textPage","&laquo;&laquo;",$openSim,$closeSim);
          $text_title=$on_title_text?" title='первая' ":"";
          $t.=replacePeremenToHablon($h,"title",$text_title,$openSim,$closeSim);
          
          $t=($t=="")?$t:$t.$razdel_link;
        }
      //ссылка на предыдущую страницу
      $h=replacePeremenToHablon(($select_num_page == 2) ? ( $hablon_first_page ? $hablon_first_page : $hablon_off_link ) : $hablon_off_link,"numPage",$select_num_page-1,$openSim,$closeSim);
      $h=replacePeremenToHablon($h,"textPage","&laquo;",$openSim,$closeSim);
      $text_title=$on_title_text?" title='предыдущая' ":"";
      $t.=replacePeremenToHablon($h,"title",$text_title,$openSim,$closeSim);
      $t=($t=="")?$t:$t.$razdel_link;
     }
   
   //$num_page_start,$num_page_end - номера страниц с которых будет начинаться и заканчиваться вывод страниц
   $num_page_start=$select_num_page-$kolvo_num_print;
   $num_page_end=$select_num_page+$kolvo_num_print;
   
   if ($num_page_start < 1)
     $num_page_start=1;
     
   if ($num_page_end > $vsego_pages)
     $num_page_end=$vsego_pages;
   
   if ($num_page_start > 1)
     {
      $t.="... ";
      $t=($t=="")?$t:$t.$razdel_link;
     }
   
   for ($p=$num_page_start;$p<=$num_page_end;$p++)
     {
      
      if ($p == $select_num_page)
        {
         //ссылка на выбранную страницу
         $h=replacePeremenToHablon($hablon_on_link,"numPage",$p,$openSim,$closeSim);
         $h=replacePeremenToHablon($h,"textPage",$p,$openSim,$closeSim);
         $text_title=$on_title_text?" title='$p' ":"";
         $t.=replacePeremenToHablon($h,"title",$text_title,$openSim,$closeSim);
         $t=($t=="")?$t:$t.$razdel_link;
        }
       else
         {
          //ссылка на другие страницы
          $h=replacePeremenToHablon( ($p == 1) ? ( $hablon_first_page ? $hablon_first_page : $hablon_off_link ):$hablon_off_link,"numPage",$p,$openSim,$closeSim);
          $h=replacePeremenToHablon($h,"textPage",$p,$openSim,$closeSim);
          $text_title=$on_title_text?" title='$p' ":"";
          $t.=replacePeremenToHablon($h,"title",$text_title,$openSim,$closeSim);
          $t=($t=="")?$t:$t.$razdel_link;
         }
      
     }
   
   if ($num_page_end < $vsego_pages)
     {
      $t.="... ";
      $t=($t=="")?$t:$t.$razdel_link;
     }
   
   if ($select_num_page < $vsego_pages)
     {
      //следующая страница
      $h=replacePeremenToHablon($hablon_off_link,"numPage",$select_num_page+1,$openSim,$closeSim);
      $h=replacePeremenToHablon($h,"textPage","&raquo;",$openSim,$closeSim);
      $text_title=$on_title_text?" title='следующая' ":"";
      $t.=replacePeremenToHablon($h,"title",$text_title,$openSim,$closeSim);
      $t=($t=="")?$t:$t.$razdel_link;
      
      //последняя страница
      if ($on_print_first_end_links)
        {
          $h=replacePeremenToHablon($hablon_off_link,"numPage",$vsego_pages,$openSim,$closeSim);
          $h=replacePeremenToHablon($h,"textPage","&raquo;&raquo;",$openSim,$closeSim);
          $text_title=$on_title_text?" title='последняя' ":"";
          $t.=replacePeremenToHablon($h,"title",$text_title,$openSim,$closeSim);
          $t=($t=="")?$t:$t.$razdel_link;
        }
     }
   
   return ($t);
  }


function replacePeremenToHablon($textHablon,$perem,$value,$startHabPerem,$endHabPerem)
  {
   $t=$textHablon;
   $textReplace=$startHabPerem.$perem.$endHabPerem;
   $t=str_replace($textReplace,$value,$t);
   //$textReplace=$startHabPerem.$perem_text.$endHabPerem;
   //$t=str_replace($textReplace,$value_text,$t);
   
   return ($t);
  }


class formationTextRss
  {
   
   public $title_rss = "";
   public $link_rss = "";
   public $description_rss = "";
   public $time_rss = 0;
   
   public $begin_text = "";
   public $end_text = "";
   
   public $max_quantity = 0;
   public $time_last = 0;
   
   public function __construct()
     {
      
     }
   
   public function setting($mas_set)
     {
      $this->title_rss = $mas_set["title"];
      $this->link_rss = $mas_set["link"];
      $this->description_rss = $mas_set["description"];
      
     }
   
   public function formation_rss($mas_rss)
     {
      $t = "";
      
      
      $time_last=0;
      $n=0;
      foreach ($mas_rss as $row)
        {
         $n++;
         $time=$row["pubDate"];//+11*60*60;
         if ( $time_last < $time )
           $time_last=$time;
         
         $date=date("D, d M Y H:i:s ",$time)." GMT +0300";
         $t.="
         <item>
         <title>".codeHtmlText($row["title"])."</title>
         <link>".codeHtmlText($row["link"])."</link>
         <description>".(codeHtmlText($row["description"]))."</description>
         <pubDate>".$date."</pubDate>
         </item>
         ";
         
         if ( $this->max_quantity > 0 && $n >= $this->max_quantity )
           break;
         
        }
      
      
      $this->time_last = $time_last;
      
      $this->formation_begin_text();
      $this->formation_end_text();
      
      return ($this->begin_text.$t.$this->end_text);
     }
   
   public function formation_begin_text()
     {
      
      $this->begin_text = "<?xml version='1.0' encoding='utf-8'?>
        <rss version='2.0'>
        <channel>
              <title>".codeHtmlText($this->title_rss)."</title>
              <link>".codeHtmlText($this->link_rss)."</link>
              <description>".codeHtmlText($this->description_rss)."</description>
              <language>ru</language>
              ";
      
      if ( $this->time_last )
        {
         $date=date("D, d M Y H:i:s ",$this->time_last)." GMT ";
         $this->begin_text .= "<lastBuildDate>".$date."</lastBuildDate>
              ";
         //<lastBuildDate>Mon, 29 Sep 2008 12:09:00 +0300</lastBuildDate>";
        }
      
     }
   
   public function formation_end_text()
     {
      $this->end_text="
        </channel>
        </rss>
      ";
     }
  }

