<?php


class smonitor
  {
   
   private static $on_use_monitor=false;
   private static $time_start=0;
   private static $time_end=0;
   private static $on_monitor=false;
   private static $number_p=0;
   private static $info=array();
   private static $name_file="log_monitor.txt";
   private static $short_monitor=false;
   
   
   function __construct()
     {
      
     }
   
   static public function point($type="",$name="",$desc="")
     {
      if (!self::$on_use_monitor) return;
      $time=microtime(true);
      
      if (!self::$on_monitor)
        {
         self::$on_monitor=true;
         self::$time_start=$time;
        }
       else
         {
          self::$number_p++;
         }
      
      self::$info[]=array($time,$type,$name,$desc,memory_get_usage());
      
      if ($type=="end")
        {
         self::save_file();
        }
     }
   
   static public function save_file()
     {
      $t="";
      $st="";
      $info=array();
      
      $filename=DIR_CONFIG_SAVE."/". self::$name_file;
      $t_date=date("d.m.Y/H:i:s",$GLOBALS["timeGlobal"]);
      
      $info["date"]=$t_date;
      $info["file"]=self::get_name_script();
      
      /*$t.="\n\n".$t_date.".\n";
      $t.="файл ".self::get_name_script() ."\n";*/
      $time_start=0;
      $time_end=0;
      $time_sc=0;
      $time_db=0;
      
      $kolvo=sizeof(self::$info);
      //write_log_cms(self::$info);
      $points=array();
      if ($kolvo > 1)
        {
         $time_start=self::$info[0][0];
         $time_end=self::$info[$kolvo-1][0];
         $time_prev=$time_start;
         $type_prev="";
         $prev=self::$info[0];
         $desc="";
         
         foreach (self::$info as $numk=>$one_info)
           {
            $type_del="php";
            $desc="";
            
            $time_p=$one_info[0]-$time_start;
            $time_del=$one_info[0]-$time_prev;
            
            if ($prev[1] == "db_start" && $one_info[1] == "db_end")
              {
               $type_del="db";
               $desc=$one_info[3];
               $time_db+=$time_del;
              }
             else
               {
                $time_sc+=$time_del;
                
               }
            /*$t.=$numk." : ".$type_del;
            $t.="| т. времени ".($time_p == 0 ? "0" : sprintf("%f",$time_p))." с.";
            $t.="| время ".($time_del == 0 ? "0" : sprintf("%f",$time_del))." c.";
            //$t.="|".($desc ? "\n".$desc:"");
            */
            $time_prev=$one_info[0];
            $type_prev=$one_info[1];
            $prev=$one_info;
            //$t.="\n";
            
            $points[]=array("n"=>$numk,"ty"=>$type_del,"tp"=>$time_p,"td"=>$time_del,"nm"=>$one_info[2],"d"=>$one_info[3],"m"=>$one_info[4]);
            
           }
         
         if (!self::$short_monitor)
           $info["points"]=$points;
         
         $info["tw"]=self::$info[$kolvo-1][0]-self::$info[0][0];
         $info["t1"]=$time_sc;
         $info["t2"]=$time_db;
         $info["maxm"]=memory_get_peak_usage(true);
         $d=self::get_data_ser();
         $info["ip"]=$d[0];
         $info["req"]=$d[1];
         /*
         $t.="----------------------------------\n";
         $t.="Общее время выполенения ". sprintf("%f",self::$info[$kolvo-1][0]-self::$info[0][0])." c.\n";
         $t.="Время php - ".$time_sc." c; время БД - ".$time_db." c";
         $t.="\n";
         $t.="**********************************";
         $t.="\n\n";
         */
         $st="\n".base64_encode(serialize($info));
        }
       else
         {
          $st="\n"."no_data";
         }
      
      file_put_contents($filename,$st,FILE_APPEND);
      
     }
   
   static function get_name_script()
     {
      $name="";
      if (isset($_SERVER) && isset($_SERVER["SCRIPT_NAME"])) $name=$_SERVER["SCRIPT_NAME"];
      
      return ($name);
     }
   
   static function get_data_ser()
     {
      $ip_adr="";
      $url = "";
      if ( !empty($_SERVER['REMOTE_ADDR']) )
        {
         $ip_adr = $_SERVER['REMOTE_ADDR'];
        }
      
      if ( isset($_SERVER["REQUEST_URI"]) )
        $url = $_SERVER["REQUEST_URI"];
      
      return (array($ip_adr,$url));
     }
   
   static function auto_init()
     {
      if (!self::$on_use_monitor || self::$on_monitor) return (false);
      
      smonitor::point("start");
      register_shutdown_function(function(){smonitor::point("end");});
     }
   
  }

//smonitor::auto_init();
//smonitor::point("db_start","запрос к БД",$db_query);
//smonitor::point("db_end","выполнен запрос к БД",$db_query);
//v_user_part.php main_init_cms.php
//include_once(DIR_CMS."/generalscript/smonitor.php");
