<?php

class article_class_driver extends base_article_class
  {
   
   var $sitemap_kolvo_group = 1000;
   
   
   
   public function sitemap_count_item()
     {
      
      $t_db_query_category = $this->obj_cache_category->get_text_db_query_data_many_lvl( "item.n_category", 0 );
      
      $db_query="select count(*) 
          from ".DB_PREF."article_item item 
          where  "
          .( $t_db_query_category ? " ( ".$t_db_query_category." ) and " : "" )
          ." item.hide='show' and item.robots_index='yes' ";//." and item.end_putdate >=".$GLOBALS["timeDayAdvert"]
          //." order by item.sort_time DESC ";
      
      $kolvo_all_item = db_work::query_count($db_query);
      $kolvo_group = ceil($kolvo_all_item/$this->sitemap_kolvo_group);
      
      return ( array($kolvo_all_item,$kolvo_group) );
     }
   
   public function sitemap_get_item($num_group)
     {
      
      $t_db_query_category = $this->obj_cache_category->get_text_db_query_data_many_lvl( "item.n_category", 0 );
      
      $db_query="select item.id_item as id_item, item.name_item as name_item,
          item.country_item, item.region_item, item.city_item, item.name_url 
          from ".DB_PREF."article_item item 
          where "
          .( $t_db_query_category ? " ( ".$t_db_query_category." ) and " : "" )
          ." item.hide='show' and item.robots_index='yes' "
          ." order by item.id_item DESC "
          ."limit ".($num_group*$this->sitemap_kolvo_group).", ".$this->sitemap_kolvo_group;
      list($kolvo_item,$data_item) = obr_db_query_select_assoc($db_query);
      
      return (array($kolvo_item,$data_item));
     }
   
   public function sitemap_get_info_group()
     {
      global $url_site;
      
      list($kolvo_all_item,$kolvo_group) = $this->sitemap_count_item();
      $mas_sitemap = array();
      $mas_sitemap[] = array( "loc" => $url_site."/sitemap_m_article_1.xml" );
      
      for ($i = 0; $i < $kolvo_group; $i++)
        $mas_sitemap[] = array( "loc" => $url_site."/sitemap_m_article_".($i+2).".xml" );
      
      return ($mas_sitemap);
     }
   
   public function sitemap_get_data_urls_group($num)
     {
      $error = 0;
      $error_text = "no";
      $urls = array();
      global $url_site,$obj_geoData,$masConfig;
      
      if ( $num == 1 )
        {
         $urls[]=array("loc"=>$url_site."/create_article/","changefreq"=>"weekly","priority"=>0.5);
         $urls[]=array("loc"=>$url_site."/allarticle/","changefreq"=>"daily","priority"=>0.8);
         //$urls[]=array("loc"=>$url_site."/search/","changefreq"=>"weekly","priority"=>0.5);
         //$urls[]=array("loc"=>$url_site."/edit/","changefreq"=>"weekly","priority"=>0.5);
         $mas_top_category = $this->obj_cache_category->get_mas_data(0,false,false);
         
         foreach ($mas_top_category as $one_top_category)
           {
            
            $url_top_category = $url_site."/allarticle/".$one_top_category["united_name_url"]."/";
            $urls[]=array("loc"=>$url_top_category,"changefreq"=>"daily","priority"=>0.8);
            $urls = array_merge($urls,$this->sitemap_forming_url_nested_category($urls,$one_top_category["id_category"],$url_top_category));
           }
         
        }
       else
         {
          list($kolvo_all_item,$kolvo_group) = $this->sitemap_count_item();
          if ( $num >= 2 && ($num - 1) <= $kolvo_group )
            {
             
             list($kolvo_item,$data_item) = $this->sitemap_get_item($num-2);
             
             if ( $kolvo_item > 0 && $masConfig["ON_USE_GEO_DATA"] == 1 )
               {
                //global $obj_geoData;
                $obj_geoData->add_data_mas_for_extract_geo($data_item,array("country_item","region_item","city_item"));
               }
             
             foreach ($data_item as $one_item)
               {
                $a=$url_site.forming_geo_part_name_url_article($one_item)."/". $this->forming_name_url_item($one_item)."-art".$one_item["id_item"].".html";
                $urls[]=array("loc"=>$a,"changefreq"=>"weekly","priority"=>0.7);
                
               }
             
            }
           else
             {
              $error = 2;
              $error_text = "неправильно задан номер группы";
             }
         }
      
      return (array($error,$error_text,$urls));
     }
   
   function sitemap_forming_url_nested_category($urls, $num_category, $url_base_category)
     {
      //global $urls,$obj_article_cache_category;
      $urls = array();
      $mas_nested_category = $this->obj_cache_category->get_mas_data($num_category, false, false);
      if ( $mas_nested_category && sizeof($mas_nested_category) > 0 )
        {
         foreach ( $mas_nested_category as $one_category )
           {
            $url_category = $url_base_category.$one_category["united_name_url"]."/";
            $urls[]=array("loc"=>$url_category,"changefreq"=>"daily","priority"=>0.8);
            $this->sitemap_forming_url_nested_category($urls, $one_category["id_category"],$url_category);
           }
        }
      
      return ($urls);
     }
   
   function get_data_page_modul_nsrl($on_struct=false)
     {
      
      global $list_modules;
      $ident_modul_article = ( !empty($list_modules["article"]) ? $list_modules["article"][5] : "0" );
      
      $mas_page=array();
      if (!$on_struct)
        $mas_page = $this->init_data_page_nested_category_nsrl($ident_modul_article,0);
      
      //var_dump($mas_page);
      
      $vdata = array( "name" => "Каталог статей", "identkey" => $ident_modul_article, "nested" => array( 
       "allitem" => array( "name" => "Все статьи", "identkey" => "3", "nested" => 0, "on_list_elm" => 1 ), 
       "additem" => array( "name" => "Страница добавления/редактирования статьи", "identkey" => "2", "nested" => 0, "on_list_elm" => 0 ),
       "general" => array( "name" => "Другие страницы каталога статей", "identkey" => "1", "nested" => 0, "on_list_elm" => 0 ),
       "category" => array( "name" => "Все категории каталога статей", "identkey" => "4", "nested" => sizeof( $mas_page ) ? $mas_page : 0, "on_list_elm" => 1 ),
       "item" => array( "name" => "Страницы статей", "identkey" => "5", "nested" => sizeof( $mas_page ) ? $mas_page : 0, "on_list_elm" => 0 ),
       
       ) );
      
      return ($vdata);
     }
   
   function init_data_page_nested_category_nsrl($ident_modul,$num_category = 0)
     {
      $mas_page = array();
      
      $mas_main_category_article = $this->obj_cache_category->get_mas_data($num_category,false,false);
      
      foreach ( $mas_main_category_article as $one_category )
        {
         $mas_nested = $this->init_data_page_nested_category_nsrl($ident_modul,$one_category["id_category"]);
         $mas_page[$one_category["id_category"]] = array("name" => $one_category["name"], "identkey" => $one_category["id_category"], "nested" => sizeof( $mas_nested ) > 0 ? $mas_nested : 0 );
         
        }
      
      return ( $mas_page );
     }
   
   function forming_email_feedback_author($mas_data)
     {
      global $url_http;
      
      $error=0;
      $error_text="";
      $is_set_send_data=false;
      $name_recipient="";
      $email_recipient="";
      $message="";
      
      $data_article=false;
      $db_query="select article_item.id_item,article_item.num_user,article_item.name_item,article_item.email "
        ." from ".DB_PREF."article_item article_item "
        ." where id_item = ".$mas_data["num_element"]." and hide='show' and is_get_email = 'yes' ";
      list($kolvo,$data_article) = db_work::query_select_one_assoc($db_query);
      
      if ($kolvo == 1 && $data_article && $data_article["email"])
        {
         global $obj_site;
         $mas_data_user=$obj_site->select_name_user_to_list_id(array($data_article["num_user"]));
         
         $name_recipient="пользователь";
         if ( !empty( $mas_data_user[$data_article["num_user"]] ) )
           $name_recipient = $mas_data_user[$data_article["num_user"]];
         
         $email_recipient=$data_article["email"];
         $is_set_send_data=true;
         
         $title_page=$data_article["name_item"];
         $url_page="/article_item".$data_article["id_item"].".html";
         
         $message="Здравствуйте, ".$name_recipient."!"
          ."<br />Вам написал сообщение посетитель сайта <a href='".$url_http."'>".NAME_SITE."</a> "
          ."с помощью контактной формы по поводу добавленной вами статьи "
          ."<a href='".$url_http.$url_page."'>".$title_page."</a>.<br />"
          ."Имя пользователя:  ".$mas_data["name_user"]."<br />Email: <a href='mailto:".$mas_data["email_user"]."'>".$mas_data["email_user"]."</a>"
          .".<br />Текст сообщения:<br /><br />".$mas_data["message_user"]
          ."<br /><br /><br />Если вы больше не хотите получать письма от пользователей нашего сайта, то вам надо отредактировать вашу статью, и отменить возможность пользователям отправлять вам сообщения с сайта.";
         
         
        }
       else
         {
          $error=1;
          $error_text="Ошибка с параметрами!";
         }
      
      return (array($error,$error_text,$is_set_send_data,$name_recipient,$email_recipient,$message));
     }
   
   function get_data_page_comment($mas_data)
     {
      $on_data=false;
      $title_page="";
      $url_page="";
      
      $db_query="select article_item.id_item,article_item.num_user,article_item.name_item,article_item.email "
        ." from ".DB_PREF."article_item article_item "
        ." where id_item = ".$mas_data["add_num_element"]." and hide='show' ";
      list($kolvo,$data_article) = db_work::query_select_one_assoc($db_query);
      
      if ( $kolvo )
        {
         $on_data=true;
         $title_page=$data_article["name_item"];
         $url_page="/article_item".$data_article["id_item"].".html";
        }
      
      return (array($on_data,$title_page,$url_page));
     }
   
  }

$obj_article=new article_class_driver();
/*
Значение "$obj_имя_объекта" - должно быть прописано в конфигурационном
 файле CMS в соответствии с указанными комментариями 
*/

