<?php

//файл php



function set_united_name_url_mas_category_item_article($mas_category)
  {
   // функция вернет массив с новым полем united_name_url, 
   // если будет значение в поле name_url, то это значение будет присвоено полю united_name_url,
   // иначе полю united_name_url будет присвоено транслированное значение поля name
   
   foreach ($mas_category as $key => $one_category)
     {
      $value = "";
      if ( trim( $one_category["name_url"] ) )
        $value = $one_category["name_url"];
       else
         $value = encode_text_to_url_name($one_category["name"]);
      
      $mas_category[$key]["united_name_url"] = $value;
     }
   
   return ($mas_category);
  }



class article_cache_category extends model_cache_many_lvl_data
  {
   public function init_obj()
     {
      $this->name_model = "article";
      //$this->dir_cache = DIR_CACHE_DATA . "/";
      
     }
   
   public function select_data_first_level()
     {
      //данный метод должен переопределяться для конкретного объекта
      
      //формируем запрос к базе данных для получения категорий 1-го уровня.
      $mas_data_1lvl = array();
      
      //$db_query="select * from ".DB_PREF."article_category where hide='show' and type='high' order by pos ";
      $db_query="select id_category,type,n_category,hide,name,pos,image,name_url from ".DB_PREF."article_category where hide='show' and type='high' order by pos ";
      //list($kol,$mas_data_1lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      list($kol,$mas_data_1lvl) = db_work::query_select_assoc_index($db_query,"id_category",function($row){ return (self::convert_one_category($row)); } );
      
      //$mas_data_1lvl = set_united_name_url_mas_category_item_article($mas_data_1lvl);
      
      return ($mas_data_1lvl);
     }
   
   public function select_data_many_level()
     {
      //данный метод должен переопределяться для конкретного объекта
      
      //формируем запрос к базе данных для получения категорий всех уровней
      $mas_data_many_lvl = array();
      
      //$db_query="select * from ".DB_PREF."category where hide='show' and type='high' order by pos ";
      //list($kol,$mas_data_1lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      
      //$db_query="select * from ".DB_PREF."article_category where hide='show' order by pos ";
      $db_query="select id_category,type,n_category,hide,name,pos,image,name_url from ".DB_PREF."article_category where hide='show' order by pos ";
      //list($kol,$mas_data_many_lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      list($kol,$mas_data_many_lvl) = db_work::query_select_assoc_index($db_query,"id_category",function($row){ return (self::convert_one_category($row)); } );
      
      //$mas_data_many_lvl = set_united_name_url_mas_category_item_article($mas_data_many_lvl);
      
      return ($mas_data_many_lvl);
     }
   
   public function get_one_data_full($id_category)
     {
       $db_query="select * from ".DB_PREF."article_category where id_category = ".$id_category;
       list($kolvo,$one_data)=db_work::query_select_one_assoc($db_query);
       
       return ($kolvo == 1 ? $one_data : false);
     }
   
   public static function convert_one_category($d_category)
     {
       
       $d_category["united_name_url"] = $d_category["name_url"] ? $d_category["name_url"] : encode_text_to_url_name($d_category["name"]);
       $d_category["id_category"]=intval($d_category["id_category"]);
       $d_category["n_category"]=intval($d_category["n_category"]);
       $d_category["pos"]=intval($d_category["pos"]);
       //write_log_cms($d_category);
       
       return ($d_category);
     }
   
  }


//$obj_article_cache_category = new article_cache_category("article", DIR_CACHE_DATA);
//$obj_article_cache_category->select_data_first_level();


class mdarticle_cache_category extends model_cache_many_lvl_data
  {
   public function init_obj()
     {
      $this->name_model = "mdarticle";
      //$this->dir_cache = DIR_CACHE_DATA . "/";
      
     }
   
   public function select_data_first_level()
     {
      //данный метод должен переопределяться для конкретного объекта
      
      //формируем запрос к базе данных для получения категорий 1-го уровня.
      $mas_data_1lvl = array();
      
      //$db_query="select * from ".DB_PREF."article_category where type='high' order by pos ";
      $db_query="select id_category,type,n_category,hide,name,pos,image,name_url from ".DB_PREF."article_category where type='high' order by pos ";
      //list($kol,$mas_data_1lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      list($kol,$mas_data_1lvl) = db_work::query_select_assoc_index($db_query,"id_category",function($row){ return (self::convert_one_category($row)); } );
      
      //$mas_data_1lvl = set_united_name_url_mas_category_item_article($mas_data_1lvl);
      
      return ($mas_data_1lvl);
     }
   
   public function select_data_many_level()
     {
      //данный метод должен переопределяться для конкретного объекта
      
      //формируем запрос к базе данных для получения категорий всех уровней
      $mas_data_many_lvl = array();
      
      //$db_query="select * from ".DB_PREF."category where hide='show' and type='high' order by pos ";
      //list($kol,$mas_data_1lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      
      //$db_query="select * from ".DB_PREF."article_category order by pos ";
      $db_query="select id_category,type,n_category,hide,name,pos,image,name_url from ".DB_PREF."article_category order by pos ";
      //list($kol,$mas_data_many_lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      list($kol,$mas_data_many_lvl) = db_work::query_select_assoc_index($db_query,"id_category",function($row){ return (self::convert_one_category($row)); } );
      
      //$mas_data_many_lvl = set_united_name_url_mas_category_item_article($mas_data_many_lvl);
      
      return ($mas_data_many_lvl);
     }
   
   public function get_one_data_full($id_category)
     {
       $db_query="select * from ".DB_PREF."article_category where id_category = ".$id_category;
       list($kolvo,$one_data)=db_work::query_select_one_assoc($db_query);
       
       return ($kolvo == 1 ? $one_data : false);
     }
   
   public static function convert_one_category($d_category)
     {
       
       $d_category["united_name_url"] = $d_category["name_url"] ? $d_category["name_url"] : encode_text_to_url_name($d_category["name"]);
       $d_category["id_category"]=intval($d_category["id_category"]);
       $d_category["n_category"]=intval($d_category["n_category"]);
       $d_category["pos"]=intval($d_category["pos"]);
       //write_log_cms($d_category);
       
       return ($d_category);
     }
   
  }


/*
function sort_category_name_board($a,$b)
  {
   if ( $a["name"] === $b["name"] ) return 0;
   return ( ( $a["name"] > $b["name"] ) ? 1 : -1 );
  }
*/

function forming_geo_part_name_url_article($data_item)
  {
   $t = "";
   
   global $masConfig;
   if ( $masConfig["ON_USE_GEO_DATA"] == 1 && $masConfig["ON_USE_GEO_LINK_ARTICLE_ITEM"] == 1 )
     {
      global $obj_geoData;
      $t = $obj_geoData->forming_geo_in_url_mas_data( array($data_item["country_item"],$data_item["region_item"],$data_item["city_item"]) );
     }
   
   return ($t);
  }

