<?php

include_once("../../../../config/config.php");
$type_rights_access = array("article","server","write");
$type_answer = "iframe";
$admin_check_contr_code=true;
include_once(DIR_ADMIN."/init_work.php");



class create_articleItem_cp
  {
   
   private $mas_inbox=array();
   private $mas_status=array();
   
   private $rez="";
   
   private $error=0;
   private $error_text="";
   
   private $mas_save=array();
   
   //private $time_end_putdate=0;
   //private $save_end_putdate=false;
   
   private $mas_n_lvl_category=array();
   //private $mas_dynamic_data=array();
   private $data_item=array();
   
   private $mas_images=array();
   private $save_images=false;
   
   private $operation="";
   
   private $obj_uploader=false;
   
   function __construct()
     {
      $this->dir_big_images = DIR_LOADFILES_MODULS . "/article/bigfoto/";
      $this->dir_small_images = DIR_LOADFILES_MODULS . "/article/smallfoto/";
      $this->dir_images_cms = DIR_CMS."/images/";
      
      $this->obj_uploader = new eng_fsupload();
     }
   
   function start()
     {
      global $masConfig;
      $error=0;
      $error_text="";
      
      $this->mas_inbox=array();
      $this->mas_status=array();
      
      //$this->flag_is_fill_key_words = ( $masConfig["USE_POLE_KEY_WORDS_ADWERT"] == 1 && $masConfig["IS_FILL_POLE_KEY_WORDS_ADWERT"] == 1 ) ? true : false;
      
      $this->operation="new";
      
      $this->on_user=false;//объявление добавляет авторизованный пользователь
      $this->num_user=0;// id авторизованного пользователя
      $this->name_user_avtoriz="";
      $this->data_auth_user = false;
      
      list($this->error,$this->error_text)=$this->base();
      
      $this->answer();
     }
   
   function base()
     {
      global $masConfig,$obj_article;
      
      $this->obj_cache_category = new mdarticle_cache_category("mdarticle", DIR_CACHE_DATA);
      
      if ( $masConfig["ON_VIEW_QUANTITY_ARTICLE_CATEGORY"] == 1 )
        {
         $this->obj_cache_db = new class_article_cache_db();
         $this->obj_cache_db->set_obj_article_cache_category($this->obj_cache_category);
        }
      
      //if (!$this->check_status_user()) return (array(1,"Только зарегистрированные и авторизованные пользователи могут добавлять объявления!"));
      //if (!$this->check_external_data()) return (array(1,"Обнаружена неизвестная ошибка!  Код ошибки 9."));
      if (!$this->control_external_data()) return (array(1,"Ошибка с данными! Возможно не все поля заполнены!"));
      //if (!$this->check_status_user_form()) return (array(1,"Обнаружена неизвестная ошибка! Код ошибки 1."));
      
      $this->operation = $this->mas_inbox["type_create"];
      
      if ($this->operation == "edit")
        {
         $this->data_item=$this->get_data_item($this->mas_inbox["id_item"]);
         if (!$this->data_item) return (array(1,"Обнаружена ошибка: статья не найдена!"));
        }
      
      $this->mas_images=($this->data_item && $this->data_item["image"] ? explode("|",$this->data_item["image"]) : array() );
      $this->save_images=false;
      
      
      //$this->time_end_putdate=($this->data_item ? $this->data_item["end_putdate"] : 0);
      //$this->save_end_putdate=false;
      
      
      $mas_index = array("id_item","name_item","teg_title","meta_keywords","meta_description",/*"email",*/ "site",
        "phone","address","add_text","short_text","all_text","num_user",
        "moder","hide","abuse","on_comments","add_comments",/*"is_get_email",*/ "access_user_authorize","access_user_status_1",
        "robots_index");
      
      $this->mas_save = copy_mas_to_mas_index($this->mas_inbox,array(),$mas_index);
      
      $this->mas_save["name_url"] = $obj_article->forming_name_url_item($this->mas_save["name_item"]);
      $this->mas_save["hash_text"] = "";
      //$this->check_data_maps();
      
      $m_fn=array("check_geo_data","check_data_category",
        /*"delete_images_edit","check_add_images",*/"check_add_images_2"
       );
      
      foreach ($m_fn as $one_fn)
        {
         list($error,$error_text)=$this->$one_fn();
         if ($error==1) return (array(1,$error_text));
        }
      
      $this->add_db();
      
      return (array(0,""));
     }
   
   function control_external_data()
     {
      global $obj_control_data,$masConfig;
      
      $mas = array(
        array("type_create","post","type_create","text",true,true,"listv","new,edit",false,false),
        array("id_item","post","id_item","numeric",true,false,false,"",false,false),
        array("category","post","num_highcategory","numeric",true,true,false,"",false,false),
        //array("podcategory","post","n_category","numeric",true,true,false,"",false,false),
        array("name_item","post","name_item","text",true,true,false,"",false,false),
        array("teg_title","post","teg_title","text",true,false,false,"",false,false),
        array("meta_keywords","post","meta_keywords","text",true,false,false,"",false,false),
        array("meta_description","post","meta_description","text",true,false,false,"",false,false),
        
        //array("email","post","email","text",true,false,"function","check_data_email",false,false),
        array("site","post","site","text",true,false,false,false,false,false),
        array("phone","post","phone","text",true,false,false,false,false,false),
        array("address","post","address","text",true,false,false,false,false,false),
        array("add_text","post","add_text","text",true,false,false,false,false,false),
        array("short_text","post","short_text","text",true,true,false,false,false,false),
        array("all_text","post","all_text","text",true,true,false,false,false,false),
        array("moder","post","moder","text",true,true,"listv","new,view",false,false),
        array("hide","post","hide","text",true,true,"listv","hide,show",false,false),
        //array("status","post","status_item","text",true,true,"listv","usual,vip",false,false),
        //array("timevip","post","timevip","numeric",true,false,false,"",false,false),
        array("abuse","post","abuse","text",true,true,"listv","on,off",false,false),
        array("access_user_authorize","post","access_user_authorize","text",true,true,"listv","yes,no",false,false),
        array("access_user_status_1","post","access_user_status_1","text",true,true,"listv","yes,no",false,false),
        //array("cost","post","cost","numeric",true,false,false,"",false,false),
        //array("currency","post","currency","text",true,true,"listv","rub,usd,uah,eur",false,false),
        //array("pick_out","post","pick_out_item","text",true,true,"listv","usual,picked",false,false),
        //array("time_picked","post","time_picked","numeric",true,false,false,"",false,false),
        //array("upitem","post","upitem","text",true,true,"listv","on,off",false,false),
        array("on_comments","post","on_comments","text",true,true,"listv","on,off",false,false),
        array("add_comments","post","add_comments","text",true,true,"listv","on,off",false,false),
        //array("makegood","post","is_makegood","text",true,true,"listv","no,yes",false,false),
        //array("is_get_email","post","is_get_email","text",true,true,"listv","no,yes",false,false),
        //array("imgsrc_del","post","imgname_del","text",true,false,false,"",false,false),
        
        array("country_num","post","country_item","numeric",false,false,false,false,false,false,"all",0),
        array("region_num","post","region_item","numeric",false,false,false,false,false,false,"all",0),
        array("city_num","post","city_item","numeric",false,false,false,false,false,false,"all",0),
        
        array("num_user","post","num_user","numeric",true,true,false,false,false,false,"all",0),
        //array("add_maps","post","add_maps","text",true,true,"listv","on,off",false,false),
        //array("longitude","post","longitude","numeric",true,false,false,"",false,false),
        //array("latitude","post","latitude","numeric",true,false,false,"",false,false),
        
        array("robots_index","post","robots_index","text",true,true,"listv","yes,no",false,false),
        
       );
      
      $rez_control_data=$obj_control_data->processing_one_group($mas);
      $this->mas_inbox=$rez_control_data[3];
      $this->mas_status=$rez_control_data[5];
      
      if ( !$rez_control_data[0] || $rez_control_data[1]) return (false);
      
      return (true);
     }
   
   function check_geo_data()
     {
      global $masConfig;
      
      $country_item = 0;
      $region_item = 0;
      $city_item = 0;
      
      $name_country_item = "";
      $name_region_item = "";
      $name_city_item = "";
      
      if ( $masConfig["ON_USE_GEO_DATA"] == 1 && $masConfig["ON_USE_GEO_LINK_ARTICLE_ITEM"] == 1 )
        {
         global $obj_geoData;
         //проверяем правильность передачи данных о регионе
         if ( $this->mas_inbox["country_item"] > 0 && $this->mas_inbox["region_item"] > 0 && $this->mas_inbox["city_item"] > 0 )
           {
            
            $name_country_item = $obj_geoData->select_name_geo_data("country",$this->mas_inbox["country_item"]);
            $name_region_item = $obj_geoData->select_name_geo_data("region",$this->mas_inbox["region_item"]);
            $name_city_item = $obj_geoData->select_name_geo_data("city",$this->mas_inbox["city_item"]);
            
            if (!$name_country_item || !$name_region_item || !$name_city_item) return (array(1,"Ошибка с гео-данными!"));
            
            $country_item = $this->mas_inbox["country_item"];
            $region_item = $this->mas_inbox["region_item"];
            $city_item = $this->mas_inbox["city_item"];
           }
          elseif ( $masConfig["NEED_TO_USE_GEO_LINK_ARTICLE_ITEM"] == 1 )
            {
             return (array(1,"Ошибка с гео-данными!"));
            }
        }
      
      $this->mas_save["country_item"] = $country_item;
      $this->mas_save["region_item"] = $region_item;
      $this->mas_save["city_item"] = $city_item;
      
      $this->mas_save["name_country_item"] = $name_country_item;
      $this->mas_save["name_region_item"] = $name_region_item;
      $this->mas_save["name_city_item"] = $name_city_item;
      
      return (array(0,""));
     }
   
   function check_data_category()
     {
      // проверяем категорию, которая указана в объявлении
      
      if ( !$this->obj_cache_category->check_num_data_1lvl( $this->mas_inbox["num_highcategory"] ) ) return (array(1,"Неправильно указана категория!"));
      
      $mas_n_lvl_category=array();
      $mas_n_lvl_category[0] = $this->mas_inbox["num_highcategory"];
      $mas_n_lvl_category = array_merge( $mas_n_lvl_category, ext_post_mas_vpole("category_lvl_n", true) );
      
      if ( !$this->obj_cache_category->check_mas_num_lvl_data( $mas_n_lvl_category ) ) return (array(1,"Неправильно указана одна или несколько категорий!"));
      $this->mas_n_lvl_category=$mas_n_lvl_category;
      
      return (array(0,""));
     }
   
   function get_data_item($id_item)
     {
      $rez=false;
      $db_query="select * from ".DB_PREF."article_item where id_item=".$id_item." ";
      list($kol_item,$data_item)=obr_db_query_select_one_assoc($db_query);
      
      if ($kol_item > 0) $rez=$data_item;
      
      return ($rez);
     }
   /*
   function delete_images_edit()
     {
      //$this->mas_images = array();
      $mas_delete_images = ext_post_mas_vpole("delete_image_item",false);//получаем названия изображений, которые нужно удалить
      
      if ( sizeof($mas_delete_images)==0 ) return (array(0,""));
      
      foreach ($mas_delete_images as $name_delete_one_image)
        {
         $num_index_del=array_search($name_delete_one_image,$this->mas_images);
         if ($num_index_del !== false)
           {
            $this->save_images=true;
            //удаляем название файла из массива
            unset($this->mas_images[$num_index_del]);
            //удаляем большую и маленькую картинки
            if (!(file_exists($this->dir_big_images.$name_delete_one_image) && unlink($this->dir_big_images.$name_delete_one_image)))
              {
               
              }
            if (!(file_exists($this->dir_small_images.$name_delete_one_image) && unlink($this->dir_small_images.$name_delete_one_image)))
              {
               
              }
           }
        }
      
      return (array(0,""));
     }
   
   function check_add_images()
     {
      global $masConfig;
      
      $use_watermark = false;
      $file_img_watermark = "";
      if ( $masConfig["ON_USE_WM_IMG_ARTICLE"] == 1 && $masConfig["FILE_WM_IMG_ARTICLE"] && proverka_exp_img($masConfig["FILE_WM_IMG_ARTICLE"]) )
        {
         $use_watermark = true;
         $file_img_watermark = $this->dir_images_cms.$masConfig["FILE_WM_IMG_ARTICLE"];
         
        }
      
      $data_new_upload_files = save_upload_mas_file( "img_element",$this->dir_small_images,true,"jpg|jpeg|gif|png", "tosize", MAX_WIDTH_ICON_ARTICLE, MAX_HEIGHT_ICON_ARTICLE, -1,
       $this->dir_big_images,"resize", MAX_WIDTH_ARTICLE, MAX_HEIGHT_ARTICLE,
       false, 0,0, 
       $file_img_watermark, $masConfig["POSITION_X_WM_IMG_ARTICLE"],$masConfig["POSITION_Y_WM_IMG_ARTICLE"] 
       );
      
      if ( $data_new_upload_files[0] )
        {
         $this->save_images = true;
         $this->mas_images = array_merge($this->mas_images,$data_new_upload_files[2]);
        }
      
      return (array(0,""));
     }
   */
   
   function check_add_images_2()
     {
       global $masConfig;
       
       $error = 0;
       $error_text = "";
       
       $opts_upload = [
         "max_numbr_files" => 0,// $masConfig["QUANTITY_IMG_ARTICLE"],
         "max_size_img" => $masConfig["MAX_SIZE_IMG_ARTICLE"],//50000000
         
         "on_use_wm_img" => $masConfig["ON_USE_WM_IMG_ARTICLE"],
         "file_wm_img" => $masConfig["FILE_WM_IMG_ARTICLE"],
         "position_x_wm" => $masConfig["POSITION_X_WM_IMG_ARTICLE"],
         "position_y_wm" => $masConfig["POSITION_Y_WM_IMG_ARTICLE"],
         
         "max_width_img" => $masConfig["MAX_WIDTH_ARTICLE"],
         "max_height_img" => $masConfig["MAX_HEIGHT_ARTICLE"],
         "max_width_preview" => $masConfig["MAX_WIDTH_ICON_ARTICLE"],
         "max_height_preview" => $masConfig["MAX_HEIGHT_ICON_ARTICLE"],
         
         "name_pole_type_upload" => "type_upload_imgs",
         "name_pole_dlt" => "dlt_name_imgs",
         "name_pole_new" => "accepted_name_imgs",
         "name_pole_sort" => "sort_name_imgs",
         
         "name_field_files" => "create_img_article"
       ];
       
       $this->obj_uploader->set_data_imgs($this->mas_images, $this->dir_big_images, $this->dir_small_images, $this->dir_images_cms, $opts_upload);
       
       list($error, $error_text, $save_images, $mas_images) = $this->obj_uploader->process_upload_imgs();
       
       if ($error == 0)
         {
           $this->save_images = $save_images;
           $this->mas_images = $mas_images;
         }
       
       return (array($error, $error_text));
     }
   
   function add_db()
     {
      global $masConfig,$url_site;
      
      if ($this->operation == "new" || $this->save_images)
        $this->mas_save["image"] = ( sizeof($this->mas_images) > 0 ? implode("|",$this->mas_images) : "" );
      
      $this->mas_save["n_category"] = end($this->mas_n_lvl_category);
      
      $this->mas_save["email"] = "";
      $this->mas_save["is_get_email"] = "no";
      
      if ( $this->operation == "new" )
        {
         
         $this->mas_save["start_putdate"] = $GLOBALS["timeGlobal"];
         $this->mas_save["sort_time"] = $GLOBALS["timeGlobal"];
         $this->mas_save["end_putdate"] = 0;
         $this->mas_save["redak_putdate"] = 0;
         
         $this->mas_save["kolvo_view"] = 0;
         $this->mas_save["date_last_view"] = 0;
         //$this->mas_save["num_user"] = $GLOBALS["num_user"];
         
         $this->mas_save["key_words"] = "";
         $this->mas_save["num_type_display"] = 0;
         //$this->mas_save["add_comments"] = "on";
         
         //$this->mas_save["access_user_authorize"] = "no";
         //$this->mas_save["access_user_status_1"] = "no";
         
        }
      
      $db_query = forming_db_query_indexmas(DB_PREF."article_item",$this->mas_save,$this->operation,"id_item");
      $q_ident = obr_db_query($db_query);
      
      
      updateSettings( array("article_cache_stats" => 0) );//меняем параметр кэша статистики
      
      if ( $masConfig["ON_VIEW_QUANTITY_ARTICLE_CATEGORY"] == 1 )
        {
         if ( $this->operation == "edit" && $this->data_item )
           $this->obj_cache_db->clear_cache_data( $this->data_item["country_item"],$this->data_item["region_item"],$this->data_item["city_item"],$this->data_item["n_category"] );
         
         $this->obj_cache_db->clear_cache_data( $this->mas_save["country_item"],$this->mas_save["region_item"],$this->mas_save["city_item"],$this->mas_save["n_category"] );
        }
      
     }
   
   function answer()
     {
      global $masConfig;
      
      write_js_iframe_answer($this->error,$this->error_text,$this->rez);
      
     }
   
  }

$obj_create_articleItem_cp=new create_articleItem_cp();
$obj_create_articleItem_cp->start();

