<?php

include_once("../../../../config/config.php");
$type_rights_access = array("article","server","read");
include_once(DIR_ADMIN."/init_work.php");



class class_article_select_item
  {
   
   public $obj_mdarticle_cache_category = false;
   public $rez_control_data = array();
   public $mas_inbox = array();
   public $mas_status = array();
   public $obj_article = false;
   public $obj_site = false;
   
   function __construct()
     {
      global $obj_article;
      global $obj_site;
      $this->obj_article = $obj_article;
      $this->obj_site = $obj_site;
      $this->obj_mdarticle_cache_category = new mdarticle_cache_category("mdarticle", DIR_CACHE_DATA);
      
     }
   
   function work()
     {
      $error=0;
      $error_text="no";
      $rez="";
      
      $d_mas = $this->list_oper();
      $error = $d_mas[0];
      $error_text = $d_mas[1];
      if ( isset($d_mas[2]) ) $rez = $d_mas[2];
      
      write_ajax_answer_jc($error,$error_text,$rez);
     }
   
   function list_oper()
     {
      
      $this->check_post_data();
      if ( !($this->rez_control_data[0] && !$this->rez_control_data[1]) ) return (array(1,"Ошибка с данными!"));
      
      return ($this->select_data());
     }
   
   function check_post_data()
     {
      
      $mas_check = array(
        
        array("page","post","page","numeric",true,true,false,false,false,false),
        array("kol_item","post","kol_item","numeric",true,true,false,false,false,false),
        array("hide","post","hide","text",true,true,"listv","all,show,hide",false,false),
        array("moder","post","moder","text",true,true,"listv","all,new,view",false,false),
        array("abuse","post","abuse","text",true,true,"listv","all,on,off",false,false),
        array("cat","post","cat","numeric",true,false,false,false,false,false),
        //array("podcat","post","podcat","numeric",true,false,false,false,false,false),
        array("list_id","post","list_id","text",true,false,"hablonrv","/^[0-9]+(\,[0-9]+)*$/is",false,false),
        array("list_num_user","post","list_num_user","text",true,false,"hablonrv","/^[0-9]+(\,[0-9]+)*$/is",false,false),
        array("stext","post","stext","text",true,false,false,"",false,false,"all",""),
        array("logical_and","post","logical_and","text",true,true,"listv","on,off",false,false,"all","on"),
        array("on_quantity","post","on_quantity","text",true,true,"listv","on,off",false,false,"all","off"),
        array("num_country","post","num_country","numeric",true,false,false,"",false,false,"all",0),
        array("num_region","post","num_region","numeric",true,false,false,"",false,false,"all",0),
        array("num_city","post","num_city","numeric",true,false,false,"",false,false,"all",0),
        array("robots_index","post","robots_index","text",true,true,"listv","yes,no,all",false,false,"all","all"),
        
       );
      
      global $obj_control_data;
      
      $this->rez_control_data=$obj_control_data->processing_one_group($mas_check);
      $this->mas_inbox=$this->rez_control_data[3];
      $this->mas_status=$this->rez_control_data[5];
     }
   
   function select_data()
     {
      //данные обнаружены и ошибок нет
      $error=0;
      $error_text="no";
      $rez="";
      
      global $obj_site;
      
      $mas_inbox = $this->mas_inbox;
      $mas_status = $this->mas_status;
      
      
      $page=$mas_inbox["page"];
      $kol_to_page=$mas_inbox["kol_item"];
      $hide=$mas_inbox["hide"];
      $moder=$mas_inbox["moder"];
      $category=$mas_inbox["cat"];
      //$podcategory=$mas_inbox["podcat"];
      //$status=$_POST["status"];
      $abuse=$mas_inbox["abuse"];
      $type="all";//$_POST["type"];
      
      //$picked=$_POST["picked"];
      //$vimages=$_POST["vimages"];
      
      $list_id = $mas_inbox["list_id"];
      $list_num_user = $mas_inbox["list_num_user"];
      
      $stext = $mas_inbox["stext"];
      $logical_and = $mas_inbox["logical_and"];
      $on_quantity_elm = ($mas_inbox["on_quantity"] == "on" ? true : false);
      
      $num_country = $mas_inbox["num_country"];
      $num_region = $mas_inbox["num_region"];
      $num_city = $mas_inbox["num_city"];
      
      $robots_index=$mas_inbox["robots_index"];
      
      list($kolvo_vsego,$kolvo,$mas_data_item) = $this->select_item_filter($page,$kol_to_page,$hide,$moder,$category,$abuse,$type,
        $list_id,$list_num_user,$stext,$logical_and,$on_quantity_elm,$num_country,$num_region,$num_city,$robots_index);
      
      $encode_text = encode_gen_mas_to_jointext($mas_data_item,false, true );
      $rez .= " kolvo_vsego: ".$kolvo_vsego;
      $rez .= " , kolvo:".$kolvo." , data:[ ".$encode_text." ] ";
      
      
      $data_user = array();
      $mas_num_user = select_mas1lev_2level($mas_data_item,"num_user", false);
      //$mas_num_user = ext_data_from_mas2level($data_mas,"type_user","user","num_user");
      if ( sizeof($mas_num_user) )
        {
         
         $data_user = $obj_site->select_data_user_to_list_id($mas_num_user,"id_user,name_user,date_create,access_admin,operation_1");
        }
      
      $rez .= ",data_user : {".encode_gen_mas_to_jointext($data_user,false, true, "assoc" )."}";
      
      $data_quantity_user = array();
      if ( $on_quantity_elm )
        $data_quantity_user = $this->search_quantity_item_user($mas_data_item);
      $rez .= ", data_quantity_user : {".encode_gen_mas_to_jointext($data_quantity_user,false,true,"assoc")."}";
      
      return (array(0,"no",$rez));
     }
   
   function select_item_filter($page,$kol_to_page,$hide,$moder,$category,$abuse,$type,
     $list_id,$list_num_user,$stext,$logical_and,$on_quantity_elm,$num_country,$num_region,$num_city,$robots_index)
     {
      
      //global $obj_mdarticle_cache_category;
      
      //$mas_num_item=array();
      
      $where_hide=" ";$where_moder=" ";$where_status=" ";$where_abuse=" ";$where_type=" ";$where_picked=" ";
      $where_vimages=" ";$where_list_id = " ";$where_list_num_user = " ";
      $where_stext = " ";$where_geo = " ";$where_robots_ind=" ";
      
      if ($hide=="hide" || $hide=="show") $where_hide=" and item.hide='$hide' ";
      if ($moder=="new" || $moder=="view") $where_moder=" and item.moder='$moder' ";
      //if ($status=="vip" || $status=="usual") $where_status=" and item.status_item='$status' ";
      if ($abuse != "all") $where_abuse=" and item.abuse='$abuse' ";
      if ($type != "all") $where_type=" and item.type='$type' ";
      //if ($picked != "all") $where_picked=" and item.pick_out_item='$picked' ";
      //if ($vimages != "all") $where_vimages=" and item.vimages_item='$vimages' ";
      if ( trim($list_id ) ) $where_list_id = " and id_item IN (".$list_id.") ";
      if ( trim( $list_num_user ) || $list_num_user === "0" ) $where_list_num_user = " and num_user IN (".$list_num_user.") ";
      if ($robots_index != "all") $where_robots_ind=" and item.robots_index='$robots_index' ";
      
      /*
      $db_query="select item.id_item,item.name_user,item.name_item,item.image,item.hide,item.moder,item.n_category,
        item.kolvo_view,item.start_putdate,item.end_putdate,item.redak_putdate 
        from ".DB_PREF."item item ";*/
      $db_query="select item.*
        from ".DB_PREF."article_item item where ";
      $db_query_1="select count(*) 
        from ".DB_PREF."article_item item where ";
      
      $part2=" ";
      
      if ( $category > 0 )
        {
         
         //$mas_id_category = $obj_mdarticle_cache_category->get_mas_num_data($category,true);
         //$part2 .= sizeof($mas_id_category) > 0 ? " n_category IN (".implode(",",$mas_id_category).") " : "";
         $t_db_query_category = $this->obj_mdarticle_cache_category->get_text_db_query_data_many_lvl("n_category", $category);
         $part2 .= $t_db_query_category ? " ( ". $t_db_query_category. " ) " : " n_category > 0 ";
        }
       else
         {
          $part2 .= " n_category > 0 ";
         }
      
      if ( trim( $stext ) )
        {
         list($mas_words,$is_min) = process_text_search($stext,2,60,"=+.%$#@!'\",*(){}[]\\|/?<>",false);
         if ( sizeof( $mas_words ) )
           {
            $where_stext .= " and ( ";
            if ( $logical_and == "off" )
              {
               $sep = "";
               foreach ( $mas_words as $one_word )
                 {
                  $s_word = addcslashes(codeText($one_word),"%_");
                  $where_stext .= $sep." item.name_item LIKE '%".$s_word."%' or item.short_text LIKE '%".$s_word."%' "
                  ." or item.all_text LIKE '%".$s_word."%'  or item.email LIKE '%".$s_word."%' ";
                  $sep = " or ";
                 }
              }
             else
               {
                $t_like = "";
                //$t_like .= implode("%",$mas_words);
                //$t_like = "%".codeText($t_like)."%";
                $sep = "";
                foreach ( $mas_words as $one_word )
                  {
                   $t_like .= $sep.addcslashes(codeText($one_word),"%_");
                   $sep = "%";
                  }
                $t_like = "%".$t_like."%";
                $where_stext .= " item.name_item LIKE '".$t_like."' or item.short_text LIKE '".$t_like."' "
                  ." or item.all_text LIKE '".$t_like."' or item.email LIKE '".$t_like."' ";
               }
            $where_stext .= " ) ";
            //var_dump($where_stext);
           }
         
        }
      
      if ( $num_country > 0 )
        {
         $where_geo = " and item.country_item = ".$num_country." ";
         if ( $num_region > 0 )
           {
            $where_geo .= " and item.region_item = ".$num_region." ";
            if ( $num_city > 0 )
              $where_geo .= " and item.city_item = ".$num_city." ";
           }
        }
      
      //$db_query.=$where_hide.$where_moder;
      $part3=" order by item.id_item DESC limit ".($page-1)*$kol_to_page.",".$kol_to_page;
      
      $kolvo_vsego = obr_db_query_count($db_query_1.$part2.$where_hide.$where_moder.$where_status.$where_picked.$where_vimages.$where_robots_ind
       .$where_list_id.$where_list_num_user.$where_abuse.$where_type.$where_geo.$where_stext);
      
      
      //$rez=" kolvo_vsego:";
      //$rez.=$kolvo_vsego." ";
      if ($kolvo_vsego==0)
        {
         //$rez.=" , data:'' ";
         return (array($kolvo_vsego,0,array()));
        }
      
      list($kolvo,$data_mas) = obr_db_query_select_assoc($db_query.$part2.$where_hide.$where_moder.$where_status.$where_picked.$where_vimages.$where_robots_ind
       .$where_list_id.$where_list_num_user.$where_abuse.$where_type.$where_geo.$where_stext.$part3);
      
      /*
      $mas_num_adv = select_mas1lev_2level($data_mas,"id_item", false);
      
      $encode_text = encode_gen_mas_to_jointext($data_mas,false, true );
      $rez.=" , kolvo:".$kolvo." , data:[ ";
      $rez.= $encode_text;
      $rez.=" ] ";
      */
      return (array($kolvo_vsego,$kolvo,$data_mas));
     }
   
   function search_quantity_item_user($mas_item)
     {
      $data_quantity = array();
      $mas_quantity_user = array();
      
      
      if ( sizeof($mas_item) > 0 )
        {
         
         foreach ( $mas_item as $one_item )
           {
            $v_num_user = trim($one_item["num_user"]);
            
            //list($v_phone,$mas_norm_phone,$mas_v_phone)=$this->normaliz_phone($one_item["phone"]);
            $id_item = $one_item["id_item"];
            
            $quantity = 0;
            
            if ( $v_num_user > 0 )
              {
               
               $is_check_quantity = false;
               
               if ( isset($mas_quantity_user[$v_num_user]) )
                 {
                  $quantity = $mas_quantity_user[$v_num_user];
                  $is_check_quantity = true;
                  
                 }
               
               if ( !$is_check_quantity )
                {
                 
                 $db_query = "select count(*) from ".DB_PREF."article_item item where num_user = ".$v_num_user." ";
                 
                 $quantity = db_work::query_count($db_query);
                 $mas_quantity_user[$v_num_user] = $quantity;
                 
                }
              }
            
            $data_quantity[$id_item] = $quantity;
            
           }
         
        }
      
      return ($data_quantity);
     }
   
  }


$obj_article_select_item = new class_article_select_item();
$obj_article_select_item->work();

