<?php


class guest_class extends base_guest_class
  {
   
   function on_iniz_param_modul()//используется в главном модуле для определения нужно ли проверять входящие данные (GET или POST)
     {
      return ($this->iniz_param);
     }
   
   function opred_all_get_data_modul()//функция должна возвращать массив со всеми возможными для данного модуля $_GET переменными
     {
      $mas_get_data=array("guestpage");
      return ($mas_get_data);
     }
   
   function opred_param_modul($m,$k)//должна возвращать следующее
     {
      // 1 - если задан хотябы один параметр, даже если задан не верно. Иначе 0
      
      $rezult=0;
      $param_url=$GLOBALS["param_open_url_union"];
      if (isset($param_url["guestpage"]))
        {
         $this->num_page=$param_url["guestpage"];
         $this->set_page=true;
         $rezult=1;
        }
      return ($rezult);
     }
   
   function korek_param_modul()//должна возвращать true если все параметры заданны верно, или false - если не верно
     {
      
      if (!$this->set_page)
        {
         //$this->on_guest=true;
         $this->num_page=1;
        }
       else
         {
          if (!is_numeric($this->num_page)) return (false);
          if ($this->num_page <= 0) return (false);
         }
      
      $db_query="select count(*) from ".DB_PREF."guest where hide='show' ";// limit ".($this->num_page-1)*$this->kol_messages_on_page.",".$this->kol_messages_on_page;
      $this->kol_messages_vsego = obr_db_query_count($db_query);
      
      
      if ($this->kol_messages_vsego==0 && $this->num_page != 1 )
        {
         return (false);
        }
      
      $this->kol_pages=ceil($this->kol_messages_vsego/$this->kol_messages_on_page);
      if ($this->num_page > 1 && $this->kol_pages < $this->num_page)
        return (false);
      
      $this->on_guest=true;
      $this->open_this_modul=true;
      
      return (true);
     }
   
   function init_write_data($korekParam,$openModul)
     {
      return(false);
     }
   
   function write_menu_modul()//функция должна выводить массив пунктов/подпунктов
     {
      /*
      новая структура:
      
      каждый элемент должен быть массивом следующего содержания:
      0 - позиция пункта в меню
      1 - данные о пункте - массив содержащий следующее:
        
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      2 - массив с данными о подпунктах,если они есть, иначе false
        каждый подпункт меню, представляет собой массив следующего содержания:
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      
      */
      $set=1;
      if ($this->on_guest)
        $set=2;
      
      global $dir_http;
      $one_punkt=array("Гостевая",$dir_http."/guest/",$set);
      
      return (array(array(100,$one_punkt,false)));
     }
   
   function add_text_head()// метод должен возращать текст выводимый в заголовке head страницы (дополнительные теги нужные модулю) или false - если текст подключать не надо
     {
      $htext=false;
      
      return ($htext);
     }
   
   function write_soder_modul()//функция должна возвращать массив с заголовком и текстом основного содержимого
     {
      $title_text = "";
      $text = "";
      
      if ($this->on_guest)
        {
         include_once("guest_include.php"); 
        }
      
      return (array("t0"=>$title_text, "t1"=>$text));
     }
   
   function write_modul_title_meta()
     {
      //функция должна возвращать массив с  текстом тега <title> - то есть заголовок страницы
      // и содержимым мета-тегов description и keywords
      $mas=array("title"=>$this->page_title,"description"=>$this->page_description,"keywords"=>$this->page_keywords);
      //$mas["title"]="Гостевая книга";
      
      return ($mas);
     }
   
   function write_content_modul($name_part_write)// функция возвращает контент в виде HTML-кода (то есть текст), если вообще выводит (on_write_content_modul() должна возвращать true)
     {
      return ("");
     }
   
   function write_glav_page()//функция должна возвращать HTML-код для главной страницы ( если модуль конечно же выводит эти данные)
     {
      $text="";
      
      return ($text);
     }
   
   
   
   
  }

$obj_guest=new guest_class();
