<?php


class htmlbloks_class extends base_htmlbloks_class
  {
   
   function on_iniz_param_modul()//используется в главном модуле для определения нужно ли проверять входящие данные (GET или POST)
     {
      return ($this->iniz_param);
     }
   
   function opred_all_get_data_modul()//функция должна возвращать массив со всеми возможными для данного модуля $_GET переменными
     {
      $mas_get_data=array();
      return ($mas_get_data);
     }
   
   function opred_param_modul($m,$k)//должна возвращать следующее
     {
      // 1 - если задан хотябы один параметр, даже если задан не верно. Иначе 0
      
      $rezult=0;
      
      return ($rezult);
     }
   
   function korek_param_modul()//должна возвращать true если все параметры заданны верно, или false - если не верно
     {
      
      return (true);
     }
   
   function init_write_data($korekParam,$openModul)
     {
      return(false);
     }
   
   function write_menu_modul()//функция должна выводить массив пунктов/подпунктов
     {
      /*
      новая структура:
      
      каждый элемент должен быть массивом следующего содержания:
      0 - позиция пункта в меню
      1 - данные о пункте - массив содержащий следующее:
        
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      2 - массив с данными о подпунктах,если они есть, иначе false
        каждый подпункт меню, представляет собой массив следующего содержания:
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      
      */
      
      
      return (false);
     }
   
   function add_text_head()// метод должен возращать текст выводимый в заголовке head страницы (дополнительные теги нужные модулю) или false - если текст подключать не надо
     {
      $htext=false;
      
      return ($htext);
     }
   
   function write_soder_modul()//функции передается управление для подготовки вывода в основное содержимое сайта
     {
      /*
      функция должна возвратить массив
      - первый элемент должен содержать заголовок содержимого
      - второй элемент должен содержанть текст основного содержимого
      Например как показано ниже
      */
      
      $rez=array("t0"=>$this->zagolov_osnov_soder,"t1"=>$this->text_osnov_soder);
      return ($rez);
     }
   
   function write_modul_title_meta()
     {
      //функция должна возвращать массив с  текстом тега <title> - то есть заголовок страницы
      // и содержимым мета-тегов description и keywords
      $mas=array("title"=>"","description"=>"","keywords"=>"");
      $mas["title"]="Блоки HTML";
      //if ($this->num_photogallery!=0)
      //  $text_title.=" :: ".$this->data_num_photogallery["name_pg"];
      return ($mas);
     }
   
   function write_content_modul($name_part_write)// функция возвращает контент в виде массива  (каждый элемент: массив ->позиция и HTML-код (то есть текст)), если вообще выводит (on_write_content_modul() должна возвращать true) в отдельном блоке на странице
     {
      if (!$this->on_get_data_bloks)
        $this->get_data_bloks();
      
      global $dir_http,$dir_http_template,$mas_gl_values_cms,$masConfig;
      $array_text=array();
      
      
      
      if ( isset( $this->mas_data_bloks_group[$name_part_write] ) )
        {
         $mas_perem = $mas_gl_values_cms;
         $mas_perem["dir_http"] = $dir_http;
         $mas_perem["dir_http_template"] = $dir_http_template;
         
         $url_geo="";
         
         if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
           {
             global $obj_geoData;
             $url_geo = $obj_geoData->forming_geo_in_url_main_setting();
           }
         $mas_perem["url_geo"] = $url_geo;
         
         foreach ( $this->mas_data_bloks_group[$name_part_write] as $one_item )
           {
            $array_text[] = array( $one_item["pos_blok"], replace_perem_texthablon($one_item["text_blok"],"{:",":}",$mas_perem) );
           }
         
        }
      
      
      return ($array_text);
     }
   
   function write_glav_page()//функция должна возвращать HTML-код для главной страницы ( если модуль конечно же выводит эти данные)
     {
      $text="";
      
      return ($text);
     }
   
   
   function get_data_bloks()
     {
      //write_log_cms("htmlbloks: modul -> ".$this->f_openModul." component -> ".$this->nameComponent." num -> ".(is_array($this->numComponent) ? implode(",",$this->numComponent):$this->numComponent));
      $this->on_get_data_bloks = true;
      
      $q_view_page=" view_page = '' or view_page = '[all]' ";
      
      if ( $this->f_openModul )
        {
         $q_view_page .= " or view_page LIKE '%[".$this->f_openModul."]%' ";
         
         if ( $this->nameComponent )
           {
            $q_view_page .= " or view_page LIKE '%[".$this->f_openModul."-".$this->nameComponent."]%' ";
            /*
            if ( $this->numComponent && sizeof( $this->numComponent ) > 0 )
              {
               if ( sizeof( $this->numComponent ) == 1 )
                  $q_view_page .= " or view_page LIKE '%[".$this->f_openModul."-".$this->nameComponent."-".$this->numComponent[0]."]%' ";
                else
                  {
                   $q_view_page .= " or view_page RLIKE '\\\[".$this->f_openModul."\\\-".$this->nameComponent."\\\-(".(implode("|",$this->numComponent)).")\\\]' ";
                  }
              }
            */
           }
         
        }
      
      $db_query="select * from ".DB_PREF."html_bloks "
         ."where hide_blok='show' and (".$q_view_page.") ";
      
      list($kolvo, $mas_data)=obr_db_query_select_assoc_index_group($db_query,"name_part");
      
      if ( $kolvo > 0 )
        $this->mas_data_bloks_group = $mas_data;
      
      return (true);
     }
   
   
   
  }


$obj_htmlbloks=new htmlbloks_class();
/*
Значение "$obj_имя_объекта" - должно быть прописано в конфигурационном
 файле CMS в соответствии с указанными комментариями 
*/

