<?php


class news_class extends base_news_class
  {
   
   function on_iniz_param_modul()//используется в главном модуле для определения нужно ли проверять входящие данные (GET или POST)
     {
      return ($this->iniz_param);
     }
   
   function opred_all_get_data_modul()//функция должна возвращать массив со всеми возможными для данного модуля $_GET переменными
     {
      $mas_get_data=array("newspage","newsarhiv");
      return ($mas_get_data);
     }
   
   function opred_param_modul($m,$k)//должна возвращать следующее
     {
      // 1 - если задан хотябы один параметр, даже если задан не верно. Иначе 0
      
      $rezult=0;
      $param_url=$GLOBALS["param_open_url_union"];
      if (isset($param_url["newspage"]))
        {
         $this->in_params["num_page"]=$param_url["newspage"];
         $rezult=1;
         $this->set_page=true;
        }
      
      if (isset($param_url["newsarhiv"]))
        {
         $this->on_arhiv=true;
         $rezult=1;
         $this->in_params["on_arhiv"]=$param_url["newsarhiv"];
        }
      
      return ($rezult);
     }
   
   function korek_param_modul()//должна возвращать true если все параметры заданны верно, или false - если не верно
     {
      
      if ($this->on_arhiv)
        {
         if ($this->in_params["on_arhiv"]!="on")
           return (false);
        }
      
      if ($this->set_page)
        {
          if (is_numeric($this->in_params["num_page"]))
            {
              $this->open_num_page=$this->in_params["num_page"];
              if ($this->open_num_page <= 0) return (false);
            }
          else
            {
              return (false);
            }
        }
      
      $db_query="select count(*) from ".DB_PREF."news where hide='show' ";
      
      if ($this->on_arhiv)
        $db_query.=" and arhiv='arhiv' ";
       else
         $db_query.=" and arhiv='view' ";
      
      $this->quantity_all_news = db_work::query_count($db_query);
      
      if ($this->quantity_all_news==0)
        {
         if ($this->open_num_page != 1)
           return (false);
        }
       else
         {
          $this->quantity_pages_news=ceil($this->quantity_all_news/$this->kol_news_to_page);
          if ($this->quantity_pages_news < $this->open_num_page)
            return (false);
         }
      
      
      $this->open_this_modul=true;
      
      return (true);
     }
   
   function init_write_data($korekParam,$openModul)
     {
      return(false);
     }
   
   function write_menu_modul()//функция должна выводить массив пунктов/подпунктов
     {
      /*
      новая структура:
      
      каждый элемент должен быть массивом следующего содержания:
      0 - позиция пункта в меню
      1 - данные о пункте - массив содержащий следующее:
        
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      2 - массив с данными о подпунктах,если они есть, иначе false
        каждый подпункт меню, представляет собой массив следующего содержания:
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      
      */
      global $dir_http;
      $set=1;
      if ($this->open_this_modul)
        $set=2;
      $one_punkt=array ("Новости сайта",$dir_http."/news/",$set);
      //$punkts=array();
      //$punkts[]=$one_punkt;
      return ( array(array(50,$one_punkt,false)) );
     }
   
   function add_text_head()// метод должен возращать текст выводимый в заголовке head страницы (дополнительные теги нужные модулю) или false - если текст подключать не надо
     {
      $htext=false;
      
      return ($htext);
     }
   
   function write_soder_modul()//функции передается управление для подготовки вывода в основное содержимое сайта
     {
       /*
       функция должна возвратить массив
       - первый элемент должен содержать заголовок содержимого
       - второй элемент должен содержанть текст основного содержимого
       Например как показано ниже
       */
       $this->title_content = (!$this->on_arhiv ? "Новости сайта" : "Архив новостей сайта");
       $text = "";
       //include_once("news_include.php");
       
       $t_num_page = ($this->open_num_page > 1 ? " - Страница ".$this->open_num_page : "");
       $t_num_page_2 = ($this->open_num_page > 1 ? " страница ".$this->open_num_page : "");
       $this->title_content.=$t_num_page;
       
       $this->page_title=$this->title_content;
       
       $this->page_description = ($this->on_arhiv ? "Архивные новости и события сайта" : "Новости и события сайта").$t_num_page;
       $this->page_keywords = "новости события сайт".($this->on_arhiv ? " архив":"").$t_num_page_2;
       
       global $mas_value_template, $tpl;
       $mas_perem = $mas_value_template;
       
       
       $db_query = "select * from ".DB_PREF."news where hide='show' and ";
       $db_query .= " arhiv='".(($this->on_arhiv) ? "arhiv" : "view")."' ";
       $db_query .= " order by putdate DESC limit "
         .(($this->open_num_page - 1) * $this->kol_news_to_page).", ".$this->kol_news_to_page;
       list($kol_news, $dataNews) = obr_db_query_select_assoc($db_query);
       
       //$link_arhiv = "arhiv/";
       //$kolvo_vsego = 0;
       //$vsego_pages = 0;
       
       $mas_perem["on_arhiv"] = $this->on_arhiv;
       /*
       if ($kol_news)
         {
           $db_query = "select count(*) from ".DB_PREF."news where hide='show' and ";
           $db_query .= " arhiv='".(($this->on_arhiv) ? "arhiv" : "view")."' ";
           $kolvo_vsego = obr_db_query_count($db_query);
           
           $vsego_pages = ceil($kolvo_vsego / $this->kol_news_to_page);
           
         }
       */
       $mas_perem["kol_news"] = $kol_news;
       $mas_perem["dataNews"] = $dataNews;
       //$mas_perem["link_arhiv"] = $link_arhiv;
       
       $mas_perem["kolvo_vsego"] = $this->quantity_all_news;
       $mas_perem["vsego_pages"] = $this->quantity_pages_news;
       $mas_perem["num_page"] = $this->open_num_page;
       
       $tpl->template_dir = $this->dir_template_mfile."/";
       
       $tpl->assign($mas_perem);
       $text .= $tpl->fetch("page_news.html");
       
       
       $this->text_content = $text;
       
       $rez = array("t0" => $this->title_content, "t1" => $this->text_content);
       return ($rez);
     }
   
   function write_modul_title_meta()
     {
      //функция должна возвращать массив с  текстом тега <title> - то есть заголовок страницы
      // и содержимым мета-тегов description и keywords
      
      /*
      if ($this->on_arhiv)
        $mas["title"]="Архив новостей сайта";
       else
         $mas["title"]="Новости сайта";
      */
      $mas=array("title"=>$this->page_title,"description"=>$this->page_description,"keywords"=>$this->page_keywords);
      
      return ($mas);
     }
   
   function write_content_modul($name_part_write)// функция возвращает контент в виде HTML-кода (то есть текст), если вообще выводит (on_write_content_modul() должна возвращать true) в отдельном блоке на странице
     {
      $array_text=array();
      global $masConfig,$obj_eng_cfg_tpl;
      if ($masConfig["NEWS_ON_VIEW_SHORT_LIST"] == 1)
        {
          $mas_check = $obj_eng_cfg_tpl->check_part("news", $name_part_write);
          
          //write_log_cms($mas_check,"Модуль Новости сайта. Область ".$name_part_write);
          
          if ($mas_check == false)
            {
              return ($array_text);
            }
          
          //if (!$this->open_this_modul)
          if (isset($mas_check["boxNewsLast"]) && $mas_check["boxNewsLast"] !== false)
            {
              $text = "";
              
              $db_query = "select * from ".DB_PREF."news where hide='show' && arhiv='view' order by putdate DESC limit ".$this->quantity_items_preview;
              list($kol_news, $dataNews) = obr_db_query_select_assoc($db_query);
              
              global $mas_value_template, $tpl;
              $mas_perem = $mas_value_template;
              $mas_perem["kol_news"] = $kol_news;
              $mas_perem["dataNews"] = $dataNews;
              $tpl->template_dir = $this->dir_template_mfile."/";
              
              $tpl->assign($mas_perem);
              $text .= $tpl->fetch("box_news_last.html");
              $array_text[] = array($mas_check["boxNewsLast"], $text);
            }
        }
      
      return ($array_text);
     }
   
   function write_glav_page()//функция должна возвращать HTML-код для главной страницы ( если модуль конечно же выводит эти данные)
     {
      $text="";
      
      
      $db_query="select * from ".DB_PREF."news where hide='show' && arhiv='view' order by putdate DESC limit ".$this->quantity_items_preview;
      list($kol_news,$dataNews)=obr_db_query_select_assoc($db_query);
      
      
      global $mas_value_template,$tpl;
      $mas_perem = $mas_value_template;
      $mas_perem["kol_news"]=$kol_news;
      $mas_perem["dataNews"]=$dataNews;
      $tpl->template_dir = $this->dir_template_mfile."/";
      
      $tpl->assign($mas_perem);
      $text .= $tpl->fetch("news_main_page.html");
      
      return ($text);
     }
   
   
   
  }


$obj_news=new news_class();
/*
Значение "$obj_имя_объекта" - должно быть прописано в конфигурационном
 файле CMS в соответствии с указанными комментариями 
*/

