<?php

class base_subscribe_class extends class_main_modul_part
  {
   var $name_modul = "subscribe";
   
   var $iniz_param;// проверять ли инициализацию входящих данных
   var $menu_includ;// влючается ли в меню пункты из данного модуля
   var $param_get_subscribe;
   var $param_get_deletsub;
   var $param_get_activsub;
   var $param_get_codesub;
   var $set_page_delete=false;
   var $set_page_activ=false;
   var $on_subscribe=false;//просматривается данный модуль (рассылка) (true) или нет (false)
   var $zagolov_osnov_soder="";
   var $text_osnov_soder="";
   var $dbcnx;
   var $new_email="";
   var $new_name="";
   var $error_new_subscribe=false;
   var $on_view_form=false;
   var $mas_error_alert=array();
   var $text_error_new_subscribe="";
   
   var $error_activ_email=false;
   var $on_activ_email=false;
   
   var $delete_email="";
   var $error_delete_email=false;
   var $text_error_delete_email="";
   var $on_delete_email=false;
   
   var $open_this_modul=false;
   
   function construct_main()
     {
      $this->iniz_param=true;
      $this->menu_includ=false;
      
      global $dir_http,$dir_cms,$dir_template,$dir_http_template;
      //$this->dbcnx=$dbcnx;
	  //$this->nameSite=NAME_SITE;
	  //$this->korekParam=false;
      $this->dir_http=$dir_http;
      $this->dir_cms=$dir_cms;
      $this->dir_template = $dir_template;
      $this->dir_http_template=$dir_http_template;
      $this->dir_template_modul = $this->dir_template."/moduls/subscribe";
      $this->dir_http_template_modul = $this->dir_http_template."/moduls/subscribe";
      $this->dir_template_mfile = $this->dir_template_modul."/mtemplates";
      
     }
   
   function on_iniz_to_glav_modul($dbcnx)//метод получает идентификатор соединения с базой данных, метод должден возвращать: 0 - если это независимый модуль, 1 - модуль используется совместно с главным модулем
     {
      $this->dbcnx=$dbcnx;
      return (0);
     }
   
   function on_menu_modul()//функция должна выводить true если модуль включает свои пункты в меню или false если нет (только для независимых модулей)
     {
      return (false);
     }
   
   function on_write_content_modul()//функция возвращает массив с именами областей, в которых модуль выводит контент, или false, если не выводит дополнительный контент
     {
       $v=true;
       global $obj_eng_cfg_tpl;
       $obj_eng_cfg_tpl->init_data_modul("subscribe");
       $v=$obj_eng_cfg_tpl->get_list_part_modul("subscribe");
       
       return ($v);
     }
   
   function on_css_modul()//функция должна возращать true если модуль использует CSS (файл CSS должен быть в папке модуля) либо false в ином случае
     {
      return (true);
     }
   
   function on_write_glav_page()//функция должна возвращать true если модуль выводит данные на главной странице
     {
      return (false);
     }
   
   function set_status_send_news($id_news,$v_status,$number_sent)
     {
      //$v_status - true или false
      $db_query="update ".DB_PREF."subscribe_news set status='".($v_status?"onsend":"error")."', sent_date=". time_cms() .","//putdate заменен на sent_date. v 23.1.1
        ." number_sent=".$number_sent . " "
        ." where id_news = ".$id_news." ";
      db_work::query($db_query);
     }
   
   function add_new_user()
     {
       $res_data=$this->_add_new_user();
       //write_log_cms($res_data,"subscribe new user res_data");
       
       return ($res_data);
     }
   
   protected function _add_new_user()
     {
       global $masConfig,$obj_control_data;
       
       $error=false;
       $mas_errors=[];
       $data_user=["name"=>"", "email"=>"", "on_consent"=>""];
       $exist_user=false;
       $on_add=false;
       
       $res_data=["error"=>$error, "mas_errors"=>$mas_errors, "on_data"=>false, "exist_user"=> $exist_user, "on_add"=>$on_add, "data_user"=>$data_user];
       
       $mas = array(
        array("name_subscribe", "post", "name_subscribe", "text", true, true, false, "", true, "tr", "all", "", "Не указано имя!", true, false),
        array("email_subscribe", "post", "email_subscribe", "text", true, true, "function", "check_data_email", true, "tr", "no_value", "", "Не указан Email!", true, "Указан некорректный Email!"),
        array("new_subs", "post", "new_subs", "text", true, true, "value", "nDf81kKbn3x", true, "tr", "all", "", "Ошибка с данными!", true, true),
       );
       
       if ($masConfig["SUBSCRIBE_ON_USE_CONSENT"] == 1)
         $mas[] = array("on_consent", "post", "on_consent", "text", true, true, "value", "on", true, "tr", "all", "", "Вы не согласились с обработкой персональных данных!", true, false);
       
       $rez_control_data = $obj_control_data->processing_one_group($mas);
       $mas_inbox = $rez_control_data[3];
       $mas_status = $rez_control_data[5];
       
       if (!$rez_control_data[0]) return ($res_data);
       
       $new_name = $mas_inbox["name_subscribe"];
       $new_email = $mas_inbox["email_subscribe"];
       
       $data_user=[
         "name"=>$mas_inbox["name_subscribe"],
         "email"=>$mas_inbox["email_subscribe"],
         "on_consent"=>$mas_inbox["on_consent"] ?? ""
       ];
       
       if ($rez_control_data[1])
         {
           $error=true;
           $mas_errors=$rez_control_data[4];
         }
       
       if (!$error)
         {
           $db_query = "select count(*) from ".DB_PREF."subscribe_users where email='".codeText($new_email)."' ";
        
           $kol_email = db_work::query_count($db_query);
           if ($kol_email != 0)
             {
               $exist_user=true;
             }
           else
             {
               
               $kod_email = md5(time() . "subs_user");
               
               $db_query = "insert into ".DB_PREF."subscribe_users values (0,'".codeText($new_name)."','".codeText($new_email)."','inactive',
                  ".$GLOBALS["timeGlobal"].",'$kod_email') ";
               db_work::query($db_query);
               
               $new_id = db_work::get_insert_id();
               global $dir_http, $url_site;
               
               $url_page = $url_site."/?m=subscribe&activsub=".$new_id."&codesub=".$kod_email;
               
               $mas_perem = array();
               $mas_perem["url_site"] = $url_site;
               $mas_perem["url_page"] = $url_page;
               
               $subject = $masConfig["SUBSCRIBE_TITLE_EMAIL_ACTIV_ACCOUNT"];
               
               /*$message="Здравствуйте!<br>\n"
                 ."Вы (или кто-то от Вашего имени) подписались на рассылку сайта <a href='".$url_site."'>".$url_site."</a>.\n"
                 ."Если вы хотите подтвердить свою подписку, то вам нужно перейти по ссылке<br>\n"
                 ."<a href='".$url_page."'>".$url_page."</a> .<br>\n"
                 ."Если вы не подписывались на рассылку данного сайта, то просто проигнорируйте это письмо."
                 .forming_signature_email();*/
               
               $message = $masConfig["SUBSCRIBE_TEXT_EMAIL_ACTIV_ACCOUNT"];
               $message = replace_perem_texthablon($message, "{", "}", $mas_perem);
               $message .= forming_signature_email();
               
               send_email($subject, $message, "", $new_email, false, false, false, false, true);
               
               $on_add=true;
             }
         }
       
       $res_data=["error"=>$error, "mas_errors"=>$mas_errors, "on_data"=>true, "exist_user"=> $exist_user, "on_add"=>$on_add, "data_user"=>$data_user];
       
       return ($res_data);
     }
   
  }




