<?php


class subscribe_class extends base_subscribe_class
  {
   
   function on_iniz_param_modul()//используется в главном модуле для определения нужно ли проверять входящие данные (GET или POST)
     {
      return ($this->iniz_param);
     }
   
   function opred_all_get_data_modul()//функция должна возвращать массив со всеми возможными для данного модуля $_GET переменными
     {
      $mas_get_data=array("subscribe","deletsub","activsub","codesub");
      return ($mas_get_data);
     }
   
   function opred_param_modul($m,$k)//должна возвращать следующее
     {
      // 1 - если задан хотябы один параметр, даже если задан не верно. Иначе 0
      
      $rezult=0;
      $param_url=$GLOBALS["param_open_url_union"];
      
      if (isset($param_url["deletsub"]))
         {
          $this->param_get_deletsub=$param_url["deletsub"];
          $rezult=1;
          $this->set_page_delete=true;
         }
      
      if (isset($param_url["activsub"]))
        {
         $this->set_page_activ=true;
         $rezult=1;
         $this->param_get_activsub=$param_url["activsub"];
        }
      
      if (isset($param_url["codesub"]))
        {
         $this->set_page_activ=true;
         $rezult=1;
         $this->param_get_codesub=$param_url["codesub"];
        }
      
      return ($rezult);
     }
   
   function korek_param_modul()//должна возвращать true если все параметры заданны верно, или false - если не верно
     {
      global $masConfig,$obj_control_data;
      
      if ($this->set_page_delete && $this->set_page_activ) return (false);
      
      if ($this->set_page_delete)
        {
         if ($this->param_get_deletsub!="on") return (false);
         if (isset($_POST["delemail_subscribe"]))
           {
            $this->delete_email=trim($_POST["delemail_subscribe"]);
            
            if ($this->delete_email=="")
              {
               $this->error_delete_email=true;
               //$this->text_error_delete_email="Ошибка! Не указан E-mail!";
               $this->mas_error_alert[]="Не указан E-mail!";
              }
            
            if (!$this->error_delete_email && !check_data_email($this->delete_email))
              {
               $this->error_delete_email=true;
               $this->mas_error_alert[]="Указан некорректный Email!";
              }
            
            if (!$this->error_delete_email)
              {
               
               $db_query="select count(*) from ".DB_PREF."subscribe_users where email='".codeText($this->delete_email)."'";
               $kol_delet_email = db_work::query_count($db_query);
               
               if ($kol_delet_email!=0)
                 {
                  $db_query="delete from ".DB_PREF."subscribe_users where email='".codeText($this->delete_email)."'";
                  $q_result = db_work::query($db_query);
                  
                  $this->on_delete_email=true;
                 }
               
               global $obj_site;
               if ( $obj_site->cancel_subscribe_user_email($this->delete_email) )
                 $this->on_delete_email = true;
               
               if ( !$this->on_delete_email )
                 {
                  $this->error_delete_email=true;
                  $this->mas_error_alert[]="Указаный Вами E-mail не найден в базе!";
                 }
                else
                  {
                   $this->delete_email = "";
                  }
               
              }
            
           }
         
         $this->open_this_modul=true;
         return (true);
        }
      
      if ($this->set_page_activ)
        {
         if ($this->param_get_activsub=="" || $this->param_get_codesub=="" || !is_numeric($this->param_get_activsub)
           || !preg_match("/^[0-9a-zA-Z]+$/i",$this->param_get_codesub) )
           {
            $this->error_activ_email=true;
           }
          else
            {
             $db_query="select count(*) from ".DB_PREF."subscribe_users where id_user=".$this->param_get_activsub." and kod_active='".codeText($this->param_get_codesub)."' and status='inactive' ";
             
             $kol_rows = db_work::query_count($db_query);
             
             if ($kol_rows==1)
               {
                $db_query="update ".DB_PREF."subscribe_users set status='active',kod_active=0 where id_user=".$this->param_get_activsub." and kod_active='".codeText($this->param_get_codesub)."' ";
                
                $q_result = db_work::query($db_query);
                $this->on_activ_email=true;
                
               }
              else
                {
                 $this->error_activ_email=true;
                }
             
            }
         
         $this->open_this_modul=true;
         return (true);
        }
      
      if (!$this->set_page_delete && !$this->set_page_activ)
        {
          $this->open_this_modul=true;
          
          $this->on_view_form=true;
          
          /*
          $data_proc=$this->add_new_user();
          
          if ( !$data_proc["on_data"] ) return (true);
          
          $error=$data_proc["error"];
          //$mas_errors=$data_proc["mas_errors"];
          
          $data_new_user=$data_proc["data_user"];
          
          $this->new_name=$data_new_user["name"];
          $this->new_email=$data_new_user["email"];
          
          if ($error)
            {
              $this->error_new_subscribe=true;
              $this->mas_error_alert=$data_proc["mas_errors"];
            }
          
          if (!$error)
            {
              
              if ($data_proc["exist_user"])
                {
                  $this->error_new_subscribe=true;
                  $this->mas_error_alert[]="Такой E-mail уже есть в базе!";
                }
              
              if ($data_proc["on_add"])
                {
                  $this->on_view_form=false;
                }
            }
          
          */
          
         }
      
      $this->open_this_modul=true;
      
      return (true);
     }
   
   function init_write_data($korekParam,$openModul)
     {
      return(false);
     }
   
   function write_menu_modul()//функция должна выводить массив пунктов/подпунктов
     {
      /*
      новая структура:
      
      каждый элемент должен быть массивом следующего содержания:
      0 - позиция пункта в меню
      1 - данные о пункте - массив содержащий следующее:
        
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      2 - массив с данными о подпунктах,если они есть, иначе false
        каждый подпункт меню, представляет собой массив следующего содержания:
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      */
      
      return (false);
     }
   
   function add_text_head()// метод должен возращать текст выводимый в заголовке head страницы (дополнительные теги нужные модулю) или false - если текст подключать не надо
     {
      $htext=false;
      
      return ($htext);
     }
   
   function write_soder_modul()//функции передается управление для подготовки вывода в основное содержимое сайта
     {
      /*
      функция должна возвратить массив
      - первый элемент должен содержать заголовок содержимого
      - второй элемент должен содержанть текст основного содержимого
      Например как показано ниже
      */
      
      $text="";
      $title_text="";
      
      include_once("subscribe_include.php");
      
      $rez=array("t0"=>$title_text, "t1"=>$text);
      
      return ($rez);
     }
   
   function write_modul_title_meta()
     {
      //функция должна возвращать массив с  текстом тега <title> - то есть заголовок страницы
      // и содержимым мета-тегов description и keywords
      $mas=array("title"=>"","description"=>"","keywords"=>"");
      $name="";
      if ($this->set_page_delete)
        $name="Отписаться от рассылки";
       elseif ($this->set_page_activ)
         $name="Подтверждение E-mail для рассылки";
       else
         $name="Подписка на рассылку";
      
      $mas=array("title"=>$name,"description"=>$name,"keywords"=>$name);
      
      return ($mas);
     }
   
   function write_content_modul($name_part_write)// функция возвращает контент в виде HTML-кода (то есть текст), если вообще выводит (on_write_content_modul() должна возвращать true) в отдельном блоке на странице
     {
      $array_text=array();
      global $masConfig,$obj_eng_cfg_tpl;
      
      if ($masConfig["SUBSCRIBE_ON_VIEW_BLOCK_ADD"] == 1)
        {
          $mas_check = $obj_eng_cfg_tpl->check_part("subscribe", $name_part_write);
    
          //write_log_cms($mas_check,"Модуль рассылка. Область ".$name_part_write);
    
          if ($mas_check == false)
            {
              return ($array_text);
            }
    
          //if (!$this->open_this_modul)
          if (isset($mas_check["boxSubscribe"]) && $mas_check["boxSubscribe"] !== false)
            {
              $text = "";
        
              global $mas_value_template, $tpl, $url_site;
              $mas_perem = $mas_value_template;
              //$mas_perem["kol_stat"]=$kol_stat;
              //$mas_perem["dataStat"]=$dataStat;
              $mas_perem["url_site"] = $url_site;
              $tpl->template_dir = $this->dir_template_mfile."/";
        
              $tpl->assign($mas_perem);
              $text .= $tpl->fetch("box_subscribe.html");
              $array_text[] = array($mas_check["boxSubscribe"], $text);
            }
        }
      
      return ($array_text);
     }
   
   function write_glav_page()//функция должна возвращать HTML-код для главной страницы ( если модуль конечно же выводит эти данные)
     {
      $text="";
      
      return ($text);
     }
   
   
   
   
  }


$obj_subscribe=new subscribe_class();
/*
Значение "$obj_имя_объекта" - должно быть прописано в конфигурационном
 файле CMS в соответствии с указанными комментариями 
*/
