<?php



function BBCodeToHtml($str)
  {
   
   $pr_str="";
   while ($pos_html=mb_strpos($str,"[html]"))
    {
     $is_html=true;
     $textDoHtml=mb_substr($str,0,$pos_html);
     $pr_str.=modulBBCodeToHtml(htmlspecialchars($textDoHtml));
     $pos_EndHtml=mb_strpos($str,"[/html]");
     if ($pos_EndHtml!==false)
       {
  	  $textHtml=mb_substr($str,($pos_html+6),($pos_EndHtml-$pos_html-6));
  	  $lenNewStr=mb_strlen($str)-$pos_EndHtml-7;
  	  $pos_EndHtml+=7;
  	 }
  	 else
  	  {
  	   $pos_EndHtml=mb_strlen($str);
  	   $textHtml=mb_substr($str,($pos_html+6),($pos_EndHtml-$pos_html-6));
  	   $lenNewStr=0;
  	  }
     
     

     $pr_str.="<div class='block_konteiner'><div class='block_html'>".$textHtml."</div></div>";
     $str=mb_substr($str,$pos_EndHtml,$lenNewStr);

    }
   $pr_str.=modulBBCodeToHtml(htmlspecialchars($str));

   return ($pr_str);
  }

function zamenaPerevStrToBr($t)
  {
   $t=preg_replace("/\n/","<br>",$t);
   return ($t);
  }
  
function modulBBCodeToHtml($s)
  {
   //удаляем лишние переводы строк
   
   $s=ereg_replace("\r?\n?(\[list=1\])","\\1",$s);
   //$s=ereg_replace("(\[/list\])\r?\n?","\\1",$s);
   
   $masBB=array ("list","left","center","right","justify","code","html","\*","ul");
   foreach ($masBB as $value)
     {
	  $s=ereg_replace("\r?\n?(\[".$value."\])\r?\n?","\\1",$s);
	  $s=ereg_replace ("\r?\n?(\[/".$value."\])\r?\n?","\\1",$s);
	 }
   //меняем переводы на новую строку в блоке code на <br>
   $s=preg_replace("/\[code\](.*?)\[\/code\]/ies","'[code]'.zamenaPerevStrToBr('\\1').'[/code]'",$s);
   //меняем переводы на новую строку в блоке list и list=1 (то есть в списках) на <br>
   $s=preg_replace("/\[list\](.*?)\[\/list\]/ies","'[list]'.zamenaPerevStrToBr('\\1').'[/list]'",$s);
   $s=preg_replace("/\[list=1\](.*?)\[\/list\]/ies","'[list=1]'.zamenaPerevStrToBr('\\1').'[/list]'",$s);
   
   //меняем во всем другом тексте переводы на новую строку на <p>
   $s=preg_replace("/\r/","",$s);//удаляем если есть символ "\r"
   $s=preg_replace("/\n\n/","<p>",$s);
   $s=preg_replace("/\n/","<br/>",$s);
   
   
   
   $s=preg_replace("/\[b\](.*?)\[\/b\]/is","<span class='text_bold'>\\1</span>",$s);
   $s=preg_replace("/\[tb\](.*?)\[\/tb\]/is","<b>\\1</b>",$s);
   $s=preg_replace("/\[i\](.*?)\[\/i\]/is","<span class='text_italic'>\\1</span>",$s);
   $s=preg_replace("/\[u\](.*?)\[\/u\]/is","<u>\\1</u>",$s);
   $s=preg_replace("/\[s\](.*?)\[\/s\]/is","<strike>\\1</strike>",$s);
   $s=preg_replace("/\[color=(.*?)\](.*?)\[\/color\]/is","<font color='\\1'>\\2</font>",$s);
   
   $s=preg_replace("/\[url=(.*?)\](.*?)\[\/url\]/i","<a href='\\1'>\\2</a>",$s);
   $s=preg_replace("/\[urlnew=(.*?)\](.*?)\[\/urlnew\]/i","<a href='\\1' target='_blank'>\\2</a>",$s);
   $s=preg_replace("/\[email=(.*?)\](.*?)\[\/email\]/i","<a href='\\1'>\\2</a>",$s);
   $s=preg_replace("/\[img=(.*?)\](.*?)\[\/img\]/i","<img src='\\1' alt='\\2'>",$s);
   
   $zagol_code="<div class='zagol_block_code'> Код </div>";
   $s=preg_replace("/\[code\](.*?)\[\/code\]/is","<div class='block_konteiner'>".$zagol_code."<div class='block_code'>\\1</div></div>",$s);
   
   $s=preg_replace("/\[left\](.*?)\[\/left\]/is","<div class='block_konteiner'><div class='block_left'>\\1</div></div>",$s);
   $s=preg_replace("/\[center\](.*?)\[\/center\]/is","<div class='block_konteiner'><div class='block_center'>\\1</div></div>",$s);
   $s=preg_replace("/\[right\](.*?)\[\/right\]/is","<div class='block_konteiner'><div class='block_right'>\\1</div></div>",$s);
   $s=preg_replace("/\[justify\](.*?)\[\/justify\]/is","<div class='block_konteiner'><div class='block_justify'>\\1</div></div>",$s);
   
   $s=preg_replace("/\[\*\]/is","<li>",$s);
   $s=preg_replace("/\[list=1\](.*?)\[\/list\]/si","<ol>\\1</ol>",$s);
   $s=preg_replace("/\[list\](.*?)\[\/list\]/si","<ul>\\1</ul>",$s);
   
   $s=preg_replace("/\[font=(.*?)\](.*?)\[\/font\]/is","<span style='font-family:\\1;'>\\2</span>",$s);
   $s=preg_replace("/\[size=(.*?)\](.*?)\[\/size\]/is","<span style='font-size:\\1px;'>\\2</span>",$s);
   
   //$s=setTextLinkFileDown($s);//замена bb-кода [df] на ссылку, описание и количесво скачиваний
   
   return ($s);
  }
 
function setTextLinkFileDown($s)
  {
   global $dbcnx, $dir_http, $dir_cms, $masConfig, $url_site;
   while (($p_start=mb_strpos($s,"[df]"))!==false)
     {
      if (($p_end=mb_strpos($s,"[/df]"))===false)
        break;
      $p_end1=$p_end+5;
      $p_length=$p_end-$p_start-4;
      $s_start=mb_substr($s,0,$p_start);
      
      $s_end=mb_substr($s,$p_end1,mb_strlen($s)-$p_end1);
      $bb_namefile=mb_substr($s,$p_start+4,$p_length);
      
      $text_downFile="";
      
      if (mb_strpos($bb_namefile,"'")===false && mb_strpos($bb_namefile,'"')===false)
        {
          
          $db_query="select * from ".DB_PREF."downfiles where BINARY namefile='".codeText($bb_namefile)."' ";
          
          list($kol_namefile,$data_files) = obr_db_query_select_assoc($db_query);
          
          
          if ($kol_namefile!=0)
            {
              
              $row = $data_files[0];
              $description_namefile=$row["description"];
              $hitsfile=$row["hitsfile"];
              $link_namefile=$url_site."/downfile.php?down=".$bb_namefile;
              
              $dir_downfiles = DIR_CMS."/".NAME_DIR_DOWNFILES;
              $file_server=$dir_downfiles."/".$row["urlfile"];
              
              if (file_exists($file_server))
                {
                  $size=filesize($file_server);
                  $text_size="";
                  //if ($size)
                    {
                     
                     
                     $text_size = "Размер: ".convSizeByte($size);
                     
                    }
                  $text_downFile="<span class='span_title_description_downfile'>Описание:</span> <span class='span_down_file_description'>".$description_namefile."</span><br><a class='link_down_file' href='$link_namefile' target='_blank'>Скачать</a> <span class='span_down_file_kolvo_load'>$text_size. Количество скачиваний: $hitsfile</span>";
                }
               else
                 $text_downFile="<span class='span_error_down_file'>Обнаружена ошибка. Возможно ссылка устарела.</span>";
            }
           else
             {
              $text_downFile="<span class='span_error_down_file'>Обнаружена ошибка. Возможно ссылка устарела.</span>";
              
             }
        }
       else
         {
          $text_downFile="<span class='span_error_down_file'>Обнаружена ошибка. Ссылка задано неверно. Пожалуйста, обратитесь к администрации сайта, объясните ошибку и укажите данную страницу.</span>";
          
         }
      $s=$s_start."<div class='div_down_file'>".$text_downFile."</div>".$s_end;
     }
   return ($s);
  }
 

