<?php

/*
Архив CMS находится на сайте www.boxcode.ru  
Информацию по установке и использованию CMS можно прочитать на сайте www.boxcode.ru 
*/

class class_base_site
  {
   
   var $dbcnx=false;//идентификатор базы данных
   
   var $nameSite;//название сайта
   
   var $title = "";
   var $description = "";
   var $keywords = "";
   var $data_base_content=array();//массив содержащий данные основного содержимого
   // 0 - заголовок
   // 1 - текст содержимого
   // 2 - дополнительный текст (зарезирвировано)
   // 3 - комментарии (зарезирвировано)
   
   
   var $openModul = "";// главная страница сайта - mainPage, либо название компонента главного модуля, либо название подключаемого модуля
   var $pageModul = "";// стараница модуля. не обязательно использовать. для главной страницы равняется пустой строке
   var $openKeyComponent = "";
   var $korekParam = false;
   
   var $componentGlModul = array();
   
   var $error_baz;
   var $on_moduls=false;//управление модулями - разрешено использование (true) или нет (false)
   var $list_obj_moduls;//массив подключенных модулей
   var $on_glav_modul=false;//флаг определяющий отрыта страница главного модуля (true) или нет (false)
   
   
   var $mas_menu=array();//массив содержащий данные о пунктах меню
   
   var $set_content_gl_modul = array("","","","","","","");//title,description,keywords,заголовок основного содержимого,основной текст и остальные парамтеры - дополнительный текст 
   
   
   var $begin_marker="{::";
   var $end_marker="::}";
   
   
   var $on_avtoriz = false;
   var $user_avtoriz_site=0;
   
   /* переменные модуля облака тегов */
   var $on_modul_metks_text=false;//используется модуль или нет
   
   //var $set_metka_text="";
   
   
   //переменные модуля комментариев
   var $page_comment=1;//страница комментариев
   var $on_submit_message_com=false;//массив с данными для работы модуля
   var $mas_answer_com=array();
   var $mas_from_kol_vsego_com=array();
   var $save_id_comment=-1;
   var $on_save_message_com=false;
   var $is_get_email_guest='no';
   
   private $comts_data_form=array();
   private $comts_error_data_form=false;
   private $comts_mas_error_data=array();
   private $comts_on_submit_form=false;
   
   private $comts_on_save_comnt=false;
   private $comts_save_answ_num_comnt=0;
   
   private $comts_save_id_comnt=0;
   
   var $d_site = "";
   
   var $on_cancel_get_email_comments=false;
   var $value_cancel_get_email_comments="";
   
   var $quantity_message_user_not_read = 0;
   var $on_checked_get_param = false;
   var $on_error_init_get_param_geo = false;
   
   var $seo_data_replace = false;
   var $messenger_user_quantity_msg_not_read=0;
   
   var $obj_comments=false;
   var $obj_subscribe_content=false;
   var $obj_likes_content=false;
   
   protected $dir_http="";
   protected $dir_cms="";
   protected $dir_template = "";
   protected $dir_http_template="";
   public $dir_template_components = "";
   public $dir_template_complement = "";
   
   public $data_reg_num_show_user = [];
   
   function __construct($dbcnx,$nameSite)
     {
      
      $this->dbcnx=$dbcnx;
      $this->nameSite=$nameSite;
      
      $this->korekParam=false;
      $this->error_baz=false;
      
      $this->on_modul_metks_text=ON_METKS_TEXT;//использовать или нет модуль меток
      $this->on_avtoriz = ON_AVTORIZ;
      
      
      
      $this->list_obj_moduls=array();// содержит список массивов, а каждый массив
      // key - название модуля
      // 0 -> имя объекта модуля
      // 1 -> ипользуется ли с главным модулем (0 - нет, 1 - да, "-1" - не определено)
      // 2 -> используется ли при открытии текущей страницы (0 - нет, 1 - да, "-1" - не определено)
      // 3 -> в каком блоке шаблона модуль должен выводить свою информацию (название), если вообще не должен выводить то 0
      // 4 -> название модуля
      // 5 - объект модуля (ссылка на объект)
      // дополнительно дальше в "function inizial_obj_moduls()"
      
      
      
      
      global $dir_http,$dir_cms,$dir_template,$dir_http_template,$dir_template_components,$dir_template_complement;
      $this->dir_http=$dir_http;
      $this->dir_cms=$dir_cms;
      $this->dir_template = $dir_template;
      $this->dir_http_template=$dir_http_template;
      $this->dir_template_components = $dir_template_components;
      $this->dir_template_complement = $dir_template_complement;
      
      $this->construct_part();
      
     }
   
   function construct_part()
     {
      
     }
   
   function first_init_modul()
     {
      
     }
   
   function opredel_avtoriz()//base method
     {
      if ( $this->on_avtoriz )
        {
         
         //проверяем авторизован ли пользователь или нет
         $data_user = session_auth_user::check_auth_user();
         if ( $data_user )
           {
            $this->id_user_avtoriz=$data_user["id_user"];
            $this->name_user_avtoriz=$data_user["name_user"];
            
            $this->user_avtoriz_site=1;
           }
        }
      
     }
   
   function reload_data_user()
     {
      // обновляем данные в переменной $GLOBALS["data_authorize_user"]
      // к примеру после оплаты услуг со счета пользователя
      if ( $GLOBALS["user_to_site"] )
        {
         $db_query = "select * from ".DB_PREF."users where id_user = ".codeText($this->id_user_avtoriz);
         
         list($kol,$data_user) = obr_db_query_select_one_assoc($db_query);
         
         if ( $kol > 0 )
           {
            $GLOBALS["data_authorize_user"] = $data_user;
            
            $this->name_user_avtoriz=$data_user["name_user"];
            session_auth_user::set_session($data_user,false);
           }
         
        }
     }
   
   function inizial_obj_moduls($mass_moduls)
     {
      $this->list_obj_moduls=$mass_moduls;
      $this->on_moduls=true;
      foreach ($mass_moduls as $num_modul => $data_one_moduls)
        {
         
         $set=$data_one_moduls[5]->on_iniz_to_glav_modul($this->dbcnx);
         if ($set==1 || $set==0)
           {
            $this->list_obj_moduls[$num_modul][1]=$set;
           }
        }
      
     }
   
   function init_data_site()
     {
      
      $a = trim(getenv(dw("4855455455055f54854f553554")));
      $this->d_site="";
      
      if ( $a )
       {
        preg_match("/^(".dw("68574574570573")."?:\/\/)?([^\/]+)/i",$a, $m);
        $this->d_site = $m[2];
        $this->d_site = begin_delete_text(dw("77577577").".",$this->d_site);
        
       }
      
     }
   
   
   function first_init_comments()//($page_com,$name_modul,$num_element,$url_param,$on_write=true,$add_comments=true)
     {
       
       if (!$this->obj_comments)
         $this->obj_comments=new eng_comments();
       
       return (true);
     }
  /*
  function check_comments_modul($name_modul,$num_element,$page_com,$url_param,$on_write=true,$add_comments=true)
     {
       $this->first_init_comments();
       
       return (true);
     }
   */
   
   function get_data_comments_modul($name_modul,$num_element,$on_write=true,$add_comments=true,$num_user_author=0,$page_num=1,$url_param="")
     {
      
      $this->first_init_comments();
      
      // Получаем [количество комментариев, комментарии (html-код)]
      $d_comments=$this->obj_comments->write_comments_modul($name_modul,$num_element,$on_write,$add_comments,$num_user_author,$page_num,$url_param);
      
      return ($d_comments);
     }
   
   function get_count_comments_mas_elm($name_modul,$mas_num_elm)
     {
       $this->first_init_comments();
       $d_count=$this->obj_comments->get_count_comments_mas_elm($name_modul,$mas_num_elm);
       
       return ($d_count);
     }
   
   function delete_comments_to_num_element_modul($num_modul,$num_element)
     {
       //функция удаляет комментарии одной записи (статьи, объявления, публикации и т.д.)
       $this->first_init_comments();
       
       $this->obj_comments->delete_comments_one_elm($num_modul,$num_element);
       /*
       $db_query="delete from ".DB_PREF."comments where num_modul=$num_modul and num_element=$num_element_del  ";
       $q_ident=obr_db_query($db_query);
       */
       return (true);
     }
   
   function delete_comments_list_num_element_modul($num_modul,$list_num_element)
     {
       //функция удаляет комментарии нескольких записей (то есть комментарии указанные к статьям, объявлениям, публикациям и т.д.)
       $this->first_init_comments();
       
       $mas_num_elm=explode(",",$list_num_element);
       
       $this->obj_comments->delete_comments_mas_elm($num_modul,$mas_num_elm);
       /*
       $db_query = "delete from ".DB_PREF."comments where num_modul=$num_modul and num_element IN ($list_num_element) ";
       $q_result = db_work::query($db_query);
       */
       return (true);
     }
   
   
   
   function select_name_user_to_list_id($mas_id_user)
     {
      //функция возратит имена (логины) пользователей, указанных в массиве $mas_id_user
      
      //require ("select_name_user_to_list_id.php");
      
      $mas_id_user=array_unique($mas_id_user);
      $list_id_user=implode(",",$mas_id_user);
      
      $db_query="select id_user,name_user from ".DB_PREF."users where id_user in ($list_id_user)  ";
      list($list,$data_user)=obr_db_query_select_assoc($db_query);
      
      $mas_name_user=array();
      
      foreach ($data_user as $row)
        {
         $mas_name_user[$row["id_user"]]=$row["name_user"];
        }
      
      return ($mas_name_user);
     }
   
   function select_data_user_to_list_id($mas_id_user,$data_pole = false,$on_active_user=true)
     {
      // Функция возвратит данные зарегистрированных пользователей, указанных в массиве $mas_id_user
      // необходимые поля нужно указать в параметре $data_pole - текстовой строкой, поля через запятую
      // к примеру "id_user,name_user,date_create,access_admin"
      // если в списке полей не будет id_user, то это поле будет добавлено автоматически
      
      $mas_data_user = array();
      
      $mas_id_user=array_unique($mas_id_user);
      $list_id_user=implode(",",$mas_id_user);
      
      $list_pole = " * ";
      
      if ( $data_pole && is_string($data_pole) && mb_strlen($data_pole) )
        {
         $list_pole = $data_pole;
         if ( mb_strpos($list_pole,"id_user") === false ) $list_pole .= ",id_user";//добавляем поле id_user если его нет в списке
        }
      
      if ( sizeof($mas_id_user) > 0 )
        {
         $db_query = "select ".$list_pole." from ".DB_PREF."users where id_user in (".$list_id_user.") ".($on_active_user ? " and activ_user = 'on' " : "");
         //write_log_cms($db_query);
         list($kolvo,$mas_data_user)=obr_db_query_select_assoc_index($db_query,"id_user");
        }
      
      return ($mas_data_user);
     }
   
   function get_data_one_user_num($num_user,$data_pole=false,$on_active_user=true)
     {
       // Функция возвратит данные пользователя, id которого будет указано в $num_user.
       // Если пользователь не будет найден, то будет возвращено false
       // необходимые поля нужно указать в параметре $data_pole - текстовой строкой, поля через запятую
       // к примеру "id_user,name_user,date_create,access_admin"
       // если в списке полей не будет id_user, то это поле будет добавлено автоматически
       
       $data_user=false;
       
       $list_pole=" * ";
       if ($data_pole && is_string($data_pole))
         {
           $list_pole=$data_pole;
           if (mb_strpos($list_pole,"id_user") === false) $list_pole = "id_user,".$list_pole;
         }
       
       if ($num_user)
         {
           $db_query="select ".$list_pole." from ".DB_PREF."users where id_user = ".$num_user." ".($on_active_user ? " and activ_user = 'on' " : "");
           list($kolvo,$one_data)=db_work::query_select_one_assoc($db_query);
           if ($kolvo == 1) $data_user=$one_data;
         }
       
       return ($data_user);
     }
   
   function save_data_user($id_user,$data_user)
     {
      // меняем данные пользователя
      
      // $data_user - данные для сохранения, кроме id пользователя
      // $id_user - id пользователя, для которого сохраняются данные
      
      $data_user["id_user"] = $id_user;
      
      $db_query = forming_db_query_indexmas(DB_PREF."users",$data_user,"edit","id_user");
      db_work::query($db_query);
      
      return (true);
     }
   
   
   function cancel_subscribe_user_email($email_user)
     {
      
      //require ("cancel_subscribe_user_email.php");
      $on_cancel = false;
      
      $db_query="select count(*) from ".DB_PREF."users where email_user = '".codeText($email_user)."'  ";
      $kolvo = db_work::query_count($db_query);
      
      if ( $kolvo )
        {
         $db_query = "update ".DB_PREF."users set on_subscribe = 'off' where email_user = '".codeText($email_user)."' ";
         $q_result = db_work::query($db_query);
         
         $on_cancel=true;
         
        }
      
      return ($on_cancel);
     }
   
   function check_name_modul($name_modul)
     {
      $vrez = false;
      if ($name_modul)
        {
         if ( !empty($this->list_obj_moduls[$name_modul]) )
           {
            $vrez = true;
           }
        }
      
      return ($vrez);
     }
   
   function intercomCheckModul($name_modul)
     {
      return ($this->check_name_modul($name_modul));
     }
   
   function intercomLink($name_modul,$command = false, $vdata = false)
     {
      $vrez = false;
      if ( $name_modul )
        {
         if ( !empty($this->list_obj_moduls[$name_modul]) )
           {
            $vrez = $this->list_obj_moduls[$name_modul][5]->intercom($command,$vdata);
           }
        }
      
      return ($vrez);
     }
   
   function getObjModul( $name_modul )
     {
      $vrez = false;
      if ( $name_modul )
        {
         if ( !empty($this->list_obj_moduls[$name_modul]) )
           {
            $vrez = &$this->list_obj_moduls[$name_modul][5];
           }
        }
      
      return ($vrez);
     }
   
   function get_info_cms()
     {
      $t = "PGRpdiBzdHlsZT0nZm9udC1zaXplOiAwLjdlbTsgZm9udC1mYW1pbHk6ICJMdWNpZGEgQ29uc29sZSIsIE1vbmFjbywgbW9ub3NwYWNlOyc+LSM"
       ."jIyMtLS0jIy0tLSMjLS0jIyMjPGJyLz4NCiMjLS0jIy0tIyMjLSMjIy0jIzxici8+DQojIy0tLS0tLSMjLSMtIyMtLSMjIyM8YnIvPg0KIyMtLSMjL"
       ."S0jIy0tLSMjLS0tLS0jIzxici8+DQotIyMjIy0tLSMjLS0tIyMtLSMjIyM8YnIvPg0KPGJyLz4NCiMjIyMjLS0tLSMjIyMtLS0jIy0tIyMtLS0jIyM"
       ."jLS0tLSMjIyMtLS0jIyMjIy0tLSMjIyMjPGJyLz4NCiMjLS0jIy0tIyMtLSMjLS0tIyMjIy0tLSMjLS0jIy0tIyMtLSMjLS0jIy0tIyMtLSMjPGJyL"
       ."z4NCiMjIyMjLS0tIyMtLSMjLS0tLSMjLS0tLSMjLS0tLS0tIyMtLSMjLS0jIy0tIyMtLSMjIyM8YnIvPg0KIyMtLSMjLS0jIy0tIyMtLS0jIyMjLS0"
       ."tIyMtLSMjLS0jIy0tIyMtLSMjLS0jIy0tIyM8YnIvPg0KIyMjIyMtLS0tIyMjIy0tLSMjLS0jIy0tLSMjIyMtLS0tIyMjIy0tLSMjIyMjLS0tIyMjI"
       ."yM8L2Rpdj4=";
      
      $t = base64_decode($t);
      
      return ($t);
     }
   
   function formingMainPageModul($name_modul, $param_modul = "")
     {
      $t = "";
      if ( $this->intercomCheckModul( $name_modul ) )
        {
         if ( $param_modul == "" )
           {
            $t = $this->list_obj_moduls[$name_modul][5]->write_glav_page();
           }
          else
            {
             
            }
        }
      
      return ( $t );
     }
   
   function formingBlockModulPageInfoUser($name_modul, $param_modul = "")
     {
      $t = "";
      if ( $this->intercomCheckModul( $name_modul ) )
        {
         $t = $this->list_obj_moduls[$name_modul][5]->formingBlockPageInfoUser( $param_modul );
         if ( $t === false ) $t = "";
         
        }
      
      return ( $t );
     }
   
   function formingBlockModulPageShowUser($name_modul, $param_modul = "")
     {
      $t = "";
      
      $data_user = false;
      if ( !empty($this->data_reg_num_show_user) && sizeof($this->data_reg_num_show_user) )
        $data_user = $this->data_reg_num_show_user;
      
      if ( $this->intercomCheckModul( $name_modul ) )
        {
         $t = $this->list_obj_moduls[$name_modul][5]->formingBlockPageShowUser( $data_user, $param_modul );
         if ( $t === false ) $t = "";
         
        }
      
      return ( $t );
     }
   
   function close_session_user()
     {
      
      $num_user=session_auth_user::clear_session(true);
      
      if ($num_user > 0)
        session_auth_user::save_not_authorize_user($num_user);
     }
   
   function forming_text_client()
     {
      global $data_modul, $open_name_modul, $masConfig, $text_client;
      $this->text_client = "";
      $first_right = get_check_text("4456854853953256b54b54256355653854656d");
      $two_right = get_check_text("76542552545538538570551538579534578");
      $tt = "d059d5d05b55d05b25d05b55d15805d05bd5d1"
        ."58b5d05b95205d05ba5d05be5d05b45205d05bb5d05b85d1"
        ."5865d05b55d05bd5d05b75d05b85d05b8521";
      
      if ( !( $masConfig[dw("53553")] && strpos($masConfig[dw("53553")], md5($first_right.$this->d_site.$two_right) ) !== false || strpos(getenv(dw("5254554d54f55454555f541544544552")),dw("31532537").".") === 0 ) )
        {
         if ( $open_name_modul && $open_name_modul != dw("6356f56e566569567573569574565")  )
           {
            $data_modul = false;
            $text_client = get_check_text($tt);
            $this->text_client = $text_client;
           }
         
        }
      
      return ( $text_client );
     }
   
   function init_quantity_message_user()
     {
      
      if ( $GLOBALS["user_to_site"] && $GLOBALS["id_user_to_site"] > 0 )
        {
         $this->quantity_message_user_not_read = $this->get_quantity_message_user($GLOBALS["id_user_to_site"],"inbox","off");
        }
      
      return (true);
     }
   
   function get_quantity_message_user($num_user,$type_box,$filtr_on_read = false)
     {
      // $type_box : sent - отправленные  или inbox - полученные сообщения
      $quantity = 0;
      //require ("get_quantity_message_user.php");
      $quantity = 0;
      
      $name_pole_user = "";
      $v_type_box = "";
      
      if ( $type_box == "sent" )
        {
         $name_pole_user = "sent_user";
         $v_type_box = "sent";
         
        }
       else
         {
          $name_pole_user = "recipient_user";
          $v_type_box = "inbox";
          
         }
      
      $db_query = "select count(*) from ".DB_PREF."private_message where num_user = ".$num_user." "
        ." and type_box = '".$v_type_box."' "
        .(( $filtr_on_read !== false && ( $filtr_on_read === "on" || $filtr_on_read === "off" ) ) ? " and on_read = '".$filtr_on_read."' " : " " );
      
      $quantity = obr_db_query_count( $db_query );
      
      return ( $quantity );
     }
   
   function messenger_init_quantity_not_read()
     {
       
       if ($GLOBALS["user_to_site"])
         {
           $obj_eng_messenger = new eng_messenger();
           $this->messenger_user_quantity_msg_not_read=$obj_eng_messenger->get_count_message_user_not_read($GLOBALS["id_user_to_site"]);
           
         }
       
       return (true);
     }
   
   function gl_values_cms_add_v($mas_v)
     {
      global $mas_gl_values_cms;
      foreach ( $mas_v as $key => $value )
        {
         $mas_gl_values_cms[$key] = $value;
         
        }
     }
   
   function gl_values_cms_get_v($name_v,$default_v="")
     {
      global $mas_gl_values_cms;
      $v = (isset($mas_gl_values_cms[$name_v]) ? $mas_gl_values_cms[$name_v] : $default_v);
      
      return ($v);
     }
   
   function gl_values_cms_get_all_v()
     {
      global $mas_gl_values_cms;
      return ($mas_gl_values_cms);
     }
   
   function protection_account_check($ip_adr,$name_user)
     {
      $on_blocked=false;
      $quant_attempts=0;
      
      $db_query="select * from ".DB_PREF."authorization "
        ." where "
        ." ip_adr='".codeText($ip_adr)."' and name_user='".codeText($name_user)."' and "
        ." ( (put_date>".($GLOBALS["timeGlobal"]-20)." and enter='off' and blocked='off') "
        ." or (put_date>".($GLOBALS["timeGlobal"]-5*60)." and blocked='on' ))";
      
      list($kolvo,$data)=db_work::query_select_assoc($db_query);
      if ($kolvo > 0)
        {
         $m_blocked=select_mas_2level($data,"blocked","on",false);
         $quant_blocked=sizeof($m_blocked);
         if ( $quant_blocked > 0)
           {
            $on_blocked=true;
            $quant_attempts=$kolvo-$quant_blocked;
           }
          else
            {
             $quant_attempts=$kolvo;
            }
        }
      
      return (array($on_blocked,$quant_attempts));
     }
   
   function protection_account_add($blocked,$ip_adr,$name_user,$num_user,$enter,$point)
     {
      
      $d_save=array("id_authorization"=>0,
        "name_user"=>$name_user,
        "num_user"=>$num_user,
        "ip_adr"=>$ip_adr,
        "put_date"=>$GLOBALS["timeGlobal"],
        "blocked"=>$blocked,
        "enter"=>$enter,
        "point"=>$point
       );
      
      $db_query=forming_db_query_indexmas(DB_PREF."authorization",$d_save,"new","id_authorization");
      db_work::query($db_query);
      
     }
   
   function protection_account_clear()
     {
      // очищаем историю авторизаций
      // время хранения будет отличатся в зависимости от необходимости:
      // попытки входа неудачные, заблокированные, авторизация обычных пользователй и администраторов
      $db_query="delete from ".DB_PREF."authorization where "
        ." (blocked='off' and enter='off' and put_date < ".($GLOBALS["timeGlobal"]-10*24*3600).") "
        ." or (blocked='on' and put_date < ".($GLOBALS["timeGlobal"]-100*24*3600).") "
        ." or (enter='on' and put_date < ".($GLOBALS["timeGlobal"]-150*24*3600).") and ( name_user NOT IN (select name_user from ".DB_PREF."users where (access_admin = 'on' or access_admin = 'sadmin')) )"
        ." or (enter='on' and put_date < ".($GLOBALS["timeGlobal"]-200*24*3600).") and ( name_user IN (select name_user from ".DB_PREF."users where (access_admin = 'on' or access_admin = 'sadmin')) )";
      db_work::query($db_query);
      
      return (true);
     }
   
   public static function check_param_open_url()
     {
      global $dir_http,$dir_cms;
      
      $url_str=false;
      
      if (isset($_GET["url_str"])) $url_str=$_GET["url_str"];
      
      if (!empty($_SERVER) && !empty($_SERVER["REQUEST_URI"]))
        {
         $request_uri=$_SERVER["REQUEST_URI"];
         
         if ($request_uri == $dir_http."/index.php")
           {
            sendheader::location($dir_http."/");
            exit();
           }
         
         //ищем в $request_uri index.php, если есть, значит строчка содержит не только index.php и другой текст, к примеру index.php/text или index.php?text
         // выдаем ошибку 404
         // и ищем в $request_uri строчку url_str - если есть, выдаем ошибку 404
         if (strpos($request_uri,"index.php") !== false || strpos($request_uri,"?url_str") !== false || strpos($request_uri,"&url_str") !== false )
           {
             $url_str="error_not_found";
           }
         
        }
      
      global $mas_init_check_search_url_adr;
      
      global $mas_init_check_ident_url_adr;
      
      $mas_init_check_search_url_adr["mainModul"]=array("punkt","page","stpoisk","metka","registr",
        "add_money","payment_balance","success_payment","fail_payment","modcom",
        "message","on_sent.html","sitemap","downfile.php","messenger","mesngr"
       );
      
      global $mas_init_sitemap;
      $mas_name_moduls=array_keys($mas_init_sitemap);
      
      $mas_init_check_ident_url_adr["mainModul"]=array(
        
        //^sitemapindex.xml$ sitemapindex.php
        array('#^sitemapindex\.xml$#',false,array("w"=>"sitemapindex"),array(),true,$mas_name_moduls),//array("article","ishop")
        //^sitemap_m_([a-zA-Z0-9]+).xml$ sitemap_modul.php?m=$1
        array('#^sitemap_m_([a-zA-Z0-9]+)\.xml$#',false,array("w"=>"sitemap_modul"),array("mod"=>1),true,$mas_name_moduls),//array(/*"doska","catalog",*/"article","ishop")
        //^sitemap_m_([a-zA-Z0-9]+)_([0-9]+).xml$ sitemap_modul.php?m=$1&num=$2
        array('#^sitemap_m_([a-zA-Z0-9]+)_([0-9]+)\.xml$#',false,array("w"=>"sitemap_modul"),array("mod"=>1,"num"=>2),true,$mas_name_moduls),//array("article","ishop")
        //downfile.php
        array('#^downfile\.php$#',false,array("w"=>"downfile"),array(),true,array()),
        
        array('#^punkt([0-9]+)/?$#',true,array("m"=>"grup","k"=>"punkt"),array("num_punkt"=>1)),
        array('#^punkt([0-9]+)/npage([0-9]+)/?$#',false,array("m"=>"grup","k"=>"punkt"),array("num_punkt"=>1,"numpage"=>2)),//^punkt([0-9]+)/npage([0-9]+)/?$ index.php?m=grup&k=$1&numpage=$2
        array('#^page([0-9]+)\.html$#',false,array("m"=>"stat","k"=>"item"),array("num_item"=>1)),//^page([0-9]+)\.html$ index.php?m=stat&k=$1
        //array('#^stpoisk/?$#',true,array("m"=>"stpoisk"),array()),//^stpoisk/?$ index.php?m=stpoisk
        //array('#^metka/(.*)/$#',true,array("m"=>"setmetka"),array("k"=>1)),//^metka/(.*)/$ index.php?m=setmetka&k=$1
        
        array('#^registr/?$#',true,array("m"=>"registr","k"=>"add_new"),array()),
        array('#^registr/exitavt/?$#',true,array("m"=>"registr","k"=>"exit_account"),array()),//^registr/exitavt/?$ index.php?m=registr&exitavt=on
        array('#^registr/activ/?$#',true,array("m"=>"registr","k"=>"activ_account"),array()),
        array('#^registr/inforeg/?$#',true,array("m"=>"registr","k"=>"info_profile"),array()),//^registr/inforeg/?$ index.php?m=registr&inforeg=on
        array('#^registr/regrepair/?$#',true,array("m"=>"registr","k"=>"repair_pas"),array()),//^registr/regrepair/?$ index.php?m=registr&regrepair=on
        array('#^registr/user([0-9]+)\.html$#',false,array("m"=>"registr","k"=>"show_user"),array("num_user"=>1)),//^registr/user([0-9]+).html$ index.php?m=registr&showuser=$1
        array('#^registr/enter/?$#',true,array("m"=>"registr","k"=>"enter"),array()),//^registr/enter/?$ index.php?m=registr&enter=on
        
        array('#^add_money/?$#',true,array("m"=>"money","k"=>"add_money"),array()),//^add_money/?$ index.php?m=money&add_money=on
        array('#^payment_balance/?$#',false,array("m"=>"money","k"=>"payment_balance"),array()),//^payment_balance/?$ index.php?m=money&payment_balance=on
        array('#^success_payment\.html$#',false,array("m"=>"money","k"=>"success_payment"),array()),//^success_payment\.html$ index.php?m=money&success_payment=on
        array('#^fail_payment\.html$#',false,array("m"=>"money","k"=>"fail_payment"),array()),//^fail_payment\.html$ index.php?m=money_fpayment&fail_payment=on
        
        /*
        array('#^my_message/?$#',true,array("m"=>"message","type"=>"showin"),array()),//^my_message/?$ index.php?m=message&type=showin
        array('#^sd_message/?$#',true,array("m"=>"message","type"=>"showsend"),array()),//^sd_message/?$ index.php?m=message&type=showsend
        array('#^send_message_([0-9]+)\.html$#',false,array("m"=>"message","send"=>"on"),array("num_user"=>1)),//^send_message_([0-9]+).html$ index.php?m=message&send=on&num_user=$1
        array('#^show_message_([0-9]+)\.html$#',false,array("m"=>"message"),array("num_message"=>1)),//^show_message_([0-9]+).html$ index.php?m=message&num_message=$1
        array('#^on_sent\.html$#',false,array("m"=>"message","on_sent"=>"on"),array()),//^on_sent.html$ index.php?m=message&on_sent=on
        */
        array('#^messenger/?$#',true,array("m"=>"messenger","k"=>"messenger_all"),array()),
        array('#^messenger/npage([0-9]+)\.html$#',false,array("m"=>"messenger","k"=>"messenger_all"),array("num_page"=>1)),
        array('#^mesngr_u([0-9]+)$#',false,array("m"=>"messenger","k"=>"messenger_user"),array("num_user"=>1)),
        
        
       );
      
      $on_search=false;
      $search_name_modul=array();
      
      $on_addit=false;
      $list_name_modul=false;
      
      foreach ($mas_init_check_search_url_adr as $name_modul => $d_modul)
        {
         if (!($name_modul == "mainModul" || work_init_moduls::check_use_modul($name_modul))) continue;
         foreach ($d_modul as $v_key)
           {
            if (strpos($url_str,$v_key) !== false)
              {
               $on_search=true;
               $search_name_modul[]=$name_modul;
               continue 2;
              }
           }
         
        }
      
      
      $on_check_url=false;
      $data_url=array();
      if ($on_search)
        {
         foreach ($search_name_modul as $name_modul)
           {
            if (empty($mas_init_check_ident_url_adr[$name_modul])) continue;
            $list_ident=$mas_init_check_ident_url_adr[$name_modul];
            foreach ($list_ident as $one_ident)
              {
               if (preg_match($one_ident[0],$url_str,$matches))
                 {
                  $on_check_url=true;
                  
                  $GLOBALS["param_open_url_modul"]=$name_modul;
                  
                  if (!empty($one_ident[1]))
                    {
                     if (strpos($url_str,"/",strlen($url_str)-1) === false)
                       {
                        
                        sendheader::location($dir_http."/".$url_str."/",true);
                        exit();
                       }
                    }
                  
                  if (!empty($one_ident[2]))
                    {
                     foreach ($one_ident[2] as $one_key=>$one_v) $data_url[$one_key]=$one_v;
                    }
                  
                  if (!empty($one_ident[3]))
                    {
                     foreach ($one_ident[3] as $one_key=>$one_v)
                       {
                        $vv="";
                        if (isset($matches[$one_v])) $vv=$matches[$one_v];
                        $data_url[$one_key]=$vv;
                       }
                    }
                  
                  if (!empty($one_ident[4]) && $one_ident[4])
                    {
                     $on_addit=true;
                    }
                  
                  if (!empty($one_ident[5]) && $one_ident[5] && is_array($one_ident[5]))
                    {
                     $list_name_modul=$one_ident[5];
                    }
                  
                  break 2;
                 }
              }
           }
        }
      
      if ($url_str && sizeof($data_url) == 0) $data_url["smgeo"]=$url_str;
      
      $GLOBALS["param_open_url_str"]=$url_str;
      $GLOBALS["param_open_url_init"]=$data_url;
      
      $GLOBALS["param_open_url_union"]=$data_url;
      if (isset($_GET)) $GLOBALS["param_open_url_union"]=array_merge($GLOBALS["param_open_url_union"],$_GET);
      
      return (array($on_addit,$list_name_modul));
     }
   
   public function work_addit_open_url()
     {
      
      if ($GLOBALS["param_open_url_modul"] == "mainModul")
        {
         $this->work_mainModul_addit_open_url();
        }
       else
         {
          $this->list_obj_moduls[$GLOBALS["param_open_url_modul"]][5]->work_addit_open_url();
         }
      
     }
   
   public function work_mainModul_addit_open_url()
     {
      global $obj_control_data;
      
      $mas_init_p=array(
        "sitemapindex"=>array(),
        "sitemap_modul"=>array(
          array("mod","mas","mod","text",true,true,false,"",true,false,"all",""),
          array("num","mas","num","numeric:int:positive",false,false,false,"",true,false,"all",0)
         ),
        
        "downfile"=>array(
          array("down","mas","downname","text",true,true,"hablonrv",'/^[a-zA-Z0-9\-\_]+$/',true,false,"all","")
         ),
        
       );
      
      $w="";
      $error=0;
      $error_text="";
      $mas_inbox=array();
      $mas_status=array();
      
      $w_answer=false;
      $w_data=false;
      
      if (isset($GLOBALS["param_open_url_union"]["w"]))
        $w=$GLOBALS["param_open_url_union"]["w"];
      
      if ($w && isset($mas_init_p[$w]))
        {
         
         if (sizeof($mas_init_p[$w]) > 0)
           {
            $rez_control_data=$obj_control_data->processing_one_group($mas_init_p[$w],$GLOBALS["param_open_url_union"]);
            
            if ( !$rez_control_data[1] )//$rez_control_data[0]
              {
               $mas_inbox=$rez_control_data[3];
               $mas_status = $rez_control_data[5];
              }
             else
               {
                $error=2;
               }
           }
        }
       else
         {
          $error=2;
         }
      
      if ($w && $error==0)
        {
         include_once(DIR_COMPLEMENT."w_".$w.".php");
        }
       else
         {
          $error=2;
          $error_text="Неверный запрос!";
         }
      
      eng_answer::v_user_addit($error,$error_text,$w_answer,$w_data);
      
     }
   
   public function check_comment_elem($name_modul,$num_element)
     {
       $data_check=[
         "on_add_comment" => false,
         "data_elm"=>false
       ];
       
       $kolvo=0;
       
       if ($name_modul == "punkt")
         {
           $db_query = "select * from ".DB_PREF."components " 
            ." where id_component=".$num_element." and hide='show' and modul = 'punkt' "
            ." and on_comments='on' and add_comments='on' ";
           
           list($kolvo, $data_component) = db_work::query_select_one_assoc($db_query);
           
           if ($kolvo > 0)
             {
               $data_elm=[];
               $data_elm["id"]=$data_component["id_component"];
               $data_elm["num_user"]=$data_component["num_user"];
               $data_elm["name"]=$data_component["name"];
               $data_elm["url_page"]="/punkt" . $data_component["id_component"] ."/";
               
               $data_check["on_add_comment"] = true;
               $data_check["data_elm"] = $data_elm;
             }
         }
        elseif ($name_modul == "stat")
          {
            $db_query="select * from ".DB_PREF."components "
             ." where id_component=".$num_element." && hide='show' && modul = 'stat' "
             ." and on_comments='on' and add_comments='on' ";
            
            list($kolvo, $data_component) = db_work::query_select_one_assoc($db_query);
            
            if ($kolvo > 0)
              {
                $data_elm = [];
                $data_elm["id"] = $data_component["id_component"];
                $data_elm["num_user"] = $data_component["num_user"];
                $data_elm["name"] = $data_component["name"];
                $data_elm["url_page"] = "/page".$data_component["id_component"].".html";
                
                $data_check["on_add_comment"] = true;
                $data_check["data_elm"] = $data_elm;
              }
          }
       
       
       return ($data_check);
     }
   
   
   /* Функции для работы с подпиской на контент (на пользователя) */
   public function first_init_subscribe_content()
     {
       if (!$this->obj_subscribe_content)
         $this->obj_subscribe_content=new eng_subscribe_content();
       
     }
   
   public function check_on_subscribe_content_one_user($num_author,$num_user)
     {
       //Функция проверяет, подписан или нет пользователь на автора
       $this->first_init_subscribe_content();
       
       $d_subscribe=$this->obj_subscribe_content->check_on_subscribe_author($num_author,$num_user);
       
       return ($d_subscribe);
     }
   
   public function get_subscribe_content_query_list_authors($num_user)
     {
       //Функция возвращает запрос ($db_query), который можно использовать как подзапрос для поиска авторов
       return (eng_subscribe_content::get_text_query_list_authors($num_user));
     }
   
   public function get_subscribe_content_count_authors($num_user,$only_actual)
     {
       return (eng_subscribe_content::get_count_authors($num_user,$only_actual));
     }
   
   public function get_subscribe_content_info_authors_page($num_user,$num_page,$elms_page,$only_actual)
     {
       //Получаем данные о подписках, то есть о пользователях (авторах), на которых подписан указанный пользователь (в $num_user)
       $this->first_init_subscribe_content();
       
       return ($this->obj_subscribe_content->get_info_authors_page($num_user,$num_page,$elms_page,$only_actual));
     }
   
   public function get_subscribe_content_info_users_author_page($num_author,$num_page,$elms_page,$only_actual)
     {
       //Получаем данные о подписчиках, то есть о пользователях, которые подписаны на конкретного пользователя (автора, в $num_user)
       $this->first_init_subscribe_content();
       
       return ($this->obj_subscribe_content->get_info_users_author_page($num_author,$num_page,$elms_page,$only_actual));
     }
   
   function clear_data_subscribe_content()
     {
       return (eng_subscribe_content::clear_data_subscribe());
     }
   
   
   /* Функции для работы с системой оценки (likes) */
   public function first_init_likes_content()
     {
       if (!$this->obj_likes_content)
         $this->obj_likes_content=new eng_likes_content();
       
     }
   
   public function get_likes_content_data_one_elm($name_modul,$num_elm,$num_user)
     {
       $this->first_init_likes_content();
       $data=$this->obj_likes_content->get_full_data_like_one_elm($name_modul,$num_elm,$num_user);
       
       return ($data);
     }
   
   public function get_likes_content_data_mas_elm($name_modul,$mas_num_elm,$num_user)
     {
       $this->first_init_likes_content();
       $data=$this->obj_likes_content->get_full_data_likes_mas_elm($name_modul,$mas_num_elm,$num_user);
       
       return ($data);
     }
   
   public function delete_likes_content_one_elm($name_modul,$num_element)
     {
       $this->first_init_likes_content();
       $this->obj_likes_content->delete_likes_one_elm($name_modul,$num_element);
       
       return (true);
     }
   
   public function delete_likes_content_mas_elm($name_modul,$mas_num_elm)
     {
       $this->first_init_likes_content();
       $this->obj_likes_content->delete_likes_mas_elm($name_modul,$mas_num_elm);
       
       return (true);
     }
   
   
   public function proc_referer_ubehavior()
     {
       // Функция добавит значение referer в статистику Действия пользователя, если пользователь пришел с другого сайта
       
       global $infoUserAgent, $site_http_referer, $site_type_referer, $on_spam_referer;
       
       $v_referer=$site_http_referer;
       $type_referer = $site_type_referer;
       
       //write_log_cms($type_referer,"type_referer");
       //write_log_cms($v_referer,"v_referer");
       
       if ($type_referer === "cross" && !$infoUserAgent[2] && !$on_spam_referer)
         {
           // Если пользователь пришел с другого сайта и это не робот и не реф-спам, то добавим в Действия пользователей
           $max_len = 300;
           $str_len = mb_strlen($v_referer);
           if ($str_len > $max_len)
             {
               // Обрежем адрес referer, так как может быть очень длинным
               $v_referer = mb_substr($v_referer, 0, $max_len)."...";
             }
           eng_user_behavior::add_one("mainModul", "user_referer", ["vtext" => $v_referer]);
         }
       
       return (true);
     }
   
   
   public function get_data_ubehavior_mainModul($d_ubehavior)
     {
       $data_comb=[];
       
       foreach ($d_ubehavior as $row)
         {
           $note="";
           
           if ($row["oper"] == "user_referer")
             {
               $note="Переход с ".$row["vtext"];
             }
           
           $new_row=["id_item"=>$row["id_item"], "_note"=>$note];
           $data_comb[]=$new_row;
         }
       
       return ($data_comb);
     }
   
   
  }
/*
function sort_menu($a,$b)
  {
   if ($a[0]==$b[0]) return 0;
   return (($a[0]>$b[0])?1:-1);
  }
*/

/*
Архив CMS находится на сайте www.boxcode.ru  
Информацию по установке и использованию CMS можно прочитать на сайте www.boxcode.ru 
*/