<?php


// файл php


class complement_geo_user
  {
   
   
   //страна, регион и город пользователя
   public $user_view_country = 0;
   public $user_view_region = 0;
   public $user_view_city = 0;
   
   public $user_view_name_country = 0;
   public $user_view_name_region = 0;
   public $user_view_name_city = 0;
   
   public $use_start_onload = false;
   public $start_onload = false;
   public $on_checked_get_param = true;
   public $error_init_get_param = false;
   public $set_geo_data_from_url = false;
   function __construct()
     {
      
      global $masConfig;
      if ( $masConfig["ON_USE_FIRST_CHOICE_GEO_LOCATION"] == 1 )
        $this->use_start_onload = true;
      
      //$this->init_param_geo_user();
      
     }
   
   public function init_param_geo_user()
     {
      $this->opred_param_geo_user();
      
      global $obj_geoData;
      if ( $this->user_view_country > 0 )
        {
         $GLOBALS["set_geo_data_from_url"] = $this->set_geo_data_from_url;
         $d_country = $obj_geoData->select_one_geo_data("country",$this->user_view_country);
         if ( $d_country )
           {
            $GLOBALS["user_view_data_country"] = $d_country;
            $GLOBALS["user_view_name_country"] = $d_country["name"];
            
            if ( $this->user_view_region > 0 )
              {
               $d_region = $obj_geoData->select_one_geo_data("region",$this->user_view_region);
               if ( $d_region )
                 {
                  $GLOBALS["user_view_data_region"] = $d_region;
                  $GLOBALS["user_view_name_region"] = $d_region["name"];
                  
                  if ( $this->user_view_city > 0 )
                    {
                     $d_city = $obj_geoData->select_one_geo_data("city",$this->user_view_city);
                     if ( $d_city )
                       {
                        $GLOBALS["user_view_data_city"] = $d_city;
                        $GLOBALS["user_view_name_city"] = $d_city["name"];
                       }
                    }
                  
                 }
              }
            
           }
        }
      
      $GLOBALS["user_view_country"] = $this->user_view_country;
      $GLOBALS["user_view_region"] = $this->user_view_region;
      $GLOBALS["user_view_city"] = $this->user_view_city;
      
      $GLOBALS["geo_type_part"]=$this->get_use_type_part();
      
      
      $this->opred_param_geo_user_2();
      
      return ( array( $this->on_checked_get_param, $this->error_init_get_param ));
     }
   
   public function opred_param_geo_user()
     {
      //$this->on_checked_get_param = true;
      global $masConfig,$obj_geoData;
      
      $mas_data_geo = false;
      
      $txt_name_geo="";
      $error = false;
      $on_set = false;
      
      if ( isset($GLOBALS["param_open_url_init"]["smgeo"]) )
        {
         $txt_name_geo = $GLOBALS["param_open_url_init"]["smgeo"];
         
         $mas_data_geo = $this->parse_text_url_from_geo($txt_name_geo);
         
         if ( sizeof($mas_data_geo[1]) > 0 ) $error = true;
         
         if (!$error)
           {
            $redirect_main_page = false;
            if ( $mas_data_geo[0]["allgeo"] )
              {
               $this->user_view_country=0;
               $this->user_view_region=0;
               $this->user_view_city=0;
               $redirect_main_page = $mas_data_geo[0]["redirect"];
              }
             else
               {
                $mas_geo = $obj_geoData->get_data_geo_translit($mas_data_geo[0]);
                if ( $mas_geo["error"] )
                  $error = true;
                 else
                   {
                    $this->user_view_country=(int) $mas_geo["country"];
                    $this->user_view_region=(int) $mas_geo["region"];
                    $this->user_view_city=(int) $mas_geo["city"];
                    $this->set_geo_data_from_url = true;
                   }
               }
            
            if ( !$error )
              {
               $on_set = true;
               $this->set_session_data_geo();
               $this->set_cookie_data_geo();
               if ( $redirect_main_page )
                 {
                  global $dir_http,$url_site;
                  sendheader::location($url_site);
                  exit();
                 }
              }
           }
         
        }
      
      if ( $error ) $this->error_init_get_param = true;
      
      if ( !$on_set )
        {
         
         if ( !empty($_POST["set_user_geo"]) )
          {
           
           if ( isset($_POST["pf_num_country"]) && is_numeric($_POST["pf_num_country"]) 
              && isset($_POST["pf_num_region"]) && is_numeric($_POST["pf_num_region"]) 
              && isset($_POST["pf_num_city"]) && is_numeric($_POST["pf_num_city"]) 
              )
             {
              
              $this->user_view_country=(int) $_POST["pf_num_country"];
              $this->user_view_region=(int) $_POST["pf_num_region"];
              $this->user_view_city=(int) $_POST["pf_num_city"];
              
              $this->set_session_data_geo();
              $this->set_cookie_data_geo();
              
             }
           
          }
         else
           {
            
            if ( isset($_SESSION["ses_user_num_country"])  && is_numeric($_SESSION["ses_user_num_country"]) 
                 && isset($_SESSION["ses_user_num_region"])  && is_numeric($_SESSION["ses_user_num_region"]) 
                 && isset($_SESSION["ses_user_num_city"])  && is_numeric($_SESSION["ses_user_num_city"]) 
               )
              {
               
               $this->user_view_country=$_SESSION["ses_user_num_country"];
               $this->user_view_region=$_SESSION["ses_user_num_region"];
               $this->user_view_city=$_SESSION["ses_user_num_city"];
               
               
              }
             else
               {
                
                $on_query_setting_geo_user = true;
                
                if ( isset($_COOKIE["datags"]) )
                  {
                   $setup_user_geo = base64_decode($_COOKIE["datags"]);
                   $mas_setup_user_geo = explode(":",$setup_user_geo);
                   
                   if ( sizeof( $mas_setup_user_geo ) == 3 )
                     {
                      $on_check_data = true;
                      
                      foreach ( $mas_setup_user_geo as $one_elem )
                        {
                         if ( !is_numeric($one_elem) )
                           {
                            $on_check_data = false;
                            break;
                           }
                        }
                      
                      if ( $on_check_data )
                        {
                         $on_query_setting_geo_user = false;
                         list($this->user_view_country,$this->user_view_region,$this->user_view_city) = $mas_setup_user_geo;
                         
                         $this->set_session_data_geo();
                         
                        }
                       else
                         {
                          
                         }
                      
                     }
                   
                  }
                
                if ( $on_query_setting_geo_user )
                  {
                   
                   if ( $this->use_start_onload )
                     {
                      $this->verification_setting_onload();
                      
                     }
                   
                   $this->set_session_data_geo();
                  }
                
               }
            
            
           }
        }
      
     }
   
   public function opred_param_geo_user_2()
     {
       //определяем вторичные ГЕО-данные из url-адреса
       if ( !isset($GLOBALS["param_open_url_init"]["smgeo2"]) ) return (true);
       
       global $masConfig,$obj_geoData;
       
       $country_num=0;
       $region_num=0;
       $city_num=0;
       
       //$mas_data_geo = false;
       //$txt_name_geo="";
       
       $error = false;
       $on_set = false;
       
       $txt_geo = $GLOBALS["param_open_url_init"]["smgeo2"];
       
       $mas_data_geo = $this->parse_text_url_from_geo($txt_geo);
       
       if ( sizeof($mas_data_geo[1]) > 0 ) $error = true;
       $mas_v_geo=array();
       
       if (!$error)
         {
           //$redirect_main_page = false;
           if (!$mas_data_geo[0]["allgeo"])
             {
               $mas_v_geo = $obj_geoData->get_data_geo_translit($mas_data_geo[0]);
               
               if ($mas_v_geo["error"])
                 $error = true;
               else
                 {
                   $on_set = true;
                   
                 }
             }
           
         }
       
       if ($on_set)
         {
           $GLOBALS["geo_data_2"] = array(
             "on_set"=>true,
             
             "country_num"=>(int) $mas_v_geo["country"],
             "region_num"=>(int) $mas_v_geo["region"],
             "city_num"=>(int) $mas_v_geo["city"],
             
             "country_name"=>$mas_v_geo["d_country"] ? $mas_v_geo["d_country"]["name"] : false,
             "region_name"=>$mas_v_geo["d_region"] ? $mas_v_geo["d_region"]["name"] : false,
             "city_name"=>$mas_v_geo["d_city"] ? $mas_v_geo["d_city"]["name"] : false,
             
             "country_translit"=>$mas_v_geo["d_country"] ? $mas_v_geo["d_country"]["translit"] : false,
             "region_translit"=>$mas_v_geo["d_region"] ? $mas_v_geo["d_region"]["translit"] : false,
             "city_translit"=>$mas_v_geo["d_city"] ? $mas_v_geo["d_city"]["translit"] : false,
             
             "country_data"=>$mas_v_geo["d_country"],
             "region_data"=>$mas_v_geo["d_region"],
             "city_data"=>$mas_v_geo["d_city"],
            );
         }
       
       //write_log_cms($GLOBALS["geo_data_2"],"geo data 2");
       
       return (!$error);
     }
   
   public function set_session_data_geo()
     {
      $_SESSION["ses_user_num_country"]=$this->user_view_country;
      $_SESSION["ses_user_num_region"]=$this->user_view_region;
      $_SESSION["ses_user_num_city"]=$this->user_view_city;
     }
   
   public function set_cookie_data_geo()
     {
      $t_data = $this->user_view_country.":".$this->user_view_region.":".$this->user_view_city;
      $t_data = base64_encode($t_data);
      syst_setcookie("datags",$t_data,array("expires"=>time()+24*3600*90));
     }
   
   public function verification_setting_onload()
     {
      
      //параметры сессии проверялись в функции (методе) opred_param_geo_user() 
      
      //поэтому проверяем, был ли это переход с другой страницы данного сайта
      // если да, то выходим из функции
      
      //echo($_SERVER['HTTP_REFERER'] ." " .$_SERVER["SERVER_NAME"]);
      if ( !empty( $_SERVER['HTTP_REFERER'] ) )
        {
         $domen = mb_strtolower($_SERVER["SERVER_NAME"]);
         $domen = delete_pref_text($domen,"www.");
         
         $referer = mb_strtolower($_SERVER['HTTP_REFERER']);
         
         //echo (" " .$domen . " " . $referer);
         
         if ( mb_strpos($referer, $domen)  !== false )
           {
            return;
           }
         
        }
      
      // если нет, то
      //считаем это первым посещением сайта посетителем
      $this->start_onload = true;
      
     }
   
   public function forming_block_setup_user_geo()
     {
      $t="";
      if ( ON_USE_GEO_DATA == 1 )
        {
         require ("blocksetupusergeo.php");
        }
      return ($t);
      
     }
   
   public function forming_link_jscript_set_geo_user()
     {
      $t = "";
      global $dir_http_template;
      $t.="\n<script type='text/javascript' src='".$dir_http_template."/complement/js_set_geo_user.js'></script>";
      
      return ($t);
     }
   
   public function include_code_head_html()
     {
      $t = "";
      global $masConfig,$obj_geoData;
      //$quick_link = $obj_geoData->selectCityQuickLink();
      $mas_data = array( "country" => $GLOBALS["user_view_data_country"], "region" => $GLOBALS["user_view_data_region"], "city" => $GLOBALS["user_view_data_city"] );
      $t .= "\n"
          ."<script type='text/javascript'>\n"
          ."on_use_geo_data=".$masConfig["ON_USE_GEO_DATA"].";"
          ."num_country=".$masConfig["NUM_COUNTRY"].";"
          ."num_region=".$masConfig["NUM_REGION"].";"
          ."user_view_country=".$this->user_view_country.";"
          ."user_view_region=".$this->user_view_region.";"
          ."user_view_city=".$this->user_view_city.";"
          ."mas_user_view_data_geo=".encode_gen_mas_to_jointext($mas_data,true,true).";"
          ."decode_mas(mas_user_view_data_geo);"
          //"mas_quick_link_geo_data = ".encode_gen_mas_to_jointext($quick_link,true,true).";"
          //."decode_mas(mas_quick_link_geo_data);"
          //."\n"
          .( $this->use_start_onload ? 
            ( $this->start_onload ? "\n". "add_functions_start_on_load(function(){engine_setup_geo.start_init_onload();});" : "" ) : ""
           )
          ."\n"."</script>";
      
      return ($t);
     }
   
   
   public function parse_text_url_from_geo($txt_url)
     {
      
      return ( classGeoData::parse_text_url_from_geo($txt_url) );
     }
   
   public function get_use_type_part()
     {
      global $masConfig;
      $data_info = array("first" =>"","end"=>"","next"=>"","use"=>"","num"=>array("country"=>0,"region"=>0,"city"=>0),
       "name"=>array("country"=>"","region"=>"","city"=>""),"last_name"=>"","url"=>array("country"=>"","region"=>"","city"=>""),
       "name_list"=>array("country"=>array(),"region"=>array(),"city"=>array()));
      
      $part_stg_type = array();
      $part_use_type = array();
      $init_next=array("country"=>"region","region"=>"city","city"=>"");
      $mas_num=array("country"=>0,"region"=>0,"city"=>0);
      $mas_name=array("country"=>"","region"=>"","city"=>"");
      $last_name="";
      $mas_url=array("country"=>"","region"=>"","city"=>"");
      $url="";
      $mas_name_list=array("country"=>array(),"region"=>array(),"city"=>array());
      $name_list=array();
      
      if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
        {
         
         if ( !($masConfig["NUM_COUNTRY"] > 0) )
           {
            $part_stg_type[]="country";
            if ( $GLOBALS["user_view_data_country"] )
              {
               $part_use_type[]="country";
               $mas_num["country"]=$GLOBALS["user_view_country"];
               $mas_name["country"]=$GLOBALS["user_view_name_country"];
               $name_list[]=$GLOBALS["user_view_name_country"];
               $url="/".$GLOBALS["user_view_data_country"]["translit"];
               $mas_url["country"]=$url;
               $mas_name_list["country"]=$name_list;
              }
           }
          else
            {
             $mas_num["country"]=$masConfig["NUM_COUNTRY"];
            }
         
         if ( !($masConfig["NUM_REGION"] > 0) )
           {
            $part_stg_type[]="region";
            if ( $GLOBALS["user_view_data_region"] )
              {
               $part_use_type[]="region";
               $mas_num["region"]=$GLOBALS["user_view_region"];
               $mas_name["region"]=$GLOBALS["user_view_name_region"];
               $name_list[]=$GLOBALS["user_view_name_region"];
               $url.="/".$GLOBALS["user_view_data_region"]["translit"];
               $mas_url["region"]=$url;
               $mas_name_list["region"]=$name_list;
              }
           }
          else
            {
             $mas_num["region"]=$masConfig["NUM_REGION"];
            }
         
         $part_stg_type[]="city";
         if ( $GLOBALS["user_view_data_city"] )
           {
            $part_use_type[]="city";
            $mas_num["city"]=$GLOBALS["user_view_city"];
            $mas_name["city"]=$GLOBALS["user_view_name_city"];
            $name_list[]=$GLOBALS["user_view_name_city"];
            $url.="/".$GLOBALS["user_view_data_city"]["translit"];
            $mas_url["city"]=$url;
            $mas_name_list["city"]=$name_list;
           }
         
         if ( sizeof($part_stg_type) ) $data_info["use"]=$part_stg_type;
         
         if ( sizeof($part_use_type) )
           {
            $data_info["first"]=$part_use_type[0];
            $data_info["end"]=$part_use_type[sizeof($part_use_type)-1];
            if ( $data_info["end"] ) $data_info["next"]=$init_next[$data_info["end"]];
           }
          else
            {
             if ( sizeof($part_stg_type) ) $data_info["next"]=$part_stg_type[0];
            }
         
         $data_info["num"]=$mas_num;
         $data_info["name"]=$mas_name;
         
         if ($data_info["end"])
           $data_info["last_name"]=$data_info["name"][$data_info["end"]];
         
         $data_info["url"]=$mas_url;
         $data_info["name_list"]=$mas_name_list;
         
        }
      
      return ($data_info);
     }
   
   
   
  }