<?php


class eng_main_component_base
{
  
  protected $type_page="";
  
  protected $set_inbox=[];
  protected $mas_inbox=[];
  protected $status_inbox=[];
  
  protected $openComponentIdent=false;
  //protected $openComponentIdent = false;
  protected $openNumPage = false;
  protected $openOnGetNumPage = false;
  
  protected $openNsrlKeyComponent = "1";
  protected $openNsrlComponentIdent = "0";
  protected $openNsrlPageOnRelative = false;
  
  /**
   * @var $obj_site work_site
   */
  protected $obj_site;
  
  protected $title_text="Страница";
  protected $text="";
  
  protected $t2="";
  protected $t3="";
  protected $t4="";
  protected $t5="";
  
  protected $title="";
  protected $description="";
  protected $keywords="";
  protected $mas_navigation_links=[];
  
  protected $dir_http="";
  
  protected $mas_name_copy=[];
  
  function __construct($type_page,$mas_control,$obj_site)
    {
      global $dir_http;
      
      //write_log_cms($mas_control,"construct gen modul page");
      $this->type_page=$type_page;
      
      if ($mas_control && sizeof($mas_control) > 0)
        {
          $this->set_inbox = $mas_control[2];
          $this->mas_inbox = $mas_control[3];
          $this->status_inbox = $mas_control[5];
        }
      
      $this->obj_site=$obj_site;
      $this->dir_http = $dir_http;
      
      $this->first_init();
      
      return (true);
    }
  
  function first_init()
    {
      // Метод нужно переопределять в конкретном классе
      return (true);
    }
  
  function _control_data()
    {
      $korekParam=$this->control_data();
      return ([$korekParam,
       //[$this->openComponentIdent, $this->openNumPage, $this->openOnGetNumPage],
       //[$this->openNsrlKeyComponent, $this->openNsrlComponentIdent, $this->openNsrlPageOnRelative]
      ]);
    }
  
  function control_data()
    {
      // Метод нужно переопределять в конкретном классе
      // Должна возвращать true ($korekParam), если все параметры заданы верно, иначе false
      return (true);
    }
  
  
  function _forming_data()
    {
      $this->forming_data();
      
      $rez=[$this->title_text,
        $this->text,
        $this->t2,
        $this->t3,
        $this->t4,
        $this->t5,
        $this->title,
        $this->description,
        $this->keywords,
        $this->mas_navigation_links];
      
      return ($rez);
    }
  
  function forming_data()
    {
      // Метод нужно переопределять в конкретном классе
      return (true);
    }
  
  function _copy_param_in_modul()
    {
      if (sizeof($this->mas_name_copy))
        {
          foreach ($this->mas_name_copy as $name)
            {
              $this->obj_site->$name=$this->$name;
            }
        }
      
      $this->copy_param_in_modul();
    }
  
  function copy_param_in_modul()
    {
      
    }
  
}
