<?php


class eng_main_component_registr extends eng_main_component_base
{
  
  protected $send_form_registr = false;
  protected $mas_error_registr = array();
  protected $on_add_registr = false;
  //protected $type_alert_registr = "";
  protected $mas_inbox_registr = array();
  protected $use_type_account = false;
  protected $on_use_company = false;
  
  
  protected $send_form_enter = false;
  protected $mas_error_enter = array();
  protected $mas_inbox_enter = [];
  protected $ip_adr_auth = "";
  protected $control_data_enter = [];
  protected $user_avtoriz_site = 1;
  protected $name_user_avtoriz = "";
  protected $id_user_avtoriz = 0;
  
  protected $data_reg_num_show_user=[];
  
  protected $send_form_info = false;
  protected $mas_error_info = array();
  
  protected $mas_inbox_info = array();
  protected $access_info = false;
  
  protected $print_alert = false;
  protected $print_text_alert = "";
  
  protected $control_data_info = "";
  
  
  protected $send_form_repair = false;
  protected $mas_error_repair = array();
  
  protected $mas_inbox_repair = array();
  
  protected $on_send_email = false;
  protected $control_data_repair = [];
  
  protected $on_activreg = false;
  protected $name_user_activreg = "";
  protected $email_user_activreg = "";
  
  function first_init()
    {
      
    }
  
  function control_data()
    {
      $korekParam=false;
      
      if ($this->type_page == "add_new")
        {
          $korekParam=$this->control_add_new();
        }
      elseif ($this->type_page == "enter")
        {
          $korekParam=$this->control_enter();
        }
      elseif ($this->type_page == "show_user")
        {
          $korekParam=$this->control_show_user();
        }
      elseif ($this->type_page == "info_profile")
        {
          $korekParam=$this->control_info_profile();
        }
      elseif ($this->type_page == "exit_account")
        {
          $this->obj_site->close_session_user();
          header ("Location: ".$this->dir_http."/");
          exit();
        }
      elseif ($this->type_page == "repair_pas")
        {
          $korekParam=$this->control_repair_password();
        }
      elseif ($this->type_page == "activ_account")
        {
          $korekParam=$this->control_activ_account();
        }
      
      return ($korekParam);
    }
  
  function forming_data()
    {
      
      if ($this->type_page == "add_new")
        {
          $this->forming_add_new();
        }
      elseif ($this->type_page == "enter")
        {
          $this->forming_enter();
        }
      elseif ($this->type_page == "show_user")
        {
          $this->forming_show_user();
        }
      elseif ($this->type_page == "info_profile")
        {
          $this->forming_info_profile();
        }
      elseif ($this->type_page == "exit_account")
        {
          // Выход из аккаунта
        }
      elseif ($this->type_page == "repair_pas")
        {
          $this->forming_repair_password();
        }
      elseif ($this->type_page == "activ_account")
        {
          $this->forming_activ_account();
        }
      
      return (true);
    }
  
  function control_add_new()
    {
      
      
      $this->send_form_registr = false;
      $this->mas_error_registr = array();
      $this->on_add_registr = false;
      //$this->type_alert_registr = "";
      $this->mas_inbox_registr = array();
      
      global $masConfig, $url_site, $domen_site, $dir_http;
      
      $this->use_type_account = ($masConfig["REGISTR_USE_TYPE_ACCOUNT"] == 1 ? true : false);
      
      $v_type_account = "regular";
      
      $this->on_use_company = false;
      
      $error = false;
      $mas_errors = [];
      $mas_index_errors = [];
      
      if ($GLOBALS["user_to_site"])
        {
          sendheader::location($dir_http."/");
          exit();
        }
      
      if ($this->use_type_account)
        {
          $on_mod_catalog = $this->obj_site->intercomCheckModul("catalog");
          //Если модуль Каталог компаний есть и он подключен, то используем поле Название компании
          if ($on_mod_catalog) $this->on_use_company = true;
        }
      
      $obj_registr_user = new eng_registr_user();
      
      
      if (!empty($_POST["new_control_registr"]))
        {
          $this->send_form_registr = true;
          
          //if ($this->use_type_account && !empty($_POST["type_account"]) && $_POST["type_account"]=="business") $v_type_account="business";
          list($error, $mas_index_errors, $v_type_account, $this->mas_inbox_registr) = $obj_registr_user->check_in_data_new_user($this->use_type_account, $this->on_use_company);
          /*
          write_log_cms($error,"error");
          write_log_cms($mas_index_errors,"errors");
          write_log_cms($v_type_account,"v_type_account");
          write_log_cms($this->mas_inbox_registr,"mas_inbox_registr");
          */
          if (!$error)
            {
              
              //проверка Email в таблице пользователей
              if ($obj_registr_user->check_exists_email($this->mas_inbox_registr["email_user"]))
                {
                  $this->mas_error_registr[] = "Пользователь с таким E-mail уже существует!";
                  return (false);
                }
              
              $phone_user = "";
              
              if ($masConfig["ON_USE_POLE_PHONE_USER"] == 1)
                {
                  $phone_user = $this->mas_inbox_registr["phone_user"];
                  
                  if ($phone_user != "")
                    {
                      if ($masConfig["USE_CHECK_ACTIVE_PHONE_USER"] == 1)
                        {
                          if (!$obj_registr_user->check_active_phone($phone_user))
                            {
                              $this->mas_error_registr[] = "Телефон не подтвержден!";
                              return (false);
                            }
                        }
                      
                      if ($obj_registr_user->check_exists_phone($phone_user))
                        {
                          $this->mas_error_registr[] = "Пользователь с таким телефоном уже существует!";
                          return (false);
                        }
                    }
                  
                }
              
              clear_data_capcha("ses_registr_kapcha");
              
              $code_email = "";
              $on_code_email = true;// true - включено подтверждение Email, код (ссылка для подтверждения) отправляется пользователю 
              
              if ($on_code_email)
                {
                  // Если включено подтверждение по e-mail
                  // генерируем код $code_email, который отправляется пользователю по почте
                  // $code_email=md5(time() . rand(100, 20000) . rand(100, 10000));
                }
              else
                {
                  //подтверждение по e-mail не включено, поэтому сразу регистрируем пользователя
                  $this->on_add_registr = "add";
                }
              
              $d_user = $this->mas_inbox_registr;
              $d_user["phone_user"] = $phone_user;//Добавляем номер телефона (может быть неуказан, переменная будет равна пустой строке)
              
              list($new_id_user, $code_email) = $obj_registr_user->add_new_user_normal($d_user, $v_type_account, $on_code_email);
              
              $obj_registr_user->send_email_active($d_user["email_user"], $d_user["name_user"], $new_id_user, $code_email);
              
              $this->on_add_registr = "sendemail";
              
              if ($this->on_use_company && $v_type_account == "business")
                {
                  $data_comp = array("num_user" => $new_id_user,
                    "name" => $this->mas_inbox_registr["company_name"],
                    "email" => $this->mas_inbox_registr["email_user"],
                    //"phone" => $phone_user,
                    //"n_category" => $this->mas_inbox_registr["n_category"],
                    //"n_category_2" => $this->mas_inbox_registr["n_category_2"],
                  );
                  $d_add_modul = $this->obj_site->intercomLink("catalog", "create_object_registr", array("add_object", $data_comp
                  ));
                }
            }
          else
            {
              $mas_errors = $mas_index_errors[0];
              $_mas_error2 = array_values($mas_index_errors[1]);
              $mas_errors = array_merge($mas_errors, $_mas_error2);
              
              $this->mas_error_registr = $mas_errors;
            }
          
        }
      
      return (true);
    }
  
  function forming_add_new()
    {
      
      $this->title = 'Регистрация';
      
      $this->title_text = "Регистрация";
      
      $this->description = "Регистрация нового пользователя на сайте";
      $this->keywords = "регистрация новый пользователь сайт";
      
      $this->mas_navigation_links = array(array("Регистрация", false));
      
      $print_form = true;
      $mas_form = array("type_account" => "", "name_user" => "", "email_user" => "", "on_subscribe" => "on",
        "get_message_user" => "on",/*"get_message_guest" => "on",*/
        //"name_real" => "", "num_country" => 0, "num_region" => 0, "num_city" => 0
        "phone_user" => "", "company_name" => ""
      );
      
      global $masConfig;//,$obj_geoData;
      
      $text_error = "";
      
      $on_error = 0;
      $mas_error = array();
      $message = "";
      $question_kapcha = "";
      $sessionId = "";
      
      if ($this->send_form_registr)
        {
          if (sizeof($this->mas_error_registr))
            {
              //$text_error = forming_text_error_from_mas($this->mas_error_registr,"Обнаружена ошибка или несколько:");
              $mas_error = $this->mas_error_registr;
              $on_error = 1;
              $copy_index = array();
              
              //if ( ON_AKTIV_AVTORIZ == 1 )
              $copy_index = array("email_user" /*,"on_subscribe","get_message_user","get_message_guest"*/);
              /*
              if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
                {
                 $copy_index = array_merge($copy_index,array("num_country","num_region","num_city"));
                }
              */
              $copy_index[] = "name_user";
              if ($masConfig["ON_USE_POLE_PHONE_USER"] == 1)
                {
                  $copy_index[] = "phone_user";
                }
              
              if ($this->use_type_account)
                {
                  $copy_index[] = "type_account";
                  if ($this->on_use_company)
                    {
                      $copy_index[] = "company_name";
                    }
                }
              
              $mas_form = copy_mas_to_mas_index($this->mas_inbox_registr, $mas_form, $copy_index);
              
            }
          else
            {
              
              if ($this->on_add_registr === "add")
                {
                  //пользователь зарегистрирован
                  $message .= "<div>Поздравляем! Вы зарегистрированы!</div>";
                  $print_form = false;
                  
                }
              elseif ($this->on_add_registr == "sendemail")
                {
                  $message .= "<div>На указанный Вами E-mail отправленно письмо. Вам нужно будет подтвердить регистрацию пройдя по указанной в письме ссылке.</div>";
                  
                  
                  $message .= ((trim($masConfig["TEXT_AVTORIZ_NOT_GET_ACTIVE_EMAIL"])) ? "<div class='marginTop20'>".nl2br($masConfig["TEXT_AVTORIZ_NOT_GET_ACTIVE_EMAIL"])."</div>" : "");
                  $print_form = false;
                  
                }
              
            }
          
        }
      
      
      $mas_country = array();
      $mas_region = array();
      $mas_city = array();
      
      
      if ($print_form)
        {
          
          /*
          if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
              {
                if ( NUM_COUNTRY == 0 )
                  {
                   $mas_country = $obj_geoData->selectAllCountry();
                  }
                
                if ( NUM_REGION == 0 && ( $mas_form["num_country"] > 0 || $masConfig["NUM_COUNTRY"] != 0 ) )
                  {
                   $mas_region = $obj_geoData->selectRegion( $masConfig["NUM_COUNTRY"] != 0 ? $masConfig["NUM_COUNTRY"] : $mas_form["num_country"] );
                  }
                
                if ( $masConfig["NUM_REGION"] != 0 || $mas_form["num_region"] > 0 )
                  {
                   $mas_city = $obj_geoData->selectCity($masConfig["NUM_REGION"] != 0 ? $masConfig["NUM_REGION"] : $mas_form["num_region"] );
                  }
                
              }
          */
          
          //капча
          if (REGISTR_KAPCHA == 1)
            {
              
              list($_num_v, $question_kapcha, $_answer_kapcha) = set_data_capcha("ses_registr_kapcha", false);
              $sessionId = session_id();
              
            }
          
        }
      
      
      global $mas_value_template, $tpl, $url_site;
      $mas_perem = $mas_value_template;
      $mas_perem["ON_AKTIV_AVTORIZ"] = ON_AKTIV_AVTORIZ;
      $mas_perem["REGISTR_KAPCHA"] = REGISTR_KAPCHA;
      $mas_perem["mas_form"] = $mas_form;
      $mas_perem["print_form"] = $print_form;
      $mas_perem["on_error"] = $on_error;
      $mas_perem["mas_error"] = $mas_error;
      $mas_perem["message"] = $message;
      $mas_perem["question_kapcha"] = $question_kapcha;
      $mas_perem["sessionId"] = $sessionId;
      $mas_perem["url_site"] = $url_site;
      $mas_perem["use_type_account"] = $this->use_type_account ? 1 : 0;
      $mas_perem["on_use_company"] = $this->on_use_company ? 1 : 0;
      
      /*
      $mas_perem["mas_country"] = $mas_country;
      $mas_perem["mas_region"] = $mas_region;
      $mas_perem["mas_city"] = $mas_city;
      */
      
      $mas_perem["masConfig"] = $masConfig;
      
      
      $tpl->template_dir = $this->obj_site->dir_template_components."/";
      
      $tpl->assign($mas_perem);
      
      $this->text = $tpl->fetch("registr_add.html");
      
      
      return (true);
    }
  
  function control_enter()
    {
      global $obj_control_data;
      
      $this->send_form_enter = false;
      $this->mas_error_enter = array();
      
      $this->mas_inbox_enter = array("name_user" => "", "password_user" => "", "memory_authoriz" => "off");
      
      global $infoUserAgent;
      $this->ip_adr_auth = $infoUserAgent[1];
      
      $on_redirect = false;
      $memory_authoriz = true;
      
      if (!empty($_POST["control_avtoriz"]))//проверка данных для авторизации на сайте (логин и пароль)
        {
          $this->send_form_enter = true;
          $mas_prov = array(
            array("name_user", "post", "name_user", "text", true, true, false, "", true, "tr", false, false, "Не указан E-mail!", true, true),
            array("password_user", "post", "password_user", "text", true, true, false, "", true, "tr", false, false, "Не указан пароль!", true, true),
            array("memory_authoriz", "post", "memory_authoriz", "text", false, true, "value", "on", true, false, "all", "off", "Обнаружена неизвестная ошибка!", true, true),
          );
          
          $this->control_data_enter = $obj_control_data->processing_one_group($mas_prov);
          //var_dump($this->control_data_enter);
          $this->mas_inbox_enter = $this->control_data_enter[3];
        
          if ($this->control_data_enter[0] && !$this->control_data_enter[1])
            {
              $protection_quant_attempts = 0;
              list($protection_blocked, $protection_quant_attempts) = $this->obj_site->protection_account_check($this->ip_adr_auth, $this->mas_inbox_enter["name_user"]);
              
              if (!$protection_blocked)
                {
                  $name_select = $this->mas_inbox_enter["name_user"];
                  $password_select = $this->mas_inbox_enter["password_user"];
                  $memory_authoriz = ($this->mas_inbox_enter["memory_authoriz"] == "on" ? true : false);
                  
                  $db_query = "select * from ".DB_PREF."users where type_registr='site' "
                    ." and email_user='".codeText($name_select)."' && BINARY password_user='".md5($password_select)."' ";
                  list($kolvo, $data_user) = db_work::query_select_one_assoc($db_query);
                  
                  
                  if ($kolvo == 1)
                    {
                      
                      //проверка активации аккаунта
                      if ($data_user["activ_user"] == "off")
                        {
                          //пользователь не активировал свой аккаунт
                          $this->mas_error_enter[] = "Данный аккаунт не активирован!";
                          return (true);
                        }
                      
                      //проверка "бана" пользователя
                      if ($data_user["access_user"] == "off" && $data_user["access_admin"] != "sadmin")
                        {
                          //пользователю запрещен доступ на сайт
                          $this->mas_error_enter[] = "Вам запрещен доступ на сайт!";
                          return (true);
                        }
                      
                      //пользователь авторизован
                      
                      
                      $this->user_avtoriz_site = 1;
                      
                      $this->name_user_avtoriz = $data_user["name_user"];
                      $this->id_user_avtoriz = $data_user["id_user"];
                      
                      session_auth_user::set_session($data_user, $memory_authoriz);
                      
                      /*
                      $_SESSION["id_user"]=$this->id_user_avtoriz;
                      $_SESSION["name_user_avt"]=$this->name_user_avtoriz;
                      $_SESSION["email_user_avt"]=$data_user["email_user"];
                      $_SESSION["time_avt"]=$GLOBALS["timeGlobal"];
                      $_SESSION["access_admin_avt"]=$data_user["access_admin"];
                      */
                      
                      //сохраняем дату авторизации
                      session_auth_user::save_time_authoriz_user($name_select, $this->id_user_avtoriz);
                      /*
                      $db_query="update ".DB_PREF."users set date_visit=".$GLOBALS["timeGlobal"]." where name_user='$name_select' ";
                      $q_result = db_work::query($db_query);
                      */
                      
                      /*
                      $GLOBALS["user_to_site"]=true;
                      $GLOBALS["name_user_to_site"]=$this->name_user_avtoriz;
                      $GLOBALS["id_user_to_site"]=$this->id_user_avtoriz;
                      $GLOBALS["email_user_to_site"]=$data_user["email_user"];
                      $GLOBALS["data_authorize_user"]=$data_user;
                      */
                      
                      $this->obj_site->protection_account_add("off", $this->ip_adr_auth, $this->mas_inbox_enter["name_user"], $this->id_user_avtoriz, "on", "user");
                      
                      $on_redirect = true;
                      /*
                      if ( 1 )
                        {
                          //передаем ход работы модулям, для выявления переадресации, (для интернет-магазина нужна переадресация для оформления товаров)
                          foreach ($this->list_obj_moduls as $data_one_modul)
                            {
                             if (!work_init_moduls::check_use_modul($name_modul)) continue;
                             
                             $link=$data_one_modul[5]->link_redirect_on_authoriz();
                             if ( $link )
                               {
                                header ("Location: ".$this->dir_http.$link);
                                exit();
                                
                               }
                             
                            }
                        }
                      
                      $url = $this->dir_http."/";
                      $previous_url = $this->get_request_url_page_site_session();
                      $url = ($previous_url ? $previous_url : $url);
                      
                      header ("Location: ".$url);
                      exit();
                      */
                    }
                  else
                    {
                      //ошибка с логином или паролем
                      $this->mas_error_enter[] = "Неправильный логин или пароль!";
                      $protection_action_blocked = "off";
                      
                      if ($protection_quant_attempts >= 9)
                        {
                          $protection_action_blocked = "on";
                        }
                      else
                        {
                          $protection_action_blocked = "off";
                        }
                      
                      $this->obj_site->protection_account_add($protection_action_blocked, $this->ip_adr_auth, $this->mas_inbox_enter["name_user"], 0, "off", "user");
                    }
                
                }
              else
                {
                  //Защита от подбора пароля.  ip адрес заблокирован на некоторое время и поэтому выводим сообщение об ошибке.
                  $this->mas_error_enter[] = "Обнаружены подозрительные действия. Вам временно приостановлена возможность авторизоваться на сайте.";
                }
            }
          else
            {
              $this->mas_error_enter = $this->control_data_enter[4];
            }
        }
      elseif (REGISTR_ON_SOCIAL == 1 && !empty($_POST["token"]))
        {
          //регистрация и авторизация через социальные сети
          $this->send_form_enter = true;
          
          $token = $_POST["token"];
          
          $service_data = file_get_contents('https://ulogin.ru/token.php?token='.$token.'&host='.$_SERVER['HTTP_HOST']);
          
          $user_soc = ($service_data ? json_decode($service_data, true) : false);
          
          if ($user_soc && !isset($user_soc["error"]))
            {
              
              if (empty($user_soc["email"]) || empty($user_soc["verified_email"]) || $user_soc["verified_email"] != 1)
                {
                  $this->mas_error_enter[] = "Email не указан или не подтвержден!";
                  return (true);
                }
              
              $db_query = "select * from ".DB_PREF."users where type_registr='social' and social_name='".codeText($user_soc["network"])."' "
                ." and social_ident='".codeText($user_soc["identity"])."' ";
              list($kolvo, $data_user) = db_work::query_select_one_assoc($db_query);
              
              if ($kolvo == 0)
                {
                  //добавляем пользователя в базу данных
                  
                  
                  $s_user = array(
                    "id_user" => 0,
                    "name_user" => $user_soc["first_name"],
                    "password_user" => "",
                    "email_user" => $user_soc["email"],
                    "phone_user" => "",
                    "date_create" => $GLOBALS["timeGlobal"],
                    "date_visit" => $GLOBALS["timeGlobal"],
                    "sait_user" => '',
                    "about_user" => '',
                    "print_email_user" => 'off',
                    "access_user" => 'on',
                    "activ_user" => 'on',
                    "kod_activ" => "",
                    "access_admin" => 'off',
                    "access_privat" => '',
                    "image_user" => "",
                    "on_subscribe" => "on",
                    "get_message_admin" => 'on',
                    "get_message_user" => 'on',
                    "get_message_guest" => "on",
                    "operation_1" => 'off',
                    "operation_2" => 'off',
                    "operation_3" => 'off',
                    "money" => 0,
                    "on_partner" => 'off',
                    "partner_amount" => 0,
                    "partner_key" => '',
                    "partner_purse" => '',
                    "partner_invite" => 0,
                    "partner_get_message" => 'off',
                    "notice_new_private_message" => 'on',
                    "type_registr" => 'social',
                    "social_name" => $user_soc["network"],
                    "social_ident" => $user_soc["identity"],
                    "social_profile" => $user_soc["profile"],
                    "service_ident" => $user_soc["uid"],
                    "note" => '',
                    "authorized" => "on",
                    "date_admin" => 0,
                    "authorized_admin" => "off",
                    "type_account" => "regular",
                    
                  );
                  
                  $db_query = forming_db_query_indexmas(DB_PREF."users", $s_user, "new", "id_user");
                  db_work::query($db_query);
                  
                  $new_id = db_work::get_insert_id();
                  
                  $data_user = $s_user;
                  $data_user["id_user"] = $new_id;
                  
                  $this->user_avtoriz_site = 1;
                  
                  $this->name_user_avtoriz = $data_user["name_user"];
                  $this->id_user_avtoriz = $data_user["id_user"];
                  
                  session_auth_user::set_session($data_user, $memory_authoriz);
                  
                  $this->obj_site->protection_account_add("off", $this->ip_adr_auth, $data_user["name_user"], $new_id, "on", "user");
                  
                  $on_redirect = true;
                }
              else
                {
                  //пользователь уже есть в базе
                  
                  //проверка "бана" пользоватея
                  if ($data_user["access_user"] == "off" && $data_user["access_admin"] != "sadmin")
                    {
                      //пользователю запрещен доступ на сайт
                      $this->mas_error_enter[] = "Вам запрещен доступ на сайт!";
                      return (true);
                    }
                  
                  //сохраняем время посещения
                  $mas_save = array();
                  $mas_save["id_user"] = $data_user["id_user"];
                  $mas_save["date_visit"] = $GLOBALS["timeGlobal"];
                  $mas_save["authorized"] = "on";
                  
                  if (
                    $data_user["name_user"] != $user_soc["first_name"] || $data_user["email_user"] != $user_soc["email"]
                    || $data_user["social_profile"] != $user_soc["profile"] || $data_user["service_ident"] != $user_soc["uid"]
                  )
                    {
                      //данные пользователя изменились, обновим в базе данных
                      $mas_save["name_user"] = $user_soc["first_name"];
                      $mas_save["email_user"] = $user_soc["email"];
                      $mas_save["social_profile"] = $user_soc["profile"];
                      $mas_save["service_ident"] = $user_soc["uid"];
                      
                      $data_user["name_user"] = $mas_save["name_user"];
                      $data_user["email_user"] = $mas_save["email_user"];
                      $data_user["social_profile"] = $mas_save["social_profile"];
                      $data_user["service_ident"] = $mas_save["service_ident"];
                    }
                  
                  $db_query = forming_db_query_indexmas(DB_PREF."users", $mas_save, "edit", "id_user");
                  db_work::query($db_query);
                  
                  $this->user_avtoriz_site = 1;
                  
                  $this->name_user_avtoriz = $data_user["name_user"];
                  $this->id_user_avtoriz = $data_user["id_user"];
                  
                  session_auth_user::set_session($data_user, $memory_authoriz);
                  
                  $this->obj_site->protection_account_add("off", $this->ip_adr_auth, $data_user["name_user"], $data_user["id_user"], "on", "user");
                  
                  $on_redirect = true;
                  
                }
              
              
            }
          
        }
      
      
      if ($on_redirect)
        {
          //передаем ход работы модулям, для выявления переадресации, (для интернет-магазина нужна переадресация для оформления товаров)
          foreach ($this->obj_site->list_obj_moduls as $data_one_modul)
            {
              
              $link = $data_one_modul[5]->link_redirect_on_authoriz();
              if ($link)
                {
                  header("Location: ".$this->dir_http.$link);
                  exit();
                  
                }
              
            }
          
          $url = $this->dir_http."/";
          $previous_url = $this->obj_site->get_request_url_page_site_session();
          $url = ($previous_url ? $previous_url : $url);
          
          header("Location: ".$url);
          exit();
        }
      
      return (true);
    }
  
  function forming_enter()
    {
      
      $this->title = 'Вход в аккаунт';
      
      $this->title_text = "Вход в аккаунт";
      
      $this->description = "Вход в аккаунт";
      $this->keywords = "Вход в аккаунт";
      
      $this->mas_navigation_links = array(array("Вход в аккаунт", false));
      
      $name = "";
      $text_error = "";
      $on_error_enter = 0;
      $mas_error_enter = array();
      
      if ($this->send_form_enter)
        {
          if (sizeof($this->mas_error_enter))
            {
              //$text_error = forming_text_error_from_mas($this->mas_error_enter,"Обнаружена ошибка или несколько:");
              $on_error_enter = 1;
              $mas_error_enter = $this->mas_error_enter;
              $name = $this->mas_inbox_enter["name_user"];
            }
        }
      
      
      global $mas_value_template, $tpl, $url_site;
      $mas_perem = $mas_value_template;
      $mas_perem["ON_AKTIV_AVTORIZ"] = ON_AKTIV_AVTORIZ;
      $mas_perem["name"] = $name;
      $mas_perem["on_error_enter"] = $on_error_enter;
      $mas_perem["mas_error_enter"] = $mas_error_enter;
      $mas_perem["url_site"] = $url_site;
      $tpl->template_dir = $this->obj_site->dir_template_components."/";
      
      $tpl->assign($mas_perem);
      
      $this->text = $tpl->fetch("registr_enter.html");
      
      
      return (true);
    }
  
  
  function control_show_user()
    {
      
      $db_query = "select * from ".DB_PREF."users where id_user=".$this->mas_inbox["num_user"] . " and activ_user='on' ";
      list($kol_rows, $this->data_reg_num_show_user) = obr_db_query_select_one_assoc($db_query);
      
      if ($kol_rows == 0) return (false);
      
      $this->obj_site->data_reg_num_show_user=$this->data_reg_num_show_user;
      //$korekParam = true;
      
      return (true);
    }
  
  function forming_show_user()
    {
      
      $data_user = $this->data_reg_num_show_user;
      
      $name_user = codeHtmlText($data_user["name_user"]);
      
      $this->title = 'Информация о пользователе '.$name_user." (".$data_user["id_user"].")";
      
      $this->title_text = "Информация о пользователе ".$name_user." (".$data_user["id_user"].")";
    
      $this->description = "Информация о зарегистрированном пользователе ".$name_user." (".$data_user["id_user"].")";
      $this->keywords = "Информация профиль зарегистрированный пользователь ".$name_user." ".$data_user["id_user"]."";
      
      $this->mas_navigation_links = array(array("Информация о пользователе", false));
      
      
      global $mas_value_template, $tpl;
      $mas_perem = $mas_value_template;
      $mas_perem["ON_AKTIV_AVTORIZ"] = ON_AKTIV_AVTORIZ;
      $mas_perem["REGISTR_KAPCHA"] = REGISTR_KAPCHA;
      
      $mas_perem["data_user"] = $data_user;
      //$mas_perem["on_error"]=$on_error;
      //$mas_perem["mas_error"]=$mas_error;
      //$mas_perem["on_send_email"]=$this->on_send_email;
      
      global $mas_init_show_profile;
      $mas_list_moduls = array();
      $mas_d = array();
      foreach ($mas_init_show_profile as $name_modul => $data_modul)
        {
          if (!$data_modul[1]) continue;
          $mas_d[$name_modul] = $data_modul;
        }
      if (sizeof($mas_d) > 0)
        {
          uasort($mas_d, function ($a, $b) { return ($a[0] > $b[0] ? 1 : -1); });
        }
      $mas_list_moduls = array_keys($mas_d);
      
      $mas_perem["mas_list_moduls"] = $mas_list_moduls;
      
      
      $mas_perem["obj_site"] = &$this->obj_site;
      
      $tpl->template_dir = $this->obj_site->dir_template_components."/";
      
      $tpl->assign($mas_perem);
      
      $this->text = $tpl->fetch("registr_showuser.html");
      
      return (true);
    }
  
  function control_info_profile()
    {
      
      global $obj_control_data;
      /*
      $this->send_form_info = false;
      $this->mas_error_info = array();
      
      $this->mas_inbox_info = array();
      $this->access_info = false;
      
      $this->print_alert = false;
      $this->print_text_alert = "";
      */
      if (!$GLOBALS["user_to_site"]) return (true);
      
      $this->access_info = true;
      
      global $masConfig;
      
      $data_user = $GLOBALS["data_authorize_user"];
      
      if (!empty($_POST["reg_update_acc_info"]))
        {
          $this->send_form_info = true;
          $mas_prov = array(
            
            array("reg_info_name_user", "post", "name_user", "text", true, true, "hablonrv",
              "/^[a-zA-Zа-яА-ЯёЁ0-9_ ]+$/u", true, "tr", false, false, "Не указано имя!", true, "Неверный формат имени!"
            ),
            array("reg_info_sait_user", "post", "sait_user", "text", true, false, false, "", true, false, false, false,
              false, false, false
            ),
            array("reg_info_text_user", "post", "about_user", "text", true, false, false, "", false, false, false,
              false, false, false, false
            ),
            array("reg_contr", "post", "contr_code", "text", true, true, false, "", false, false, false, false,
              "Не указан ключ безопасности!", true, false
            )
          );
          
          if ($masConfig["ON_AKTIV_AVTORIZ"] == 1)
            {
              
              $mas_prov[] = array("reg_subscribe_show_user", "post", "on_subscribe", "text", true, true, "listv",
                "on,off", false, false, false, false, "Обнаружена неизвестная ошика!", true, true
              );
              $mas_prov[] = array("reg_get_message_user", "post", "get_message_user", "text", true, true, "listv",
                "on,off", false, false, false, false, "Обнаружена неизвестная ошика!", true, true
              );
              //$mas_prov[] = array("reg_is_get_email_guest_show_user","post","get_message_guest","text",true,true,"listv","on,off",false,false,false,false,"Обнаружена неизвестная ошика!",true,true);
              $mas_prov[] = array("reg_is_notice_new_private_message", "post", "notice_new_private_message", "text",
                true, true, "listv", "on,off", false, false, false, false, "Обнаружена неизвестная ошика!", true, true
              );
              
            }
          
          if ($masConfig["USE_COMP_PARTNER"] == 1 && $GLOBALS["data_authorize_user"]["on_partner"] == "on")
            {
              $mas_prov[] = array("reg_partner_purse_user", "post", "partner_purse", "text", false, false, false, "",
                false, "tr", "all", "", false, false, false
              );
              $mas_prov[] = array("reg_partner_get_message_user", "post", "partner_get_message", "text", false, true,
                "listv", "on,off", false, false, "all", "off", "Обнаружена неизвестная ошика!", true, true
              );
            }
        
          $this->control_data_info = $obj_control_data->processing_one_group($mas_prov);
          //write_log_cms($this->control_data_info);
          $this->mas_inbox_info = $this->control_data_info[3];
          
          if ($this->control_data_info[0] && !$this->control_data_info[1])
            {
              $on_check_contr = false;
              
              if (eng_promote_safety::check_code($GLOBALS["id_user_to_site"], $this->mas_inbox_info["contr_code"]))
                {
                  $on_check_contr = true;
                }
              else
                {
                  $this->mas_error_info[] = "Неверный ключ безопасности!";
                }
              
              if ($on_check_contr)
                {
                  
                  $mas_save = $this->mas_inbox_info;
                  unset($mas_save["contr_code"]);
                  
                  $mas_save["id_user"] = $GLOBALS["id_user_to_site"];
                  $db_query = forming_db_query_indexmas(DB_PREF."users", $mas_save, "edit", "id_user");
                  obr_db_query($db_query);
                  
                  $this->print_alert = true;
                  $this->print_text_alert = "Данные успешно сохранены!";
                }
            }
          else
            {
              $this->mas_error_info = $this->control_data_info[4];
            }
          
          $this->obj_site->reload_data_user();
          
          return (true);
        }
      
      if ($data_user["type_registr"] == "site" && !empty($_POST["reg_num_acc"]))
        {
          $this->send_form_info = true;
          $mas_prov = array(
            
            array("reg_tek_pasw", "post", "tek_password", "text", true, true, false, "", false, false, false, false,
              "Не указан текущий пароль!", true, true
            ),
            array("reg_new_pasw", "post", "new_password", "text", true, true, "hablonrv", "/^[a-zA-Z0-9_]+$/u", false,
              false, false, false, "Не указан новый пароль!", true, "Неверный формат пароля!"
            ),
            array("reg_new_pasw_dubl", "post", "new_password_dubl", "text", true, true, "hablonrv",
              "/^[a-zA-Z0-9_]+$/u", false, false, false, false, "Не указан проверочный новый пароль!", true,
              "Неверный формат проверочного пароля!"
            ),
            array("reg_contr", "post", "contr_code", "text", true, true, false, "", false, false, false, false,
              "Не указан ключ безопасности!", true, false
            )
          );
          
          $this->control_data_info = $obj_control_data->processing_one_group($mas_prov);
          //write_log_cms($this->control_data_info);
          $this->mas_inbox_info = $this->control_data_info[3];
          
          if ($this->control_data_info[0] && !$this->control_data_info[1])
            {
              
              $on_check_contr = false;
              
              if (eng_promote_safety::check_code($GLOBALS["id_user_to_site"], $this->mas_inbox_info["contr_code"]))
                {
                  $on_check_contr = true;
                }
              else
                {
                  $this->mas_error_info[] = "Неверный ключ безопасности!";
                }
              
              if ($on_check_contr)
                {
                  
                  if ($this->mas_inbox_info["new_password"] == $this->mas_inbox_info["new_password_dubl"])
                    {
                      $id_user = $GLOBALS["id_user_to_site"];//trim($_POST["reg_num_acc"]);
                      //проверяем текущий пароль по номеру id_user пользователя
                      $db_query = "select count(*) from ".DB_PREF."users where id_user='$id_user' and password_user='".md5($this->mas_inbox_info["tek_password"])."' ";
                      $kol = obr_db_query_count($db_query);
                      if ($kol)
                        {
                          $db_query = "update ".DB_PREF."users set password_user='".md5($this->mas_inbox_info["new_password"])."' where id_user=$id_user ";
                          obr_db_query($db_query);
                          $this->print_alert = true;
                          $this->print_text_alert = "Пароль успешно сохранен!";
                        }
                      else
                        {
                          $this->mas_error_info[] = "Текущий пароль введен не правильно!!";
                        }
                    }
                  else
                    {
                      $this->mas_error_info[] = "Новый пароль и проверочный пароль не совпадают!";
                    }
                }
            }
          else
            {
              $this->mas_error_info = $this->control_data_info[4];
            }
          
          return (true);
        }
      
      
      if ($data_user["type_registr"] == "site" && !empty($_POST["reg_update_email_user"]))
        {
          
          $this->send_form_info = true;
          
          $mas_prov = array(
            array("reg_new_email", "post", "email_user", "text", true, true, "function", "check_data_email", true,
              false, false, false, "Не указан Email!", true, "Неправильно написан Email!"
            ),
            array("reg_contr", "post", "contr_code", "text", true, true, false, "", false, false, false, false,
              "Не указан ключ безопасности!", true, false
            )
          );
          
          
          $this->control_data_info = $obj_control_data->processing_one_group($mas_prov);
          //write_log_cms($this->control_data_info);
          $this->mas_inbox_info = $this->control_data_info[3];
          
          if ($this->control_data_info[0] && !$this->control_data_info[1])
            {
              $error = false;
              $on_check_contr = false;
              
              if (eng_promote_safety::check_code($GLOBALS["id_user_to_site"], $this->mas_inbox_info["contr_code"]))
                {
                  $on_check_contr = true;
                }
              else
                {
                  $this->mas_error_info[] = "Неверный ключ безопасности!";
                  $error = true;
                }
              
              if ($on_check_contr)
                {
                  //проверка e-mail в таблице пользователей
                  $db_query = "select count(*) from ".DB_PREF."users where email_user='".codeText($this->mas_inbox_info["email_user"])."'";
                  $kol_email = db_work::query_count($db_query);
                  
                  if ($kol_email != 0)
                    {
                      $this->mas_error_info[] = "Пользователь с таким E-mail уже существует!";
                      $error = true;
                      
                    }
                  
                  if (!$error)
                    {
                      $obj_tool_check_active_email = new tool_check_active_email();
                      $is_check_active_email = $obj_tool_check_active_email->is_check_active_email($this->mas_inbox_info["email_user"], false);
                      if (!$is_check_active_email)
                        {
                          $this->mas_error_info[] = "Email не подтвержден!";
                          $error = true;
                        }
                    }
                  
                  if (!$error)
                    {
                      $id_user = $GLOBALS["id_user_to_site"];
                      $db_query = "update ".DB_PREF."users set email_user='".codeText($this->mas_inbox_info["email_user"])."' where id_user = ".$id_user." ";
                      $q_ident = db_work::query($db_query);
                      $this->print_alert = true;
                      $this->print_text_alert = "Email успешно обновлен!";
                    
                    }
                }
              
            }
          else
            {
              $this->mas_error_info = $this->control_data_info[4];
            }
          
          return (true);
        }
      
      
      if (!empty($_POST["reg_update_phone_user"]))
        {
          
          $this->send_form_info = true;
          if ($masConfig["USE_CHECK_ACTIVE_PHONE_USER"] == 1)
            {
              $mas_prov = array(
                array("reg_new_phone", "post", "phone_user", "text", true, true, "function", "check_data_phone", true,
                  "tr", false, false, "Не указан номер телефона!", true, "Неправильно написан номер телефона!"
                ),
              );
            }
          else
            {
              $mas_prov = array(
                array("reg_new_phone", "post", "phone_user", "text", true, false, "function", "check_data_phone", true,
                  "tr", false, false, "Не указан номер телефона!", true, "Неправильно написан номер телефона!"
                ),
              );
            }
          
          $this->control_data_info = $obj_control_data->processing_one_group($mas_prov);
          //write_log_cms($this->control_data_info);
          $this->mas_inbox_info = $this->control_data_info[3];
          
          if ($this->control_data_info[0] && !$this->control_data_info[1])
            {
              $error = false;
              $phone_user = $this->mas_inbox_info["phone_user"];
              if ($masConfig["USE_CHECK_ACTIVE_PHONE_USER"] == 1)
                {
                  $obj_tool_check_active_phone = new tool_check_active_phone();
                  $is_check_active_phone = $obj_tool_check_active_phone->is_check_active_phone($phone_user, false);
                  if (!$is_check_active_phone)
                    {
                      $this->mas_error_info[] = "Телефон не подтвержден!";
                      $error = true;
                    }
                }
              
              if (!$error && $phone_user != "")
                {
                  //проверка номера телефона в таблице пользователей
                  $db_query = "select count(*) from ".DB_PREF."users where phone_user='".codeText($phone_user)."'";
                  $kol_phone = db_work::query_count($db_query);
                  
                  if ($kol_phone != 0)
                    {
                      $this->mas_error_info[] = "Пользователь с таким номером телефона уже существует!";
                      $error = true;
                    }
                }
              
              if (!$error)
                {
                  $id_user = $GLOBALS["id_user_to_site"];
                  $db_query = "update ".DB_PREF."users set phone_user='".codeText($phone_user)."' where id_user = ".$id_user." ";
                  obr_db_query($db_query);
                  $this->print_alert = true;
                  $this->print_text_alert = "Новый номер телефона успешно сохранен!";
                }
              
            }
          else
            {
              $this->mas_error_info = $this->control_data_info[4];
            }
          
          return (true);
        }
    
    
      return (true);
    }
  
  function forming_info_profile()
    {
      
      global $mas_value_template, $tpl;
      $mas_perem = $mas_value_template;
      $mas_perem["ON_AKTIV_AVTORIZ"] = ON_AKTIV_AVTORIZ;
      $mas_perem["REGISTR_KAPCHA"] = REGISTR_KAPCHA;
      
      
      $this->title = 'Мой профиль';
      
      $this->title_text = "Мой профиль";
      
      $this->description = "Профиль зарегистрированного пользователя";
      $this->keywords = "Профиль пользователь";
      
      $this->mas_navigation_links = array(array("Мой профиль", false));
      
      
      $on_error = 0;
      $mas_error = array();
      $on_alert = 0;
      $text_alert = "";
      
      $mas_perem["access_info"] = $this->access_info;
      
      
      $text_error = "";
      
      if ($this->send_form_info)
        {
          if (sizeof($this->mas_error_info))
            {
              //$text_error = forming_text_error_from_mas($this->mas_error_info,"Обнаружена ошибка или несколько:");
              $on_error = 1;
              $mas_error = $this->mas_error_info;
            }
        }
      
      //$text_alert = "";
      if ($this->print_alert)
        {
          //$text_alert = forming_text_alert($this->print_text_alert);
          $on_alert = 1;
          $text_alert = $this->print_text_alert;
        }
      
      $data_user = [];
      global $mas_init_reg_profile;
      $mas_list_moduls = array();
      
      if ($GLOBALS["user_to_site"])
        {
          $db_query = "select * from ".DB_PREF."users where  id_user=".$GLOBALS["id_user_to_site"];
          list($kolvo, $data_user) = obr_db_query_select_one_assoc($db_query);
          
          
          $mas_d = array();
          foreach ($mas_init_reg_profile as $name_modul => $data_modul)
            {
              if (!$data_modul[1]) continue;
              $mas_d[$name_modul] = $data_modul;
            }
          if (sizeof($mas_d) > 0)
            {
              uasort($mas_d, function ($a, $b) {
                return ($a[0] > $b[0] ? 1 : -1);
              });
            }
          $mas_list_moduls = array_keys($mas_d);
        }
      
      $mas_perem["mas_list_moduls"] = $mas_list_moduls;
      
      $mas_perem["data_user"] = $data_user;
      $mas_perem["on_error"] = $on_error;
      $mas_perem["mas_error"] = $mas_error;
      $mas_perem["on_alert"] = $on_alert;
      $mas_perem["text_alert"] = $text_alert;
      
      $mas_perem["mesngr_not_read"] = $this->obj_site->messenger_user_quantity_msg_not_read;
      
      $mas_perem["id_user_to_site"] = $GLOBALS["id_user_to_site"];
      $mas_perem["contr_code"] = eng_promote_safety::get_code($GLOBALS["id_user_to_site"]);
      
      $mas_perem["obj_site"] = &$this->obj_site;
      
      $tpl->template_dir = $this->obj_site->dir_template_components."/";
      
      $tpl->assign($mas_perem);
      
      $this->text = $tpl->fetch("registr_inforeg.html");
      
      
      return (true);
    }
  
  function control_repair_password()
    {
      
      global $masConfig, $url_site, $domen_site, $obj_control_data;
      
      $this->send_form_repair = false;
      $this->on_send_email = false;
      /*
      $this->mas_error_repair = array();
      $this->mas_inbox_repair = array();
      */
      
      if (!empty($_POST["repair_passwrd"]))//проверка данных для авторизации на сайте (логин и пароль)
        {
          $this->send_form_repair = true;
          $mas_prov = array(
            array("repair_email", "post", "email", "text", true, true, "function", "check_data_email", true, false,
              false, false, "Не указан Email!", true, "Неверный формат Email!"
            )
          );
          
          $this->control_data_repair = $obj_control_data->processing_one_group($mas_prov);
          
          $this->mas_inbox_repair = $this->control_data_repair[3];
          
          if ($this->control_data_repair[0] && !$this->control_data_repair[1])
            {
              
              $value_email = $this->mas_inbox_repair["email"];
              
              $db_query = "select * from ".DB_PREF."users where type_registr='site' and email_user='".codeText($value_email)."' ";
              list($kol_user_to_email, $mas_data_user) = db_work::query_select_assoc($db_query);
              
              
              if ($kol_user_to_email == 1)
                {
                  $data_user = $mas_data_user[0];
                  $new_passwd = mb_substr(md5(mt_rand(100, 100000)), 0, 9);
                  $db_query = "update ".DB_PREF."users set password_user='".md5($new_passwd)."' where type_registr='site' and email_user='".codeText($value_email)."' ";
                  db_work::query($db_query);
                  
                  $p_email = $value_email;
                  $site_name = NAME_SITE_TO_EMAIL;
                  $mas_perem = array("site_name" => $site_name);
                  
                  $subject = $masConfig["AUTHORIZATION_TITLE_EMAIL_REPAIR_PASSWORD"];//"Восстановление пароля пользователя зарегистрированного на сайте $site_name";
                  $subject = replace_perem_texthablon($subject, "{", "}", $mas_perem);
                  
                  $mas_perem["url_site"] = $url_site;
                  $mas_perem["domen_site"] = $domen_site;
                  $mas_perem["email_user"] = $data_user["email_user"];
                  $mas_perem["name_user"] = $data_user["email_user"];//$data_user["name_user"];
                  $mas_perem["new_password"] = $new_passwd;
                  
                  $message = $masConfig["AUTHORIZATION_TEXT_EMAIL_REPAIR_PASSWORD"];
                  $message = replace_perem_texthablon($message, "{", "}", $mas_perem);
                  $message .= forming_signature_email();
                  
                  /*
                  $message="Здравствуйте!<br>\n"
                    ."Ваш E-mail был указан для восстановления пароля пользователя, зарегистрированного на сайте $site_name."
                    ."<br>\n"
                    ."Пароль был сгенерирован заново. Логин для входа <b>".$data_user["name_user"]."</b>, пароль <b>".$new_passwd."</b>."
                    .forming_signature_email();
                  */
                  
                  //$get_send_mail=send_email($server,$domen_server,$port,$login_email,$passw_email,$from_email,$from_text,$p_email,$subject,$message,$headers);
                  $get_send_mail = send_email($subject, $message, "", $p_email, false, false, false, false, true);
                  
                  $this->on_send_email = true;
                  
                }
              else
                {
                  
                  $this->mas_error_repair[] = "Не найден пользователь с таким E-mail!";
                }
              
              
            }
          else
            {
              $this->mas_error_repair = $this->control_data_repair[4];
            }
        }
      
      
      return (true);
    }
  
  function forming_repair_password()
    {
      
      $this->title = 'Восстановление пароля';
      
      $this->title_text = "Восстановление пароля";
      
      $this->description = "Восстановление пароля";
      $this->keywords = "Восстановление пароля";
      
      $this->mas_navigation_links = array(array("Восстановление пароля", false));
      
      $value_email = "";
      $text_error = "";
      $on_error = 0;
      $mas_error = array();
      
      if ($this->send_form_repair)
        {
          if (sizeof($this->mas_error_repair))
            {
              //$text_error = forming_text_error_from_mas($this->mas_error_repair,"Обнаружена ошибка или несколько:");
              $on_error = 1;
              $mas_error = $this->mas_error_repair;
              $value_email = $this->mas_inbox_repair["email"];
            }
        }
      
      if ($this->on_send_email)
        {
          
          //$t1.="На указанный Вами E-mail отправлено письмо с логином и паролем для входа в аккаунт.";
          
        }
      else
        {
          
        }
      
      
      global $mas_value_template, $tpl;
      $mas_perem = $mas_value_template;
      $mas_perem["ON_AKTIV_AVTORIZ"] = ON_AKTIV_AVTORIZ;
      $mas_perem["REGISTR_KAPCHA"] = REGISTR_KAPCHA;
      
      $mas_perem["value_email"] = $value_email;
      $mas_perem["on_error"] = $on_error;
      $mas_perem["mas_error"] = $mas_error;
      $mas_perem["on_send_email"] = $this->on_send_email;
      
      
      $tpl->template_dir = $this->obj_site->dir_template_components."/";
      
      $tpl->assign($mas_perem);
      
      $this->text = $tpl->fetch("registr_regrepair.html");
      
      
      return (true);
    }
  
  
  function control_activ_account()
    {
      
      $this->on_activreg = false;
      $this->name_user_activreg = "";
      $this->email_user_activreg = "";
      
      $id_user = $this->mas_inbox["activreg"];
      $code = $this->mas_inbox["codereg"];
      
      $code = stripslashes($code);
      
      //$code=str_replace("'","",$code);
      $db_query = "select * from ".DB_PREF."users where id_user=".codeText($id_user)." and kod_activ='".codeText($code)."'";
      list($kol_rows, $data_user) = db_work::query_select_one_assoc($db_query);
      
      if ($kol_rows == 1)
        {
          
          $db_query = "update ".DB_PREF."users "
            ." set activ_user='on', kod_activ='' "
            ." where id_user = $id_user and kod_activ='".codeText($code)."' ";
          db_work::query($db_query);
          
          
          //аккаунт подтвержден успешно
          $this->on_activreg = true;
          $this->name_user_activreg = $data_user["name_user"];
          $this->email_user_activreg = $data_user["email_user"];
          
        }
      else
        {
          //ошибка с подтверждением аккаунта
          
        }
      
      
      return (true);
    }
  
  function forming_activ_account()
    {
      
      $this->title = 'Подтверждение регистрации';
      
      $this->title_text = "Подтверждение регистрации";
      
      $this->description = "Подтверждение регистрации";
      $this->keywords = "Подтверждение регистрации";
      
      $this->mas_navigation_links = array(array("Подтверждение регистрации", false));
      
      
      $message = "";
      
      if ($this->on_activreg)
        {
          $message .= " Поздравляем!<br> Активация аккаунта прошла успешно."
            ." Для входа используйте E-mail <span class='login_user'>".$this->email_user_activreg."</span> "
            ."и пароль который Вы указали при регистрации. ";
          
        }
      else
        {
          $message .= "Произошла неизвестная ошибка. Возможные причины:";
          $message .= "<ul><li>Данный аккаунт уже подтвержден.</li><li>Данный аккаунт удален.</li></ul>";
          
        }
      
      
      global $mas_value_template, $tpl;
      $mas_perem = $mas_value_template;
      $mas_perem["ON_AKTIV_AVTORIZ"] = ON_AKTIV_AVTORIZ;
      $mas_perem["REGISTR_KAPCHA"] = REGISTR_KAPCHA;
      
      $mas_perem["message"] = $message;
      
      
      $tpl->template_dir = $this->obj_site->dir_template_components."/";
      
      $tpl->assign($mas_perem);
      
      $this->text = $tpl->fetch("registr_activreg.html");
      
      
      return (true);
    }
  
}

