<?php


/*
 * Базовый файл настроек движка
 */


$masConfig = array();


//Если не определена переменная $dir_cms (корневая папка сайта), то определяем 
if (empty($dir_cms)) $dir_cms=realpath(dirname(__FILE__)."/../");

define("DIR_CMS",$dir_cms);

$dir_config=DIR_CMS."/config";//dirname(__FILE__);

define("DIR_CONFIG_SAVE",realpath(DIR_CMS."/config_save"));


//массив модулей которые используют комментарии
$moduls_comments=array(
  /*
  "name_modul"=>array(
   идентификационный номер модуля,
   "название модуля(отображается в админке)",
   false или true - обязательно ли должен быть указан email
   false или true - выводить ли поле Сайт
   )
  */
  "stat"=>array(1,"Статьи (главный модуль)",false,true,"add_class_send_message_com.php","Автор публикации"),
  "punkt"=>array(2,"Пункт меню",false,true,"add_class_send_message_com.php","Автор публикации")
  
 );


$mas_init_punkts_menu = array();

$mas_init_punkts_menu["mainModul"] = array(
 
   "name_modul" => "Главный модуль",
   "punkts" => array(
     "mainPage" => array("name" => "Главная","url"=>"{url_geo}/","view_user" => "all","ontext" => "on" ),
     "myprofile" => array("name" => "Мой профиль","url"=>"/registr/inforeg/","view_user" => "all" ),
     "messenger" => array("name" => "Мессенджер","url"=>"/messenger","view_user" => "all" ),
     )
 );
/*
$mas_init_punkts_menu["registr"] = array(
   "name_modul" => "Модуль регистрации",
   "punkts" => array(
     "registr" => array("name" => "Регистрация","url"=>"/registr/","view_user"=>"guest","ontext" => "off" )
     )
 );
*/

//название cookie которое будет устанавливаться на компьютере посетителя
define ("NAME_COOKIE","control");


include_once(DIR_CONFIG_SAVE."/config_main.php");


//настройки времени
$GLOBALS["timeGlobal"]=time()+DELTA_TIME*3600;
$GLOBALS["dataNow"] = getdate($GLOBALS["timeGlobal"]);
$GLOBALS["timeBeginDay"] = mktime(0,0,0,(int)$GLOBALS["dataNow"]["mon"],(int)$GLOBALS["dataNow"]["mday"],(int)$GLOBALS["dataNow"]["year"]);
$GLOBALS["timeBeginNextDay"] = $GLOBALS["timeBeginDay"]+24*60*60;


//массив в котором должны храниться данные об параметрах капчи содержащейся в сессии
$mas_data_capcha_session = array();
$mas_data_capcha_session["registr_user"] = "ses_registr_kapcha";


$mas_init_auto_execution = array();
$mas_init_auto_execution[] = array("mainModul",true,"mainModulCron","/script/cron_main_modul.php",10,"cron main modul",0,2,false);
$mas_init_auto_execution[] = array("mainModul",true,"msender_cron","/script/cron_msender.php",500,"cron mail sender",0,2,false);
$mas_init_auto_execution[] = array("mainModul",true,"clearMessenger","/script/cron_messenger.php",350,"cron clear messenger",false,false,false);


define("NAME_DIR_LOADFILES","loadfiles");

define("NAME_DIR_LOADFILES_MODULS",NAME_DIR_LOADFILES."/moduls");

define("DIR_LOADFILES_MODULS",DIR_CMS."/".NAME_DIR_LOADFILES."/moduls");

define("DIR_COMPLEMENT",DIR_CMS."/script/complement/");


//название папки, в которой находится панель управления
define("NAME_DIR_ADMIN","dans");
//путь к папке с панелью управления
define("DIR_ADMIN",DIR_CMS."/".NAME_DIR_ADMIN);

//имя папки для кэширования данных
define("NAME_DIR_CACHE_DATA","cache_data");
//папка для кэширования данных
define("DIR_CACHE_DATA",DIR_CMS."/".NAME_DIR_CACHE_DATA);

//имя папки для модуля downfiles
define("NAME_DIR_DOWNFILES",NAME_DIR_LOADFILES."/"."downloadfls");

//имя папки для временных данных
define("NAME_DIR_TMP_DATA","tmp");
//папка для временных данных
define("DIR_TMP_DATA",DIR_CMS."/".NAME_DIR_TMP_DATA);

//Файл с параметрами системы
define("FILE_SETTINGS",DIR_CONFIG_SAVE."/../config_save/settings.php");


define("USE_ENER_PROMOCODE", 0);
define("USE_ENER_SUBSCRIBE_CONTENT", 0);
define("USE_ENER_USER_BEHAVIOR", 1);


define("USE_UNION_CSS_FILES", 1);
$masConfig["USE_UNION_CSS_FILES"] = USE_UNION_CSS_FILES;
define("USE_UNION_JS_FILES", 1);
$masConfig["USE_UNION_JS_FILES"] = USE_UNION_JS_FILES;


define ("INFO_PROD_NAME","CMS boxcode.ru");
define ("INFO_PROD_NVERSION","30");


define("USE_COMP_PARTNER", 0);
$masConfig["USE_COMP_PARTNER"] = USE_COMP_PARTNER;


$mas_init_promocode = array();
$mas_name_moduls_dynam_promocode = array();

$mas_init_check_ident_url_adr=array();
$mas_init_check_search_url_adr=array();


$mas_init_sitemap=array();
$mas_init_reg_profile=array();
$mas_init_show_profile=array();

$mas_init_links_profile=array();

$mas_init_likes_content=array();

$mas_init_user_behavior = array();

$mas_registr_class=array();


$mas_month=array (
 "января","февраля","марта","апреля","мая","июня","июля","августа","сентября","октября","ноября","декабря",
 "01"=>"января","02"=>"февраля","03"=>"марта","04"=>"апреля","05"=>"мая","06"=>"июня","07"=>"июля","08"=>"августа","09"=>"сентября","10"=>"октября","11"=>"ноября","12"=>"декабря"
 );
$mas_months=array(1=>"января","февраля","марта","апреля","мая","июня","июля","августа","сентября","октября","ноября","декабря",
"01"=>"января","02"=>"февраля","03"=>"марта","04"=>"апреля","05"=>"мая","06"=>"июня","07"=>"июля","08"=>"августа","09"=>"сентября","10"=>"октября","11"=>"ноября","12"=>"декабря");


$mas_init_page_nsrl = array();
$mas_init_page_nsrl["mainPage"] = array( "name" => "Главная страница", "identkey" => "1", "nested" => 0 );
$mas_init_page_nsrl["mainModul"] = array( "name" => "Главный модуль", "identkey" => "2", "nested" => 0 );

$masConfig["protocol_url_cms"] = PROTOCOL_URL_CMS;





foreach ($list_modules as $num_key => $data_one_modul)
  {
   $one_config=DIR_CONFIG_SAVE."/config_m_".$data_one_modul[0].".php";
   require_once($one_config);
   //$name_define_set_modul="ON_MODUL_".strtoupper($data_one_modul[0]);
   
  }

//$mas_all_define=get_defined_constants();

foreach ($list_modules as $num_key => $data_one_modul)
  {
   //$one_config=$dir_config."/../moduls/".$data_one_modul[0]."/config_save/config_php.php";
   //include_once($one_config);
   
   $name_big_modul=strtoupper($data_one_modul[0]);
   
   if (isset($masConfig["ON_MODUL_".$name_big_modul]))
     {
      $list_modules[$num_key][2]=$masConfig["ON_MODUL_".$name_big_modul];
      //if (isset($masConfig[$name_big_modul."_MODUL_NAME_PART_HABLON"]))
      $list_modules[$num_key][3]="all_first";//$masConfig[$name_big_modul."_MODUL_NAME_PART_HABLON"];
      if ( $list_modules[$num_key][2] == 1 )
        {
         require_once(DIR_CMS."/moduls/".$data_one_modul[0]."/config_data_modul.php");
        }
     }
   
  }


$dir_template = realpath(DIR_CMS."/templates/".$name_template);
$dir_template_components = $dir_template."/components";
$dir_template_complement = $dir_template."/complement";
$dir_template_moduls = $dir_template."/moduls";


//подключаем конфигурационный файл шаблона
if ( file_exists($dir_template."/configs/param_cfg_tpl.php") )
  {
   include($dir_template."/configs/param_cfg_tpl.php");
  }



//файл настроек валюты
include(DIR_CONFIG_SAVE."/initcurrency.php");


// добавляем данные об валютах в массив настроек $masConfig
$masConfig["init_currency"] = $init_currency;
$masConfig["init_base_currency"] = $init_base_currency;
$masConfig["init_use_currency"] = $init_use_currency;
$masConfig["init_course_currency"] = $init_course_currency;
$masConfig["data_base_currency"] = $init_currency[$init_base_currency];



