
/* Загрузка файла на сервер. Можно использовать для загрузки превью, лого и т.п. */

function eng_upload_one_file(elm_form,elm_field_file,opts,back_fn)
  {
    this.obj_field_file=false;
    this.back_fn=false;
    this.opts={
      "nameFieldFile":"field_new_file",
      "accept_type_files":"jpg|jpeg|png|gif",
      "max_size_file": 50000000,
      "path_url_upload":"",
      "param_add_send":[],
      "param_serv_upload":["type_file","upload_one_file"],
      "param_serv_delete":["type_file","delete_one_file"],
    };
    
    this.cur_add_param=[];
    
    this._first_init = function()
      {
        var this_obj = this;
        this.obj_field_file = engine_elm_html.get_obj_pf(elm_form, elm_field_file);
        //wconsole("eng_upload_one_file obj_field_file",this.obj_field_file);
        
        if (!this.obj_field_file) return (false);
        
        if (opts)
          {
            for (var i in this.opts)
              {
                if (typeof(opts[i]) != "undefined") this.opts[i]=opts[i];
              }
          }
        
        elmAddEventListener(this.obj_field_file, "change", function (a){ this_obj._action_change_field_file(a); });
        
        if (back_fn) this.back_fn=back_fn;
        
        return (true);
      }
    
    this.action_choose_file = function(cur_add_param)
      {
        if (typeof (cur_add_param) == "undefined") cur_add_param=[];
        this.cur_add_param=[];
        if (cur_add_param && cur_add_param.length > 0)
          this.cur_add_param=cur_add_param;
        
        if (!this.obj_field_file) return (false);
        this.obj_field_file.click();
        
        return (true);
      }
    
    this.action_delete_file = function(on_confirm,cur_add_param)
      {
        if (typeof(on_confirm)=="undefined") on_confirm=true;
        if (typeof (cur_add_param) == "undefined") cur_add_param=[];
        this.cur_add_param=[];
        if (cur_add_param && cur_add_param.length > 0)
          this.cur_add_param=cur_add_param;
        
        this._send_serv_delete_file(on_confirm);
      }
    
    this._action_change_field_file = function(e)
      {
        var this_obj=this;
        //wconsole(this.obj_field_file.files);
        if (this.obj_field_file.files.length == 0) return (false);
        
        var file=this.obj_field_file.files[0];
        if (!file) return (false);
        //wconsole(file);
        var d_check_exp = check_exp_file(file.name, this_obj.opts["accept_type_files"], "Неверный формат файла!\n Допускаются только форматы ", false);
        
        //пропускаем файл, если неверное расширение файла
        if (d_check_exp == false)
          {
            //очищаем поле (удаляем файл в поле)
            clear_field_file(this.obj_field_file);
            
            return (false);
          }
        
        //пропускаем файл, если размер файла превышает допустимый
        if (this_obj.opts["max_size_file"] > 0 && file.size && this_obj.opts["max_size_file"] < file.size) return (false);
        
        var data_send = new FormData();
        
        //data_send.append('type_file', "upload_one_file");
        data_send.append(this.opts.param_serv_upload[0], this.opts.param_serv_upload[1]);
        /*
        var control=eng_secrt_user_part.get_param_mas();
        data_send.append(control[0], control[1]);
        */
        var mas_add_param=[];
        if (this.cur_add_param && this.cur_add_param.length > 0) mas_add_param=this.cur_add_param;
        mas_add_param=mas_add_param.concat(this.opts["param_add_send"]);
        
        if (mas_add_param && mas_add_param.length > 0)
          {
            for (var j = 0; j < mas_add_param.length; j++)
              {
                data_send.append(mas_add_param[j][0], mas_add_param[j][1]);
              }
          }
        
        data_send.append(this.opts.nameFieldFile, file);
        
        var url=this.opts["path_url_upload"];//dir_http + "/allinclude/oper_user_profile.php";
        
        loadHTTPjc(url,function(a,b){this_obj._obr_upload_file_serv(a,b)},data_send);
      }
    
    this._obr_upload_file_serv = function(answer,add_param)
      {
        //wconsole(answer);
        var data=answer.data || {};
        this._clear_field_file();
        
        if (!data || !data.on_upload || data.on_upload == 0)
          {
            alert("Ошибка с загрузкой изображения!");
            return (false);
          }
        
        //wconsole(data.name_file);
        if (this.back_fn) this.back_fn("on_upload",data.name_file);
        //this._replace_profile_user_file(data.name_file);
        
        return (true);
      }
    
    this._clear_field_file = function()
      {
        this.obj_field_file.type="text";
        this.obj_field_file.value="";
        this.obj_field_file.type="file";
      }
    
    this._send_serv_delete_file = function(on_confirm)
      {
        var this_obj=this;
        if (on_confirm && !confirm("Удалить изображение?")) return (false);
        
        var mas_send={};
        
        //mas_send["type_file"]="delete_one_file";
        mas_send[this.opts.param_serv_delete[0]] = this.opts.param_serv_delete[1];
        
        //eng_secrt_user_part.add_code_mas(mas_send);
        
        var mas_add_param=[];
        if (this.cur_add_param && this.cur_add_param.length > 0) mas_add_param=this.cur_add_param;
        mas_add_param=mas_add_param.concat(this.opts["param_add_send"]);
        
        if (mas_add_param && mas_add_param.length > 0)
          {
            for (var j = 0; j < mas_add_param.length; j++)
              {
                mas_send[ mas_add_param[j][0] ] = mas_add_param[j][1];
              }
          }
        
        var url=this.opts["path_url_upload"];//dir_http + "/allinclude/oper_user_profile.php";
        
        var data_send=encode_assoc_mas_query_ajax( mas_send );
        //wconsole(data_send);
        
        loadHTTPjc(url,function(a,b){ this_obj._obr_send_serv_delete_file(a,b); },data_send);
        
        return (true);
      }
    
    this._obr_send_serv_delete_file = function(answer,add_param)
      {
        
        if (this.back_fn) this.back_fn("on_delete","");
        
      }
    
    this._first_init();
  }
