

engine_templ = {};
/*
engine_templ.onload_page = function()
  {
   var a = this;
   for (var i in a)
     {
      if ( !a.hasOwnProperty(i) ) continue;
      
      if ( a[i].onload_start && a[i].onload_start_action )
        {
         a[i].onload_start_action();
        }
     }
   
  }
add_functions_start_on_load(function(){engine_templ.onload_page();});
*/

engine_templ.menu = {
  user_action : function()
    {
     
     var obj_base = engine_elm_html.get_obj("menu_main_block_base");
     var on_class_open = change_class_name.check_is(obj_base,"menu_main_open");
     if ( on_class_open )
       {
        change_class_name.delete_cl(obj_base,"menu_main_open");
       }
      else
        {
         change_class_name.add(obj_base,"menu_main_open");
        }
     
     return (false);
    }
  
 };


engine_templ.auth_site = {
  
  on_first_run:false,
  on_open_recently: false,
  
  user_action_open_light_auth : function(flag)
    {
     flag = (typeof(flag) == "undefined" ? false : flag);
     var obj_link_enter = engine_elm_html.get_obj("light_auth_site_link_enter");
     var is_class_open = change_class_name.check_is(obj_link_enter,"light_auth_site_view_form");
     var obj_panel = engine_elm_html.get_obj("light_auth_site_box_panel");
     
     var proc = false;
     if ( flag === "close" )
       {
        if ( is_class_open ) proc = "delete";
       }
      else
        if ( is_class_open )
          proc = "delete";
         else
           proc = "add";
     
     if ( proc )
       {
        if ( proc === "add" )
          {
            change_class_name.add(obj_link_enter, "light_auth_site_view_form");
            change_class_name.add(obj_panel, "light_auth_site_view_form");
            
          }
         else
          {
            change_class_name.delete_cl(obj_link_enter, "light_auth_site_view_form");
            change_class_name.delete_cl(obj_panel, "light_auth_site_view_form");
          }
       }
     
    },
  
  user_action_open_light_auth_2 : function(flag)
    {
     
     flag = (typeof(flag) == "undefined" ? false : flag);
     //var obj_link_enter = engine_elm_html.get_obj("light_auth_site_link_enter");
     
     var obj_panel = engine_elm_html.get_obj("light_auth_site_box_panel");
     var is_class_open = change_class_name.check_is(obj_panel,"light_auth_site_view_form");
     
     var proc = false;
     if ( flag === "close" )
       {
        if ( is_class_open ) proc = "delete";
       }
      else
        if ( is_class_open )
          proc = "delete";
         else
           proc = "add";
     
     if ( proc )
       {
        if ( proc === "add" )
          {
            var this_obj=this;
            //change_class_name.add(obj_link_enter, "light_auth_site_view_form");
            change_class_name.add(obj_panel, "light_auth_site_view_form");
            this.on_open_recently=true;
            
            if (!this.on_first_run)
              {
                document.addEventListener("click", function (e)
                  {
                    this_obj.check_click(e);
                  });
                
                this.on_first_run = true;
              }
            
            setTimeout(function(){this_obj.on_open_recently=false;},100);
          }
         else
          {
            //change_class_name.delete_cl(obj_link_enter, "light_auth_site_view_form");
            change_class_name.delete_cl(obj_panel, "light_auth_site_view_form");
          }
       }
     
    },
  
  check_click: function(e)
    {
      
      var obj=e.target;
      //wconsole(obj);
      var obj_panel = engine_elm_html.get_obj("light_auth_site_box_panel");
      var is_class_open = change_class_name.check_is(obj_panel,"light_auth_site_view_form");
      if (!is_class_open || this.on_open_recently) return (true);
      
      var on_panel=false;
      for (i=0;obj && (obj.tagName !== "BODY");obj=obj.parentNode,i++)
        {
          //wconsole(obj.tagName,obj.id,i);
          //if (obj.tagName == "BODY") break;
          if (obj.id && obj.id === "light_auth_site_box_panel")
            {
              on_panel=true;
              break;
            }
        }
      
      var this_obj=this;
      if (!on_panel)
        {
          this.user_action_open_light_auth_2("close");
          //document.removeEventListener("click",function(e){this_obj.check_click(e);});
        }
      
      return (true);
    }
  
 };


engine_templ.section_list_category = {
  
  init_fn_user_action : function (opts)
    {
     /*
     opts.id_base - id базового блока (первого уровня, к примеру, ul)
     opts.class_elm - класс элемента первого уровня (элемента категории первого уровня)
     opts.class_btn - класс "кнопки-маркера" категорий второго уровня, к нему будет добавляться обработчик событий
     opts.class_inferior_lvl - класс блока с категориями второго уровня
     opts.class_add - класс, который будет добавяться/удаляться к элементу с классом opts.class_elm
     */
     
     var obj_base = engine_elm_html.get_obj(opts.id_base);
     if ( !obj_base ) return (false);
     var mas_obj_btn = getElementsByClassNameGen(opts.class_btn,obj_base);
     
     for (var i = 0; i < mas_obj_btn.length; i++)
       {
        this.init_one_fn(mas_obj_btn[i],i,opts);
       }
     
     return (true);
    },
  
  init_one_fn : function (obj_btn,i,opts)
    {
     var this_obj = this;
     elmAddEventListener(obj_btn,"click",function(obj_click){this_obj.user_action(obj_btn,i,opts);});
    },
  
  user_action : function (obj_btn,i,opts)
    {
     //alert (i);
     var obj_s = obj_btn;
     var obj_elm = false;
     var obj_inferior_lvl = false;
     
     for (var s = 0; s < 5; s++)
       {
        obj_s = obj_s.parentNode;
        if ( change_class_name.check_is(obj_s,opts.class_elm) )
          {
           obj_elm = obj_s;
           break;
          }
       }
     
     if ( !obj_elm ) return;
     
     var mas_s = getElementsByClassNameGen(opts.class_inferior_lvl,obj_elm);
     if ( mas_s.length ) obj_inferior_lvl = mas_s[0];
     
     if ( opts.class_add )
       {
        var is_add_class = change_class_name.check_is(obj_elm,opts.class_add);
        if ( !is_add_class )
          change_class_name.add(obj_elm,opts.class_add);
         else
           change_class_name.delete_cl(obj_elm,opts.class_add);
        
       }
     
    }
  
 };


engine_templ.manager_scroll_page = {
  //onload_start : true,
  view_arrow_top : true,
  view_arrow_bottom : true,
  timer_arrow_top : false,
  timer_arrow_bottom : false,
  obj_top : false,
  obj_bottom : false,
  v_opacity : 80,
  v_delta : 10,
  
  onload_start_action : function()
    {
     
     this.init_first();
    },
  
  init_first : function()
    {
     this.init_html();
     var this_obj = this;
     engine_event_win.add_fun("scroll",function(){this_obj.action_scroll();});
     this.obj_top = engine_elm_html.get_obj("manager_scroll_page_btn_top");
     this.obj_bottom = engine_elm_html.get_obj("manager_scroll_page_btn_bottom");
     this.check_view_arrow();
     obj_processing_block.set_opacity(this.obj_top,this.v_opacity);
     obj_processing_block.set_opacity(this.obj_bottom,this.v_opacity);
     
    },
  
  init_html : function()
    {
     //<div class='box_manager_scroll_page'>
     //<span class='manager_scroll_page_btn_top' id='manager_scroll_page_btn_top' onclick="engine_templ.manager_scroll_page.user_action(1)"></span>
     //<span class='manager_scroll_page_btn_bottom' id='manager_scroll_page_btn_bottom' onclick="engine_templ.manager_scroll_page.user_action(-1)"></span>
     //</div>
     var this_obj = this;
     var obj_box = obj_processing_block.create_block_div("box_manager_scroll_page","content_page","box_manager_scroll_page");
     
     var m_st = [
       ["span",[["id","manager_scroll_page_btn_top"],["class","manager_scroll_page_btn_top fawe"]],"&#xf077;",[["click",function(){ this_obj.user_action(1); }]]],
       ["span",[["id","manager_scroll_page_btn_bottom"],["class","manager_scroll_page_btn_bottom fawe"]],"&#xf078;",[["click",function(){ this_obj.user_action(-1); }]]]
      ];
     
     forming_html_struct_data.write_data(obj_box,m_st);
     
    },
  
  action_scroll : function()
    {
     
     this.check_view_arrow();
    },
  
  user_action : function(v)
    {
     //wconsole(v);
     var this_obj = this;
     var size_page = obj_processing_block.get_size_page();
     var size_window = obj_processing_block.get_size_window();
     var delta_page = obj_processing_block.get_delta_page();
     
     var pos = delta_page.top;
     var max_delta = size_page.height-size_window.height;
     //wconsole(size_page);
     //wconsole(delta_page);
     //wconsole("max_delta "+max_delta);
     //wconsole("pos "+pos);
     /*
     if ( v == 1 )
       engine_elm_html.scrollTo(0,0);
      else
        engine_elm_html.scrollTo(0,max_delta);
     */
     var start = pos;
     var end = ((v == 1)?0:max_delta);
     tools_animation.driver({delay:15,duration:500,delta:"linear",step:function(d){ engine_elm_html.scrollTo(0,start+(end-start)*d); }});
     
     return (false);
    },
  
  check_view_arrow : function()
    {
     var this_obj = this;
     var size_page = obj_processing_block.get_size_page();
     var size_window = obj_processing_block.get_size_window();
     var delta_page = obj_processing_block.get_delta_page();
     //wconsole(delta_page);
     
     var pos = delta_page.top;
     var max_delta = size_page.height-size_window.height;
     var view_top = false;
     var view_bottom = false;
     
     if ( pos <= this.v_delta )
       view_top = false;
      else
        view_top = true;
     if ( pos >= (max_delta - this.v_delta) )
       view_bottom = false;
      else
        view_bottom = true;
     
     if ( this.view_arrow_top != view_top )
       {
        this.action_view_arrow("top",view_top);
       }
     
     if ( this.view_arrow_bottom != view_bottom )
       {
        this.action_view_arrow("bottom",view_bottom);
       }
     
    },
  
  action_view_arrow : function(type,view)
    {
     if ( type == "top" )
       {
        if ( this.timer_arrow_top )
          {
           tools_animation.stop(this.timer_arrow_top);
           this.timer_arrow_top = false;
          }
        
        this.action_view_effect(this.obj_top,view,type);
        this.view_arrow_top = view;
        
       }
      else if ( type == "bottom" )
        {
         if ( this.timer_arrow_bottom )
           {
            tools_animation.stop(this.timer_arrow_bottom);
            this.timer_arrow_bottom = false;
           }
         
         this.action_view_effect(this.obj_bottom,view,type);
         this.view_arrow_bottom = view;
         
        }
    },
  
  action_view_effect : function(obj_arrow,view,type)
    {
     if ( view )
       obj_arrow.style.display = (view ? "block":"none");
     var _this=this;
     var v_opacity = this.v_opacity;
     if ( type == "top" )
       this.timer_arrow_top = tools_animation.driver({
         delay:15,
         duration:500,
         delta:"linear",
         step:function(d){ obj_processing_block.set_opacity(obj_arrow,view ?(v_opacity*d):(v_opacity*(1-d))); },
         complete:function(){ obj_arrow.style.display = (view ? "block":"none"); _this.timer_arrow_top = false; }
        });
      else if ( type == "bottom" )
       this.timer_arrow_bottom = tools_animation.driver({
           delay:15,
           duration:500,
           delta:"linear",
           step:function(d){ obj_processing_block.set_opacity(obj_arrow,view ?(v_opacity*d):(v_opacity*(1-d))); },
           complete:function(){ obj_arrow.style.display = (view ? "block":"none"); _this.timer_arrow_bottom = false; }
        });
    }
  
 };

add_functions_start_on_load(function(){engine_templ.manager_scroll_page.onload_start_action();});


engine_templ.subscribe_content = {
  
  num_user : 0,
  num_author : 0,
  
  action_user_proc: function(num_author,part_id)
    {
      //wconsole("action user proc subscribe content");
      
      this._manager_user_proc(num_author,part_id);
    },
  
  _manager_user_proc: function(num_author,part_id)
    {
      var _this=this;
      this.num_user = (on_user_authorize_site && num_user_authorize_site ? num_user_authorize_site : 0);
      var type_new="on";
      
      if (this.num_user == 0)
        {
          //alert ("Подписаться могут только авторизованные пользователи!");
          engine_templ.inform_user_popup.action("need_authorized","Подписаться на пользователя можно будет после авторизации на сайте.");
          return (false);
        }
      
      if (num_author == this.num_user)
        {
          alert ("Вы пытаетесь подписаться на самого себя!");
          return (false);
        }
      
      var id_btn="btn_proc_subscribe_content_"+part_id+"_"+num_author;
      var obj_btn=engine_elm_html.get_obj(id_btn);
      if (!obj_btn)
        {
          wconsole("Неправильный ID кнопки подписки на контент");
          return (false);
        }
      
      var attr_type=obj_btn.getAttribute("data-on_subscribe");
      //wconsole(attr_type);
      type_new=(attr_type === "off"?"on":"off");
      
      var url=dir_http + "/allinclude/oper_subscribe_content.php";
      var send_data={"oper":"change_subscribe_user", "type":type_new, "num_author": num_author};
      eng_secrt_user_part.add_code_mas(send_data);
      
      var post=encode_assoc_mas_query_ajax(send_data);
      var init_data={"oper":"change_subscribe_user", "type":type_new, "num_author": num_author,"id_btn":id_btn};
      
      loadHTTPjc(url,function(a,b){ _this._obr_serv_manager_user_proc(a,b); },post,init_data);
    },
  
  _obr_serv_manager_user_proc: function(answer,add_param)
    {
      //wconsole(answer,add_param);
      var mdata=answer.data;
      decode_mas(mdata);
      //wconsole(mdata);
      if (mdata.error_proc > 0)
        {
          wconsole("Ошибка при выполнении запроса на изменение подписки на контент",mdata.error_text_proc);
          return (false);
        }
      
      this._proc_show_btn_subscribe(add_param.type,add_param.num_author,add_param.id_btn);
      
    },
  
  _proc_show_btn_subscribe: function(type,num_author,id_btn,on_proc_author)
    {
      // on_proc_author - определяет пользователя, 
      // если равен false - управляет подпиской пользователь
      // если равен true - управляет подпиской автор (при просмотре подписчиков)
      
      if (typeof(on_proc_author) == "undefined") on_proc_author=false;
      var obj_btn=engine_elm_html.get_obj(id_btn);
      if (!obj_btn) return (false);
      
      var mas_txt=(!on_proc_author ? ["Отписаться","Подписаться"]:["Удалить","Восстановить"]);
      obj_btn.setAttribute("data-on_subscribe",type);
      engine_elm_html.set_html(obj_btn,(type == "on"?mas_txt[0]:mas_txt[1]));
      
      if (type == "on")
        {
          change_class_name.add(obj_btn,"btn_subscribe_content_on");
        }
      else
        {
          change_class_name.delete_cl(obj_btn,"btn_subscribe_content_on");
        }
      
      return (true);
    },
  
  action_author_proc: function(num_user,part_id)
    {
      //wconsole("action user proc subscribe content");
      
      this._manager_author_proc(num_user,part_id);
    },
  
  _manager_author_proc: function(num_user,part_id)
    {
      var _this=this;
      this.num_author = (on_user_authorize_site && num_user_authorize_site ? num_user_authorize_site : 0);
      var type_new="on";
      
      if (this.num_author == 0)
        {
          alert ("Управлять подписчиками могут только авторизованные пользователи!");
          return (false);
        }
      /*
      if (num_user == this.num_author)
        {
          alert ("Вы пытаетесь подписаться на самого себя!");
          return (false);
        }
      */
      var id_btn="btn_proc_subscribe_content_"+part_id+"_"+num_user;
      var obj_btn=engine_elm_html.get_obj(id_btn);
      if (!obj_btn)
        {
          wconsole("Неправильный ID кнопки управлением подписки на контент");
          return (false);
        }
      
      var attr_type=obj_btn.getAttribute("data-on_subscribe");
      //wconsole(attr_type);
      type_new=(attr_type === "off"?"on":"off");
      
      var url=dir_http + "/allinclude/oper_subscribe_content.php";
      var send_data={"oper":"change_subscribe_author", "type":type_new, "num_user": num_user};
      eng_secrt_user_part.add_code_mas(send_data);
      
      var post=encode_assoc_mas_query_ajax(send_data);
      var init_data={"oper":"change_subscribe_author", "type":type_new, "num_user": num_user,"id_btn":id_btn};
      
      loadHTTPjc(url,function(a,b){ _this._obr_serv_manager_author_proc(a,b); },post,init_data);
    },
  
  _obr_serv_manager_author_proc: function(answer,add_param)
    {
      //wconsole(answer,add_param);
      var mdata=answer.data;
      decode_mas(mdata);
      //wconsole(mdata);
      if (mdata.error_proc > 0)
        {
          wconsole("Ошибка при выполнении запроса на изменение подписки на контент",mdata.error_text_proc);
          return (false);
        }
      
      this._proc_show_btn_subscribe(add_param.type,add_param.num_author,add_param.id_btn,true);
      
    },
  
};


engine_templ.inform_user_popup = {
  action: function(type,content)
    {
      if (type == "need_authorized")
        {
          this._write_need_authorized(content);
          
        }
    },
  
  _write_need_authorized: function(content)
    {
      var t= "<div class='mesg_need_register'>";
      t+="<div class='marginBottom20'>"+content+"</div>";
      t+="<div><a href='"+dir_http+"/registr/' class='ui_button'>Зарегистироваться</a></div><div class='marginTB10'> или </div><div><a href='"+dir_http+"/registr/enter/' class='ui_button'>Авторизоваться</a></div>";
      t+="</div>";
      
      engine_box_modal.write_box("Для продолжения нужно войти в аккаунт",t,function(){ engine_box_modal.close_box(); },true,{"name_class_box2":"block_modal_box_w400"});
    }
};

engine_templ.likes_content = {
  
  num_user : 0,
  
  action_user_proc: function(num_modul,num_elm,type_status)
    {
      /* wconsole("likes content action");
      wconsole("num_modul",num_modul);
      wconsole("num_elm",num_elm);
      wconsole("type_status",type_status);*/
      this._manager_like_proc(num_modul,num_elm,type_status);
      
    },
  
  _manager_like_proc: function(num_modul,num_elm,status_type)
    {
      var _this=this;
      this.num_user = (on_user_authorize_site && num_user_authorize_site ? num_user_authorize_site : 0);
      var status_new="off";
      
      if (this.num_user == 0)
        {
          //alert ("Оценить публикацию могут только авторизованные пользователи!");
          engine_templ.inform_user_popup.action("need_authorized","Оценить публикацию можно будет после авторизации на сайте.");
          return (false);
        }
      
      var id_btn="elm_like_content_"+(status_type == "plus" ? "plus": "minus")+"_"+num_modul+"_"+num_elm;
      var obj_btn=engine_elm_html.get_obj(id_btn);
      if (!obj_btn)
        {
          wconsole("Неправильный ID кнопки оценки (like)");
          return (false);
        }
      
      var attr_type=obj_btn.getAttribute("data-on_status");
      //wconsole(attr_type);
      status_new=(attr_type === "off"?(status_type == "plus" ? "plus":"minus"):"off");
      
      var url=dir_http + "/allinclude/oper_likes_content.php";
      var send_data={"oper":"change_status_like", "num_modul":num_modul, "num_elm": num_elm, "status":status_new};
      eng_secrt_user_part.add_code_mas(send_data);
      
      var post=encode_assoc_mas_query_ajax(send_data);
      var init_data={"oper":"change_status_like", "num_modul":num_modul, "num_elm": num_elm, "status_type":status_type, "status_new":status_new};
      
      loadHTTPjc(url,function(a,b){ _this._obr_serv_manager_like_proc(a,b); },post,init_data);
      
    },
  
  _obr_serv_manager_like_proc: function(answer,add_param)
    {
      //wconsole(answer,add_param);
      var mdata=answer.data;
      
      if (mdata.error_proc > 0)
        {
          wconsole("Обнареужена ошибка при оценке контента. "+decodeURIComponent(mdata.error_text_proc));
          return (false);
        }
      
      var data_likes=mdata.data_res;
      //wconsole(data_likes);
      this._proc_show_bnt_like_one_elm(add_param["num_modul"],add_param["num_elm"],add_param["status_type"],add_param["status_new"],data_likes);
    },
  
  _proc_show_bnt_like_one_elm: function(num_modul,num_elm,status_type,status_new,data_likes)
    {
      var id_btn_plus="elm_like_content_plus_"+num_modul+"_"+num_elm;
      var id_btn_minus="elm_like_content_minus_"+num_modul+"_"+num_elm;
      var obj_btn_plus=engine_elm_html.get_obj(id_btn_plus);
      var obj_btn_minus=engine_elm_html.get_obj(id_btn_minus);
      //wconsole("status_new "+status_new);
      //var status_v=(status_type == "plus");
      obj_btn_plus.setAttribute("data-on_status",status_new == "plus"?'on':'off');
      obj_btn_minus.setAttribute("data-on_status",status_new == "minus"?'on':'off');
      
      var obj_btn_count_plus=obj_btn_plus.querySelector("[data-on_count]");
      //wconsole("obj_btn_plus",obj_btn_count_plus);
      if (obj_btn_count_plus)
        {
          engine_elm_html.set_html(obj_btn_count_plus, data_likes["count_likes"]);
          obj_btn_count_plus.setAttribute("data-on_count",data_likes["count_likes"] > 0 ? "on":"off");
        }
      
      var obj_btn_count_minus=obj_btn_minus.querySelector("[data-on_count]");
      //wconsole("obj_btn_minum",obj_btn_count_minus);
      if (obj_btn_count_minus)
        {
          engine_elm_html.set_html(obj_btn_count_minus, data_likes["count_dislikes"]);
          obj_btn_count_minus.setAttribute("data-on_count",data_likes["count_dislikes"] > 0 ? "on":"off");
        }
    }
  
  
};



engine_templ.get_image_profile_user = function(data_user)
  {
    //data_user - должна содержать данные пользователя или false
    
    var name_img_default = "img_user_default.jpg";
    
    var path_img="";
    
    if (data_user && data_user["image_user"])
      {
        path_img=dir_http+"/"+name_dir_loadfiles+"/user_image/"+data_user["image_user"];
      }
    else
      {
        path_img=dir_http_template+"/images/"+name_img_default;
      }
    
    return (path_img);
  }



engine_templ.statist_likes_content =
{
  
  action_user_proc: function(num_modul,num_elm)
    {
      //wconsole(num_modul,num_elm);
      this._get_serv_data(num_modul,num_elm,1);
    },
  
  _get_serv_data: function(num_modul,num_elm,num_page)
    {
      var _this=this;
      
      var url=dir_http + "/allinclude/oper_likes_content.php";
      var send_data={"oper":"get_statist_likes", "num_modul":num_modul, "num_elm": num_elm, "num_page":num_page};
      //eng_secrt_user_part.add_code_mas(send_data);
      
      var post=encode_assoc_mas_query_ajax(send_data);
      var init_data={"oper":"get_statist_like", "num_modul":num_modul, "num_elm": num_elm, "num_page":num_page};
      
      loadHTTPjc(url,function(a,b){ _this._obr_serv_statist_likes(a,b); },post,init_data);
    },
  
  _obr_serv_statist_likes: function(answer,add_param)
    {
      
      var error=answer.data.error_proc;
      if (error != 0)
        {
          var text_error=decodeURIComponent(answer.data.error_text_proc);
          wconsole("Ошибка при получении статистики лайков. "+text_error);
          return (false);
        }
      var all_votes=answer.data.data_res.all_votes;
      var all_pages=answer.data.data_res.all_pages;
      var d_votes=answer.data.data_res.d_votes;
      var data_users=answer.data.data_res.data_users;
      decode_mas(data_users);
      
      add_param["all_votes"]=all_votes;
      add_param["all_pages"]=all_pages;
      
      this._write_data(d_votes,data_users,add_param);
      
      return (true);
    },
  
  _write_data: function(d_votes,data_users,init_param)
    {
      var t="";
      
      if (init_param.num_page == 1)
        {
          this._view_bk_main();
    
          if (d_votes.length == 0)
            {
              t = "<div>Нет лайков</div>";
            }
          else
            {
              t = '<div class="statist_likes_list_area">';
              t += '<div class="statist_likes_list_base" id="statist_likes_list_base"></div>';
              t += '<div class="statist_likes_bk_more" id="statist_likes_bk_more" style="display: none;"></div>';//<span class="statist_likes_btn_more">Показать еще</span>
              t += '</div>';
            }
          
          engine_elm_html.set_html("statist_likes_elm_base",t);
        }
      
      if (init_param.all_votes > 0)
        {
          this._view_list_statist(d_votes, data_users, init_param);
          if (init_param.num_page < init_param.all_pages)
            this._view_btn_load_more("view",init_param);
          else
            this._view_btn_load_more("hide",init_param);
        }
    },
  
  _view_bk_main: function()
    {
      var hcode="<div id='statist_likes_elm_base'></div>";
      
      engine_box_modal.write_box("Лайки к публикации",hcode,function(){ engine_box_modal.close_box(); },true);
      
    },
  
  _view_list_statist: function(d_votes,data_users,init_param)
    {
      var one_vote = [], one_user = [], obj_row = false;
      
      for (var i = 0; i < d_votes.length; i++)
        {
          one_vote = d_votes[i];
          if (data_users[one_vote["num_user"]])
            one_user = data_users[one_vote["num_user"]];
          else
            one_user = false;
          
          obj_row = obj_processing_block.create_block_div("statist_likes_list_num_"+one_vote["id_vote"],"statist_likes_list_base","statist_likes_list_one");
          
          engine_elm_html.set_html(obj_row, this._forming_one_row_statist(one_vote, one_user) );
          
        }
      
    },
  
  _forming_one_row_statist: function(one_vote,d_user)
    {
      var t="";
      
      t+='<span class="fawe statist_likes_list-icon">'+(one_vote["status"]==2 ? "&#xf164;":"&#xf165;")+'</span>';
      t+='<span class="statist_likes_list-bk_image"><span class="statist_likes_list-image" style="background-image: url(\''+ engine_templ.get_image_profile_user(d_user) +'\');"></span></span>';
      t+='<span class="statist_likes_list-name"> '+(d_user ? '<a href="'+dir_http+'/registr/user'+d_user["id_user"]+'.html'+'">'+d_user['name_user']+'</a>':'нет данных')+'</span>';
      
      //t+='<span> '+one_vote["status"]+' </span>';
      
      return (t);
    },
  
  _view_btn_load_more: function(type,init_param)
    {
      var bk_more_name="statist_likes_bk_more";
      var obj_bk_more=engine_elm_html.get_obj(bk_more_name);
      var _this=this;
      if (type == "view")
        {
          obj_bk_more.style.display="block";
          var st_btn=[["span",[["class","statist_likes_btn_more"]],"Показать еще",[["click",function(){ _this.action_load_more(init_param); }]]]];
          forming_html_struct_data.write_data(obj_bk_more,st_btn);
        }
      else
        {
          obj_bk_more.style.display="none";
          engine_elm_html.set_html(obj_bk_more,"");
        }
      
      return (true);
    },
  
  action_load_more: function(init_param)
    {
      
      this._get_serv_data(init_param.num_modul,init_param.num_elm,init_param.num_page+1);
      
    }
  
};

