

/* файл slideshow */

function eng_slideshow_work()
  {
    this.mas_obj_item = [];
    this.obj_main_box = false;
    this.obj_items_box = false;
    this.num_rotation = null;
    this.num_previous = null;
    this.time_pause_rotation = 5000; //время паузы в милисекундах
    
    this.time_split_effect = 50;
    this.on_effect = false;
    this.delta_effect = 10;
    this.v_effect = 0;
    this.ident_pause_rotation = false;
    this.ident_split_effect = false;
    this.on_cursor_over=false;
    this.on_touch=false;
    
    this.init_work = function()
      {
        
        this.obj_main_box = document.getElementById("box_main_slideshow");
        this.obj_items_box = document.getElementById("block_slideshow_items");
        
        if (!this.obj_main_box) return;
        
        var list_obj = this.obj_main_box.getElementsByTagName("div");
        
        for (var i = 0; i < list_obj.length; i++)
          {
            
            if (list_obj[i].getAttribute("data-slideshow") == null) continue;
            this.mas_obj_item[this.mas_obj_item.length] = list_obj[i];
            
          }
        
        if (this.mas_obj_item.length <= 1) return (true);
        
        this.num_rotation = 0;
        this.num_previous = this.mas_obj_item.length;
        
        this.init_service();
        this.output_btn();
        this.output_indicators();
        this.set_status_indicators();
        this.cycle_rotation();
        
        return (true);
      }
    
    this.init_service = function()
      {
        var this_obj=this;
        
        elmAddEventListener(this.obj_main_box,"mouseover",function(){ this_obj.action_mouse_move(1); });
        elmAddEventListener(this.obj_main_box,"mouseout",function(){ this_obj.action_mouse_move(-1); });
        
        this.obj_touch = new engine_touch_step(this_obj,{"elm_base":this.obj_main_box,
          "fn_action_back":function(v){this_obj.action_next(-v);},"fn_set_back_on_touch":function(v){this_obj.on_touch=v;} },{}
         );
      }
    
    this.action_mouse_move = function (v)
      {
        //wconsole("cursov move "+v);
        if (v > 0)
          this.on_curser_over = true;
         else
           this.on_curser_over = false;
        
        return (true);
      }
    
    this.output_btn = function ()
      {
        var this_obj=this;
        var obj_b=engine_elm_html.get_obj("box_outer_slideshow");
        
        var obj_next=obj_processing_block.create_elm_tag("btn_next_slideshow",obj_b,"btn_next_slideshow",false,"div");
        var obj_prev=obj_processing_block.create_elm_tag("btn_prev_slideshow",obj_b,"btn_prev_slideshow",false,"div");
        
        obj_next.onclick=function(){ this_obj.action_next(1); };
        obj_prev.onclick=function(){ this_obj.action_next(-1); };
      }
    
    this.output_indicators = function()
      {
        
        var mas_st=[];
        var this_obj=this;
        
        for (var i = 0; i < this.mas_obj_item.length; i++)
          {
            
            mas_st.push(this_obj.forming_one_indicator(i));
          }
        
        forming_html_struct_data.write_data("box_indicators_slideshow",mas_st);
      }
    
    this.forming_one_indicator = function(num)
      {
        var this_obj=this;
        var one_st=["span",[["class","one_indicator_slideshow"],["id","one_indicator_slideshow_n"+num]],"",[["click",function(){ this_obj.click_num_rotation(num); }]]];
        return (one_st);
      }
    
    this.set_status_indicators = function()
      {
        
        this.set_one_status_indicator(this.num_rotation, "on");
        
        for (var i = 0; i < this.mas_obj_item.length; i++)
          {
            if (i == this.num_rotation) continue;
            this.set_one_status_indicator(i, "off");
          }
        
      }
    
    this.set_one_status_indicator = function(num_view, type)
      {
        
        var obj = document.getElementById("one_indicator_slideshow_n" + num_view);
        if (type == "on")
          {
            //obj.className = "span_link_slideshow_active";
            change_class_name.add(obj,"one_indicator_slideshow_active");
          }
        else
          {
            //obj.className = "span_link_slideshow_inactive";
            change_class_name.delete_cl(obj,"one_indicator_slideshow_active");
          }
        
      }
    
    
    this.cycle_rotation = function()
      {
        var this_obj=this;
        this.clear_timer_cycle();
        
        this.ident_pause_rotation = setTimeout(function ()
        {
          this_obj.action_rotation(false,true);
        }, this.time_pause_rotation);
        
      }
    
    this.clear_timer_cycle = function()
      {
        if (this.ident_pause_rotation !== false)
          {
            clearTimeout(this.ident_pause_rotation);
            this.ident_pause_rotation=false;
          }
        return (true);
      }
    
    this.action_rotation = function(next_num,on_auto)
      {
        if (typeof (next_num) == "undefined") next_num = false;
        
        if (this.ident_pause_rotation) clearTimeout(this.ident_pause_rotation);
        this.ident_pause_rotation = false;
        
        //Статус вкладки
        var vState=false;
        if (document.visibilityState) vState=document.visibilityState;
        //wconsole("Статус вкладки",vState);
        
        if (on_auto && (this.on_curser_over || this.on_touch || vState === "hidden"))
          {
            this.cycle_rotation();
            return (true);
          }
        
        if (this.num_rotation === null) return;
        
        this.num_previous = this.num_rotation;
        
        if (next_num === false)
          {
            this.num_rotation++;
            
            if (this.mas_obj_item.length <= this.num_rotation)
              this.num_rotation = 0;
          }
        else
          {
            this.num_rotation = next_num;
          }
        
        
        this.set_status_indicators();
        
        this.action_effect();
        
        this.cycle_rotation();
        
      }
    
    this.action_effect = function()
      {
        var pos_x=-this.num_rotation * 100;
        
        this.obj_items_box.style.transform="translateX("+pos_x+"%)";
      }
    
    this.click_num_rotation = function(next_num)
      {
        //wconsole(next_num);
        if (next_num == this.num_rotation) return;
        
        this.clear_timer_cycle();
        
        this.action_rotation(next_num,false);
        
      }
    
    this.action_next = function(direction)
      {
        //wconsole("direction "+direction);
        this.clear_timer_cycle();
        var nn=this.num_rotation + direction;
        var numb_all=this.mas_obj_item.length;
        
        if (nn < 0)
          {
            nn = numb_all-1;
          }
        else if (nn >= numb_all)
          {
            nn =0;
          }
        
        this.action_rotation(nn,false);
        
        return (true);
      }
    
  }


add_functions_start_on_load(function(){var obj_slideshow = new eng_slideshow_work(); obj_slideshow.init_work(); });
