<?php



class dmk_compiler
  {
   
   public $left_delimiter = '{';
   public $right_delimiter = '}';
   public $left_comment_delimiter = '{*';
   public $right_comment_delimiter = '*}';
   public $t = "";
   public $mas_fileTpl = array();
   public $nameFileTpl = "";
   public $numStr = 0;
   public $vsegoStr = 0;
   public $oneStr = "";
   public $type_search = "";
   public $pos_search = "";
   public $error_compile = false;
   public $code = "";
   public $write_one_param = true;
   public $param_to_block = false;
   public $mas_load_block = array();
   public $mas_registr_block = array();
   public $mas_stack_block = array();
   public $mas_load_modifier = array();
   public $on_not_compile = false;
   public $mas_init_const = array();
   public $on_not_write_txt = false;
   public $mas_vars_not_compile = array();
   
   function __construct()
     {
      $this->init();
     }
   
   function init()
     {
      $this->list_models_regexp = array(
         "var" =>  "\\$[_a-zA-Z][\w]*",// переменная $var 
         // переменная $var $var2.key1 $var2.$var3 $var4.["keyStr"] $var5.['keyStr'] $var6.key2['keyStr']
         "vars" =>  "\\$[_a-zA-Z][\w]*"
         ."( (\\. (\\$[_a-zA-Z][\w]* | [\w]+) )*"."( \[[\s]*\\$[_a-zA-Z][\w]*[\s]*\] | \[[\s]*\"(\\\.|[^\"\\\])*\"[\s]*\] | \[[\s]*'(\\\.|[^'\\\])*'[\s]*\] )* )*",
         
         //"var" =>  "/^\\$[_a-zA-Z][\w]*(\\.(\\$)?[_a-zA-Z][\w]*)*$/uis",// переменная $var $var2.key1 $var2.$var3
         //  "/^\\$[_a-zA-Z][\w]*(\[(\\$)?[_a-zA-Z][\w]*\])*$/uis",// переменная $var1 $var2[key1] $var3[$key]
         //  '/^\\$[_a-zA-Z][\w]*(\["(\\$)?[_a-zA-Z][\w]*"\])+$/uis',// переменная $var2["key1"] $var3["$key"]
         //  "/^\\$[_a-zA-Z][\w]*(\['(\\$)?[_a-zA-Z][\w]*'\])+$/uis",// переменная $var2['key1'] $var3['$key']
         "numeric" =>  "(-)?[\d]+(\\.[\d]+)?",//число
         "text1" =>  '"(\\\.|[^"\\\])*"',// текст в ""
         "text2" =>  "'(\\\.|[^'\\\])*'",// текст в ''
         "function" => "[_a-zA-Z][\w]*",// имя функции
         "constanta" => "[_a-zA-Z][\w]*",// имя функции
       );
      
      $this->mas_init_const["rdelim"] = '"'.$this->right_delimiter.'"';
      $this->mas_init_const["ldelim"] = '"'.$this->left_delimiter.'"';
      $this->mas_vars_not_compile = array("GLOBALS");
      
     }
   
   function compile_mas($mas_fileTpl,$nameFile)
     {
      
      //$this->t = "";
      $this->on_not_compile = false;
      $this->mas_fileTpl = $mas_fileTpl;
      $this->nameFileTpl = $nameFile;
      $this->compile_proc($mas_fileTpl);// implode("",$mas_fileTpl);
      
      $this->add_text_compile_tpl = "";
      
      $this->add_include_files_modifier();
      
      $this->t = "<?php\n".$this->add_text_compile_tpl."\n?>".$this->t;
      
      return($this->t);
     }
   
   function add_include_files_modifier()
     {
      $t = "";
      if ( sizeof($this->mas_load_modifier) )
        {
         foreach ( $this->mas_load_modifier as $one_modifier )
           {
            $t .= "include_once ('".DIR_PLUGIN_TEMPLATING_DMK."modifier.".$one_modifier.".php');\n";
           }
        }
      if ( $t )
        {
         $this->add_text_compile_tpl = $t;
        }
     }
   
   function compile_proc()
     {
      $this->numStr = 0;
      $this->vsegoStr = sizeof($this->mas_fileTpl);
      
      $this->t = "";
      $this->type_search = "";
      $this->pos_search = 0;
      
      $this->open_pos = false;
      $this->open_strNum = 0;
      $this->close_pos = false;
      $this->close_strNum = 0;
      
      //$this->t_html = "";
      //$this->b_code = "";
      //$this->st = "";
      
      $begin_pos = 0;
      $begin_strNum = 0;
      
      $on_search = true;
      do {
         $this->code = "";
         $name_search = $this->searchOneStr();
         if ( $this->type_search == "" )
           {
            $this->t .= $this->extract_poss_mas($begin_pos,$begin_strNum,mb_strlen($this->mas_fileTpl[$this->vsegoStr-1]),$this->vsegoStr-1);
            $on_search = false;
           }
          elseif ( $name_search == "" )
            {
             //ошибка - не найден закрывающий элемент
             //$this->t .= "ошибка - не найден закрывающий элемент";
             //$on_search = false;
             $this->alert_error("не найден закрывающий элемент");
            }
           else
             {
              if ( $name_search == "comment" )
                {
                 if ( !$this->on_not_write_txt )
                   $this->t .= $this->extract_poss_mas($begin_pos,$begin_strNum,$this->open_pos,$this->open_strNum);
                 
                 //$this->t .= $this->extract_poss_mas($this->open_pos,$this->open_strNum,$this->close_pos,$this->close_strNum);
                 
                 $begin_pos = $this->close_pos+mb_strlen($this->right_comment_delimiter);
                 $begin_strNum = $this->close_strNum;
                 
                }
               elseif ( $name_search == "code" )
                 {
                  if ( !$this->on_not_write_txt )
                    $this->t .= $this->extract_poss_mas($begin_pos,$begin_strNum,$this->open_pos,$this->open_strNum);
                  
                  $this->code = $this->extract_poss_mas($this->open_pos+mb_strlen($this->left_delimiter),$this->open_strNum,$this->close_pos,$this->close_strNum);
                  
                  $this->parseOneTag();
                  
                  if ( $this->error_compile )
                    {
                     //$on_search = false;
                    }
                  
                  $begin_pos = $this->close_pos+mb_strlen($this->right_delimiter);
                  $begin_strNum = $this->close_strNum;
                  
                 }
              
             }
         
         if ( $this->error_compile )
           {
            $on_search = false;
           }
         
        }
      while ( $on_search );
      
      
      
     }
   
   function searchOneStr()
     {
      
      $this->type_search = "";
      
      //$name_search = "";
      $cycle_search = true;
      $new_stroka = true;
      
      do {
        $new_stroka = true;
        $this->oneStr = $this->mas_fileTpl[$this->numStr];
        
        $lenstr = mb_strlen($this->oneStr);
        
        if ( $this->on_not_compile )
          {
           //ищем закрывающий тег при текущем режиме не компилировать
           $reg = "~".addcslashes($this->left_delimiter,"{}*[]")." */[\w]* *".addcslashes($this->right_delimiter,"{}*[]")."~uis";
           if ( preg_match($reg,$this->oneStr,$matches,PREG_OFFSET_CAPTURE,$this->pos_search) )
             {
              $this->open_strNum = $this->numStr;
              $this->close_strNum = $this->numStr;//var_dump($matches);
              $this->open_pos = $matches[0][1];
              $this->close_pos = $this->open_pos + mb_strlen($matches[0][0])-mb_strlen($this->right_delimiter);
              $this->pos_search = $this->close_pos + 1;//echo("закрывающий тег literal ");
              $this->type_search = $this->left_delimiter;
              return ("code");
             }
           
          }
        elseif ( $this->type_search == "" )
          {
           $open_pos_comment = false;
           $open_pos_comment = mb_strpos($this->oneStr,$this->left_comment_delimiter,$this->pos_search);
           $open_pos_code = mb_strpos($this->oneStr,$this->left_delimiter,$this->pos_search);
           if ( $open_pos_comment !== false && $open_pos_code !== false )
             {
              if ( $open_pos_comment <= $open_pos_code )
                $open_pos_code = false;
               else
                 $open_pos_comment = false;
             }
               
           if ( $open_pos_comment !== false )
             {
              $this->open_pos = $open_pos_comment;
              $this->open_strNum = $this->numStr;
              $this->type_search = $this->left_comment_delimiter;
              $this->pos_search = $this->open_pos+1;
              //$name_search = "comment";
              $new_stroka = false;
             }
            elseif ( $open_pos_code !== false )
              {
               $this->open_pos = $open_pos_code;
               $this->open_strNum = $this->numStr;
               $this->type_search = $this->left_delimiter;
               $this->pos_search = $this->open_pos+1;
               //$name_search = "code";
               $new_stroka = false;
              }
           
          }
         elseif ( $this->type_search == $this->left_comment_delimiter )
           {
            if ( ( $this->close_pos = mb_strpos($this->oneStr,$this->right_comment_delimiter,$this->pos_search) ) !== false )
              {
               $this->close_strNum = $this->numStr;
               $this->pos_search = $this->close_pos+1;
               return("comment");
              }
            
           }
          elseif ( $this->type_search == $this->left_delimiter )
            {
             if ( ( $this->close_pos = mb_strpos($this->oneStr,$this->right_delimiter,$this->pos_search) ) !== false )
               {
                $this->close_strNum = $this->numStr;
                $this->pos_search = $this->close_pos+1;
                
                return("code");
               }
             
            }
         
         if ( $new_stroka )
           {
            if ( $this->numStr < ( $this->vsegoStr - 1 ) )
              {
               $this->numStr++;
               $this->pos_search = 0;
              }
             else
               {
                $cycle_search = false;
               }
           }
         
        }
      while ( $cycle_search );
      
      return ("");
     }
   
   function extract_poss_mas($begin_pos,$begin_numStr,$end_pos,$end_numStr)
     {
      
      $t = "";
      if ( $begin_numStr == $end_numStr )
        {
         $t .= mb_substr($this->mas_fileTpl[$begin_numStr],$begin_pos,$end_pos-$begin_pos);
        }
       elseif ( $begin_numStr < $end_numStr )
         {
          $t .= mb_substr($this->mas_fileTpl[$begin_numStr],$begin_pos,mb_strlen($this->mas_fileTpl[$begin_numStr])-$begin_pos);
          for ( $n = $begin_numStr+1; $n < $end_numStr ; $n++ )
            $t .= $this->mas_fileTpl[$n];
          $t.= mb_substr($this->mas_fileTpl[$end_numStr],0,$end_pos);
          
         }
      return ($t);
     }
   
   function parseOneTag()
     {
      $this->write_one_param = true;
      $this->param_to_block = false;
      
      $code = trim($this->code);
      if ( mb_strpos($code,"?") === 0 )
        {
         $this->write_one_param = false;
         $code = trim(mb_substr($code,1,mb_strlen($code)-1));
        }
      if ( $code == "" )
        {
         //строка пустая
         $this->alert_error("не указан код");
         return (false);
        }
      
      $this->parseTagString($code,true);//парсим строку одного тега (код шаблонизатора)
      
     }
   
   function setWriteOneParam($v)
     {
      //устанавливаем флаг вывода данных текущего тега
      $this->write_one_param = $v;
     }
   function setStatusBlock($v)
     {
      $this->param_to_block = $v;
     }
   
   function setNotCompile($v)
     {
      $this->on_not_compile = $v;
     }
   
   function setNotWriteTxt($v)
     {
      $this->on_not_write_txt = $v;
     }
   
   function alert_error($t_error,$write_str = true,$write_code = true)
     {
      $this->error_compile = true;
      $this->t = "\n<br><i>Сообщение шаблонизатора:</i> $t_error";
      if ( $write_str )
        $this->t .= "\n<br>Файл: ".$this->nameFileTpl.", строка: ".($this->numStr+1);
      if ( $write_code )
        $this->t .= "\n<br>Тег: {".$this->code."}";
      $this->t .= "\n<br>";
      return (false);
     }
   
   function parseTagString($code)
     {
      //парсим одну строку кода шаблонизатора (один тег)
      if ( ( $t = $this->parseCodeString(trim($code),true) ) === false ) return(false);
      if ( $t === null )
        {
         //ничего не добавляем в шаблон
         
        }
       elseif ( !$this->on_not_compile )
         $this->t .= "<?php ".(!$this->param_to_block && $this->write_one_param ? "echo " : "" ).$t.($this->param_to_block  ? "":";" )." ?>";
        else
          $this->t .= $this->left_delimiter.$this->code.$this->right_delimiter;
     }
   
   function parseCodeString($code,$on_check_tagBlock=false)
     {
      //функция вернет распарсенный текст $t или false в случае какой-либо ошибки
      //$code = trim($code);
      $t = "";
      $mas_divide = $this->split_text_bracket($code);//разделяем строку на блоки в скобках, 
      //вложенные скобки не учитываются, указывается в только присутствие вложенных скобок (в возвращаемом массиве)
      
      if ( $mas_divide === false )
        {
         $this->alert_error("не найдена открывающая или закрывающая скобка.");
         return (false);
        }
      
      //var_dump($a);
      
      if ( !sizeof($mas_divide) )
        {
         $this->alert_error("пустой тег.");
         return(false);
        }
      
      $i = 0;
      $on_repeat = true;
      $is_block = false;
      $text_block = "";
      
      $size_mas_divide = sizeof($mas_divide);
      
      $on_not_compile = $this->on_not_compile;
      
      do
        {
         $on_check = false;
         
         if ( !$on_check && $i == 0 && $on_check_tagBlock && !$mas_divide[0][1] )
           {
            // проверяем строку на блоковую конструкцию (блок или нет)
            //$this->search_modifier_line_str($mas_divide[0][0]);
            
            if ( !$on_not_compile && preg_match("/^".$this->list_models_regexp["function"]."/uis",$code,$matches) )
              {
               // код содержит либо оператор (блоковая конструкция) либо функцию
               //$all = $matches[0];
               $name= $matches[0];
               $end = $this->cut_begin_part_str($code,$name);
               $name = mb_strtolower($name);
               $data = $this->check_on_block($name);
               
               if ( $data !== false )
                 {
                  //name - блок
                  
                  $this->setStatusBlock(true);
                  
                  $dataBlock = $this->mas_load_block[$name]->driver($name,$end,$this,"");
                  if ( $dataBlock === false ) return(false);
                  $text_block = $dataBlock[0];
                  $on_check = true;
                  $on_repeat = false;
                  $is_block = true;
                  
                  //если это открывающий тег, то 
                  if ( $dataBlock[2] )
                    {
                     //добавляем в стек название блока
                     $this->mas_stack_block[] = array($name,$name);
                    }
                  
                 }
               
               //$this->t .= "%".$name."%".$end."%";
               
               if ( !$on_check )
                 {
                  //проверяем на дополнительные теги
                  $on_addition_teg = false;
                  $name_block = "";
                  foreach ( $this->mas_registr_block as $s_name => $mas_tegs )
                    {
                     //if ( $name !== $s_name ) continue;
                     foreach ( $mas_tegs as $one_teg )
                       {
                        if ( $name === $one_teg )
                          {
                           $on_addition_teg = true;
                           $name_block = $s_name;
                           break (2);
                          }
                       }
                    }
                  
                  if ( $on_addition_teg )
                    {
                     list($name_block_stack,$previous_teg) = end($this->mas_stack_block);
                     $n_key = key($this->mas_stack_block);
                     
                     $this->setStatusBlock(true);
                     
                     $dataBlock = $this->mas_load_block[$name_block]->driver($name,$end,$this,$previous_teg);
                     if ( $dataBlock === false ) return(false);
                     $text_block = $dataBlock[0];
                     $on_check = true;
                     $on_repeat = false;
                     $is_block = true;
                     
                     $this->mas_stack_block[$n_key][1] = $name;
                     
                    }
                  
                 }
               
              }
            
            $on_name_teg_close = false;
            
            if ( !$on_check && ($code === "/" || 
                ( $on_name_teg_close = preg_match("/^\\/".$this->list_models_regexp["function"]."/uis",$code,$matches) )) )
              {
               //найден закрывающий тег
               $this->setStatusBlock(true);
               
               if ( !sizeof($this->mas_stack_block) )
                 {
                  
                  return ($this->alert_error("найден лишний закрывающий тег."));
                 }
               
               $last_tag = end($this->mas_stack_block);
               if ( $on_name_teg_close )
                 {
                  
                  $end = $this->cut_begin_part_str($code,$matches[0]);
                  
                  $name_close = $this->cut_begin_part_str($matches[0],"/");
                  //echo($name_close);
                  
                  if ( $last_tag[0] !== $name_close )
                    {
                     if ( $on_not_compile )
                      {
                       //если комплировать код не надо, то выходим из цикла - ищем только соответствующий закрывающий тек
                       break;
                      }
                     else
                      return ($this->alert_error("синтаксическая ошибка - нарушена вложенность элементов"));
                    }
                  
                  if ( trim($end) ) return ($this->alert_error("синтаксическая ошибка - в закрывающем теге недолжно быть других элементов"));
                 }
               
               $dataBlock = $this->mas_load_block[$last_tag[0]]->driver("close","",$this,$last_tag[1]);
               if ( $dataBlock === false ) return(false);
               $text_block = $dataBlock[0];
               $on_check = true;
               $on_repeat = false;
               $is_block = true;
               
               //удаляем из стека название блока
               array_pop($this->mas_stack_block);
               
              }
            
           }
         
         if ( $on_not_compile )
           {
            $on_ckeck = true;$on_repeat = false;
           }
         
         /*
         if ( !$on_check && !$mas_divide[$i][1] && (( $i + 1 ) < $size_mas_divide) && $mas_divide[$i+1][1] )
           {
            //проверяем, является ли функцией текст перед скобками
            
            if ( preg_match("/(".$this->list_models_regexp["function"].")[\s]*$/uis",$mas_divide[$i][0],$matches,PREG_OFFSET_CAPTURE,0) )
              {
               //$this->t .= "*".$matches[0][0]."*";
               $data_name = $matches[1];
               $name = $data_name[0];
               
               $begin_text = mb_substr($mas_divide[$i][0],0,$data_name[1]);
               if ( !$begin_text || ( $begin_text && mb_substr($begin_text,mb_strlen($begin_text)-1,1) !== "$" ) )
                 {
                  
                  //$this->t .= "@-".$begin_text."-@".$name."@";
                  //проверяем существует ли функция, если нет, то выводим сообщение
                  
                 }
               
              }
           }
         */
         
         if ( !$on_check && $mas_divide[$i][2] )
           {
            //в этом участке есть вложенные скобки
            //рекурсивно передаем текущей функции данный участок
            $vl = $this->parseCodeString($mas_divide[$i][0],false);
            
            if ( $vl === false ) return (false);
            $on_check = true;
            $mas_divide[$i][0] = $vl;
           }
         
         if ( !$on_check && !$mas_divide[$i][2] )
           {
            //на этом участке нет вложенных скобок
            $mas_divide[$i][0] = $this->replace_tpl_vars($mas_divide[$i][0]);
            if (($mas_divide[$i][0] = $this->search_modifier_line_str($mas_divide[$i][0])) === false) return (false);
            
            if ( $i > 0 && !$mas_divide[$i][1] && $mas_divide[$i-1][1] )
              {
               //проверим наличие модификатора после скобок на предыдущем участке
               
               if( preg_match("/^\\|".$this->list_models_regexp["function"]."(:("
                 .$this->list_models_regexp["vars"]."|".$this->list_models_regexp["numeric"]."|".$this->list_models_regexp["text1"]
                 ."|".$this->list_models_regexp['text2']."|".$this->list_models_regexp['constanta']
                 ."))*/uisx",$mas_divide[$i][0],$matches,PREG_OFFSET_CAPTURE,0) )
                 {
                  
                  $all_str_modifier=$matches[0][0];
                  
                  $str_modifier = $this->cut_begin_part_str($all_str_modifier,"|");
                  
                  if(($data_modifier = $this->parse_code_modifier($str_modifier)) === false) return(false);
                  
                  if (($nameModifier = $this->check_name_modifier($data_modifier[0])) === false) return(false);
                  $data_modifier[0] = $nameModifier;//меняем назнвание модификатора на соответствующую функцию
                  //$this->t .= "modifier: ".$str_modifier;
                  
                  $mas_divide[$i][0] = $this->cut_begin_part_str($mas_divide[$i][0],$all_str_modifier);
                  $on_basket = true;
                  $all_function = "";
                  $data_function = array();
                  if ( $i > 1 && !$mas_divide[$i-2][1] )
                    {
                     //проверим, есть ли перед скобками функция, если есть то модификатор будет дейстовать на функцию
                     if ( preg_match("/(".$this->list_models_regexp["function"]."|".$this->list_models_regexp["vars"].")[\s]*$/uisx",$mas_divide[$i-2][0],$matches,PREG_OFFSET_CAPTURE,0) )
                       {
                        $all_function = $matches[0][0];
                        $data_function = $matches[0];
                        $on_basket = false;
                        //$this->t .= "funct_modif: ".$all_function;
                        
                       }
                    }
                  
                  if ( !$on_basket )
                    {
                     //модификатор действует на функцию стоящую перед скобками
                     $mas_divide[$i-2][0] = mb_substr($mas_divide[$i-2][0],0,$data_function[1]);
                     $mas_divide[$i-2][0] .= $data_modifier[0]."(".$all_function;
                     $mas_divide[$i][0] = ")".$mas_divide[$i][0];
                     if ( sizeof($data_modifier[1]) )
                       {
                        $t_m = "";
                        foreach ( $data_modifier[1] as $one_m )
                          $t_m .= ",".$one_m;
                        $mas_divide[$i][0] = $t_m.$mas_divide[$i][0];
                       }
                     
                    }
                   else
                     {
                      //модификатор действует только на содержимое скобок
                      $mas_divide = $this->move_elements_mas($mas_divide,$i-1,1);//сдвигаем массив на один элемент
                      $mas_divide[$i-1] = array($data_modifier[0],false,0);//добавляем функцию - модификатор
                      $t_m = "";
                      if ( sizeof($data_modifier[1]) )
                        {
                         foreach ( $data_modifier[1] as $one_m )
                           $t_m .= ",".$one_m;
                         $mas_divide[$i+1][0] = $t_m.$mas_divide[$i+1][0].")";
                         $mas_divide[$i-1][0] .= "(";
                        }
                      $i++;
                      $size_mas_divide = sizeof($mas_divide);
                     }
                 }
               
              }
            
            //$mas_divide[$i][0] = $this->replace_tpl_vars($mas_divide[$i][0]);
            $is_end_function = false;
            if ( !$mas_divide[$i][1] && !empty($mas_divide[$i+1]) && $mas_divide[$i+1][1]  )
              $is_end_function = true;
            $mas_divide[$i][0] = $this->replace_tpl_const( $mas_divide[$i][0],$is_end_function);
            
           }
         
         
         
         $i++;
        }
      while ($on_repeat && ( $i < $size_mas_divide));
      
      if ( $is_block )
        $t = $text_block;
       else
         {
          for ( $i = 0 ; $i < $size_mas_divide; $i++)
            {
             $t .= ($mas_divide[$i][1] ? "(":"" ).$mas_divide[$i][0].($mas_divide[$i][1] ? ")":"" );
            }
         }
      
      return ($t);
     }
   
   function replace_tpl_vars($code)
     {
      //заменяем переменные шаблона, на переменные шаблонизатора
      $mas_data = $this->split_text_quotes($code,true,"[","]");
      //var_dump($mas_data);
      //echo("\n<div>-->".$code."</div>\n");
      $t = "";
      
      foreach ( $mas_data as $one_t )
        {
         if ( $one_t[1] == "quotes" )
           {
            $t .= $one_t[0];
            continue;
           }
         if ( $one_t[1] == "code" )
           {
            $t .= preg_replace_callback("/".$this->list_models_regexp["vars"]."/uisx",array(&$this,"replace_in_one_var"),$one_t[0]);
            
           }
         if ( $one_t[1] == "dbquotes" )
           {
            $t.=$this->replace_in_one_var_dbquotes($one_t[0]);
           }
        }
      //echo("\n<div>||>".$t."</div>\n");
      return ($t);
     }
   
   function replace_in_one_var($matches)
     {
      //парсим текст найденной переменной и заменяем на переменную шаблонизатора
      $t = "";
      //var_dump($matches);
      $v = $matches[0];
      $mas = $this->split_text_quotes($v,false,"[","]");
      //var_dump($mas);
      foreach ( $mas as $one_v )
        {
         if ( $one_v[1] == "quotes" )
           {
            $t .= $one_v[0];
            continue;
           }
         if ( $one_v[1] == "code" )
           {
            $t .= $this->replace_in_one_var_code($one_v[0]);
           }
         if ( $one_v[1] == "dbquotes" )
           {
            //echo("==".$one_v[0]."==");
            $t.=$this->replace_in_one_var_dbquotes($one_v[0]);
           }
        }
      
      return($t);
     }
   
   function _replace_in_one_var_code($v)
     {
      //заменяем переменные в найденном тексте одной переменной не содержащей текст в кавычках
      
      $v = preg_replace("/\\$([_a-zA-Z][\w]*)/uis","\$vars['\\1']",$v);
      $v = preg_replace("/\\.([\w]+)/uis","['\\1']",$v);
      
      return ($v);
     }
   
   function replace_in_one_var_code($v)
     {
      //заменяем переменные в найденном тексте одной переменной не содержащей текст в кавычках
      
      $v = preg_replace_callback("/\\$([_a-zA-Z][\w]*)/uis",array(&$this,"replace_name_one_var"),$v);
      $v = preg_replace("/\\.([\w]+)/uis","['\\1']",$v);
      
      return ($v);
     }
   
   function replace_name_one_var($v)
     {
      if ( in_array( $v[1], $this->mas_vars_not_compile ) )
         $v = "\$".$v[1];
       else
          $v = "\$vars['".$v[1]."']";
      
      return ($v);
     }
   
   function replace_in_one_var_dbquotes($v)
     {
      //заменяем переменную вида $var в тексте заключенном в двойных кавычках
      //причем переменную выносим из текста
      
      $v = preg_replace("/\\$([_a-zA-Z][\w]*)/uis","\".\$vars['\\1'].\"",$v);
      $v = str_replace('"".','',$v);
      $v = str_replace('.""','',$v);
      
      return($v);
     }
   
   function replace_tpl_const($t,$is_end_function = false)
     {
      //echo( "<div> анализируемая строка: ".$t."</div>" );
      if ( $is_end_function )
        {
         //проверяем, есть ли функция в конце строки
         
         if ( preg_match("/(\\$?".$this->list_models_regexp["function"].")[\s]*$/uis",$t,$matches,PREG_OFFSET_CAPTURE,0) )
           {
            //$this->t .= "*".$matches[0][0]."*";
            $data_name = $matches[0];
            $name = $data_name[0];
            //echo(" functions -> ".$name."<br>\n");
            $begin_text = mb_substr($t,0,$data_name[1]);
            if ( !trim($begin_text) )
              return ($t);
             else
              {
               $v = $this->replace_tpl_const($begin_text);
               return ( $v === false ? false : $v . $name);
               
              }
           }
        }
      
      /*
      if ( preg_match("/^[\s]*(".$this->list_models_regexp["function"].")[\s]*$/uis",$t,$matches,PREG_OFFSET_CAPTURE,0) )
        {
         $data_name = $matches[1];
         $name = $data_name[0];
         
         $begin_text = mb_substr($t,0,$data_name[1]);
         $end_text = mb_substr($t,$data_name[1]+mb_strlen($name),mb_strlen($t)-$data_name[1]-mb_strlen($name));
         echo(" CONST -> ".$name."<br>\n");
         
         //проверяем и заменяем в случае необходимости константу
         //...
         $newConst = "Тут должна быть константа";
         echo ( "%".$begin_text."%".$end_text."%" );
         $t = $begin_text.$newConst.$end_text;
         if ( !trim($end_text) ) return ($t);
         echo(" # ".$begin_text." # ");
        }
      */
      
      $mas_t = $this->split_text_quotes($t,$use_bracket=false,$sep1 = "[",$sep2 = "]");
      
      if ( $mas_t === false ) return ($this->alert_error("синтаксическая ошибка"));
      $v = "";
      foreach ( $mas_t as $one_t )
        {
         if ( $one_t[1] !== "code" )
           {
            $v .= $one_t[0];
            continue;
           }
         
         $v .= $this->replace_code_one_tpl_const($one_t[0], 0);
         
        }
      
      //echo("<div>получили: ".$v."</div>");
      return ($v);
     }
   
   function replace_code_one_tpl_const($str_code,$pos = 0)
     {
      
      if ( preg_match("/".$this->list_models_regexp["function"]."/uis",$str_code,$matches,PREG_OFFSET_CAPTURE,$pos) )
       {
        $data_name = $matches[0];
        $name = $data_name[0];
        
        $begin_text = mb_substr($str_code,0,$data_name[1]);
        $end_text = mb_substr($str_code,$data_name[1]+mb_strlen($name),mb_strlen($str_code)-$data_name[1]-mb_strlen($name));
        
        $newConst = $name;
        
        $is_const = true;
        if ( trim($begin_text) && mb_substr($begin_text,mb_strlen($begin_text)-1,1) === "$"  )
          $is_const = false;
        
        if ( trim($end_text) && mb_substr(trim($end_text),0,1) === "(" )
          $is_const = false;
        
        if ( $is_const )
          {
           //echo(" CONST -> ".$name."<br>\n");
           //echo ( "%".$begin_text."%".$end_text."%" );
           //проверяем и заменяем в случае необходимости константу
           //...
           $newConst = $this->replace_name_const($name);
          }
        
        /*
        $t = $begin_text.$newConst.$end_text;
        if ( !trim($end_text) ) return ($t);
        echo(" # ".$begin_text." # ");
        */
        
        $str_code = $this->replace_code_one_tpl_const($begin_text.$newConst.$end_text,mb_strlen($begin_text.$newConst));
        
       }
      
      return ($str_code);
     }
   
   function replace_name_const($nameConst)
     {
      $v = $nameConst;
      if ( isset( $this->mas_init_const[$nameConst]) )
        $v = $this->mas_init_const[$nameConst];
      return ($v);
     }
   
   function check_on_block($name)
     {
      //name - имя проверяемого блока
      $is = false;
      //проверяем является ли name блоком
      if ( $this->is_name_block($name) ) $is = true;
      
      return($is);
     }
   
   function is_name_block($name)
     {
      // провеяем загружен ли класс блока в массив $mas_load_block, то есть присутствует или нет в массиве
      // если не присутствует, то проверяем наличие блока в подлючаемых файлах
      // если нет, то возвращаем false, если блок есть в подключаемых файлах, то подключаем (в другом методе)
      // в итоге - если name является блоком, то возвращаем true, если нет - false
      
      if ( in_array( $name,$this->mas_load_block ) ) return(true);
      if ( $this->load_name_block($name) )
        {
         return (true);
        }
      return (false);
     }
   
   function load_name_block($name)
     {
      //проверяем является ли name подключаемым блоком, 
      // и если да - то подключаем и добавляем объект в массив $mas_load_block
      $is = false;
      if ( file_exists(DIR_PLUGIN_TEMPLATING_DMK."block.".$name.".php") )
        {
         include_once (DIR_PLUGIN_TEMPLATING_DMK."block.".$name.".php");
         $class_name = "tpl_dmk_block_".$name;
         $this->mas_load_block[$name]= new $class_name;
         $this->mas_registr_block[$name]= $this->mas_load_block[$name]->init_tegs();
         $is = true;
        }
      
      return ($is);
     }
   
   function search_modifier_line_str($str)
     {
      
      foreach ( $this->list_models_regexp as $name_regexp => $v_regexp )
        {
         if ( !( $name_regexp == "vars" || $name_regexp == "numeric"  
          || $name_regexp == "text1" || $name_regexp == "text2" ) ) continue;
         
         
         if( preg_match("/(".$v_regexp.")\\|".$this->list_models_regexp["function"]."(:("
         .$this->list_models_regexp["vars"]."|".$this->list_models_regexp["numeric"]."|".$this->list_models_regexp["text1"]
         ."|".$this->list_models_regexp['text2']
         ."))*/uisx",$str,$matches,PREG_OFFSET_CAPTURE,0) )
         //if( preg_match("/".$v_regexp."/uisx",$str,$matches,PREG_OFFSET_CAPTURE,0) )
           {
            //var_dump($matches);
            $data_all_str = $matches[0];//вся строка
            $data_value = $matches[1];//строка содержащие только значение (переменная, текст или число)
            
            //echo($data_all_str[0]." -- ".$data_value[0]." ");
            
            $str_code_modifier=$this->cut_begin_part_str($data_all_str[0],$data_value[0]."|");
            //echo($str_code_modifier."- ");
            
            if (($data_modifier = $this->parse_code_modifier($str_code_modifier)) === false) return(false);
            //var_dump($data_modifier);
            
            if (($nameModifier = $this->check_name_modifier($data_modifier[0])) === false) return(false);
            $data_modifier[0] = $nameModifier;
            
            $t_replace = $this->forming_code_modifier($data_modifier[0],$data_value[0],$data_modifier[1]);
            //echo($t_replace);
            $begin_str = mb_substr($str,0,$data_all_str[1]);
            $end_str = mb_substr($str,$data_all_str[1]+mb_strlen($data_all_str[0]),mb_strlen($str)-$data_all_str[1]-mb_strlen($data_all_str[0]));
            
            $str = $begin_str.$t_replace.$end_str;
            
           }
         
        }
      return ($str);
     }
   
   function parse_code_modifier($str_code_modifier)
     {
      //$str_code_modifier - должна содержать модификатор с параметрами:
      //name_modifier:param1:param2:param3... - обязательно должен быть модификатор, параметры - необязатльно
      
      $mas_data = $this->separator_text_params($str_code_modifier,":");
      $data_params = array();
      $size_data = sizeof($mas_data);
      if ( $mas_data && ( $size_data > 0 ) )
        {
         $name_modifier = $mas_data[0];
         if ( $size_data > 1 )
           {
            for ( $i=1; $i < $size_data ; $i++ )
              {
               $data_params[] = $mas_data[$i];
              }
           }
         
        }
       else
         {
          //синтаксическая ошибка
          $this->alert_error("синтаксическая ошибка с параметрами модификатора");
          return (false);
         }
      
      return (array($name_modifier,$data_params));
     }
   
   function forming_code_modifier($name_modifier,$first_param,$mas_addit_params)
     {
      //передаем имя модификатора, основной параметр и дополнительные параметры
      //формируем: name_modifier(first_param,list_addit_params)
      
      $t = $name_modifier."(".$first_param;
      if ( sizeof($mas_addit_params) )
        {
         for ($i=0;$i<sizeof($mas_addit_params);$i++)
           $t.=",".$mas_addit_params[$i];
        }
      $t.=")";
      return ($t);
     }
   
   function check_name_modifier($nameModifier)
     {
      //проверяем имя модификатора
      // если функция с таким именем существует, то возвращаем имя этой функции
      // если нет такой функции, то смотрим есть ли соответствующий плагин-модификатор, и если есть то возвращаем имя функции в плагине
      
      $is = false;
      if ( function_exists($nameModifier) )
        {
         $is = $nameModifier;
        }
      if ( !$is )
        {
         if ( in_array($nameModifier,$this->mas_load_modifier) )
           {
            $is = "dmk_modifier_".$nameModifier;
           }
          elseif ( file_exists(DIR_PLUGIN_TEMPLATING_DMK."modifier.".$nameModifier.".php") )
            {
             $is = "dmk_modifier_".$nameModifier;
             $this->add_name_modifier_mas_load($nameModifier);
            }
        }
      if ( !$is )
        {
         $this->alert_error("не определен модификатор ".$nameModifier);
        }
      return ($is);
     }
   
   function add_name_modifier_mas_load($nameModifier)
     {
      //добавляем в массив модификаторов файл для подключения в скомпилированный файл шаблона
      if ( !in_array($nameModifier,$this->mas_load_modifier) )
        $this->mas_load_modifier[] = $nameModifier;
     }
   
   function move_elements_mas($mas,$numStart,$kolMove = 1)
     {
      //смещаем элементы массива с определенного номера на заданное количество
      for ($i = sizeof($mas)-1 ; $i >= $numStart ; $i--)
        {
         $mas[$i+$kolMove] = $mas[$i];
        }
      return ($mas);
     }
   
   function cut_begin_part_str($str,$cut_part)
     {
      
      return (mb_substr($str,mb_strlen($cut_part),mb_strlen($str)-mb_strlen($cut_part)));
     }
   
   function setvarname($name)
     {
      //преобразуем строку в переменную. Если текст состоит из текста в кавычках ("varname"), то преобразуем в $varname
      
      if ( preg_match("/^('([\w]+)'|\"([\w]+)\")$/uis",$name,$matches) )
        {
         $name = "$".mb_substr($matches[0],1,mb_strlen($matches[0])-2);
        }
       elseif ( preg_match("/^[\w]+$/uis",$name,$matches) )//строку состоящую из текст varname преобразуем в $varname
         {
          $name = "$".$name;
         }
     $t = $this->parseCodeString($name);
      
      return ($t);
     }
   
   function parse_str_attribute($str)
     {
      //парсим строку типа name1 = "text" key = $var value = array()
      //и получаем массив с ключами и значениями array( "name1" => "text , "key" => $var , "value" => array() )
      //в случае ошибки вернем false
      if ( !trim($str) ) return ( array() );//если пустая строка - возвращаем пустой массив
      
      $mas = $this->separator_text_params($str,"=");//var_dump($mas);
      if ( !$mas || sizeof($mas) < 2 ) return (false);
      
      $params = array();
      $kol = sizeof($mas);
      if ( $kol  == 2 )
        $params[$mas[0]] = $mas[1];
       else
         {
          //$params[$mas[0]] = "";
          $nameKey = $mas[0];
          for ( $i = 1; $i < $kol-1; $i++  )
            {
             
             if ( preg_match("/\\s[\\S]+$/uis",$mas[$i],$matches,PREG_OFFSET_CAPTURE) )
               {
                
                $params[$nameKey] = mb_substr($mas[$i],0,$matches[0][1]);
                $nameKey = trim($matches[0][0]);
               }
              else
                return (false);
             
            }
          $params[$nameKey] = $mas[$kol-1];
          
         }
      
      return ($params);
     }
   
   
   
   function separator_text_params($t,$sep = ",")
     {
      $t = trim($t);
      $mas = array();
      if ( $t )
        {
         $mas = $this->split_text_sim($t,$sep);
         if ( $mas === false ) return(false);
         foreach ( $mas as $key => $value )
           {
            $v = trim($value);
            if ( $v || $v === "0" )
              {
               $mas[$key]=trim($value);
              }
             else
               {
                //echo(" err:".trim($v)." ");
                return (false);
               }
           }
        }
      return ($mas);
     }
   function split_text_sim($t,$sep = ",")
     {
      $params = array();
      //$t = trim($t);
      if ( $t )
        {
         $part_t = "";//текст параметра
         $type_t = "";//тип текста: в кавычках ' или "
         $open_bracket = 0;//открывающая скобка "("
         $prev_sim = "";//предыдущий символ
         $len = mb_strlen($t);
         $sim = "";//текущий символ
         for ( $i = 0;$i<$len;$i++ )
           {
            $sim = mb_substr($t,$i,1);
            if ( $sim === $sep )
              {
               //if ( $part_t  )
                 {
                  if ( $type_t || $open_bracket )
                    {
                     //пропускаем разделяющий символ (запятую) если он находится в кавычках или в скобках
                     $part_t .= $sim;
                    }
                   else
                     {
                      $params[] = $part_t;
                      $part_t = "";
                      
                     }
                 }
                //else
                //  return(false);
              }
             else
               {
                $part_t .= $sim;
                if ( ($sim === "'" || $sim === '"') && $prev_sim !== "\\" )
                  {
                   $type_t = $type_t ? ( $type_t === $sim ? "":$type_t ):$sim;
                  }
                 elseif ( $sim === "(" && !$type_t  )
                   {
                    $open_bracket++;//обнаружена открывающая скобка вне кавычек
                    
                   }
                  elseif ( $sim === ")" && !$type_t )
                    {
                     if ( $open_bracket  )
                       {
                        $open_bracket--;
                        
                       }
                      else
                        {
                         //обнаружена закрывающая кавычка, но ранее не было открывающей. 
                         //Синтаксическая ошибка 
                         return (false);
                        }
                     
                    }
                //$prev_sim = $sim;
                
               }
            $prev_sim = $sim;
           }
         if ( $part_t )
           $params[] = $part_t;
          elseif ( $sim === $sep )
            $params[] = "";
        }
      
      return ($params);
     }
   
   function split_text_bracket($t,$sep1 = "(",$sep2 = ")")
     {
      $params = array();
      //$t = trim($t);
      if ( $t !== "" && $t !== false )
        {
         $part_t = "";//текст параметра
         $type_t = "";//тип текста: в кавычках ' или "
         $open_bracket = 0;//открывающая скобка "("
         $nested_bracket = 0;//вложенные скобки
         $prev_sim = "";//предыдущий символ
         $len = mb_strlen($t);
         $sim = "";//текущий символ
         for ( $i = 0;$i<$len;$i++ )
           {
            $sim = mb_substr($t,$i,1);
            
            if ( ($sim === "'" || $sim === '"') && $prev_sim !== "\\" )
              {
               $type_t = $type_t ? ( $type_t === $sim ? "":$type_t ):$sim;
               $part_t .= $sim;
              }
             elseif ( $type_t )
               {
                //пропускаем открывающий символ если он находится в кавычках
                $part_t .= $sim;
               }
              elseif ( $sim === $sep1 )
                {
                 //if ( $part_t  )
                 {
                  if ( $open_bracket )
                    {
                     //найден вложенный открывающий элемент
                     $open_bracket++;
                     $nested_bracket = 1;
                     $part_t .= $sim;
                    }
                   else
                     {
                      $open_bracket++;
                      if ( $part_t )
                        $params[] = array($part_t,false,0);
                      $part_t = "";
                      
                     }
                 }
                 //else
                 //  return(false);
                }
               elseif ( $sim === $sep2 )
                 {
                  if ( !$open_bracket ) return(false);//синтаксическая ошибка - найден закрывающий элемент, но не было открывающего
                  if ( $open_bracket == 1 )
                    {
                     $params[] = array($part_t,true,$nested_bracket);
                     $part_t = "";
                     $nested_bracket = 0;
                    }
                   else
                     {
                      $part_t .= $sim;
                      //$nested_bracket = 1;
                     }
                  $open_bracket--;
                  
                 }
                else
                  {
                   $part_t .= $sim;
                  }
            $prev_sim = $sim;
           }
         
         if ( $open_bracket ) return(false);
         if ( $part_t !== "" )
           $params[] = array( $part_t,false,0);
          /*elseif ( $sim === $sep )
            $params[] = "";*/
        }
      
      return ($params);
     }
   
   function split_text_quotes($t,$use_bracket=true,$sep1 = "[",$sep2 = "]")
     {
      $params = array();
      //$t = trim($t);
      if ( $t !== "" && $t !== false )
        {
         $part_t = "";//текст параметра
         $type_t = "";//тип текста: в кавычках ' или "
         $open_bracket = 0;//открывающая скобка "("
         //$nested_bracket = 0;//вложенные скобки
         $prev_sim = "";//предыдущий символ
         $len = mb_strlen($t);
         $sim = "";//текущий символ
         for ( $i = 0;$i<$len;$i++ )
           {
            $sim = mb_substr($t,$i,1);
            
            if ( !$open_bracket && ($sim === "'" || $sim === '"') && $prev_sim !== "\\" )
              {
               
               if ( $type_t )
                 {
                  $part_t .= $sim;
                  if ( $type_t === $sim )
                    {
                     $params[] = array($part_t,$type_t === '"' ? "dbquotes" : "quotes");
                     $part_t = "";
                     $type_t = "";
                    }
                 }
                else
                  {
                   $type_t = $sim;
                   if ( $part_t )
                     $params[] = array($part_t,"code");
                   $part_t = $sim;
                  }
               
              }
             elseif ( $type_t || !$use_bracket )
               {
                //пропускаем открывающий символ если он находится в кавычках
                $part_t .= $sim;
               }
              elseif ( $sim === $sep1 )
                {
                 $open_bracket++;
                 $part_t .= $sim;
                 
                }
               elseif ( $sim === $sep2 )
                 {
                  
                  $open_bracket--;
                  $part_t .= $sim;
                  if ( $open_bracket < 0 ) return(false);
                  
                 }
                else
                  {
                   $part_t .= $sim;
                  }
            $prev_sim = $sim;
           }
         
         if ( $open_bracket || $type_t ) return(false);
         if ( $part_t !== "" )
           $params[] = array( $part_t,"code");
          /*elseif ( $sim === $sep )
            $params[] = "";*/
        }
      
      return ($params);
     }
   
   
   
  }



/*

numeric string
$name_var $name_var.index_mas $name_var["name_key"].. $name_var[numeric_key].. $name_var['name_key'].. 
$name_var[$name_var1] 

любое_значение|modifier:param1:param2

name_function () 
+ * - &  / || && or and xor . , ;
=

*/

/*

rdelim - правый огранитель тега
ldelim - левый огранитель тега

literal - блок игнорируемый компилятором

Управляющие конструкции языка PHP

Основными конструкциями языка PHP являются:

   1. Условные операторы (if, else);
   2. Циклы (while, do-while, for, foreach, break, continue);
   3. Конструкции выбора (switch);
   4. Конструкции объявления (declare);
   5. Конструкции возврата значений (return);
   6. Конструкции включений (require, include).

*/

