<?php


class tpl_dmk_block_foreach
  {
   
   function __construct()
     {
      //$this->init();
     }
   
   function init()
     {
      
     }
   
   function init_tegs()
     {
      //возвращаем все дополнительные возможные теги блока, то есть все кроме открывающего и закрывающего
      return ( array("foreachelse") );//"else","elseif"
     }
   
   function driver($name,$str_params,$compiler,$previous_tag)
     {
      $t = "";
      $is = false;
      $is_open_teg = false;
      
      if ( $name === "foreach" )
        {
         $params = $compiler->parse_str_attribute($str_params);
         //var_dump($params);
         if ( $params === false ) return($compiler->alert_error("синтаксическая ошибка в блоке foreach."));
         
         if ( empty($params["from"]) ) return ($compiler->alert_error("в блоке foreach отсутствует параметр 'from'"));
         if ( empty($params["value"]) ) return ($compiler->alert_error("в блоке foreach нужно указать параметр 'value'"));
         
         if ( empty($params["key"]) )
           $params["key"] = "";
          else
            $params["key"] = $compiler->setvarname($params["key"]);
         
         if ( empty($params["value"]) )
           $params["value"] = "";
          else
            $params["value"] = $compiler->setvarname($params["value"]);
         $params["from"] = $compiler->parseCodeString($params["from"]);
         
         $is = true;
         $is_open_teg = true;
         
         
         
         $t .= '$_from = '.$params["from"].";\n"
          .'if (sizeof($_from) > 0):  foreach ( $_from as '.($params["key"] ? $params["key"]." => " : "").$params["value"].' ):';
         
        }
       elseif ( $name === "foreachelse" )
         {
          $is = true;
          $t = "endforeach; else: ";
          
         }
         /*
        elseif ( $name === "elseif" )
          {
           $params = $compiler->parseCodeString($str_params,false);
           if ( $params === false ) return(false);
           $is = true;
           $t = " elseif ( ".$params." ): ";
           
          }
          */
         elseif ( $name === "close" )
           {
            $is = true;
            if ( $previous_tag !== "foreachelse" )
              $t = "endforeach; ";
            $t .= " endif;";
           }
      
      if ( $is )
        {
         return (array($t,$is,$is_open_teg));
        }
       else
         return ($compiler->alert_error("Неизвестный оператор"));
     }
   
   
  }





