

function jsPrintListNumbersPages(select_num_page,vsego_pages,hablon_on_link,hablon_off_link,kolvo_num_print,razdel_link,on_title_text,on_print_first_end_links)
  {
   //устанавливаем значения по умолчанию
   if (typeof(kolvo_num_print) == "undefined")
     kolvo_num_print=3;
   if (typeof(razdel_link) == "undefined")
     razdel_link="";
   if (typeof(on_title_text) == "undefined")
     on_title_text=true;
   if (typeof(on_print_first_end_links) == "undefined")
     on_print_first_end_links=true;
   
   var t="";
   //hablon_on_link="{::numPage::}  ";
   //hablon_off_link="<a href='http://cms/page{::numPage::}.html' {::title::}>{::textPage::}</a> ";
   var h,text_title,num_page_start,num_page_end,p;
   
   if (select_num_page > 1)
     {
      //ссылка на первую страницу
      if (on_print_first_end_links)
        {
          h=jsReplacePeremenToHablon(hablon_off_link,"numPage",1,"{::","::}");
          h=jsReplacePeremenToHablon(h,"textPage","&laquo;&laquo;","{::","::}");
          text_title=on_title_text?" title='первая' ":"";
          t+=jsReplacePeremenToHablon(h,"title",text_title,"{::","::}");
          
          t=(t=="")?t:t+razdel_link;
        }
      //ссылка на предыдущую страницу
      h=jsReplacePeremenToHablon(hablon_off_link,"numPage",select_num_page-1,"{::","::}");
      h=jsReplacePeremenToHablon(h,"textPage","&laquo;","{::","::}");
      text_title=on_title_text?" title='предыдущая' ":"";
      t+=jsReplacePeremenToHablon(h,"title",text_title,"{::","::}");
      t=(t=="")?t:t+razdel_link;
     }
   
   //num_page_start,num_page_end - номера страниц с которых будет начинаться и заканчиваться вывод страниц
   num_page_start=select_num_page-kolvo_num_print;
   num_page_end=select_num_page+kolvo_num_print;
   
   if (num_page_start < 1)
     num_page_start=1;
     
   if (num_page_end > vsego_pages)
     num_page_end=vsego_pages;
   
   if (num_page_start > 1)
     {
      t+="... ";
      t=(t=="")?t:t+razdel_link;
     }
   
   for (p=num_page_start;p<=num_page_end;p++)
     {
      //alert(p);
      if (p == select_num_page)
        {
         //ссылка на выбранную страницу
         h=jsReplacePeremenToHablon(hablon_on_link,"numPage",p,"{::","::}");
         h=jsReplacePeremenToHablon(h,"textPage",p,"{::","::}");
         text_title=on_title_text?" title='"+p+"' ":"";
         t+=jsReplacePeremenToHablon(h,"title",text_title,"{::","::}");
         t=(t=="")?t:t+razdel_link;
        }
       else
         {
          //ссылка на другие страницы
          h=jsReplacePeremenToHablon(hablon_off_link,"numPage",p,"{::","::}");
          h=jsReplacePeremenToHablon(h,"textPage",p,"{::","::}");
          text_title=on_title_text?" title='"+p+"' ":"";
          t+=jsReplacePeremenToHablon(h,"title",text_title,"{::","::}");
          t=(t=="")?t:t+razdel_link;
         }
      
     }
   
   if (num_page_end < vsego_pages)
     {
      t+="... ";
      t=(t=="")?t:t+razdel_link;
     }
   
   if (select_num_page < vsego_pages)
     {
      //следующая страница
      h=jsReplacePeremenToHablon(hablon_off_link,"numPage",select_num_page+1,"{::","::}");
      h=jsReplacePeremenToHablon(h,"textPage","&raquo;","{::","::}");
      text_title=on_title_text?" title='следующая' ":"";
      t+=jsReplacePeremenToHablon(h,"title",text_title,"{::","::}");
      t=(t=="")?t:t+razdel_link;
      
      //последняя страница
      if (on_print_first_end_links)
        {
          h=jsReplacePeremenToHablon(hablon_off_link,"numPage",vsego_pages,"{::","::}");
          h=jsReplacePeremenToHablon(h,"textPage","&raquo;&raquo;","{::","::}");
          text_title=on_title_text?" title='последняя' ":"";
          t+=jsReplacePeremenToHablon(h,"title",text_title,"{::","::}");
          t=(t=="")?t:t+razdel_link;
        }
     }
   
   return (t);
  }
  
  
function jsReplacePeremenToHablon(textHablon,perem,value,startHabPerem,endHabPerem)
  {
   var t,textReplace;
   t=textHablon;
   var textReplace=startHabPerem+perem+endHabPerem;
   t=jsStringReplace(t,textReplace,value);//str_replace(textReplace,value,t);
   //textReplace=startHabPerem.perem_text.endHabPerem;
   //t=str_replace(textReplace,value_text,t);
   
   return (t);
  }


function jsDataInitListNumbersPages(select_num_page,quantity_page,fun_run,opts)
  {
   // функция вернет данные в формате функции forming_html_struct_data
   if ( typeof(opts) == "undefined" || !opts ) opts = {};
   opts.max_num = opts.max_num || 7;
   opts.on = opts.on || 'nav_list_page_link_on';
   opts.off = opts.off || 'nav_list_page_link';
   opts.on_title = opts.on_title || true;
   opts.on_link_first_end = opts.on_link_first_end || true;
   opts.sim_next = opts.sim_next || "&raquo;";
   opts.sim_previous = opts.sim_previous || "&laquo;";
   opts.sim_first = opts.sim_first || "&laquo;&laquo;";
   opts.sim_end = opts.sim_end || "&raquo;&raquo;";
   opts.text_space = opts.text_space || "...";
   opts.class_space = opts.class_space || "";
   opts.class_ptr_cnt = opts.class_ptr_cnt || "nav_list_page_pointer_contr";
   
   var mas = [];
   var num_page_start,num_page_end;
   var one_elm = [];
   if ( quantity_page > 0 )
     {
      mas =  ["ul",[["class",opts.class_ptr_cnt]],[]];
      
      num_page_start=select_num_page-opts.max_num;
      num_page_end=select_num_page+opts.max_num;
      
      if (num_page_start < 1)
        num_page_start=1;
        
      if (num_page_end > quantity_page)
        num_page_end = quantity_page;
      
      if ( select_num_page > 1 )
        {
         if ( opts.on_link_first_end )
           {
            one_elm = init_one_elm(1,{title: "первая", on : false,text:opts.sim_first },opts,fun_run);
            mas[2].push(one_elm);
           }
         one_elm = init_one_elm(select_num_page-1,{title: "предыдущая", on : false,text:opts.sim_previous },opts,fun_run);
         mas[2].push(one_elm);
        }
      
      if ( num_page_start > 1 )
        {
         one_elm = init_one_space_elm(opts);
         mas[2].push(one_elm);
        }
      
      for ( var n = num_page_start; n <= num_page_end; n++ )
        {
         one_elm = init_one_elm(n,{title: n, on : (n == select_num_page ? true : false)},opts,fun_run);
         
         mas[2].push(one_elm);
        }
      
      if ( num_page_end < quantity_page )
        {
         one_elm = init_one_space_elm(opts);
         mas[2].push(one_elm);
        }
      
      if ( select_num_page < quantity_page )
        {
         one_elm = init_one_elm(select_num_page+1,{title: "следующая", on : false,text:opts.sim_next },opts,fun_run);
         mas[2].push(one_elm);
         
         if ( opts.on_link_first_end )
           {
            one_elm = init_one_elm(quantity_page,{title: "последняя", on : false,text:opts.sim_end },opts,fun_run);
            mas[2].push(one_elm);
           }
         
        }
      
     }
   
   return (mas);
   
   function init_one_elm(n,data,opts,fun_run)
     {
      data.on = data.on || false;
      data.title = data.title || false;
      var one_elm = ["li",[["class","nav_list_page_elm_num "+(data.on ? opts.on : opts.off)]],data.text ? data.text:n,[["click",function(){fun_run(n);}]]];
      if ( opts.on_title && data.title ) one_elm[1].push(["title",data.title]);
      
      return (one_elm);
     }
   
   function init_one_space_elm(opts)
     {
      
      var one_elm = ["li",[["class","nav_list_page_elm_space"+(opts.class_space ? " "+opts.class_space : "")]],opts.text_space ];
      
      
      return (one_elm);
     }
   
  }
