<?php




//массив названий констант, используемых в конфигурационном файле
//
//
$data_mas_config=array(
  array(
   array("Название, ключевые слова, описание сайта, базовые параметры",1),
   array(
      array("URL_SITE_MAIN","text","oneline|trim","URL сайта","без http:// и без косой черты (слеша) в конце, например, site.ru,  www.site.ru, www.site.ru/dir1, www.site.ru/dir1/dir2 "),
      array("NAME_SITE","text","oneline","Название сайта","например,  Система администрирования сайта"),
      
      array("ON_TEXT_TITLE_SITE_BASE","select",array(array(0,"не выводить"),array(1,"выводить на всех страницах"),array(2,"выводить на всех страницах, кроме главной")),"Вывод базового текста в заголовке сайта (тега title)","Работает совместно со следующим параметром"),//: 0 - не выводится, 1 - выводится
      array("TEXT_TITLE_SITE_BASE","text","oneline","Базовая часть заголовка страницы (тега title)","Текст этого параметра будет добавляться в конец тега title, если в предыдущем параметре включен вывод данного параметра. Например: - доска бесплатных объявлений"),
      
      array("ON_DESCRIPTION","select",array(array(0,"не выводить"),array(1,"выводить")),"вывод содержимого meta-тега description ( описание страницы )",""),//: 0 - не выводится, 1 - выводится
      
      array("MIN_LENGTH_DESCRIPTION","numeric",0,"если вывод содержимого meta-тега description включен, то описание будет выведено на страницу, если длина его будет превышать данную величину","дополнительный фильтр, например, 10"),
      
      array("ON_KEYWORDS","select",array(array(0,"не выводить"),array(1,"выводить")),"вывод содержимого мета-тега keywords (ключевые слова)",""),//: 0 - не выводится, 1 -выводится
      
      array("MIN_LENGTH_KEYWORDS","numeric",0,"если вывод содержимого мета-тега keywords включен, то этот тег будет выведен, если длина содержимого будет превышать длину заданную данной величиной","дополнительный фильтр, например, 10"),
      
      //array("ON_USE_PERSONAL_MESSAGE","select",array(array(0,"не использовать"),array(1,"использовать")),"Использование личных сообщений на сайте","использовать или нет"),
      array("QUANTITY_MESSAGE_LIST_SYSTMSG","numeric",0,"Количество сообщений в списке","Например, 10"),
      
      array("PAGE_NOT_FOUND_TITLE","text","oneline|trim","Заголовок страницы 404-Not Found","например,  Ошибка 404 - Not Found"),
      array("PAGE_NOT_FOUND_TEXT","text",0,"Текст страницы 404-Not Found","HTML-текст, в тексте можно использовать переменные {:dir_http_template:} - путь к каталогу шаблона. Например, Невозможно найти страницу. Возможно, эта страница была удалена, переименована, или она временно недоступна."),
      
      array("ON_STOP_WORK_SITE","select",array(array(0,"доступ к сайту неограничен"),array(1,"доступ к сайту ограничен"),array(2,"доступ к сайту закрыт")),"Доступ к сайту",'Можно ограничить посетителям доступ к сайту на время каких-либо работ. Если выбрать "доступ к сайту ограничен", то получить доступ к сайту можно добавив к адресу сайта параметр "?access=on", к примеру, "www.domen.ru?access=on".'),
      array("STOP_WORK_SITE_TEXT","text",0,"Текст сообщения выдаваемого при ограничении доступа к сайту","Например, сайт на реконструкции"),
      
      array("ON_USE_BALANCE_SITE","select",array(array(0,"не использовать"),array(1,"использовать")),"Использование баланса пользователя на сайте","использовать или нет","hide"),
      
   )),
  array(
   array("Поиск по сайту",0),
   array(
      array("POISK_SITE","select",array(array(0,"не использовать"),array(1,"использовать")),"поиск по сайту","поиск идет только по статьям"),
      //array("NAME_PART_HABLON_FORM_POISK_STAT","text",0,"область вывода формы поиска по сайту","например, search"),
      //array("FORM_FORM_STAT_NUM_PRINT_PART_HABLON","numeric",0,"позиция выводимой формы поиска в соответствующей области","например, 1"),
      array("KOL_STR_POISK","numeric",0,"количество строк в результатах поиска","например, 10"),
      //array("textForPolePoisk","text",0,"текст перед полем формы поиска","например, поиск по сайту"),

      //array("textHelpPoisk","text",0,"текст подсказки для поиска по сайту",'не рекомендуется изменять '),
      //По умолчанию ищутся все слова.<br>Если нужно найти какое-то одно слово из нескольких, то можно использовать вертикальную черту "|", например<br>"<b>html | xhtml</b>"<br>Не используйте в запросе слова длиной меньше 4 букв.<br>В запросе можно использовать буквы и цифры, все остальные символы игнорируются при поиске
      
   )),
  array(
   array("Управление статьями",1),
   array(
      array("PRINT_ON_TEXT_TO_LIST_STAT","select",array(array(0,"отображать название соответствующего подпункта"),array(1,"отображать текст следующего параметра")),"заголовок списка ссылок статей в основном содержимом",""),
      array("TEXT_TO_LIST_STAT","text","oneline|trim","заголовок списка ссылок статей в основном содержимом","См. предыдущий параметр. Например, Статьи по теме"),
      
      array("LIST_ZAGOL_STAT_PAGE","select",array(array(0,"не выводить"),array(1,"выводить")),"заголовки других статей выводимых на странице со статьей",""),//: 0 - отключено, 1 - включено
      array("KOL_ZAGOL_STAT_PAGE","numeric",0,"количество заголовков других статей выводимых на странице со статьей, для быстрого перехода пользователем (работает совместно с предыдущим параметром)","например, 10"),
      
      array("KOL_ADD_STAT_TO_PUNKT","numeric",0,"количество статей на странице","например, 10"),
      //array("REDAKTOR_STAT","select",array(array("wysiwyg","визуальный редактор"),array("bbcode","редактор bb-кодов")),"редактор статей по умолчанию",""),//"wysiwyg" - визуальный редактор (WYSIWYG), "bbcode" - будет использоваться редактор bb-кодов; 
      
  )),
  array(
   array("Облако тегов",0),
   array(
      array("ON_METKS_TEXT","select",array(array(0,"не выводить"),array(1,"выводить")),"вывод облака тегов (меток)",""),//0 - не выводится, 1 - выводить облако тегов (метки)
      //array("PART_METKS_TEXT","text",0,"область вывода облака тегов","например, right"),
      //array("METKS_TEXT_NUM_PRINT_PART_HABLON","numeric",0,"позиция выводимого облака тегов (меток) в соответствующей области","например, 10"),
      
      
   )),
  array(
   array("Комментарии",1),
   array(
      array("ON_COMMENTS","select",array(array(0,"не разрешено"),array(1,"разрешено")),"Комментарии к статьям и другим модулям",""),//1 - используются, 0 - не используются
      
      array("COMMENTS_ONLY_AVTORIZ_USER","select",array(array(0,"все пользователи"),array(1,"только зарегистрированные")),"Возможность комментировать имеют только зарегистрированные пользователи",""),//1 - только зарегистрированные, 0 - все пользователи
      
      array("COMMENTS_KAPCHA","select",array(array(0,"не использовать"),array(1,"использовать")),"Использование капчи для формы комментариев",""),// 1 - использовать капчу, 0 - не использовать
      
      array("COMMENTS_PREVIEW","select",array(array(0,"не использовать"),array(1,"использовать")),"Премодерация комментариев",""),//1 - используется, 0 - не используется
      
      array("SET_PAGES_COMMENTS","select",array(array(0,"не использовать"),array(1,"использовать")),"Разбиение комментариев на страницы",""),//1 - используется, 0 - не используется
      
      array("KOL_COMMENTS_TO_PAGE","numeric",0,"Количество комментариев на странице","Работает совместно с предыдущим параметром, например, 10"),
      
      array("COMMENTS_NOTICE_ADMIN_ADD_NEW","select",array(array(0,"не оповещать"),array(1,"оповещать")),"Оповещение администратора о новых комментариях на сайте","Оповещать по Email или нет"),
      
   )),
  array(
   array("Регистрация и авторизация пользователей",1),
   array(
      array("REGISTR_ON_SOCIAL","select",array(array(0,"выключена"),array(1,"включена")),"Авторизация через социальные сети","Авторизация происходит с помощью сервиса ulogin.ru"),
      array("REGISTR_USE_TYPE_ACCOUNT","select",array(array(0,"не использовать"),array(1,"использовать")),"Использование типа аккаунта для зарегистированных пользователей","Если включить, то аккаунты пользователей будут делиться на бизнес и обычные","hide"),
      array("REGISTR_USER_IMG_WIDTH","numeric",0,"Ширина изображения пользователя","например, 200"),
      array("REGISTR_USER_IMG_HEIGHT","numeric",0,"Высота изображения пользователя","например, 200"),
      array("TIME_SESSION_AVTORIZ","numeric",0,"Время сессии авторизованного пользователя","В секундах, например, 60*60=3600"),
      array("REGISTR_KAPCHA","select",array(array(0,"не использовать"),array(1,"использовать")),"Использование контрольного вопроса в форме регистрации пользователей","Использовать или нет"),//0 - не используется, 1 - используется
      array("TEXT_AVTORIZ_NOT_GET_ACTIVE_EMAIL","text",0,"Сообщение, показываемое пользователю, после отправления письма с кодом активации","Поясняющий текст пользователю, на случай, если ему не пришло письмо с кодом активации. HTML-текст"),
      array("TIME_SESSION_ADMIN_MIN","numeric",0,"Время действия сессии администратора в панели управлении","В минутах. Например, 30"),
      array("AUTHORIZATION_TITLE_EMAIL_ADD_USER","text","oneline","Заголовок письма отправляемого новому пользователю при регистрации на сайте","в тексте можно использовать переменную {site_name} - название сайта (берется из &laquo;Настройки почты/Url-адрес сайта для писем&raquo;)"),
      array("AUTHORIZATION_TEXT_EMAIL_ADD_USER","text",0,"Текст письма отправляемого новому пользователю при регистрации на сайте","html-текст, в тексте можно использовать переменные {url_site} - url-адрес сайта, {domen_site} - домен сайта, {url_page_activreg} - url-адрес страницы подтверждения регистрации. В тексте обязательно должна быть ссылка на страницу подтверждения регистрации. К тексту будет добавлена подпись, которая указывается в параметре &laquo;Настройки почты/Подпись в письмах&raquo;"),
      array("AUTHORIZATION_TITLE_EMAIL_REPAIR_PASSWORD","text","oneline","Заголовок письма отправляемого пользователю при восстановлении пароля","в тексте можно использовать переменную {site_name} - название сайта (берется из &laquo;Настройки почты/Url-адрес сайта для писем&raquo;)"),
      array("AUTHORIZATION_TEXT_EMAIL_REPAIR_PASSWORD","text",0,"Текст письма отправляемого пользователю при восстановлении пароля","html-текст, в тексте можно использовать переменные {url_site} - url-адрес сайта, {domen_site} - домен сайта, {site_name} - название сайта (берется из &laquo;Настройки почты/Url-адрес сайта для писем&raquo;), {name_user} - логин пользователя, {new_password} - новый пароль. В тексте обязательно должен быть логин пользователя и новый пароль. К тексту будет добавлена подпись, которая указывается в параметре &laquo;Настройки почты/Подпись в письмах&raquo;"),
      array("REGISTR_ON_USE_CONSENT","select",array(array(0,"не использовать"),array(1,"использовать")),"Пункт соглашения с правилами сайта и политикой конфиденциальности","Выводить пункт в форме регистрации или нет"),
      array("REGISTR_CONSENT_DEFINITION","text",0,"Пояснение к пункту соглашения с правилами сайта и политикой конфиденциальности","В тексте можно использовать переменную {url_site} - url-адрес сайта"),
      array("AUTHORIZATION_TITLE_USER_CHECK_EMAIL","text","oneline","Заголовок письма отправляемого пользователю при подтверждении Email","К примеру, Подтверждение Email"),
      array("AUTHORIZATION_TEXT_USER_CHECK_EMAIL","text",0,"Текст письма отправляемого пользователю при подтверждении Email","html-текст, в тексте можно использовать переменные {url_site} - url-адрес сайта, {domen_site} - домен сайта, {site_name} - название сайта (берется из &laquo;Настройки почты/Url-адрес сайта для писем&raquo;), {code} - код подтверждения. В тексте обязательно должен быть код подтверждения. К тексту будет добавлена подпись, которая указывается в параметре &laquo;Настройки почты/Подпись в письмах&raquo;"),
      
      array("AUTHORIZATION_TITLE_EMAIL_REGISTR_QUICK","text","oneline","Заголовок письма отправляемого пользователю при быстрой регистрации","в тексте можно использовать переменную {site_name} - название сайта (берется из &laquo;Настройки почты/Url-адрес сайта для писем&raquo;)","hide"),
      array("AUTHORIZATION_TEXT_EMAIL_REGISTR_QUICK","text",0,"Текст письма отправляемого пользователю при быстрой регистрации","html-текст, в тексте можно использовать переменные {url_site} - url-адрес сайта, {domen_site} - домен сайта, {site_name} - название сайта (берется из &laquo;Настройки почты/Url-адрес сайта для писем&raquo;), {name_user} - имя пользователя, {email_user} - E-mail пользователя, {password} - пароль. В тексте обязательно должен быть E-mail пользователя и пароль. К тексту будет добавлена подпись, которая указывается в параметре &laquo;Настройки почты/Подпись в письмах&raquo;","hide"),
      
   )),
  array(
   array("Настройки почты",1),
   array(
      array("EMAIL_ADMIN","text","oneline|trim","Email администратора сайта","нужен для отправки почты с сайта, например, support@domen.ru"),
      array("NAME_EMAIL_ADMIN","text","oneline","Имя отправителя электронного письма","будет отображено в поле от кого вместе с Email в письме, например, Администрация сайта domen.ru"),
      array("NAME_SITE_TO_EMAIL","text","oneline|trim","Url-адрес сайта для писем","например, www.domen.ru"),
      array("ON_SMTP_EMAIL_SITE","select",array(array(0,"использовать функцию mail() интерпретатора php"),array(1,"использовать SMTP-протокол")),"Способ отправки почты с сайта","для использования SMTP-протокола нужно будет указать все параметры данного блока настроек"),
      array("EMAIL_PASSW_ADMIN","text","oneline","Пароль Email администратора сайта","например, **********"),
      array("SERVER_EMAIL_ADMIN","text","oneline","Сервер электронной почты","например, mail.domen.ru"),
      array("DOMEN_SERVER_EMAIL_ADMIN","text","oneline","Домен электронной почты","например, domen.ru"),
      array("EMAIL_PORT_ADMIN","numeric",0,"Порт электронной почты","обычно 25, для зашифрованного соединения 465 или 587"),
      array("EMAIL_ADMIN_SIGNATURE","text",0,"Подпись в письмах","Подпись будет добавляться в конце писем, отправляемых с сайта. К примеру, администрация сайта site.ru"),
      array("EMAIL_SITE_TEMPL_HEADER_NAME","text","oneline|trim","Название сайта в заголовке шаблона письма","Название будет отображаться вверху шаблона письма, отправляемого с сайта, если шаблон поддерживает данную возможность. Нерекомендуется длинный текст, оптимальным вариантом будет от 1 до 3 слов. Например,  Сайт domen.ru"),
      array("QUANTITY_MAS_SEND_EMAIL","numeric",0,"Количество отправляемых писем за один цикл рассылки","например, 10"),
      array("TIME_PAUSE_MAS_SEND_EMAIL","numeric",0,"Пауза между циклами рассылки писем","в секундах, например, 5"),
      
   )),
  array(
   array("Настройки ГЕО",0),
   array(
      array("ON_USE_GEO_DATA","select",array(array(0,"не использовать"),array(1,"использовать")),"Привязка сайта к ГЕО данным","использовать или нет"),
      array("NUM_COUNTRY","numeric",0,"Номер страны","например, Россия - 3159"),
      array("NUM_REGION","numeric",0,"Номер региона","например, Москва и Московская область - 4312, Краснодарский край - 4052"),
      array ("TITLE_CHOSEN_GEO_LOCATION_DEFAULT","text","oneline|trim","Заголовок блока выбора местоположения по умолчанию",'Заголовок будет выводиться, когда пользователем не выбрано гео-положение. Например, Доска объявлений, объявления всех городов'),
      array ("TITLE_CHOSEN_GEO_LOCATION_COUNTRY","text","oneline|trim","Заголовок блока выбора местоположения: шаблон названия страны",'Заголовок будет выводиться, когда пользователем выбрана какая-либо страна. Можно использовать переменные: {geo_n1} - название страны, {geo_n2} - название в родительном падеже, {geo_n3} - название в предложном падеже. Например, Доска объявлений {geo_n2}'),
      array ("TITLE_CHOSEN_GEO_LOCATION_REGION","text","oneline|trim","Заголовок блока выбора местоположения: шаблон названия региона",'Заголовок будет выводиться, когда пользователем выбран какой-либо регион. Можно использовать переменные: {geo_n1} - название региона, {geo_n2} - название в родительном падеже, {geo_n3} - название в предложном падеже. Например, Доска объявлений {geo_n2}'),
      array ("TITLE_CHOSEN_GEO_LOCATION_CITY","text","oneline|trim","Заголовок блока выбора местоположения: шаблон названия города",'Заголовок будет выводиться, когда пользователем выбран какая-либо город. Можно использовать переменные: {geo_n1} - название города, {geo_n2} - название в родительном падеже, {geo_n3} - название в предложном падеже. Например, Доска объявлений {geo_n2}'),
      //array("NUM_CITY","numeric",0,"Номер города","например, Москва - 4400, Краснодар - 4079"),
      //array("NAME_PART_HABLON_MANAGER_CHOICE_GEO_DATA","text",0,"Имя области, в которой будет выводиться блок выбора гео-положения","например, user_geo"),
      //array("NUM_PART_HABLON_MANAGER_CHOICE_GEO_DATA","numeric",0,"Позиция блока выбора гео-положения в соответствующей области","например, 1"),
      array("ON_USE_FIRST_CHOICE_GEO_LOCATION","select",array(array(0,"не использовать"),array(1,"использовать")),"Первоначальный выбор гео-положения пользователем","использовать или нет"),
    )
   ),
  
  array(
   array("Настройки Яндекс и Google карт",1),
   array(
      array("ON_USE_SERVICE_MAPS","select",array(array(0,"не использовать"),array("yandex","использовать Яндекс карты"),array("google","использовать Google карты")),"Использование карт","использовать или нет"),
      
      array("KEY_YANDEX_MAPS","text","oneline","Ключ Яндекс карт","Для корректной работы карты необходимо указывать API ключ. Например, =key="),
      
      array("S_LONGITUDE_MAPS","numeric",0,"Долгота","Значение по умолчанию. Например, 38.975062"),
      array("S_LATITUDE_MAPS","numeric",0,"Широта","Значение по умолчанию. Например, 45.037069"),
      
      //array("S_LONGITUDE_YANDEX_MAPS","numeric",0,"Долгота Яндекс карты","например, 38.975062"),
      //array("S_LATITUDE_YANDEX_MAPS","numeric",0,"Широта Яндекс карты","например, 45.037069"),
      
      array("S_ZOOM_YANDEX_MAPS","numeric",0,"Масштаб Яндекс карты","Нужно указать значение от 1 до 17. Например, 12"),
      array("S_ZOOM_YANDEX_MAPS_POINT","numeric",0,"Масштаб Яндекс карты при просмотре объекта","Нужно указать значение от 1 до 17. Например, 14"),
      
      array ("DEFAULT_TEXT_SEARCH_ADDRESS_MAPS","text","oneline","Текст в поле поиска адреса на карте",'Значение по умолчанию. Например, Краснодар, ул. Красная 5'),
      
      array("KEY_GOOGLE_MAPS","text","oneline","Ключ Google карты","Для корректной работы карты необходимо указывать API ключ. Например, =key="),
      array("S_ZOOM_GOOGLE_MAPS","numeric",0,"Масштаб Google карты","Нужно указать значение от 1 до 20. Например, 12"),
      array("S_ZOOM_GOOGLE_MAPS_POINT","numeric",0,"Масштаб Google карты при просмотре объекта","Нужно указать значение от 1 до 20. Например, 14"),
      
    )
   ),
  
  array(
   array("Другие настройки",1),
   array(
      array("ON_MODULS","select",array(array(0,"не использовать"),array(1,"использовать")),"Дополнительные модули сайта","использовать или нет"),
      
      array("DELTA_TIME","numeric",0,"Разница в часах между вашим часовым поясом и часовым поясом хостинга","Например, 1. Устаревший параметр. Не рекомендуется использовать, лучше правильно настоить на сервере (в php) время, то есть временную зону (часовой пояс)."),
      
      array("ON_LINK_ADD_SERVICE_SOCIAL","select",array(array(0,"не использовать"),array(1,"использовать")),"Блок транслирования страниц сайта в социальные сети и блоги","использовать или нет"),
      
      array("ON_ADD_INFO_LOG_MAIN_CRON","select",array(array(0,"не добавлять"),array(1,"добавлять")),"Добавлять информацию о выполнении автоматически выполняемого задания (cron) в лог-файл системы","добавлять или нет"),
      
    )
   ),
  array(
   array("Система smspilot",0),
   array(
      array("ON_USE_SMSPILOT","select",array(array(0,"не использовать"),array(1,"отправлять код на телефон"),array(2,"отправлять код на телефон и дублировать на почту администратора"),array(3,"отправлять код только на почту администратора")),"Использование системы smspilot","Использовать или нет. Код подтверждения можно отправлять также на почту администратора сайта (для тестирования работы)."),
      
      array("SMSPILOT_API_KEY","text","oneline|trim","API-ключ системы smspilot","например, xxxxxx"),
      array("SMSPILOT_NAME_FROM","text","oneline|trim","Название отправителя в sms","например, site.ru"),
      
    )
   ),
  array(
   array("Дополнительные настройки",0),
   array(
      array("ON_USE_POLE_PHONE_USER","select",array(array(0,"не использовать"),array(1,"использовать")),"Использование поля &laquo;телефон&raquo; в данных пользователя","использовать или нет"),
      array("USE_CHECK_ACTIVE_PHONE_USER","select",array(array(0,"не использовать"),array(1,"использовать")),"Подтверждение телефона при регистрации пользователя","Использовать подтверждение или нет"),
      array("INFO_CHECK_PHONE_USER","text",0,"Поясняющий текст для поля Телефон",'HTML-текст'),
      
      array("ON_AVTORIZ","select",array(array(1,"включена")),"Авторизация на сайте",""),//0 - не использовать, 1 - использовать на сайте авторизацию пользователей array(0,"выключена"),
      array("ON_AKTIV_AVTORIZ","select",array(array(1,"использовать")),"активация регистрации пользователей посредством электронной почты","Если отключить активацию, то при регистрации не будет поля Email, соответственно, у аккаунтов пользователей не будет Email."),// array(0,"не использовать"),
      
    )
   ),
  array(
    array("Код лицензии",0),
    array(
      array("SS","text",0,"Код лицензии","")
    )
   ),
  /*
  array(
    array("Вспомогательные настройки",0),
    array(
      
      array("ON_VIEW_LAST_COMPONENTS","select",array(array(0,"не выводить"),array(1,"выводить")),"Вывод заголовков последних добавленных статей в отдельном блоке","выводить или нет"),
      array("LAST_COMPONENTS_NAME_PART_HABLON","text",0,"Имя области, в которой будет выводиться блок последних статей",'нужно написать либо имя области, либо значение "-1", если модуль не будет выводить дополнительную информацию'),
      array("LAST_COMPONENTS_NUM_PRINT_PART_HABLON","numeric",0,"Позиция выводимого блока последних статей в соответствующей области","например,10"),
      array("LAST_COMPONENTS_KOLVO_ELEMENTS","numeric",0,"Количество заголовков в блоке последних статей","например, 5"),
      
      array("NAME_PART_HABLON_FORM_AVTORIZ","text",0,"область вывода формы авторизации пользователей на сайте","например, right"),
      array("FORM_AVTORIZ_NUM_PRINT_PART_HABLON","numeric",0,"позиция выводимой формы авторизации в соответствующей области","например, 1"),
      
    )
   )
  */
  /*
  array(
    array("Тестовые настройки",1),
    array(
      array("INIT_LIST_ABUSE_ADVERT_TEST","array",array(array("text","Название причины жалобы")),"Причины для жалобы","нужно создать одну или более записей"),
      array("TEST_TYPE_SELECT","select",array(array(0,"не использовать"),array(1,"использовать")),"Выбор из списка значений","Нужно выбрать одно из значений"),
      array("TEST_TYPE_NUMERIC","numeric",0,"Нужно указать число","например, 100"),
    )
   ),
  */
  );



