
/* Загрузчик изображений для панели управления */

function eng_fsupload_cp(elm_main_box,first_list_files,opts)
  {
    
    this.obj_main_box=false;
    
    this.first_list_files=first_list_files;
    this.first_mas_files=[];
    //this.pref=pref;
    this.type_proc="preload";
    this.opts= {
      "max_numbr_files": 5,
      "max_size_img": 50000000,
      "nameFieldFiles":"upload_field_files",
      "path_url_upload":"",//"url_dir/upload_file.php"
      "path_url_img_new":"",
      "dir_url_img_exists":"",
      "dir_url_img_big_exists":"",
      "ident":"1",
      "param_add_send":[],
      "on_alter":true,
      "only_read":false
    };
    
    this.data_files=[];//массив с данными о файлах
    this.accepted_files=[];//массив с загруженными файлами
    this.sort_files=[];//массив с отсортированными файлами
    this.mas_delete_files=[];
    
    this.is_blocked_preload_imgs=false;
    
    this.accept_type_files="jpg|jpeg|png|gif";
    
    this.obj_preload_base_imgs=false;
    this.obj_box_preview_imgs=false;
    this.obj_box_uploader_files=false;
    this.obj_field_files=false;
    this.obj_block_btn_main=false;
    this.obj_elm_status=false;
    
    this.id_file_list=1;
    
    this.num_create_img_normal=1;
    this.quantity_img_normal=0;
    
    
    this._first_init=function()
      {
        this.obj_main_box=engine_elm_html.get_obj(elm_main_box);
        
        this.first_mas_files=[];
        if (this.first_list_files != "")
          {
            this.first_mas_files=this.first_list_files.split("|");
          }
        
        if (opts)
          {
            for (var i in this.opts)
              {
                if ( typeof(opts[i]) != "undefined") this.opts[i]=opts[i];
              }
          }
        //wconsole("opts",this.opts);
      }
    
    this.write_imgs=function()
      {
        
        if (this.type_proc == "preload")
          {
            this._write_imgs_preload();
          }
         else
          {
            this._write_imgs_normal();
          }
        
      }
    
    this._write_imgs_preload=function()
      {
        this.accepted_files=[];
        this.sort_files=[];
        this.mas_delete_files=[];
        
        this._write_base_block_imgs_preload();
        
        this._init_imgs_preload();
        this._add_exists_imgs_preload();
        
        this.is_blocked_preload_imgs=false;
      }
    
    this._init_imgs_preload=function()
      {
        var ident=this.opts["ident"];
        var this_obj=this;
        
        this.obj_preload_base_imgs=engine_elm_html.get_obj("fsupload_preload_base_imgs_"+ident);
        this.obj_box_preview_imgs=engine_elm_html.get_obj("fsupload_box_preview_imgs_"+ident);
        this.obj_box_uploader_files=engine_elm_html.get_obj("fsupload_box_uploader_files_"+ident);
        this.obj_field_files=engine_elm_html.get_obj("fsupload_field_files_"+ident);
        this.obj_block_btn_main=engine_elm_html.get_obj("fsupload_block_btn_main_"+ident);
        this.obj_elm_status=engine_elm_html.get_obj("fsupload_elm_status_"+ident);
        
        elmAddEventListener(this.obj_block_btn_main,"click",function(){ if (this_obj.opts["only_read"]) {alert ("Загрузка изображений запрещена!"); return (false);} if (!this_obj.is_blocked_preload_imgs) this_obj.obj_field_files.click(); });
        elmAddEventListener(this.obj_field_files,"change",function(a){ this_obj._action_field_change_files(a); });
        
        var sortable;
        if (this.obj_box_preview_imgs)
          {
            sortable = Sortable.create(this_obj.obj_box_preview_imgs, {
              animation: 150,
              filter: ".fsupload_cp_image_button_remove,.uploader_image_button_rotate_1,.uploader_image_button_rotate_2",
              preventOnFilter: false,
              onUpdate: function() {
                //this_obj._refresh_data_mas_imgs();
                return (true);
              }
            });
            
          }
      }
    
    this._write_base_block_imgs_preload=function()
      {
        var ident=this.opts["ident"];
        var this_obj=this;
        var mas_st=[
         ["div",[["id","fsupload_preload_base_imgs_"+ident]],[
          ["div",[["class","fsupload_cp_box_preview"],["id","fsupload_box_preview_imgs_"+ident]],""],
          ["div",[["id","fsupload_box_uploader_files_"+ident]],[
            ["input",[["type","file"], ["id","fsupload_field_files_"+ident],["multiple","multiple"],["class","fsupload_cp_nodisplay"],["name","files_img_bd[]"],["accept","image/*"]]],
            ["div",[["id","fsupload_block_btn_main_"+ident],["class","fsupload_cp_block_btn_main"]],[
              ["span",[["id","fsupload_elm_status_"+ident],["class","fsupload_cp_elm_status"]],"Загрузить изображения"]
             ]]
           ]],
          this.opts["on_alter"] ?
          ["div",[["class","marginTop10"]],[
            "Если у вас возникли проблемы с загрузкой изображений, воспользуйтесь ",
            ["span",[["class","fsupload_cp_action_link"]],"альтернативным способом",[["click",function(){ this_obj._action_change_type_load_imgs("normal"); }]]]
           ]] : false
         ]]
        ];
        
        forming_html_struct_data.write_data(this.obj_main_box,mas_st);
      }
    
    this._add_exists_imgs_preload=function()
      {
        var mas_files=[], d_file={}, name_image="", url_image="";
        //wconsole("массив с существующими изорбражениями",this.first_mas_files);
        for (var i=0; i<this.first_mas_files.length; i++)
          {
            d_file = {
              "name": "",
              "size": 0,
              "dataURL": "",
              "status": "success",
              "accepted": true,
              "existfile": true,
              "tmp_name_srv": "",
              "file": false,
              "id": ""
            };
            name_image = this.first_mas_files[i];
            //url_image =dir_http+"/"+name_dir_loadfiles_moduls+"/ishop/smallfoto/"+name_image;
            //url_image =this.images_directory+name_image;
            url_image = this.opts["dir_url_img_exists"] + name_image;
            
            d_file["name"] = name_image;
            d_file["dataURL"] = url_image;
            
            mas_files.push(d_file);
          }
        
        if (mas_files.length > 0) this._add_files(mas_files);
        
        return (true);
      }
    
    /* блокируем кнопку загрузки */
    this._block_upload_imgs=function()
      {
        this.is_blocked_preload_imgs=true;
        engine_elm_html.set_html(this.obj_elm_status, 'Идет загрузка...');
        
        return (true);
      }
    
    /* разблокируем кнопку загрузки */
    this._unblock_upload_imgs=function()
      {
        this.is_blocked_preload_imgs=false;
        engine_elm_html.set_html(this.obj_elm_status, 'Загрузить изображения');
        
        this._clear_field_files_upload();
        
        return (true);
      }
    
    this._action_field_change_files=function(e)
      {
        var this_obj=this;
        
        if ( this_obj.is_blocked_preload_imgs ) return (false);
        
        var files=[], files_count=0, files_counter=0, upload_files=false, d_file={};
        this._block_upload_imgs();
        
        files = this.obj_field_files.files;
        files_count = files.length;
        files_counter = 0;
        upload_files = function()
          {
            var data_send, file;
            if (files_count <= files_counter || (this_obj.opts["max_numbr_files"] > 0 && this_obj.data_files.length >= this_obj.opts["max_numbr_files"]))
              {
                this_obj._unblock_upload_imgs();
                
                return (true);
              }
            
            file = files[files_counter];
            files_counter++;
            
            //wconsole(file);
            var d_check_exp = check_exp_file(file.name, this_obj.accept_type_files, "", true);
            
            //пропускаем файл, если неверное расширение файла
            if (d_check_exp[0] == false) return upload_files();
            
            //пропускаем файл, если размер файла превышает допустимый
            if (this_obj.opts["max_size_img"] > 0 && file.size && this_obj.opts["max_size_img"] < file.size) return upload_files();
            
            data_send = new FormData();
            data_send.append('uploading', 1);
            data_send.append(this_obj.opts["nameFieldFiles"], file);
            if (this_obj.opts["param_add_send"] && this_obj.opts["param_add_send"].length > 0)
              {
                for (var j = 0; j < this_obj.opts["param_add_send"].length; j++)
                  {
                    data_send.append(this_obj.opts["param_add_send"][j][0], this_obj.opts["param_add_send"][j][1]);
                  }
              }
            //wconsole(file);
            //var one_file={"name":name_image,"size":10,"dataURL":url_image,"status":"success","accepted":true,"existfile":true};
            d_file = {
              "name": "",
              "size": 0,
              "dataURL": "",
              "status": false,
              "accepted": false,
              "existfile": false,
              "tmp_name_srv": "",
              "file": false,//file,
              "id": ""
            };
            
            var url = this_obj.opts["path_url_upload"];
            
            loadHTTPjc(url, function (answer, add_param)
              {
                //wconsole(answer);
                var data=answer.data;
                if (data.oper_error == 0 && data.files.length > 0)
                  {
                    var new_file = data.files[0];
                    d_file["name"] = new_file[1];
                    d_file["dataURL"] = this_obj.opts["path_url_img_new"] + new_file[1];
                    d_file["tmp_name_srv"] = new_file[1];
                    d_file["status"] = "success";
                    d_file["accepted"] = true;
                    this_obj._add_files([d_file]);
                  }
                return (upload_files());
              }, data_send);
            
            return (true);
          };
        
        return (upload_files());
      }
    
    this._add_files=function(files)
      {
        //wconsole("add new files", files);
        
        var f = false, j = 0, len = 0;
        
        for (j = 0, len = files.length; j < len; j++)
          {
            f = files[j];
            f["num"] = this.id_file_list;
            f["id"] = "prevElemUpLoad_" + this.opts["ident"] + "_" + this.id_file_list;
            this.id_file_list++;
            
            this.data_files.push(f);
            this._write_one_image_preload(f);
          }
        
        //this._refresh_data_mas_imgs();
        
        return (true);
      }
    
    this._refresh_data_mas_imgs=function()
      {
        var list = [], one_file = false;
        var mas_accepted = [], mas_sort_file = [];
        
        if (this.data_files.length > 0)
          {
            for (var i = 0; i < this.data_files.length; i++)
              {
                one_file = this.data_files[i];
                //this.write_txt_info("---",one_file.name,one_file.status,one_file.tmp_name_srv,one_file.accepted);
                if (one_file.status == "success" && one_file.tmp_name_srv && !one_file.existfile)
                  {
                    mas_accepted.push(one_file.tmp_name_srv);
                  }
                
                if (one_file.status == "success")
                  {
                    mas_sort_file.push([one_file.tmp_name_srv ? one_file.tmp_name_srv : one_file.name, one_file.id, 0]);
                  }
              }
          }
        
        this.accepted_files = mas_accepted;
        
        var sort_block = this.obj_box_preview_imgs.childNodes;
        
        var numb_sort_block = {};
        var j = 0;
        for (j = 0; j < sort_block.length; j++)
          {
            numb_sort_block[sort_block[j].id] = j + 1;
          }
        
        for (j = 0; j < mas_sort_file.length; j++)
          {
            if (numb_sort_block[mas_sort_file[j][1]]) mas_sort_file[j][2] = numb_sort_block[mas_sort_file[j][1]];
          }
        
        mas_sort_file.sort(function (a, b)
          {
            return (a[2] - b[2])
          });
        
        this.sort_files = ext_mas1_from_mas2level(mas_sort_file, 0);
        //wconsole("массивы с новыми файлами и с порядком сортировки",this.accepted_files,this.sort_files);
        
        return (true);
      }
    
    this._write_one_image_preload=function(one_file)
      {
        
        var this_obj=this;
        var tt = ''
          + '<div class="fsupload_cp_image_box_bg">'
          + '<div class="fsupload_cp_image_box_img"></div>'
          //+'<span class="fsupload_cp_image_button_rotate_1" data-image-rotate="back"></span>'
          //+'<span class="fsupload_cp_image_button_rotate_2" data-image-rotate="forward"></span>'
          + '<span class="fsupload_cp_image_button_remove">x</span>'
          + '</div>'
          + '';
        
        var templ = obj_processing_block.create_block_div(one_file["id"], this.obj_box_preview_imgs, "fsupload_cp_image_box");
        templ.innerHTML = tt;
        
        var obj_elm = getElementsByClassNameGen("fsupload_cp_image_box_img", templ);
        engine_elm_html.set_html(obj_elm[0], '<img src="' + (one_file["dataURL"]) + '" alt="">');
        
        obj_elm = getElementsByClassNameGen("fsupload_cp_image_button_remove", templ);
        elmAddEventListener(obj_elm[0], "click", function ()
          {
            this_obj._delete_one_img_preload(one_file);
          });
        
        return (true);
      }
    
    this._delete_one_img_preload=function (one_file)
      {
        if (this.opts["only_read"])
          {
            alert ("Запрещено удалять изображения!");
            return (false);
          }
        
        if (!confirm("Удалить изображение?")) return (false);
        var s_elm=search_mas_2level(this.data_files,"num",one_file.num,false);
        
        if (!s_elm[0]) return (false);
        var elm=this.data_files[s_elm[1]];
        
        var obj=engine_elm_html.get_obj(elm["id"]);
        obj.parentNode.removeChild(obj);//удаляем превьюшку
        
        this.data_files.splice(s_elm[1],1);//удаляем изображение из массива с изображениями
        
        //удаляем изображение на сервере - удаляем предзагруженное изображение или помечаем для удаления
        this._delete_server_one_img_preload(elm);
        
        return (true);
      }
    
    this._delete_server_one_img_preload=function(one_file)
      {
        //wconsole("удаляем изображение",one_file);
        
        if (one_file.status == "success" && !one_file.existfile && one_file.tmp_name_srv)
          {
            //это новое загруженное изображение, удаляем его с сервера (удаляем предзагруженное изображение)
            var url=this.opts["path_url_upload"];//dir_http+"/moduls/ishop/mdadmin/ajax_elm/tools_files.php";
            var post="delete_tmp=on&name_tmp="+one_file.tmp_name_srv + "&" + this._forming_query_param_add_send();
            
            loadHTTPjc(url,function(a,b){  },post);
          }
         else if (one_file.status == "success" && one_file.existfile)
          {
            //это существующее изображение, помечаем его для удаления в дальнейшем
            
            this.mas_delete_files.push(one_file.name);
            
          }
        
      }
    
    this._forming_query_param_add_send=function()
      {
        var post="";
        if (this.opts["param_add_send"] && this.opts["param_add_send"].length > 0)
          {
            var s="";
            for (var j = 0; j < this.opts["param_add_send"].length; j++)
              {
                post+=s+this.opts["param_add_send"][j][0] + "=" + encodeURIComponent(this.opts["param_add_send"][j][1]);
                s="&";
              }
          }
        return (post);
      }
    
    this._clear_field_files_upload=function()
      {
        this.obj_field_files.type="text";
        this.obj_field_files.value="";
        this.obj_field_files.type="file";
        
        return (true);
      }
    
    this._removeAllFilesPreload=function()
      {
        var one_file = false;
        
        if (this.data_files.length > 0)
          {
            for (var i = 0; i < this.data_files.length; i++)
              {
                one_file = this.data_files[i];
                
                var obj = engine_elm_html.get_obj(one_file["id"]);
                obj.parentNode.removeChild(obj);
                
                if (one_file.status == "success" && one_file.tmp_name_srv && !one_file.existfile)
                  {
                    this._delete_server_one_img_preload(one_file);
                  }
                
              }
            
            this.data_files = [];
          }
      }
    
    this._clear_method_preload=function()
      {
        this._removeAllFilesPreload();
        
        this.accepted_files=[];
        this.sort_files=[];
        this.mas_delete_files=[];
        
        engine_elm_html.set_html(this.obj_main_box,"");
        
      }
    
    this.get_data_imgs=function()
      {
        this._refresh_data_mas_imgs();
        var vdata=[];
        if (this.type_proc == "preload")
          {
            vdata=[this.type_proc,this.accepted_files,this.sort_files,this.mas_delete_files];
          }
         else
          {
            vdata=[this.type_proc,"","",this.mas_delete_files];
          }
        
        return (vdata);
      }
    
    this._action_change_type_load_imgs=function(v_type)
      {
        
        this.type_proc=v_type;
        
        if (this.type_proc == "preload")
          {
            this._clear_method_normal();
            this._write_imgs_preload();
          }
         else
          {
            this._clear_method_preload();
            this._write_imgs_normal();
          }
        
      }
    
    this._write_imgs_normal=function()
      {
        this.accepted_files=[];
        this.sort_files=[];
        this.mas_delete_files=[];
        
        this._write_base_block_imgs_normal();
        
        this._init_imgs_normal();
        this._add_exists_imgs_normal();
        
        this._control_btn_add_elm_normal();
        
        if (this.opts["max_numbr_files"] <=0 || this.quantity_img_normal < this.opts["max_numbr_files"])
          {
            this._add_one_elm_normal_imgs();
          }
      }
    
    this._write_base_block_imgs_normal=function()
      {
        var ident=this.opts["ident"];
        var this_obj=this;
        var mas_st=[
         ["div",[["id","fsupload_normal_base_imgs_"+ident]],[
          ["div",[["class","fsupload_cp_box_preview"],["id","fsupload_box_exists_imgs_"+ident]],""],
          
          ["div",[["id","fsupload_add_normal_imgs_"+ident]],[
            //["input", [["type",'file'], ["name",'img_element[]'], ["value",'']]]
           ]],
          ["div",[["class","marginTop10"]],[
            ["input",[["type",'button'], ["value",'Добавить изображение'],["name","_button_add_normal_img"],["id","_fsupload_btn_add_normal_img_"+ident],["class","elm_btn"]],false,[["click",function(){this_obj._add_one_elm_normal_imgs();}]] ]
           ]],
          /*["div",[["id","fsupload_box_uploader_files_"+ident]],[
            ["input",[["type","file"], ["id","fsupload_field_files_"+ident],["multiple","multiple"],["class","fsupload_cp_nodisplay"],["name","files_img_bd[]"],["accept","image/*"]]],
            ["div",[["id","fsupload_block_btn_main_"+ident],["class","fsupload_cp_block_btn_main"]],[
              ["span",[["id","fsupload_elm_status_"+ident],["class","fsupload_cp_elm_status"]],"Загрузить изображения"]
             ]]
           ]],*/
          ["div",[["class","marginTop10"]],[
            "Попробуйте ",
            ["span",[["class","fsupload_cp_action_link"]],"удобный способ загрузки изображений",[["click",function(){ this_obj._action_change_type_load_imgs("preload"); }]]]
           ]]
         ]]
        ];
        
        forming_html_struct_data.write_data(this.obj_main_box,mas_st);
      }
    
    this._init_imgs_normal=function()
      {
        var ident=this.opts["ident"];
        var this_obj=this;
        
        this.quantity_img_normal=0;
        
        this.obj_normal_base_imgs=engine_elm_html.get_obj("fsupload_normal_base_imgs_"+ident);
        this.obj_box_exists_imgs=engine_elm_html.get_obj("fsupload_box_exists_imgs_"+ident);
        this.obj_box_add_normal_imgs=engine_elm_html.get_obj("fsupload_add_normal_imgs_"+ident);
        this.obj_btn_add_normal=engine_elm_html.get_obj("_fsupload_btn_add_normal_img_"+ident);
        
        //elmAddEventListener(this.obj_block_btn_main,"click",function(){ if (!this_obj.is_blocked_preload_imgs) this_obj.obj_field_files.click(); });
        //elmAddEventListener(this.obj_field_files,"change",function(a){ this_obj._action_field_change_files(a); });
        
        return (true);
      }
    
    this._add_exists_imgs_normal=function()
      {
        var st_data=[];
        if (this.first_mas_files.length > 0)
          {
            for (var i = 0; i < this.first_mas_files.length; i++)
              {
                this.quantity_img_normal++;
                
                st_data.push(this._write_one_image_normal(this.first_mas_files[i],i));
              }
          }
        
        forming_html_struct_data.write_data(this.obj_box_exists_imgs,st_data);
      }
    
    this._write_one_image_normal=function(name_img,num_mas)
      {
        var ident=this.opts["ident"];
        
        var this_obj=this;
        var st_one=["div",[["class","fsupload_cp_image_box"],["id","one_img_normal_load_imgs_"+ident+"_"+num_mas]],[
          ["div",[["class","fsupload_cp_image_box_bg"]],[
            ["div",[["class","fsupload_cp_image_box_img"]],[
              ["img",[["src",this.opts["dir_url_img_exists"] + name_img]]]
             ]],
            ["span",[["class","fsupload_cp_image_button_remove"]],"x",[["click",function(){ this_obj._delete_one_img_exist_normal(name_img,num_mas); }]]]
           ]]
         ]];
        
        return (st_one);
      }
    
    this._delete_one_img_exist_normal=function(name_img,num_mas)
      {
        if (this.opts["only_read"])
          {
            alert ("Запрещено удалять изображения!");
            return (false);
          }
        
        if (!confirm("Удалить изображение?")) return (false);
        
        var ident=this.opts["ident"];
        var obj_elm=engine_elm_html.get_obj("one_img_normal_load_imgs_"+ident+"_"+num_mas);
        //var s_elm=search_mas_2level(this.data_files,"num",one_file.num,false);
        
        if (!obj_elm) return (false);
        //var elm=this.data_files[s_elm[1]];
        
        //var obj=engine_elm_html.get_obj(elm["id"]);
        obj_elm.parentNode.removeChild(obj_elm);//удаляем превьюшку
        
        //this.data_files.splice(s_elm[1],1);//удаляем изображение из массива с изображениями
        
        //помечаем изображение для удаления
        this.mas_delete_files.push(name_img);
        this.quantity_img_normal--;
        
        this._control_btn_add_elm_normal();
        
        return (true);
      }
    
    this._add_one_elm_normal_imgs=function()
      {
        
        var ident=this.opts["ident"];
        
        if (this.opts["max_numbr_files"] > 0 && this.opts["max_numbr_files"] <= this.quantity_img_normal)
          {
            return;
          }
        
        var this_obj = this;
        /*
        var elem_new_block = document.createElement("div");
        elem_new_block.className = "bk_contr_new_item_normal_load_imgs";
        var obj_new = document.getElementById("block_new_images_product_" + this.num_serial_edit).appendChild(elem_new_block);
        */
        var name_pole=this.opts["nameFieldFiles"];
        var obj_new=obj_processing_block.create_block_div("block_new_field_file_normal_"+ident+"_"+this.num_create_img_normal,this.obj_box_add_normal_imgs,"fsupload_cp_contr_new_field_img");
        //this.mas_create_elem_item[this.num_create_elem_item] = obj_new;
        var n = this.num_create_img_normal;
        var mas_init = [
          ["input", [["type", "file"], ["name", name_pole+"[]"]],false,[["change",function(){ this_obj._action_change_field_file_normal(n); }]]],
          "&nbsp;",
          ["span", [["class", "fsupload_cp_action_link"]], "удалить", [["click", function ()
            {
              this_obj._delete_one_new_field_normal(n);
            }]]]
         ];
        //obj_new.innerHTML="<input type='file' name='img_element[]'>&nbsp;<a href='#' onClick='delete_elem_img("+num_create_elem_item+"); return(false);'>удалить</a>";
        forming_html_struct_data.write_data(obj_new, mas_init);
        this.num_create_img_normal++;
        
        this.quantity_img_normal++;
        this._control_btn_add_elm_normal();
        
      }
    
    this._action_change_field_file_normal=function(num)
      {
        var ident=this.opts["ident"];
        var obj_bk=engine_elm_html.get_obj("block_new_field_file_normal_"+ident+"_"+num);
        var obj_pfs=obj_bk.getElementsByTagName("input");
        var obj_pf=obj_pfs[0];
         
        if (this.opts["only_read"])
          {
            this._clear_one_field_files_normal(obj_pf);
            alert ("Загрузка изображений запрещена!");
            return (false);
          }
        
        if ( !check_exp_file(obj_pf.value,this.accept_type_files,"Недопустимое расширение изображения!\nДопускаются изображения ",false) )
          {
            //расширение неверное, поэтому очищаем поле 
            this._clear_one_field_files_normal(obj_pf);
            
            return (false);
          }
        
        return (true);
      }
    
    this._clear_one_field_files_normal=function(obj_pf)
      {
        obj_pf.type="text";
        obj_pf.value="";
        obj_pf.type="file";
        
        return (true);
      }
    
    this._delete_one_new_field_normal=function(num)
      {
        var ident=this.opts["ident"];
        var obj=engine_elm_html.get_obj("block_new_field_file_normal_"+ident+"_"+num);
        obj.parentNode.removeChild(obj);
        this.quantity_img_normal--;
        this._control_btn_add_elm_normal();
        
        return (true);
      }
    
    this._control_btn_add_elm_normal=function()
      {
        
        var vv=false;
        
        if (this.opts["max_numbr_files"] > 0)
          {
            if (this.quantity_img_normal >= this.opts["max_numbr_files"])
              {
                vv = true;
              }
            else
              {
                vv = false;
              }
          }
        
        this.obj_btn_add_normal.disabled=vv;
      }
    
    this._clear_method_normal=function()
      {
        //удаляем изображения, выведенные методом normal
        
        this.accepted_files=[];
        this.sort_files=[];
        this.mas_delete_files=[];
        
        engine_elm_html.set_html(this.obj_main_box,"");
      }
    
    this._first_init();
    
  }
