<?php


class eng_mang_subscribe_content
{
  
  
  function __construct()
    {
      
    }
  
  function work_external($oper)
    {
      
      
      $error=0;
      $error_text="";
      $data=false;
      //$data_res=false;
      
      if ($oper == "get_data")
        {
          list($error,$error_text,$data)=$this->get_data_subscribe();
        }
      elseif ($oper == "delete_data")
        {
          list($error,$error_text,$data)=$this->delete_data_subscribe();
        }
      
      write_ajax_answer_jc($error,$error_text, "data:" . ($data ? "{" . encode_gen_mas_to_jointext($data,false,true) ."} " :' "" ') );
      
      return (true);
    }
  
  function get_data_subscribe()
    {
      return ($this->_get_data_subscribe());
    }
  
  function _get_data_subscribe()
    {
      global $obj_control_data, $obj_site;
      
      $error=0;
      $error_text="";
      $data=false;
      
      $mas_init=array(
        array("num_author","post","num_author","numeric:int",true,false,false,"",false,"tr","all",0,"Не указан автор!",false,false),
        array("num_user","post","num_user","numeric:int",true,false,false,"",false,"tr","all",0,"Не указан пользователь!",false,false),
        array("num_page","post","num_page","numeric:int",true,true,false,"",false,"tr","all",1,"Не указана страница!",false,false),
        array("elms_page","post","elms_page","numeric:int",true,true,false,"",false,"tr","all",10,"Не указано количество элементов на странице!",false,false),
        
        //array("type","post","type","text",true,true,"listv","on,off",false,false,"all","off"),
        //array("contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
       );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_init);
      
      if ( !($rez_control_data[0] && !$rez_control_data[1]) ) return ([1,"Ошибка с данными!",false]);
      
      $mas_inbox = $rez_control_data[3];
      
      //if ( !eng_promote_safety::check_code($GLOBALS["id_user_to_site"],$mas_inbox["contr_code"]) ) return ([1,"Неверный ключ безопасности!",false]);
      $num_author=$mas_inbox["num_author"];
      $num_user=$mas_inbox["num_user"];
      $num_page=$mas_inbox["num_page"];
      $elms_page=$mas_inbox["elms_page"];
      
      $kolvo_all=$this->get_count_subscribe($num_author,$num_user);
      $data_subscribe=[];
      $data_users=[];
      
      if ($kolvo_all > 0)
        {
          $db_query="select * from ".DB_PREF."subscribe_content where status='on' "
           .($num_author > 0 ? " and num_author = ".$num_author:"")
           .($num_user > 0 ? " and num_user = ".$num_user:"")
           ." order by put_date DESC limit ".(($num_page - 1) * $elms_page).",".$elms_page." ";
          
          list($kolvo,$data_subscribe)=db_work::query_select_assoc($db_query);
          
          if ($kolvo > 0)
            {
              $m_num_users1=select_mas1lev_2level($data_subscribe,"num_author",false);
              
              $m_num_users2=select_mas1lev_2level($data_subscribe,"num_user",false);
              
              $m_num_users=array_merge($m_num_users1,$m_num_users2);
              
              $m_num_users=array_unique($m_num_users);
              
              $m_num_users=array_values($m_num_users);
              //write_log_cms($m_num_users,"m num user");
              
              $data_users = $obj_site->select_data_user_to_list_id($m_num_users,"id_user,name_user,date_create");
            }
        }
      
      $data=["kolvo_all"=>$kolvo_all,"data_subscribe"=>$data_subscribe,"data_users"=>$data_users];
      
      return ([$error,$error_text,$data]);
    }
  
  function get_count_subscribe($num_author,$num_user)
    {
      $db_query="select count(*) from ".DB_PREF."subscribe_content where status='on' "
       .($num_author > 0 ? " and num_author = ".$num_author:"")
       .($num_user > 0 ? " and num_user = ".$num_user:"");
       
      $kolvo=db_work::query_count($db_query);
      //write_log_cms($kolvo,"kolvo all");
      return ($kolvo);
    }
  
  function delete_data_subscribe()
    {
      return ($this->_delete_data_subscribe());
    }
  
  function _delete_data_subscribe()
    {
      global $obj_control_data, $obj_site;
      
      $error=0;
      $error_text="";
      $data=false;
      
      $mas_init=array(
        //array("num_author","post","num_author","numeric:int",true,false,false,"",false,"tr","all",0,"Не указан автор!",false,false),
        array("list_items","post","list_items","list_int",true,true,false,"",false,false,"all",0,"Не указан список!",false,false),
        /*
        array("num_page","post","num_page","numeric:int",true,true,false,"",false,"tr","all",1,"Не указана страница!",false,false),
        array("elms_page","post","elms_page","numeric:int",true,true,false,"",false,"tr","all",10,"Не указано количество элементов на странице!",false,false),
        */
        //array("type","post","type","text",true,true,"listv","on,off",false,false,"all","off"),
        //array("contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
       );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_init);
      
      if ( !($rez_control_data[0] && !$rez_control_data[1]) ) return ([1,"Ошибка с данными!",false]);
      
      $mas_inbox = $rez_control_data[3];
      
      //if ( !eng_promote_safety::check_code($GLOBALS["id_user_to_site"],$mas_inbox["contr_code"]) ) return ([1,"Неверный ключ безопасности!",false]);
      
      $db_query="delete from ".DB_PREF."subscribe_content where id_subscribe IN (". $mas_inbox["list_items"] .") ";
      //write_log_cms($db_query);
      db_work::query($db_query);
      
      return ([$error,$error_text,$data]);
    }
  
  
}