<?php


class eng_tpl_manag
{
  
  protected $dir_template="";
  protected $name_file_set_bk="set_bk_tpl.php";
  
  function __construct()
    {
      $this->init_data();
    }
  
  function init_data()
    {
      global $dir_template;
      
      $this->dir_template=$dir_template;
    }
  
  function get_all_data()
    {
      global $list_modules;
      
      $data=["init_moduls"=>[],"set_moduls"=>[],"name_template"=>""];
      $data_init_moduls=[];
      
      $data_init_mainmodul=$this->get_one_tpl_init_bk_modul("mainModul");
      if ($data_init_mainmodul)
        $data_init_moduls[]=["mainModul","Главный модуль",$data_init_mainmodul];
      
      foreach ($list_modules as $ident_modul => $one_modul)
        {
          if (!$one_modul[2]) continue;//( !$one_modul[2] || !$one_modul[6] )
          
          $one_tpl_init_bk=$this->get_one_tpl_init_bk_modul($ident_modul);
          
          if ($one_tpl_init_bk)
            {
              $data_init_moduls[]=[$ident_modul,$one_modul[4],$one_tpl_init_bk];
            }
        }
      
      $data["init_moduls"]=$data_init_moduls;
      
      $data["set_moduls"]=$this->get_all_set_bk_tpl();
      
      //получаем описание областей шаблона
      $obj_eng_parts_desc = new engine_parts_tpl_desc();
      
      $cfg_parts_desc=$obj_eng_parts_desc->get_list_parts();
      //write_log_cms($cfg_parts_desc);
      $data["init_parts_desc"]=$cfg_parts_desc;
      
      
      //получаем init-данные страниц пользовательской части сайта
      global $obj_site;
      $mas_all_init_page = $obj_site->get_data_page_all_modul_nsrl(true);
      
      $mas_full_init_page["all"] = array( "name" => "На всех страницах", "identkey" => "all", "nested" => $mas_all_init_page );
      $data["init_page"]=$mas_full_init_page;
      //write_log_cms($mas_full_init_page,"full init page");
      global $name_template;
      $data["name_template"]=$name_template;
      
      return ($data);
    }
  
  function get_one_tpl_init_bk_modul($name_modul)
    {
      // $name_modul - mainModul (главный модуль) или имя модуля
      // возвращает $cfg_modul заданного модуля или false, если файл или переменная не найдена
      
      $data_init = false;// array();
      $file_init = "";
      //$file_set = "";
      $on_file=false;
      
      if ($name_modul == "mainModul")
        {
          $file_init = $this->dir_template."/cfg_tpl_main.php";
        }
       elseif ($name_modul)
         {
           $file_init = $this->dir_template."/moduls/".$name_modul."/cfg_tpl_modul.php";
         }
      
      if ($file_init && is_file($file_init))
        {
          $on_file=true;
          include($file_init);
        }
      
      if ($on_file && !empty($part_init_bk_tpl)) $data_init = $part_init_bk_tpl;
      
      return ($data_init);
    }
  
  function get_all_set_bk_tpl()
    {
      //получение из файла массива с настройками блоков
      $file_set = $this->dir_template."/configs/".$this->name_file_set_bk;// "set_bk_tpl.php";
      $all_set=[];
      
      if ($file_set && is_file($file_set))
        {
          include($file_set);
          if (!empty($all_set_bk_tpl)) $all_set=$all_set_bk_tpl;
        }
      
      return ($all_set);
    }
  
  function save_file_all_set_bk_tpl($all_set_bk_tpl)
    {
      //функция сохраняет готовый массив с настройками
      
      $path_file=$this->dir_template."/configs/".$this->name_file_set_bk;
      
      file_put_contents($path_file,"<?php\n\n" . '$all_set_bk_tpl=' . var_export($all_set_bk_tpl,true) .";");
      
      return (true);
    }
  
  function create_one_tpl_init_bk_modul()
    {
      global $obj_control_data;
      $error=0;$error_text="no";
      $rez="";
      
      $massiv=array(
        
        array("part_tpl","post","part_tpl","text",true,true,"hablonrv","/^[a-zA-Z_0-9\-]+$/is",true,"tr"),
        array("pos","post","pos","numeric",true,true,false,""),
        array("hide","post","hide","text",true,true,"listv","hide,show"),
        
        array("ident_modul","post","ident_modul","text",true,true,"hablonrv","/^[a-zA-Z_0-9\-]+$/is",true,"tr"),
        array("ident_bk","post","ident_bk","text",true,true,"hablonrv","/^[a-zA-Z_0-9\-]+$/is",true,"tr"),
        //array("htext","post","htext","text",true,true,false,""),
        //array("idedit","post","idedit","numeric",false,false,false,""),
        
        array("view_page","post","view_page","text",true,true,"hablonrv","/^[a-zA-Z_0-9\\[\\]\\-]+$/is"),
        array("not_view_page","post","not_view_page","text",true,true,"hablonrv","/^[a-zA-Z_0-9\\[\\]\\-]+$/is"),
      );
      
      $rez_control=$obj_control_data->processing_one_group($massiv);
      
      if ( $rez_control[0] && !$rez_control[1] )
        {
          $mas_inbox = $rez_control[3];
          $mas_status = $rez_control[5];
          //write_log_cms($mas_inbox);
          
          list($error,$error_text)=$this->save_one_tpl_init_bk_modul($mas_inbox);
          
        }
       else
         {
           $error=1;
           $error_text="Ошибка с данными!";
         }
      
      return ([$error,$error_text]);
    }
  
  function save_one_tpl_init_bk_modul($c_data)
    {
      $error=0;
      $error_text="";
      
      $modul=$c_data["ident_modul"];
      $ident_bk=$c_data["ident_bk"];
      
      $on_modul=false;
      
      if ($modul == "mainModul")
        {
          $on_modul=true;
        }
       else
         {
           $on_modul=work_init_moduls::check_use_modul($modul);
         }
      
      if (!$on_modul)
        {
          return ([1,"Неверно задан модуль!"]);
        }
      
      $one_tpl_init_bk=$this->get_one_tpl_init_bk_modul($modul);
      //write_log_cms($one_tpl_init_bk);
      
      if (empty($one_tpl_init_bk[$ident_bk]))
        {
          return ([1,"Неверно задан блок!"]);
        }
      
      //имя области, позиция блока, страницы на которых выводится блок, страницы на которых не должен выводиться блок, видимость
      $one_set=[$c_data["part_tpl"], $c_data["pos"], $c_data["view_page"], $c_data["not_view_page"], ($c_data["hide"] == "show" ? true : false)];
      //write_log_cms($one_set,"one_set");
      
      $all_set=$this->get_all_set_bk_tpl();
      
      if (empty($all_set[$modul])) $all_set[$modul]=[];
      
      $all_set[$modul][$ident_bk]=$one_set;
      
      $this->save_file_all_set_bk_tpl($all_set);
      
      
      return ([$error,$error_text]);
    }
  
  
  
}
