<?php


class eng_user_behavior_cp
{
  protected $index_code_visitor=[];
  
  function __construct()
    {
      
    }
  
  public function get_init_data()
    {
      $mas_init_data=[];
      
      global $mas_init_user_behavior;
      $mas_init_data=$mas_init_user_behavior;
      
      return ($mas_init_data);
    }
  
  public function get_data_page()
    {
      $error=0;
      $error_text="";
      
      $count_all=0;
      $data_ubehavior=[];
      $data_ubehavior_comb=[];
      $data_user=[];
      
      $in_data=[];
      $data=[];
      
      global $obj_control_data;
      
      list($error,$error_text,$in_data)=$this->_check_in_data();
      
      if ($error == 0)
        {
          list($error,$error_text,$count_all,$data_ubehavior)=$this->_get_data_ubehavior($in_data);
          
          if (sizeof($data_ubehavior))
            {
              $data_user=$this->_get_data_user($data_ubehavior);
              $data_ubehavior_comb=$this->_get_data_modul($data_ubehavior);
            }
        }
      
      $data=["count_all"=>$count_all, "data_ubehavior"=>$data_ubehavior_comb, "data_user"=>$data_user];
      
      return ([$error,$error_text,$data]);
    }
  
  protected function _check_in_data()
    {
      $error=0;
      $error_text="";
      
      $data=[];
      $data["elms_page"]=10;
      $data["num_page"]=1;
      $data["type_modul"]="";
      $data["type_oper"]="";
          
      global $obj_control_data;
      
      $mas=array(
        array("elms_page","post","elms_page","numeric:int",true,true,false,"",false,false,"all",10),
        array("num_page","post","num_page","numeric",true,false,false,"",false,false,"all",1),
        //array("on_like","post","on_like","text",true,true,"listv","on,off",false,false,"all","off"),
        array("type","post","type","text",true,false,false,"",false,"tr","all",""),
        array("id_visitor","post","id_visitor","text",true,false,false,"",false,"tr","all",""),
        //array("num_user","post","num_user","text",true,false,"hablonrv","/^[0-9]+(\,[0-9]+)*$/is",false,false,"all",""),
        array("period","post","period","text",true,true,"listv","all,today,yesterday,week,month,last_month,last_month2,numb_days30",false,"tr","all",""),
        
       );
      
      $rez_control_data=$obj_control_data->processing_one_group($mas);
      
      if ( $rez_control_data[0] && !$rez_control_data[1] )
        {
          $mas_inbox = $rez_control_data[3];
          $mas_status = $rez_control_data[5];
          
          $data["elms_page"]=$mas_inbox["elms_page"];
          $data["num_page"]=$mas_inbox["num_page"];
          $data["type_modul"]="";
          $data["type_oper"]="";
          $data["id_visitor"]=$mas_inbox["id_visitor"];
          $data["period"]=$mas_inbox["period"];
          
          if ($mas_inbox["type"])
            {
              $mas_type=explode(":",$mas_inbox["type"]);
              if (sizeof($mas_type) == 2)
                {
                  global $mas_init_user_behavior;
                  $mas_init_data=$mas_init_user_behavior;
                  if (!empty($mas_init_data[$mas_type[0]]) && !empty($mas_init_data[$mas_type[0]][$mas_type[1]]) && $num_m=work_init_moduls::get_num_modul($mas_type[0]) )
                    {
                      
                      $data["type_modul"]=$num_m;
                      $data["type_oper"]=$mas_type[1];
                    }
                  else
                    {
                      $error=1;
                      $error_text="Ошибка с данными!";
                    }
                }
              else
                {
                  $error=1;
                  $error_text="Ошибка с данными!";
                }
            }
          
        }
      else
        {
          $error=1;
          $error_text="Ошибка с данными!";
        }
      
      return ([$error,$error_text,$data]);
    }
  
  protected function _get_data_ubehavior($in_data)
    {
      $error=0;
      $error_text="";
      $count_all=0;
      $data=[];
      
      $cond="";
      if ($in_data["type_modul"])
        {
          $cond.=" modul = ".codeText($in_data["type_modul"])." and oper = '".codeText($in_data["type_oper"])."' ";
        }
      
      if ($in_data["id_visitor"])
        {
          $cond.=($cond ? " and ":"")." id_visitor='".codeText($in_data["id_visitor"])."' ";
        }
      
      if ($in_data["period"] !== "" && $in_data["period"] !== "all")
        {
          $_c_period=$this->_get_cond_period($in_data["period"]);
          if ($_c_period)
            $cond.=($cond ? " and ":"").$_c_period;
        }
      
      $db_query="select count(*) from ".DB_PREF."user_behavior "
        .($cond ? " where " . $cond : "");
        //." order by id_item DESC ";
      
      $count_all=db_work::query_count($db_query);
      
      if ($count_all > 0)
        {
          $db_query = "select * from ".DB_PREF."user_behavior "
            .($cond ? " where " . $cond :"")
            ." order by id_item DESC "." limit ".(($in_data["num_page"] - 1) * $in_data["elms_page"]).",".$in_data["elms_page"]." ";
          
          list($kolvo, $data) = db_work::query_select_assoc($db_query);
        }
      
      return ([$error,$error_text,$count_all,$data]);
    }
  
  protected function _get_data_user($data_ubehavior)
    {
      global $obj_site;
      $data_user=[];
      
      $mas_num_user = select_mas1lev_2level($data_ubehavior, "num_user", false);
      $mas_num_user = array_unique($mas_num_user);
      $mas_num_user2=[];
      
      foreach ($mas_num_user as $one_user)
        {
          $n_user = intval($one_user);//преобразуем в числа (может быть пустая строка или NULL)
          //И пропускаем, если, нет значения  
          if ($n_user > 0) $mas_num_user2[] = $n_user;
        }
      
      if (sizeof($mas_num_user2))
        {
          $data_user = $obj_site->select_data_user_to_list_id($mas_num_user, "id_user,name_user,date_create,access_admin,operation_1");
        }
      
      return ($data_user);
    }
  
  protected function _get_data_modul($data_ubehavior)
    {
      global $obj_site;
      
      $data_comb=[];
      $mas_name_modul=[];
      
      $index_data=[];
      
      foreach ($data_ubehavior as $row)
        {
          $new_row=$row;
          
          $name_modul=$mas_name_modul[$row["modul"]] ?? "";
          
          if ($name_modul == "")
            {
              $name_modul = work_init_moduls::get_name_modul($row["modul"],true);
              if (!$name_modul)
                {
                  $name_modul="none";
                }
              
              $mas_name_modul[$row["modul"]]=$name_modul;
              //write_log_cms($name_modul,"получено название модуля");
            }
          
          //write_log_cms($name_modul,"name modul");
          if (!isset($index_data[$name_modul]))
            $index_data[$name_modul]=[];
          
          $index_data[$name_modul][]=$row;
          
          $new_row["name_modul"]=$name_modul;
          $new_row["_note"]="";
          $new_row["_idv_code"]=$this->_get_code_id_visitor($row["id_visitor"]);
          
          $data_comb[]=$new_row;
        }
      
      //write_log_cms($index_data,"index data");
      foreach ($index_data as $name_modul => $d_ubehavior)
        {
          if ($name_modul && $name_modul != "none")
            {
              $data_comb_modul=false;
              
              if ($name_modul == "mainModul")
                {
                  
                  $data_comb_modul = $obj_site->get_data_ubehavior_mainModul($d_ubehavior);
                }
              else
                {
                  $data_comb_modul = $obj_site->intercomLink($name_modul, "ext_data_ubehavior", $d_ubehavior);
                }
              
              if ($data_comb_modul && is_array($data_comb_modul))
                {
                  foreach ($data_comb_modul as $row_comb)
                    {
                      $d_search = search_mas_2level($data_comb, "id_item", $row_comb["id_item"], false);
                      if ($d_search[0])
                        {
                          $data_comb[$d_search[1]]["_note"] = $row_comb["_note"];
                        }
                    }
                }
            }
        }
      
      //write_log_cms($data_comb,"data comb all");
      
      return ($data_comb);
    }
  
  protected function _get_code_id_visitor($id_visitor)
    {
      $code=$id_visitor;
      
      if (!empty($this->index_code_visitor[$id_visitor]))
        {
          $code=$this->index_code_visitor[$id_visitor];
        }
      else
        {
          $len = mb_strlen($id_visitor);
          //write_log_cms($len,"len str code");
          $kolvo_step=4;
          
          if ($len >= 10)
            {
              $code = "";
              
              for ($i = 0; $i * $kolvo_step < $len; $i++)
                {
                  $code .= mb_substr($id_visitor, $i * $kolvo_step, 1);
                }
              
              $code = mb_strtoupper($code);
              //write_log_cms($code, "получен код");
            }
          
          $this->index_code_visitor[$id_visitor]=$code;
        }
      
      return ($code);
    }
  
  protected function _get_cond_period($period)
    {
      $t="";
      
      $mas_interval_timestamp=eng_time::get_interval_timestamp_period($period,$GLOBALS["timeGlobal"]);
      
      //write_log_cms($mas_interval_timestamp,"интервал в timestamp");
      //write_log_cms($mas_interval_timestamp[1]-$mas_interval_timestamp[0],"интервал времени - разница в секундах");
      
      if ($mas_interval_timestamp[0] != 0 || $mas_interval_timestamp[1] != 0)
        {
          $t = " (putdate >= ".$mas_interval_timestamp[0]." and putdate < ".$mas_interval_timestamp[1] .") ";
        }
      
      return ($t);
    }
  
  
  
}

