<?php



class model_cache_many_lvl_data
  {
   
   protected $name_model = "";
   protected $dir_cache = "";
   
   protected $hn_name_file_1lvl = "data_1lvl";
   protected $name_file_1lvl = "";
   
   protected $hn_name_file_num_1lvl = "data_num_1lvl_";
   protected $name_file_num_1lvl = "";
   protected $hn_name_file_num_list_lvl = "data_num_list_lvl_";
   protected $hn_name_file_num_series_lvl = "data_num_series_lvl_";
   protected $hn_name_file_num_data_interval_lvl = "data_num_interval_lvl_";
   protected $hn_name_file_list_num_data_interval_name_pole = "data_num_intv_pl_nm_";
   
   protected $mas_data_1lvl = array();//содержит категории 1-го уровня
   protected $mas_num_1lvl = array();//содержит id категорий 1-го уровня
   protected $mas_data_many_lvl = array();
   protected $mas_data_index_many_lvl = array();
   
   protected $mas_num_data_lvl = array();//содержит номера всех подкатегорий: для каждой категории 1-го увроня свой массив.
   // к примеру array(
   // 1 => array(55,56,57,...),
   // 2 => array(77,78,79,...),
   // )
   protected $mas_all_num_data_lvl = array();//массив содержит номера всех категорий
   protected $mas_text_num_data_lvl = array();//массив содержит категорий в виде текстовой строки
   
   protected $tmp_mas_data_many_lvl = array();
   
   //новые массивы
   protected $mas_all_data_num_direction_lvl = array();
   protected $mas_data_group_num_direction_lvl = array();
   protected $mas_interval_num_data_top = array();
   
   protected $mas_data_num_link_nested_1node = array();
   public $mas_init_default_value_pole = array();
   
   protected $cache_many=array("data_1lvl_num_"=>array());
   
   protected $num_1lvl=0;
   protected $text_num_data_lvl="";
   protected $mas_data_one_lvl=[];
   
   protected $mas_index_nested_num_list_lvl=[];
   protected $hn_name_file_index_nested_mas_num_lvl="data_index_mas_num_lvl_";
   protected $mas_status_load_file_nested_num=[];
   
   protected $mas_index_interval_num_data_lvl=[];
   protected $hn_name_file_index_interval_num_lvl="index_interval_num_lvl_";
   protected $mas_status_load_file_interval_num=[];
   
   
   function __construct($name_model,$dir_cache_data,$on_first_init = true)
     {
      $this->init_start($name_model,$dir_cache_data,$on_first_init);
     }
   
   public function set_init_data_work()
     {
       //данный метод должен переопределяться для конкретного объекта
       return (false);
     }
   
   public function init_start($name_model, $dir_cache_data,$on_first_init = true)
     {
      $this->set_init_data_work();
      
      $this->name_model = $name_model;
      //$this->name_file_many_lvl = $name_model . "_".$this->hn_name_file_many_lvl . ".php";
      $this->dir_cache = $dir_cache_data . "/";
      
      $this->init_obj();
      
      $this->name_file_1lvl = $name_model . "_".$this->hn_name_file_1lvl . ".php";
      
      if ( $on_first_init )
        {
         $this->first_init_data_many_lvl();
        }
      
     }
   
   public function init_obj()
     {
      // для каждого объекта нужно переназначать этот метод
     }
   
   public function select_data_first_level()
     {
      //данный метод должен переопределяться для конкретного объекта
      return (false);
     }
   
   public function select_data_many_level()
     {
      //данный метод должен переопределяться для конкретного объекта
      return (false);
     }
   
   public function get_one_data_full($id_category)
     {
       //данный метод должен переопределяться для конкретного объекта
       //метод должен возвращать данные одной категории или false
       return (false);
     }
   
   public function first_init_data_many_lvl()
     {
      $this->_pause_work("check");
      
      if ( $this->check_cache_data_1lvl() )
        {
         $mas_data_1lvl=[];
         $mas_all_num_data_lvl=[];
         $mas_all_data_num_direction_lvl=[];
         $mas_num_data_lvl=[];
         $mas_data_group_num_direction_lvl=[];
         $mas_text_num_data_lvl=[];
         $mas_num_1lvl=[];
         $mas_interval_num_data_top=[];
         $mas_data_num_link_nested_1node=[];
         include ( $this->dir_cache . $this->name_file_1lvl );
         
         $this->mas_data_1lvl = $mas_data_1lvl;// Данные категорий первого уровня
         unset($mas_data_1lvl);
         $this->mas_all_num_data_lvl = $mas_all_num_data_lvl;//массив со всеми id категорий (список id категорий)
         unset($mas_all_num_data_lvl);
         $this->mas_all_data_num_direction_lvl = $mas_all_data_num_direction_lvl;//массив, в котором указывается принадлежность категории (id) к категории первого уровня   (то есть данные вида id_category => id_category_first_level)
         unset($mas_all_data_num_direction_lvl);
         $this->mas_num_data_lvl = $mas_num_data_lvl;//массив, каждый элемент (ключом является id категории первого уровня) которого содержит все id вложенных подкатегорий (всех уровней)
         unset($mas_num_data_lvl);
         $this->mas_data_group_num_direction_lvl = $mas_data_group_num_direction_lvl;//2-уровневый массив: id категории 1-го уров. => массив элементов: id категории => id категории, к которой привязана категория
         unset($mas_data_group_num_direction_lvl);
         $this->mas_text_num_data_lvl = $mas_text_num_data_lvl;//массив: id категории первого уров. => текст вида [id_category:[id_category2,...],...]
         unset($mas_text_num_data_lvl);
         $this->mas_num_1lvl = $mas_num_1lvl;//массив с id категорий первого уровня
         unset($mas_num_1lvl);
         $this->mas_interval_num_data_top = $mas_interval_num_data_top;//массив интервалов id категорий: все категории и по категориям первого уровня
         unset($mas_interval_num_data_top);
         $this->mas_data_num_link_nested_1node = $mas_data_num_link_nested_1node;//массив c вложенными id категорий, группируются по id категорий выше находящихся 
         unset($mas_data_num_link_nested_1node);
        }
       else
         {
          // файла кэша нет, получим данные первого уровня и создадим кэш
          $this->_pause_work("add");
          
          $this->create_cache_data_general();
          
          $this->_pause_work("clear");
         }
      
     }
   
   protected function check_cache_data_1lvl()
     {
      return ( file_exists( $this->dir_cache . $this->name_file_1lvl ) );
     }
   /*
   public function check_cache_data_many_lvl()
     {
      return ( file_exists( $this->dir_cache . $this->name_file_many_lvl ) );
     }
   */
   protected function create_cache_data_general()
     {
      
      // $mas_data_1lvl $mas_all_num_data_lvl $mas_num_data_lvl $mas_text_num_data_lvl $mas_num_1lvl
      
      // файла кэша нет, получим данные первого уровня и создадим кэш
      $this->mas_data_1lvl = $this->select_data_first_level();
      
      $t = '$mas_data_1lvl = ';//."\n";
      
      //$t .= var_export($this->mas_data_1lvl, true);
      $t .= $this->_var_to_code($this->mas_data_1lvl);
      $t .= ";";
      $this->save_cache_file($this->name_file_1lvl, $t);
      $t = "";
      
      // файла кэша нет, получим данные всех уровней и создадим кэш
      $this->mas_data_many_lvl = $this->select_data_many_level();
      
      $this->create_data_index_many_level();//создаем индексный массив данных с категориями
      //$this->mas_data_many_lvl = ext_on_view_lvl_category($this->mas_data_many_lvl,$this->mas_data_1lvl);
      
      //$t = '$mas_data_many_lvl =  array('."\n";
      $this->tmp_mas_data_many_lvl = array();
      
      
      $this->mas_data_one_lvl = array();//все категории относящиеся к одной какой-либо категории 1-го уровня
      // включает и саму категорию 1-го уровня
      
      $this->mas_num_data_lvl = array();
      $this->num_1lvl = 0;//номер категории 1-го уровня
      
      $this->mas_text_num_data_lvl = array();
      $sep_t = "";
      $this->text_num_data_lvl = "";
      $this->mas_num_1lvl = array();
      
      
      
      foreach ( $this->mas_data_1lvl as $num_data => $one_data )
        {
         //$this->text_num_data_lvl .= "[";
         
         $this->num_1lvl = $one_data["id_category"];
         //$this->mas_data_one_lvl[$this->num_1lvl] = $one_data;
         $this->mas_all_num_data_lvl[] = $this->num_1lvl;
         $this->mas_all_data_num_direction_lvl[$this->num_1lvl] = 0;
         $this->mas_num_1lvl[] = $this->num_1lvl;
         $this->mas_num_data_lvl[$this->num_1lvl] = array();
         $this->mas_data_group_num_direction_lvl[$this->num_1lvl] = array();
         
         $this->mas_data_num_link_nested_1node[$this->num_1lvl] = array();
         
         //$this->text_num_data_lvl .= $this->num_1lvl;
         
         $this->proc_data_many_lvl($this->num_1lvl, true);
         
         $this->create_cache_data_num_1lvl();
         $this->mas_data_one_lvl = array();
         
         //$this->text_num_data_lvl .="]";
         $this->mas_text_num_data_lvl[$this->num_1lvl] = "[".$this->text_num_data_lvl."]";
         $this->text_num_data_lvl = "";
        }
      
      
      $this->create_interval_num_data_top();
      
      //$t .= "\n ); ";
      
      //$this->save_cache_file($this->name_file_many_lvl, $t);
      
      $t = '$mas_all_num_data_lvl = ';//."\n";
      //$t .= var_export($this->mas_all_num_data_lvl, true);
      $t .= $this->_var_to_code($this->mas_all_num_data_lvl);
      $t .= ";";
      $this->save_cache_file($this->name_file_1lvl, $t, true);
      $t = "";
      
      $t = '$mas_all_data_num_direction_lvl = ';//."\n";
      //$t .= var_export($this->mas_all_data_num_direction_lvl, true);
      $t .= $this->_var_to_code($this->mas_all_data_num_direction_lvl);
      $t .= ";";
      $this->save_cache_file($this->name_file_1lvl, $t, true);
      $t = "";
      
      $t = '$mas_num_data_lvl = ';//."\n";
      //$t .= var_export($this->mas_num_data_lvl, true);
      $t .= $this->_var_to_code($this->mas_num_data_lvl);
      $t .= ";";
      $this->save_cache_file($this->name_file_1lvl, $t, true);
      $t = "";
      
      $t = '$mas_data_group_num_direction_lvl = ';//."\n";
      //$t .= var_export($this->mas_data_group_num_direction_lvl, true);
      $t .= $this->_var_to_code($this->mas_data_group_num_direction_lvl);
      $t .= ";";
      $this->save_cache_file($this->name_file_1lvl, $t, true);
      $t = "";
      
      $t = '$mas_text_num_data_lvl = ';//."\n";
      $t .= var_export($this->mas_text_num_data_lvl, true);
      $t .= ";";
      $this->save_cache_file($this->name_file_1lvl, $t, true);
      $t = "";
      
      $t = '$mas_num_1lvl = ';//."\n";
      $t .= var_export($this->mas_num_1lvl, true);
      $t .= ";";
      $this->save_cache_file($this->name_file_1lvl, $t, true);
      $t = "";
      
      $t = '$mas_interval_num_data_top = ';//."\n";
      //$t .= var_export($this->mas_interval_num_data_top, true);
      $t .= $this->_var_to_code($this->mas_interval_num_data_top);
      $t .= ";";
      $this->save_cache_file($this->name_file_1lvl, $t, true);
      $t = "";
      
      $t = '$mas_data_num_link_nested_1node = ';//."\n";
      //$t .= var_export($this->mas_data_num_link_nested_1node, true);
      $t .= $this->_var_to_code($this->mas_data_num_link_nested_1node);
      $t .= ";";
      $this->save_cache_file($this->name_file_1lvl, $t, true);
      $t = "";
      
     }
   
   protected function proc_data_many_lvl($num_category, $first_cycl = false)
     {
      
      $this->text_num_data_lvl .= ( $first_cycl ? "" : ":[" );
      $sep_t = "";
      $kol = 0;
      
      if ( isset($this->mas_data_index_many_lvl[$num_category]) )
        foreach ( $this->mas_data_index_many_lvl[$num_category] as $one_category )
          {
           $key_category=$one_category["id_category"];
           /*
           if ($num_category != $one_category["n_category"])
             {
              //$this->tmp_mas_data_many_lvl[$key_category] = $one_category;
              continue;
             }
           */
           $kol++;
           $d_one_category = $this->set_default_value_pole($key_category,$first_cycl);
           if ( $d_one_category !== false )
             {
              $this->mas_data_many_lvl[$key_category] = $d_one_category;
              $one_category = $d_one_category;
             }
           
           //$mas_ext_category = array_merge($mas_ext_category, $ext_key ? array( 0 => $one_category["id_category"]) : array($key_category => $one_category ) );
           $this->mas_data_one_lvl[$key_category] = $one_category;
           $this->mas_all_num_data_lvl[] = $one_category["id_category"];
           $this->mas_all_data_num_direction_lvl[$one_category["id_category"]] = $this->num_1lvl;
           $this->mas_num_data_lvl[$this->num_1lvl][] = $one_category["id_category"];
           $this->mas_data_group_num_direction_lvl[$this->num_1lvl][$one_category["id_category"]] = $one_category["n_category"];
           
           if ( !isset( $this->mas_data_num_link_nested_1node[$this->num_1lvl][$num_category] ) )
             $this->mas_data_num_link_nested_1node[$this->num_1lvl][$num_category] = array();
           $this->mas_data_num_link_nested_1node[$this->num_1lvl][$num_category][] = $one_category["id_category"];
           
           $this->text_num_data_lvl .= $sep_t . $one_category["id_category"];
           $sep_t = ",";
           $this->proc_data_many_lvl($one_category["id_category"]);
           
          }
      
      if ( !$first_cycl )
        {
         if ( $kol > 0 )
           $this->text_num_data_lvl .= "]";
          else
            $this->text_num_data_lvl = mb_substr($this->text_num_data_lvl,0,-2);
        }
      
     }
   
   
   protected function set_default_value_pole($key_category,$on_first_lvl)
     {
      $d_one_category = false;
      
      // массив $this->mas_init_default_value_pole содержит элементы, которые являеются массивами с ключами:
      // 0 - имя поля в массиве
      // 1 - тип значения по умолчанию:
      // inheritance - наследование: при нахождении значения по умолчанию берется значенией из предыдущего элемента (предыдущего уровня)
      // 
      // 2 - значение по умолчанию, может быть значением или массивом значений
      
      if ( $this->mas_init_default_value_pole )
        {
         $data_lvl = $this->mas_data_many_lvl[$key_category];
         $data_parent_lvl = ( $on_first_lvl ? $this->mas_data_1lvl[$this->mas_data_many_lvl[$key_category]["n_category"]] : $this->mas_data_many_lvl[$this->mas_data_many_lvl[$key_category]["n_category"]] );
         
         foreach ( $this->mas_init_default_value_pole as $one_init_default )
           {
            $on_check_defaul_lvl = false;
            $on_check_defaul_parent_lvl = false;
            if ( is_array($one_init_default[2]) )
              {
               $on_check_defaul_lvl = in_array($data_lvl[$one_init_default[0]],$one_init_default[2]);
              }
             else
               {
                $on_check_defaul_lvl = ( $data_lvl[$one_init_default[0]] == $one_init_default[2] ? true : false );
               }
            
            if ( $one_init_default[1] != "inheritance" )//нужно переписать условие: заменить на ==  и подставить нужные типы 
              {
               if ( is_array($one_init_default[2]) )
                 {
                  $on_check_defaul_parent_lvl = in_array($data_parent_lvl[$one_init_default[0]],$one_init_default[2]);
                 }
                else
                  {
                   $on_check_defaul_parent_lvl = ( $data_parent_lvl[$one_init_default[0]] == $one_init_default[2] ? true : false );
                  }
              }
            //var_dump($on_check_defaul_lvl);
            if ( $one_init_default[1] == "inheritance" )
              {
               if ( $on_check_defaul_lvl )
                 $data_lvl[$one_init_default[0]] = $data_parent_lvl[$one_init_default[0]];
              }
            
           }
         
         
         $d_one_category = $data_lvl;
        }
      
      return ($d_one_category);
     }
   
   protected function create_cache_data_num_1lvl()
     {
      
      $t = '$mas_data_num_1lvl =  ';//."\n";
      
      //$t .= var_export($this->mas_data_one_lvl, true);
      $t .= $this->_var_to_code($this->mas_data_one_lvl);
      $t .= ";";
      $this->save_cache_file($this->name_model . "_".$this->hn_name_file_num_1lvl. $this->num_1lvl . ".php",$t, false);
      $t = "";
     }
   
   protected function save_cache_file($name_file_cache,$data_save,$add_data = false)
     {
      if ( !$add_data )
        {
         file_put_contents($this->dir_cache.$name_file_cache, "<?php \n\n".$data_save);
        }
       else
         {
          file_put_contents($this->dir_cache.$name_file_cache, "\n\n".$data_save, FILE_APPEND);
         }
     }
   
   public function get_mas_num_data($num_data_lvl,$add_base = false)
     {
      // Функция вернет массив id категорий.
      // $num_data_lvl может принимать значения 
      // 0 - результатом будет массив с id 1-го уровня
      // all - результатом будет массив со всеми id
      // номер категории - результатом будет массив со всеми id вложенных категорий, при этом будет учитываться 
      // параметр $add_base
      
      $res = array();
      
      
      if ( $num_data_lvl === 0 || $num_data_lvl === "0" )
        {
         $res = $this->mas_num_1lvl;
        }
       elseif ( $num_data_lvl === "all" )
         {
          $res = $this->mas_all_num_data_lvl;
         }
        else
          {
           if ( $add_base )
             $res[] = $num_data_lvl;
           
           if ( !empty( $this->mas_data_1lvl[$num_data_lvl] ) )
             {
              $res = array_merge($res, $this->mas_num_data_lvl[$num_data_lvl]);
             }
            else
              {
               $m = $this->get_mas_num_nested_data($num_data_lvl);
               if ( sizeof($m) )
                 {
                  
                  $res = array_merge($res, $m );
                  //echo("остановлено 29");exit();
                 }
              }
         }
      
      
      
      return ( $res );
     }
   
   
   public function get_mas_num_nested_data($num_data_lvl, $add_nested = true)
     {
       $res = [];
       //write_log_cms($num_data_lvl." :: add_nested ".($add_nested ? "true":"false"),"get_mas_num_nested_data");
       
       $key=$num_data_lvl.($add_nested ? "_all":"");
       
       if (isset($this->mas_index_nested_num_list_lvl[$key]))
         {
           $res=$this->mas_index_nested_num_list_lvl[$key];
         }
       else
         {
           $num_1lvl=0;
           if ( in_array($num_data_lvl, $this->mas_num_1lvl) )
             {
               $num_1lvl=$num_data_lvl;
             }
           else
             {
               $search_num_1lvl = $this->search_1lvl($num_data_lvl);
               if ($search_num_1lvl !== false)
                 {
                   $num_1lvl=$search_num_1lvl;
                 }
               else
                 {
                   return ($res);
                 }
             }
           
           $on_load_file=false;
           $on_data_res=false;
           $on_create_file=false;
           
           if (isset($this->mas_status_load_file_nested_num[$num_1lvl])) $on_load_file=true;
           
           $path_file = $this->name_model."_".$this->hn_name_file_index_nested_mas_num_lvl.$num_1lvl.".php";
           
           if (!$on_load_file)
             {
               //Файл не был загружен, поэтому подключаем файл, и получаем данные
               //write_log_cms("подключаем файл index nested mas num lvl - ".$num_1lvl);
               
               if ( file_exists( $this->dir_cache . $path_file ) )
                 {
                   $_cache_index = [];
                   include($this->dir_cache.$path_file);
                   $this->mas_index_nested_num_list_lvl += $_cache_index;
                   unset($_cache_index);
                   $this->mas_status_load_file_nested_num[$num_1lvl] = true;
                   
                   $on_create_file = false;
                   
                   if (isset($this->mas_index_nested_num_list_lvl[$key]))
                     {
                       $res = $this->mas_index_nested_num_list_lvl[$key];
                       $on_data_res = true;
                     }
                 }
               else
                 {
                   $on_data_res = false;
                   $on_create_file = true;
                 }
               
             }
           
           if (!$on_data_res)
             {
               if ($num_data_lvl == $num_1lvl)
                 {
                   $res = $this->_parse_num_data($this->mas_text_num_data_lvl[$num_data_lvl], 0, false);
                 }
               else
                 {
                   $pos_num = $this->_search_pos_num_data_text($num_1lvl,$num_data_lvl);
                   if ( $pos_num !== false )
                     {
                       $pos_check = $pos_num + mb_strlen($num_data_lvl."");
                       $sim_check = mb_substr($this->mas_text_num_data_lvl[$num_1lvl], $pos_check, 1);
                       //write_log_cms( "*".$sim_check."*" );
                       if ($sim_check === ":")
                         {
                           $res = $this->_parse_num_data($this->mas_text_num_data_lvl[$num_1lvl], $pos_check, $add_nested);
                         }
                     }
                 }
               
               $this->mas_index_nested_num_list_lvl[$key]=$res;
               
               $t = '$_cache_index['. ($add_nested ? "'".$key."'" : $key).']=';
               //$t .= var_export($res, true);
               $t .= $this->_var_to_code($res);
               $t .= ";";
               $this->save_cache_file($path_file, $t, $on_create_file ? false:true);
               $t = "";
               unset($t);
             }
         }
       
       //write_log_cms($res,"data return function");
       
       return ($res);
     }
   
   
   public function get_mas_data($num_data_lvl,$add_base = false,$all_nested = true)
     {
      // $num_data_lvl может принимать значения 
      // 0 - результатом будет массив с данными категорий 1-го уровня
      
      // номер категории - результатом будет массив со всеми данными вложенных категорий, при этом будет учитываться 
      // параметр $add_base
      
      $res = array();
      
      
      if ( $num_data_lvl === 0 || $num_data_lvl === "0" )
        {
         $res = $this->mas_data_1lvl;
        }
       /*
       elseif ( $num_data_lvl === "all" )
         {
          $res = $this->$mas_all_num_data_lvl;
         }
       */
        else
          {
           //if ( $add_base )
           //  $res[] = $num_data_lvl;
           //echo("остановлено 5");exit();
           if ( !empty( $this->mas_data_1lvl[$num_data_lvl] ) )
             {
              if ( $add_base )
                $res[$num_data_lvl] = $this->mas_data_1lvl[$num_data_lvl];
              
              if ( $all_nested )
                {
                 //$res = array_merge($res, $this->mas_num_data_lvl[$num_data_lvl]);
                 //echo("stop get_mad_data 1");exit();
                 //*include($this->dir_cache . $this->name_model . "_".$this->hn_name_file_num_1lvl. $num_data_lvl . ".php");
                 $mas_data_num_1lvl=$this->get_data_num_1lvl($num_data_lvl);
                 $res = array_merge($res, $mas_data_num_1lvl);
                 //$res = $res + $mas_data_num_1lvl;
                 unset($mas_data_num_1lvl);
                 
                }
               else
                 {
                  //$text_num_data = $this->mas_text_num_data_lvl[$num_data_lvl];
                  //var_dump($text_num_data);
                  //$mas_num_data = $this->parse_  num_data($text_num_data, 0, false);
                  $mas_num_data = $this->get_mas_num_nested_data($num_data_lvl, false);
                  //var_dump($mas_num_data);
                  
                  //*include($this->dir_cache.$this->name_model . "_".$this->hn_name_file_num_1lvl. $num_data_lvl . ".php");
                  $mas_data_num_1lvl=$this->get_data_num_1lvl($num_data_lvl);
                  foreach ( $mas_num_data as $one_num )
                    $res[$one_num] = $mas_data_num_1lvl[$one_num];
                  unset($mas_data_num_1lvl);
                  
                  //echo("остановлено get_mas_data");exit();
                  
                 }
             }
            else
              {
               $get_num = array();
               $num_1lvl = $this->search_1lvl($num_data_lvl);
               if ( $num_1lvl !== false )
                 {
                  if ( $add_base )
                    $get_num[] = $num_data_lvl;

                  $m = $this->get_mas_num_nested_data($num_data_lvl, $all_nested);
                  if ( sizeof( $m ) )
                    {
                     $get_num = array_merge( $get_num, $m);
                     
                    }
                  
                  if ( sizeof( $get_num ) )
                    {
                     //*include($this->dir_cache.$this->name_model . "_".$this->hn_name_file_num_1lvl. $num_1lvl . ".php");
                     $mas_data_num_1lvl=$this->get_data_num_1lvl($num_1lvl);
                     foreach ( $get_num as $one_num )
                       $res[$one_num] = $mas_data_num_1lvl[$one_num];
                     
                     unset($mas_data_num_1lvl);
                    }
                  
                 }
              }
          }
      
      
      
      return ( $res );
     }
   
   public function get_mas_all_nested_data($add_first_lvl=false)
     {
      // функция вернет все вложенные категории
      // если $add_first_lvl -> true, то будут возвращены все категории (то есть включая данные и первого уровня)
      $mas_data = array();
      $mas_id_1lvl = $this->get_mas_num_data(0,false);
      
      if ( $add_first_lvl )
        {
         $mas_data = $this->get_mas_data(0,false,false);
        }
      
      foreach ( $mas_id_1lvl as $one_num )
        {
         $mas_data = array_merge($mas_data,$this->get_mas_data($one_num,false,true));
        }
      
      
      return ($mas_data);
     }
   
   protected function _parse_num_data($text_data, $startPos, $add_nested)
     {
      //$startPos - должен указывать на открывающую скобку или двоеточие
      
      //$num_cycl = 0;
      $len = mb_strlen($text_data);
      $sim = "";//текущий символ
      
      $mas_num = array();
      
      $on_search = true;
      $pos = $startPos;
      
      $part_t = "";
      $add_num = true;
      
      $kol_open = 0;
      
      //$prev_sim = "";
      
      if ( $text_data )
        {
         while ( $on_search && $pos < $len )
           {
            
            $sim = mb_substr($text_data,$pos,1);
            
            if ( !$add_nested )
              {
               if ( $kol_open > 1 )
                  $add_num = false;
                else
                   $add_num = true;
              }
            
            if ( $sim === "[" )
              {
               $kol_open++;
               if ( $part_t && is_numeric($part_t) && $add_num )
                 {
                  $mas_num[] = $part_t;
                  
                 }
               $part_t = "";
              }
             elseif ( $sim === "]" )
               {
                $kol_open--;
                if ( $part_t && is_numeric($part_t) && $add_num )
                  {
                   $mas_num[] = $part_t;
                  
                  }
                $part_t = "";
                
                if ( $kol_open <= 0 )
                   $on_search = false;
                
               }
             elseif ( $sim === "," )
               {
                if ( $part_t && is_numeric($part_t) && $add_num )
                  {
                   $mas_num[] = $part_t;
                  
                  }
                $part_t = "";
               }
             elseif ( $sim === ":" )
               {
                if ( $part_t && is_numeric($part_t) && $add_num )
                  {
                   $mas_num[] = $part_t;
                  
                  }
                $part_t = "";
               }
             elseif ( $sim >= "0" && $sim <= "9" )
               {
                $part_t .= $sim;
                
               }
            
            $pos++;
            
           }
         
        }
      
      return ( $mas_num );
     }
   
   
   protected function search_series_num_data_in_category( $num_data_lvl )
     {
      $res = false;
      
      if ( isset( $this->mas_all_data_num_direction_lvl[$num_data_lvl] ) )
        {
         $num_data_top_lvl = $this->mas_all_data_num_direction_lvl[$num_data_lvl];
         if ( $num_data_top_lvl == 0 )
           {
            $res = array($num_data_lvl);
           }
          else
            {
             if ( isset( $this->mas_data_group_num_direction_lvl[$num_data_top_lvl] ) )
               {
                $check_num = $num_data_lvl;
                $on_check = false;
                $res = array();
                while ( isset( $this->mas_data_group_num_direction_lvl[$num_data_top_lvl][$check_num] ) )
                  {
                   $v = $this->mas_data_group_num_direction_lvl[$num_data_top_lvl][$check_num];
                   $res[] = $check_num;
                   if ( $v == $num_data_top_lvl )
                     {
                      $res[] = $num_data_top_lvl;
                      $on_check = true;
                      break;
                     }
                    else
                      {
                       $check_num = $v;
                      }
                  }
                
                if ( $on_check )
                  {
                   $res = array_reverse($res);
                  }
                 else
                   {
                    $res = false;
                   }
                
               }
            }
         
        }
      
      return ( $res );
     }
   
   public function search_series_num_data($num_data_lvl)
     {
      // ищем серию категорий. То есть по заданной id категории n-го уровня, ищем категории всех промежуточных уровней - с 1-го уровня до n-го уровня
      // К примеру, если задана категория 3-го уровня с id -> 10 (марка авто ВАЗ), то должен быть массив из трех элементов: array( 1, 5, 10 ) / Транспорт, Легковые авто, ВАЗ
      $res = false;
      
      //if ( !empty( $this->mas_data_1lvl[$num_data_lvl] ) )
      if ( in_array($num_data_lvl,$this->mas_num_1lvl) )
        {
         $res = array( $num_data_lvl );
         //$res[] = $num_data_lvl;
        }
       else
         {
          
          $res = $this->search_series_num_data_in_category( $num_data_lvl );
          
         }
      
      return ( $res );
     }
   
   
   
   public function search_1lvl($num_data)
     {
      // ищем id категории первого уровня, к которой принадлежит id заданной категории (при этом категория может быть 3-го уровня или большего)
      // если не найдена то результат - false
      $res = false;
      
      if ( isset( $this->mas_all_data_num_direction_lvl[$num_data] ) )
        {
         $res = $this->mas_all_data_num_direction_lvl[$num_data];
        }
      /*
      foreach ( $this->mas_num_data_lvl as $num_1lvl => $mas_nested_num )
        {
         if ( in_array($num_data, $mas_nested_num) )
           {
            $res = $num_1lvl;
            break;
           }
        }
      */
      return ( $res );
     }
   
   /*
   public function search_1lvl($num_data)
     {
      $res = false;
      
      foreach ( $this->mas_num_data_lvl as $num_1lvl => $mas_nested_num )
        {
         if ( in_array($num_data, $mas_nested_num) )
           {
            $res = $num_1lvl;
            break;
           }
        }
      
      return ( $res );
     }
   */
   
   protected function _search_pos_num_data_text($num_1lvl,$num_data)
     {
      $pos = false;
      
      if ( preg_match("/\D".$num_data."\D/", $this->mas_text_num_data_lvl[$num_1lvl], $matches, PREG_OFFSET_CAPTURE) )
        {
         
         //var_dump($matches);
         $pos = $matches[0][1] + 1;
        }
      return ( $pos );
     }
   
   public function check_num_data_1lvl($num_data)
     {
      $res = false;
      
      if ( !empty( $this->mas_data_1lvl[$num_data] ) )
        {
         $res = true;
        }
      
      return ( $res );
     }
   
   public function check_num_data_many_lvl($num_data)
     {
      $res = false;
      
      if ( isset($this->mas_all_data_num_direction_lvl[$num_data]) )
        $res = true;
      
      /*
      foreach ( $this->mas_num_data_lvl as $num_1lvl => $mas_nested_num )
        {
         if ( in_array($num_data, $mas_nested_num) )
           {
            $res = true;
            
            break;
           }
        }
      */
      
      return ( $res );
     }
   
   public function get_num1lvl_num_many_lvl($num_data)
     {
      $res = false;
      
      if ( isset($this->mas_all_data_num_direction_lvl[$num_data]) )
        $res = $this->mas_all_data_num_direction_lvl[$num_data];
      
      /*
      foreach ( $this->mas_num_data_lvl as $num_1lvl => $mas_nested_num )
        {
         if ( in_array($num_data, $mas_nested_num) )
           {
            $res = true;
            
            break;
           }
        }
      */
      
      return ( $res );
     }
   
   public function get_one_num_data($num_data)
     {
      // получение данных одной категории, указанной в $num_data
      $res = false;
      
      if ( !empty( $this->mas_data_1lvl[$num_data] ) )
        {
         $res = $this->mas_data_1lvl[$num_data];
        }
       else
         {
          foreach ( $this->mas_num_data_lvl as $num_1lvl => $mas_nested_num )
            {
             if ( in_array($num_data, $mas_nested_num) )
               {
                
                //*include( $this->dir_cache . $this->name_model . "_".$this->hn_name_file_num_1lvl. $num_1lvl . ".php");
                $mas_data_num_1lvl=$this->get_data_num_1lvl($num_1lvl);
                $res = $mas_data_num_1lvl[$num_data];
                unset($mas_data_num_1lvl);
                break;
               }
            }
         }
      
      return ( $res );
     }
   
   public function get_data_mas_num($mas_list_data)
     {
      $mas_data = array();
      
      foreach ( $mas_list_data as $one_num )
        {
         $data = $this->get_one_num_data($one_num);
         if ( $data )
           $mas_data[$one_num] = $data;
        }
      
      return ( $mas_data );
     }
   
   public function check_mas_num_lvl_data( $check_mas_num_data )
     {
      $error = true;
      if ( $check_mas_num_data && sizeof( $check_mas_num_data ) && !empty($check_mas_num_data[0]) )
        {
         //$error = false;
         $num_1lvl = $check_mas_num_data[0];
         $last_num = end($check_mas_num_data);
         //$mas_series = $this->get_mas_num_data($num_1lvl, true);
         $mas_series = $this->search_series_num_data($last_num);
         
         if ( sizeof( array_diff( $mas_series, $check_mas_num_data ) ) == 0 )
           $error = false;
         
        }
      
      return ( !$error );
     }
   
   public function clear_cache()
     {
      
      $elements = scandir( $this->dir_cache );
      if ( $elements && sizeof( $elements ) > 0 )
        {
         foreach ( $elements as $element )
           {
            if ( is_file( $this->dir_cache."/".$element ) && mb_strpos($element,$this->name_model) === 0 )
              {
               unlink( $this->dir_cache ."/" . $element );
               
              }
           }

        }
      
      $this->_pause_work("clear");
      
      return (true);
     }
   
   public function check_mas_name_url_data($mas_name_url_data)
     {
      // проверяем массив с многоуровневыми названиями url категорий - array("transport","legkovie_avto")
      $res = false;
      $k = sizeof($mas_name_url_data);
      if ( $k )
        {
         
         $mas_data_1lvl = $this->get_mas_data(0,false,false);
         
         list($on_search,$key_1lvl) = search_mas_2level($mas_data_1lvl,"united_name_url",$mas_name_url_data[0],false);
         
         if ( $on_search )
           {
            $res = array();
            $res[] = $mas_data_1lvl[$key_1lvl]["id_category"];
            
            for ( $i = 1; $i < $k; $i++ )
              {
               $check_name_url = $mas_name_url_data[$i];
               $num_previous_data = $res[$i-1];
               
               $mas_data_lvl = $this->get_mas_data($num_previous_data,false,false);
               if ( !sizeof( $mas_data_lvl ) )
                 {
                  $res = false;
                  break;
                 }
               
               list($on_search,$key_lvl) = search_mas_2level($mas_data_lvl,"united_name_url",$check_name_url,false);
               if ( !$on_search )
                 {
                  $res = false;
                  break;
                 }
               
               $res[] = $mas_data_lvl[$key_lvl]["id_category"];
               
              }
            
           }
         
        }
      
      return ( $res );
     }
   
   protected function search_interval_num( $mas_num )
     {
      $res = array ( 0 => array(), 1 => array() );// 0 - содержит интервалы, 1 - список num
      $kolvo = sizeof($mas_num);
      if ( $kolvo > 0 )
        {
         
         if ( $kolvo == 1 )
           {
            $res[1][] = current($mas_num);
           }
          else
            {
             sort($mas_num);
             // 1,2,3,4,5,6,7,8,9,10
             // 1,3,5,6,8,10
             $mas_interval = array();
             $mas_list = array();
             $mas_one_interval = array(0,0);
             
             foreach($mas_num as $key => $value)
               {
                
                if ( $mas_one_interval[0] == 0 )//(0,0)
                  {
                   $mas_one_interval[0] = $value;
                  }
                 elseif ( $mas_one_interval[1] == 0 )//(a,0)
                  {
                   if ( $mas_one_interval[0] == ($value - 1) )
                     {
                      $mas_one_interval[1] = $value;
                     }
                    else
                      {
                       $mas_list[] = $mas_one_interval[0];
                       $mas_one_interval = array($value, 0);
                      }
                  }
                 else//(a,b)
                  {
                   if ( $mas_one_interval[1] == ($value - 1) )
                     {
                      $mas_one_interval[1] = $value;
                     }
                    else
                      {
                       $mas_interval[] = $mas_one_interval;
                       $mas_one_interval = array($value,0);
                       
                      }
                   
                  }
                
               }
             
             if ( $mas_one_interval[0] > 0 )
               {
                if ( $mas_one_interval[1] > 0 )
                  {
                   $mas_interval[] = $mas_one_interval;
                  }
                 else
                   {
                    $mas_list[] = $mas_one_interval[0];
                   }
               }
             
             $res[0] = $mas_interval;
             $res[1] = $mas_list;
             
            }
         
        }
      
      return ($res);
     }
   
   protected function create_interval_num_data_top()
     {
      $this->mas_interval_num_data_top = array();
      $this->mas_interval_num_data_top[0] = $this->search_interval_num( $this->mas_all_num_data_lvl );
      
      foreach ( $this->mas_num_data_lvl as $num_data_top => $mas_list_num )
        {
         $this->mas_interval_num_data_top[$num_data_top] = $this->search_interval_num(array_merge(array($num_data_top),$mas_list_num));
         
        }
      
     }
   
   protected function create_interval_num_data_many_lvl( $num_data )
     {
      $res = array();
      
      $mas_num = $this->get_mas_num_data($num_data,true);
      
      $res = $this->search_interval_num($mas_num);
      
      return ($res);
     }
   
   
   
   public function get_interval_num_data($num_data_many_lvl)
     {
       $res=[];
       //write_log_cms($num_data_many_lvl,"get_interval_num_data : indata");
       
       if ( !$num_data_many_lvl || $num_data_many_lvl === "all" )
         {
           $res = $this->mas_interval_num_data_top[0];
         }
       elseif ( $this->check_num_data_1lvl($num_data_many_lvl) )
         {
           $res = $this->mas_interval_num_data_top[$num_data_many_lvl];
         }
       else
         {
           $num_1lvl=$this->get_num1lvl_num_many_lvl($num_data_many_lvl);
           
           if (!$num_1lvl) return ($res);
           
           $key=$num_data_many_lvl;
           
           if (isset($this->mas_index_interval_num_data_lvl[$key]))
             {
               $res=$this->mas_index_interval_num_data_lvl[$key];
             }
           else
             {
               $on_load_file = false;
               $on_data_res = false;
               $on_create_file = false;
               
               if (isset($this->mas_status_load_file_interval_num[$key])) $on_load_file=true;
               
               $path_file = $this->name_model."_".$this->hn_name_file_index_interval_num_lvl.$num_1lvl.".php";
               
               if (!$on_load_file)
                 {
                   
                   if ( file_exists( $this->dir_cache . $path_file ) )
                     {
                       $_cache_index=[];
                       include ( $this->dir_cache.$path_file);
                       $this->mas_index_interval_num_data_lvl += $_cache_index;
                       unset( $_cache_index );
                       $this->mas_status_load_file_interval_num[$num_1lvl]=true;
                       
                       $on_create_file=false;
                       
                       if (isset($this->mas_index_interval_num_data_lvl[$key]))
                         {
                           $res = $this->mas_index_interval_num_data_lvl[$key];
                           $on_data_res = true;
                         }
                     }
                   else
                     {
                       $on_data_res=false;
                       $on_create_file=true;
                     }
                 }
               
               if (!$on_data_res)
                 {
                   
                   $res = $this->create_interval_num_data_many_lvl($num_data_many_lvl);
                   
                   $this->mas_index_interval_num_data_lvl[$key] = $res;
                   
                   $t = '$_cache_index['.$key.']=';
                   //$t .= var_export($res, true);
                   $t .= $this->_var_to_code($res);
                   $t .= ";";
                   $this->save_cache_file($path_file, $t, $on_create_file ? false : true);
                   $t = "";
                   unset($t);
                 }
               
             }
           
         }
       
       //write_log_cms($res,"__get_interval_num_data :: res");
       
       return ($res);
     }
   
   public function get_text_db_query_data_many_lvl($name_pole, $num_category = 0)
     {
      $t = "";
      
      $data_interval = $this->get_interval_num_data($num_category);
      
      if ( $data_interval && is_array($data_interval) )
        {
         if ( isset($data_interval[0]) && is_array($data_interval[0]) && sizeof($data_interval[0]) > 0 )
           {
            $sep = " ";
            foreach ( $data_interval[0] as $one_interval )
              {
               $t .= $sep . " ".$name_pole." between ".$one_interval[0]." and ".$one_interval[1];
               $sep = " or ";
              }
            
           }
         
         if ( isset($data_interval[1]) && is_array($data_interval[1]) && sizeof($data_interval[1]) > 0 )
           {
            $t .= ( $t ? " or " : "" );
            $t .= " ".$name_pole." IN ( ".implode(",",$data_interval[1])." ) ";
           }
         
        }
      
      return ($t);
     }
   
   public function get_text_db_query_data_value_name_pole($name_pole_extract,$value_pole_extract,$name_pole_query,$type_search = false,$get_mas_num = false)
     {
      $t = "";
      $mas_num = array();
      
      $data_interval = $this->get_interval_num_to_name_pole($name_pole_extract,$value_pole_extract,$type_search);
      
      if ( $data_interval && is_array($data_interval) )
        {
         if ( !$get_mas_num )
           {
            if ( isset($data_interval[0]) && is_array($data_interval[0]) && sizeof($data_interval[0]) > 0 )
              {
               $sep = " ";
               foreach ( $data_interval[0] as $one_interval )
                 {
                  $t .= $sep . " ".$name_pole_query." between ".$one_interval[0]." and ".$one_interval[1];
                  $sep = " or ";
                 }
               
              }
            
            if ( isset($data_interval[1]) && is_array($data_interval[1]) && sizeof($data_interval[1]) > 0 )
              {
               $t .= ( $t ? " or " : "" );
               $t .= " ".$name_pole_query." IN ( ".implode(",",$data_interval[1])." ) ";
              }
           }
          else
            {
             if ( isset($data_interval[0]) && is_array($data_interval[0]) && sizeof($data_interval[0]) > 0 )
               {
                
                foreach ( $data_interval[0] as $one_interval )
                  {
                   $mas_num = array_merge($mas_num,range($one_interval[0],$one_interval[1],1));
                   
                  }
                
               }
             
             if ( isset($data_interval[1]) && is_array($data_interval[1]) && sizeof($data_interval[1]) > 0 )
               {
                $mas_num = array_merge($mas_num,$data_interval[1]);
                
               }
            }
         
        }
      
      return ( $get_mas_num ? $mas_num : $t);
     }
   
   public function get_interval_num_to_name_pole($name_pole_item,$value_pole_extract,$type_search = false)
     {
      
      // получаем список категорий со значением $value_pole_extract в поле $name_pole_item
      $data_interval = false;
      $type_search_name_file = "";
      if ( $type_search )
        {
         $type_search_name_file = "_tv_".$value_pole_extract;
        }
      $path_file = $this->name_model ."_" . $this->hn_name_file_list_num_data_interval_name_pole.$name_pole_item.$type_search_name_file.".php";
      
      if ( file_exists( $this->dir_cache . $path_file ) )
        {
         $mas_interval_num_name_pole=[];
         include ( $this->dir_cache.$path_file);
         $res = $mas_interval_num_name_pole;
         unset( $mas_interval_num_name_pole );
        }
       else
         {
          
          $res = $this->create_list_num_data_interval_name_pole($name_pole_item,$type_search ? $value_pole_extract : false);
          
          if ( 1 )
            {
             $t = '$mas_interval_num_name_pole = '."\n";
             $t .= var_export($res, true);
             $t .= ";";
             $this->save_cache_file($path_file, $t, false);
             $t = "";
            }
          
         }
      
      
      
      if ( !empty($res[$value_pole_extract]) )
        {
         $data_interval = $res[$value_pole_extract];
        }
      
      return ($data_interval);
     }
   
   public function create_list_num_data_interval_name_pole($name_pole_item,$v_search = false)
     {
      $this->mas_data_num_element_group_name_pole = array();
      $mas_interval_num_name_pole = array();
      
      foreach ( $this->mas_data_1lvl as $one_data )
        {
         
         $v_name_pole = $one_data[$name_pole_item];
         if ( $v_search !== false && $v_name_pole != $v_search ) continue;// ищем элементы с определенным значением, если значение указано
         $this->mas_data_element_create_np = $this->get_mas_data($one_data["id_category"],false,true);
         //var_dump($this->mas_data_element_create_np);
         $this->add_element_to_mas_num_group_name_pole($v_name_pole,$one_data["id_category"]);
         
         $this->proc_many_lvl_create_list_num_data_interval_name_pole($one_data["id_category"],$one_data["id_category"],$name_pole_item,$v_name_pole);
         
        }
      
      //var_dump($this->mas_data_num_element_group_name_pole);
      
      foreach ( $this->mas_data_num_element_group_name_pole as $v_pole_name => $mas_num )
        {
         
         $mas_interval = $this->search_interval_num($mas_num);
         
         $mas_interval_num_name_pole[$v_pole_name] = $mas_interval;
        }
      
      //var_dump($mas_interval_num_name_pole);
      $this->mas_data_num_element_group_name_pole = false;
      
      return ($mas_interval_num_name_pole);
     }
   
   protected function proc_many_lvl_create_list_num_data_interval_name_pole($first_num,$num_element,$name_pole,$v_name_pole,$v_search = false)
     {
      
      if ( isset( $this->mas_data_num_link_nested_1node[$first_num][$num_element] ) && is_array( $this->mas_data_num_link_nested_1node[$first_num][$num_element] ) 
          && sizeof( $this->mas_data_num_link_nested_1node[$first_num][$num_element] )
         )
        {
         
         $mas_num_list = $this->mas_data_num_link_nested_1node[$first_num][$num_element];
         
         foreach ( $mas_num_list as $one_num )
           {
            list($on_search, $key_row) = search_mas_2level($this->mas_data_element_create_np,"id_category",$one_num,false);
            if ( $on_search )
              {
               $data_one_element = $this->mas_data_element_create_np[$key_row];
               $v_name_pole_element = ( $data_one_element[$name_pole] ? $data_one_element[$name_pole] : $v_name_pole );
               if ( $v_search !== false && $v_name_pole_element != $v_search ) continue;// ищем элементы с определенным значением, если значение указано
               $this->add_element_to_mas_num_group_name_pole($v_name_pole_element, $data_one_element["id_category"]);
               $this->proc_many_lvl_create_list_num_data_interval_name_pole($first_num, $data_one_element["id_category"],$name_pole,$v_name_pole_element);
              }
           }
         
        }
      
     }
   
   protected function add_element_to_mas_num_group_name_pole( $v_name_pole, $num_element)
     {
      if ( $v_name_pole )
        {
         if ( !isset( $this->mas_data_num_element_group_name_pole[$v_name_pole] ) )
           $this->mas_data_num_element_group_name_pole[$v_name_pole] = array();
         $this->mas_data_num_element_group_name_pole[$v_name_pole][] = $num_element;
        }
      
     }
   
   protected function create_data_index_many_level()
     {
      $this->mas_data_index_many_lvl=array();
      
      foreach ($this->mas_data_many_lvl as $key_category => $one_category)
        {
         if ( !isset($this->mas_data_index_many_lvl[$one_category["n_category"]]) )
           $this->mas_data_index_many_lvl[$one_category["n_category"]]=array();
         
         $this->mas_data_index_many_lvl[$one_category["n_category"]][]=$one_category;
        }
      
     }
   
   protected function get_data_num_1lvl($num_data_lvl)
     {
      $mas_data_num_1lvl=array();
      if (isset($this->cache_many["data_1lvl_num_"][$num_data_lvl]))
        {
         $mas_data_num_1lvl=$this->cache_many["data_1lvl_num_"][$num_data_lvl];
        }
       else
         {
          include($this->dir_cache . $this->name_model . "_".$this->hn_name_file_num_1lvl. $num_data_lvl . ".php");
          $this->cache_many["data_1lvl_num_"][$num_data_lvl]=$mas_data_num_1lvl;
          //unset($mas_data_num_1lvl);
         }
      
      return ($mas_data_num_1lvl);
     }
   
   protected function _var_to_code($perem)
     {
       $t="";
       $v = var_export($perem, true);
       $v=replace_one_str_end($v);
       $mas_v=explode("\n",$v);
       //write_log_cms($mas_v);
       array_walk($mas_v,function(&$value,$key){ $value=trim($value); });
       //write_log_cms($mas_v);
       $t=implode("",$mas_v);
       //write_log_cms($t,"code");
       
       return ($t);
     }
   
   protected function _pause_work($oper)
     {
       global $ident_process_cms;
       
       $name="cache_ctg_".$this->name_model;
       //write_log_cms($name.":".$oper.":".$ident_process_cms);
       //eng_pause_work_cms::oper_one($name, $oper);
       
     }
   
  }


