<?php


class eng_answer
  {
   
   function __construct()
     {
      
     }
   
   static public function main($error=1,$error_text="Обнаружена неизвестная ошибка!",$answer = false,$data=false)
     {
      global $type_answer,$type_action_part_site;
      
      if ($type_action_part_site == "v_user")
        {
         self::v_user_error($error,$error_text,$answer);
        }
       elseif ($type_answer == "v_user_addit")
         {
          self::v_user_addit($error,$error_text,$answer);
         }
       elseif ($type_answer == "ajax")
         {
          self::ajax_jc($error,$error_text,$answer);
         }
       elseif ($type_answer == "iframe")
         {
          self::iframe_js($error,$error_text,$answer);
         }
       elseif ($type_answer == "html")
         {
          self::html_p($error,$error_text,$answer,$data);
         }
       elseif ($type_answer === false)
         {
          self::special($error,$error_text,$answer,$data);
         }
      
      exit();
     }
   
   static public function v_user_error($error=1,$error_text="Произошла ошибка с базой данных!")
     {
      self::html_p(1,$error_text);
     }
   
   static public function v_user_addit($error=1,$error_text="Произошла ошибка с базой данных!",$answer=false,$data=false)
     {
      
      if ($error == 1)
        {
         sendheader::error503();
         sendheader::retryAfter(3600);
         echo ($error_text);
        }
       elseif ($error == 2)
         {
          sendheader::error404();
          echo ($error_text);
         }
       else
         {
          
          if ($data && is_array($data))
            {
             if (isset($data["sheader"]))
               sendheader::main($data["sheader"]);
             if (isset($data["text"]))
               echo($data["text"]);
            }
          
          if ($answer)
            echo ($answer);
          
         }
      
      exit();
     }
   
   static public function ajax_jc($error=1,$error_text="Обнаружена неизвестная ошибка!",$answer = false)
     {
      echo ("{ error:{code:$error,text:'$error_text'} ".( ( $error == 0 && $answer ) ? " , ".$answer : "" )." }");
      exit();
     }
   
   static public function iframe_js($error=1,$error_text="Обнаружена неизвестная ошибка!",$answer = false)
     {
      
      $t='
        <!DOCTYPE html>
        <html>
        <head>
          <title></title>
        </head>
        <body>
        <pre>
        ответ
        </pre>
        <script type="text/javascript">
        numError='.$error.';
        textError="'.$error_text.'";
        mas_answer = new Array();
        ';
        
        if ( $answer && is_array($answer) )
          {
           foreach ( $answer as $key => $value )
             {
              $t.="mas_answer['".$key."']=".( is_numeric($value) ? $value : "'".$value."'" ).";\n";
             }
          }
        
        $t.='
        window.onload=function (){ window.parent.answer_load_file(numError,textError,mas_answer); };
        
        </script>
        
        </body>
        </html>';
      
      echo($t);
      
      exit();
      
     }
   
   static public function html_p($error=1,$error_text="Обнаружена неизвестная ошибка!",$answer = false,$data_html=false)
     {
      if (!$data_html) $data_html=array("title"=>"ответ");
      
      $t='
       <!DOCTYPE html>
       <html>
       <head>
         <title>'. ($error == 1 ? "Сообщение об ошибке" : (isset($data_html["title"]) ? $data_html["title"] : "Ответ") ) .'</title>
       </head>
       <body>
       <div>
       <h3>'. ($error == 1 ? "Сообщение об ошибке" : (isset($data_html["title"]) ? $data_html["title"] : "Ответ") ). '</h3>
       <div>';
      
      if ( isset($data_html["text_first"]) )
        {
         if ( is_array($data_html["text_first"]) )
           {
            foreach ( $data_html["text_first"] as $one_row )
              {
               $t.= ("<div style='margin: 10px 0px;'>".$one_row."</div>");
              }
           }
          else
            {
             $t.=("<div style='margin: 10px 0px;'>".$data_html["text_first"]."</div>");
            }
        }
      
      if ( $error == 1 )
        {
         $t.=$error_text;
        }
      
      if ( $answer )
        {
         if ( is_array($answer) )
           {
            foreach ( $answer as $one_row )
              {
               $t.= ("<div style='margin: 10px 0px;'>".$one_row."</div>");
              }
           }
          else
            {
             $t.=("<div style='margin: 10px 0px;'>".$answer."</div>");
             
            }
        }
      
      if ( isset($data_html["text_end"]) )
        {
         if ( is_array($data_html["text_end"]) )
           {
            foreach ( $data_html["text_end"] as $one_row )
              {
               $t.= ("<div style='margin: 10px 0px;'>".$one_row."</div>");
              }
           }
          else
            {
             $t.=("<div style='margin: 10px 0px;'>".$data_html["text_end"]."</div>");
             
            }
        }
      
      $t.='
       </div>
       </div>
       </body>
       </html>
       ';
      
      echo ($t);
      
      exit();
     }
   
   static public function special($error=1,$error_text="Обнаружена неизвестная ошибка!",$answer = false,$data=false)
     {
      $args=func_get_args();//write_log_cms("это функция special eng_answer","eng_answer");write_log_cms($args,"eng_answer");
      call_user_func_array("write_answer_special",$args);
      exit();
     }
   
  }



function write_ajax_answer_jc($error=1,$error_text="Обнаружена неизвестная ошибка!",$answer = false)
  {
   //echo ("{ error:{code:$error,text:'$error_text'} ".( ( $error == 0 && $answer ) ? " , ".$answer : "" )." }");
   eng_answer::ajax_jc($error,$error_text,$answer);
   exit();
  }



function write_js_iframe_answer($error=1,$error_text="Обнаружена неизвестная ошибка!",$answer = false)
  {
   eng_answer::iframe_js($error,$error_text,$answer);
   
   exit();
  }


function write_html_answer($error=1,$error_text="Обнаружена неизвестная ошибка!",$answer = false,$data_html=array("title"=>"ответ"))
  {
   eng_answer::html_p($error,$error_text,$answer,$data_html);
   
   exit();
  }
