<?php


class eng_messenger
{
  protected $file_storage="mesngr_storage.php";
  
  protected $all_card=array();
  protected $card_user1=array();
  protected $card_user2=array();
  
  protected $one_light=array();
  
  protected $auth_num_user=0;
  
  function __construct()
    {
      $this->auth_num_user=$GLOBALS["id_user_to_site"];
    }
  
  function get_messages($num_user1,$num_user2,$id_last_messenger=0)
    {
      $db_query="select * from ".DB_PREF."messenger "
       ." where "
       ." ( ( num_author=".$num_user1." and num_recipient=".$num_user2." )"
       ." or (num_author=".$num_user2." and num_recipient=".$num_user1.") ) "
       .($id_last_messenger > 0 ? " and id_messenger > ".$id_last_messenger:"")
       ." order by id_messenger ASC ";
      
      list($kolvo,$data_messages)=db_work::query_select_assoc($db_query);
      
      return (array($kolvo,$data_messages));
    }
  
  function save_one_msg($input_data)
    {
      //$input_data - данные полученные от клиента с новым сообщением
      //write_log_cms($input_data,"данные нового сообщения");
      
      $data_msg=array();
      $data_status=array();
      $data_user1=false;
      $data_user2=false;
      //$data_elm=false;
      $error=0;
      $error_text="";
      
      list($error,$error_text,$data_user1,$data_user2)=$this->check_data_real($input_data);
      
      if ($error == 0)
        {
          
          $this->add_one_msg_db($input_data);
          
          $this->send_email_notice_user2($input_data, $data_user1, $data_user2);
          
          //получаем данные новых сообщений и отправляем клиенту (браузеру)
          list($kolvo, $data_msg) = $this->get_messages($input_data["num_user1"], $input_data["num_user2"], $input_data["id_last_messenger"]);
          //write_log_cms($data_msg,"data new status");
          
          //получаем статусы для сообщений
          list($kolvo, $data_status) = $this->get_status_msg($input_data["num_user1"], $input_data["num_user2"]);
          //write_log_cms($data_status,"data_status message");
          
          $this->ext_card_users($input_data["num_user1"], $input_data["num_user2"]);
          $this->card_user1[0] = $GLOBALS["timeGlobal"];
          $this->card_user1[2][$input_data["num_user2"]] = $GLOBALS["timeGlobal"];
          
          $this->card_user2[0] = $GLOBALS["timeGlobal"];
          $this->card_user2[1] = -1;
          $this->card_user2[2][$input_data["num_user1"]] = $GLOBALS["timeGlobal"];
          
          $this->set_card_user($input_data["num_user1"], $input_data["num_user2"]);
          $this->save_all_card_users();
          
          
        }
      
      return (array($error,$error_text,$data_msg,$data_status));
    }
  
  function add_one_msg_db($mas_data)
    {
      
      $mas_save=array(
        
        "id_messenger" =>0,
        //"num_modul" =>0,//$mas_data["num_modul"],
        //"num_element" =>0,//$mas_data["num_elm"],
        "num_author" =>$mas_data["num_user1"],//$GLOBALS["id_user_to_site"],
        "num_recipient" =>$mas_data["num_user2"],
        "status_author" =>0,//int NOT NULL,
        "status_recipient" =>0,// int NOT NULL,
        "message" =>$mas_data["message"],
        "putdate" =>$GLOBALS["timeGlobal"],//int unsigned,
        "onread" =>'off',
       );
      
      $db_query=forming_db_query_indexmas(DB_PREF."messenger",$mas_save,"new","id_messenger");
      db_work::query($db_query);
      
      return (true);
    }
  
  function get_status_msg($num_user1,$num_user2)
    {
      $db_query = "select id_messenger,num_author,num_recipient,status_author,status_recipient,onread "
        ." from ".DB_PREF."messenger where "
        //." num_modul= ".$num_modul." and num_element=".$num_elm." "
        ." ((num_author=".$num_user1." and num_recipient=".$num_user2.") "
        ." or (num_author=".$num_user2." and num_recipient=".$num_user1.")) "
        //." and id_messenger > ".$id_last_messenger." "
        ." order by id_messenger ASC ";
      
      list($kolvo,$data_msg)=db_work::query_select_assoc($db_query);
      
      return (array($kolvo,$data_msg));
    }
  
  function set_on_read_msg($num_user1,$num_user2,$id_last_messenger)
    {
      $db_query="update ".DB_PREF."messenger set onread='on' where "
       //." num_modul= ".$num_modul." and num_element=".$num_elm." "
       ." num_author=".$num_user2." and num_recipient=".$num_user1." "
       ." and id_messenger > ".$id_last_messenger;
      
      db_work::query($db_query);
      
      $count=db_work::get_affected_rows();
      
      return ($count > 0 ? $count : 0);
    }
  
  function auto_update($input_data)
    {
      //write_log_cms($input_data);
      
      $data_msg=array();
      $data_status=array();
      
      list($error,$error_text)=$this->check_data($input_data);
      
      if ($error==0)
        {
          $this->ext_card_users($input_data["num_user1"],0);
          
          list($on_new,$on_update_card)=$this->check_new_data_user1($input_data["num_user2"],$input_data["time_last"]);
          
          if ($on_new)
            {
              //write_log_cms("получаем новые данные для пользователей ".$input_data["num_user1"]." - ".$input_data["num_user2"],"auto update messenger");
              $count_affected=$this->set_on_read_msg($input_data["num_user1"],$input_data["num_user2"],$input_data["id_last_messenger"]);
              
              //получаем данные новых сообщений и отправляем клиенту (браузеру)
              list($kolvo_msg, $data_msg) = $this->get_messages($input_data["num_user1"], $input_data["num_user2"], $input_data["id_last_messenger"]);
              
              //получаем статусы для сообщений
              list($kolvo, $data_status) = $this->get_status_msg($input_data["num_user1"], $input_data["num_user2"]);
              
              if ($on_update_card || $count_affected > 0 || $kolvo_msg > 0)
                {
                  //если есть какие-то изменения, то обновляем данные о статусе пользователей
                  $this->ext_card_users($input_data["num_user1"],$input_data["num_user2"]);
                  
                  $this->card_user1[0]=$GLOBALS["timeGlobal"];
                  $this->card_user1[2][$input_data["num_user2"]]=$GLOBALS["timeGlobal"];
                  
                  $this->card_user2[0]=$GLOBALS["timeGlobal"];
                  $this->card_user2[1]=-1;
                  $this->card_user2[2][$input_data["num_user1"]]=$GLOBALS["timeGlobal"];
                  
                  $this->set_card_user($input_data["num_user1"],$input_data["num_user2"]);
                  $this->save_all_card_users();
                }
              
            }
          
        }
      
      return (array($error,$error_text,$data_msg,$data_status));
    }
  
  function check_data($mas_data)
    {
      $error=0;
      $error_text="";
      
      $data_session=$this->get_data_session();
      
      list($confirm_session,$key_control,$data_control)=$this->check_data_session($data_session,$mas_data);
      
      if ($confirm_session != 0 && $data_control[0]<$GLOBALS["timeGlobal"]-600)
        {
          $confirm_session=0;//время проверки по данным сессии вышло, проверяем заново данные как обычно.
        }
      
      if ($confirm_session == 0)
        {
          //write_log_cms("start check real ".$mas_data["num_user1"]);
          list($error,$error_text,$data_user1,$data_user2)=$this->check_data_real($mas_data);
          if ($error==0)
            {
              $data_session[$key_control]=array($GLOBALS["timeGlobal"],1);
              $this->save_data_session($data_session);
            }
        }
      
      return (array($error,$error_text));
    }
  
  function check_data_session($data_session,$mas_data)
    {
      $confirm=0;
      
      //$key="n".$mas_data["num_modul"].":".$mas_data["num_elm"].":".$mas_data["num_user1"].":".$mas_data["num_user2"].":".$mas_data["type"];
      $key="n".$mas_data["num_user1"].":".$mas_data["num_user2"].":".$mas_data["type"];
      //write_log_cms($key,"key for session");
      $data_control=array();
      
      if (isset($data_session[$key]))
        {
          $confirm=1;
          $data_control=$data_session[$key];
        }
      
      return (array($confirm,$key,$data_control));
    }
  
  function check_data_real($mas_data)
    {
      /* Проверка данных $mas_data
      num_user1 -> numeric:int,
      num_user2 -> numeric:int,
      
      id_last_messenger -> numeric:int,
      message -> text,
      
      type -> text:user,
      oper -> text:add,update
      */
      
      global $obj_site;
      
      $error=0;
      $error_text="";
      
      $type_open=$mas_data["type"];
      
      //$num_modul=0;
      //$num_elm=0;
      $data_user1=false;
      $data_user2=false;
      //$data_elm=false;
      
      if ($mas_data["num_user1"] == $this->auth_num_user)
        {
          $num_user1=$mas_data["num_user1"];
          $num_user2=$mas_data["num_user2"];
          
          //$num_modul=$mas_data["num_modul"];
          //$num_elm=$mas_data["num_elm"];
          
          if ($num_user1 == $num_user2)
            {
              return (array(1,"Ошибка. Вы пытаетесь написать сами себе.",$data_user1,$data_user2));
            }
          
          $mas_data_user=$obj_site->select_data_user_to_list_id(array($num_user1,$num_user2),"id_user,name_user,email_user,date_visit,get_message_user,access_user,notice_new_private_message,authorized,date_admin,authorized_admin");
          if (empty($mas_data_user[$num_user1]) || empty($mas_data_user[$num_user2]))
            {
              return (array(1,"Ошибка. Пользователь не найден в базе.",$data_user1,$data_user2));
            }
          $data_user1=$mas_data_user[$num_user1];
          $data_user2=$mas_data_user[$num_user2];
          //write_log_cms($data_user2,"check data messenger - data user2");
          
          if ($data_user2["access_user"] != "on")
            {
              $error = 1;
              $error_text = "Нет возможности написать сообщение. Пользователь заблокирован.";
            }
          
          if ($error == 0 && ($data_user1["get_message_user"] != "on" || $data_user2["get_message_user"] != "on"))
            {
              $error = 1;
              $error_text=($data_user1["get_message_user"] != "on" ? "Вы запретили писать вам сообщения." : "Пользователь запретил отправлять сообщения.");
            }
        }
       else
         {
           $error=1;
           $error_text="Ошибка. Время сессии вышло.";
         }
      
      return (array($error,$error_text,$data_user1,$data_user2));
    }
  
  function get_data_session()
    {
      $data_session=array();
      
      if (isset($_SESSION["data_check_messenger"]))
        {
          $data_session=$_SESSION["data_check_messenger"];
        }
      
      return ($data_session);
    }
  
  function save_data_session($data)
    {
      $_SESSION["data_check_messenger"]=$data;
    }
  
  
  function storage_light_save_data($mas_data)
    {
      file_put_contents(DIR_CACHE_DATA."/".$this->file_storage,"<?php\n\n" . '$messenger_data=' . var_export($mas_data,true) .";");
      return (true);
    }
  
  function storage_light_get_data()
    {
      $data=array();
      
      if (file_exists(DIR_CACHE_DATA."/".$this->file_storage))
        {
          include (DIR_CACHE_DATA."/".$this->file_storage);
          if (isset($messenger_data)) $data=$messenger_data;
        }
      
      return ($data);
    }
  
  function clear_storage_light()
    {
      $this->storage_light_save_data(array());
    }
  
  function save_all_card_users()
    {
      $this->storage_light_save_data($this->all_card);
    }
  
  function ext_card_users($num_user1,$num_user2)
    {
      $this->all_card=$this->storage_light_get_data();
      //write_log_cms($this->all_card,"all card");
      
      //данные в карте пользователя
      //0 - время последнего события (добавлено новое сообщение, прочитано сообщение);
      //1 - количество непрочитанных сообщений пользователя (всех). Значение -1 - подсчет не производился;
      //2 - массив, содержащий время последнего события соответствующего конкретному пользователю,
      // то есть содержит значения id_user=>время события 
      
      
      if ($num_user1 > 0)
        {
          $this->card_user1 = array();
          if (isset($this->all_card[$num_user1]))
            {
              $this->card_user1=$this->all_card[$num_user1];
            }
          else
            {
              $this->card_user1=array(0,-1,array());
            }
        }
      
      if ($num_user2 > 0)
        {
          $this->card_user2 = array();
          if (isset($this->all_card[$num_user2]))
            {
              $this->card_user2=$this->all_card[$num_user2];
            }
          else
            {
              $this->card_user2=array(0,-1,array());
            }
        }
      
    }
  
  function set_card_user($num_user1,$num_user2)
    {
      if ($num_user1 > 0)
        {
          $this->all_card[$num_user1]=$this->card_user1;
        }
      
      if ($num_user2 > 0)
        {
          $this->all_card[$num_user2]=$this->card_user2;
        }
    }
  
  function check_new_data_user1($num_user2,$time_last)
    {
      $on_new=false;
      $on_update_card=false;
      $time_card_user1=!empty($this->card_user1[2][$num_user2]) ? $this->card_user1[2][$num_user2] : 0;
      
      if ($time_last == 0 || $time_card_user1 == 0 || $time_card_user1>$time_last)
        {
          $on_new=true;
        }
      
      if ($time_card_user1 == 0)
        $on_update_card=true;
      
      return (array($on_new,$on_update_card));
    }
  
  function set_mark_card_users($num_user1,$num_user2)
    {
      //обновляем данные пользователей в картах
      
      $this->ext_card_users($num_user1,$num_user2);
      
      $this->card_user1[0]=$GLOBALS["timeGlobal"];
      $this->card_user1[1]=-1;
      $this->card_user1[2][$num_user2]=$GLOBALS["timeGlobal"];
      
      $this->card_user2[0]=$GLOBALS["timeGlobal"];
      $this->card_user2[1]=-1;
      $this->card_user2[2][$num_user1]=$GLOBALS["timeGlobal"];
      
      $this->set_card_user($num_user1,$num_user2);
      $this->save_all_card_users();
      
      return (true);
    }
  
  function get_count_message_user_not_read($num_user1)
    {
      $quantity=0;
      
      $on_cache=false;
      
      $this->ext_card_users($num_user1,0);
      if ($this->card_user1[1] != -1)
        {
          $on_cache=true;
          $quantity=$this->card_user1[1];
          
        }
      
      if (!$on_cache)
        {
          $db_query = "select count(id_messenger) "." from ".DB_PREF."messenger "
            . " where num_recipient=" . $num_user1 . " and onread='off' ";
          
          $kolvo = db_work::query_count($db_query);
          if ($kolvo > 0) $quantity = $kolvo;
          $this->card_user1[1]=$quantity;
          $this->set_card_user($num_user1,0);
          $this->save_all_card_users();
        }
      
      return ($quantity);
    }
  
  function send_email_notice_user2($one_message,$data_user1,$data_user2)
    {
      if ($data_user2 && $data_user2["notice_new_private_message"] == "on" && ($data_user2["authorized"] == "off" || $data_user2["authorized"] == "on" && ($GLOBALS["timeGlobal"] - $data_user2["date_visit"]) > 2*60)
          && ($data_user2["authorized_admin"] == "off" || $data_user2["authorized_admin"] == "on" && ($GLOBALS["timeGlobal"] - $data_user2["date_admin"]) > 2*60)
         )
        {
          global  $dir_http,$url_site;
          
          $link=$url_site."/messenger";
          
          if ($data_user1) $link=$url_site."/mesngr_u".$data_user1["id_user"];
          
          global $url_site,$domen_site;
          $t=
            '<table border="0" cellpadding="0" cellspacing="0" width="100%" style="margin:0; padding:0; font-family: Verdana, Geneva, sans-serif; font-size: 14px;">'
            .'<tr><td>'
            
            ."Здравствуйте.<br/>\n<br />\n"
            ."Пользователь <a href='".$url_site."/registr/user".$data_user1["id_user"].".html'>".codeHtmlText($data_user1["name_user"])."</a> написал вам новое сообщение на сайте <a href='".$url_site."'>".$domen_site."</a>."
            ."\n<br/>Текст сообщения:"
            
            ."</td></tr>"
            
            ."<tr><td style='padding: 10px 0px;'>"
             .'<table border="0" cellpadding="0" cellspacing="0" bgcolor="#eef4ed" width="100%" style=" background: #eef4ed; color: #444; margin:0; padding:0; font-family: Verdana, Geneva, sans-serif; font-size: 14px;">'
              .'<tr><td style="padding: 10px; color: #444;">' 
              .nl2br(codeHtmlText($one_message["message"]))
              .'</td></tr>'
             ."</table>"
            ."</td></tr>"
            
            ."<tr><td>"
            
            ."Посмотреть сообщение и ответить вы можете на странице <a href='".$link."'>Сообщения</a>."
            ."\n<br/>\n<br /> Отписаться от получения уведомлений по Email можно в своем профиле <a href='".$url_site."/registr/inforeg/'>Мой профиль</a>."
            .forming_signature_email()
            .'</td></tr>'
            .'</table>';
          
          send_email("Оповещение о новом сообщении",$t,$data_user2["name_user"],$data_user2["email_user"],false,false,false,false,true);
        }
      
      return (true);
    }
  
}
