<?php



class eng_money_user
  {
   
   function __construct()
     {
      
     }
   
   static public function operationCheckServiceAddMoney($num_user, $add_amount, $info_payment = false, $is_check_query = false)
     {
      // $is_check_query -> true - запрос для проверки данных, сама оплата не была проведена, и выполнять платеж на сайте не надо
      $error = 0;
      $error_text = "";
      
      //проверяем данные в массиве $mas_data
      if ( !( is_numeric($num_user) && is_numeric($add_amount) ) )
        {
         $error = 1; 
         $error_text = "неверно заданы инициализационные данные.";
        }
      
      if ( $error == 0 && !$is_check_query )
        {
         list($error,$error_text) = self::operationAddMoney($num_user,$add_amount, $info_payment);
        }
      
      return (array($error,$error_text));
     }
   
   
   static public function operationAddMoney($num_user, $add_amount, $info_payment = false)
     {
      $error = 0;
      $error_text = "";
      
      $db_query="update ".DB_PREF."users set money = round(money + ".$add_amount.", 2) where id_user = ".$num_user;
      
      obr_db_query($db_query);
      
      if ( $info_payment !== false )
        {
         $info_payment["num_user"] = $num_user;
         $info_payment["cost"] = $add_amount;
         $info_payment["type_oper"] = "addmoney";
         $info_payment["description"] = "Пополнение счета пользователем";
         self::add_item_log( $info_payment );
        }
      
      return ( array($error, $error_text) );
     }
   
   static public function operationDecrMoney($num_user, $decr_amount, $info_payment = false)
     {
      $error = 0;
      $error_text = "";
      
      $db_query = "update ".DB_PREF."users set money = round(money - ".codeText($decr_amount).", 2) where id_user = ".$num_user." ";
      
      obr_db_query( $db_query );
      
      if ( $info_payment !== false )
        self::add_item_log( $info_payment );
      
      return ( array($error, $error_text) );
     }
   
   static public function add_item_log($mas_data)
     {
      
      $mas_save = array( 
        "id_log_money" => 0,
        "num_user" => 0,
        "description" => "",
        "cost" => 0,
        "putdate" => $GLOBALS["timeGlobal"],
        "type_oper" => "",
        "type_ps" => "" );
      
      // в массиве ключи
      // type_oper - тип операции:
      //  decrement - списание средст со счета (оплата услуг средствами с баланса пользователя на сайте),
      //  addmoney - пополнение средст на счете,
      //  paymentserv - оплата услуг на прямую,
      // type_ps - тип платежной системы:
      //  balance - баланс пользователя на счете
      //  webmoney, a1lite, и т.д.
      
      $keys = array( "num_user", "description", "cost", "putdate", "type_oper", "type_ps" );
      
      foreach ( $keys as $one_key )
        if ( isset( $mas_data[$one_key] ) ) $mas_save[$one_key] = $mas_data[$one_key];
      
      
      $db_query = forming_db_query_indexmas(DB_PREF."log_money",$mas_save,"new","id_log_money");
      obr_db_query($db_query);
      
      return ( true );
     }
   
   static public function select_list_log_money($kol_page, $num_page, $filtr_num_user )
     {
      // извлекаем список ip адресов
      $data = array();
      $kolvo_vsego = 0;
      
      $query_search = "";
      $filtr_num_user = trim( $filtr_num_user );
      if (  $filtr_num_user || $filtr_num_user === "0" )
        {
         $query_search = " num_user IN (".codeText($filtr_num_user).") ";
         
        }
      
      if ( $query_search )
        $query_search = " where ".$query_search;
      
      $db_query="select count(*) from ".DB_PREF."log_money ".$query_search." ";//"order by ip_adr DESC limit ".(($num_page - 1) * $kol_page).",".$kol_page;
      
      $kolvo_vsego = obr_db_query_count($db_query);
      if ( $kolvo_vsego > 0 )
        {
         $db_query="select * from ".DB_PREF."log_money ".$query_search." order by id_log_money DESC limit ".(($num_page - 1) * $kol_page).",".$kol_page;
         
         list($kolvo,$data)=obr_db_query_select_assoc($db_query);
        }
      
      return ( array( $kolvo_vsego, $data ) );
     }
   
   static public function delete_list_num_log_money( $list_num )
     {
      
      $db_query = "delete from ".DB_PREF."log_money where id_log_money IN (".$list_num.")";
      
      obr_db_query($db_query);
      
      return (true);
     }
   
   
   static public function operationMoneyPanel($num_user, $amount, $oper_money)
     {
      $error = 0;
      $error_text = "";
      
      $t_description = "";
      $db_query = "";
      
      if ( $oper_money == "addmoney_panel" )
        {
         $db_query="update ".DB_PREF."users 
           set money = round(money + ".$amount.", 2) 
           where id_user = ".$num_user;
         $t_description = "Пополнение баланса в панели управления";
        }
       elseif ( $oper_money == "decrmoney_panel" )
         {
          $db_query="update ".DB_PREF."users 
            set money = round(money - ".$amount.", 2) 
            where id_user = ".$num_user;
          $t_description = "Списание средств с баланса в панели управления";
         }
       elseif ( $oper_money == "setmoney_panel" )
         {
          $db_query="update ".DB_PREF."users 
            set money =  round(".$amount.", 2) 
            where id_user = ".$num_user;
          $t_description = "Формирование баланса в панели управления";
         }
      
      
      if ( $db_query )
        {
         
         obr_db_query( $db_query );
         
         $info_payment = array();
         $info_payment["num_user"] = $num_user;
         $info_payment["cost"] = $amount;
         $info_payment["type_oper"] = $oper_money;
         $info_payment["type_ps"] = "balance";
         $info_payment["description"] = $t_description;
         self::add_item_log( $info_payment );
        }
      
      return ( array($error, $error_text) );
     }
   
  }












