<?php


function generator_name_img()
  {
   //генерируем новое случайное имя рисунка
   $newname="";
   $new = mt_rand(10000,99999999).mt_rand(10000,99999999).mt_rand(10000,99999999).mt_rand(10000,99999999).mt_rand(10000,99999999);
   $newname = md5( $new );
   $newname = strtolower($newname);
   return ($newname);
  }

/*
function generator_name_img()
  {
   //генерируем новое случайное имя рисунка
   $newname="";
   for ($k=1;$k<=32;$k++)
     if ( rand(0, 5)==3 ) 
       $newname .= chr(48+rand(0, 9));
      else
        $newname .= chr(65+rand(0, 25));
   $newname = strtolower($newname);
   return ($newname);
  }
*/

function proverka_exp_img($name_img)
  {
   //проверим расширение загруженных картинок
   return (proverka_exp_file($name_img,"jpg|gif|png|jpeg"));
  }


function preob_img($img_file,$img_new,$max_width,$max_height,$quality=85)
  {
   
   return (transform_size_image($img_file,$img_new,$max_width,$max_height,true, $quality));
   
  }


function preob_tosize_img($img_file,$img_new,$max_width,$max_height,$quality=85)
  {
   
   return (transform_size_image($img_file,$img_new,$max_width,$max_height,false, $quality));
   
  }


class eng_image_file
{
  
  static public function get_img_type($path_file)
    {
      //получаем тип изображения из данных файла
      //функция вернет расширение (jpeg или png или gif) или false
      $exp=false;
      
      $type=@exif_imagetype($path_file);
      
      if ($type)
        {
          if ($type == IMAGETYPE_JPEG) $exp="jpg";
           elseif ($type == IMAGETYPE_PNG) $exp="png";
           elseif ($type == IMAGETYPE_GIF) $exp="gif";
        }
      
      return ($exp);
    }
  
  static public function check_img_type($exp_check,$path_file)
    {
      //функция сравнивает заданное расширение (обычно расширение файла) с типом изображения из данных файла
      // возвращает true если типы совпадают, иначе false
      $on_check=false;
      
      $exp_check=mb_strtolower($exp_check);
      if ($exp_check == "jpeg") $exp_check="jpg";
      
      if ($exp_check === self::get_img_type($path_file)) $on_check=true;
      
      return ($on_check);
    }
}


function transform_size_image($img_file,$img_new,$max_width,$max_height,$prop_transform_size, $quality=85,$nplane=0,$check_rotate=false,$stream=false)
  {
   // $prop_transform_size -> true - преобразование изображения с сохранением пропорций
   // false - точный подгон изображения к заданным размерам.
   // $stream - false -> запись в файл, true -> вывод в поток
   
   //проверяем и преобразуем если надо рисунок
   $on_img = false;
   $exp = proverka_exp_img($img_new);
   $exp = ($exp ? strtolower($exp) : $exp);
   if (!$exp) return (false);
   if (!eng_image_file::check_img_type($exp,$img_file)) return (false);
   
   $d_img = false;
   $is_exp = "";
   
   
   list($d_img,$is_exp) = imagephp_create_from_file($img_file,$exp,true,$check_rotate);
   if (!$d_img || !$is_exp) return (false);
   
   $width=ImageSX($d_img);
   $height=ImageSY($d_img);
   
   
   $on_edit=false;
   
   $img_width=$width;
   $img_height=$height;
   $cut_x=0;
   $cut_y=0;
   
   list($on_edit,$new_width,$new_height,$cut_width,$cut_height,$cut_x,$cut_y) = 
     calculation_transform_size_imagephp($img_width,$img_height,$max_width,$max_height,$prop_transform_size,$nplane);
   
   
   if ($on_edit)
     {
      
      $d_new_img=imagecreatetruecolor($new_width,$new_height);
      if ($exp=="png")
        {
         imagealphablending($d_new_img,true);
         imagesavealpha($d_new_img,true);
         imagefill($d_new_img,0,0,imagecolorallocatealpha($d_new_img,0,0,0,127));
        }
      imagecopyresampled($d_new_img,$d_img,0,0,$cut_x,$cut_y,$new_width,$new_height,$cut_width,$cut_height);
      
      $img_width = $new_width;
      $img_height = $new_height;
      if (!$stream)
        {
          $on_img = create_file_from_imagephp($d_new_img, $img_new, $is_exp, $quality);
        }
       else
         {
           $on_img = write_imagephp_stream($d_new_img, $is_exp, $quality);
         }
      
      ImageDestroy($d_new_img);
      
     }
    else
      {
       //$d_new_img = $d_img;
       if (!$stream)
         {
           if ($img_file === $img_new)
             {
               $on_img = true;
             }
           elseif (copy($img_file, $img_new))
             {
               $on_img = true;
             }
         }
        else
          {
            $on_img = write_imagephp_stream($d_img, $is_exp, $quality);
          }
       
      }
   
   ImageDestroy($d_img);
   
   return ( $on_img ? array($img_width,$img_height) : false );
  }



function transform_size_image_watermark($img_file,$img_new,$img_watermark,$max_width,$max_height,$prop_transform_size,$watermark_x = 0,$watermark_y = 0, $quality=85, $nplane = 0, $check_rotate=false)
  {
   // $prop_transform_size -> true - преобразование изображения с сохранением пропорций
   // false - точный подгон изображения к заданным размерам.
   
   
   //проверяем и преобразуем если надо рисунок
   $on_img = false;
   $exp = proverka_exp_img($img_new);
   $exp = ($exp ? strtolower($exp) : $exp);
   if (!$exp) return (false);
   if (!eng_image_file::check_img_type($exp,$img_file)) return (false);
   
   $d_img = false;
   $is_exp = "";
   
   
   list($d_img,$is_exp) = imagephp_create_from_file($img_file,$exp,true,$check_rotate);
   if (!$d_img || !$is_exp) return (false);
   
   $width=ImageSX($d_img);
   $height=ImageSY($d_img);
   
   
   $on_edit=false;
   
   $img_width=$width;
   $img_height=$height;
   $cut_x=0;
   $cut_y=0;
   
   list($on_edit,$new_width,$new_height,$cut_width,$cut_height,$cut_x,$cut_y) = 
     calculation_transform_size_imagephp($img_width,$img_height,$max_width,$max_height,$prop_transform_size,$nplane);
   
   
   if ($on_edit)
     {
      
      $d_new_img=imagecreatetruecolor($new_width,$new_height);
      if ($exp=="png")
        {
         imagealphablending($d_new_img,true);
         imagesavealpha($d_new_img,true);
         imagefill($d_new_img,0,0,imagecolorallocatealpha($d_new_img,0,0,0,127));
        }
      imagecopyresampled($d_new_img,$d_img,0,0,$cut_x,$cut_y,$new_width,$new_height,$cut_width,$cut_height);
      ImageDestroy($d_img);
      $img_width = $new_width;
      $img_height = $new_height;
      
     }
    else
      {
       $d_new_img = $d_img;
       /*
       if (copy($img_file,$img_new))
         {
          $on_img=true;
         }
       */
      }
   
   $exp_watermark = proverka_exp_img($img_watermark);
   $exp_watermark = ( $exp_watermark ? strtolower($exp_watermark) : $exp_watermark );
   
   if ( $exp_watermark )
     {
      
      //открываем рисунок водяного знака
      list($d_img_watermark,$is_exp_watermark) = imagephp_create_from_file($img_watermark,$exp_watermark,true,false);
      
      if ( !$d_img_watermark || !$is_exp_watermark ) return (false);
      
      $width_watermark=ImageSX($d_img_watermark);
      $height_watermark=ImageSY($d_img_watermark);
   
      $x_position=round(($img_width - $width_watermark - $watermark_x));
      $y_position=round(($img_height - $height_watermark - $watermark_y ));
      
      imagecopyresampled($d_new_img,$d_img_watermark,$x_position,$y_position,0,0,$width_watermark,$height_watermark,$width_watermark,$height_watermark);
      
      ImageDestroy($d_img_watermark);
     }
   
   $on_img = create_file_from_imagephp($d_new_img,$img_new,$is_exp,$quality);
   ImageDestroy($d_new_img);
   
   return ( $on_img ? array($img_width,$img_height) : false );
  }


function calculation_transform_size_imagephp($img_width,$img_height,$max_width,$max_height,$prop_transform_size,$nplane=0)
  {
   // $nplane -> задает область копирования исходного изображения при обрезации изображения (в случае $prop_transform_site равном false)
   // 0 - область будет расчитываться с верхнего левого угла
   // 1 - будет использоваться центральная часть изображения
   
   $on_edit = false;
   
   $prop_create = $max_width/$max_height;
   $prop = $img_width/$img_height;
   
   $new_width = $max_width;
   $new_height = $max_height;
   $cut_width = $img_width;
   $cut_height = $img_height;
   
   $cut_x=0;
   $cut_y=0;
   
   if ( $prop_transform_size )
     {
      if ( $prop >= $prop_create )
         {
          if ( $img_width > $max_width )
            {
              $k=$img_width/$max_width;
              $new_width=$max_width;
              $new_height=floor($img_height/$k);
              $on_edit=true;
              
            }
          
         }
        else
          {
           if ( $img_height > $max_height )
             {
               $k=$img_height/$max_height;
               $new_height=$max_height;
               $new_width=floor($img_width/$k);
               $on_edit=true;
               
             }
          }
      
     }
    else
      {
       if ( !($img_width == $max_width && $img_height == $max_height) )
         {
          $on_edit=true;
          
          if ( $prop <= $prop_create )
             {
              $k=$img_width/$max_width;
              //$cut_width=$img_width;
              $cut_height=floor($max_height*$k);
              if ($nplane == 1)
                $cut_y=floor(($img_height-$cut_height)/2);
             }
            else
              {
               $k=$img_height/$max_height;
               //$cut_height=$img_height;
               $cut_width=floor($max_width*$k);
               if ($nplane == 1)
                 $cut_x=floor(($img_width-$cut_width)/2);
              }
          
         }
       
       
      }
   
   return ( array($on_edit,$new_width,$new_height,$cut_width,$cut_height,$cut_x,$cut_y) );
  }


function imagephp_create_from_file($file_image,$exp="",$alphablending=false,$check_rotate=false)
  {
   $d_img = false;
   $is_exp = "";
   if ( file_exists($file_image) )
     {
       
       $angle = 0;
       
       if ($check_rotate)
         {
           $exif = @exif_read_data($file_image);
           if ($exif && !empty($exif["Orientation"]))
             {
               switch ($exif["Orientation"])
                 {
                  case 8:
                     $angle = 90;
                     break;
                  case 3:
                     $angle = 180;
                     break;
                  case 6:
                     $angle = -90;
                     break;
                 }
             }
         }
       
       if ($exp == "jpg" || $exp == "jpeg")
         {
          $d_img=@ImageCreateFromJpeg($file_image);
          if ($d_img) $is_exp="jpg";
         }
        elseif ($exp == "gif")
          {
           $d_img=@ImageCreateFromGif($file_image);
           if ($d_img) $is_exp="gif";
          }
         elseif ($exp == "png")
           {
            $d_img=@ImageCreateFromPng($file_image);
            if ($d_img)
              {
                imagealphablending($d_img, true);
                imagesavealpha($d_img, true);
                $is_exp = "png";
              }
           }
       
       if ($check_rotate && $angle != 0 && $d_img)
         {
           $d_img=imagerotate($d_img,$angle,0);
           
         }
     }
   
   return (array($d_img,$is_exp));
  }

function create_file_from_imagephp($d_img,$name_file,$exp,$quality = 85)
  {
   $on_img = false;
   if ($exp == "jpg" || $exp == "jpeg")
     {
      imagejpeg($d_img,$name_file,$quality);
      $on_img=true;
     }
    elseif ($exp == "gif")
      {
       imagegif($d_img,$name_file);
       $on_img=true;
      }
     elseif ($exp=="png")
       {
        imagepng($d_img,$name_file);
        $on_img=true;
       }
   
   return ($on_img);
  }


function write_imagephp_stream($d_img,$exp,$quality = 85)
  {
    //выводим изображение в поток (в браузер)
    $on_img = false;
    if ($exp == "jpg" || $exp == "jpeg")
      {
        header("Content-type: image/jpeg");
        imagejpeg($d_img, null, $quality);
        $on_img = true;
      }
    elseif ($exp == "gif")
      {
        header("Content-type: image/gif");
        imagegif($d_img, null);
        $on_img = true;
      }
    elseif ($exp == "png")
      {
        header("Content-type: image/png");
        imagepng($d_img, null);
        $on_img = true;
      }
    
    return ($on_img);
  }



function proverka_exp_file($name_file,$list_exp="jpg|gif|png|jpeg")
  {
   $on_exp=false;
   $mas_exp=explode("|",$list_exp);
   
   $exp=get_exp_file($name_file);
   if ( $exp )
     {
       //$all_exp=array ("jpg","gif","png");
       
       foreach ($mas_exp as $one_exp)
        {
         if ($one_exp == $exp)
           {
            $on_exp=$one_exp;
            break;
           }
        }
    }
   
   return ($on_exp);
  }

function get_exp_file($name_file)
  {
   $exp=false;
   $mas_data_file=explode(".",$name_file);
   if ( sizeof($mas_data_file) >= 2 )
     {
      $exp=mb_strtolower(end($mas_data_file));
      
     }
   
   return ($exp);
  }

function check_stop_exp_file($name_file,$list_exp="exe|php")
  {
   $on_stop=false;
   $mas_exp=explode("|",$list_exp);
   
   $exp=get_exp_file($name_file);
   if ( $exp )
     {
      if (in_array($exp,$mas_exp)) $on_stop=true;
     }
   
   return ($on_stop);
  }

function get_info_file($name_file)
  {
   $name = "";
   $exp = "";
   $mas_data_file=explode(".",$name_file);
   if ( sizeof($mas_data_file) >= 2 )
     {
      $sep = "";
      for ( $n=0 ; $n < sizeof($mas_data_file)-1 ; $n++ )
        {
         $name .= $sep. $mas_data_file[$n];
         $sep = ".";
        }
      $exp=mb_strtolower(end($mas_data_file));
     }
   return (array("name" => $name,"exp" => $exp));
  }



function control_upload_file($name_pole,$size_file = -1)
  {
   $name_upload="";
   $error=false;
   
   if (isset($_FILES[$name_pole]["error"]) && $_FILES[$name_pole]["error"] == 0)
     {
      if ( ( $size_file >= 0 && $_FILES[$name_pole]["size"] < $size_file ) || $size_file == -1 )
         $name_upload=$_FILES[$name_pole]["name"];
        else
          $error=true;
      
      
     }
    else
      {
       $error=true;
      }
   return (array($error,$name_upload));
  }

function save_upload_file( $name_pole,$dir_save,$on_generate_new_name,$set_name_file,$type_file,
    $type_save="copy",$img_width=0,$img_height=0,$size_file = -1,
    $dir_save_2="",$type_save_2="",$img_width_2=0,$img_height_2=0,$stop_type="", $nplane = 0, $check_rotate = false )
  {
   //
   //$type_file - указываются через вертикальную черту (|) допустимые расширения файлов 
   // или значение all , если  загружаются все файлы
   //
   //$type_save - может принимать значения: 
   // copy - просто копируется файл
   // resize - просто уменьшается рисунок до указанных размерам
   // tosize - рисунок преобразуется к указанным размерам, при необходимости обрезается
   //
   
   $name_save_file="";
   $exp_save_file="";
   $file_save="";
   
   $rez_upload=control_upload_file($name_pole,$size_file);
   $error=false;
   
   if ( !$rez_upload[0] && $rez_upload[1] )
     {
      $name_upload_file=$rez_upload[1];
      if ($type_file === "all" )
        {
         $exp_save_file=get_exp_file($name_upload_file);
        }
       else
         {
          $exp_save_file=proverka_exp_file($name_upload_file,$type_file);
          if ( !$exp_save_file )
            $error=true;
         }
      
      if ( !$error && $stop_type != "" )
        {
         if (check_stop_exp_file($name_upload_file,$stop_type)) $error=true;
        }
      
      if ( !$error )
        {
         if ( $on_generate_new_name )
           {
            $name_save_file=generator_name_img();
            $file_save=$name_save_file.".".$exp_save_file;
           }
          else
            {
             if ( $set_name_file )
               {
                $name_save_file=$set_name_file;
                $file_save=$name_save_file.".".$exp_save_file;
               }
              else
                {
                 $file_save=$name_upload_file;
                }
             
            }
        }
      
      if ( !$error )
        {
         
         $error=processing_uploadfile($type_save,$name_pole,$dir_save,$file_save,$img_width,$img_height,$nplane,$check_rotate);
         
        }
      
      if ( !$error && $type_save_2 )
        {
         
         $error=processing_uploadfile($type_save_2,$name_pole,$dir_save_2,$file_save,$img_width_2,$img_height_2,$nplane,$check_rotate);
         
        }
      
     }
    else
      $error=true;
   
   return (array($error,$error?"":$file_save));
  }

function processing_uploadfile($type_save,$name_pole,$dir_save,$file_save,$img_width,$img_height, $nplane = 0, $check_rotate = false)
  {
   $error=false;
   
   switch ( $type_save )
       {
        case ("copy"):
           if ( copy($_FILES[$name_pole]["tmp_name"],$dir_save.$file_save) )
             {
              
             }
            else
              {
               $error=true;
              }
          break;
        case ("resize"):
           //if ( preob_img($_FILES[$name_pole]["tmp_name"],$dir_save.$file_save,$img_width,$img_height) )
           if ( transform_size_image($_FILES[$name_pole]["tmp_name"],$dir_save.$file_save,$img_width,$img_height,true,85,$nplane,$check_rotate) )
             {
              
             }
            else
              {
               $error=true;
              }
          break;
        case ("tosize"):
           //if ( preob_tosize_img($_FILES[$name_pole]["tmp_name"],$dir_save.$file_save,$img_width,$img_height) )
           if ( transform_size_image($_FILES[$name_pole]["tmp_name"],$dir_save.$file_save,$img_width,$img_height,false,85,$nplane, $check_rotate) )
             {
              
             }
            else
              {
               $error=true;
              }
          break;
       }
   
   return ($error);
  }



function delete_file($dir_file,$name_file)
  {
   $error=false;
   if (file_exists($dir_file.$name_file))
     {
      if ( !unlink($dir_file.$name_file) )
        $error=2;
     }
    else
      $error=1;
   
   return ($error);
  }

function delete_mas_file($dir_file,$mas_name_file)
  {
   foreach ($mas_name_file as $name_file)
     {
       if (file_exists($dir_file.$name_file))
         {
          unlink($dir_file.$name_file);
         }
     }
   
  }



function delete_list_files($dir_file,$list_name_files,$sim_separator="|")
  {
   if ( trim( $list_name_files ) )
     {
      delete_mas_file($dir_file,explode($sim_separator,$list_name_files));
      
     }
   
   
  }



function control_upload_file_in_mas($name_pole,$num ,$size_file = -1)
  {
   $name_upload="";
   $error=false;
   
   if (isset($_FILES[$name_pole]["error"][$num]) && $_FILES[$name_pole]["error"][$num] == 0)
     {
      if ( ( $size_file >= 0 && $_FILES[$name_pole]["size"][$num] < $size_file ) || $size_file == -1 )
         $name_upload=$_FILES[$name_pole]["name"][$num];
        else
          $error=true;
      
     }
    else
      {
       $error=true;
      }
   return (array($error,$name_upload));
  }



function save_upload_mas_file( $name_pole,$dir_save,$on_generate_new_name,$type_file,
    $type_save="copy",$img_width=0,$img_height=0,$size_file = -1,
    $dir_save_2="",$type_save_2="",$img_width_2=0,$img_height_2=0,
    $img_watermark_1 = false, $watermark_x_1 = 5, $watermark_y_1 = 5,   
    $img_watermark_2 = false, $watermark_x_2 = 5, $watermark_y_2 = 5, $nplane = 0, $check_rotate = false, $max_numbr = 0 )
  {
   //
   //$type_file - указываются через вертикальную черту (|) допустимые расширения файлов 
   // или значение all , если  загружаются все файлы
   //
   //$type_save - может принимать значения: 
   // copy - просто копируется файл
   // resize - просто уменьшается рисунок до указанных размерам
   // tosize - рисунок преобразуется к указанным размерам, при необходимости обрезается
   //
   // $max_numbr - максимальное количество файлов, 0 - без ограничений
   
   $name_save_file="";
   $exp_save_file="";
   $file_save="";
   
   $error=false;
   $is_correct_files=false;
   $one_error=false;
   $mas_name_files=array();
   
   $files_counter=0;
   
   if (isset($_FILES[$name_pole]["error"]) && is_array($_FILES[$name_pole]["error"]) && sizeof($_FILES[$name_pole]["error"])>0 )
     {
      
      $kol_files=sizeof($_FILES[$name_pole]["error"]);
      
      if ( $kol_files > 0 )
        {
         for ($i=0;$i<$kol_files;$i++)
           {
            //Если достигнут предел по количеству файлов, то выходим из цикла
            if ($max_numbr > 0 && $files_counter >= $max_numbr) break;
            $one_error=false;
            
            if (isset($_FILES[$name_pole]["error"][$i]) && $_FILES[$name_pole]["error"][$i] == 0)
              {
               
               $rez_upload=control_upload_file_in_mas($name_pole,$i,$size_file);
               
               
               if ( !$rez_upload[0] && $rez_upload[1] )
                 {
                  $name_upload_file=$rez_upload[1];
                  if ($type_file === "all" )
                    {
                     $exp_save_file=get_exp_file($name_upload_file);
                    }
                   else
                     {
                      $exp_save_file=proverka_exp_file($name_upload_file,$type_file);
                      if ( !$exp_save_file )
                        $one_error=true;
                     }
                  
                  if ( !$one_error )
                    {
                     if ( $on_generate_new_name )
                       {
                        $name_save_file=generator_name_img();
                        $file_save=$name_save_file.".".$exp_save_file;
                       }
                      else
                        {
                         $file_save=$name_upload_file;
                         
                        }
                    }
                  
                  if ( !$one_error )
                    {
                     
                     $one_error=processing_upload_mas_file($type_save,$name_pole,$i,$dir_save,$file_save,$img_width,$img_height,$img_watermark_1,$watermark_x_1,$watermark_y_1,$nplane,$check_rotate);
                     
                     if ( !$one_error && $type_save_2 )
                       {
                        
                        $one_error=processing_upload_mas_file($type_save_2,$name_pole,$i,$dir_save_2,$file_save,$img_width_2,$img_height_2,$img_watermark_2,$watermark_x_2,$watermark_y_2,$nplane,$check_rotate);
                        
                       }
                     
                     if ( !$one_error )
                       {
                        $is_correct_files=true;
                        $mas_name_files[]=$file_save;
                        $files_counter++;
                       }
                      else
                        {
                          $error=true;
                        }
                     
                    }
                  
                 }
                else
                  {
                    $error=true;
                  }
               
              }
             else
               {
                 $error=true;
               }
           }
        }
     }
   
   return (array($is_correct_files,$error,$mas_name_files));
  }



function processing_upload_mas_file($type_save,$name_pole,$num,$dir_save,$file_save,$img_width,$img_height,$img_watermark = false,$watermark_x = 5,$watermark_y = 5,$nplane=0,$check_rotate=false)
  {
   $error=false;
   
   switch ( $type_save )
       {
        case ("copy"):
           if ( copy($_FILES[$name_pole]["tmp_name"][$num],$dir_save.$file_save) )
             {
              
             }
            else
              {
               $error=true;
              }
          break;
        case ("resize"):
           //if ( preob_img($_FILES[$name_pole]["tmp_name"][$num],$dir_save.$file_save,$img_width,$img_height) )
           if ( !$img_watermark )
             {
              if ( !transform_size_image($_FILES[$name_pole]["tmp_name"][$num],$dir_save.$file_save,$img_width,$img_height,true, 85,$nplane,$check_rotate) )
                {
                 $error=true;
                }
             }
            else
              {
               if ( !transform_size_image_watermark($_FILES[$name_pole]["tmp_name"][$num],$dir_save.$file_save,$img_watermark,$img_width,$img_height,true,$watermark_x,$watermark_y, 85,$nplane,$check_rotate) )
                {
                 $error=true;
                }
              }
            
          break;
        case ("tosize"):
           //if ( preob_tosize_img($_FILES[$name_pole]["tmp_name"][$num],$dir_save.$file_save,$img_width,$img_height) )
           if ( !$img_watermark )
             {
              if ( !transform_size_image($_FILES[$name_pole]["tmp_name"][$num],$dir_save.$file_save,$img_width,$img_height,false, 85,$nplane,$check_rotate) )
                {
                 $error=true;
                }
             }
            else
              {
               if ( !transform_size_image_watermark($_FILES[$name_pole]["tmp_name"][$num],$dir_save.$file_save,$img_watermark,$img_width,$img_height,false,$watermark_x,$watermark_y, 85,$nplane,$check_rotate) )
                {
                 $error=true;
                }
              }
            
          break;
       }
   
   return ($error);
  }


function generator_name_file_unique_dir($dir,$exp,$pref="")
  {
   
   do
    {
     $name_file = $pref. generator_name_img().".".$exp;
    }
   while ( file_exists($dir.$name_file) );
   
   return ($name_file);
  }



class write_image_client_path
  {
   
   protected $width=140;
   protected $height=140;
   protected $path="";
   
   function __construct()
     {
       
     }
   
   function get_param($name_param)
     {
      $name="";
      
      if (!empty($_GET[$name_param]) && is_string($_GET[$name_param])) $name=$_GET[$name_param];
      
      return (array($name));
     }
   
   function write_small($path)
     {
      
      $exp=proverka_exp_file($path,"jpg|gif|png|jpeg");
      
      if (!$exp) return (false);
      
      if (!file_exists($path)) return (false);
      
      transform_size_image($path,$path,$this->width,$this->height,true,85,0,true,true);
      
      return (true);
     }
   
   function small_tmp($dir,$name_param,$max_width,$max_height,$allow_directory=false)
     {
      global $masConfig;
      
      $this->width=$max_width;
      $this->height=$max_height;
      
      $param=$this->get_param($name_param);
      $on=false;
      
      if ($param[0])
        {
         $name=$param[0];
         
         if (!$this->check_path($name,$allow_directory)) return (false);
         
         $path=$dir."/". $name;
         $path=preg_replace(array('#\\\\#','#(/)+#'),array('/','/'),$path);
         //write_log_cms($path,"path image");
         $on=$this->write_small($path);
        }
      
      return ($on);
     }
   
   function check_path($path,$allow_directory)
     {
      $on=true;
      
      if (preg_match('#(\\.\\.)|(:\\/)|(:\\\\)|(\\.\\/)|(\\.\\\\)#',$path) !== 0) $on=false;
      if (!$allow_directory && preg_match('#(\\/)|(\\\\)#',$path) !== 0) $on=false;
      
      return ($on);
     }
   
  }

