<?php

// функции для cms boxcode.ru


spl_autoload_register(function ($class_name){
  //write_log_cms ($class_name,"class name");
  global $mas_registr_class;
  
  $path_file="";
  
  if (!empty($mas_registr_class[$class_name])) $path_file = DIR_CMS . $mas_registr_class[$class_name];
  
  if ($path_file)
    {
      include($path_file);
    }
  
});


function time_cms()
  {
    return (time()+DELTA_TIME*3600);
  }



class work_init_moduls
  {
   
   function __construct()
     {
      
     }
   
   static public function get_num_modul($name_modul)
     {
      global $list_modules;
      $num_modul = 0;
      
      if ($name_modul)
        {
          if ($name_modul == "mainModul")
            {
              $num_modul = 2;
            }
          elseif (!empty($list_modules[$name_modul]))
            {
              $num_modul = $list_modules[$name_modul][5];
            }
        }
      
      return ($num_modul);
     }
   
   static public function get_name_modul($num_modul,$on_use=false)
     {
      global $list_modules;
      $name_modul = "";
      
      if ($num_modul == 2)
        {
          $name_modul = "mainModul";
        }
       else
         {
           foreach ($list_modules as $one_modul)
             {
               if ($one_modul[5] == $num_modul && (!$on_use || $on_use && $one_modul[2] == 1))
                 {
                   $name_modul = $one_modul[0];
                   break;
                 }
             }
         }
      
      return ($name_modul);
     }
   
   static public function check_use_modul($name_modul)
     {
      global $list_modules;
      $on_use=false;
      if (!empty($list_modules[$name_modul]) && $list_modules[$name_modul][2] == 1) $on_use=true;
      
      return ($on_use);
     }
   
  }

function forming_signature_email()
  {
   global $masConfig;
   $t = trim($masConfig["EMAIL_ADMIN_SIGNATURE"]);
   
   if ( $t ) $t = "<br><br>".$t;
   
   return ($t);
  }


// функции записи сообщений (ошибок) в лог-файл CMS

function db_error($name=false,$text_error=false)
   {
    if ( !$name )
      $name="Главный скрипт";
    
    if ( !$text_error )
      {
       $text_error="";
       $text_error.=db_work::get_db_error();
      }
    
    write_log_cms($text_error,$name);
   }

function write_log_cms($data,$name="данные")
  {
   global $errors_file;
   $today_timestamp = $GLOBALS["timeGlobal"];
   $r_date=date("H:i:s/d.m.Y",$today_timestamp);
   $w_data = "";
   if ( is_array($data) )
     {
      $w_data = var_export($data,true);
     }
    elseif ( $data === true || $data === false )
      {
       $w_data= $data ? "true": "false";
      }
     else
       {
        $w_data = $data;
       }
   //добавляем время в сообщение об ошибке
   $text = "Время ".$r_date." | ".($name ? $name.": ": "").$w_data."\n\n"; 
   
   if (!file_exists($errors_file))
     {
      $file_d=fopen($errors_file,"w");
      fclose($file_d);
     }
   
   if ((file_exists($errors_file)) && (filesize ($errors_file) < 3000000))
     {
      $file_d=fopen ($errors_file,"a");

      fwrite ($file_d,$text);
      fclose ($file_d);
     }
  }




// класс для работы с сессией пользователя на сайте

class session_auth_user
  {
   
   function __construct()
     {
      
     }
   
   static public function set_session($data_user, $on_memory)
     {
      
      // добавляем в сессию данные
      $_SESSION["time_avt"]=$GLOBALS["timeGlobal"];
      
      $_SESSION["id_user"] = $data_user["id_user"];
      $_SESSION["name_user_avt"] = $data_user["name_user"];
      $_SESSION["email_user_avt"] = $data_user["email_user"];
      
      $_SESSION["access_admin_avt"] = $data_user["access_admin"];
      
      // добаляем в глобальные переменные данные
      $GLOBALS["user_to_site"] = true;
      $GLOBALS["name_user_to_site"] = $data_user["name_user"];
      $GLOBALS["id_user_to_site"] = $data_user["id_user"];
      $GLOBALS["email_user_to_site"] = $data_user["email_user"];
      $GLOBALS["access_admin"] = $data_user["access_admin"];
      $GLOBALS["data_authorize_user"] = $data_user;
      
      if ( $on_memory )
        {
         self::set_cookie_memory($data_user);
        }
      
     }
   
   static public function check_auth_user()
     {
      
      $GLOBALS["user_avtoriz"]=true;//авторизация на сайте включена (глобальная переменная для других модулей)
      
      $check_access = 0;
      $num_user = 0;
      $time_session = 0;
      $data_user = false;
      
      $time_tek=$GLOBALS["timeGlobal"];
      $clear_session = false;
      $on_memory_session = false;
      
      $clear_num_user=0;
      
      if ( isset($_SESSION["id_user"]) && isset($_SESSION["time_avt"]) 
        && is_numeric($_SESSION["id_user"]) && is_numeric($_SESSION["time_avt"]) )
        {
         //сессия определена
         $time_session = $_SESSION['time_avt'];
         $num_user = $_SESSION["id_user"];
         
         $data_user = self::check_num_user($num_user);
         
         if ( !$data_user )
           {
            $num_user = 0;
            $time_session = 0;
            $data_user = false;
           }
         
        }
      
      if ( $num_user > 0 )
        {
         if ( ( $time_tek-$time_session ) > TIME_SESSION_AVTORIZ )
           {
            //время сессии вышло
            $clear_num_user=$num_user;
            $check_access = 0;
            $clear_session = true;
            $num_user = 0;
            $data_user = false;
            $time_session = 0;
            
           }
        }
      
      if ( $num_user == 0 )
        {
         $data_user_ck = self::check_user_cookie_memory();
         
         if ( $data_user_ck != false )
           {
            $data_user = $data_user_ck;
            //self::set_session($data_user,true);
            $num_user = $data_user["id_user"];
            $time_session = time();
            $clear_session = false;
            $on_memory_session = true;
            //self::save_time_authoriz_user("",$num_user);
           }
        }
      
      if ( $clear_session )
        {
         self::clear_session(false);//удаляем сессию
        }
       elseif ( $num_user && $time_session && $data_user )
         {
          
          self::set_session($data_user,$on_memory_session);
          
          self::save_time_authoriz_user("",$num_user);
         }
      
      if ($clear_num_user > 0 && $clear_num_user != $num_user)//проверить
        {
          self::save_not_authorize_user($clear_num_user);
        }
      
      return ( $num_user > 0 ? $data_user : false );
     }
   
   static public function check_num_user($id_user)
     {
      $data_user=false;
      
      $db_query="select * from ".DB_PREF."users "
        ." where id_user='".codeText($id_user)."' " //."and BINARY password_user='".md5($password_user)."' "
        ." and ( access_user='on' or access_admin = 'sadmin' ) ";
      list($kolvo,$data_user)=db_work::query_select_one_assoc($db_query);
      
      
      if ($kolvo != 1)
        {
         $data_user = false;
        }
      
      return ($data_user);
     }
   
   static public function check_user_cookie_memory()
     {
      $data = false;
      if ( isset($_COOKIE["memoryauth"]) )
        {
         $mas_data = explode(":",base64_decode($_COOKIE["memoryauth"]));
         $error = false;
         if ( sizeof($mas_data) == 2 && $mas_data[0] && $mas_data[1] && is_numeric($mas_data[0]) )
           {
            $data_user_db = self::check_num_user($mas_data[0]);
            if ( $data_user_db )
              {
               $sk = md5("luHTUge7djyYT883Ytu06hTGHIdbvmBJGKjg75fJGf5t" . md5($data_user_db["password_user"]."g39dkjgkd93kdfj39dkjf83jdkeJKHGkj7y"));
               if ( $sk == $mas_data[1] )
                 {
                  $data = $data_user_db;
                 }
                else
                  {
                   $error = true;
                  }
              }
             else
               {
                $error = true;
               }
           }
          else
            {
             $error = true;
            }
         
         if ( $error )
           {
            //удаляем куку
            self::set_cookie_memory(false);
           }
        }
      
      return ($data);
     }
   
   static public function clear_session($delete_cookie_memory = true)
     {
      $num_user =0;
      
      if (isset($_SESSION['id_user']))
        {
         $num_user=$_SESSION['id_user'];
         //session_destroy();
         //unset($_SESSION['time_avt']);
         //unset($_SESSION['id_user']);
         
         //проверяем значения сессии - удаляем значение, если название ключа не начинается на "rem_" и "ses_" 
         foreach ($_SESSION as $key => $value)
           {
             
             if (strpos($key,"rem_") !== 0 && strpos($key,"ses_") !== 0)
               {
                 unset($_SESSION[$key]);
               }
           }
         
        }
      
      if ( $delete_cookie_memory )
        {
         self::set_cookie_memory(false);
        }
      
      return ($num_user);
     }
   
   static public function set_cookie_memory($data_user)
     {
      // если $data_user -> false , то удаляем куку
      $time_c = time()+3600*24*100;
      if ( $data_user == false )
        {
         $v = "";
         $time_c = 1000;
        }
       else
         $v = base64_encode($data_user["id_user"].":".md5("luHTUge7djyYT883Ytu06hTGHIdbvmBJGKjg75fJGf5t" . md5($data_user["password_user"]."g39dkjgkd93kdfj39dkjf83jdkeJKHGkj7y")));
      
      syst_setcookie("memoryauth",$v,array("expires"=>$time_c));
     }
   
   static public function init_authoriz_user_sc()
     {
      
      $GLOBALS["user_avtoriz"]=false;//авторизация пользователей на сайте (false - нет, true - да)
      $GLOBALS["user_to_site"]=false;//авторизован ли пользователь на сайте (false - нет, true - да)
      $GLOBALS["name_user_to_site"]="";//имя авторизованного пользователя
      $GLOBALS["id_user_to_site"]=-1;//уникальный номер пользователя - поле id_user таблицы users
      $GLOBALS["email_user_to_site"]="";//e-mail пользователя авторизованного на сайте
      $GLOBALS["access_admin"] = "";
      $GLOBALS["data_authorize_user"] = false;
      
      self::check_auth_user();
      
     }
   
   static public function save_time_authoriz_user($email_user,$id_user = false)
     {
      $db_query="update ".DB_PREF."users set date_visit=".$GLOBALS["timeGlobal"].", authorized='on' "
        ." where ".( $id_user ? " id_user = ".codeText($id_user)." " : " email_user='".codeText($email_user)."' ");
      $q_result = db_work::query($db_query);
     }
   
   static public function save_not_authorize_user($num_user)
     {
       $db_query="update ".DB_PREF."users set authorized='off' "
        ." where  id_user = ".codeText($num_user)." ";
       db_work::query($db_query);
     }
  }


class work_auto_execution
  {
   
   function __construct()
     {
      
     }
   
   static public function save_ini($ident_last,$mas_ident,$data)
     {
      $data_settings=array($GLOBALS["timeGlobal"],$ident_last,$mas_ident,$data);
      saveNameConfig("cron_status",array("mas_settings"=>serialize($data_settings)));
      return (true);
     }
   
   static public function get_ini()
     {
      $data_settings=loadNameConfig("cron_status");
      $time_last=0;
      $ident_last="";
      $mas_ident=array();
      $data=array();
      
      if (sizeof($data_settings) > 0)
        {
         $data_settings=unserialize($data_settings["mas_settings"]);
         $time_last=$data_settings[0];
         $ident_last=$data_settings[1];
         $mas_ident=$data_settings[2];
         $data=$data_settings[3];
        }
      
      //write_log_cms(array($time_last,$ident_last,$mas_ident,$data),"cron value ini file");
      
      return (array($time_last,$ident_last,$mas_ident,$data));
     }
   
   static public function get_status()
     {
      list($time_last,$ident_last,$mas_ident,$data_status)=self::get_ini();
      
      if ($time_last < $GLOBALS["timeBeginDay"])
        {
         $time_last=0;
         $ident_last="";
         $mas_ident=array();
         $data_status=array();
        }
      
      return (array($time_last,$ident_last,$mas_ident,$data_status));
     }
   
   static public function check_status($mas_init,$mas_ident,$data_status)
     {
      
      $info_time = getdate($GLOBALS["timeGlobal"]);
      
      foreach ($mas_init as $one_key => $one_init)
        {
         // 6-время запуска (0, false или "10:30"),
         // 7-ограничение по количеству (false - только один раз),
         // 8-интервал между запусками задания (в часах, false - не учитывается)
         
         $ident_one=$one_init[2];
         
         $run=true;
         
         if (in_array($ident_one,$mas_ident)) $run=false;
         
         if ( $run && $one_init[6] && $one_init[6] != 0)
           {
            //проверяем время запуска
            $info_clock_run=self::get_info_clock($one_init[6]);
            
            if ( $GLOBALS["timeGlobal"] < $GLOBALS["timeBeginDay"] + $info_clock_run["allmin"] * 60 )
              $run=false;
            
           }
         
         if ( $run && isset($data_status[$ident_one]))
           {
            $one_status=$data_status[$ident_one];
            
            if ( $one_init[7] === false || ($one_init[7] !== 0 && $one_init[7] <= $one_status[1]) )
              {
               //проверяем ограничение на повторение
               $run=false;
              }
            
            if ( $run && $one_init[8])
              {
               //проверяем интервал запуска
               $info_clock_interval=self::get_info_clock($one_init[8]);
               
               $all_minute_interval=$info_clock_interval["allmin"];
                
               $info_time_work=getdate($one_status[0]);
               
               $seconds_day_work=$one_status[0]-$GLOBALS["timeBeginDay"];
               $number_interval=ceil($seconds_day_work/($all_minute_interval*60));
               $time_end_last_interval= $GLOBALS["timeBeginDay"] + $number_interval*$all_minute_interval*60;
               
               if ($GLOBALS["timeGlobal"] < $time_end_last_interval) $run=false;
               
              }
           }
         
         
         $mas_init[$one_key]["run"]=$run;
         
        }
      
      //write_log_cms($mas_init,"cron status init run");
      
      return ($mas_init);
     }
   
   static public function get_part_make($mas_init)
     {
      $key_make=false;
      $on_next=false;
      
      foreach ($mas_init as $one_key => $one_init)
        {
         if ($one_init["run"])
           {
            if ($key_make === false)
              {
               $key_make = $one_key;
              }
             else
               {
                $on_next=true;
                break;
               }
           }
        }
      
      return (array($key_make,$on_next));
     }
   
   static public function get_data_part()
     {
      $key_exe = false;
      $ident_exe = false;
      $one_data_init = false;
      //$key_next = false;
      //$ident_next = false;
      $on_next = false;
      
      $time_last=0;
      $ident_last="";
      $mas_ident=array();
      $data_status=array();
      
      list($time_last,$ident_last,$mas_ident,$data_status)=self::get_status();
      
      global $mas_init_auto_execution;
      $mas_init = select_mas_2level($mas_init_auto_execution,1,true,false);
      
      if ( sizeof($mas_init) )
        {
         usort($mas_init,array("work_auto_execution","sort_order"));
         
         $mas_init=self::check_status($mas_init,$mas_ident,$data_status);
         
         list($key_exe,$on_next)=self::get_part_make($mas_init);
         
         if ( $key_exe !== false )
           {
            $one_data_init = $mas_init[$key_exe];
            $ident_exe = $mas_init[$key_exe][2];
            
            if (!isset($data_status[$ident_exe]))
              {
               $data_status[$ident_exe]=array($GLOBALS["timeGlobal"],1);
              }
             else
               {
                $data_status[$ident_exe][0]=$GLOBALS["timeGlobal"];
                $data_status[$ident_exe][1]++;
               }
            
            $mas_ident[]=$ident_exe;
            if (!$on_next) $mas_ident=array();
            
            self::save_ini($ident_exe,$mas_ident,$data_status);
            
           }
         
        }
      
      return (array($ident_exe,$one_data_init,$on_next));
     }
   
   static public function get_info_clock($v)
     {
      $info=array("hour"=>0,"minute"=>0,"allmin"=>0);
      
      if ($v)
        {
         $mas=explode(":",(string)$v);
         if (sizeof($mas)==1)
           $info["hour"]=(int)$mas[0];
          elseif (sizeof($mas)==2)
            {
             $info["hour"]=(int)$mas[0];
             $info["minute"]=(int)$mas[1];
            }
         
         $info["allmin"]=((int)$info["hour"]) * 60 + (int)$info["minute"];
        }
      
      return ($info);
     }
   
   static public function sort_order($a,$b)
     {
      if ( $a[4] == $b[4] ) return (0);
      return ( ($a[4] > $b[4]) ? +1 : -1 );
     }
   
  }



function set_data_capcha($name_key_session,$reset = true)
  {
   $value_session = false;
   $question = "";
   $answer = "";
   
   global $mas_data_kapcha;
   
   if ( isset($_SESSION[$name_key_session]) && $_SESSION[$name_key_session] >= 0 )
     {
      $value_session = $_SESSION[$name_key_session];
     }
   
   
   if ( $value_session === false || $value_session < 0 || $reset )
     {
      
      //srand ((float) microtime() * 10000000);
      $mas_keys = array_rand( $mas_data_kapcha, 2 );
      //write_log_cms($mas_keys,"mas keys");
      
      if (sizeof($mas_keys) == 2)
        {
          $new_value = $mas_keys[0];
          
          if ($reset && $value_session == $new_value)
            {
              // Если нужно заменить вопрос (reset -> true),
              // то проверяем, чтобы не совпадал с текущим вопросом
              
              $new_value = $mas_keys[1];
            }
          
          $value_session = $new_value;
        }
       else
         {
           // На всякий случай оставляем выборку одного элемента
           $value_session = array_rand($mas_data_kapcha, 1);
         }
      
      $_SESSION[$name_key_session] = $value_session;
      
      $question = $mas_data_kapcha[$value_session][0];
      $answer = $mas_data_kapcha[$value_session][1];
      
     }
    else
      {
       $question = $mas_data_kapcha[$value_session][0];
       $answer = $mas_data_kapcha[$value_session][1];
      }
   
   
   return ( array($value_session, $question, $answer) );
  }


function clear_data_capcha($name_key_session)
  {
   
   $_SESSION[$name_key_session] = -1;
   
  }

function check_data_capcha($name_key_session,$user_answer)
  {
   $checked = false;
   
   $value_session = false;
   global $mas_data_kapcha;
   
   if ( isset($_SESSION[$name_key_session]) && $_SESSION[$name_key_session] >= 0 )
     {
      $value_session = $_SESSION[$name_key_session];
     }
   
   if ( $value_session !== false && $value_session >= 0 )
     {
      if ( mb_strtolower(trim($user_answer)) == mb_strtolower( trim($mas_data_kapcha[$value_session][1]) ) )
        $checked = true;
     }
   
   return ( $checked );
  }



class forming_js_param_stg
  {
   
   static public function get_code($mas_name=false)
     {
      global $masConfig,$mas_name_param_stg;
      
      $t="";
      
      if (!$mas_name && !empty($mas_name_param_stg) && is_array($mas_name_param_stg) && sizeof($mas_name_param_stg))
        $mas_name=$mas_name_param_stg;
      
      if ($mas_name)
        {
         foreach ($mas_name as $one_name)
           {
            if (isset($masConfig[$one_name]))
              {
               $t.='mas_stg_admin["'. mb_strtolower($one_name).'"]=';
               $v=$masConfig[$one_name];
               if (is_string($v))
                 $t.="'".$v."'";
                elseif (is_int($v) || is_float($v))
                  $t.=$v;
                elseif ($v === false || $v === true)
                  $t.=($v?"true":"false");
               $t.=";\n";
              }
           }
        }
      
      return ($t);
     }
   
  }


class engine_cfg_tpl
{
  protected $all_set_bk=[];
  protected $on_get_all_set_bk=false;
  
  protected function get_all_set_bk_tpl()
    {
      if ($this->on_get_all_set_bk) return (true);
      $this->on_get_all_set_bk=true;
      
      global $dir_template;
      
      //получение из файла массива с настройками блоков
      $file_set = $dir_template."/configs/set_bk_tpl.php";
      $this->all_set_bk=[];
      
      if ($file_set && is_file($file_set))
        {
          include($file_set);
          if (!empty($all_set_bk_tpl)) $this->all_set_bk=$all_set_bk_tpl;
        }
      
      return (true);
    }
  
  public function init_data_modul($name_modul)
    {
      global $main_cfg_tpl,$main_index_cfg_tpl;
      
      if (!isset($main_cfg_tpl[$name_modul]))
        {
          $cfg_modul=$this->get_one_cfg_modul($name_modul);
          $comb_modul=$this->make_combined_data($name_modul,$cfg_modul);
          //$main_cfg_tpl[$name_modul]=$cfg_modul;
          $main_cfg_tpl[$name_modul]=$comb_modul;
          
          $index=array("list_part"=>array());
          
          foreach ($comb_modul as $name_bk => $one_set)
            {
              $index["list_part"][]=$one_set[0];
            }
          
          $main_index_cfg_tpl[$name_modul]=$index;
          
        }
      //write_log_cms($main_index_cfg_tpl);
      
      return (true);
    }
  
  protected function make_combined_data($name_modul,$cfg_modul)
    {
      $data_comb=[];
      $this->get_all_set_bk_tpl();
      
      $mas_set=false;
      
      if (!empty($this->all_set_bk[$name_modul]))
        {
          $mas_set=$this->all_set_bk[$name_modul];
        }
      
      foreach ($cfg_modul as $name_bk => $data_init)
        {
          $one_comb=[$data_init[0],$data_init[1],"[all]","[]",$data_init[4],$data_init[5]];
          
          if ($data_init[2] != false) $one_comb[2]=$data_init[2];
          if ($data_init[3] != false) $one_comb[3]=$data_init[3];
          
          if ($mas_set && !empty($mas_set[$name_bk]))
            {
              $one_bk_set=$mas_set[$name_bk];
              $one_comb[0]=$one_bk_set[0];
              $one_comb[1]=intval($one_bk_set[1]);
              $one_comb[2]=$one_bk_set[2];
              $one_comb[3]=$one_bk_set[3];
              if (!$one_bk_set[4]) $one_comb[4] = false;
            }
          
          if ($one_comb[4])
            $data_comb[$name_bk]=$one_comb;
        }
      
      return ($data_comb);
    }
  
  public function get_list_part_modul($name_modul)
    {
      //перед вызовом этой функции нужно вызвать init_data_modul();
      //метод вернет массив, который будет содержать имена областей, в которых модуль выводит дополнительное содержимое
      
      $list_part=array();
      
      global $main_index_cfg_tpl;
      
      if (isset($main_index_cfg_tpl[$name_modul])) $list_part=$main_index_cfg_tpl[$name_modul]["list_part"];
      
      return ($list_part);
    }
  
  public function get_one_cfg_modul($name_modul)
    {
      // $name_modul - mainModul (главный модуль) или имя модуля
      // возвращает $cfg_modul заданного модуля или пустой массив, если файл или переменная не найдена
      
      global $dir_template, $main_cfg_tpl;
      
      $mas=array();
      $file="";
      
      if ($name_modul == "mainModul")
        $file = $dir_template."/cfg_tpl_main.php";
       elseif ($name_modul)
         $file = $dir_template."/moduls/".$name_modul."/cfg_tpl_modul.php";
      
      if ($file && is_file($file))
        {
          include($file);
        }
      
      if (isset($part_init_bk_tpl)) $mas=$part_init_bk_tpl;
      
      return ($mas);
    }
  
  public function check_part($name_modul,$name_part)
    {
      //возвращает массив $mas_check=array("имя_блока"=>позиция_блока);
      //или false
      
      global $main_cfg_tpl,$main_index_cfg_tpl;
      $mas_check=array();
      
      if (!isset($main_cfg_tpl[$name_modul]))
        {
          $this->init_data_modul($name_modul);
        }
      
      if (!in_array($name_part,$main_index_cfg_tpl[$name_modul]["list_part"]))
        {
          //в индексном массиве не найдена указанная область $name_part, поэтому упрощаем действия - возвращаем false
          return (false);
        }
      
      $all_not=true;
      
      foreach ($main_cfg_tpl[$name_modul] as $name_bk => $one_cfg)
        {
          $value=false;
          $not=false;
          
          if ($one_cfg[0] == $name_part)
            {
              if (!empty($one_cfg[3]))
                {
                  if ($this->check_page($name_modul, $name_part, $one_cfg[3]))
                    {
                      $not=true;
                    }
                }
              
              if (!$not)
                {
                  if (!empty($one_cfg[2]))
                    {
                      if ($this->check_page($name_modul, $name_part, $one_cfg[2]))
                        {
                          $value = $one_cfg[1];
                        }
                    }
                  else
                    {
                      $value = $one_cfg[1];
                    }
                }
              
              if ($value !== false) $all_not=false;
            }
          
          $mas_check[$name_bk]=$value;
        }
      
      return ($all_not ? false : $mas_check);
    }
  
  protected function check_page($name_modul,$name_part,$set_page)
    {
      $on=false;
      
      global $dsOpenModul,$dsOpenKeyComponent,$dsOpenNsrlModul,$dsOpenNsrlKeyComponent;
      //write_log_cms( array( $dsOpenModul,$dsOpenKeyComponent,$dsOpenNsrlModul,$dsOpenNsrlKeyComponent), "Данные страницы" );
      
      //$openModul=$dsOpenModul;
      //$openKeyComponent=$dsOpenKeyComponent;
      $openModul=$dsOpenNsrlModul;
      $openNComponent=$dsOpenNsrlKeyComponent;
      
      if ($set_page === "[]")
        {
          $on=false;
        }
       elseif ($set_page === "[all]")
         {
           $on=true;
         }
       else
         {
           $rv="#\\[".$openModul."\\]".($openNComponent > 0 ? "|\\[".$openModul."-".$openNComponent."\\]" : "")."#";
           if (preg_match($rv,$set_page) == 1) $on=true;
         }
      
      return ($on);
    }
  
}



class engine_parts_tpl_desc
{
  
  public static function get_list_parts()
    {
      global $dir_template;
      
      $mas=array();
      
      $file = $dir_template."/cfg_tpl_main.php";
      
      if ($file && is_file($file))
        {
          include($file);
        }
      
      if (isset($cfg_parts_desc)) $mas=$cfg_parts_desc;
      
      return ($mas);
    }
}


//пример использования следующей функции
//$url_http = "http://".$_SERVER["SERVER_NAME"].set_dir_from_path($_SERVER["SCRIPT_NAME"],2);
function set_dir_from_path($path_file,$num_up_path = 0)
  {
    $dir = str_replace("\\", "/", dirname($path_file));
    $on_dir = false;
    
    if ($num_up_path === false)
      {
        $current_file = str_replace("\\", "/", __FILE__);
        $doc_root = str_replace("\\", "/", get_value_params_server("DOCUMENT_ROOT"));
        
        if ($doc_root && mb_strpos($current_file, $doc_root, 0) === 0)
          {
            $len_doc = mb_strlen($doc_root);
            $len_cur = mb_strlen($current_file);
            $part1 = mb_substr($current_file, $len_doc, $len_cur - $len_doc);
            
            if (mb_strpos($part1, "/", 0) !== 0) $part1 = "/".$part1;
            
            $part1 = dirname(dirname($part1));
            
            if (mb_strpos($dir, $part1, 0) === 0)
              {
                $dir = $part1;
                $on_dir = true;
              }
          }
      }
    
    if (!$on_dir && ($num_up_path > 0 || $num_up_path === false))
      {
        if ($num_up_path === false) $num_up_path = 1;
        
        for ($i = 0; $i < $num_up_path; $i++)
          {
            $dir = dirname($dir);
          }
      }
    
    $dir = str_replace("\\", "/", $dir);
    
    if ($dir == "/" || $dir == "\\" || $dir == ".") $dir = "";
    
    return ($dir);
  }



class eng_promote_safety
{
  
  public static function get_code($num_user)
    {
      $v="";
      
      $v_secret=self::get_secret();
      $v_salt=self::forming_salt();
      //$v=md5($v_salt. ":". $v_secret. ":". $num_user). ":". $v_salt;
      $v=self::forming_hash($num_user,$v_secret,$v_salt) .":". $v_salt;
      
      return ($v);
    }
  
  public static function check_code_post($num_user,$name_pole)
    {
      //данные проверочного кода должны быть в $_POST[$name_pole]
      
      $v="";
      $on_check=false;
      
      if (($_POST[$name_pole] ?? false) && is_string($_POST[$name_pole]))
        $v=$_POST[$name_pole];
      
      if ($v)
        $on_check=self::check_code($num_user, $v);
      
      return ($on_check);
    }
  
  public static function check_code($num_user,$code)
    {
      $on_check=false;
      
      if ($code != "")
        {
          $v_secret=self::get_secret();
          $m=explode(":",$code);
          
          if (sizeof($m) == 2)
            {
              $v_salt=$m[1];
              $hash=self::forming_hash($num_user,$v_secret,$v_salt);
              if ($m[0] === $hash)
                {
                  $on_check=true;
                }
            }
          
        }
      
      return ($on_check);
    }
  
  public static function admin_check_code($type_answer)
    {
      $on_control=false;
      $control_code="";
      
      if (!empty($_POST["contr_code"]))
        {
          $control_code=$_POST["contr_code"];
        }
      
      if ($control_code)
        {
          if ( self::check_code($GLOBALS["num_user"],$control_code) )
            {
              $on_control=true;
            }
        }
      
      if (!$on_control)
        {
          //Если контрольный код неверный, то выводим ответ
          self::answer_admin_contr($type_answer);
        }
      
      return (true);
    }
  
  protected static function get_secret()
    {
      $v="";
      
      if (!empty($_SESSION["secret_code"]))
        {
          $v=$_SESSION["secret_code"];
        }
       else
         {
           $n = md5(rand(1111111,9999999));
           $v=mb_substr($n,5,10);
           $_SESSION["secret_code"]=$v;
           
         }
      
      return ($v);
    }
  
  protected static function forming_hash($num_user,$v_secret,$v_salt)
    {
      if (!($num_user && $num_user > 0)) $num_user="0";
      
      $hash=md5($v_salt. ":". $v_secret. ":". $num_user);
      
      return ($hash);
    }
  
  protected static function forming_salt()
    {
      return (time());
    }
  
  protected static function answer_admin_contr($type_answer)
    {
      $text_error="Неверный ключ безопасности!";
      
      if ($type_answer == "ajax")
        {
          echo ("{ error:{code:1,text:'".$text_error."'} }");
        }
       elseif ($type_answer == "iframe")
         {
           write_js_iframe_answer(1,$text_error,false);
         }
       else
         {
           echo($text_error);
         }
      
      exit();
    }
}


function syst_setcookie($name,$value,$opts=[])
  {
    //expires, path, domain, secure, httponly и samesite
    $set_opts=array();
    
    $set_opts["expires"]=$opts["expires"] ?? 0;
    $set_opts["path"]=$opts["path"] ?? "/";
    if (isset($opts["domain"]))
      $set_opts["domain"]=$opts["domain"];
    $set_opts["secure"]=$opts["secure"] ?? false;
    $set_opts["httponly"]=$opts["httponly"] ?? true;
    $set_opts["samesite"]=$opts["samesite"] ?? "Lax";
    
    return ( setcookie($name,$value,$set_opts) );
  }



class eng_edit_links_profile
{
  
  public static function one_link_set_use($name_modul,$ident_link,$v_use)
    {
      global $mas_init_links_profile;
      
      if (!empty($mas_init_links_profile[$name_modul]))
        {
          $d_search=search_mas_2level($mas_init_links_profile[$name_modul],0,$ident_link,false);
          if ($d_search[0]) $mas_init_links_profile[$name_modul][$d_search[1]][2]=$v_use;
        }
      
      return (true);
    }
}


class eng_ident_visitor_user
{
  protected static $_name_cookie = "prm_usr";
  
  public static function set_main_ident()
    {
      global $ident_visitor_user;
      
      $mas_v_cookie = self::_get_cookie();
      
      if ($mas_v_cookie[0])
        {
          $ident_visitor_user=$mas_v_cookie[0];
          if ($GLOBALS["timeGlobal"] - $mas_v_cookie[1] >= 1*24*3600)
            {
              self::_set_cookie($ident_visitor_user);
            }
        }
      else
        {
          $ident_visitor_user=self::_generate_cookie();
        }
      
      return (true);
    }
  
  public static function _generate_cookie()
    {
      
      $v_ident=self::_generate_ident();
      
      self::_set_cookie($v_ident);
      
      return ($v_ident);
    }
  
  protected static function _get_cookie()
    {
      $v_ident="";
      $v_time=0;
      
      $v_cookie = $_COOKIE[self::$_name_cookie] ?? "";
      //write_log_cms($v_cookie,"v cookie identify");
      
      if ($v_cookie)
        {
          $mas_d=explode(":",$v_cookie);
          if (sizeof($mas_d) == 2 && $mas_d[0] && $mas_d[1] && preg_match("/^[a-zA-Z0-9]+$/",$mas_d[0]) === 1 && is_numeric($mas_d[1]))
            {
              $v_ident=$mas_d[0];
              $v_time=$mas_d[1];
            }
        }
      
      return ([$v_ident,$v_time]);
    }
  
  protected static function _set_cookie($v_ident)
    {
      syst_setcookie(self::$_name_cookie,$v_ident . ":" . $GLOBALS["timeGlobal"],["expires"=>time() + 100*24*3600]);
    }
  
  protected static function _generate_ident()
    {
      $v_ident=md5("afgB178" . time() . mt_rand(10000,99999999).mt_rand(10000,99999999).mt_rand(10000,99999999) ."kKmN77b". mt_rand(10000,99999999).mt_rand(10000,99999999) );
      
      $v_ident=base_convert($v_ident,16,36);
      //write_log_cms($v_ident,"число в 36");
      
      return ($v_ident);
    }
  
}



function get_type_user_referer()
  {
    // Функция определяет откуда пришел посетитель
    // Функция вернет массив [тип referer, адрес referer]
    // Тип referer:
    // false,
    // current - текущий сайт, то есть пользователь перешел с одной страницы сайта на другую,
    // cross - пользователь перешел с другого сайта
    
    global $site_http_referer, $domen_site, $dir_http;
    
    //write_log_cms($site_http_referer,"site http referer");
    //write_log_cms($domen_site,"domen site url");
    
    $type_referer = false;
    $v_referer = "";
    
    $domen_site_clear=get_domen_from_url($domen_site,true);
    //write_log_cms($domen_site_clear,"domen site clear");
    
    if ( $site_http_referer )//Если есть referer
      {
        $v_referer = $site_http_referer;
        
        if (preg_match("#^(https?)(://)(www\.)?(.*)$#i", $v_referer, $matches))
          {
            //write_log_cms($matches, "parse referer");
            if ($matches[4] && (stripos($matches[4], $domen_site_clear.$dir_http) === 0))
              {
                $type_referer = "current";
              }
            else
              {
                $type_referer = "cross";
              }
          }
        
      }
    
    return ( $type_referer );
  }


function check_spam_referer()
  {
    global $site_http_referer, $gl_spam_referer;
    $on_spam=false;
    
    if ($site_http_referer)
      {
        
        $v_referer = $site_http_referer;
        //write_log_cms($v_referer, "http referer");
        /*
        $_v_utf8=idn_to_utf8($v_referer);
        write_log_cms($_v_utf8, "domen in utf8");
        if ($_v_utf8) $v_referer=$_v_utf8;
        */
        
        $v_referer = mb_strtolower($v_referer);
        
        foreach ($gl_spam_referer as $one_v)
          {
            if (strpos($v_referer, $one_v) !== false)
              {
                $on_spam = true;
                break;
              }
          }
        //write_log_cms($on_spam, "on spam referer");
      }
    
    return ($on_spam);
  }


function generate_id_process_cms()
  {
    
    $v_ident=md5("n7G4Mvx" . time() . mt_rand(10000,99999999).mt_rand(10000,99999999).mt_rand(10000,99999999) ."z8HJkr4v". mt_rand(10000,99999999).mt_rand(10000,99999999) );
    
    $v_ident=base_convert($v_ident,16,36);
    
    return ($v_ident);
  }


class eng_pause_work_cms
{
  static protected $name_file="stgs_pause_cms";
  
  static public function check_pause($name="")
    {
      $on_pause=false;
      
      $data=self::_get_data();
      if ($data && is_array($data))
        {
          foreach ($data as $one_name => $one_item)
            {
              if ($one_item[0] == 1 && (!$name || $name && $name == $one_name))
                {
                  $on_pause=true;
                  break;
                }
            }
        }
      
      return ($on_pause);
    }
  
  static public function add_one($name)
    {
      $data=self::_get_data();
      if (!in_array($name,$data))
        {
          $data[$name]=[1];
          
          self::_save_data($data);
        }
      
      return (true);
    }
  
  static public function clear_one($name)
    {
      $data=self::_get_data();
      if (!in_array($name,$data))
        {
          $data[$name]=[0];
          //unset($data[$name]);
          self::_save_data($data);
        }
      
      return (true);
    }
  
  static public function oper_one($name, $oper)
    {
      global $ident_process_cms;
      
      if ($oper == "add")
        {
          self::add_one($name);
        }
      elseif ($oper == "clear")
        {
          self::clear_one($name);
        }
      elseif ($oper == "check")
        {
          $on_pause = self::check_pause($name);
          //write_log_cms($on_pause, $name.":on_pause:".$ident_process_cms);
          if ($on_pause)
            {
              $n=0;
              do {
                sleep(6);
                $n++;
                $on_pause = self::check_pause($name);
                //write_log_cms($on_pause, $name.":on_pause_2:".$ident_process_cms);
              }
              while ( $on_pause && $n < 50 );
            }
        }
    }
  
  static protected function _get_data()
    {
      $data=[];
      
      $_d=loadNameConfig(self::$name_file);
      //write_log_cms($_d,"get all data pause init");
      if ($_d && is_array($_d))
        {
          foreach ($_d as $name => $item)
            {
              $data[$name]=unserialize($item);
            }
        }
      //write_log_cms($data,"get all data pause");
      return ($data);
    }
  
  static protected function _save_data($data)
    {
      //write_log_cms($data,"save all data pause");
      $save_data=[];
      
      foreach ($data as $name => $one_item)
        {
          $save_data[$name]=serialize($one_item);
        }
      
      saveNameConfig(self::$name_file,$save_data);
      
      return (true);
    }
  
}

