<?php


function control_input_data($name_data,$type_method,$type_data,$only_set,$only_value,$check_type=false,$check_value=false,$set_default=false,$value_default="")
  {
   //$type_method - тип метода полученной переменной (get или post)
   //$name_data - имя переменной
   //$type_data - тип данных : число - numeric, текст - text
   //$only_set - обязательно ли должна быть объявлена переменная или нет - true или false
   //$only_value - обязательно ли должно быть присвоено значение (не равно пустой строке или 0) или нет - true или false
   //$check_type  -нужна ли проверка на определенное значение (если значение задано и отлично от '' и 0): 
   //  если не нужно то false,
   //  если нужно то параметр должен принимать значение value,
   //  если одно из значений, то - listv, 
   //  если должно удовлетворять шаблону регулярного выражения 
   //  (для текстового значения), то - hablonrv",
   //$check_value - "зависит от предыдущего значения. если предыдущее значение равно:
   //  false - то этот параметр не имеет ни какого значения и должен равняться пустой строке,
   //  value - то этот параметр должен содержать, то значение, которое должна иметь переменная,
   //  listv - то этот параметр должен содержать список возможных значений указанных через запятую, которые может содержать переменная,
   //  hablonrv - то этот параметр должен содержать регулярное выражение, которому должно соответствовать значение переменной
   
   $set_data=false;
   $value_data=false;
   $is_value=false;
   $error_data=false;
   
   if ($type_method == "get")
     {
      if (isset($_GET[$name_data]))
        {
         $set_data=true;
         $value_data=$_GET[$name_data];
        }
     }
    elseif ($type_method == "post")
      {
       if (isset($_POST[$name_data]))
         {
          $set_data=true;
          $value_data=$_POST[$name_data];
         }
      }
   
   if ( $set_data && !empty($value_data) )
     {
      $is_value=true;
      
     }
   
   if ($only_set && !$set_data)
     $error_data=true;
   
   if (!$error_data && $only_value && !$is_value )
     $error_data=true;
   
   
   if (!$error_data && $is_value )
     {
      
      switch ($type_data)
        {
         case ("numeric"):
           if (!is_numeric($value_data))
             {
              $error_data=true;
             }
         break;
         case ("text"):
         
         break;
        }
      
     }
   
   if (!$error_data && $is_value)
     {
      if ($check_type)
        {
         //значение переменной должно удовлетворять неким условиям
         switch ($check_type)
           {
            case ("value"): //переменная должно быть строго одному заданному значению
              if ($value_data != $check_value)
                $error_data=true;//переменная не равна нужному значению
              break;
            
            case ("listv"):// переменная должна быть равна одному из перечисленных значений
              $mas_d_value=explode(",",$check_value);
              if (!in_array($value_data,$mas_d_value))
                $error_data=true;
              break;
            
            case ("hablonrv"):// значение переменной должно соответствовать регулярному выражению
              if (!preg_match($check_value,$value_data))
                $error_data=true;
              break;
           }
        }
     }
   
   if ((!$is_value || $error_data ) && $set_default)
     {
      
      switch ($set_default)
        {
         case("all"):
           $value_data=$value_default;break;
         case("error"):
           if ($error_data)
             $value_data=$value_default;
           break;
         case("not_value"):
           if (!$is_value)
             $value_data=$value_default;
           break;
        }
      
      
     }
   
   
   return (array("set_data"=>$set_data,"value"=>$value_data,"set_value"=>$is_value,"error"=>$error_data));
  }


function value_control_input_data($name_data,$type_method,$type_data,$only_set,$only_value,$check_type=false,$check_value=false,$set_default=false,$value_default="")
  {
   $rez=control_input_data($name_data,$type_method,$type_data,$only_set,$only_value,$check_type,$check_value,$set_default,$value_default);
   
   return ($rez["value"]);
  }



