<?php


class msender
  {
   
   private $id_send=0;
   private $size_contacts=0;
   
   private $quantity_cycle=10;
   private $time_pause=5;
   
   
   function __construct()
     {
      global $masConfig;
      $this->quantity_cycle=$masConfig["QUANTITY_MAS_SEND_EMAIL"];
      $this->time_pause=$masConfig["TIME_PAUSE_MAS_SEND_EMAIL"];
      
     }
   
   public function create_msender($type_create,$mas_data,$modul)
     {
      $id_msender=0;
      $contr_code="";
      if ($type_create == "new")
        {
         $mas_data["put_date"]=$GLOBALS["timeGlobal"];
         $mas_data["sent_date"]=0;
         $mas_data["last_date"]=$GLOBALS["timeGlobal"];
         if (empty($mas_data["status"])) $mas_data["status"]="new";
         if (empty($mas_data["mode"])) $mas_data["mode"]="auto";
         if (!isset($mas_data["perem"])) $mas_data["perem"]="";
         $mas_data["modul"]=$modul;
         if (!isset($mas_data["ident"])) $mas_data["ident"]=0;
         $contr_code=substr(md5(time()."KL_tRem7sqw"),5,12);
         $mas_data["contr_code"]=$contr_code;
        }
      
      $db_query=forming_db_query_indexmas(DB_PREF."msender",$mas_data,$type_create,"id_msender");
      
      db_work::query($db_query);
      
      if ($type_create == "new")
        $id_msender=db_work::get_insert_id();
       else
         $id_msender=$mas_data["id_msender"];
      
      return (array($id_msender,$contr_code));
     }
   /*
   public function get_list_msender($page,$kolvo,$filter)
     {
      $q_where="";
      if ($filter=="none" || $filter=="on")
        {
         if ($filter=="none")
           $q_where=" where status='new' ";
          else
            $q_where=" where status='sent' ";
         
        }
      $db_query="select count(*) from ".DB_PREF."msender ".$q_where;
      
      $kol_vsego = db_work::query_count($db_query);
      
      $data=" vsego_msender:".$kol_vsego."";
      
      
      $db_query="select * from ".DB_PREF."msender ".$q_where." order by id_msender DESC limit ".(($page-1)*$kolvo).",".$kolvo." ";
      list($kolvo,$data_msender) = db_work::query_select_assoc($db_query);
      
      $data.=", d_msender:[";
      $data.=encode_gen_mas_to_jointext($data_msender,false,true,"numeric",false);
      $data.=" ] ";
      
      return ($data);
     }
   */
   public function operListMsender($list_num)
     {
      $db_query="delete from ".DB_PREF."msender where id_msender IN (".$list_num.") ";
      
      db_work::query($db_query);
      
      return (true);
     }
   
   public function get_one_msender($id_msender)
     {
      
      $db_query="select * from ".DB_PREF."msender where id_msender=".$id_msender;
      list($kolvo,$one_data)=db_work::query_select_one_assoc($db_query);
      
      return ($kolvo > 0 ? $one_data:false);
     }
   
   public function check_active_msender()
     {
      
      $db_query="select count(*) from ".DB_PREF."msender where status='active' ";
      $kolvo=db_work::query_count($db_query);
      
      return ($kolvo);
     }
   
   public function set_value_status_msender($num,$v_status)
     {
      $db_query="update ".DB_PREF."msender set status='".$v_status."',last_date=". time_cms() ." where id_msender = ".$num." ";
      //write_log_cms($db_query);
      db_work::query($db_query);
      
      return(true);
     }
   
   public function set_end_work_msender($id_msender)
     {
      
      $db_query="update ".DB_PREF."msender set "
       ." sent_date=".time_cms().", "
       ." status='sent' where id_msender=".$id_msender." ";
      
      db_work::query($db_query);
      
      return (true);
     }
   
   public function add_mas_contacts($id_msender,$data_contacts,$init_key)
     {
      
      $db_query="insert ".DB_PREF."msender_contacts (id_contact,name,email,num_msender,status,perem) values ";
      $list_values="";
      $sep="";
      foreach ($data_contacts as $one_contact)
        {
         $perem="";
         if (!empty($one_contact["perem"])) $perem=serialize($one_contact["perem"]);
         $list_values.=$sep."(0,'".codeText($one_contact[$init_key["kname"]])."','".codeText($one_contact[$init_key["kemail"]])."',"
           .$id_msender.",'new','".codeText($perem)."')";
         $sep=",\n";
        }
      
      if ($list_values)
        {
         $db_query.=$list_values;
         db_work::query($db_query);
         //write_log_cms($db_query,"add mas contacts");
        }
      
      return (true);
     }
   
   private function check_incoming_data()
     {
      $id_msender=0;
      $contr_code="";
      
      if (!empty($_GET["idsend"]) && is_numeric($_GET["idsend"]))
        {
         $id_msender=$_GET["idsend"];
        }
       
       if (!empty($_GET["contr_code_ms"]) && is_string($_GET["contr_code_ms"]))
        {
         $contr_code=$_GET["contr_code_ms"];
        }
      
      return (array($id_msender,$contr_code));
     }
   
   private function get_size_contacts($id_msender)
     {
      $db_query="select count(*) from ".DB_PREF."msender_contacts where num_msender = ".$id_msender ." and status ='new' ";
      $kolvo=db_work::query_count($db_query);
      
      return ($kolvo);
     }
   
   private function get_part_contacts($id_msender,$num_part)
     {
      
      $db_query="select * from ".DB_PREF."msender_contacts where num_msender = ".$id_msender." and status='new' "
       ." order by id_contact limit ".$this->quantity_cycle." ";
      
      list($kolvo,$data_contacts)=db_work::query_select_assoc($db_query);
      
      return (array($kolvo,$data_contacts));
     }
   
   private function set_status_contacts($id_msender,$mas_id,$v_status)
     {
      $db_query="update ".DB_PREF."msender_contacts set status = '".$v_status."' where id_contact IN (".implode(",",$mas_id).") "
       ." and num_msender=".$id_msender;
      db_work::query($db_query);
      
      return (true);
     }
   
   private function send_part_contacts($one_msender,$data_contacts)
     {
      
      list($error,$error_text,$mas_id_sent,$mas_id_error)=send_mail::send_list_mails($one_msender,$data_contacts);
      
      //write_log_cms($error,"ошибка при отправке рассылки");
      //write_log_cms($mas_id_sent,"id успешно отправленных");
      //write_log_cms($mas_id_error,"id не отправленных, с ошибкой");
      
      return (array($error,$error_text,$mas_id_sent,$mas_id_error));
     }
   
   private function set_status_send($one_msender,$number_sent,$error=false)
     {
      global $obj_site;
      $this->set_value_status_msender($one_msender["id_msender"],$error?"error":"onsend");
      
      if ($one_msender["modul"] == "subscribe")
        {
         $obj_modul=$obj_site->getObjModul($one_msender["modul"]);
         if ($obj_modul) $obj_modul->set_status_send_news($one_msender["ident"],$error?false:true,$number_sent);
        }
      
      return (true);
     }
   
   private function delete_data($id_msender)
     {
      $db_query="delete from ".DB_PREF."msender where id_msender=".$id_msender;
      db_work::query($db_query);
      $db_query="delete from ".DB_PREF."msender_contacts where num_msender=".$id_msender;
      db_work::query($db_query);
      
      return (true);
     }
   
   private function send_one_msender($id_msender,$one_msender)
     {
      $this->size_contacts=$this->get_size_contacts($id_msender);
      $error=0;
      $error_text="";
      //if ($this->size_contacts == 0) return (false);
      $number_sent=0;
      
      if ($this->size_contacts > 0)
        {
         set_time_limit(0);//запускаем скрипт навсегда
         
         $kolvo_part=ceil($this->size_contacts/$this->quantity_cycle);
         
         //$this->set_value_status_msender($one_msender["id_msender"],"active");
         
         for ($i=0; $i<$kolvo_part; $i++)
           {
            $this->set_value_status_msender($one_msender["id_msender"],"active");
            
            list($kolvo_contacts,$data_contacts)=$this->get_part_contacts($id_msender,$i);
            if ($kolvo_contacts > 0)
              {
                list($error,$error_text,$mas_id_sent,$mas_id_error)=$this->send_part_contacts($one_msender, $data_contacts);
                $number_sent+=sizeof($mas_id_sent);
                
                if ($error == 0)
                  {
                    $mas_id = select_mas1lev_2level($data_contacts, "id_contact");
                    
                    $this->set_status_contacts($id_msender, $mas_id, "sent");
                    sleep($this->time_pause);
                  }
                 else
                   {
                     //$error=1;
                     //$error_text="Ошибка с отправкой писем";
                     break;
                   }
              }
             else
               {
                 $error=1;
                 $error_text="Ошибка с получением контактов подписчиков";
                 break;
               }
           }
         
        }
      
      $this->set_status_send($one_msender,$number_sent,$error);
      $this->delete_data($id_msender);
      
      if ($error == 0)
        {
          write_log_cms("Выполнена рассылка «".$one_msender["title"]."»; писем отправлено ".$number_sent, "Процесс рассылки писем");
        }
       else
         {
           write_log_cms($error_text . ($number_sent > 0 ?". Писем отправлено ".$number_sent:""),"Ошибка при отправке рассылки");
         }
      
      return (array($error,$error_text));
     }
   
   private function work_msender_manual()
     {
      //отправляем рассылку созданную в модуле Рассылка
      list($this->id_send,$contr_code)=$this->check_incoming_data();//получаем $_GET["idsend"] и $_GET["contr_code_ms"]
      
      $one_msender=$this->get_one_msender($this->id_send);
      
      if (!$one_msender) return (false);
      if ($one_msender["contr_code"] != $contr_code) return (false);
      if ($one_msender["status"] != "onload" || $one_msender["mode"] != "manual") return (false);
      
      $kolvo_active=$this->check_active_msender();
      if ($kolvo_active > 0) return (false);
      
      $this->send_one_msender($this->id_send,$one_msender);
      
      return (true);
     }
   
   public function action_work_manual()
     {
      $this->work_msender_manual();
      
      return (true);
     }
   
   private function work_msender_auto()
     {
      //отправляем рассылки созданные автоматически разными модулями (к примеру, модулем Доска объявлений - напоминание об завершении времени действия)
      $db_query="select * from ".DB_PREF."msender where mode='auto' and status='onload' order by id_msender ASC ";
      list($kolvo_msender,$data_msender)=db_work::query_select_assoc($db_query);
      
      foreach ($data_msender as $one_msender)
        {
         $this->send_one_msender($one_msender["id_msender"],$one_msender);
        }
      
      return (true);
     }
   
   public function clear_data_msender()
     {
      //проверям и удаляем рассылки, с которыми уже давно проводились какие-либо действия, то есть завершились с какой-либо ошибкой
      $status=0; 
      
      $mas_subscribe=array();
      
      $db_query="select * from ".DB_PREF."msender order by id_msender ASC ";
      list($kolvo_msender,$data_msender)=db_work::query_select_assoc($db_query);
      
      if ($kolvo_msender > 0)
        {
          $status=5;
          foreach ($data_msender as $one_msender)
            {
              $time = $one_msender["last_date"] > 0 ? $one_msender["last_date"] : $one_msender["put_date"];
              if (($GLOBALS["timeGlobal"] - $time) > 3 * 3600)
                {
                  $this->delete_data($one_msender["id_msender"]);
                  
                }
               else
                 {
                   $status=10;
                   if ($one_msender["modul"]=="subscribe")
                     {
                       $mas_subscribe[]=$one_msender["ident"];
                     }
                 }
            }
        }
      
      return (array($status,$mas_subscribe));
     }
   
   public function action_work_auto()
     {
      $this->clear_data_msender();
      $this->work_msender_auto();
      
      return (true);
     }
   
  }
