<?php



class classProcPartnerUser
  {
   
   public $percentage_partner = 10;//процент партнерских отчислений
   
   function __construct()
     {
      
     }
   
   public function generate_partner_key_user( $num_user )
     {
      $error = 0;
      $error_text = "";
      
      $db_query = "select * from ".DB_PREF."users where id_user = ".$num_user;
      list($kolvo,$data_user) = obr_db_query_select_one_assoc( $db_query );
      
      if ( $kolvo )
        {
         if ( !trim( $data_user["partner_key"] ) )
           {
            
            $key = "";
            
            do
              {
               $key = $this->forming_key();
               
               $db_query = "select * from ".DB_PREF."users where partner_key = '".codeText($key)."'";
               list($kolvo_key,$data_user_key) = obr_db_query_select_one_assoc( $db_query );
              }
            while ( $kolvo_key > 0 );
            
            $db_query="update ".DB_PREF."users 
              set partner_key = '".codeText( $key )."' 
              where id_user = ".$num_user;
            
            $q_ident = obr_db_query( $db_query );
            
            //$error = 1;
            //$error_text = "код ".$key;
            
           }
          else
            {
             $error = 1;
             $error_text = "Партнерский код для указанного пользователя уже есть!";
            }
        }
       else
         {
          $error = 1;
          $error_text = "Пользователь не найден!";
         }
      
      return (array($error,$error_text));
     }
   
   
   public function forming_key()
     {
      $key = "";
      
      $key = md5( time() + mt_rand(100,100000) );
      $key = chr(97+rand(0, 25)).mb_substr($key,0,6).chr(65+rand(0, 25));
      $sim = array( "A", "E", "U", "B", "C", "D", "F", "G", "H", "J", "K", "M", "N", "P", "Q", "R", "S", "T", "V", "W", "X", "Z" );
      $n = array_rand( $sim );
      $key = $sim[$n].$key;
      $key = mb_strtoupper( $key );
      
      return ( $key );
     }
   
   public function check_partner_key( $check_key )
     {
      $data = false;
      
      $db_query = "select * from ".DB_PREF."users where on_partner = 'on' and partner_key = '".codeText($check_key)."'";
      list($kolvo_key,$data_user_key) = obr_db_query_select_one_assoc( $db_query );
      
      if ( $kolvo_key )
        {
         $data = $data_user_key;
         
         
        }
      
      return ( $data );
     }
   
   public function set_partner_invite_user( $num_user, $data_partner )
     {
      // $data_partner - содержит данные о партнере, который привлек пользователя $num_user
      
      if ( $num_user != $data_partner["id_user"] )
        {
         //партнет не может сам себя привлечь 
         
         $db_query="update ".DB_PREF."users 
             set partner_invite = ". $data_partner["id_user"] ." 
             where id_user = ".$num_user;
         
         $q_ident = obr_db_query( $db_query );
         
        }
      
     }
   
   
   public function check_user_invite_partner($num_user, $amount, $info_payment = false)
     {
      //$num_user - пользователь совершивший платеж
      //$amount - сумма платежа
      // функция проверит, пригласил ли данного пользователя ($num_user), какой-либо партнер. 
      // И если да, то перечисляем ему процент согласно партнерской программе.
      
      $db_query = "select * from ".DB_PREF."users where id_user = ".codeText($num_user)." ";
      list($kolvo_user,$data_user_payment) = obr_db_query_select_one_assoc( $db_query );
      
      if ( $kolvo_user && $data_user_payment["partner_invite"] > 0 )
        {
         
         $db_query = "select * from ".DB_PREF."users where on_partner = 'on' and id_user = '".codeText($data_user_payment["partner_invite"])."'";
         list($kolvo_partner,$data_user_partner) = obr_db_query_select_one_assoc( $db_query );
         
         if ( $kolvo_partner > 0 )
           {
            
            $sum_partner = $this->calculation_sum_partner( $amount );
            
            $this->additional_sum_partner($data_user_partner["id_user"], $sum_partner);
            
            if ( $info_payment !== false )
              {
               $info_payment["num_user"] = $data_user_partner["id_user"];
               $info_payment["cost"] = $sum_partner;
               $info_payment["type_oper"] = "addmoney";
               $info_payment["description"] = "Партнерские отчисления";
               $this->add_item_log( $info_payment );
              }
            
            if ( $data_user_partner["partner_get_message"] == "on" )
              {
               
               global $url_site,$masConfig;
               $subject = "Оповещение о зачислении средств на ваш партнерский счет";
               $message = 'Здравствуйте, '.$data_user_partner["name_user"].'!<br><br>'
                 //.'На вашем сайте '.$url_site.' оплачен заказ номер '.$payment_num_order.'. <br> '
                 .'Привлеченный Вами клиент оплатил заказ на сайте <a href="'.$url_site.'">'.$url_site.'</a>.<br> '
                 .'На Ваш партнерский счет зачислено партнерское вознаграждение в размере '.$sum_partner.' руб.<br>'
                 //.'Баланс партнерского счета теперь составляет: xxx руб.<br>'
                 .'Состояние Вашего партнерского счета Вы можете узнать в своем аккаунте на сайте <a href="'.$url_site.'">'.$url_site.'</a>.<br>'
                 .'<br><br>'
                 .'Администрация сайта '.$masConfig["URL_SITE_MAIN"].'.';
               
               
               @send_email($subject,$message,"",$data_user_partner["email_user"]);
               
              }
            
           }
         
        }
      
      
     }
   
   public function calculation_sum_partner( $amount )
     {
      return ( round(( $amount * $this->percentage_partner ) / 100 ) );
     }
   
   public function additional_sum_partner($num_partner, $sum_partner)
     {
      // начисляем партнерский процент партнеру
      // $num_partner - id партнера
      // $sum_partner - сумма которая должна быть начислена на счет партнеру
      
      $db_query="update ".DB_PREF."users 
          set partner_amount = partner_amount + ". $sum_partner ." 
          where id_user = ".$num_partner;
      
      $q_ident = obr_db_query( $db_query );
      
     }
   
   public function add_item_log($mas_data)
     {
      
      $mas_save = array( 
        "id_log_partner" => 0,
        "num_user" => 0,
        "description" => "",
        "cost" => 0,
        "putdate" => $GLOBALS["timeGlobal"],
        "type_oper" => "",
        "type_ps" => "" );
      
      // в массиве ключи
      // type_oper - тип операции:
      //  decrement - списание средст со счета (оплата услуг средствами с баланса пользователя на сайте),
      //  addmoney - пополнение средст на счете,
      //  paymentserv - оплата услуг на прямую,
      // type_ps - тип платежной системы:
      //  balance - баланс пользователя на счете
      //  webmoney, a1lite, и т.д.
      
      $keys = array( "num_user", "description", "cost", "putdate", "type_oper", "type_ps" );
      
      foreach ( $keys as $one_key )
        if ( isset( $mas_data[$one_key] ) ) $mas_save[$one_key] = $mas_data[$one_key];
      
      
      $db_query = forming_db_query_indexmas(DB_PREF."log_partner",$mas_save,"new","id_log_partner");
      $q_ident = db_work::query($db_query);
      
      return ( true );
     }
   
   public function operationBalancePartner($num_user, $amount, $oper_money)
     {
      $error = 0;
      $error_text = "";
      
      $t_description = "";
      $db_query = "";
      
      if ( $oper_money == "addmoney_panel" )
        {
         $db_query="update ".DB_PREF."users 
           set partner_amount = partner_amount + ".$amount." 
           where id_user = ".$num_user;
         $t_description = "Пополнение партнерского счета в панели управления";
        }
       elseif ( $oper_money == "decrmoney_panel" )
         {
          $db_query="update ".DB_PREF."users 
            set partner_amount = partner_amount - ".$amount." 
            where id_user = ".$num_user;
          $t_description = "Списание средств с партнерского счета в панели управления";
         }
       elseif ( $oper_money == "setmoney_panel" )
         {
          $db_query="update ".DB_PREF."users 
            set partner_amount =  ".$amount." 
            where id_user = ".$num_user;
          $t_description = "Формирование баланса партнерского счета в панели управления";
         }
      
      
      if ( $db_query )
        {
         
         $q_ident = db_work::query($db_query);
         /*
         // добавляем в лог информацию
         $info_payment = array();
         $info_payment["num_user"] = $num_user;
         $info_payment["cost"] = $amount;
         $info_payment["type_oper"] = $oper_money;
         $info_payment["type_ps"] = "balance";
         $info_payment["description"] = $t_description;
         $this->add_item_log( $info_payment );
         */
        }
      
      return ( array($error, $error_text) );
     }
   
   public function select_list_log_partner($kol_page, $num_page, $filtr_num_user )
     {
      // извлекаем список ip адресов
      $data = array();
      $kolvo_vsego = 0;
      
      $query_search = "";
      $filtr_num_user = trim( $filtr_num_user );
      if (  $filtr_num_user || $filtr_num_user === "0" )
        {
         $query_search = " num_user IN (".codeText($filtr_num_user).") ";
         
        }
      
      if ( $query_search )
        $query_search = " where ".$query_search;
      
      $db_query="select count(*) from ".DB_PREF."log_partner ".$query_search." ";//"order by ip_adr DESC limit ".(($num_page - 1) * $kol_page).",".$kol_page;
      
      $kolvo_vsego = obr_db_query_count($db_query);
      if ( $kolvo_vsego > 0 )
        {
         $db_query="select * from ".DB_PREF."log_partner ".$query_search." order by id_log_partner DESC limit ".(($num_page - 1) * $kol_page).",".$kol_page;
         //echo($db_query);
         list($kolvo,$data)=obr_db_query_select_assoc($db_query);
        }
      
      return ( array( $kolvo_vsego, $data ) );
     }
   
   public function delete_list_num_log_partner( $list_num )
     {
      
      $db_query = "delete from ".DB_PREF."log_partner where id_log_partner IN (".$list_num.")";
      
      obr_db_query($db_query);
      
      return (true);
     }
   
   
  }






