<?php


class classProcPromocode
  {
   
   protected $on_user_site=false;//Авторизован или нет пользователь в пользовательской части сайта
   protected $num_user_site=0;//Номер (ID) пользователя авторизованного в пользовательской части сайта
   protected $data_auth_user_site=[];//Номер (ID) пользователя авторизованного в пользовательской части сайта
   protected $on_check_auth_user_site=false;
   
   function __construct()
     {
       
     }
   
   public function check_auth_user_site()
     {
       if ($this->on_check_auth_user_site) return (true);
       
       if ($GLOBALS["user_to_site"] && $GLOBALS["id_user_to_site"] > 0)
         {
           $this->num_user_site = $GLOBALS["id_user_to_site"];
           $this->data_auth_user_site = $GLOBALS["data_authorize_user"];
           $this->on_user_site = true;
         }
       
       $this->on_check_auth_user_site = true;
       return (true);
     }
   
   public function get_init_promocode()
     {
       global $mas_init_promocode,$mas_name_moduls_dynam_promocode,$obj_site;
       //$mas_all_init=array();
       $mas_all_init=$mas_init_promocode;
       
       foreach ($mas_name_moduls_dynam_promocode as $name_modul)
         {
           $mas=$obj_site->intercomLink($name_modul,"ext_init_promocode");
           if ($mas && sizeof($mas)) $mas_all_init=array_merge($mas_all_init,$mas);
         }
       
       return ($mas_all_init);
     }
  
   public function select_list_data($kol_elm_page,$num_page,$promocode,$num_user)
     {
      
      $data = array();
      $kolvo_vsego = 0;
      
      $query_search = "";
      $num_user = trim( $num_user );
      if (  $num_user || $num_user === "0" )
        {
         $query_search = " num_user IN (".codeText($num_user).") ";
        }
      
      if ($promocode)
        {
         $query_search=($query_search ?" and ":"")." promocode like '%".codeText($promocode)."%' ";
        }
      
      if ( $query_search )
        $query_search = " where ".$query_search;
      
      $db_query="select count(*) from ".DB_PREF."promocode ".$query_search." ";//"order by ip_adr DESC limit ".(($num_page - 1) * $kol_page).",".$kol_page;
      
      $kolvo_vsego = db_work::query_count($db_query);
      if ( $kolvo_vsego > 0 )
        {
         $db_query="select * from ".DB_PREF."promocode ".$query_search." order by id_promocode DESC limit ".(($num_page - 1) * $kol_elm_page).",".$kol_elm_page;
         //echo($db_query);
         list($kolvo,$data)=db_work::query_select_assoc($db_query);
        }
      
      return (array($kolvo_vsego,$data));
     }
   
   public function check_is_promocode($promocode,$type_create="",$id_promocode=0)
     {
      //проверяем, есть ли уже такой промокод
      $db_query="select count(*) from ".DB_PREF."promocode where promocode='".codeText($promocode)."'"
        .(($type_create && $type_create=="edit")? " and id_promocode!=".$id_promocode :"");
      $count=db_work::query_count($db_query);
      
      return ($count);
     }
   
   public function generate_promocode($n_sim)
     {
      //генерируем промокод
      $n_sim=($n_sim>0?$n_sim:mt_rand(7,15));
      
      $new=mt_rand(10000,99999999).mt_rand(10000,99999999).mt_rand(10000,99999999).mt_rand(10000,99999999).mt_rand(10000,99999999);
      $code=md5($new);
      $code=mb_strtoupper($code);
      $code=mb_substr($code,0,$n_sim);
      
      return ($code);
     }
   
   public function generate_unique_promocode()
     {
      $n=0;
      do
       {
        $n++;
        $code=$this->generate_promocode(0);
        if ($n>10)
          {
           $code.=$this->generate_promocode(5);
          }
        $count=$this->check_is_promocode($code);
        
       }
      while ($count>0 && $n<15);
      //write_log_cms($n);
      return ($code);
     }
   
   public function create_auto_promocode($modul,$service,$num_user,$quantity_max,$start_date,$end_date,$day=0,$locked="off")
     {
      // нужно указать $start_date/$end_date или $day
      // если указывается $day, то игнорируются изначальные значения $start_date/$end_date
      
      if ( $day && $day > 0 )
        {
         $start_date=$GLOBALS["timeGlobal"];
         $end_date=$start_date+24*3600*$day;
        }
      
      $data_save=array(
        "id_promocode"=>0,
        "promocode"=>"",
        "modul"=>$modul,
        "service"=>$service,
        "quantity_max"=>$quantity_max,
        "type_limit_quantity"=>"total_uses",
        "start_date"=>$start_date,
        "end_date"=>$end_date,
        "locked"=>$locked
       );
      
      return ($this->create_promocode("new","auto",$data_save,true,$num_user));
     }
   
   public function create_promocode($type_create,$type_forming,$data_save,$on_timestamp,$num_user=0)
     {
      //write_log_cms($data_save["start_date"]);
      if (!$on_timestamp)
        {
         $data_save["start_date"]= ($data_save["start_date"]? mktime(00,00,00,$data_save["start_date"][1],$data_save["start_date"][0],$data_save["start_date"][2]) :0);
         $data_save["end_date"] = ($data_save["end_date"]? mktime(23,59,00,$data_save["end_date"][1],$data_save["end_date"][0],$data_save["end_date"][2]):0);
        }
      
      if ( $type_forming=="manual" )
        {
         //проверяем уникальность промокода
         $count=$this->check_is_promocode($data_save["promocode"],$type_create,$data_save["id_promocode"]);
         if ( $count > 0 ) return (array(1,"Такой промокод есть в базе!",false));
        }
       else
         {
          //генерируем промокод
          $data_save["promocode"]=$this->generate_unique_promocode();
         }
      
      if ( $type_create == "new" )
        {
         //$data_save["modul"]="doska";
         $data_save["put_date"]=$GLOBALS["timeGlobal"];
         $data_save["last_used_date"]=0;
         $data_save["quantity_use"]=0;
         $data_save["used"]="off";
         $data_save["generate"]=($type_forming == "manual" ? "admin":"auto");
         $data_save["num_user"]=$num_user;
         $data_save["type_limit_quantity"]=($data_save["type_limit_quantity"] ?? "total_uses");
        }
      
      $db_query = forming_db_query_indexmas(DB_PREF."promocode",$data_save,$type_create,"id_promocode");
      //write_log_cms($db_query);
      
      $q_result = db_work::query($db_query);
      
      return (array(0,"no",$data_save));
     }
   
   public function operation_list_promocode($oper,$list_id)
     {
      
      if ($oper=="delete")
        {
         $db_query="delete from ".DB_PREF."promocode_log where num_promocode IN (". $list_id .") ";
         db_work::query($db_query);
         
         $db_query="delete from ".DB_PREF."promocode where id_promocode IN ($list_id) ";
         db_work::query($db_query);
        }
      
      return (array(0,"no"));
     }
   
   public function check_promocode($promocode,$modul,$check_service)
     {
      /*
       * Изменения v24.1 
       * 1. Парметр $check_service - можно задавать false, тогда параметр service промокода не будет проверяться. Проверка указанной услуги в промокоде должна быть в дальнейшем.
       * Также, если $check_service будет указан false, то количество использований промокода в дальнейшем нужно будет увеличивать (так как $check_service нужно проверять в дальнейшем).
       * 2. Функция 3-им параметром возвращает данные промокода или false (в случае ошибки)
       */
      $error=0;
      $error_text="no";
      
      $db_query="select * from ".DB_PREF."promocode where promocode='".codeText($promocode)."' ";
      list($kolvo,$data_promocode)=db_work::query_select_one_assoc($db_query);
      
      if ($kolvo == 0) return(array(1,"Указан неверный промокод!",false));
      
      if ($data_promocode["locked"]=="on") return(array(1,"Промокод заблокирован!",false));
      
      if ($data_promocode["start_date"] > 0 && $data_promocode["start_date"]>$GLOBALS["timeGlobal"]) return(array(1,"Время действия промокода еще не началось!",false));
      if ($data_promocode["end_date"] > 0 && $data_promocode["end_date"]<$GLOBALS["timeGlobal"]) return(array(1,"Время действия промокода уже закончилось!",false));
      
      //if ($data_promocode["quantity_max"] > 0 && $data_promocode["quantity_max"]<=$data_promocode["quantity_use"]) return(array(1,"У промокода превышено количесто использований!",false));
      if ($data_promocode["quantity_max"] > 0)
        {
          if ($data_promocode["type_limit_quantity"] == "total_uses")
            {
              if ($data_promocode["quantity_max"]<=$data_promocode["quantity_use"]) return(array(1,"У промокода превышено количесто использований!",false));
            }
          elseif ($data_promocode["type_limit_quantity"] == "one_user")
            {
              list($error,$error_text,$on_limit_max)=$this->check_limit_quantity_promocode_user($data_promocode);
              if ($error > 0) return ([$error,$error_text,false]);
            }
        }
      
      if ($data_promocode["modul"] != $modul) return(array(1,"Промокод невозможно использовать для данной услуги!",false));
      if ($check_service != false && ($data_promocode["service"] != "any_one" && $data_promocode["service"] != $check_service)) return(array(1,"Промокод невозможно использовать для данной услуги!",false));
      
      if ($check_service != false)
        $this->promocode_use_incr($data_promocode["id_promocode"]);
      
      return (array($error,$error_text,$data_promocode));
     }
   
   public function promocode_use_incr($id_promocode)
     {
      $this->check_auth_user_site();
      
      $db_query="update ".DB_PREF."promocode set quantity_use=quantity_use+1, last_used_date=".$GLOBALS["timeGlobal"]." where id_promocode=".$id_promocode;
      db_work::query($db_query);
      
      $save_data=["id_log"=>0, "num_promocode"=>$id_promocode, "num_user"=>$this->num_user_site, "put_date"=>$GLOBALS["timeGlobal"]];
      $db_query=forming_db_query_indexmas(DB_PREF."promocode_log",$save_data,"new","id_log");
      db_work::query($db_query);
      
      return (true);
     }
   
   public function promocode_data_use_incr($one_promocode)
     {
       return ($this->promocode_use_incr($one_promocode["id_promocode"]));
     }
   
   public function get_name_promocode($modul,$service)
     {
      global $mas_init_promocode;
      $name="";
      
      //$m=select_mas_2level($mas_init_promocode,0,$modul,false);
      $d=search_mas_2lvl_2key($mas_init_promocode,array(array(0,$modul),array(1,$service)),false);
      if ($d[0]) $name=$mas_init_promocode[$d[1]][2];
      
      return ($name);
     }
   
   public function clear_promocode()
     {
      //для cron
      
      $day_wait=210;//количество дней, по истечению которых, будут удаляться устаревшие данные
      
      $db_query_part="select id_promocode from ".DB_PREF."promocode where (quantity_max > 0 and type_limit_quantity ='total_uses' and quantity_use >= quantity_max and last_used_date < ".($GLOBALS["timeGlobal"]-$day_wait*24*3600)." ) "
        ." or  ( end_date > 0 and end_date < ".($GLOBALS["timeGlobal"]-$day_wait*24*3600) ." ) "
        ." or ( locked = 'on' and end_date < ".($GLOBALS["timeGlobal"]-$day_wait*24*3600) ." and last_used_date < ".($GLOBALS["timeGlobal"]-$day_wait*24*3600) ." ) ";
      
      $db_query="delete from ".DB_PREF."promocode_log where num_promocode IN (". $db_query_part .") "
       ." or ( put_date < ".($GLOBALS["timeGlobal"]-$day_wait*24*3600) ." and num_promocode NOT IN ( select id_promocode from ".DB_PREF."promocode ) ) ";
      //write_log_cms($db_query);
      db_work::query($db_query);
      
      $db_query="delete from ".DB_PREF."promocode where (quantity_max > 0 and type_limit_quantity ='total_uses' and quantity_use >= quantity_max and last_used_date < ".($GLOBALS["timeGlobal"]-$day_wait*24*3600)." ) "
        ." or  ( end_date > 0 and end_date < ".($GLOBALS["timeGlobal"]-$day_wait*24*3600) ." ) "
        ." or ( locked = 'on' and end_date < ".($GLOBALS["timeGlobal"]-$day_wait*24*3600) ." and last_used_date < ".($GLOBALS["timeGlobal"]-$day_wait*24*3600) ." ) ";
      //write_log_cms($db_query);
      db_work::query($db_query);
      
      
     }
   
   public function get_service_promocode($data_promocode)
     {
       return ($data_promocode["service"] ?? "");
     }
   
   public function check_limit_quantity_promocode_user($data_promocode)
     {
       $error=0;
       $error_text="";
       $on_max=false;
       $this->check_auth_user_site();
       
       if (!$this->on_user_site) return ([1,"Чтобы применить этот промокод нужно авторизоваться на сайте!",$on_max]);
       
       $db_query="select count(*) from ".DB_PREF."promocode_log where num_promocode = ".$data_promocode["id_promocode"]." and num_user = ".$this->num_user_site;
       $kolvo_use=db_work::query_count($db_query);
       
       if ($data_promocode["quantity_max"]<=$kolvo_use) return(array(1,"Вы достигли предела в применении этого промокода!",true));
       
       return ([$error,$error_text,$on_max]);
     }
   
   
   public function get_log_data($elms_page,$num_page,$promocode,$num_user)
     {
      
      $data = array();
      $kolvo_vsego = 0;
      
      $query_search = "";
      $num_user = trim( $num_user );
      
      if (  $num_user || $num_user === "0" )
        {
         $query_search = " log.num_user IN (".codeText($num_user).") ";
        }
      
      if ($promocode)
        {
         $query_search=($query_search ?" and ":"")." promocode.promocode like '%".codeText($promocode)."%' ";
        }
      
      if ( $query_search )
        $query_search = " where ".$query_search;
      /*
      $db_query="select count(*) from ".DB_PREF."promocode_log ".$query_search." ";
      */
      $db_query="select count(*) from ".DB_PREF."promocode_log log ";
      if ($promocode || $num_user)
        {
          $db_query.=" where ";
          $and = "";
          if ($num_user)
            {
              $db_query .= " log.num_user IN (".codeText($num_user).") ";
              $and = " and ";
            }
          if ($promocode)
            {
              $db_query.= $and . " num_promocode IN (select id_promocode from ".DB_PREF."promocode where promocode like '%".codeText($promocode)."%' ) ";
            }
        }
      
      $kolvo_vsego = db_work::query_count($db_query);
      
      if ( $kolvo_vsego > 0 )
        {
         $db_query="select log.id_log id_log, log.num_promocode num_promocode, log.num_user num_user, log.put_date put_date, "
         ." promocode.promocode promocode, promocode.modul modul, promocode.service service, promocode.num_user num_user_cr "
         ." from ".DB_PREF."promocode_log log LEFT JOIN ".DB_PREF."promocode promocode "
         ." on log.num_promocode = promocode.id_promocode "
         .$query_search." order by log.id_log DESC limit ".(($num_page - 1) * $elms_page).",".$elms_page;
         //write_log_cms($db_query);
         list($kolvo,$data)=db_work::query_select_assoc($db_query);
        }
      
      return (array($kolvo_vsego,$data));
     }
   
   public function operation_list_log_promocode($oper,$list_id)
     {
      
      if ($oper=="delete")
        {
         $db_query="delete from ".DB_PREF."promocode_log where id_log IN (". $list_id .") ";
         db_work::query($db_query);
        }
      
      return (array(0,"no"));
     }
   
   
   
  }
