<?php


class eng_cms_install
  {
   
   private $dbcnx=false;
   
   function __construct()
     {
      
     }
   
   public function work()
     {
      
      $error = 0;
      $error_text = "no";
      $data = "";
      
      $on_get_data = false;
      
      $step_error = 0;
      $step_error_text = "";
      
      $mas_data = array();
      
      if ( !empty($_POST["stepins"]) && is_numeric($_POST["stepins"])  )
        {
         
         switch ( $_POST["stepins"] )
           {
            
            case( 1 ):
              {
               list($error,$error_text,$data)=$this->check_settings_host();
               $on_get_data = true;
               break;
              }
            case( 2 ):
              {
               list($error,$error_text,$data)=$this->check_connect_db();
               $on_get_data = true;
               break;
              }
            
            case( 3 ):
              {
               list($error,$error_text,$data)=$this->check_tables_db();
               $on_get_data = true;
               break;
              }
            
            case( 4 ):
              {
               list($error,$error_text,$data)=$this->proces_tables_db();
               $on_get_data = true;
               break;
              }
            
            case( 5 ):
              {
               list($error,$error_text,$data)=$this->create_user_admin();
               $on_get_data = true;
               break;
              }
            
            case( 6 ):
              {
               list($error,$error_text,$data)=$this->add_in_db_data();
               $on_get_data = true;
               break;
              }
            
            case( 7 ):
              {
               list($error,$error_text,$data)=$this->change_dir_perms();
               $on_get_data = true;
               break;
              }
            case( 8 ):
              {
               list($error,$error_text,$data)=$this->check_dir_perms();
               $on_get_data = true;
               break;
              }
           }
         
         if( !$on_get_data )
           {
            $error=1;
            $error_text="Ошибка с данными!";
           }
         
        }
       else
         {
          $error=1;
          $error_text="Ошибка с данными!";
         }
      
      write_answer_special($error,$error_text,$data);
     }
   
   private function connect_db($catch_error=false)
     {
      global $obj_db_connect,$dbhost,$dbuser,$dbpasswd,$dbname;
      if (!$this->dbcnx)
        {
         $this->dbcnx=@$obj_db_connect->connectBaz($dbhost,$dbuser,$dbpasswd,$dbname,!$catch_error);
        }
      
      if (!$this->dbcnx && !$catch_error)
        {
         write_answer_special(1,"Произошла ошибка при работе базы данных!");
        }
      
      return ($this->dbcnx);
     }
   
   private function check_settings_host()
     {
      // 1 шаг установки
      //проверяем настройки хостинга
      //ini_set("register_globals","1");
      
      $error = 0;
      $error_text = "no";
      
      $r_g = ini_get("register_globals");
      $m_q_g = ini_get("magic_quotes_gpc");
      
      $bool_r_g = false;
      $bool_m_q_g = false;
      
      if ( $r_g )
        {
         $r_g=mb_strtolower($r_g);
         
         switch ( $r_g )
          {
           case 'on':
           case 'yes':
           case 'true':
           case '1':
           $bool_r_g=true;
           break;
          }
        }
      
      if ( $m_q_g )
        {
         $m_q_g = mb_strtolower($m_q_g);
         
         switch ( $m_q_g )
          {
           case 'on':
           case 'yes':
           case 'true':
           case '1':
           $bool_m_q_g = true;
           break;
          }
        }
      
      if ( $bool_r_g || $bool_m_q_g  )
        {
         $error = 1;
         $error_text="<div><div>Обнаружены недопустимые настройки PHP.</div>"
         .( $bool_r_g ? "<div style='padding: 10px 0px 0px 10px;'> - Опция конфигурации PHP <b>register_globals</b> имеет значение 1, тогда как для работы CMS нужно значение 0 (то есть данная опция должна быть выключена)!
         <br>Установите значение опции <b>register_globals</b> равное 0 и перезагрузите страницу.</div>" : "" )
         .( $bool_m_q_g ? "<div style='padding: 10px 0px 0px 10px;'> - Опция конфигурации PHP <b>magic_quotes_gpc</b> имеет значение 1, тогда как для работы CMS нужно значение 0 (то есть данная опция должна быть выключена)!
         <br>Установите значение опции <b>magic_quotes_gpc</b> равное 0 и перезагрузите страницу.</div>" : "" )
         ."</div>";
         
        }
      
      return (array($error,$error_text,""));
     }
   
   private function check_connect_db()
     {
      //$dbcnx=@$obj_db_connect->connectBaz($dbhost,$dbuser,$dbpasswd,$dbname,false);
      $dbcnx=$this->connect_db(true);
      if ( !$dbcnx )
        {
         write_answer_special(1,"Произошла ошибка при соединении с базой данных. Проверьте данные для подключения к базе данных!");
        }
      
      return (array(0,"",""));
     }
   
   private function check_tables_db()
     {
      global $tablesCreat;
      
      $mas_tables = array();
      
      $is_exists_table = false;
      
      $dbcnx=$this->connect_db();
      
      $db_query = "show tables";
      
      list($kolvo,$data_tables) = db_work::query_select_row($db_query);
      
      foreach ( $data_tables as $row )
        {
         $mas_tables[] = mb_strtolower($row[0]);
        }
      
      foreach ( $tablesCreat as $nameTable => $sqlTable )
        {
         
         if ( in_array( DB_PREF.$nameTable,$mas_tables ) )
           {
            $is_exists_table = true;
            break;
           }
         
        }
      
      $data = " existsTable : ".( $is_exists_table ? "1" : "0");
      
      return (array(0,"",$data));
     }
   
   private function proces_tables_db()
     {
      //создание таблиц
      $dbcnx=$this->connect_db();
      
      global $tablesCreat;
      $error = 0;
      $error_text = "no";
      $data="";
      $count_admin = 0;
      
      if ( !empty($_POST["newcreate"]) && ( $_POST["newcreate"] == "on" || $_POST["newcreate"] == "off" ) )
        {
         
         if ( $_POST["newcreate"] == "on" )
           {
            $this->create_tables_db();
           }
          else
            {
             
             $mas_exists_tables = array();
             
             $db_query = "show tables";
             list($kolvo,$data_tables) = db_work::query_select_row($db_query);
             
             foreach ( $data_tables as $row )
               {
                $mas_exists_tables[] = strtolower($row[0]);
               }
             
             //меняем структуру у существующих таблиц
             foreach ( $tablesCreat as $nameTable => $sqlTable )
               {
                if ( in_array( DB_PREF.$nameTable,$mas_exists_tables ) )
                  {
                   
                   if ( edit_table_db::edit_one_table(DB_PREF.$nameTable,$sqlTable) === false )
                     {
                      write_answer_special(1,"<div>Произошла ошибка при редактировании таблицы ".DB_PREF.$nameTable." </div>");
                     }
                   
                  }
                 else
                   {
                    //или создаем новые таблицы
                    $q_result = db_work::query($sqlTable,"<div>Произошла ошибка при создании таблицы ".DB_PREF.$nameTable." <div>{error}</div></div>");
                   }
               }
             
             //проверяем администратора сайта в таблице пользователей
             $db_query = "select count(*) from ".DB_PREF."users  where access_admin = 'sadmin' ";
             $count_admin = obr_db_query_count($db_query);
             
            }
         
         $data = " exists_admin:" .( $count_admin ? "'on'" : "'off'" );
         
        }
       else
         {
          $error = 1;
          $error_text = "Ошибка с данными!";
         }
      
      return (array($error,$error_text,$data));
     }
   
   private function create_tables_db()
     {
      global $tablesCreat;
      
      foreach ($tablesCreat as $name_tab => $srt_tab)
        {
         $db_query=$srt_tab;
         $q_result = db_work::query($db_query,"<div>Произошла ошибка при создании таблицы ".DB_PREF.$name_tab." <div>{error}</div></div>");
         
        }
      
      return (true);
     }
   
   private function create_user_admin()
     {
      global $obj_control_data;
      $error = 0;
      $error_text = "no";
      
      $dbcnx=$this->connect_db();
      
      $mas = array(
        array("name_user","post","name_user","text",true,true,false,"",false,false,false,false),
        array("password_user","post","password_user","text",true,true,false,"",false,false,false,false),
        array("email_user","post","email_user","text",true,true,false,"",false,false,false,false)
       );
      
      $rez_control_data=$obj_control_data->processing_one_group($mas);
      if ( $rez_control_data[0] &&  !$rez_control_data[1]   )
        {
         //данные обнаружены и ошибок нет
         $mas_inbox=$rez_control_data[3];
         $mas_status = $rez_control_data[5];
         
         $this->add_user_admin($mas_inbox["name_user"],$mas_inbox["email_user"],$mas_inbox["password_user"]);
         
        }
       else
         {
          $error = 1;
          $error_text = "Ошибка с данными!";
         }
      
      return (array($error,$error_text,""));
     }
   
   private function add_user_admin($name,$email,$password)
     {
      
      $save_data = array(
       "id_user" => 1,
       "name_user" => $name,
       "password_user" => md5($password),
       "email_user" => $email,
       "phone_user" => "",
       "date_create" => $GLOBALS["timeGlobal"],
       "date_visit" => 0,
       "sait_user" => "",
       "about_user" => "",
       "print_email_user" => 'off',
       "access_user" => 'on',
       "activ_user" => 'on',
       "kod_activ" => '',
       "access_admin" => 'sadmin',
       "access_privat" => '[all]',
       "image_user" => '',
       
       "on_subscribe" => 'on',
       "get_message_admin" => 'on',
       "get_message_user" => 'on',
       "get_message_guest" => 'on',
       "operation_1" => 'on',
       "operation_2" => 'on',
       "operation_3" => 'on',
       "money" => 0,
       "on_partner" =>  'off',
       "partner_amount" => 0,
       "partner_key" => "",
       "partner_purse" => "",
       "partner_invite" => 0,
       "partner_get_message" => 'off',
       "notice_new_private_message" => 'on',
       
       "type_registr" => 'site',
       "social_name" => '',
       "social_ident" => '',
       "social_profile" => '',
       "service_ident" => '',
       "note" => '',
       "authorized" => 'off',
       "date_admin"=>0,
       "authorized_admin"=>"off",
       "type_account"=>"regular"//regular или business
       );
      
      
      $db_query = forming_db_query_indexmas(DB_PREF."users",$save_data,"new","id_user");
      db_work::query($db_query,"<div>Ошибка при добавлении администратора в базу данных</div><div>{error}</div>");
      
      return (true);
     }
   
   private function add_in_db_data()
     {
      //добавляем в базу начальные данные
      $mas_query=array();
      require("masaddquery.php");
      global $on_add_in_db_from_files,$on_add_geo_data,$on_check_type_account_user;
      
      $dbcnx=$this->connect_db();
      
      $error_insert=false;
      
      foreach ($mas_query as $data_one_query)
        {
         $count_row_table = db_work::query_count($data_one_query[0]);//"<div>Ошибка при добавлении в базу данных <div>{error}</div></div>"
         if ( $count_row_table == 0 )
           {
            $q_result = db_work::query($data_one_query[1],"<div>Ошибка при добавлении в базу данных <div>{error}</div></div>");
           }
         
        }
      
      if ($on_add_in_db_from_files)
        {
          $this->add_in_db_data_from_files();
        }
      
      if ($on_add_geo_data)
        {
          $this->add_in_db_data_geo();
        }
      
      if ($on_check_type_account_user)
        {
          $this->check_type_account_user();
        }
      
      return (array(0,"",""));
     }
   
   private function add_in_db_data_from_files()
     {
       $dir_script=getcwd();
       $dir_script=str_replace("\\","/",$dir_script);
       
       global $mas_init_add_in_files;
       /*
       $mas_files=array(
         
         array(DB_PREF."article_category","bmysql_article_category.txt","id_category",0),
         
         array(DB_PREF."ishop_category","bmysql_ishop_category.txt","id_category",0),
         array(DB_PREF."ishop_properties","bmysql_ishop_properties.txt","id_properties",0),
         array(DB_PREF."ishop_listv","bmysql_ishop_listv.txt","id_value",0),
         array(DB_PREF."ishop_link_pc","bmysql_ishop_link_pc.txt","id_link_pc",0),
         
        );
       */
       /*
       $file_country=$dir_script."/bmysql_country.txt";
       $file_city=$dir_script."/bmysql_city.txt";
       $file_region=$dir_script."/bmysql_region.txt";
       */
       
       foreach ($mas_init_add_in_files as $one_file)
         {
           add_db_data_file::proces($one_file[0],$dir_script."/".$one_file[1],$one_file[2],$one_file[3],true);
         }
       
       return (array(0,"",""));
     }
   
   private function add_in_db_data_geo()
     {
      //добавляем в базу страны, регионы и города
      
      $dir_script=getcwd();
      $dir_script=str_replace("\\","/",$dir_script);
      
      global $mas_init_add_geo_data;
      
      foreach ($mas_init_add_geo_data as $one_init)
        {
          add_db_data_file::proces($one_init[0],$dir_script."/".$one_init[1],$one_init[2],$one_init[3],$one_init[4]);
        }
      /*
      $file_country=$dir_script."/bmysql_country.txt";
      $file_city=$dir_script."/bmysql_city.txt";
      $file_region=$dir_script."/bmysql_region.txt";
      
      add_db_data_file::proces(DB_PREF."country",$file_country,"country_id",2,false);
      add_db_data_file::proces(DB_PREF."region",$file_region,"region_id",3,false);
      add_db_data_file::proces(DB_PREF."city",$file_city,"city_id",3,false);
      */
      
      return (array(0,"",""));
     }
   
   private function change_dir_perms()
     {
      global $dir_cms,$mas_dirs_perms;
      
      //include ("dirs_perms.php");
      
      clearstatcache();
      
      foreach ( $mas_dirs_perms as $one_dir )
        {
         $dir = $dir_cms.$one_dir[0];
         
         if ( is_dir( $dir ) )
           {
            //$status = "is";
            
            @chmod($dir,0777);
            
            if ( $one_dir[1] == 1 )
              {
               //проверяем файлы в каталоге
               $elements = scandir($dir);
               
               if ( $elements && sizeof( $elements ) > 0 )
                 {
                  foreach ( $elements as $element )
                    {
                     if ( is_file( $dir."/".$element ) )
                       {
                        //$status = "is";
                        $file = $dir."/".$element;
                        @chmod($file,0777);
                        
                       }
                    }
                 }
              }
            
           }
         
        }
      
      return (array(0,"",""));
     }
   
   private function check_dir_perms()
     {
      global $dir_cms,$mas_dirs_perms;
      
      //include ("dirs_perms.php");
      
      $data_dirs = array();
      
      clearstatcache();
      
      $all_perms = "on";
      
      foreach ( $mas_dirs_perms as $one_dir )
        {
         
         $dir = $dir_cms.$one_dir[0];
         //echo($dir."\n");
         $perms = "none";
         $status = "none";
         if ( is_dir( $dir ) )
           {
            $status = "is";
            
            //chmod($dir,0777);
            
            $res = fileperms($dir);
            $perms = (0777 & $res);//decoct()
            //echo($status."\n"); //octdec()
            
            if ( $perms == 0777 )
              {
               $status = "on";
              }
             else
               {
                $all_perms = "off";
               }
            
            $data_dirs[] = array($one_dir[0],$perms,$status);
            
            if ( $one_dir[1] == 1 )
              {
               //проверяем файлы в каталоге
               $elements = scandir($dir);
               
               if ( $elements && sizeof( $elements ) > 0 )
                 {
                  foreach ( $elements as $element )
                    {
                     if ( is_file( $dir."/".$element ) )
                       {
                        $status = "is";
                        
                        $file = $dir."/".$element;
                        //chmod($file,0777);
                        
                        $res = fileperms($dir);
                        $perms = (0777 & $res);
                        
                        if ( $perms == 0777 )
                          {
                           $status = "on";
                          }
                         else
                           {
                            $all_perms = "off";
                           }
                        
                        //echo($perms);
                        $data_dirs[] = array($one_dir[0]."/".$element,$perms,$status);
                        
                       }
                    }
                 }
              }
            
           }
          else
            {
             $data_dirs[] = array($one_dir[0],$perms,$status);
             $all_perms = "off";
            }
         
        }
      
      list($t_encode,$t_assoc) = encode_gen_mas_to_jointext($data_dirs, true );
      $data = " datadir: " . $t_encode. " , allperms: '$all_perms' ";
      
      return (array(0,"",$data));
     }
   
   public function check_type_account_user()
     {
       // Проверяем type_account пользователей.
       // Если у пользователя есть объект (компания), то меняем значение параметра type_account -> business
       
       $db_query = "update ".DB_PREF."users set type_account='business' where id_user IN (select DISTINCT num_user from ".DB_PREF."catalog_object) ";
       db_work::query($db_query,"<div>Произошла ошибка при проверке типа аккаунта <div>{error}</div></div>");
       
       return (array(0,"",""));
     }
   
   public function install_auto($admin_email,$admin_password)
     {
      $error = 0;
      $error_text = "no";
      $data = "";
      
      list($error,$error_text)=$this->proces_install_auto($admin_email,$admin_password);
      
      write_answer_special($error,$error_text,$data);
     }
   
   private function proces_install_auto($admin_email,$admin_password)
     {
      $error = 0;
      $error_text = "no";
      
      list($error,$error_text)=$this->check_connect_db();
      if ($error > 0) return (array($error,$error_text));
      
      list($error,$error_text)=$this->create_tables_db();
      if ($error > 0) return (array($error,$error_text));
      
      list($error,$error_text)=$this->add_user_admin("admin",$admin_email,$admin_password);
      if ($error > 0) return (array($error,$error_text));
      
      list($error,$error_text)=$this->add_in_db_data();
      if ($error > 0) return (array($error,$error_text));
      
      list($error,$error_text)=$this->change_dir_perms();
      if ($error > 0) return (array($error,$error_text));
      
      
      return (array($error,$error_text));
     }
   
  }
