<?php


class add_db_data_file
  {
   
   private static $mas_index_name=array();
   
   
   function __construct()
     {
      
     }
   
   static public function proces($name_table,$file_data,$name_id_column,$key_name_file,$only_add)
     {
      // $only_add - проверка значений в таблице
      // Проверка нужна только для таблиц содержащих ГЕО-даные - проверяется наличие транслита названия и склонения
      
      $error=false;
      
      $db_query = "select count(*) from ".$name_table." ";
      $count_row = db_work::query_count($db_query);
      if ($count_row == 0)
        $error=self::add_new($name_table,$file_data,$name_id_column);
       elseif (!$only_add)
         {
           //Если $only_add -> true, то пропускаем проверку значений в таблице
           
           $error = self::check_edit($name_table, $file_data, $name_id_column, $key_name_file);
         }
      
      return ($error);
     }
   
   static private function add_new($name_table,$file_data,$name_id_column)
     {
      $error=false;
      
      $mas_file=file($file_data,FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
      
      $kol_add_one = 30;//количество строк добавляемых за один запрос
      
      if ( $mas_file )
        {
         
         $kol_rows=sizeof($mas_file);
         $n=0;
         while ( $n < $kol_rows )
           {
            $i = 0;
            
            $db_query = "insert IGNORE into ".$name_table." values ";
            $query_list="";
            $sep = "";
            while (  $n < $kol_rows && $i < $kol_add_one  )
              {
               $text_row = trim($mas_file[$n]);
               $n++;
               
               if (!$text_row) continue;
               
               $mas_row = explode(";",$text_row);
               
               $query_list .= $sep . " (".self::constr_text_param($mas_row).") ";
               $sep = ",";
               $i++;
              }
            
            if ($query_list)
              $q_result = db_work::query($db_query.$query_list,"<div>Ошибка при добавлении в базу данных <div>{error}</div></div>");
            
           }
         
        }
       else
         {
          $error = true;
         }
      
      unset($mas_file);
      
      return ($error);
     }
   
   static private function check_edit($name_table,$file_data,$name_id_column,$key_name_file)
     {
      
      self::get_index_data_file($file_data,$key_name_file);
      
      $db_query = "select count(*) from ".$name_table." where translit = '' or name_2 = '' or name_3 = '' ";
      $count_edit = db_work::query_count($db_query);
      
      if ( $count_edit > 0 )
        {
         $kol_add_one = 30;//количество строк добавляемых за один запрос
         $kolvo_cycle = ceil($count_edit/$kol_add_one);
         
         $i = 0;
         while ($i < $kolvo_cycle)
           {
            $db_query = "select * from ".$name_table." where translit = '' or name_2 = '' or name_3 = '' limit 0,".$kol_add_one." ";
            list($kolvo,$data_tb) = db_work::query_select_assoc($db_query);
            
            if ( $kolvo > 0 )
              {
               
               foreach ($data_tb as $one_data)
                 {
                  $mas_save=array();
                  if ($one_data["translit"] == "")
                    $mas_save["translit"]=encode_text_to_url_name($one_data["name"],"-");
                  if ($one_data["name_2"] == "" || $one_data["name_3"] == "")
                    {
                     $nn=self::get_name_n($one_data["name"]);
                     if ($nn)
                       {
                        if ($one_data["name_2"] == "" && $nn[0]) $mas_save["name_2"]=$nn[0];
                        if ($one_data["name_3"] == "" && $nn[1]) $mas_save["name_3"]=$nn[1];
                       }
                    }
                  
                  if (sizeof($mas_save) > 0)
                    {
                     $mas_save[$name_id_column]=$one_data[$name_id_column];
                     $db_query=forming_db_query_indexmas($name_table,$mas_save,"edit",$name_id_column);
                     db_work::query($db_query);
                    }
                  
                 }
               
              }
            
            $i++;
           }
        }
      
      self::$mas_index_name=array();
      
      return (false);
     }
   
   static private function get_index_data_file($file_data,$key_name_file)
     {
      
      $mas_file=file($file_data,FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
      if (!$mas_file) return (false);
      
      foreach ($mas_file as $one_row)
        {
         $mas_one=explode(";",$one_row);
         $length=sizeof($mas_one);
         self::$mas_index_name[$mas_one[$key_name_file]]=array($mas_one[$length-2],$mas_one[$length-1]);
        }
      
      return (true);
     }
   
   static private function get_name_n($name)
     {
      $vv=false;
      
      if (!empty(self::$mas_index_name[$name]))
        $vv=self::$mas_index_name[$name];
      
      return ($vv);
     }
   
   static private function constr_text_param($mas_param)
     {
      $t="";
      $sep="";
      for ($n=0; $n<sizeof($mas_param); $n++)
        {
         $t.=$sep;
         if ( is_numeric($mas_param[$n]) )
           $t.=$mas_param[$n];
          else
            $t.="'".$mas_param[$n]."'";
         
         $sep=",";
        }
      
      return ($t);
     }
   
   
  }


