<?php


//редактирование таблицы БД

class edit_table_db
{
  
  static function edit_one_table($nameTable, $sql_cr_table)
    {
      $on_edit = false;
      //парсим запрос создания таблицы, получаем массив с полями таблицы и массив с данными index
      $d_parser = self::parserSqlCreateTable($sql_cr_table, $nameTable);
      if (!$d_parser) return ($on_edit);
      
      list($dataCrTable, $dataCrIndex) = $d_parser;
      
      $dataTableDb = self::get_all_fields_table($nameTable);
      $dataIndexTable = self::get_index_table_db($nameTable);
      
      //write_log_cms($dataCrTable, $nameTable." data fields sql");
      //write_log_cms($dataCrIndex, $nameTable." data create index");
      //write_log_cms($dataTableDb, $nameTable." данные полей из БД");
      //write_log_cms($dataIndexTable, $nameTable." данные index из БД");
      
      foreach ($dataCrTable as $num => $poleCreate)
        {
          
          if (!empty($dataTableDb[$num]))
            {
              if (mb_strtolower($dataTableDb[$num]["Field"]) !== mb_strtolower($dataCrTable[$num]["name"]))
                {
                  //echo("<div>add ".$dataTableDb[$num]["Field"]." ".$dataCrTable[$num]["name"]."</div>");
                  if (!self::add_one_field($nameTable, $dataCrTable, $num)) return (false);
                  $dataTableDb = self::get_all_fields_table($nameTable);
                  $on_edit = true;
                }
              else
                {
                  //write_log_cms("Названия полей (сущ и исх) ".$dataTableDb[$num]["Field"] ." ". $dataCrTable[$num]["name"]);
                  $res=self::check_type_one_field($nameTable,$dataCrTable[$num],$dataTableDb[$num]);
                  if ($res === false) return (false);
                  if ($res === 2) $on_edit = true;
                }
              
            }
          else
            {
              //echo("<div>addend *** ".$dataCrTable[$num]["name"]."</div>");
              if (!self::add_one_field($nameTable, $dataCrTable, $num)) return (false);
              $dataTableDb = self::get_all_fields_table($nameTable);
              $on_edit = true;
            }
          
        }
      
      self::edit_index_table($nameTable,$dataCrIndex,$dataIndexTable);
      
      return ($on_edit ? "on" : "off");
    }
  
  static function edit_index_table($nameTable,$dataCrIndex,$dataIndexTable)
    {
      // $nameTable - имя таблицы,
      // $dataCrIndex - спарсенные данные об создании индекса из запроса создания таблицы ,
      // $dataIndexTable - данные о существующих индексах таблицы полученный из БД
      
      foreach ($dataCrIndex as $one_index)
        {
          if (!isset($dataIndexTable[$one_index["name"]]))
            {
              //write_log_cms($one_index["name"],"Таблица ".$nameTable.", нет индекса");
              $db_query="ALTER TABLE ".$nameTable." ADD ".$one_index["sql"];
              //write_log_cms($db_query,"db_query для добавления индекса в таблице ".$nameTable);
              db_work::query($db_query,"<div>Произошла ошибка при редактировании индексов таблицы ".$nameTable." </div>");
            }
        }
      
      return (false);
    }
  
  static function add_one_field($nameTable, $dataCrTable, $num)
    {
      
      if ($num == 0)
        {
          return (false);
        }
      elseif ($num > 0)
        {
          $begin_column = $dataCrTable[$num - 1]["name"];
          $db_query = "ALTER TABLE ".$nameTable." ADD ".$dataCrTable[$num]["sql"]." AFTER ".$begin_column;
          
          $q_result = db_work::query($db_query,"<div>Произошла ошибка при редактировании таблицы ".$nameTable." </div>");
          
        }
      
      return (true);
    }
  
  
  static function get_all_fields_table($nameTable)
    {
      
      $db_query = "describe ".$nameTable;
      
      list($kol, $data) = obr_db_query_select_assoc($db_query);
      
      return ($data);
    }
  
  static function get_index_table_db($nameTable)
    {
      $db_query = "show index from ".$nameTable;
      
      list($kolvo, $data) = db_work::query_select_assoc_index_group($db_query,"Key_name");
      //write_log_cms($data);
      
      return ($data);
    }
  
  static function check_type_one_field($nameTable,$source_field,$struct_db_field)
    {
      //write_log_cms($source_field,"исходное поле");
      //write_log_cms($struct_db_field,"структура поля в БД");
      $status = 1;// 1 - поле не было изменено, 2 - поле изменено
      
      $parse_mas=split_text_separator::parse_text_params($source_field["sql"]," ");
      //write_log_cms($parse_mas,"parse sql");
      
      /* $parse_mas:
      0 - название поля,
      1 - тип поля
      2 - в зависимости от кода (от пробела можену ENUM и скобкой): для поля ENUM - может содержать значения ('1','2','3',...), а могут быть следующие данные
      3,4... - другие данные
      */
      
      //Проверим поле ENUM, при необходимости отредактируем (поменяем значения в списке ENUM)
      if (stripos($parse_mas[1],"enum") === 0)
        {
          //write_log_cms($parse_mas,"данные поля create");
          //write_log_cms($struct_db_field,"данные поле struct");
          
          if (stripos($struct_db_field["Type"],"enum") === 0)
            {
              $type_cr=strtolower(str_replace('"',"'",$parse_mas[1]));
              $type_struct=strtolower(str_replace('"',"'",$struct_db_field["Type"]));
              
              if ($type_cr == "enum")
                {
                  if (!empty($parse_mas[2]))
                    {
                      $type_cr .= strtolower($parse_mas[2]);
                    }
                }
              
              //write_log_cms($type_cr,"тип поля create");
              //write_log_cms($type_struct,"тип поля struct");
              
              $type_cr2=123;// присваиваем разные значения, чтобы оне не были одинаковы
              $type_struct2=456;
              
              if (preg_match('#^enum\s*\((.*)\)$#i',$type_cr,$matches_cr) == 1
                && preg_match('#^enum\s*\((.*)\)$#i',$type_struct,$matches_struct) == 1)
                {
                  
                  $list_cr = $matches_cr[1];
                  $list_struct = $matches_struct[1];
                  $mas_values_cr = split_text_separator::parse_text_params($list_cr, ",");
                  $mas_values_struct = split_text_separator::parse_text_params($list_struct, ",");
                  //write_log_cms($mas_values_cr, "mas values ENUM create");
                  //write_log_cms($mas_values_struct, "mas values ENUM struct");
                  
                  $type_cr2 = implode(",", $mas_values_cr);
                  $type_struct2 = implode(",", $mas_values_struct);
                  
                  //write_log_cms($type_cr2,"тип поля create2");
                  //write_log_cms($type_struct2,"тип поля struct2");
                  
                  if ($type_cr2 != $type_struct2)
                    {
                      //write_log_cms("значения отличаются", "сравнение значений ENUM");
                      $db_query="ALTER TABLE ".$nameTable." CHANGE ".$source_field["name"]." ".$source_field["sql"];
                      //write_log_cms($db_query,"alter table field type");
                      db_work::query($db_query,"<div>Произошла ошибка при редактировании индексов таблицы ".$nameTable." </div>");
                      $status = 2;
                    }
                  else
                    {
                      //write_log_cms("значения одинаковые", "сравнение значений ENUM");
                    }
                }
              
            }
          else
            {
              //write_log_cms("имя поля".$parse_mas[0],"несовпадение типов полей");
              return (false);
            }
        }
      
      
      return ($status);
    }
  
  
  static function parserSqlCreateTable($sql_query, $nameTable)
    {
      $data_poles = array();
      $data_index = array();
      
      $error = false;
      $sql_query = trim($sql_query);
      
      $pattern = "/^create[\s]+(temporary[\s]+)?table[\s]+(if[\s]+not[\s]+exists[\s]+)?".$nameTable."[\s]*\((.*)\)[^\)]*$/uis";
      
      if (!preg_match($pattern, $sql_query, $matches))
        {
          return (false);
        }
      
      $poles = $matches[3];
      
      $mas_cr_pole = split_text_separator::parse_text_params($poles, ",");
      if (!$mas_cr_pole) return (false);
      
      $pattern = "/^([\S]+)[\s]+([a-zA-Z0-9_]+)\b(.*)/is";
      
      $kol = sizeof($mas_cr_pole);
      
      foreach ($mas_cr_pole as $num => $row)
        {
          if (!preg_match($pattern, $row, $matches))
            {
              //write_log_cms($row, "Регулятное выражение - ошибка");
              return (false);
            }
          
          $name_pole = mb_strtolower($matches[1]);
          if ($name_pole == "primary" || $name_pole == "fulltext" || $name_pole == "key" || $name_pole == "index")
            {
              if ($name_pole == "fulltext" || $name_pole == "index")
                {
                  //найдена инструкция создающая fulltext
                  $name = $matches[2];
                  
                  $data_index[] = array("name" => $name, "type" => $name_pole, "sql" => $row);
                }
            }
          else
            $data_poles[] = array("name" => $matches[1], "sql" => $row);
          
        }
      
      return ([$data_poles, $data_index]);
    }
  
}


class split_text_separator
  {
   
   public static function parse_text_params($t,$sep = ",")
     {
      $t = trim($t);
      $mas = array();
      if ( $t )
        {
         $mas = split_text_separator::split_text_params($t,$sep);
         foreach ( $mas as $key => $value )
           {
            $v = trim($value);
            if ( $v || $v === "0" )
              {
               $mas[$key]=trim($value);
              }
             else
               {
                //echo(" err:".trim($v)." ");
                return (false);
               }
           }
        }
      return ($mas);
     }
   public static function split_text_params($t,$sep = ",")
     {
      $params = array();
      //$t = trim($t);
      if ( $t )
        {
         $part_t = "";//текст параметра
         $type_t = "";//тип текста: в кавычках ' или "
         $open_bracket = "";//открывающая скобка "("
         $prev_sim = "";//предыдущий символ
         $len = mb_strlen($t);
         $sim = "";//текущий символ
         for ( $i = 0;$i<$len;$i++ )
           {
            $sim = mb_substr($t,$i,1);
            if ( $sim === $sep )
              {
               //if ( $part_t  )
                 {
                  if ( $type_t || $open_bracket )
                    {
                     //пропускаем разделяющий символ (запятую) если он находится в кавычках или в скобках
                     $part_t .= $sim;
                    }
                   else
                     {
                      $params[] = $part_t;
                      $part_t = "";
                      
                     }
                 }
                //else
                //  return(false);
              }
             else
               {
                $part_t .= $sim;
                if ( ($sim === "'" || $sim === '"') && $prev_sim !== "\\" )
                  {
                   $type_t = $type_t ? ( $type_t === $sim ? "":$type_t ):$sim;
                  }
                 elseif ( $sim === "(" && !$type_t  )
                   {
                    $open_bracket = "(";//обнаружена открывающая скобка вне кавычек
                    
                   }
                  elseif ( $sim === ")" && !$type_t )
                    {
                     if ( $open_bracket === "(" )
                       {
                        $open_bracket = "";
                        
                       }
                      else
                        {
                         //обнаружена закрывающая кавычка, но ранее не было открывающей. 
                         //Синтаксическая ошибка, но не учитывается
                         
                        }
                     
                    }
                //$prev_sim = $sim;
                
               }
            $prev_sim = $sim;
           }
         if ( $part_t )
           $params[] = $part_t;
          elseif ( $sim === $sep )
            $params[] = "";
        }
      
      return ($params);
     }
   
  }
