<?php



$tablesCreat=array(
    
    
	"components" => "create table if not exists ".DB_PREF."components 
      (
       id_component int not null AUTO_INCREMENT,
       n_base_component int not null,
       n_component int not null,
       pos int not null,
       type_level ENUM('high','inferior'),
       hide ENUM('show','hide'),
       modul tinytext,
       ident tinytext,
       url tinytext,
       view_type_user ENUM('all','guest','user') not null,
       name_punkt tinytext not null,
       name text not null,
       teg_title text not null,
       meta_keywords text,
       meta_description text, 
       short_text text,
       all_text text,
       key_words tinytext,
       put_date int(11) UNSIGNED,
       edit_date int(11) UNSIGNED,
       kol_view int UNSIGNED,
       type_editor ENUM('wysiwyg', 'bbcode'),
       num_user int not null,
       on_comments ENUM('on','off'),
       add_comments ENUM('on','off'),
       on_add_rss ENUM('on','off'),
       text_rss text not null,
       target ENUM('self','new') not null default 'self',
       add_class text not null,
       PRIMARY KEY (id_component)
       ) ENGINE=MyISAM DEFAULT CHARSET=utf8",
	
	
    "users" => "create table if not exists ".DB_PREF."users
          (
           id_user int not null AUTO_INCREMENT,
           name_user tinytext,
           password_user tinytext,
           email_user tinytext,
           phone_user tinytext NOT NULL,
           date_create int unsigned,
           date_visit int unsigned,
           sait_user tinytext,
           about_user text,
           print_email_user ENUM('on','off'),
           access_user ENUM ('on','off'),
           activ_user ENUM ('on','off'),
           kod_activ tinytext,
           access_admin ENUM ('on','off','sadmin') default 'off',
           access_privat text not null,
           
           image_user text NOT NULL,
           on_subscribe ENUM('on','off') not null default 'on',
           get_message_admin ENUM('on','off') not null default 'on',
           get_message_user ENUM('on','off') not null default 'on',
           get_message_guest ENUM('on','off') not null default 'on',
           operation_1 ENUM('on','off') not null default 'off',
           operation_2 ENUM('on','off') not null default 'off',
           operation_3 ENUM('on','off') not null default 'off',
           money double NOT NULL default 0,
           on_partner ENUM('on','off') not null default 'off',
           partner_amount double NOT NULL default 0,
           partner_key tinytext NOT NULL,
           partner_purse tinytext NOT NULL,
           partner_invite int NOT NULL,
           partner_get_message ENUM('on','off') not null default 'off',
           notice_new_private_message ENUM('on','off') not null default 'on',
           
           type_registr ENUM ('site','social') not null default 'site',
           social_name tinytext NOT NULL,
           social_ident tinytext NOT NULL,
           social_profile tinytext NOT NULL,
           service_ident tinytext NOT NULL,
           
           note text NOT NULL,
           authorized ENUM('on','off') not null default 'off',
           date_admin int unsigned NOT NULL,
           authorized_admin ENUM('on','off') not null default 'off',
           
           type_account ENUM ('regular','business') default 'regular',
           
           "
           /*
           name_real tinytext NOT NULL,
           
           num_country int NOT NULL,
           num_region int NOT NULL,
           num_city int NOT NULL,
           name_country tinytext NOT NULL,
           name_region tinytext NOT NULL,
           name_city tinytext NOT NULL,
           
           on_company ENUM('on','off') NOT NULL default 'off',
           name_company tinytext NOT NULL,
           n_category int not null,
           add_maps ENUM('on','off') NOT NULL default 'off',
           longitude double NOT NULL,
           latitude double NOT NULL,
           */
           ."PRIMARY KEY (id_user)
          ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "downfiles" => "create table if not exists ".DB_PREF."downfiles
         (
          id_downfile int not null AUTO_INCREMENT,
          urlfile tinytext,
          namefile tinytext,
          description tinytext,
          hitsfile int,
          PRIMARY KEY (id_downfile)
         )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "news" => "create table if not exists ".DB_PREF."news 
         (
          id_news int not null AUTO_INCREMENT,
          name tinytext,
          text_news text,
          putdate int unsigned,
          hide ENUM ('show','hide'),
          arhiv ENUM ('arhiv','view'),
          preview_text_news text,
          preview_image tinytext,
          PRIMARY KEY (id_news)
         )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    /*"newsrss" => "create table if not exists ".DB_PREF."newsrss 
        (
          id_newsrss int not null AUTO_INCREMENT,
          title_rss tinytext,
          link_rss tinytext,
          description_rss text,
          pubDate_rss int unsigned,
          hide ENUM ('show','hide'),      
          PRIMARY KEY (id_newsrss)
         )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",*/
    
    "subscribe_users" => "create table if not exists ".DB_PREF."subscribe_users
         (
          id_user int not null AUTO_INCREMENT,
          name tinytext,
          email tinytext,
          status ENUM ('active','inactive'),
          date int unsigned,
          kod_active tinytext,
          PRIMARY KEY (id_user)
         )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "subscribe_news" => "create table if not exists ".DB_PREF."subscribe_news
         (
          id_news int not null AUTO_INCREMENT,
          name_news tinytext,
          text_news text,
          putdate int unsigned,
          status tinytext,
          number_sent int NOT NULL,
          auto_newline ENUM ('on','off') NOT NULL default 'off',
          type_recipient ENUM ('all','user','subscriber') NOT NULL default 'all',
          user_status ENUM ('all','usual','special') NOT NULL default 'all',
          type_account_user ENUM ('all','regular','business') NOT NULL default 'all',
          contr_code tinytext NOT NULL,
          sent_date int unsigned NOT NULL default 0,
          PRIMARY KEY (id_news)
         )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "comments" => "create table if not exists ".DB_PREF."comments
        (
         id_comment int not null AUTO_INCREMENT,
         com_text text,
         com_name tinytext,
         com_email tinytext,
         com_sait tinytext,
         type_user ENUM ('guest','user','admin'),
         num_user int NOT NULL,
         hide ENUM ('show','hide'),
         putdate int unsigned,
         com_ip tinytext,
         com_moder ENUM ('new','view'),
         num_modul int,
         num_element int,
         answ_num_comment int NOT NULL,
         answ_num_comment2 int NOT NULL,
         is_get_email ENUM('yes','no') NOT NULL default 'yes',
         
         PRIMARY KEY (id_comment)
        )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "comments_count"=>"create table if not exists ".DB_PREF."comments_count
        (
         id_count int not null AUTO_INCREMENT,
         num_modul int,
         num_element int,
         count_com int NOT NULL default 0,
         put_date int unsigned NOT NULL,
         
         PRIMARY KEY (id_count),
         INDEX search1 (num_modul,num_element)
        ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    /*
    "private_message" => "create table if not exists ".DB_PREF."private_message
        (
         id_private_message int not null AUTO_INCREMENT,
         name_message text NOT NULL,
         text_message text NOT NULL,
         
         putdate int unsigned NOT NULL,
         
         num_user int NOT NULL,
         sent_user int NOT NULL,
         recipient_user int NOT NULL,
         
         type_box ENUM ('sent','inbox') NOT NULL default 'sent',
         on_read ENUM ('on','off') NOT NULL default 'off',
         hide ENUM ('show','hide') NOT NULL default 'show',
         moder ENUM ('new','view') NOT NULL default 'new',
         
         ip_adr tinytext NOT NULL,
         info_user_agent tinytext NOT NULL,
         
         PRIMARY KEY (id_private_message)
        )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    */
    /* модуль html-блоков */
    "html_bloks" => "create table if not exists ".DB_PREF."html_bloks
        (
         id_blok int not null AUTO_INCREMENT,
         name_blok tinytext,
         hide_blok ENUM('hide','show'),
         name_part tinytext,
         pos_blok int,
         text_blok text,
         view_page text NOT NULL,
         PRIMARY KEY (id_blok)
        )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "qonline" => "create table if not exists ".DB_PREF."qonline
        (
         id_qonline int not null AUTO_INCREMENT,
         name_user tinytext,
         email_user tinytext,
         text_q text,
         type ENUM('new','view'),
         putdate int unsigned,
         ip_adr tinytext,
         dop_info tinytext,
         PRIMARY KEY (id_qonline)
        )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "files"=>"create table if not exists ".DB_PREF."files
         (
          id_files int not null AUTO_INCREMENT,
          num_modul int,
          num_element int,
          namefile1 tinytext NOT NULL,
          namefile2 tinytext NOT NULL,
          title text,
          description text,
          pos int,
          base_namefile1 tinytext NOT NULL,
          base_namefile2 tinytext NOT NULL,
          type tinytext NOT NULL,
          info text NOT NULL,
          put_date int unsigned NOT NULL,
          edit_date int unsigned NOT NULL,
          
          PRIMARY KEY (id_files)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    // модуль вопрос-ответ
    "faq_group" => "CREATE TABLE if not exists ".DB_PREF."faq_group
        (
          id_group int(11) unsigned NOT NULL AUTO_INCREMENT,
          hide ENUM ('show','hide') NOT NULL,
          name_group text NOT NULL,
          pos int not null,
          PRIMARY KEY  (id_group)
        ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    "faq_item" => "CREATE TABLE if not exists ".DB_PREF."faq_item
        (
          id_item int(11) unsigned NOT NULL AUTO_INCREMENT,
          hide ENUM ('show','hide'),
          n_group int(11) unsigned not null,
          name_item text NOT NULL,
          text_item text NOT NULL,
          pos int not null,
          
          PRIMARY KEY  (id_item)
        ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    //модуль статей (каталог статей)
    "article_category"=>"create table if not exists ".DB_PREF."article_category
         (
          id_category int not null AUTO_INCREMENT,
          type ENUM ('high','inferior'),
          n_category int NOT NULL,
          hide ENUM ('show','hide'),
          name tinytext,
          pos int,
          
          title_category tinytext NOT NULL,
          teg_title text not null,
          meta_keywords text NOT NULL,
          meta_description text NOT NULL,
          short_text text NOT NULL,
          all_text text NOT NULL,
          image tinytext NOT NULL,
          name_url tinytext NOT NULL,
          
          PRIMARY KEY (id_category)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "article_item"=>"create table if not exists ".DB_PREF."article_item
         (
          id_item int not null AUTO_INCREMENT,
          email tinytext NOT NULL,
          site tinytext NOT NULL,
          
          address tinytext NOT NULL,
          phone tinytext NOT NULL,
          key_words tinytext NOT NULL,
          add_text text NOT NULL,
          all_text text NOT NULL,
          short_text text NOT NULL,
          image text NOT NULL,
          
          hide ENUM ('show','hide') NOT NULL,
          moder ENUM ('new','view') NOT NULL,
          start_putdate int unsigned NOT NULL,
          end_putdate int unsigned NOT NULL,
          redak_putdate int unsigned NOT NULL,
          
          n_category int not null,
          kolvo_view int,
          name_item tinytext NOT NULL,
          teg_title text NOT NULL,
          meta_keywords text NOT NULL,
          meta_description text NOT NULL, 
          
          country_item int NOT NULL,
          region_item int NOT NULL,
          city_item int NOT NULL,
          
          name_country_item tinytext NOT NULL,
          name_region_item tinytext NOT NULL,
          name_city_item tinytext NOT NULL,
          
          abuse ENUM('on','off') NOT NULL default 'off',
          
          num_user int NOT NULL,
          
          sort_time int unsigned default 0,
          
          num_type_display tinyint NOT NULL,
          
          on_comments ENUM('on','off') NOT NULL default 'on',
          add_comments ENUM('on','off') NOT NULL default 'on',
          is_get_email ENUM('yes','no') default 'yes',
          
          access_user_authorize ENUM('yes','no') default 'no',
          access_user_status_1 ENUM('yes','no') default 'no',
          name_url tinytext NOT NULL,
          hash_text text NOT NULL,
          
          robots_index ENUM('yes','no') NOT NULL default 'yes',
          date_last_view int unsigned NOT NULL default 0,
          
          PRIMARY KEY (id_item),
          FULLTEXT poisk_all_text (all_text),
          FULLTEXT poisk_short_text (short_text),
          FULLTEXT poisk_name_object (name_item),
          FULLTEXT poisk_key_words (key_words)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "article_quantity_item"=>"create table if not exists ".DB_PREF."article_quantity_item
         (
          id_item int not null AUTO_INCREMENT,
          
          country int NOT NULL default 0,
          region int NOT NULL default 0,
          city int NOT NULL default 0,
          n_top_category int NOT NULL,
          n_category int NOT NULL,
          
          quantity int NOT NULL default 0,
          
          PRIMARY KEY (id_item)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "article_series_category"=>"create table if not exists ".DB_PREF."article_series_category
         (
          id_item int not null AUTO_INCREMENT,
          
          n_category int NOT NULL default 0,
          num_nested int NOT NULL default 0,
          
          PRIMARY KEY (id_item)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "stop_ip_adr" => "CREATE TABLE if not exists ".DB_PREF."stop_ip_adr
         (
          id_ip_adr int NOT NULL auto_increment,
          ip_adr tinytext NOT NULL,
          PRIMARY KEY (id_ip_adr)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "log_money" => "CREATE TABLE if not exists ".DB_PREF."log_money
         (
          id_log_money int NOT NULL auto_increment,
          num_user int NOT NULL,
          description text NOT NULL,
          cost double NOT NULL,
          putdate int unsigned NOT NULL,
          type_oper tinytext NOT NULL,
          type_ps tinytext NOT NULL,
          PRIMARY KEY (id_log_money)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "code_active_email" => "CREATE TABLE if not exists ".DB_PREF."code_active_email
         (
          id_code int NOT NULL auto_increment,
          email tinytext NOT NULL,
          code tinytext NOT NULL,
          putdate int unsigned NOT NULL,
          PRIMARY KEY (id_code)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "code_active_phone" => "CREATE TABLE if not exists ".DB_PREF."code_active_phone
         (
          id_code int NOT NULL auto_increment,
          phone tinytext NOT NULL,
          code tinytext NOT NULL,
          putdate int unsigned NOT NULL,
          PRIMARY KEY (id_code)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "stop_email" => "CREATE TABLE if not exists ".DB_PREF."stop_email
         (
          id_email int NOT NULL auto_increment,
          email tinytext NOT NULL,
          PRIMARY KEY (id_email)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "stop_phone" => "CREATE TABLE if not exists ".DB_PREF."stop_phone
         (
          id_phone int NOT NULL auto_increment,
          phone tinytext NOT NULL,
          PRIMARY KEY (id_phone)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "block_spacecom" => "create table if not exists ".DB_PREF."block_spacecom
        (
         id_block int not null AUTO_INCREMENT,
         name_block tinytext NOT NULL,
         hide_block ENUM('hide','show') NOT NULL,
         name_part tinytext NOT NULL,
         pos_block int NOT NULL,
         width_block int NOT NULL,
         height_block int NOT NULL,
         template_block text NOT NULL,
         align_block ENUM('','off','left','center','right') NOT NULL default '',
         type_place int NOT NULL,
         PRIMARY KEY (id_block)
        )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "spacecom" => "create table if not exists ".DB_PREF."spacecom
        (
         id_spacecom int not null AUTO_INCREMENT,
         num_block int NOT NULL,
         hide ENUM('hide','show') NOT NULL,
         filename tinytext NOT NULL,
         filetype tinytext NOT NULL,
         width_img int NOT NULL default 0,
         height_img int NOT NULL default 0,
         kolview int NOT NULL,
         kolview_limit int NOT NULL,
         link tinytext NOT NULL,
         block_link ENUM('on','off') NOT NULL default 'off',
         putdate int unsigned NOT NULL,
         start_date int unsigned NOT NULL,
         end_date int unsigned NOT NULL,
         redirect ENUM('on','off') NOT NULL default 'on',
         new_window ENUM('on','off') NOT NULL default 'on',
         quantity_click int NOT NULL,
         spacecom_text text NOT NULL,
         title text NOT NULL,
         align ENUM('','off','left','center','right') NOT NULL default '',
         view_page text NOT NULL,
         view_geo text NOT NULL,
         type_spc ENUM('banner','text','img_text','img_title_text') NOT NULL default 'img_text',
         template_show tinytext NOT NULL,
         date_last_view int unsigned NOT NULL default 0,
         date_last_click int unsigned NOT NULL default 0,
         PRIMARY KEY (id_spacecom)
        )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "guest" =>  "create table if not exists ".DB_PREF."guest
         (
          id_message int not null AUTO_INCREMENT,
          m_text text,
          m_name tinytext,
          m_email tinytext,
          m_sait tinytext,
          hide ENUM ('show','hide'),
          mes_putdate int unsigned,
          m_ip tinytext,
          m_answer text,
          ans_putdate int unsigned,
          m_moder ENUM ('new','view'),
          PRIMARY KEY (id_message)
         )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "promocode" => "CREATE TABLE if not exists ".DB_PREF."promocode
        (
         id_promocode int NOT NULL auto_increment,
         promocode tinytext NOT NULL,
         modul tinytext NOT NULL,
         service tinytext NOT NULL,
         put_date int unsigned NOT NULL,
         start_date int unsigned NOT NULL,
         end_date int unsigned NOT NULL,
         last_used_date int unsigned NOT NULL,
         quantity_max int NOT NULL,
         quantity_use int NOT NULL,
         type_limit_quantity ENUM('total_uses','one_user') NOT NULL default 'total_uses',
         used ENUM('on','off') NOT NULL default 'off',
         locked ENUM('on','off') NOT NULL default 'off',
         generate ENUM('admin','auto') NOT NULL default 'auto',
         num_user int NOT NULL,
         
         PRIMARY KEY (id_promocode)
        ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "promocode_log" => "CREATE TABLE if not exists ".DB_PREF."promocode_log
        (
         id_log int NOT NULL auto_increment,
         num_promocode int NOT NULL,
         num_user int NOT NULL,
         put_date int unsigned NOT NULL,
         PRIMARY KEY (id_log)
        ) ENGINE=MyISAM  DEFAULT CHARSET=utf8",
    
    "payment_order" => "CREATE TABLE if not exists ".DB_PREF."payment_order
        (
         id_order int NOT NULL auto_increment,
         payment_name tinytext NOT NULL,
         modul tinytext NOT NULL,
         amount double NOT NULL default 0,
         oper tinytext NOT NULL,
         number int NOT NULL,
         param tinytext NOT NULL,
         service_amount double NOT NULL default 0,
         num_user int NOT NULL,
         put_date int unsigned NOT NULL,
         paid ENUM('on','off') NOT NULL default 'off',
         PRIMARY KEY (id_order)
        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;",
    
    "authorization" => "CREATE TABLE if not exists ".DB_PREF."authorization
        (
         id_authorization int NOT NULL auto_increment,
         name_user tinytext NOT NULL,
         num_user int NOT NULL,
         ip_adr tinytext NOT NULL,
         put_date int unsigned NOT NULL,
         blocked ENUM('on','off') NOT NULL default 'off',
         enter ENUM('on','off') NOT NULL default 'off',
         point ENUM('user','admin') NOT NULL default 'user',
         
         PRIMARY KEY (id_authorization)
        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;",
    
    "msender" => "CREATE TABLE if not exists ".DB_PREF."msender
        (
         id_msender int NOT NULL auto_increment,
         title tinytext NOT NULL,
         message text NOT NULL,
         put_date int unsigned NOT NULL,
         sent_date int unsigned NOT NULL,
         last_date int unsigned NOT NULL default 0,
         status ENUM('new','load','onload','active','onsend','error') NOT NULL default 'new',
         mode ENUM('manual','auto') NOT NULL default 'auto',
         perem text NOT NULL,
         modul tinytext NOT NULL,
         ident int NOT NULL,
         contr_code tinytext NOT NULL,
         PRIMARY KEY (id_msender)
        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;",
    
    "msender_contacts" => "CREATE TABLE if not exists ".DB_PREF."msender_contacts
        (
         id_contact int NOT NULL auto_increment,
         name tinytext NOT NULL,
         email tinytext NOT NULL,
         num_msender int NOT NULL,
         status ENUM('new','sent','error') NOT NULL default 'new',
         perem text NOT NULL,
         PRIMARY KEY (id_contact)
        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;",
    
    "messenger" => "CREATE TABLE if not exists ".DB_PREF."messenger
        (
         id_messenger int NOT NULL auto_increment,"
         /*num_modul int NOT NULL,
         num_element int NOT NULL,*/
         ."
         num_author int NOT NULL,
         num_recipient int NOT NULL,
         status_author int NOT NULL,
         status_recipient int NOT NULL,
         message text NOT NULL,
         putdate int unsigned,
         onread ENUM('on','off') NOT NULL default 'off',
         
         PRIMARY KEY (id_messenger),
         INDEX search_1 (num_author,num_recipient,onread)
        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;",
    
    "slideshow_item" => "create table if not exists ".DB_PREF."slideshow_item
         (
          id_item int not null AUTO_INCREMENT,
          hide ENUM ('show','hide') NOT NULL default 'show',
          link tinytext NOT NULL,
          name tinytext NOT NULL,
          pos int NOT NULL,
          image tinytext NOT NULL,
          new_window ENUM('on','off') NOT NULL default 'off',
          
          PRIMARY KEY (id_item)
         ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "backcon" => "create table if not exists ".DB_PREF."backcon
        (
         id_backcon int not null AUTO_INCREMENT,
         name tinytext NOT NULL,
         email tinytext NOT NULL,
         phone tinytext NOT NULL,
         message text NOT NULL,
         status ENUM('new','view') NOT NULL default 'new',
         putdate int unsigned,
         ip_adr tinytext,
         dop_info tinytext,
         PRIMARY KEY (id_backcon)
        )ENGINE=MyISAM  DEFAULT CHARSET=utf8;",
    
    "user_behavior" => "create table if not exists ".DB_PREF."user_behavior
        (
         id_item int NOT NULL AUTO_INCREMENT,
         id_visitor varchar(32) NOT NULL,
         num_user int NOT NULL,
         modul int NOT NULL,
         oper varchar(32) NOT NULL,
         vnum1 int NOT NULL,
         vnum2 int NOT NULL,
         vnum3 int NOT NULL,
         vtext text NOT NULL,
         vinfo text NOT NULL,
         putdate int unsigned NOT NULL,
         ip_adr tinytext NOT NULL,
         dop_info tinytext NOT NULL,
         PRIMARY KEY (id_item),
         INDEX search3 (id_visitor,modul,oper,putdate)
        )ENGINE=MyISAM  DEFAULT CHARSET=utf8;"
    
    );
