<?php


class eng_article_page_all_item extends eng_gen_article_page
{
  /**
   * @var $obj_modul article_class
   */
  protected $obj_modul;
  
  protected $data_all_item = array();
  
  protected $add_param_url = array();
  
  protected $base_url_page = [];
  protected $data_light_search = [];
  protected $kolvo_vsego_all_item = 0;
  protected $open_num_page_all_item = 0;
  
  protected $name_sort = "";
  protected $type_sort = "";
  
  function first_init()
    {
      $this->mas_name_copy=["name_sort","type_sort","base_url_page"];
      
      //$this->data_block_navigation = &$this->obj_modul->data_block_navigation;
      $this->add_param_url = &$this->obj_modul->add_param_url;
      $this->data_light_search = &$this->obj_modul->data_light_search;
      
      return (true);
    }
  
  function control_data()
    {
      
      global $masConfig;
      /*
      $this->data_all_item = array();
      
      $this->add_param_url = array();
      */
      $db_query_stext = "";
      $db_query_exists_images = "";
      
      if ($this->mas_inbox['geo'])
        {
          list($error, $mas_geo) = $this->obj_modul->check_geo_param_url($this->mas_inbox["geo"]);
          if ($error)
            {
              return (false);
            }
        }
      
      $this->obj_modul->check_is_add_param_url_open_page(array("m", "k", "smgeo", "page"));
      
      $t_db_query_category = $this->obj_modul->get_text_db_query_part_category("item.n_category", 0);
      
      if ($this->mas_inbox["s_text"])
        {
          $this->add_param_url["s_text"] = $this->mas_inbox["s_text"];
          
          $this->data_light_search["s_text"] = $this->mas_inbox["s_text"];
          
          list($mas_words, $is_min_length) = process_text_search($this->mas_inbox["s_text"], 3, 60);
          //$s_text = codeText($this->mas_inbox["s_text"]);
          //var_dump($mas_words,$is_min_length);
          if (sizeof($mas_words))
            {
              $db_query_stext .= " and ( ";
              $sep = "";
              foreach ($mas_words as $one_word)
                {
                  $db_query_stext .= $sep." ( "
                    ." item.all_text LIKE '%".$one_word."%' "
                    ." or item.short_text LIKE '%".$one_word."%' "
                    //." or item.key_words LIKE '%".$one_word."%' "
                    ." ) ";
                  $sep = " or ";
                }
              $db_query_stext .= " ) ";
            }
          
        }
      
      $this->data_light_search["exists_images"] = "off";
      if ($this->status_inbox["exists_images"] == "set")
        {
          $this->data_light_search["exists_images"] = "on";
          $db_query_exists_images = " and item.image != '' ";
          $this->add_param_url["s_exists_images"] = "on";
        }
      
      
      $db_query = "select count(*) "
        ." from ".DB_PREF."article_item item "
        ." where "
        //." item.n_category IN (".$this->list_id_inferiorcategory(false,true).") "
        .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
        ." item.hide='show' "
        .$db_query_stext.$db_query_exists_images
        .$this->obj_modul->add_db_query_country().$this->obj_modul->add_db_query_region().$this->obj_modul->add_db_query_city();
      
      $this->kolvo_vsego_all_item = db_work::query_count($db_query);
      
      if ($this->status_inbox["num_page"] == "set")
        {
          $this->open_num_page_all_item = $this->mas_inbox["num_page"];
          $this->openOnGetNumPage = true;
        }
      else
        {
          $this->open_num_page_all_item = 1;
        }
      
      $this->openNumPage = $this->open_num_page_all_item;
      
      if ($this->status_inbox["sort"] == "set")
        {
          $this->name_sort = $this->mas_inbox["sort"];
          $this->type_sort = $this->mas_inbox["tsort"];
          
        }
      
      if ($this->kolvo_vsego_all_item == 0)
        {
          if ($this->open_num_page_all_item != 1)
            {
              return (false);
            }
        }
      else
        {
          
          global $init_sort_articleItem;
          
          $db_query = "select item.id_item, "
            ." item.name_item, item.short_text, item.image, item.start_putdate, 
            item.name_country_item, item.name_region_item,item.name_city_item,
            item.n_category,
            item.country_item, item.region_item, item.city_item, item.name_url 
            from ".DB_PREF."article_item item  "
            ." where "
            //." item.n_category IN (".$this->list_id_inferiorcategory(false,true).") "
            .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
            ." item.hide='show' "
            .$db_query_stext.$db_query_exists_images
            .$this->obj_modul->add_db_query_country().$this->obj_modul->add_db_query_region().$this->obj_modul->add_db_query_city()
            ." order by "
            .($this->name_sort ? " ".$init_sort_articleItem[$this->name_sort]." ".$this->type_sort." " : " sort_time DESC, start_putdate DESC ")
            ." limit ".($this->open_num_page_all_item - 1) * KOL_ARTICLE_ITEM_TO_ALL_PAGE." , ".KOL_ARTICLE_ITEM_TO_ALL_PAGE;
          list($kolvo, $this->data_all_item) = obr_db_query_select_assoc($db_query);
          
          if ($kolvo == 0) return (false);
          
          if ($masConfig["ON_USE_GEO_DATA"] == 1 && $masConfig["ON_USE_GEO_LINK_ARTICLE_ITEM"] == 1)
            {
              global $obj_geoData;
              $obj_geoData->add_data_mas_for_extract_geo($this->data_all_item, array("country_item", "region_item",
                "city_item"
              ));
            }
          
        }
      
      $this->base_url_page = $this->dir_http.$this->obj_modul->forming_geo_in_url_category()."/allarticle/";
      
      $korekParam = true;
      
      
      $this->openNsrlKeyComponent = "3";
      //$this->openNsrlComponentIdent = ( sizeof( $mas_list_num ) ) ? $mas_list_num : 0;
      
      
      return (true);
    }
  
  function forming_data()
    {
      
      global $mas_value_template, $tpl, $masConfig;
      $mas_perem = $mas_value_template;
      $mas_perem["masConfig"] = $masConfig;
      
      $t_geo = "";
      $url_geo = "";
      
      if ($masConfig["ON_USE_GEO_DATA"] == 1 && $masConfig["ON_USE_GEO_LINK_ARTICLE_ITEM"] == 1)
        {
          global $obj_geoData;
          $t_geo = $obj_geoData->get_text_name_view_geo_data();
          $url_geo = $obj_geoData->forming_geo_in_url_main_setting();
        }
      
      $t_num_page = ($this->open_num_page_all_item > 1 ? " - Страница ".$this->open_num_page_all_item : "");
      
      $this->title = "Все статьи".($t_geo ? " - ".$t_geo." " : "").$t_num_page;
      $this->title_text = "Все статьи".$t_num_page;
      
      $this->mas_navigation_pointer[] = array("Все статьи");
      
      $mas_perem["url_geo"] = $url_geo;
      $mas_perem["kolvo_vsego_all_item"] = $this->kolvo_vsego_all_item;
      
      $mas_perem["data_row"] = $this->data_all_item;
      $mas_perem["kolvo_vsego_all_item"] = $this->kolvo_vsego_all_item;
      $mas_perem["open_num_page_all_item"] = $this->open_num_page_all_item;
      
      
      //global $init_currency;
      //$mas_perem["init_currency"] = $init_currency;
      
      $mas_perem["dir_http_template_modul"] = $this->obj_modul->dir_http_template_modul;
      
      $mas_perem["obj_article"] = &$this->obj_modul;
      
      $this->text = "";
      
      $tpl->template_dir = $this->obj_modul->dir_template_mfile."/";
      
      $tpl->assign($mas_perem);
      $this->text = $tpl->fetch("forming_block_oper.html");
      
      $tpl->template_dir = $this->obj_modul->dir_template_mfile."/page/";
      
      $tpl->assign($mas_perem);
      $this->text .= $tpl->fetch("all_item.html");
      
      
      return (true);
    }
  
}

