<?php


class eng_article_page_item extends eng_gen_article_page
{
  /**
   * @var $obj_modul article_class
   */
  protected $obj_modul;
  
  protected $kol_next_item = 0;
  protected $kol_previous_item = 0;
  protected $data_next_item = array();
  protected $data_previous_item = array();
  
  protected $on_access_item = true;
  protected $text_alert_not_access_item = "";
  
  protected $data_select_item = [];
  
  protected $num_page_comments_item = 1;
  
  protected $url_item_view = "";
  protected $select_item = 0;
  protected $open_num_item = 0;
  
  protected $open_num_podcategory = 0; 
  protected $select_podcategory = 0;
  protected $open_num_category = 0;
  protected $select_category = 0;
  
  protected $data_open_category = [];
  protected $data_open_podcategory = [];
  protected $num_open_lvl_category = 0;
  
  protected $data_block_navigation = [];
  
  protected $on_noindex_page = false;
  
  function first_init()
    {
      $this->mas_name_copy=["open_num_category","open_num_podcategory","num_open_lvl_category",
       "data_open_category","data_open_podcategory","on_noindex_page"];
      
      $this->data_block_navigation = &$this->obj_modul->data_block_navigation;
      
      return (true);
    }
  
  function control_data()
    {
      
      //$this->data_next_item = array();
      //$this->data_previous_item = array();
      
      $this->on_access_item = true;
      $this->text_alert_not_access_item = "";
      
      $mas_list_num = array();
      
      $db_query = "select * from ".DB_PREF."article_item where id_item = ".$this->mas_inbox["id_item"]." and hide='show' ";
      list($kolvo_item, $this->data_select_item) = obr_db_query_select_one_assoc($db_query);
      
      $this->num_page_comments_item = 1;
      
      if ($kolvo_item == 0)
        {
          return (false);
        }
      
      $on_redirect = false;
      $name_url_item = $this->obj_modul->forming_name_url_item($this->data_select_item);
      //var_dump($name_url_item);
      
      global $obj_geoData, $masConfig;
      
      if ($this->status_inbox["name_item"] == "set")
        {
          $t_url_item = $this->mas_inbox["name_item"];
          if (
            $masConfig["ON_USE_GEO_DATA"] == 1 && $masConfig["ON_USE_GEO_LINK_ARTICLE_ITEM"] == 1
            && ($this->data_select_item["country_item"] > 0 && $this->data_select_item["region_item"] > 0 && $this->data_select_item["city_item"] > 0)
          )
            {
              
              list($error_data, $part_url_name_item) = $obj_geoData->check_geo_mas_data_url_param($t_url_item, array($this->data_select_item["country_item"],
                $this->data_select_item["region_item"], $this->data_select_item["city_item"]
              ));
              if ($error_data) $on_redirect = true;
              
            }
          else
            {
              $part_url_name_item = $t_url_item;
            }
          
          if ($part_url_name_item !== $name_url_item) $on_redirect = true;
          //if ( $this->mas_inbox["name_item"] !== $name_url_item ) $on_redirect = true;
        }
      else
        {
          $on_redirect = true;
        }
      
      //добавляем гео-данные
      $t_url_geo = "";
      if ($masConfig["ON_USE_GEO_DATA"] == 1 && $masConfig["ON_USE_GEO_LINK_ARTICLE_ITEM"] == 1)
        {
          $t_url_geo = forming_geo_part_name_url_article($this->data_select_item);
        }
      
      $this->url_item_view = $this->dir_http.$t_url_geo."/".$name_url_item."-art".$this->mas_inbox["id_item"].".html";
      
      if ($on_redirect)
        {
          header("Location: ".$this->url_item_view, true, 301);
          exit ();
        }
      
      
      $this->select_item = $this->mas_inbox["id_item"];
      $id_podcat = $this->data_select_item["n_category"];
      
      $mas_serias_lvl_num_category = $this->obj_modul->serias_lvl_num_category($id_podcat);
      if (!$mas_serias_lvl_num_category) return (false);
      
      $mas_list_num = $mas_serias_lvl_num_category;
      
      $kolvo_lvl = sizeof($mas_serias_lvl_num_category);
      
      if ($this->data_select_item["access_user_authorize"] == "yes" && !$GLOBALS["user_to_site"])
        {
          $this->on_access_item = false;
          $this->text_alert_not_access_item = "Страница доступна только зарегистрированным пользователям!";
          $this->on_noindex_page = true;
        }
      
      if (
        $this->on_access_item && $this->data_select_item["access_user_status_1"] == "yes" &&
        !($GLOBALS["user_to_site"] && $GLOBALS["data_authorize_user"] && $GLOBALS["data_authorize_user"]["operation_1"] == "on")
      )
        {
          $this->on_access_item = false;
          $this->text_alert_not_access_item = "У вас нет доступа к этой странице!";
          $this->on_noindex_page = true;
        }
      
      
      //write_log_cms($data["name_podcat"]." ".$data["name_cat"]." ".$data["id_podcategory"]." ".$data["id_category"]);
      
      $this->select_podcategory = $mas_serias_lvl_num_category[$kolvo_lvl - 1];//$this->data_cat_podcat_to_item["id_podcategory"];
      $this->select_category = $mas_serias_lvl_num_category[0];//$this->data_cat_podcat_to_item["id_category"];
      
      $this->open_num_podcategory = $this->select_podcategory;
      $this->open_num_category = $this->select_category;
      
      $this->data_open_category = $this->obj_modul->obj_cache_category->get_one_num_data($this->open_num_category);
      if ($this->open_num_podcategory > 0)
        {
          $this->data_open_podcategory = $this->obj_modul->obj_cache_category->get_one_num_data($this->open_num_podcategory);
        }
      
      $this->num_open_lvl_category = $this->open_num_podcategory > 0 ? $this->open_num_podcategory : $this->open_num_category;
      
      $this->data_block_navigation["num_lvl_category"] = $this->num_open_lvl_category;
      if ($this->open_num_podcategory > 0)
        {
          $this->data_block_navigation["data_open_lvl_category"] = $this->data_open_podcategory;
        }
      else
        {
          $this->data_block_navigation["data_open_lvl_category"] = $this->data_open_category;
        }
      
      //$this->data_block_navigation["data_lvl_podcategory"]=$this->get_mas_nested_category($this->num_open_lvl_category);
      $this->data_block_navigation["series_num_lvl_category"] = $mas_serias_lvl_num_category;
      
      $url_part_category = "";
      if ($this->open_num_category > 0)
        {
          if ($this->open_num_podcategory > 0)
            {
              $url_part_category = "/".$this->obj_modul->forming_name_url_category($this->open_num_podcategory, 'inferior');
            }
          else
            {
              $url_part_category = "/".$this->obj_modul->forming_name_url_category($this->open_num_category, 'high');
            }
        }
      $this->data_block_navigation["url_part_category"] = $url_part_category;
      
      
      if ($this->obj_modul->on_view_quantity_item_category)
        {
          $mas_series_num_category = $this->obj_modul->serias_lvl_num_category($this->num_open_lvl_category);
          //$mas_num_nested_category=$this->obj_cache_category->get_mas_num_nested_data($this->num_open_lvl_category, false);
          $mas_num_get_quantity = $mas_series_num_category;//array_merge($mas_series_num_category,$mas_num_nested_category);
          
          $this->data_block_navigation["quantity_item_category"] = $this->obj_modul->obj_cache_db->get_quantity_item_mas_num_category($mas_num_get_quantity, $this->obj_modul->user_view_country, $this->obj_modul->user_view_region, $this->obj_modul->user_view_city);
        }
      
      
      $this->obj_modul->addKolOpenItem($this->select_item);
      
      if ($this->data_select_item["robots_index"] == "no")
        {
          $this->on_noindex_page = true;
        }
      
      //дополнительные (похожие) статьи на странице отображения статьи
      $kolvo_add = intval(KOL_ADDITIONALLY_ARTICLE_ITEM);
      $kolvo_add = ($kolvo_add > 0 ? $kolvo_add : 10);
      
      $kolvo_add_1 = ceil($kolvo_add / 2);
      
      // возьмем максимальное количество, позже выберем необходимое
      $db_query = "select * from ".DB_PREF."article_item item where id_item > ".$this->select_item.
        $this->obj_modul->add_db_query_country().$this->obj_modul->add_db_query_region().$this->obj_modul->add_db_query_city().
        " and hide='show' and n_category=".$id_podcat.
        "  order by id_item ASC limit ".$kolvo_add;// KOL_ADDITIONALLY_ARTICLE_ITEM;
      
      list($this->kol_next_item, $this->data_next_item) = obr_db_query_select_assoc($db_query);
      
      $this->data_next_item = array_reverse($this->data_next_item);
      
      // возьмем максимальное количество, позже выберем необходимое
      $db_query = "select * from ".DB_PREF."article_item item where id_item < ".$this->select_item.
        " and hide='show' and n_category=".$id_podcat.
        $this->obj_modul->add_db_query_country().$this->obj_modul->add_db_query_region().$this->obj_modul->add_db_query_city().
        "  order by id_item DESC limit ".$kolvo_add;// KOL_ADDITIONALLY_ARTICLE_ITEM;
      
      list($this->kol_previous_item, $this->data_previous_item) = obr_db_query_select_assoc($db_query);
      
      if ($this->kol_next_item + $this->kol_previous_item > $kolvo_add)
        {
          $kolvo_1 = 0;
          $kolvo_2 = 0;
          if ($this->kol_next_item >= $kolvo_add_1 && $this->kol_previous_item < $kolvo_add_1)
            {
              $kolvo_2 = $this->kol_previous_item;
              $kolvo_1 = $kolvo_add - $kolvo_2;
              if ($kolvo_1 > $this->kol_next_item) $kolvo_1 = $this->kol_next_item;
            }
          elseif ($this->kol_next_item < $kolvo_add_1 && $this->kol_previous_item >= $kolvo_add_1)
            {
              $kolvo_1 = $this->kol_next_item;
              $kolvo_2 = $kolvo_add - $kolvo_1;
              if ($kolvo_2 > $this->kol_previous_item) $kolvo_2 = $this->kol_previous_item;
            }
          else
            {
              $kolvo_1 = $kolvo_add_1;
              if ($kolvo_1 > $this->kol_next_item) $kolvo_1 = $this->kol_next_item;
              $kolvo_2 = $kolvo_add - $kolvo_1;
              if ($kolvo_2 > $this->kol_previous_item) $kolvo_2 = $this->kol_previous_item;
            }
          
          if ($kolvo_1 > 0)
            {
              $this->data_next_item = array_slice($this->data_next_item, -$kolvo_1, $kolvo_1);
              $this->kol_next_item = sizeof($this->data_next_item);
            }
          else
            {
              $this->kol_next_item = 0;
              $this->data_next_item = [];
            }
          
          if ($kolvo_2 > 0)
            {
              $this->data_previous_item = array_slice($this->data_previous_item, 0, $kolvo_2);
              $this->kol_previous_item = sizeof($this->data_previous_item);
            }
          else
            {
              $this->kol_previous_item = 0;
              $this->data_previous_item = [];
            }
        }
      
      if ($this->kol_next_item > 0 && $masConfig["ON_USE_GEO_DATA"] == 1 && $masConfig["ON_USE_GEO_LINK_ARTICLE_ITEM"] == 1)
        {
          global $obj_geoData;
          $obj_geoData->add_data_mas_for_extract_geo($this->data_next_item, array("country_item", "region_item",
            "city_item"
          ));
        }
      
      if ($this->kol_previous_item > 0 && $masConfig["ON_USE_GEO_DATA"] == 1 && $masConfig["ON_USE_GEO_LINK_ARTICLE_ITEM"] == 1)
        {
          global $obj_geoData;
          $obj_geoData->add_data_mas_for_extract_geo($this->data_previous_item, array("country_item", "region_item",
            "city_item"
          ));
        }
      
      /*
      if ( ON_COMMENTS_ARTICLE_ITEM == 1 )
        {
         //проверим данные комментариев
         if ( $this->status_inbox["num_page_comment"] == "set" )
           {
            $num_page_comment = $this->mas_inbox["num_page_comment"];
            if ( $num_page_comment > 0 )
              $num_page_comment = (int) round($num_page_comment);
             else
               $num_page_comment = 1;
            $this->num_page_comments_item = $num_page_comment;
           }
         global $obj_site;
         $err_baz=$obj_site->save_data_comments($this->num_page_comments_item,"article",$this->select_item,"pcomad", $this->data_select_item["on_comments"] == "on" ? true : false , $this->data_select_item["add_comments"] == "on" ? true:false );
        }
      */
      $this->open_num_item = $this->select_item;
      $this->openComponentIdent = $this->open_num_item;
      
      $korekParam = true;
      
      
      $this->openNsrlKeyComponent = "5";
      $this->openNsrlComponentIdent = (sizeof($mas_list_num)) ? $mas_list_num : 0;
      
      //$this->openNsrlPageOnRelative = true;
      
      
      return (true);
    }
  
  function forming_data()
    {
      
      global $obj_site, $dir_http;
      
      global $mas_value_template, $tpl, $masConfig;
      $mas_perem = $mas_value_template;
      $mas_perem["masConfig"] = $masConfig;
      
      $row = $this->data_select_item;
      $title = trim($row["teg_title"]) ? codeHtmlText($row["teg_title"]) : codeHtmlText($row["name_item"]);
      if ($masConfig["ON_USE_GEO_DATA"] == 1 && $masConfig["ON_USE_GEO_LINK_ARTICLE_ITEM"] == 1 && $row["city_item"] > 0)
        {
          $title .= " - ";
          if (NUM_COUNTRY == 0)
            {
              $title .= $row["name_country_item"]." , ";
            }
          if (NUM_REGION == 0)
            {
              $title .= $row["name_region_item"]." , ";
            }
          $title .= $row["name_city_item"];
        }
      
      $this->title=$title;
      
      $this->title_text = codeHtmlText($row["name_item"]);
      
      $this->description = $row["meta_description"];
      $this->keywords = $row["meta_keywords"];
      
      $mas_links = $this->obj_modul->forming_mas_links_series_category_from_num($this->open_num_podcategory > 0 ? $this->open_num_podcategory : $this->open_num_category);
      /*$sep = "";
      foreach ( $mas_links as $one_link )
        {
         $name_category .= $sep. $one_link["name"];
         $sep = ", ";
        }*/
      
      if ($this->num_open_lvl_category > 0)
        {
          
          //$this->mas_navigation_pointer[]=array("Все статьи",$dir_http.$this->data_block_navigation['url_part_geo'] .'/allarticle/');
          $this->mas_navigation_pointer[] = array("Все статьи",
            $dir_http.$this->obj_modul->forming_geo_in_url_category(false).'/allarticle/'
          );
          //$mas_links = $this->forming_mas_links_series_category_from_num($this->num_open_lvl_category);
          $kolvo_links = sizeof($mas_links);
          for ($i = 0; $i < $kolvo_links; $i++)
            {
              $one_link = $mas_links[$i];
              $this->mas_navigation_pointer[] = array($one_link["name"], $one_link["link"]);
            }
          
          $this->mas_navigation_pointer[] = array($row["name_item"], false);
        }
      
      $mas_images = array();
      
      if ($row["image"])
        {
          $mas_images = explode("|", $row["image"]);
        }
      
      global $domen_site_url, $url_site;
      $domen_url = PROTOCOL_URL_CMS."://".$domen_site_url;
      
      $this->obj_modul->schema_data_ogp[] = array("title", $row["name_item"]);
      $this->obj_modul->schema_data_ogp[] = array("description", $row["short_text"]);
      $this->obj_modul->schema_data_ogp[] = array("url", $domen_url.$this->url_item_view);
      $this->obj_modul->schema_data_ogp[] = array("type", "article");
      $this->obj_modul->schema_data_ogp[] = array("image",
        sizeof($mas_images) ? $url_site."/".NAME_DIR_LOADFILES_MODULS."/article/bigfoto/".$mas_images[0] : $domen_url.$this->dir_http."/images/default_ogp.png"
      );
      
      $mas_perem["row"] = $row;
      
      
      //$mas_perem["data_cat_podcat_to_item"] = $this->data_cat_podcat_to_item;
      $mas_perem["select_podcategory"] = $this->select_podcategory;
      
      
      $kol_item_user = 0;
      $mas_name_user = array();
      
      //if ($row["type_user"] == "user")
      {
        
        $mas_id_user = array($row["num_user"]);
        
        $mas_name_user = $obj_site->select_name_user_to_list_id($mas_id_user);
        
        if (isset($mas_name_user[$row["num_user"]]))
          {
            
            $t_db_query_category = $this->obj_modul->get_text_db_query_part_category("item.n_category", 0);
            
            $db_query = "select count(*) "
              ." from ".DB_PREF."article_item item ".
              " where "
              //." item.n_category IN (".$this->list_id_inferiorcategory(false,true).") "
              .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
              ." item.hide='show' "
              ." and num_user = ".$row["num_user"]." "
              ."   "//.$this->add_db_query_country().$this->add_db_query_region().$this->add_db_query_city()
            ;
            $kol_item_user = obr_db_query_count($db_query);
            
            
          }
        else
          {
            
          }
        
      }
      
      $mas_perem["mas_name_user"] = $mas_name_user;
      $mas_perem["kol_item_user"] = $kol_item_user;
      
      
      $mas_perem["select_item"] = $this->select_item;
      
      
      $mas_perem["kol_previous_item"] = $this->kol_previous_item;
      $mas_perem["data_previous_item"] = $this->data_previous_item;
      $mas_perem["kol_next_item"] = $this->kol_next_item;
      $mas_perem["data_next_item"] = $this->data_next_item;
      
      
      global $obj_site;
      $kolvo_advert = $obj_site->intercomLink("doska", "kolvo_advert_item", $this->mas_inbox["id_item"]);
      
      $kolvo_advert = $kolvo_advert ? $kolvo_advert : 0;
      
      $mas_perem["kolvo_advert"] = $kolvo_advert;
      
      $all_kolvo_comments = 0;
      if ($this->on_access_item && $masConfig["ON_COMMENTS_ARTICLE_ITEM"] == 1)
        {
          //выводим комментарии
          
          //$t3.=$obj_site->print_page_comments($this->num_page_comments_item,"article",$this->select_item,"pcomad", $row["on_comments"] == "on" ? true : false , $row["add_comments"] == "on" ? true:false, $row["num_user"] );
          list($all_kolvo_comments, $hcomments) = $obj_site->get_data_comments_modul("article", $this->select_item, $row["on_comments"] == "on" ? true : false, $row["add_comments"] == "on" ? true : false, $row["num_user"], $this->num_page_comments_item, "pcom");
          $this->t3 .= $hcomments;
        }
      $mas_perem["all_kolvo_comments"] = $all_kolvo_comments;
      
      $mas_perem["on_access_item"] = $this->on_access_item;
      $mas_perem["text_alert_not_access_item"] = $this->text_alert_not_access_item;
      
      
      $mas_perem["obj_article"] = &$this->obj_modul;
      //$mas_perem["init_currency"] = $init_currency;
      $mas_perem["dir_http_template_modul"] = $this->obj_modul->dir_http_template_modul;
      
      $tpl->template_dir = $this->obj_modul->dir_template_mfile."/page/";
      
      $tpl->assign($mas_perem);
      $this->text = $tpl->fetch("item.html");
      
      
      return (true);
    }
  
}

