<?php


class backcon_class extends base_backcon_class
  {
   
   function on_iniz_param_modul()//используется в главном модуле для определения нужно ли проверять входящие данные (GET или POST)
     {
      return ($this->iniz_param);
     }
   
   function opred_all_get_data_modul()//функция должна возвращать массив со всеми возможными для данного модуля $_GET переменными
     {
      $mas_get_data=array();
      return ($mas_get_data);
     }
   
   function opred_param_modul($m,$k)//должна возвращать следующее
     {
      // 1 - если задан хотябы один параметр, даже если задан не верно. Иначе 0
      
      $rezult=0;
      /*
      if (isset($_GET["qonline"]) )
        {
         $this->param_get_qonline=$_GET["qonline"];
         if ($this->param_get_qonline=="on")
           $this->on_modul=true;
         $rezult=1;
        }
       else
         {
          $rezult=0;
         }
      */
      return ($rezult);
     }
   
   function korek_param_modul()//должна возвращать true если все параметры заданны верно, или false - если не верно
     {
      return(true);
     }
   
   function init_write_data($korekParam,$openModul)
     {
      return(false);
     }
   
   function write_menu_modul()//функция должна выводить массив пунктов/подпунктов
     {
      /*
      новая структура:
      
      каждый элемент должен быть массивом следующего содержания:
      0 - позиция пункта в меню
      1 - данные о пункте - массив содержащий следующее:
        
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      2 - массив с данными о подпунктах,если они есть, иначе false
        каждый подпункт меню, представляет собой массив следующего содержания:
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      
      */
      
      return (false);
     }
   
   function add_text_head()// метод должен возращать текст выводимый в заголовке head страницы (дополнительные теги нужные модулю) или false - если текст подключать не надо
     {
      $htext="";
      global $dir_http,$masConfig;
      if ( $masConfig["USE_UNION_JS_FILES"] == 0 )
        {
         $htext="\n<script type='text/javascript' src='".$this->dir_http_template_modul."/backcon.js'></script>\n";
        }
      
      return ($htext);
     }
   
   function write_soder_modul()//функции передается управление для подготовки вывода в основное содержимое сайта
     {
      /*
      функция должна возвратить массив
      - первый элемент должен содержать заголовок содержимого
      - второй элемент должен содержанть текст основного содержимого
      Например как показано ниже
      */
      global $masConfig;
      $text = "";
      $this->zagolov_osnov_soder="Заказ звонка";
      
      global $mas_value_template,$tpl,$url_site;
      $mas_perem = $mas_value_template;
      
      $mas_perem["url_site"]=$url_site;
      
      $on_capcha = false;
      $question_capcha = "";
      if ($masConfig["BACKCON_ON_USE_CAPCHA"] == 1)
        {
         $on_capcha=true;
         list($_num_v,$question_capcha,$_answer_kapcha) = set_data_capcha("ses_backcon_capcha",false);
        }
      
      $mas_perem["on_capcha"]=$on_capcha;
      $mas_perem["question_capcha"]=$question_capcha;
      
      $tpl->template_dir = $this->dir_template_mfile."/";
      
      $tpl->assign($mas_perem);
      $text .= $tpl->fetch("page_backcon.html");
      
      $this->text_osnov_soder=$text;
      
      
      $rez=array("t0"=>$this->zagolov_osnov_soder, "t1"=>$this->text_osnov_soder);
      return ($rez);
     }
   
   function write_modul_title_meta()
     {
      //функция должна возвращать массив с  текстом тега <title> - то есть заголовок страницы
      // и содержимым мета-тегов description и keywords
      $mas=array("title"=>"","description"=>"","keywords"=>"");
      
      
      $mas["title"]="Заказ звонка";
      
      return ($mas);
     }
   
   function write_content_modul($name_part_write)// функция возвращает контент в виде HTML-кода (то есть текст), если вообще выводит (on_write_content_modul() должна возвращать true) в отдельном блоке на странице
     {
      global $dir_http,$url_site;
      $array_text=array();
      global $masConfig,$obj_eng_cfg_tpl;
      
      if (true)
        {
          $mas_check = $obj_eng_cfg_tpl->check_part("backcon", $name_part_write);
          
          //write_log_cms($mas_check,"Модуль Заказ звонка. Область ".$name_part_write);
          
          if ($mas_check == false)
            {
              return ($array_text);
            }
          
          if (isset($mas_check["block_backcon"]) && $mas_check["block_backcon"] !== false)
            {
              $text = "";
              
              //$db_query = "select * from ".DB_PREF."news where hide='show' && arhiv='view' order by putdate DESC limit ".$this->kol_news_to_okno;
              //list($kol_news, $dataNews) = obr_db_query_select_assoc($db_query);
              
              global $mas_value_template, $tpl;
              $mas_perem = $mas_value_template;
              $mas_perem["txt_consent"] = replace_perem_texthablon($masConfig["BACKCON_CONSENT_DEFINITION"],"{","}",array("url_site"=>$url_site));
              $mas_perem["txt_explanation"] = $masConfig["BACKCON_ADD_TEXT"];
              $tpl->template_dir = $this->dir_template_mfile."/";
              
              $tpl->assign($mas_perem);
              $text .= $tpl->fetch("block_backcon.html");
              $array_text[] = array($mas_check["block_backcon"], $text);
              
              //$array_text[] = array(1, "test 1");
            }
          
        }
      
      return ($array_text);
     }
   
   function write_glav_page()//функция должна возвращать HTML-код для главной страницы ( если модуль конечно же выводит эти данные)
     {
      $text="";
      
      return ($text);
     }
   
   
   
  }


$obj_backcon=new backcon_class();
/*
Значение "$obj_имя_объекта" - должно быть прописано в конфигурационном
 файле CMS в соответствии с указанными коменнтариями 
*/

