<?php


class slideshow_class extends base_slideshow_class
  {
   
   function on_iniz_param_modul()//используется в главном модуле для определения нужно ли проверять входящие данные (GET или POST)
     {
      return ($this->iniz_param);
     }
   
   function opred_all_get_data_modul()//функция должна возвращать массив со всеми возможными для данного модуля $_GET переменными
     {
      $mas_get_data=array();
      return ($mas_get_data);
     }
   
   function opred_param_modul($m,$k)//должна возвращать следующее
     {
      // 1 - если задан хотябы один параметр, даже если задан не верно. Иначе 0
      
      $rezult=0;
      
      return ($rezult);
     }
   
   function korek_param_modul()//должна возвращать true если все параметры заданны верно, или false - если не верно
     {
      
      return (true);
     } 
   
   function init_write_data($korekParam,$openModul)
     {
      
      $this->openModulSite = $openModul;
      
      return(false);
     }
   
   function write_menu_modul()//функция должна выводить массив пунктов/подпунктов
     {
      /*
      новая структура:
      
      каждый элемент должен быть массивом следующего содержания:
      0 - позиция пункта в меню
      1 - данные о пункте - массив содержащий следующее:
        
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      2 - массив с данными о подпунктах,если они есть, иначе false
        каждый подпункт меню, представляет собой массив следующего содержания:
          0. текст пункта/подпункта
          1. адрес ссылки
          2. состояние: не выбрано - 1, выбранно - 2
      
      */
      
      return (false);
     }
   
   function add_text_head()// метод должен возращать текст выводимый в заголовке head страницы (дополнительные теги нужные модулю) или false - если текст подключать не надо
     {
      $htext="";
      global $masConfig;
      
      if ( $masConfig["USE_UNION_JS_FILES"] == 0 )
        {
         if ( !( SLIDESHOW_ONLY_MAIN_PAGE == 1 && $this->openModulSite !== "mainPage") )
           $htext .= "<script type='text/javascript' src='".$this->dir_http_template_modul."/slideshow.js'></script>";
        }
      
      return ($htext);
     }
   
   function write_soder_modul()//функции передается управление для подготовки вывода в основное содержимое сайта
     {
      /*
      функция должна возвратить массив
      - первый элемент должен содержать заголовок содержимого
      - второй элемент должен содержанть текст основного содержимого
      Например как показано ниже
      */
      
      
      $rez=array("t0"=>$this->zagolov_osnov_soder, "t1"=>$this->text_osnov_soder);
      return ($rez);
     }
   
   function write_modul_title_meta()
     {
      //функция должна возвращать массив с  текстом тега <title> - то есть заголовок страницы
      // и содержимым мета-тегов description и keywords
      $mas=array("title"=>"","description"=>"","keywords"=>"");
      
      $mas["title"]="Блоки HTML";
      //if ($this->num_photogallery!=0)
      //  $text_title.=" :: ".$this->data_num_photogallery["name_pg"];
      return ($mas);
     }
   
   function write_content_modul($name_part_write)// функция возвращает контент в виде массива  (каждый элемент: массив ->позиция и HTML-код (то есть текст)), если вообще выводит (on_write_content_modul() должна возвращать true) в отдельном блоке на странице
     {
      
      //if ( $name_part_write != trim(SLIDESHOW_MODUL_NAME_PART_HABLON) ) return (false);
      //if ( SLIDESHOW_ONLY_MAIN_PAGE == 1 && $this->openModulSite !== "mainPage" ) return (false);
      
      $array_text=array();
      global $masConfig,$obj_eng_cfg_tpl;
      $mas_check=$obj_eng_cfg_tpl->check_part("slideshow",$name_part_write);
      
      //write_log_cms($mas_check,"Модуль slideshow. Область ".$name_part_write);
      
      if ($mas_check == false)
        {
          return ($array_text);
        }
      
      if (isset($mas_check["boxSlideshow"]) && $mas_check["boxSlideshow"] !== false)
        {
          $db_query = "select * "
           ." from ".DB_PREF."slideshow_item " 
           ." where hide = 'show' and image != '' "
           ." order by pos  ";
    
          list($kol, $items) = obr_db_query_select_assoc($db_query);
    
          $t = "";
    
          if ($kol)
            {
        
              global $mas_value_template, $tpl, $masConfig;
              $mas_perem = $mas_value_template;
              $mas_perem["masConfig"] = $masConfig;
              
              $mas_perem["dir_http_template_modul"] = $this->dir_http_template_modul;
              
              $mas_perem["dir_http_images"] = $this->dir_http_images;
              $mas_perem["items"] = $items;
              //$mas_perem["today_advert"] = $today_advert;
              //$mas_perem["yesterday_advert"] = $yesterday_advert;
              
              //$tpl->caching = 1;
              //$tpl->cache_lifetime = -1;
              
              $tpl->template_dir = $this->dir_template_mfile."/";
              
              $tpl->assign($mas_perem);
              $t = $tpl->fetch("box_slideshow.html");
              
              $array_text[] = array($mas_check["boxSlideshow"], $t);
            }
        }
      
      return ($array_text);
     }
   
   function write_glav_page()//функция должна возвращать HTML-код для главной страницы ( если модуль конечно же выводит эти данные)
     {
      $text="";
      
      return ($text);
     }
   
   
   
  }


$obj_slideshow=new slideshow_class();
/*
Значение "$obj_имя_объекта" - должно быть прописано в конфигурационном
 файле CMS в соответствии с указанными комментариями 
*/
