<?php

if (empty($on_include_modul) || $on_include_modul!="on")
  {
   
   exit();
  }

?>

<?php

$jstext = '
on_use_geo_data = '.$masConfig["ON_USE_GEO_DATA"].';
num_country = '.$masConfig["NUM_COUNTRY"].';
num_region = '.$masConfig["NUM_REGION"].';
';

$mas_moduls_spccom = array();

foreach ( $list_modules as $ident_modul => $one_modul )
  {
   if ( !$one_modul[2] || !$one_modul[6] ) continue;
   $mas_moduls_spccom[] = array("ident_modul"=>$one_modul[5],"name_modul"=>$one_modul[4]);
  }

$jstext .= "\n".'mas_moduls_spccom = ['.encode_gen_mas_to_jointext($mas_moduls_spccom,false,true,"numeric",false)."];\n";
$jstext .= "decode_mas(mas_moduls_spccom);\n";

$mas_cfg_template_spccom=$obj_spacecom->get_cfg_template_elm();//write_log_cms($mas_cfg_template_spccom,"template_spacecom");
$jstext .= "\n".'mas_cfg_templ_spccom = {'.encode_gen_mas_to_jointext($mas_cfg_template_spccom,false,true).'}'."\n";
$jstext .= "decode_mas(mas_cfg_templ_spccom);\n";

?>

<script type="text/javascript">
<?php
echo ( $jstext );
?>
</script>


<h1>Рекламная система</h1>

<div class="block_menu_modul_gsm" id="block_menu_modul_gsm"></div>

<div class="conteiner_content_modul_gs">
<div id="block_print_content"></div>
</div>



<script type='text/javascript'>

mas_init_menu=[
  ["Настройки модуля","link","?modul=configsite&cfgm=spacecom"],
  //["Рекламные блоки","fn",function(){use_type='category';load_data_block();return(false);}],
  ["Рекламные блоки","fn",function(){eng_run_spacecom.main("block");return(false);}]
 ];

mas_gl_admin["menu_manager"].set_init_menu(mas_init_menu);

//dir_moduls - каталог с модулями
dir_serv_proc=dir_moduls+"spacecom/mdadmin/proc_spacecom/";//каталог с файлами нужными при работе Ajax
//dir=dir_serv_proc;

obj_block_print=document.getElementById("block_print_content");
//obj_block_form=null;



var eng_run_spacecom = {
  obj_manager_data_block: false,
  "main": function(v_comand)
    {
      if (v_comand == "block")
        {
          if (!this.obj_manager_data_block)
            {
              this.obj_manager_data_block = new manager_data_block();
            }
          this.obj_manager_data_block.start();
        }
    }
};



function manager_data_block()
  {
    this.obj_block_print=document.getElementById("block_print_content");
    this.obj_block_form=null;
    
    this.dir_serv=dir_serv_proc;
    
    this.mas_data_block = new Array();
    this.kol_data_block = 0;
    
    this.init_parts_desc = [];
    this.obj_parts_tpl_desc = new tool_parts_tpl_desc("spacecom");
    
    this.mas_moduls_spccom = mas_moduls_spccom;
    
    this.id_block = 0;
    this.save_type = "";
    
    this.start = function ()
      {
        //wconsole("manager data block start");
        this.load_data_block();
      }
    
    
    this.load_data_block = function()
      {
        //проверка прав пользователя
        if (!exists_rights_this_modul("read")) return;
        var _this=this;
        if (operLoad) return;
        
        this.obj_block_print.innerHTML = "";
        
        
        var url = this.dir_serv + "selectdata_block.php";
        loadHTTPjc(url,function(a,b){ _this.ob_load_data_block(a,b); } );
        
      }
    
    this.ob_load_data_block = function(answer) //шаблон обработки запроса
      {
        
        this.mas_data_block = answer.data.list;
        //wconsole (mas_category.length);
        this.kol_data_block = this.mas_data_block.length;
        
        decode_mas(this.mas_data_block);
        
        this.init_parts_desc = answer.data.init_parts_desc;
        decode_mas(this.init_parts_desc);
        //wconsole(this.init_parts_desc);
        this.obj_parts_tpl_desc.set_data(this.init_parts_desc);
        
        this.print_data_block();
        
      }
    
    
    this.print_data_block = function()
      {
        var _this=this;
        var mas_st=[];
        
        //var html = "";
        
        mas_st.push(["h1",false,"Рекламные блоки"]);
        
        var st_btns = ["div",[["class","wrap_elm_btn"]],[
          ["input",[["type","button"],["value","Добавить"],["class","elm_btn"]],"",[["click",function(){ _this.form_new_edit_block("new",0); }]]],
          " ",
          /*["input",[["type","button"],["value","Обновить"],["class","elm_btn"]],"",[["click",function(){ _this.reload_data_block(); }]]],
          " ",*/
          ["input",[["type","button"],["value","Закрыть"],["class","elm_btn"]],"",[["click",function(){ _this.clear_block_print(); }]]],
        ]];
        
        mas_st.push(st_btns);
        
        //var table = "";
        /*
        var st_tbl = ["table",[["class","table_control_t3"],["cellspacing","0"],["cellpadding","0"]],[]];
        
        st_tbl[2].push(["thead",false,[
          ["tr",false,[
            ["td",false,"N"],
            ["td",false,"ID"],
            ["td",false,"Название"],
            ["td",false,"Ширина"],
            ["td",false,"Высота"],
            ["td",false,"Рекламные записи"],
            ["td",false,"Место вывода"],
            ["td",false,"Область шаблона"],
            ["td",false,"Видимость"],
            ["td",false,"Позиция"],
            ["td",false,"Операция"]
          ]]
        ]]);
        */
        var mas_schema = [
          ["number_str","N"],
          ["value","ID","id_block"],
          ["act_link","Название","name_block",false,["",function(_i,_v,_row){ _this.form_new_edit_block("edit",_i); }]],
          ["assoc_value","Видимость","hide_block",false,{"show":"на сайте","hide":"скрыто"}],
          ["value","Позиция","pos_block"],
          //["valueText","Ширина","width_block"],
          //["valueText","Высота","height_block"],
          ["act_link","Рекламные записи","id_block",false,["Рекламные записи",function(_i,_v,_row){ _this.manager_spacecom_num_block(_i); }]],
          ["ftn","Место вывода","type_place",false,function(_i,_v,_row)
            {
              var name_place="";
              if (_row["type_place"] > 0)
                {
                  var data_modul = _this.get_data_modul_spscom(_row["type_place"]);
                  if (data_modul)
                    name_place = data_modul["name_modul"];
                  else
                    name_place = "неизвестно";
                }
              else
                name_place = "В области шаблона";
              return (name_place);
            }],
          ["ftn","Область шаблона","name_part",false,function(_i,_v,_row)
            {
              var part_desc = "--";
              if (_row["name_part"])
                {
                  part_desc = _this.obj_parts_tpl_desc.get_one_name(_row["name_part"]);
                  part_desc = (part_desc != "" ? jsCodeHtmlChars(part_desc) : _row["name_part"]);
                }
              //(_row["name_part"] ? (part_desc != "" ? jsCodeHtmlChars(part_desc) : _row["name_part"]) : "--")
              return (part_desc);
            }],
          
          ["act_link","Операция","id_block","link_attention",["Удалить",function(_i,_v,_row){ _this.delete_data_block(_v); }]]
        ];
        var st_tbl2=eng_scheme_comp.forming_table(this.mas_data_block,mas_schema);
        mas_st.push(st_tbl2);
        
        /*
        var st_tbl_tbody=["tbody",false,[]];
        var st_row=[];
        */
        //st_tbl[2].push(st_tbl_tbody);
        //mas_st.push(st_tbl);
        
        
        forming_html_struct_data.write_data(this.obj_block_print,mas_st);
        
        return (true);
      }
    
    this.manager_spacecom_num_block = function(num_row)
      {
        //wconsole("start manager_spacecom_num_block, num_row",num_row);
        var _this=this;
        var obj = new eng_manager_spacecom_num_block( function(){ _this.back_list(); });
        
        obj.start_work(this.mas_data_block[num_row], num_row);
        return (true);
      }
    
    this.form_new_edit_block = function(type_save, num_edit)
      {
        //wconsole("type save "+type_save,"num edit "+num_edit);
        this.obj_block_form = this.obj_block_print;
        this.save_type = type_save;
        var _this=this;
        var one_block = false;
        
        if (type_save == "edit")
          {
            one_block = this.mas_data_block[num_edit];
            this.id_block = one_block["id_block"];
          }
        
        var mas_st=[];
        //var html = "";
        
        mas_st.push(["h1",false,type_save == "new"?"Новый блок":"Редактирование блока"]);
        
        var st_form = ["form",[["name","form_data_block"],["onsubmit","return (false);"]],[]];
        var st_main = ["div",[["class","dt_entry_main"]],[]];
        var st_elms = [];
        
        st_elms.push(["div",[["class","dt_entry_wrap"]],[
          ["div",[["class","dt_entry_name"]],"Название"],
          ["div",[["class","dt_entry_wrap_feild"]],[
            ["input",[["type","text"],["name","name_block"],["value",""],["class","dt_entry_field_text"]]]
          ]],
        ]]);
        
        st_elms.push(["div",[["class","dt_entry_wrap"]],[
          ["div",[["class","dt_entry_name"]],"Видимость"],
          ["div",[["class","dt_entry_wrap_feild"]],[
            ["select",[["name","hide"],["class","dt_entry_field_select"]],[
              ["option",[["value","show"]],"на сайте"],
              ["option",[["value","hide"]],"скрыто"],
            ]]
          ]],
        ]]);
        
        
        var st_com=[];
        if (type_save == "new")
          {
            var st_select = ["select", [["name",'type_place'], ["class",'dt_entry_field_select']],[],[["change",function(){_this.choice_type_place_spccom();} ]]];
            
            st_select[2].push(["option", [["value",'0']],"в области шаблона"]);
            var one_modul = false;
            for (var i = 0; i < this.mas_moduls_spccom.length; i++)
              {
                one_modul = this.mas_moduls_spccom[i];
                st_select[2].push(["option", [["value",one_modul["ident_modul"]]],"в списке элементов модуля &laquo;" + one_modul["name_modul"] + "&raquo;"]);
              }
            
            st_com.push(st_select);
          }
        else
          {
            st_com.push(["input", [["type",'hidden'], ["name",'type_place'], ["value", one_block["type_place"]]]]);
            if (one_block["type_place"] > 0)
              {
                var data_modul = this.get_data_modul_spscom(one_block["type_place"]);
                if (data_modul)
                  {
                    st_com.push(data_modul["name_modul"]);
                  }
                else
                  st_com.push("неизвестно");
              }
            else
              {
                st_com.push("в области шаблона");
              }
          }
        
        st_elms.push(["div",[["class","dt_entry_wrap"]],[
          ["div",[["class","dt_entry_name"]],"Место вывода блока"],
          ["div",[["class","dt_entry_wrap_feild"]],st_com],
        ]]);
        
        
        st_elms.push(["div",[["class","dt_entry_wrap"],["id",'fm_spccom_wrap_desc_part']],[
          ["div",[["class","dt_entry_name"]],"Область шаблона"],
          ["div",[["class","dt_entry_wrap_feild"]],[
            ["div", [["id",'fm_spccom_desc_part'], ["class",'marginTB10']],"Выберите область"],
            ["input",[["type","hidden"],["name","name_part"],["value",""]]]
          ]],
        ]]);
        
        st_elms.push(["div",[["class","dt_entry_wrap"]],[
          ["div",[["class","dt_entry_name"]],"Позиция"],
          ["div",[["class","dt_entry_wrap_feild"]],[
            ["input",[["type","text"],["name","pos"],["value",""],["class","dt_entry_field_text"]]]
          ]],
        ]]);
        /*
        st_elms.push(["div",[["class","dt_entry_wrap"]],[
          ["div",[["class","dt_entry_name"]],"Ширина блока"],
          ["div",[["class","dt_entry_wrap_feild"]],[
            ["input",[["type","text"],["name","width_block"],["value",""],["class","dt_entry_field_text"]]]
          ]],
        ]]);
        
        st_elms.push(["div",[["class","dt_entry_wrap"]],[
          ["div",[["class","dt_entry_name"]],"Высота блока"],
          ["div",[["class","dt_entry_wrap_feild"]],[
            ["input",[["type","text"],["name","height_block"],["value",""],["class","dt_entry_field_text"]]]
          ]],
        ]]);
        
        st_elms.push(["div",[["class","dt_entry_wrap"]],[
          ["div",[["class","dt_entry_name"]],"Выравнивание"],
          ["div",[["class","dt_entry_wrap_feild"]],[
            ["select",[["name","align_block"],["class","dt_entry_field_select"]],[
              ["option",[["value",""]],"не использовать"],
              ["option",[["value","left"]],"по левому краю"],
              ["option",[["value","center"]],"по центру"],
              ["option",[["value","right"]],"по правому краю"],
            ]]
          ]],
        ]]);
        */
        //шаблон вывода баннера
        var t_description = "Нужно указать HTML - код шаблона вывода баннера. Используйте переменную {banner} для вывода баннера."
        + " <br><b>Если не знаете зачем это поле, оставьте его пустым.</b><br>"
        + " К примеру сделаем отступ сверху и снизу баннера в 10px:<br> &lt;div style='margin: 10px 0px;'&gt;{banner}&lt;/div&gt; ";
        
        st_elms.push(["div",[["class","dt_entry_wrap"]],[
          ["div",[["class","dt_entry_name"]],[
            "Шаблон блока ",
            ["span",[["class","elem_view_description_base"]],[
              ["img", [["src", dir_admin_panel_http + "/images/iconca_info.png"],["alt","подсказка"]]],
              ["span",[["class","elem_view_description_appear"]],t_description]
            ]]
          ]],
          ["div",[["class","dt_entry_wrap_feild"]],[
            ["textarea",[["name","template_block"],["class","dt_entry_field_textarea"]]]
          ]],
        ]]);
         
        // или  без шаблона вывода баннера
        //html+="<input type='hidden' name='template_block' value=''>";
        
        st_elms.push(["div",[["class","wrap_elm_btn"]],[
          ["input",[["type","button"],["value","Сохранить"],["class","elm_btn"]],"",[["click",function(){ _this.save_data_block(); }]]],
          ["input",[["type","button"],["value","Отмена"],["class","elm_btn"]],"",[["click",function(){ _this.cancel_create_block(); }]]]
        ]]);
        
        
        st_elms.push(["input",[["type","hidden"],["name","width_block"],["value",""]],""]);
        st_elms.push(["input",[["type","hidden"],["name","height_block"],["value",""]],""]);
        st_elms.push(["input",[["type","hidden"],["name","align_block"],["value",""]],""]);
        
        st_main[2]=st_elms;
        st_form[2].push(st_main);
        mas_st.push(st_form);
        
        
        forming_html_struct_data.write_data(this.obj_block_form,mas_st);
        
        var obj_form = document.forms.form_data_block;
        
        if (type_save == "edit")
          {
            
            //var one_block = mas_data_block[num_edit];
            obj_form.name_block.value = one_block["name_block"];
            obj_form.pos.value = one_block["pos_block"];
            obj_form.name_part.value = one_block["name_part"];
            obj_form.width_block.value = one_block["width_block"];
            obj_form.height_block.value = one_block["height_block"];
            obj_form.template_block.value = one_block["template_block"];
            
            set_value_pole_select(obj_form.hide, one_block["hide_block"]);
            //set_value_pole_select(obj_form.align_block, one_block["align_block"]);
            obj_form.align_block.value = one_block["align_block"];
            
            this.set_type_view_pf_name_part(one_block["type_place"]);
          }
        
        this.set_link_choose_part_tpl();
        
        obj_form.elements["name_block"].focus();
      }
    
    this.set_link_choose_part_tpl = function()
      {
        var obj_form = document.forms.form_data_block;
        var _this=this;
        this.obj_parts_tpl_desc.write_link_in_elm("fm_spccom_desc_part", obj_form.elements["name_part"].value, function (a)
        {
          obj_form.elements["name_part"].value = a[0];
          _this.set_link_choose_part_tpl();
        });
        
        return (true);
      }
    
    this.choice_type_place_spccom = function()
      {
        var obj_form = document.forms.form_data_block;
        var num_type_place = obj_form.elements["type_place"].value;
        
        this.set_type_view_pf_name_part(num_type_place);
        
      }
    
    this.set_type_view_pf_name_part = function(set_num)
      {
        var obj_form = document.forms.form_data_block;
        var obj_name_part = obj_form.elements["name_part"];
        var obj_wrap = engine_elm_html.get_obj("fm_spccom_wrap_desc_part");
        
        if (set_num > 0)
          {
            obj_name_part.value = "";
            //obj_name_part.disabled = true;
            obj_wrap.style.display = "none";
          }
        else
          {
            //obj_name_part.disabled = false;
            obj_wrap.style.display = "block";
            this.set_link_choose_part_tpl();
          }
        
      }
    
    
    this.get_data_modul_spscom = function(type_place)
      {
        var data_modul = false;
        
        var v = search_mas_2level(this.mas_moduls_spccom, "ident_modul", type_place, false);
        if (v[0])
          data_modul = this.mas_moduls_spccom[v[1]];
        
        return (data_modul);
      }
    
    
    this.clear_block_print = function()
      {
        if (this.obj_block_print)
          this.obj_block_print.innerHTML = "";
        
      }
    
    this.cancel_create_block = function()
      {
        if (this.obj_block_form)
          this.obj_block_form.innerHTML = "";
        
        this.print_data_block();
      }
    
    this.save_data_block = function()
      {
        //проверка прав пользователя
        if (!exists_rights_this_modul("write")) return;
        
        var obj_form = document.forms.form_data_block;
        var _this=this;
        var masInit = [
          ["name_block", "name_block", "text", "text", true, true, "", false, "", false, "Напишите название!", false, "Название блока"],
          
          ["hide", "hide_block", "select", "text", true, true, "", false, "", false, false, false, "Видимость блока"],
          ["name_part", "name_part", "text", "text", true, false, "", false, "", false, "Не указана область шаблона!", false, "Имя области шаблона"],
          ["pos", "pos_block", "text", "numeric", true, true, "", false, "", false, "Укажите число в поле «Позиция»!", "Укажите число в поле «Позиция»!", "Позиция"],
          ["width_block", "width_block", "text", "numeric", true, false, "", false, "", false, "Укажите число в поле «Ширина блока»!", "Укажите число в поле «Ширина блока»!", "Ширина блока"],
          ["height_block", "height_block", "text", "numeric", true, false, "", false, "", false, "Укажите число в поле «Высота блока»!", "Укажите число в поле «Высота блока»!", "Высота блока"],
          ["align_block", "align_block", "text", "text", true, false, "", false, "", false, "Укажите число в поле «Высота блока»!", "Укажите число в поле «Высота блока»!", "Высота блока"],
          ["template_block", "template_block", "text", "text", true, false, "", false, "", false, false, false, "Шаблон блока"],
        
        ];
        
        if (this.save_type == "new")
          {
            masInit.push(["type_place", "type_place", "select", "text", true, false, "", false, "", false, false, false, "Место вывода блока"]);
          }
        else
          {
            masInit.push(["type_place", "type_place", "text", "text", true, false, "", false, "", false, false, false, "Место вывода блока"]);
          }
        
        var data_form = processing_data_form(obj_form, masInit);
        
        if (data_form[0]) return;
        var mas_data_send = data_form[1];
        
        if (mas_data_send["type_place"] == 0)
          {
            if (mas_data_send["name_part"] == "")
              {
                alert("Не указана область шаблона!");
                return;
              }
          }
        
        mas_data_send['typesave'] = this.save_type;
        mas_data_send['id_block'] = (this.save_type == "edit" ? this.id_block : "0");
        eng_secrt.add_code_mas(mas_data_send);
        
        var query_server = encode_assoc_mas_query_ajax(mas_data_send);
        //wconsole (query_server);
        
        var url = this.dir_serv + "save_data_block.php";
        loadHTTPjc(url,function(a,b){ _this.ob_save_data_block(a,b); }, query_server);
        
      }
    
    this.ob_save_data_block = function(answer)
      {
        var _this=this;
        setTimeout(function(){ _this.load_data_block(); }, 10);
        return (true);
      }
    
    this.delete_data_block = function(id_delete)
      {
        //проверка прав пользователя
        if (!exists_rights_this_modul("write")) return;
        //wconsole("Будет удален блок с id - " + id_delete);
        var _this=this;
        if (confirm("Удалить выбранный блок?"))
          {
            if (operLoad) return;
            
            var url = this.dir_serv + "delete_block.php";
            var text_send = "id_block=" + id_delete + "&" + eng_secrt.get_param_encode();
            
            loadHTTPjc(url, function(a,b){ _this.ob_save_data_block(a,b); }, text_send);
          }
        
        return (true);
      }
    
    this.back_list = function()
      {
        // Нужна для возвращению к списку блоков от таблицы рекламных материалов (одного блока)
        // Функция передается объекту рекламных материалов
        this.print_data_block();
      }
    
  }



<?php include_once ("include_spacecom.js") ?>

<?php include_once ("include_js_fdata.js") ?>


</script>

