<?php



class base_spacecom_class extends class_main_modul_part
  {
   public $name_modul = "spacecom";
   
   public $iniz_param = false;// проверять ли инициализацию входящих данных
   public $menu_includ = false;// влючается ли в меню пункты из данного модуля
   
   protected $on_modul=false;//просматривается данный модуль (true) или нет (false)
   protected $zagolov_osnov_soder="";
   protected $text_osnov_soder="";
   public $dbcnx = "";
   
   protected $on_redirect_link = false;
   
   protected $mas_data_block_group_part = array();
   protected $mas_data_block_group_place = array();
   protected $mas_data_block = array();
   
   protected $dir_load_files = "spacecom/files";
   
   protected $user_view_country = 0;
   protected $user_view_region = 0;
   protected $user_view_city = 0;
   
   protected $dir_this_modul="";
   
   public $f_openModul="";
   public $nameComponent="";
   public $numComponent=0;
   public $openNumPage = 0;
   public $openOnGetNumPage = false;
   public $openPageIsAddParamUrl = false;
   
   protected $on_get_cfg_template=false;
   protected $mas_cfg_template=[];
   
   function construct_main()
     {
      $this->iniz_param=false;
      $this->menu_includ=false;
      
      global $dir_http,$dir_cms;
      
      $this->dir_http=$dir_http;
      $this->dir_cms=$dir_cms;
      
      $this->dir_this_modul=$this->dir_cms."/moduls/spacecom";
      
      $this->dir_intercom_driver = $this->dir_this_modul."/intercom_driver";
      $this->mas_init_intercom_driver = array(
       "spacecom_list_elem_modul" => array("spacecom_list_elem_modul.php")
       
       );
      
      $this->addit_open_url_init=array(
        "redspc"=>array(
          array("num","mas","id_spacecom","numeric:int:positive",false,false,false,"",false,false,"all","0"),
          
         )
       );
      $this->addit_open_url_dir=$this->dir_this_modul;
      
     }
   
   function on_iniz_to_glav_modul($dbcnx)//метод получает идентификатор соединения с базой данных, метод должден возвращать: 0 - если это независимый модуль, 1 - модуль используется совместно с главным модулем
     {
      $this->dbcnx=$dbcnx;
      return (0);
     }
   
   function on_menu_modul()//функция должна выводить true если модуль включает свои пункты в меню или false если нет (только для независимых модулей)
     {
      return (false);
     }
   
   function on_write_content_modul()//функция возвращает true - если модуль выводит контент в отдельном блоке на странице, иначе - false
     {
       $v=true;
       $v=array_keys($this->mas_data_block_group_part);
       
       return ($v);
     }
   
   function on_css_modul()//функция должна возращать true если модуль использует CSS (файл CSS должен быть в папке модуля) либо false в ином случае
     {
      return (true);
     }
   
   function on_write_glav_page()//функция должна возвращать true если модуль выводит данные на главной странице
     {
      return (false);
     }
   
   function forming_spacecom_t2($data_spacecom)
     {
      global $dir_http;
      //write_log_cms($data_spacecom,"one data spacecom");
      
      $t="";
      $pos_spacecom = 0;
      
      if ( isset($this->mas_data_block[$data_spacecom["num_block"]]) )
        {
         $data_block = $this->mas_data_block[$data_spacecom["num_block"]];
        }
       else
         {
          return (array($t,$pos_spacecom));
         }
      //write_log_cms($data_block,"data block h_img");
      $pos_spacecom = $data_block["pos_block"];
      $url = $dir_http."/".NAME_DIR_LOADFILES_MODULS."/".$this->dir_load_files."/".$data_spacecom["filename"];
      
      $width = $data_block["width_block"];
      $height = $data_block["height_block"];
      $width_img = $data_spacecom["width_img"];
      $height_img = $data_spacecom["height_img"];
      
      $text_link="";
      $on_blank_link=false;
      $on_block_link=false;
      
      if ( trim($data_spacecom["link"]) )
        {
         if ($data_spacecom["redirect"] === "on" )
           {
            $text_link=$dir_http."/redspacecom/spc".$data_spacecom["id_spacecom"].".html";
           }
          else
            {
             $data_url = check_protocol_url($data_spacecom["link"],array("http://","https://"),"http://");
             $text_link = $data_url[0];
            }
         
        }
      
      $atr_target = "";
      
      if ( $data_spacecom["new_window"] === "on" )
        {
         $atr_target = " target='_blank' ";
         $on_blank_link=true;
        }
      
      if ( $data_spacecom["block_link"] === "on" )
        {
         $on_block_link=true;
        }
      
      $mas_img_type=["jpg","jpeg","png","gif"];
      $h_img = "";
      
      if ( $data_spacecom["filename"] )
        {
         if (in_array($data_spacecom["filetype"],$mas_img_type))
           {
             $h_img = "<img src='$url'". ($width_img ? " width='".$width_img ."'" : ""). ($height_img ? " height='".$height_img."'" : "")." alt=''>";
             
             if ($text_link)
               {
                 $h_img = "<a href='".$text_link."' ".$atr_target." >$h_img</a>";
               }
           }
         /*
         if ($data_spacecom["filetype"] == "swf")
           {
            $h_img="<object type='application/x-shockwave-flash' data='".$url."' width='$width' height='$height'>"
             ."<param name='movie' value='".$url."' />"
             ."<param name='wmode' value='opaque' />"
             ."</object>";
            
            if ( $text_link )
             {
              $h_img = "<div style='position:relative; width: ".$width
                ."px; height: ".$height."px;'><a href='".$text_link
                ."' ".$atr_target." style='display:block; position:absolute; z-index:100; width: "
                .$width."px; height: ".$height
                ."px; filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0); -moz-opacity:0.0; opacity:0.0; background:#000;'></a>".$h_img."</div>";
             }
           }
         */
        }
      
      $text_spacecom = "";
      $all_text = "";
      $h_text = "";
      $on_add_wrap=false;
      
      if ( trim($data_spacecom["spacecom_text"]) )
        {
         $h_text = $data_spacecom["spacecom_text"];
         while ( ($pos_open = mb_strpos($h_text,"[a]")) !== false && ($pos_close = mb_strpos($h_text,"[/a]")) !== false && $pos_open < $pos_close )
           {
            $h_text = str_replace("[a]","<a href='".$text_link."' ".$atr_target.">",$h_text);
            $h_text = str_replace("[/a]","</a>",$h_text);
           }
         //$text_spacecom = str_replace("{banner}",$h_img,$h_text);
        }
      /* else
         {
          $text_spacecom = $h_img;
         }*/
      
      
      /*
      if ( $data_block["align_block"] && $data_block["align_block"] != "off" )
        {
         switch ( $data_block["align_block"] )
           {
            case ("left"): $text_spacecom = "<div style='width:".$width."px; margin: 0px auto 0px 0px;'>".$text_spacecom."</div>"; break;
            case ("center"): $text_spacecom = "<div style='width:".$width."px; margin: 0px auto 0px auto;'>".$text_spacecom."</div>"; break;
            case ("right"): $text_spacecom = "<div style='width:".$width."px; margin: 0px 0px 0px auto;'>".$text_spacecom."</div>"; break;
           }
        }
      */
      
      if ($data_spacecom["type_spc"] == "banner")
        {
          if ($data_spacecom["template_show"])
            {
              $name_templ = $data_spacecom["template_show"];
              //write_log_cms($name_templ, "шаблон spacecom");
              $data_templ = $this->get_template_elm($name_templ);
              //write_log_cms($data_templ, "данные шаблона spacecom");
              if ($data_templ)
                {
                  $all_text = $this->forming_template_elm($data_templ[3], $h_img, "", "");
                }
            }
          elseif ($h_text)
            {
              $all_text = str_replace("{banner}",$h_img,$h_text);
            }
          else
            {
              $all_text = $h_img;
              //$on_add_wrap=true;
            }
        }
      elseif ($data_spacecom["type_spc"] == "img_text")
        {
          $name_templ=$data_spacecom["template_show"];
          //write_log_cms($name_templ,"шаблон spacecom");
          $data_templ=$this->get_template_elm($name_templ);
          //write_log_cms($data_templ,"данные шаблона spacecom");
          if ($data_templ)
            {
              $all_text = $this->forming_template_elm($data_templ[3], $h_img, $h_text, "", $text_link, $on_block_link, $on_blank_link);
            }
        }
      elseif ($data_spacecom["type_spc"] == "img_title_text")
        {
          $name_templ=$data_spacecom["template_show"];
          //write_log_cms($name_templ,"шаблон spacecom");
          $data_templ=$this->get_template_elm($name_templ);
          //write_log_cms($data_templ,"данные шаблона spacecom");
          if ($data_templ)
            {
              $all_text = $this->forming_template_elm($data_templ[3], $h_img, $h_text, $data_spacecom["title"], $text_link, $on_block_link, $on_blank_link);
            }
        }
      elseif ($data_spacecom["type_spc"] == "text")
        {
          $name_templ=$data_spacecom["template_show"];
          //write_log_cms($name_templ,"шаблон spacecom");
          if ($name_templ)
            {
              $data_templ = $this->get_template_elm($name_templ);
              //write_log_cms($data_templ, "данные шаблона spacecom");
              if ($data_templ)
                {
                  $all_text = $this->forming_template_elm($data_templ[3], $h_img, $h_text, "", $text_link, $on_block_link, $on_blank_link);
                }
            }
          else
            {
              $all_text = $h_text;
              //$on_add_wrap=true;
            }
        }
      
      if ( trim( $data_block["template_block"] ) )
        {
          $all_text = str_replace("{banner}", $all_text, $data_block["template_block"]);
        }
       elseif ($on_add_wrap)
         {
           $all_text = "<div>".$all_text."</div>";
         }
      
      /*
      if ( $data_block["align_block"] && $data_block["align_block"] != "off" )
        {
         switch ( $data_block["align_block"] )
           {
            case ("left"): $t = "<div style='width:".$width."px; margin: 0px auto 0px 0px;'>".$text_spacecom."</div>"; break;
            case ("center"): $t = "<div style='width:".$width."px; margin: 0px auto 0px auto;'>".$text_spacecom."</div>"; break;
            case ("right"): $t = "<div style='width:".$width."px; margin: 0px 0px 0px auto;'>".$text_spacecom."</div>"; break;
           }
        }
      */
      
      $t = $all_text;
      
      return (array($t,$pos_spacecom));
     }
   
   function init_data_view_page_nsrl($f_openModul,$nameComponent,$numComponent,$openNumPage,$openOnGetNumPage,$openPageIsAddParamUrl,$openNsrlPageOnRelative)
     {
      
      $this->f_openModul = $f_openModul;
      $this->nameComponent = $nameComponent;
      $this->numComponent = $numComponent;
      
      $this->openNumPage = $openNumPage;
      $this->openOnGetNumPage = $openOnGetNumPage;
      $this->openPageIsAddParamUrl = $openPageIsAddParamUrl;
      $this->openNsrlPageOnRelative = $openNsrlPageOnRelative;
      
      if ( is_string( $this->numComponent ) )
        {
         if ( $this->numComponent && $this->numComponent != 0 )
           $this->numComponent = explode(",",$this->numComponent);
          else
            $this->numComponent = array();
        }
       elseif ( is_array( $this->numComponent ) )
         {
          $this->numComponent = array_values( $this->numComponent );
         }
       else
         {
          if ( $this->numComponent && $this->numComponent != 0 )
            $this->numComponent = array( $this->numComponent );
           else
             $this->numComponent = array();
         }
      
      
      //echo("spacecom: modul -> ".$f_openModul." component -> ".$nameComponent." num -> ".$numComponent);
      
      return ( true );
     }
   
   function get_spacecom_mas_num_block( $mas_num_block )
     {
      
      $array_text=array();
      global $infoUserAgent,$masConfig;
      
      $p_query_view_page = " spacecom.view_page = '' or spacecom.view_page LIKE '%[all]%' ";
      
      $p_query_view_geo = "";
      
      if ( $this->f_openModul )
        {
         $p_query_view_page .= " or spacecom.view_page LIKE '%[".$this->f_openModul."]%' ";
         
         //$p_query_view_page .= "  ";
         
         if ( $this->nameComponent )
           {
            $p_query_view_page .= " or spacecom.view_page LIKE '%[".$this->f_openModul."-".$this->nameComponent."]%' ";
            
            if ( $this->numComponent && sizeof( $this->numComponent ) > 0 )
              {
               if ( sizeof( $this->numComponent ) == 1 )
                  $p_query_view_page .= " or spacecom.view_page LIKE '%[".$this->f_openModul."-".$this->nameComponent."-".$this->numComponent[0]."]%' ";
                else
                  {
                   
                   //$p_query_view_page .= " or spacecom.view_page RLIKE '*\\[".$this->f_openModul."\\-".$this->nameComponent."\\-(".(implode("|",$this->numComponent)).")\\]*' ";
                   $p_query_view_page .= " or spacecom.view_page RLIKE '\\\[".$this->f_openModul."\\\-".$this->nameComponent."\\\-(".(implode("|",$this->numComponent)).")\\\]' ";
                  }
              }
             else
               {
                //$p_query_view_page .= " or spacecom.view_page LIKE '%[".$this->f_openModul."-".$this->nameComponent."]%' ";
               }
           }
          else
            {
             //$p_query_view_page .= " or spacecom.view_page LIKE '%[".$this->f_openModul."-%]%' ";
             
            }
         
        }
      //var_dump($p_query_view_page);
      if ( $this->user_view_country > 0 )
        {
         $p_query_view_geo = "( spacecom.view_geo = '[all]' or spacecom.view_geo = '' ";
         $p_query_view_geo .= " or spacecom.view_geo RLIKE '\\\[".$this->user_view_country.":";
         if ( $this->user_view_region > 0 )
           {
            if ( $this->user_view_city > 0 )
              {
               $p_query_view_geo .= "((0:0)|"."(".$this->user_view_region.":0)|(".$this->user_view_region.":".$this->user_view_city."))";
              }
             else
               {
                $p_query_view_geo .= "(0|".$this->user_view_region."):0";
               }
           }
          else
            {
             $p_query_view_geo .= "0:0";
            }
         $p_query_view_geo .= "\\\]' ";
         $p_query_view_geo .= ")";
        }
       elseif ( $masConfig["SPACECOM_ON_ALWAYS_USE_GEO"] == 1 )
         {
          $p_query_view_geo = "( spacecom.view_geo LIKE '%[all]%' or spacecom.view_geo = '' )";
         }
      /*
      $db_query="select * from 
        ( 
         select * 
         from  ".DB_PREF."spacecom  spacecom 
         where 
           spacecom.hide = 'show'  and spacecom.num_block IN (".implode(",",$mas_num_block).") 
           and (spacecom.kolview_limit = 0 or (spacecom.kolview_limit > 0 and spacecom.kolview < spacecom.kolview_limit)) 
           and (spacecom.start_date = 0 or (spacecom.start_date > 0 and spacecom.start_date < ".$GLOBALS["timeGlobal"].")) 
           and (spacecom.end_date = 0 or (spacecom.end_date > 0 and spacecom.end_date > ".$GLOBALS["timeGlobal"].")) 
           and ( ".$p_query_view_page." )
           ".( $p_query_view_geo ? " and ".$p_query_view_geo : "" )."
         order by RAND() 
        ) as temp_table 
       group by num_block  ";
      */
      /*
      $db_query="select * from ".DB_PREF."spacecom 
        where id_spacecom IN ( 
         select CONVERT(substring_index( GROUP_CONCAT(CONVERT(id_spacecom USING utf8) order by RAND()),',',1), unsigned) as id_spacecom_s 
         from  ".DB_PREF."spacecom  spacecom 
         where 
           spacecom.hide = 'show'  and spacecom.num_block IN (".implode(",",$mas_num_block).") 
           and (spacecom.kolview_limit = 0 or (spacecom.kolview_limit > 0 and spacecom.kolview < spacecom.kolview_limit)) 
           and (spacecom.start_date = 0 or (spacecom.start_date > 0 and spacecom.start_date < ".$GLOBALS["timeGlobal"].")) 
           and (spacecom.end_date = 0 or (spacecom.end_date > 0 and spacecom.end_date > ".$GLOBALS["timeGlobal"].")) 
           and ( ".$p_query_view_page." )
           ".( $p_query_view_geo ? " and ".$p_query_view_geo : "" )."
         group by num_block 
        ) ";
      */
      $db_query="select spacecom4.* from ".DB_PREF."spacecom spacecom4 INNER JOIN
        (select (select spacecom.id_spacecom from ".DB_PREF."spacecom spacecom where spacecom1.num_block = spacecom.num_block 
            and spacecom.hide = 'show'  "//."and spacecom.num_block IN (".implode(",",$mas_num_block).") " 
            ." and (spacecom.kolview_limit = 0 or (spacecom.kolview_limit > 0 and spacecom.kolview < spacecom.kolview_limit)) 
            and (spacecom.start_date = 0 or (spacecom.start_date > 0 and spacecom.start_date < ".$GLOBALS["timeGlobal"].")) 
            and (spacecom.end_date = 0 or (spacecom.end_date > 0 and spacecom.end_date > ".$GLOBALS["timeGlobal"].")) 
            and ( ".$p_query_view_page." )
            ".( $p_query_view_geo ? " and ".$p_query_view_geo : "" )."
            order by RAND() limit 1 ) as id_spacecom_s  
         from ".DB_PREF."spacecom spacecom1
         where spacecom1.hide='show' and spacecom1.num_block IN (".implode(",",$mas_num_block).") group by spacecom1.num_block) as spacecom3
        ON spacecom4.id_spacecom = spacecom3.id_spacecom_s";
      
      
      list($kolvo,$mas_spacecom) = db_work::query_select_assoc($db_query);
      
      $mas_num_spacecom=array();
      
      foreach ($mas_spacecom as $row)
        {
         
         $mas_num_spacecom[]=$row["id_spacecom"];
         
         list($one_spacecom, $pos_spacecom) = $this->forming_spacecom_t2($row);
         if ( $one_spacecom )
           $array_text[]=array( $pos_spacecom, $one_spacecom );
         
        }
      
      if ( !$infoUserAgent[2] && sizeof($mas_num_spacecom) > 0 )
        {
         $db_query="update ".DB_PREF."spacecom set kolview=kolview+1,date_last_view=".$GLOBALS["timeGlobal"]." where id_spacecom IN (".implode(",",$mas_num_spacecom).") ";
         db_work::query($db_query);
         
        }
      
      return ($array_text);
     }
   
   
   function get_cfg_template_elm()
     {
       global $dir_template;
       //$mas=[];
       
       if (!$this->on_get_cfg_template)
         {
           $file = $dir_template."/moduls/spacecom/cfg_tpl_modul.php";
    
           if ($file && is_file($file))
             {
               include($file);
        
               if (isset($mas_cfg_template_spacecom)) $this->mas_cfg_template = $mas_cfg_template_spacecom;
               $this->on_get_cfg_template=true;
               //$this->mas_cfg_template=$mas;
             }
         }
       /*else
         {
           
         }*/
       
       return ($this->mas_cfg_template);
     }
   
   function get_template_elm($name_templ)
     {
       $t="";
       $mas=$this->get_cfg_template_elm();
       if ($name_templ)
         {
           if (!empty($mas[$name_templ]))
             {
               $t = $mas[$name_templ];
             }
         }
       
       return ($t);
     }
   
   function forming_template_elm($template_show,$image,$text,$title,$link="",$on_block_link=false,$on_blank=true)
     {
       $t="";
       
       $t=str_replace("{image}",$image,$template_show);
       $t=str_replace("{text}",$text,$t);
       $t=str_replace("{title}",$title,$t);
       
       $v_link="";
       
       if ($on_block_link && $link)
         {
           $v_link='<a href="'.codeHtmlText($link).'" class="area_scom_block_link"'.($on_blank ? ' target="_blank"':'').'></a>';
         }
       
       $t=str_replace("{block_link}",$v_link,$t);
       
       return ($t);
     }
   
  }



