<?php

// парсер bb кодов


function bbcode_html($t_bbcode)
  {
   $t = "";
   if ( empty($GLOBALS["obj_bbcode_html"]) )
     {
      $GLOBALS["obj_bbcode_html"] = new bbcode_boxcode();
     }
   $t = $GLOBALS["obj_bbcode_html"]->parserBBcode($t_bbcode);
   return ($t);
  }



class init_fn_tag_bbcode_boxcode
  {
   //каждой функции будет передаваться параметры
   // 0 - массив с данными: 
   //  имя тега (url,email,color),атрибут тега (текст в открывающем теге после знака равно(=) или пробела (для тега quote)),
   //  полный текст открывающего тега (например [url=www.site.ru]),полный текст закрывающего тега (например [/url])
   // 1 - значение тега, то есть текст между открывающим тегом и закрывающим
   //в случае ошибки функция должна возвратить false, если ошибки нет - то преобразованный текст.
   
   static public function fn_url($data_tag)
     {
      $t = false;
      if ( trim($data_tag[4]) )
        {
         $t = array( '<a href="'.codeHtmlText(trim($data_tag[4])).'" target="_blank">', "</a>", false );
         
        }
      return ($t);
     }
   
   static public function fn_email($data_tag)
     {
      $t = false;
      if ( trim($data_tag[4]) )
        {
         $t = array( '<a href="'.codeHtmlText(trim($data_tag[4])).'" target="_blank">', "</a>", false );
         
        }
      return ($t);
     }
   
   static public function fn_img($data_tag)
     {
      $t = false;
      if ( trim($data_tag[4]) )
        {
         $t = array( '<img src="'.codeHtmlText(trim($data_tag[4])).'" alt="" class="img_bbcode">', false, "fn_img_add");
         
        }
      return ($t);
     }
   
   static public function fn_img_add($text)
     {
      return ("");
     }
   
   static public function fn_color($data_tag)
     {
      $t = false;
      if ( trim($data_tag[4]) )
        {
         $t = array( '<span style=" color: '.codeHtmlText(trim($data_tag[4])).';" >', '</span>', false);
         
        }
      return ($t);
     }
   
   static public function fn_code($data_tag)
     {
      $t = false;
      //if ( trim($v_text) )
        {
         //$t = '<div><div >Код</div><div >'.($v_text).'</div></div>';
         
         $t = array( 
          '<div class="block_code_bbcode_main"><div class="block_code_bbcode_main_contr"><div class="block_code_bbcode_title"><div class="block_code_bbcode_title_contr">Код '
          .'</div></div><div class="block_code_bbcode_content"><div class="block_code_bbcode_content_contr"><div ><div class="block_code_bbcode_content_contr_pole"><div class="block_code_bbcode_content_contr_pole_2">',
          '</div></div></div></div></div></div></div>', false);
         
        }
      return ($t);
     }
   
   static public function fn_quote($data_tag)
     {
      $t = false;
      //if ( trim($v_text) )
        {
         
         $name_user = "";
         $t_date = "";
         $num_post = 0;
         $link = "";
         
         global $dir_http;
         
         if ( trim( $data_tag[4] ) )
           {
             $mas_param = bbcode_boxcode::parse_str_params($data_tag[4]);
             if ( !empty( $mas_param["name"] ) ) $name_user = trim($mas_param["name"]);
             if ( !empty( $mas_param["date"] ) ) $t_date = trim($mas_param["date"]);
             if ( !empty( $mas_param["post"] ) && is_numeric( $mas_param["post"] ) && $mas_param["post"] > 0 )
               {
                $num_post = $mas_param["post"];
                $link = $dir_http."/forum/topic".$num_post.".html";
               }
           }
         
         
         
         $t = array(
           '<div class="block_quote_bbcode_main"><div class="block_quote_bbcode_main_contr"><div class="block_quote_bbcode_title"><div class="block_quote_bbcode_title_contr">Цитата '
           .( ( $name_user || $t_date ) ? ( "(".( $name_user ? codeHtmlText($name_user)." " : "" ).( $t_date ? ( $name_user ? " @ ":"" ) . codeHtmlText($t_date) : "" ).")" ) : "")
           .( $link ? ' <a href="'.$link.'"><img src="'.$dir_http.'/images/link_go.png"></a>' : "" )
           .'</div></div><div class="block_quote_bbcode_content"><div class="block_quote_bbcode_content_contr">',
           '</div></div></div></div>', false );
         
        }
      return ($t);
     }
   
   static public function fn_size($data_tag)
     {
      $t = false;
      //if ( trim($v_text) )
        {
         $size = trim($data_tag[4]);
         $size = ($size <= 17 && $size >= 6) ? $size : false;
         $t = ($size !== false) ? array('<span style=" font-size: '.codeHtmlText($size).'px;" >','</span>', false) : array(false,false, false);
         
        }
      return ($t);
     }
   
   static public function fn_font($data_tag)
     {
      $t = false;
      //if ( trim($v_text) )
        {
         $t = array( '<span style=" font-family: '.codeHtmlText(trim($data_tag[4])).';" >','</span>', false );
         
        }
      return ($t);
     }
   
   static public function fn_list($data_tag)
     {
      $t = false;
      //if ( trim($v_text) )
        {
         /*
         $mas_elm = explode("[*]",$v_text);
         $kolvo = 0;
         $t = "";
         $teg = "ul";
         if ( trim($data_tag[1]) == 1 ) $teg = "ol";
         
         $t .= "<".$teg.">";
         //$t = '<span style=" font-family: '.codeHtmlText().';" >'.($v_text).'</span>';
         
         foreach ( $mas_elm as $one_elm )
           {
            $v_elm = trim($one_elm);
            if ( $v_elm )
              {
               $t .= "<li>".$v_elm."</li>";
               $kolvo++;
              }
           }
         $t .= "</".$teg.">";
         
         if ( $kolvo == 0 ) $t = "";
         */
         
         $teg = "ul";
         if ( trim($data_tag[4]) == 1 ) $teg = "ol";
         
         $t = array("<".$teg.">", "</".$teg.">","fn_list_add" );
         
        }
      return ($t);
     }
   
   static public function fn_list_add($text)
     {
      $t = "";
      //$t .= "<li>";
      $text = trim($text);
      /*
      if ( mb_strpos( $text, "[*]" ) === 0 )
        {
         $text = mb_substr($text,3,mb_strlen($text)-3);
         $text = trim($text);
        }
      $text = str_replace("[*]","<li></li>",$text);
      $t .= $text;
      */
      
      $mas_elm = explode("[*]",$text);
      
      $kolvo = 0;
      
      foreach ( $mas_elm as $one_elm )
        {
         $v_elm = trim($one_elm);
         if ( $v_elm )
           {
            $t .= "<li>".$v_elm."</li>";
            $kolvo++;
           }
        }
      
      //$t .= "</li>";
      return ( $t );
     }
   
  }




class bbcode_boxcode
  {
   
   public $bbtext = "";
   public $html_text = "";
   /*
   var $mas_stack_tag = array();
   var $mas_stack_text = array();
   var $num_mas_stack_tag = 0;
   var $num_mas_stack_text = 0;
   */
   public $mas_init_bbtag = array();
   public $length_text_url = 35;
   public $mas_not_url = array("url","email","img","code");
   
   function __construct()
     {
      $this->init();
     }
   
   
   function init()
     {
      $this->init_bbtag();
     }
   
   function init_bbtag()
     {
      $this->mas_init_bbtag = array(
        "b" => array("<b>","</b>",false),
        "i" => array("<i>","</i>",false),
        "u" => array("<u>","</u>",false),
        "s" => array("<strike>","</strike>",false),
        
        //"a" => create_function(),
        
        "center" => array("<div style='text-align: center;'>","</div>",false),
        "left" => array("<div style='text-align: left;'>","</div>",false),
        "right" => array("<div style='text-align: right;'>","</div>",false),
        "justify" => array("<div style='text-align: justify;'>","</div>",false),
        
        "url" => array("","","fn_url"),
        "email" => array("","","fn_email"),
        "img" => array("","","fn_img"),
        "color" => array("","","fn_color"),
        
        "code" => array("","","fn_code"),
        "quote" => array("","","fn_quote"),
        
        "size" => array("","","fn_size"),
        "font" => array("","","fn_font"),
        
        "list" => array("","","fn_list")
        
       );
      
     }
   
   function parserBBcode($bbtext)
     {
      $this->bbtext = $bbtext;
      $this->html_text = "";
      
      $this->compile_proc();
      
      
      return ($this->html_text);
     }
   
   function compile_proc()
     {
      
      $this->pos_cursor = 0;
      $this->bbtext = str_replace(array("\r\n","\n\r","\r"),"\n",$this->bbtext);
      $this->all_sim = mb_strlen($this->bbtext);
      $this->sim_cursor = "";
      
      if ( $this->all_sim == 0 ) return;
      
      $this->is_open_tag = false;//найден открывающий тег ([b]) или закрывающий ([/b])
      $this->on_tag = false;
      /*
      $this->mas_stack_tag = array();
      $this->mas_stack_text = array();
      $this->mas_stack_text[0] = "";
      $this->num_mas_stack_tag = -1;
      $this->num_mas_stack_text = 0;
      */
      $this->on_search = true;
      
      $this->text_stack = "";
      
      $this->text_tag = "";
      $this->text_atr_tag = "";
      $this->is_atr_tag = false;
      
      $error = false;
      
      $v_text = "";
      $this->html_text = "";
      
      $this->mas_structure = array();
      $this->mas_structure[0] = array(false,false,"","");
      
      $this->link = array(0);
      $this->level_link = 0;
      if ( isset( $this->link_structure ) ) unset ($this->link_structure);
      $this->link_structure = &$this->mas_structure[0];
      
      
      do
        {
         $error = false;
         
         $this->sim_cursor = mb_substr($this->bbtext,$this->pos_cursor,1);
         
         if ( !$this->on_tag )
           {
            if ( $this->sim_cursor === "[" )
              {
               $this->on_tag = true;
               $this->text_stack = $this->sim_cursor;//запоминаем исходный текст после нахождения открывающего символа тега
               $this->text_tag = "";
               $this->is_open_tag = true;
               $this->is_atr_tag = false;
               $this->text_atr_tag = "";
               //$this->mas_stack_text[$this->num_mas_stack_text] .= $v_text;
               //$v_text = "";
              }
             else
               {
                //$this->html_text .= $this->sim_cursor;
                //$v_text .= $this->sim_cursor;
                //$this->mas_stack_text[$this->num_mas_stack_text] .= codeHtmlText($this->sim_cursor);
                
                $this->link_structure[2] .= $this->sim_cursor;
               }
           }
          else
            {
             $this->text_stack .= $this->sim_cursor;
             
             if ( preg_match("/^[a-zA-Z]$/",$this->sim_cursor) )
               {
                if ( !$this->is_atr_tag )
                  $this->text_tag .= $this->sim_cursor;
                 else
                   $this->text_atr_tag .= $this->sim_cursor;
               }
              elseif ( $this->sim_cursor === "]" )
                {
                 if ( $this->text_tag == "" )
                   {
                    // неправильный тег, пропускаем его
                    $error = true;
                    //$this->on_tag = false;
                    //$this->html_text .= $this->text_stack;
                   }
                  else
                    {
                     if ( !empty( $this->mas_init_bbtag[$this->text_tag] ) )
                       {
                        if ( $this->is_open_tag )
                          {
                           //найден открывающий тег, к примеру [b]
                           
                           $this->link[sizeof($this->link)-1]++;
                           $this->set_link_element_mas_structure();
                           
                           $this->link_structure[2] = array( array(false,false,"") );
                           $this->link_structure[3] = $this->text_tag;
                           $this->link_structure[4] = $this->text_atr_tag;
                           $this->link_structure[5] = $this->text_stack;
                           $this->link_structure[6] = "";
                           $this->link_structure[7] = false;
                           
                           
                           
                           $this->link[] = 0;
                           $this->set_link_element_mas_structure();
                           
                           //$this->num_mas_stack_tag++;
                           //$this->num_mas_stack_text++;
                           
                           //$this->mas_stack_tag[$this->num_mas_stack_tag] = array($this->text_tag,$this->text_atr_tag,$this->text_stack,"");
                           $this->text_stack = "";
                           //$this->mas_stack_text[$this->num_mas_stack_text] = "";
                           //$v_text = "";
                           
                          }
                         else
                           {
                            //найден закрывающий тег, к примеру [/b]
                            $data_elem = $this->get_preelement_mas_structure();
                            
                            //if ( !empty( $this->mas_stack_tag[$this->num_mas_stack_tag] ) &&
                            //  $this->mas_stack_tag[$this->num_mas_stack_tag][0] == $this->text_tag )
                            if ( $data_elem && !empty( $data_elem[3] ) &&
                              $data_elem[3] == $this->text_tag )
                               {
                                unset($this->link[sizeof($this->link)-1]);
                                $this->link = array_values($this->link);
                                $this->set_link_element_mas_structure();
                                $this->link_structure[6] = $this->text_stack;
                                
                                $this->forming_tag();
                                
                                $this->link[sizeof($this->link)-1]++;
                                $this->set_link_element_mas_structure();
                                
                                
                                //$this->mas_stack_tag[$this->num_mas_stack_tag][3] = $this->text_stack;
                                //$this->forming_tag();
                                
                                //$v_text = "";
                                $this->text_stack = "";
                                //unset($this->prelink_structure);
                                //$this->prelink_structure = false;
                               }
                              else
                                {
                                 //неправильная вложенность закрывающих тегов, пропускаем закрывающий тег.
                                 $error = true;
                                }
                            
                           }
                        $this->on_tag = false;
                       }
                      else
                        {
                         //такого тега нет
                         $error = true;
                        }
                    }
                }
              elseif ( $this->sim_cursor === "=" || $this->sim_cursor === " " )
                {
                 if ( !$this->is_atr_tag )
                   {
                    if ( $this->text_tag )
                      {
                       $this->is_atr_tag = true;
                       $this->text_atr_tag = "";
                      }
                     else
                       {
                        $error = true;
                       }
                   }
                  else
                    {
                     $this->text_atr_tag .= $this->sim_cursor;
                    }
                 
                }
              elseif ( $this->sim_cursor === "/" )
                {
                 if ( $this->text_tag === "" )
                   $this->is_open_tag = false;
                  elseif ( $this->is_atr_tag )
                    $this->text_atr_tag .= $this->sim_cursor;
                   else
                     {
                      $error = true;
                      // неправильный тег, пропускаем его
                      //$this->on_tag = false;
                      //$this->html_text .= $this->text_stack;
                     }
                 
                }
              else
                {
                 if ( $this->is_atr_tag )
                   $this->text_atr_tag .= $this->sim_cursor;
                  else
                   {
                    $error = true;
                    
                   }
                }
            }
         
         if ( $error )
           {
            // неправильный тег, пропускаем его
            $this->on_tag = false;
            //$this->html_text .= $this->text_stack;
            //$this->mas_stack_text[$this->num_mas_stack_text] .= codeHtmlText($this->text_stack);
            $this->link_structure[2] .= $this->text_stack;
            $this->text_stack = "";
            //$v_text = "";
           }
         
         $this->pos_cursor++;
         if ( $this->pos_cursor >= $this->all_sim ) $this->on_search = false;
         //echo($this->pos_cursor." ");
        }
      while ( $this->on_search );
      
      if ( $this->on_tag && $this->text_stack )
        {
         $this->link_structure[2] .= $this->text_stack;
        }
      
      //var_dump($this->mas_structure);
      //var_dump($this->mas_stack_text);
      //var_dump($this->num_mas_stack_text);
      /*
      for ( $i = 0; $i <= $this->num_mas_stack_text; $i++ )
        {
         $this->html_text .= $this->mas_stack_text[$i];
         
        }
      
      $this->html_text .= $v_text . $this->text_stack;
      */
      //echo("num=".$this->num_mas_stack_text);
      $this->html_text = $this->forming_html_text($this->mas_structure);
      $this->html_text = str_replace("\n","<br />\n",$this->html_text);
     }
   
   function forming_html_text($elm_structure,$on_smile = true, $on_url = true)
     {
      $t = "";
      foreach ( $elm_structure as $one_elm )
        {
         if ( is_array( $one_elm[2] ) )
           {
            if ( $one_elm[0] === false && $one_elm[1] === false )
              $t .= $one_elm[5];
             elseif ( $one_elm[0] !== false )
                $t .= $one_elm[0];
            
            $on_url1 = $on_url;
            $on_smile1 = $on_smile;
            
            if ( in_array( $one_elm[3], $this->mas_not_url ) )
              $on_url1 = false;
            
            $vt = $this->forming_html_text( $one_elm[2], $on_smile1, $on_url1 );
            
            if ( $one_elm[7] )
              {
               $vn=$one_elm[7];
               $vt = init_fn_tag_bbcode_boxcode::$vn($vt);
              }
            
            $t .= $vt;
            
            if ( $one_elm[1] !== false )
              $t .= $one_elm[1];
            
           }
          else
            $t .= $this->code_text($one_elm[2],$on_smile,$on_url);
        }
      
      return ( $t );
     }
   
   function forming_tag()
     {
      //echo(34);
      if ( !empty( $this->link_structure ) )
        {
         $data_tag = $this->link_structure;
         //var_dump($data_tag);
         
         $v = $this->forming_html_tag($data_tag);
         if ( $v === false )
           {
            //$this->mas_stack_text[$this->num_mas_stack_text-1] .= $data_tag[2] . $this->mas_stack_text[$this->num_mas_stack_text] . $data_tag[3];
            $this->link_structure[0] = $data_tag[5];
            $this->link_structure[1] = $data_tag[6];
            $this->link_structure[7] = false;
           }
          else
            {
             //$this->mas_stack_text[$this->num_mas_stack_text-1] .= $v;
             $this->link_structure[0] = $v[0];
             $this->link_structure[1] = $v[1];
             $this->link_structure[7] = $v[2];
            }
         //$this->num_mas_stack_tag--;
         //$this->num_mas_stack_text--;
        }
     }
   
   function forming_html_tag($data_tag)
     {
      $t = false;
      
      //проверка на случай внутренних ошибок
      if ( !empty( $this->mas_init_bbtag[$data_tag[3]] ) )
        {
         $init_one_tag = $this->mas_init_bbtag[$data_tag[3]];
         if ( $init_one_tag[2] )
           {
            $vn=$init_one_tag[2];
            $v = init_fn_tag_bbcode_boxcode::$vn($data_tag);
            if ( $v === false )
              {
               $t = false;
              }
             else
               {
                $t = array( $v[0],$v[1], $v[2] );
               }
           }
          else
            {
             $t = array( $init_one_tag[0], $init_one_tag[1], false );
            }
        }
       else
         {
          //$t .= $v_text;
         }
      //echo("<hr>".$t."<hr>");
      return ($t);
     }
   
   static public function parse_str_params($t)
     {
      $mas_params = array();
      
      $mas_part = bbcode_boxcode::parse_str_attribute($t);
      
      foreach ( $mas_part as $key_part => $one_part )
        {
         $name = trim($key_part);
         $v_param = trim($one_part);
         
         if ( ($name) && ($v_param) )
           {
            //if ( preg_match("/^[a-zA-Z]$/",$one_param[0]) && preg_match("//",$one_param) )
            
            if ( mb_substr($v_param,0,1) == "'" && mb_substr($v_param,-1,1) == "'" )
              {
               $mas_params[$name] = mb_substr($v_param,1,mb_strlen($v_param)-2);
              }
             elseif ( mb_substr($v_param,0,1) == '"' && mb_substr($v_param,-1,1) == '"' )
               {
                $mas_params[$name] = mb_substr($v_param,1,mb_strlen($v_param)-2);
               }
            
           }
         
        }
      
      return ($mas_params);
     }
   
   static public function parse_str_attribute($str)
     {
      //парсим строку типа name1 = "text" key = $var value = array()
      //и получаем массив с ключами и значениями array( "name1" => "text , "key" => $var , "value" => array() )
      //в случае ошибки вернем false
      if ( !trim($str) ) return ( array() );//если пустая строка - возвращаем пустой массив
      
      $mas = bbcode_boxcode::separator_text_params($str,"=");//var_dump($mas);
      if ( !$mas || sizeof($mas) < 2 ) return (false);
      
      $params = array();
      $kol = sizeof($mas);
      if ( $kol  == 2 )
        $params[$mas[0]] = $mas[1];
       else
         {
          //$params[$mas[0]] = "";
          $nameKey = $mas[0];
          for ( $i = 1; $i < $kol-1; $i++  )
            {
             
             if ( preg_match("/\\s[\\S]+$/uis",$mas[$i],$matches,PREG_OFFSET_CAPTURE) )
               {
                
                $params[$nameKey] = mb_substr($mas[$i],0,mb_strlen($mas[$i])-mb_strlen($matches[0][0]));
                $nameKey = trim($matches[0][0]);
               }
              else
                return (false);
             
            }
          $params[$nameKey] = $mas[$kol-1];
          
         }
      
      return ($params);
     }
   
   static public function separator_text_params($t,$sep = ",")
     {
      $t = trim($t);
      $mas = array();
      if ( $t )
        {
         $mas = bbcode_boxcode::split_text_sim($t,$sep);
         if ( $mas === false ) return(false);
         foreach ( $mas as $key => $value )
           {
            $v = trim($value);
            if ( $v || $v === "0" )
              {
               $mas[$key]=trim($value);
              }
             else
               {
                //echo(" err:".trim($v)." ");
                //return (false);
               }
           }
        }
      return ($mas);
     }
   static public function split_text_sim($t,$sep = ",")
     {
      $params = array();
      //$t = trim($t);
      if ( $t )
        {
         $part_t = "";//текст параметра
         $type_t = "";//тип текста: в кавычках ' или "
         $open_bracket = 0;//открывающая скобка "("
         $prev_sim = "";//предыдущий символ
         $len = mb_strlen($t);
         $sim = "";//текущий символ
         for ( $i = 0;$i<$len;$i++ )
           {
            $sim = mb_substr($t,$i,1);
            if ( $sim === $sep )
              {
               //if ( $part_t  )
                 {
                  if ( $type_t || $open_bracket )
                    {
                     //пропускаем разделяющий символ (запятую) если он находится в кавычках или в скобках
                     $part_t .= $sim;
                    }
                   else
                     {
                      $params[] = $part_t;
                      $part_t = "";
                      
                     }
                 }
                //else
                //  return(false);
              }
             else
               {
                $part_t .= $sim;
                if ( ($sim === "'" || $sim === '"') && $prev_sim !== "\\" )
                  {
                   $type_t = $type_t ? ( $type_t === $sim ? "":$type_t ):$sim;
                  }
                 elseif ( $sim === "(" && !$type_t  )
                   {
                    $open_bracket++;//обнаружена открывающая скобка вне кавычек
                    
                   }
                  elseif ( $sim === ")" && !$type_t )
                    {
                     if ( $open_bracket  )
                       {
                        $open_bracket--;
                        
                       }
                      else
                        {
                         //обнаружена закрывающая кавычка, но ранее не было открывающей. 
                         //Синтаксическая ошибка 
                         return (false);
                        }
                     
                    }
                //$prev_sim = $sim;
                
               }
            $prev_sim = $sim;
           }
         if ( $part_t )
           $params[] = $part_t;
          elseif ( $sim === $sep )
            $params[] = "";
        }
      
      return ($params);
     }
   
   
   function set_link_element_mas_structure()
     {
      
      
      unset($this->link_structure);
      
      $num = 0;
      foreach ( $this->link as $num_lvl => $one )
        {
         if ( $num == 0 )
           {
            if ( $num == (sizeof( $this->link ) - 1) && !isset( $this->mas_structure[$one] ) )
              $this->mas_structure[$one] = array(false,false,"","");
            
            $this->link_structure = &$this->mas_structure[$one];
            
           }
          else
            {
             $is = 0;
             if ( $num == ( sizeof( $this->link ) - 1 ) && !isset( $this->link_structure[2][$one] ) )
               {
                
                $this->link_structure[2][$one] = array(false,false,"","");
                
               }
             
             $this->link_structure = &$this->link_structure[2][$one];
             
            }
         $num++;
        }
      
     }
   
   function get_preelement_mas_structure()
     {
      
      
      $data_elm = false;
      $links = $this->link;
      
      unset( $links[sizeof($links)-1] );
      $links = array_values($links);
      
      $elm = false;
      
      foreach ( $links as $num_lvl => $one )
        {
         if ( $num_lvl == 0 )
           {
            
            $elm = &$this->mas_structure[$one];
            
           }
          else
            {
             
             $elm = &$elm[2][$one];
             
            }
         
        }
      
      if ( $elm !== false )
        {
         $data_elm = $elm;
         $data_elm[2] = false;
        }
      
      return ( $data_elm );
     }
   
   function code_text($text,$on_smile,$on_url)
     {
      $t = codeHtmlText($text);
      
      if ( $on_url )
        {
         $t = preg_replace_callback('/(http|ftp)(:\/\/[\w.\/\%\-\#\?\=\+\[\]\&\;\:]+)/i', array($this,"forming_link_from_url"), $t);
        }
      
      /*
      if ( $on_smile )
        {
         $t = "";
        }
      */
      
      return ($t);
     }
   
   function forming_link_from_url($s)
     {
      $t = "";
      $url = decodeHtmlText($s[1].$s[2]);
      
      $t = "<a href='".codeHtmlText($url)."' target='_blank' title='".codeHtmlText($url)."'>".codeHtmlText( mb_strlen($url) > $this->length_text_url ? compres_text_middle($url,$this->length_text_url) : $url )."</a>";
      return ( $t );
     }
   
  }











