<?php

class eng_registr_user
{
  
  private $mas_inbox = [];
  private $mas_errors = [0=>[],1=>[]];
  private $mas_index_errors = [];
  
  function __construct()
    {
      
    }
  
  function start()
    {
      
      
    }
  
  function check_add_new_user()
    {
      global $masConfig;
      
      $error = 0;
      $mas_errors="";
      $data=[];
      
      if (!$this->_proc_check_add_new_user())
        {
          $error=1;
          $mas_errors = $this->mas_errors;
        }
      else
        {
          $message = "<div>На указанный Вами E-mail отправленно письмо. Вам нужно будет подтвердить регистрацию пройдя по указанной в письме ссылке.</div>";
          
          $message .= (( trim($masConfig["TEXT_AVTORIZ_NOT_GET_ACTIVE_EMAIL"]) ) ? "<div class='marginTop20'>". nl2br($masConfig["TEXT_AVTORIZ_NOT_GET_ACTIVE_EMAIL"])."</div>" : "");
          
          $data["mesg_success_registr"]=$message;
          
        }
      
      return ([$error,$mas_errors,$data]);
    }
  
  protected function _proc_check_add_new_user()
    {
      global $masConfig, $url_site, $domen_site, $dir_http, $obj_site;
      
      $use_type_account = ($masConfig["REGISTR_USE_TYPE_ACCOUNT"] == 1 ? true : false);
      
      $v_type_account = "regular";
      
      $on_use_company = false;
      
      $error = false;
      $mas_errors=[];
      
      /*
      if ($GLOBALS["user_to_site"])
        {
          sendheader::location($dir_http."/");
          exit();
        }
      */
      if ($use_type_account)
        {
          $on_mod_catalog = $obj_site->intercomCheckModul("catalog");
          //Если модуль Каталог компаний есть и он подключен, то используем поле Название компании
          if ($on_mod_catalog) $on_use_company = true;
        }
      
      if (empty($_POST["new_control_registr"]))
        {
          $this->mas_errors[0][] = "Ошибка с данными!";
          return (false);
        }
      
      $send_form_registr = true;
      
      //if ($this->use_type_account && !empty($_POST["type_account"]) && $_POST["type_account"]=="business") $v_type_account="business";
      list($error, $mas_errors, $v_type_account, $this->mas_inbox) = $this->check_in_data_new_user($use_type_account, $on_use_company);
      /*
      write_log_cms($error, "error");
      write_log_cms($mas_errors, "errors");
      write_log_cms($v_type_account, "v_type_account");
      write_log_cms($this->mas_inbox, "mas_inbox");
      */
      if ($error)
        {
          $this->mas_errors = $mas_errors;
          return (false);
        }
      //проверка Email в таблице пользователей
      if ($this->check_exists_email($this->mas_inbox["email_user"]))
        {
          $this->mas_errors[1]["new_email"] = "Пользователь с таким E-mail уже существует!";
          return (false);
        }
      
      $phone_user = "";
      
      if ($masConfig["ON_USE_POLE_PHONE_USER"] == 1)
        {
          $phone_user = $this->mas_inbox["phone_user"];
          
          if ($phone_user != "")
            {
              if ($masConfig["USE_CHECK_ACTIVE_PHONE_USER"] == 1)
                {
                  if (!$this->check_active_phone($phone_user))
                    {
                      $this->mas_errors[1]["new_phone"] = "Телефон не подтвержден!";
                      return (false);
                    }
                }
              
              if ($this->check_exists_phone($phone_user))
                {
                  $this->mas_errors[1]["new_phone"] = "Пользователь с таким телефоном уже существует!";
                  return (false);
                }
            }
          
        }
      
      clear_data_capcha("ses_registr_kapcha");
      
      $code_email = "";
      $on_code_email = true;// true - включено подтверждение Email, код (ссылка для подтверждения) отправляется пользователю 
      
      if ($on_code_email)
        {
          // Если включено подтверждение по e-mail
          // генерируем код $code_email, который отправляется пользователю по почте
          // $code_email=md5(time() . rand(100, 20000) . rand(100, 10000));
        }
      else
        {
          //подтверждение по e-mail не включено, поэтому сразу регистрируем пользователя
          $this->on_add_registr = "add";
        }
      
      $d_user = $this->mas_inbox;
      $d_user["phone_user"] = $phone_user;//Добавляем номер телефона (может быть неуказан, переменная будет равна пустой строке)
      
      list($new_id_user, $code_email) = $this->add_new_user_normal($d_user, $v_type_account, $on_code_email);
      
      $this->send_email_active($d_user["email_user"], $d_user["name_user"], $new_id_user, $code_email);
      
      $this->on_add_registr = "sendemail";
      
      if ($on_use_company && $v_type_account == "business")
        {
          $data_comp = array("num_user" => $new_id_user, "name" => $this->mas_inbox["company_name"], "email" => $this->mas_inbox["email_user"], //"phone" => $phone_user,
            //"n_category" => $this->mas_inbox["n_category"],
            //"n_category_2" => $this->mas_inbox["n_category_2"],
          );
          $d_add_modul = $obj_site->intercomLink("catalog", "create_object_registr", array("add_object", $data_comp));
        }
      
      
      return (true);
    }
  
  public function check_in_data_new_user($use_type_account,$on_use_company)
    {
      // $use_type_account - $this->use_type_account
      // $this->on_use_company - $on_use_company
      
      $v_type_account="regular";//возвращаемый параметр
      
      global $masConfig,$obj_control_data;
      
      $error=false;
      $mas_errors=[0=>[],1=>[]];
      //$mas_index_errors=[];
      
      if ($use_type_account && !empty($_POST["type_account"]) && $_POST["type_account"]=="business") $v_type_account="business";
      /*write_log_cms($use_type_account,"use type account");
      write_log_cms($on_use_company,"on use company");
      write_log_cms($v_type_account,"v type account");*/
      
      $mas_prov = array(
        
        array("type_account","post","type_account","text",$use_type_account ? true:false,true,"listv","regular,business",true,false,true,"regular","Выберите тип аккаунта!",true,true),
        array("new_name","post","name_user","text",true,true,"hablonrv","/^[a-zA-Zа-яА-ЯёЁ0-9_ ]+$/u",true,"tr",false,false,"Не указано имя!",true,"Неверный формат имени!"),
        array("new_company_name","post","company_name","text",($on_use_company && $v_type_account == "business") ? true:false, ($on_use_company && $v_type_account == "business") ? true:false,false,false,true,"tr",false,false,"Не указано название компании!",true,"Неверный формат названия компании!"),
        array("new_email","post","email_user","text",true,true,"function","check_data_email",true,false,false,false,"Не указан Email!",true,"Неверный формат Email!"),
        array("new_password","post","password_user","text",true,true,"hablonrv",'/^[a-zA-Z0-9_~!?<>@#\$%\^&*\(\)\-=+\.\,:;\|]+$/u',true,false,false,false,"Не указан пароль!",true,"Неверный формат пароля!"),
        array("new_password_dubl","post","password_user_dubl","text",true,true,"hablonrv",'/^[a-zA-Z0-9_~!?<>@#\$%\^&*\(\)\-=+\.\,:;\|]+$/u',true,false,false,false,"Не указан проверочный пароль!",true,"Неверный формат проверочного пароля!"),
       );
      
      
      if ( $masConfig["ON_USE_POLE_PHONE_USER"] == 1 )
        {
         if ( $masConfig["USE_CHECK_ACTIVE_PHONE_USER"] == 1 )
           $mas_prov[] = array("new_phone","post","phone_user","text",true,true,"function","check_data_phone",true,"tr",false,false,"Не указан номер телефона!",true,"Неправильно написан номер телефона!");
          else
            $mas_prov[] = array("new_phone","post","phone_user","text",true,false,"function","check_data_phone",true,"tr",false,false,"Не указан номер телефона!",true,"Неправильно написан номер телефона!");
        }
      
      if ($masConfig["REGISTR_KAPCHA"] == 1)
        {
         $mas_prov[] = array("answ_registr_kapcha","post","answ_kapcha","text",true,true,false,"",true,false,false,false,"Не указан ответ на контрольный вопрос!",true,true);
        }
      
      $control_data = $obj_control_data->processing_one_group($mas_prov);
      //write_log_cms($control_data,"control data new registr");
      
      $mas_inbox = $control_data[3];
      
      
      if ( $control_data[0] )
        {
         if ( !$control_data[1] )
           {
            
            if (REGISTR_KAPCHA == 1 )
              {
               
               if ( !( isset($mas_inbox["answ_kapcha"]) && check_data_capcha("ses_registr_kapcha",$mas_inbox["answ_kapcha"]) ) )
                 {
                   $error=true;
                   $mas_errors[1]["answ_registr_kapcha"] = "Неверный ответ на контрольный вопрос! ";
                 }
               
              }
            
            if ( $mas_inbox["password_user"] != $mas_inbox["password_user_dubl"] )
              {
                $error=true;
                $mas_errors[1]["new_password"] = "Пароль и проверочный пароль не совпадают!";
              }
            
           }
          else
            {
              $error=true;
              //$mas_errors = $control_data[4];
              $mas_errors[1] = $control_data[6];
            }
         
         
        }
       else
         {
           $error=true;
           $mas_errors[0][]="Ошибка с данными!";
         }
      
      return ([$error,$mas_errors,$v_type_account,$mas_inbox]);
    }
  
  public function check_exists_email($email)
    {
      //Проверим, есть или нет зарегистрированный пользователь с таким Email
      
      $db_query="select count(*) from ".DB_PREF."users where type_registr='site' and email_user='".codeText($email)."'";
      $kolvo_email=db_work::query_count($db_query);
      /*
      if ($kolvo_email!=0)
        {
         $this->mas_ error_registr[]="Пользователь с таким E-mail уже существует!";
         return;
        }
      */
      return ($kolvo_email > 0 ? true : false);
    }
  
  public function get_user_email($email)
    {
      //Получим данные пользователя с указанным Email
      
      $db_query="select * from ".DB_PREF."users where type_registr='site' and email_user='".codeText($email)."'";
      list($kolvo,$data_user)=db_work::query_select_one_assoc($db_query);
      
      return ($kolvo > 0 ? $data_user : false);
    }
  
  public function check_phone($v_phone)
    {
      //Проверяем номер телефона
      
      global $masConfig;
      
      $error = false;
      $mas_errors = [];
      
      //if ($masConfig["ON_USE_POLE_PHONE_USER"] == 1){  }
      
      $phone_user = $v_phone;// $this->mas_ inbox_registr["phone_user"];
      
      if ($phone_user != "" && $masConfig["USE_CHECK_ACTIVE_PHONE_USER"] == 1)
        {
          $on_active_phone = $this->check_active_phone($phone_user);
          if (!$on_active_phone)
            {
              $error = true;
              $mas_errors[] = "Телефон не подтвержден!";
            }
        }
      
      if (!$error && $phone_user != "")
        {
          if ($this->check_exists_phone($phone_user))
            {
              $error = true;
              $mas_errors[] = "Пользователь с таким телефоном уже существует!";
            }
        }
      
      return ([$error, $mas_errors]);
    }
  
  public function check_exists_phone($v_phone)
    {
      //Проверим, есть или нет зарегистрированный пользователь с указанным номером телефона
      
      $db_query = "select count(*) from ".DB_PREF."users where type_registr='site' and phone_user='".codeText($v_phone)."' ";
      
      $kolvo_phone = db_work::query_count($db_query);
      
      return ($kolvo_phone > 0 ? true : false);
    }
  
  public function check_active_phone($v_phone)
    {
      //Проверим, подтвержден телефон или нет
      global $masConfig;
      
      $on_active=false;
      
      if ($v_phone != "")//$masConfig["USE_CHECK_ACTIVE_PHONE_USER"] == 1
        {
          $obj_tool_check_active_phone = new tool_check_active_phone();
          $on_active = $obj_tool_check_active_phone->is_check_active_phone($v_phone, false);
          
        }
      
      return ($on_active);
    }
  
  public function add_new_user_normal($d_user,$v_type_account,$on_code_email)
    {
      
      $code_email = "";
      $activ_user="on";
      /*
      $on_subscribe = "on";
      $get_message_guest = "on";
      $get_message_user = "on";
      */
      $d_user["on_subscribe"]="on";
      $d_user["get_message_guest"]="on";
      $d_user["get_message_user"]="on";
      
      
      if ($on_code_email)
        {
          //если включено подтверждение по e-mail, генерируем код
          $code_email = md5(time() . mt_rand(100, 20000) . mt_rand(10, 10000));
          $activ_user="off";
        }
      
      $d_user["activ_user"]=$activ_user;
      $d_user["code_email"]=$code_email;
      
      $new_id_user=$this->_add_new_user_db($d_user,$v_type_account);
      
      return ([$new_id_user,$code_email]);
    }
  
  protected function _add_new_user_db($d_user,$v_type_account)
    {
      //Добавляем в базу нового пользователя
      /*
      $code_email = "";
      $on_subscribe = "on";
      $get_message_guest = "on";
      $get_message_user = "on";
      */
      
      $data_user = array(
        "id_user" => 0,
        "name_user" => $d_user["name_user"],
        "password_user" => md5($d_user["password_user"]),
        "email_user" => $d_user["email_user"],
        "phone_user" => $d_user["phone_user"],// $phone_user,
        "date_create" => $GLOBALS["timeGlobal"],
        "date_visit" => 0,
        "sait_user" => '',
        "about_user" => '',
        "print_email_user" => 'off',
        "access_user" => 'on',
        "activ_user" => $d_user["activ_user"],// 'off',
        "kod_activ" => $d_user["code_email"],
        "access_admin" => 'off',
        "access_privat" => '',
        "image_user" => "",
        "on_subscribe" => $d_user["on_subscribe"],// $on_subscribe,
        "get_message_admin" => 'on',
        "get_message_user" => $d_user["get_message_user"],// $get_message_user,
        "get_message_guest" => $d_user["get_message_guest"],// $get_message_guest,
        "operation_1" => 'off',
        "operation_2" => 'off',
        "operation_3" => 'off',
        "money" => 0,
        "on_partner" => 'off',
        "partner_amount" => 0,
        "partner_key" => '',
        "partner_purse" => '',
        "partner_invite" => 0,
        "partner_get_message" => 'off',
        "notice_new_private_message" => 'on',
        "type_registr" => 'site',
        "social_name" => '',
        "social_ident" => '',
        "social_profile" => '',
        "service_ident" => '',
        "note" => '',
        "authorized" => "off",
        "date_admin" => 0,
        "authorized_admin" => "off",
        "type_account" => ($v_type_account ? $v_type_account : "regular"),
        
      );
      
      $db_query=forming_db_query_indexmas(DB_PREF."users",$data_user,"new","id_user");
      db_work::query($db_query);
      
      $new_id_user = db_work::get_insert_id();
      
      return ($new_id_user);
    }
  
  public function add_new_user_quick($d_user)
    {
      //write_log_cms($d_user,"data user quick first");
      
      $d_user["name_user"]=$d_user["name_user"] ?? "Пользователь";
      $d_user["email_user"]=$d_user["email_user"] ?? "";
      $d_user["phone_user"]=$d_user["phone_user"] ?? "";
      
      $d_user["on_subscribe"]="on";
      $d_user["get_message_guest"]="on";
      $d_user["get_message_user"]="on";
      
      $d_user["code_email"]="";
      $d_user["activ_user"]="on";
      
      $password = "w". mb_substr(md5(time() . "a9nBk" . mt_rand(100,9999999)), 1, 7 );
      
      $d_user["password_user"]=$password;
      
      //write_log_cms($d_user,"data user quick first");
      
      $new_id_user=$this->_add_new_user_db($d_user,"regular");
      
      $this->send_email_registr_quick($d_user["email_user"],$d_user["name_user"],$new_id_user,$password);
      
      return ([$new_id_user,$password]);
    }
  
  public function send_email_active($email_user,$name_user,$new_id_user,$code_email)
    {
      //Отправляем письмо со ссылкой подтверждения Email
      
      global $masConfig,$url_site,$domen_site;
      //отправляем письмо для подтверждения Email
      $site_name=NAME_SITE_TO_EMAIL;
      $mas_perem = array("site_name"=>$site_name);
      
      $subject=AUTHORIZATION_TITLE_EMAIL_ADD_USER;//"Подтверждение регистрации нового пользователя на сайте $site_name";
      $subject=replace_perem_texthablon($subject,"{","}",$mas_perem);
      
      $mas_perem["url_site"]=$url_site;
      $mas_perem["domen_site"]=$domen_site;
      $mas_perem["email_user"]=$email_user;
      $mas_perem["name_user"]=$name_user;
      $mas_perem["url_page_activreg"]=$url_site."/registr/activ/?activreg=".$new_id_user."&codereg=".$code_email;
      
      $message = $masConfig["AUTHORIZATION_TEXT_EMAIL_ADD_USER"];
      $message = replace_perem_texthablon($message,"{","}",$mas_perem);
      $message .= forming_signature_email();
      
      /*
      $message="Здравствуйте!<br>\n"
        ." Вы (или кто-то от Вашего имени) зарегистрировались на сайте <a href='".$url_site."'>".$_SERVER["SERVER_NAME"]."</a>.\n"
        ." Если Вы хотите подтвердить свою регистрацию - Вам нужно перейти по ссылке<br>\n"
        ." <a href='".$url_site."/registr/?activreg=".$new_id."&codereg=$kod_email'>".$url_site."/registr/?activreg=".$new_id."&codereg=$kod_email</a>.<br>\n"
        ." Если Вы не регистрировались на данном сайте, то просто проигнорируйте данное письмо."
        .forming_signature_email();
      */
      
      $on_send=send_email($subject,$message,"",$email_user,false,false,false,false,true);
      
      return ($on_send);
    }
  
  public function send_email_registr_quick($email_user,$name_user,$new_id_user,$password)
    {
      //Отправляем письмо о быстрой регистрации, в письме также будет пароль
      
      global $masConfig,$url_site,$domen_site;
      //отправляем письмо для подтверждения Email
      $site_name=NAME_SITE_TO_EMAIL;
      $mas_perem = array("site_name"=>$site_name);
      
      $subject=$masConfig["AUTHORIZATION_TITLE_EMAIL_REGISTR_QUICK"];//"Вы успешно зарегистрированы на сайте {site_name}";
      $subject=replace_perem_texthablon($subject,"{","}",$mas_perem);
      
      $mas_perem["url_site"]=$url_site;
      $mas_perem["domen_site"]=$domen_site;
      $mas_perem["email_user"]=$email_user;
      $mas_perem["name_user"]=$name_user;
      $mas_perem["password"]=$password;
      
      $message = $masConfig["AUTHORIZATION_TEXT_EMAIL_REGISTR_QUICK"];
      
      $message = replace_perem_texthablon($message,"{","}",$mas_perem);
      $message .= forming_signature_email();
      
      
      $on_send=send_email($subject,$message,"",$email_user,false,false,false,false,true);
      
      return ($on_send);
    }
  
  public function get_data_one_user($id_user)
    {
      $mas_user = false;
      
      $db_query = "select * from ".DB_PREF."users "
        ." where id_user='".codeText($id_user)."' ";
      
      list($kolvo, $data_user) = db_work::query_select_one_assoc($db_query);
      if ($kolvo == 1) $mas_user = $data_user;
      
      return ($mas_user);
    }
  
  public function quick_authorization_user($_d_user,$on_memory=false)
    {
      //$d_user - может быть id пользователя или массив с данными пользователя
      
      $error = false;
      $error_text = "";
      
      $data_user = false;
      
      if (is_int($_d_user) || is_numeric($_d_user))
        {
          $data_user = $this->get_data_one_user($_d_user);
        }
      elseif (is_array($_d_user) && sizeof($_d_user))
        {
          $data_user = $_d_user;
        }
      
      if ($data_user)
        {
          //Проверка "бана" пользователя
          if ($data_user["access_user"] == "off" && $data_user["access_admin"] != "sadmin")
            {
              //Пользователю запрещен доступ на сайт
              $error = 1;
              $error_text = "Вам запрещен доступ на сайт!";
            }
          
          //Проверка активации аккаунта
          if ($error == 0 && $data_user["activ_user"] == "off")
            {
              //Пользователь не активировал свой аккаунт, активируем его (так как Email подтвержден)
              $this->_activation_account($data_user["id_user"]);
            }
          
          if ($error == 0)
            {
              //Авторизуем пользователя на сайте
              session_auth_user::set_session($data_user, $on_memory);
              
              global $obj_site,$infoUserAgent;
              $obj_site->protection_account_add("off",$infoUserAgent[1],$data_user["email_user"],$data_user["id_user"],"on","user");
              
            }
        }
      else
        {
          $error=1;
          $error_text="Ошибка с данными аккаунта!";
        }
      
      return ([$error, $error_text]);
    }
   
  protected function _activation_account($id_user)
    {
      $db_query = "update ".DB_PREF."users set activ_user='on', kod_activ='' where id_user = $id_user ";
      db_work::query($db_query);
    }
  
}

