<?php


class eng_main_component_grup extends eng_main_component_base
{
  
  protected $data_punkt = array();
  protected $mas_add_stat = array();
  protected $kol_add_stat = 0;
  
  protected $on_access_text = true;
  protected $text_alert_not_access = "";
  protected $kol_vsego_add_stat = 0;
  
  protected $page_comment = 1;
  
  function first_init()
    {
      
    }
  
  function control_data()
    {
      
      $this->data_punkt = array();
      $this->mas_add_stat = array();
      $this->kol_add_stat = 0;
      
      $this->on_access_text = true;
      $this->text_alert_not_access = "";
      
      //if ($data_get_comments==1) return;//комментарии на страницах пунктов и подпунктов запрещены
      $db_query = "select * "
        ." from ".DB_PREF."components "
        ." where id_component=".$this->mas_inbox["num_punkt"]." and hide='show' and modul = 'punkt' ";
      list($num_rows, $this->data_punkt) = obr_db_query_select_one_assoc($db_query);
      
      
      if ($num_rows == 0)
        {
          return (false);
        }
      
      /*
      if ($this->data_punkt["type_level"] == "inferior")
        {
         $db_query="select count(*) from ".DB_PREF."components 
           where id_component = ".$this->data_punkt["n_component"] 
           ." and hide='show' and type_level='high' and modul != 'stat' ";
         $kol=obr_db_query_count($db_query);
         if ($kol == 0)
           return;
        }
      */
      /*
      if ( ON_COMMENTS == 1 && SET_PAGES_COMMENTS == 1 && $this->data_punkt["on_comments"] == "off" )
       {
        if ($this->set_inbox["get"]["compage"]["status"] == "set") return;
        
       }
      */
      if ($this->data_punkt["view_type_user"] !== "all")
        {
          if ($this->data_punkt["view_type_user"] == "guest" && $GLOBALS["user_to_site"])
            {
              $this->on_access_text = false;
              $this->text_alert_not_access = "Страница доступна только незарегистрированным пользователям!";
            }
          
          if ($this->data_punkt["view_type_user"] == "user" && !$GLOBALS["user_to_site"])
            {
              $this->on_access_text = false;
              $this->text_alert_not_access = "Страница доступна только зарегистрированным пользователям!";
            }
          
        }
      /*
       if ( ON_COMMENTS == 1 && $this->data_punkt["on_comments"] == "on" )
        {
          $this->page_comment =1;
          //var_dump($this->set_inbox);
          if ( SET_PAGES_COMMENTS == 1 )
            {
              if ($this->set_inbox["get"]["compage"]["status"] == "set")
                {
                 //if ($this->page_comment!=1)
                   {
                    $on_data_get_comments=$this->proverka_page_comments($this->set_inbox["get"]["compage"]["value"],"punkt",$this->mas_inbox["num_punkt"]);
                    if (!$on_data_get_comments) return;
                    $this->page_comment = $this->set_inbox["get"]["compage"]["value"];
                   }
                }
            }
         if ( $this->data_punkt["add_comments"] == "on" )
            {
             $err_baz=$this->save_data_comments($this->page_comment,"punkt",$this->mas_inbox["num_punkt"],"compage");
             
            }
        }
      */
      
      
      $db_query = "select count(*) from ".DB_PREF."components "
        ." where n_component = ".$this->mas_inbox["num_punkt"]." and hide='show' and type_level='inferior' "
        ." and modul='stat' ";
      
      $this->kol_vsego_add_stat = obr_db_query_count($db_query);
      
      if (!$this->kol_vsego_add_stat && $this->status_inbox["num_page"] == "set") return (false);
      
      if ($this->kol_vsego_add_stat)
        {
          $db_query = "select id_component,name,short_text,type_editor,pos from ".DB_PREF."components "
           ." where n_component=".$this->mas_inbox["num_punkt"]." and hide='show' and type_level='inferior' "
           ." and modul = 'stat' order by pos ASC "
           ." limit ".(($this->mas_inbox["num_page"] - 1) * KOL_ADD_STAT_TO_PUNKT).",".KOL_ADD_STAT_TO_PUNKT." ";
          //write_log_cms($db_query);
          list($this->kol_add_stat, $this->mas_add_stat) = obr_db_query_select_assoc($db_query);
          if (!$this->kol_add_stat && $this->mas_inbox["num_page"]) return (false);
          
        }
      
      //$korekParam = true;
      
      return (true);
    }
  
  function forming_data()
    {
      
      $this->title = trim($this->data_punkt["teg_title"] ? $this->data_punkt["teg_title"] : $this->data_punkt["name"]);
      $this->description = $this->data_punkt["meta_description"];
      $this->keywords = $this->data_punkt["meta_keywords"];
      
      $this->mas_navigation_links = array(array($this->data_punkt["name"], false));
      
      
      $on_text_punkt = false;
      $text_print = "";
      
      if ($this->on_access_text)
        {
          /* if ($this->data_punkt["type_editor"]=="bbcode")
            {
             if ( $this->data_punkt["all_text"] && trim( $this->data_punkt["all_text"] ) )
               {
                $text_print=BBCodeToHtml($this->data_punkt["all_text"]);
                $on_text_punkt = true;
               }
            }
           else */
          //{
          if ($this->data_punkt["all_text"] && trim(strip_tags($this->data_punkt["all_text"])))
            {
              $text_print = setTextLinkFileDown($this->data_punkt["all_text"]);
              $on_text_punkt = true;
            }
          
          //}
        }
      else
        {
          $text_print = $this->text_alert_not_access;
          $on_text_punkt = true;
        }
      
      $this->title_text = $this->data_punkt["name"];
      
      
      global $mas_value_template;
      $mas_perem = $mas_value_template;
      $mas_perem["data_punkt"] = $this->data_punkt;
      $mas_perem["text_print"] = $text_print;
      $mas_perem["on_text_print"] = $on_text_punkt;
      
      
      $this->obj_site->addKolOpensStat($this->data_punkt["id_component"]);
      
      //if ( $on_text_punkt )
      //  $t1.=$this->print_data_metks_stat($this->data_punkt);
      //$mas_perem["data_metks_stat"]=$this->print_data_metks_stat($this->data_punkt);
      
      $mas_perem["ON_METKS_TEXT"] = ON_METKS_TEXT;
      
      $mas_perem["on_access_text"] = $this->on_access_text;
      
      $mas_perem["mas_add_stat"] = $this->mas_add_stat;
      $mas_perem["numPunkt"] = $this->mas_inbox["num_punkt"];
      $mas_perem["numPageAddStat"] = $this->mas_inbox["num_page"];
      $mas_perem["vsegoPageAddStat"] = ceil($this->kol_vsego_add_stat / KOL_ADD_STAT_TO_PUNKT);
      //$mas_perem["kol_vsego_add_stat"] = $this->kol_vsego_add_stat;
      
      $mas_perem["PRINT_ON_TEXT_TO_LIST_STAT"] = PRINT_ON_TEXT_TO_LIST_STAT;
      $mas_perem["TEXT_TO_LIST_STAT"] = TEXT_TO_LIST_STAT;
      
      
      global $tpl;
      $tpl->template_dir = $this->obj_site->dir_template_components."/";
      
      $tpl->assign($mas_perem);
      
      $this->text = $tpl->fetch("grup.html");
      
      //выводим комментарии к статье
      if (ON_COMMENTS == 1 && $this->data_punkt["on_comments"] == "on" && $this->on_access_text)
        {
          //$t2.=$this->print_page_comments($this->page_comment,"punkt",$this->data_punkt["id_component"],"compage",$this->data_punkt["on_comments"] == "on" ? true : false,$this->data_punkt["add_comments"] == "on" ? true : false );
          list($all_kolvo_comments, $hcomments) = $this->obj_site->get_data_comments_modul("punkt", $this->data_punkt["id_component"], $this->data_punkt["on_comments"] == "on" ? true : false, $this->data_punkt["add_comments"] == "on" ? true : false, $this->page_comment, "pcom");
          $this->t2 .= $hcomments;
        }
      
      
      return (true);
    }
  
}

