<?php


class eng_main_component_messenger extends eng_main_component_base
{
  
  protected $messenger_open = "";
  protected $messenger_user1 = 0;
  protected $messenger_user2 = 0;
  
  protected $messenger_error = false;
  protected $messenger_error_text = "";
  
  protected $messenger_items_page = 20;
  protected $messenger_open_num_page = 1;
  protected $messenger_all_pages = 1;
  protected $messenger_data_differ = [];
  
  function first_init()
    {
      
    }
  
  function control_data()
    {
      /*
      $this->messenger_open = "";
      $this->messenger_user1 = 0;
      $this->messenger_user2 = 0;
      
      $this->messenger_error = false;
      $this->messenger_error_text = "";
      
      $this->messenger_items_page = 20;
      $this->messenger_open_num_page = 1;
      $this->messenger_all_pages = 1;
      $this->messenger_data_differ = [];
      */
      $korekParam = false;
      
      if ($this->type_page == "messenger_all")
        {
          $korekParam = true;
          
          if ($GLOBALS["user_to_site"])
            {
              
              $this->messenger_open = "all";
              
              $num_user1 = $GLOBALS["id_user_to_site"];
              
              $db_query = "select count(*) from "
                ."( select if(num_author=$num_user1,num_author,num_recipient) as num_user1, if(num_author=$num_user1,num_recipient,num_author) as num_user2 "
                ." from ".DB_PREF."messenger messenger where num_author=".$num_user1." or num_recipient=".$num_user1
                ." group by num_user1, num_user2 ) as tb_messenger_1 ";
              //write_log_cms($db_query,"db query");
              $all_branch = db_work::query_count($db_query);
              //write_log_cms($all_branch,"всего веток сообщений");
              
              $this->messenger_all_pages = ceil($all_branch / $this->messenger_items_page);
              
              if ($this->status_inbox["num_page"] == "set")
                {
                  $_num_page = $this->mas_inbox["num_page"];
                  if ($_num_page >= 1 && $_num_page <= $this->messenger_all_pages)
                    {
                      $this->messenger_open_num_page = $_num_page;
                    }
                  else
                    {
                      $korekParam = false;
                    }
                }
              
              if ($korekParam && $all_branch > 0)
                {
                  
                  $db_query = "select id_messenger, num_user1, num_user2, count_not_read "
                    ." from "
                    ."(select max(id_messenger) as id_messenger, if(num_author=$num_user1,num_author,num_recipient) as num_user1, "
                    ." if(num_author=$num_user1,num_recipient,num_author) as num_user2 " //.", if(num_author=$num_user1,'question','answer') as type_msg  "
                    ." , (select count(*) from ".DB_PREF."messenger messenger_2 "
                    ." where "." messenger_2.num_recipient=num_user1 and "
                    ." messenger_2.num_author=num_user2 and messenger_2.onread='off') as count_not_read "
                    ." from ".DB_PREF."messenger messenger_1 "
                    ." where num_author=".$num_user1." or num_recipient=".$num_user1
                    ." group by num_user1, num_user2) as tb_messenger_1 "
                    ." order by id_messenger DESC "
                    ." limit ".(($this->messenger_open_num_page - 1) * $this->messenger_items_page).",".$this->messenger_items_page." ";
                  
                  list($kolvo, $data_differ) = db_work::query_select_assoc($db_query);
                  
                  if ($kolvo == 0)
                    {
                      $korekParam = false;
                    }
                  else
                    {
                      $this->messenger_data_differ = $data_differ;
                    }
                  
                }
              elseif ($korekParam)
                {
                  if ($this->messenger_open_num_page != 1)
                    {
                      $korekParam = false;
                    }
                }
              
            }
        }
      elseif ($this->type_page == "messenger_user")
        {
          $korekParam = true;
          $this->messenger_open = "user";
          
          $this->messenger_user2 = $this->mas_inbox["num_user"];
          
        }
      
      return ($korekParam);
    }
  
  function forming_data()
    {
      
      $this->title_text = 'Сообщения';
      
      $this->title = 'Сообщения';
      $this->description = "Сообщения";
      $this->keywords = "Сообщения";
      
      $t1 = "";
      
      global $mas_value_template, $tpl, $masConfig;
      $mas_perem = $mas_value_template;
      $mas_perem["masConfig"] = $masConfig;
      
      $error_page = false;
      $error_page_text = "";
      
      $alert_page = false;
      $alert_page_text = "";
      
      $on_access_write = true;
      
      $num_user1 = 0;
      $num_user2 = 0;
      
      $data_user2 = false;
      
      $data_messages = array();
      
      $id_last_messenger = 0;
      $time_last = 0;
      
      $mas_count_nread = array();
      $mas_data_user = array();
      
      global $dir_http;
      
      $open_num_page = $this->messenger_open_num_page;
      $all_pages = $this->messenger_all_pages;
      $items_page = $this->messenger_items_page;
      $data_differ = $this->messenger_data_differ;
      
      if (!$this->messenger_error)
        {
          
          if ($GLOBALS["user_to_site"])
            {
              if ($this->messenger_open == "all")
                {
                  
                  $num_user1 = $GLOBALS["id_user_to_site"];
                  
                  $mas_id_messenger = array();
                  $mas_count_nread = array();
                  
                  if (sizeof($data_differ) > 0)
                    {
                      /*
                      $db_query="select id_messenger, num_user1, num_user2, count_not_read "
                        ." from "
                        ."(select max(id_messenger) as id_messenger, if(num_author=$num_user1,num_author,num_recipient) as num_user1, "
                       ." if(num_author=$num_user1,num_recipient,num_author) as num_user2 " //.", if(num_author=$num_user1,'question','answer') as type_msg  "
                       ." , (select count(*) from ".DB_PREF."messenger messenger_2 "
                       ." where " ." messenger_2.num_recipient=num_user1 and "
                       ." messenger_2.num_author=num_user2 and messenger_2.onread='off') as count_not_read "
                       ." from ".DB_PREF."messenger messenger_1 "
                       ." where num_author=".$num_user1." or num_recipient=".$num_user1
                       ." group by num_user1, num_user2) as tb_messenger_1 "
                       ." limit ".(($open_num_page - 1) * $items_page).",".$items_page." ";
                      
                      list($kolvo,$data_differ)=db_work::query_select_assoc($db_query);
                      */
                      //write_log_cms($data_differ,"data messenger group main");
                      $mas_num_user = select_mas1lev_2level($data_differ, "num_user2", false);
                      $mas_num_user = array_values(array_unique($mas_num_user));
                      
                      if (sizeof($mas_num_user) > 0)
                        {
                          $mas_data_user = $this->obj_site->select_data_user_to_list_id($mas_num_user, "id_user,name_user");
                        }
                      
                      foreach ($data_differ as $one_data)
                        {
                          $mas_id_messenger[] = $one_data["id_messenger"];
                          $mas_count_nread[$one_data["id_messenger"]] = $one_data["count_not_read"];
                          
                        }
                      
                      if (sizeof($mas_id_messenger) > 0)
                        {
                          $db_query = "select * from ".DB_PREF."messenger "
                            ." where id_messenger IN (".implode(",", $mas_id_messenger).") order by id_messenger DESC ";
                          list($kolvo, $data_messages) = db_work::query_select_assoc($db_query);
                        }
                    }
                  
                  //write_log_cms($data_messages,"данные сообщений");
                  
                }
              elseif ($this->messenger_open == "user")
                {
                  
                  $num_user1 = $GLOBALS["id_user_to_site"];
                  $num_user2 = $this->messenger_user2;
                  
                  if (!$error_page && $num_user1 == $num_user2)
                    {
                      $error_page = true;
                      $error_page_text = "Вы пытаетесь написать сами себе!"
                        ."<br/>Посмотрите свою переписку на странице <a href='".$dir_http."/messenger'>Сообщения</a>, возможно вам уже кто-нибудь написал.";
                    }
                  
                  if (!$error_page)
                    {
                      $data_user1 = $GLOBALS["data_authorize_user"];
                      $data_user2 = $this->obj_site->get_data_one_user_num($num_user2, "id_user,name_user,get_message_user,access_user");
                      //write_log_cms($data_user2,"data user2");
                      $eng_messenger = new eng_messenger();
                      
                      if ($data_user2)
                        {
                          if ($data_user2["access_user"] == "on")
                            {
                              //обновляем статус onread
                              $eng_messenger->set_on_read_msg($num_user1, $num_user2, 0);
                              //обновляем карты пользователей
                              $eng_messenger->set_mark_card_users($num_user1, $num_user2);
    
                              //получаем сообщения
                              list($kolvo, $data_messages) = $eng_messenger->get_messages($num_user1, $num_user2);
                              if ($kolvo > 0)
                                {
                                  $id_last_messenger = $data_messages[$kolvo - 1]["id_messenger"];
                                  $time_last = $data_messages[$kolvo - 1]["putdate"];
                                }
    
                              if (!($data_user1["get_message_user"] == "on" && $data_user2["get_message_user"] == "on"))
                                {
                                  $on_access_write = false;
                                  $alert_page = true;
                                  $alert_page_text = ($data_user1["get_message_user"] != "on" ?
                                    "В вашем профиле запрещено получать сообщения от пользователей. Пользователи не могут вам написать (не смогут ответить)."
                                    ." Написать сообщение вы не сможете. Чтобы начать переписку с пользователем, сначала в настройках <a href='".$dir_http."/registr/inforeg/'>профиля</a> включите опцию &laquo;Получать сообщения от посетителей сайта&raquo;."
                                    : "Пользователь запретил отправлять ему сообщения."."<br/>Написать ему сообщение нет возможности.");
                                }
                            }
                          else
                            {
                              /*
                              $error_page = true;
                              $error_page_text = "";
                              */
                              $on_access_write = false;
                              $alert_page = true;
                              $alert_page_text = "Переписка невозможна. Пользователь заблокирован.";
                            }
                        }
                      else
                        {
                          //проверяем, есть ли сообщения от несуществующего пользователя (возможно пользователь был удален)
                          //получаем сообщения 
                          list($kolvo, $data_messages) = $eng_messenger->get_messages($num_user1, $num_user2);
                          
                          if ($kolvo > 0)
                            {
                              //обновляем статус onread
                              $eng_messenger->set_on_read_msg($num_user1, $num_user2, 0);
                              //обновляем карты пользователей
                              $eng_messenger->set_mark_card_users($num_user1, $num_user2);
                            }
                          
                          $error_page = true;
                          $error_page_text = "Переписка не найдена, возможно она была удалена или был удален пользователь."
                            ."<br/>Посмотрите свою переписку на странице <a href='".$dir_http."/messenger'>Сообщения</a>, возможно найдете нужную вам переписку.";
                        }
                    }
                  
                }
            }
          else
            {
              $error_page = true;
              $error_page_text = "Страница доступна авторизованным пользователям."
                ."<br/><br/> <a href='".$dir_http."/registr/'>Зарегистрируйтесь</a> или <a href='".$dir_http."/registr/enter/'>авторизуйтесь</a>, чтобы просмотреть сообщения или написать новое сообщение.";
            }
          
        }
      else
        {
          $error_page = $this->messenger_error;
          $error_page_text = $this->messenger_error_text;
        }
      
      $mas_perem["error_page"] = $error_page;
      $mas_perem["error_page_text"] = $error_page_text;
      
      $mas_perem["alert_page"] = $alert_page;
      $mas_perem["alert_page_text"] = $alert_page_text;
      
      $mas_perem["on_access_write"] = $on_access_write;
      
      $mas_perem["messenger_open"] = $this->messenger_open;
      $mas_perem["data_messages"] = $data_messages;
      
      $mas_perem["mas_count_nread"] = $mas_count_nread;
      
      $mas_perem["mas_data_user"] = $mas_data_user;
      
      $mas_perem["num_user2"] = $num_user2;
      $mas_perem["data_user2"] = $data_user2;
      
      $mas_perem["open_num_page"] = $open_num_page;
      $mas_perem["all_pages"] = $all_pages;
      
      $init_page = array("num_user1" => $num_user1, "num_user2" => $num_user2,
        "type" => $this->messenger_open, "id_last_messenger" => $id_last_messenger, "time_last" => $time_last,
        "contr_code" => eng_promote_safety::get_code($num_user1)
      );/*"num_modul"=>$num_modul, "num_elm"=>$num_elm*/
      
      $mas_perem["init_page"] = encode_gen_mas_to_jointext($init_page, false, true, "assoc");
      
      $tpl->template_dir = $this->obj_site->dir_template_components."/";
      
      $tpl->assign($mas_perem);
      
      $this->text = $tpl->fetch("messenger_view.html");
      
      
      return (true);
    }
  
}

