<?php

/*
Архив CMS находится на сайте www.boxcode.ru  
Информацию по установке и использованию CMS можно прочитать на сайте www.boxcode.ru 
*/


//перед подключением файла нужно 
// 1. подключить файл /config/config.php
// 2. $type_action_part_site - указывает тип выполняемой части сайта
//    v_user - пользовательская часть сайта
//    v_admin - панель управления
//    wk_user - драйвер пользовательской части сайта
//    wk_admin - драйвер панели управления
// 3  $num_level_dir_scr_file - уровень вложенности запущенного файла. Нужен для определения каталога, в котором лежит сайт
// 4. задать тип ответа $type_answer -> ajax, iframe, false
//    можно не задавать тип ответа (не указывать переменную $type_answer), тогда будет по умолчанию значение ajax
// 5. задать тип заголовка $type_header -> задается согласно методу sendheader::main()
//    можно не задавать заголовок, тогда по умолчанию будет nocache,texthtml
// 6. Если не нужно подключение к базе данных, то тогда нужно установить переменную
//    $not_use_connect_db = true;
// 7. Если не нужно подключать файлы для отправки почты, то нужно указать переменную
//    $not_include_class_send_mail = true;
// 8. Для панели управления задать права доступа к файлу
//    Если не нужно проверять доступ, то нужно создать переменную $not_check_access_rights = true;
//    Если нужно, чтобы проверялись права, то задаются они в переменной 
//    $type_rights_access = array("модуль","тип запроса -> server,server_setting или client","тип действия, выполняемый скриптом: read,setting или write");
//    к примеру $type_rights_access = array("component","server","read");
// 9. $admin_check_contr_code -> true или false, задает необходимость проверять контрольный код (ключ безопасности) в запросе в ПУ. 
//    По умолчанию false

if ( !isset($type_answer) ) $type_answer = "ajax";
if ( !isset($type_header) ) $type_header = "nocache,texthtml";
if ( !isset($not_use_connect_db) ) $not_use_connect_db = false;
if ( !isset($not_include_class_send_mail) ) $not_include_class_send_mail = false;
if ( !isset($not_check_access_rights) ) $not_check_access_rights = false;
if ( !isset($type_rights_access) ) $type_rights_access = false;
if ( !isset($word_name_script) ) $word_name_script = "Главный скрипт";
if ( !isset($admin_check_contr_code) ) $admin_check_contr_code = false;


//session_start();

//включаем буферизацию вывода php
//ob_start();

include_once($dir_cms."/config/db_config.php");

//setlocale(LC_CTYPE,"ru_RU.utf8");
//setlocale(LC_ALL,"utf-8");
//mb_internal_encoding('UTF-8');

include_once($dir_cms."/config/robotsname.php");
include_once($dir_cms."/generalscript/functiontext.php");
include_once($dir_cms."/generalscript/funct_list_forming.php");
include_once($dir_cms."/generalscript/list_functions.php");
include_once($dir_cms."/generalscript/cl_cache_many_lvl_category.php");
include_once($dir_cms."/generalscript/lib_cms.php");
include_once($dir_cms."/generalscript/clcontroldata.php");
include_once($dir_cms."/generalscript/funct_obr_db_query.php");

include_once($dir_cms."/generalscript/funct_images.php");

include_once($dir_cms."/generalscript/strip_tags_smart.php");
include_once($dir_cms."/generalscript/funct_files.php");
include     ($dir_cms."/generalscript/kapcha.php");

//include_once($dir_cms."/generalscript/clusefiles.php");
//require_once($dir_cms."/generalscript/cluploadfiles.php");
//include_once($dir_cms."/generalscript/check_active_email.php");
//include_once($dir_cms."/generalscript/check_active_phone.php");

//require_once($dir_cms."/generalscript/eng_messenger.php");
//require_once($dir_cms."/generalscript/eng_comments.php");
//require_once($dir_cms."/generalscript/eng_subscribe_content.php");
//require_once($dir_cms."/generalscript/proc_promocode.php");
//require_once($dir_cms."/generalscript/eng_likes_content.php");
//require_once($dir_cms."/generalscript/cl_fsupload.php");


$mas_registr_class["tool_check_active_email"]="/generalscript/check_active_email.php";
$mas_registr_class["tool_check_active_phone"]="/generalscript/check_active_phone.php";

$mas_registr_class["eng_registr_user"]="/script/complement/eng_registr_user.php";
$mas_registr_class["eng_user_behavior"]="/generalscript/eng_user_behavior.php";

$mas_registr_class["classProcPromocode"]="/generalscript/proc_promocode.php";
$mas_registr_class["eng_subscribe_content"]="/generalscript/eng_subscribe_content.php";
$mas_registr_class["eng_likes_content"]="/generalscript/eng_likes_content.php";
$mas_registr_class["eng_fsupload"]="/generalscript/cl_fsupload.php";
$mas_registr_class["eng_comments"]="/generalscript/eng_comments.php";
$mas_registr_class["eng_messenger"]="/generalscript/eng_messenger.php";
$mas_registr_class["eng_payment_systems"]="/generalscript/eng_gn_payment_systems.php";
$mas_registr_class["eng_money_user"]="/generalscript/eng_money_user.php";
$mas_registr_class["eng_stop_ip_adr"]="/generalscript/eng_stop_ip_adr.php";

$mas_registr_class["processing_use_files"]="/generalscript/clusefiles.php";
$mas_registr_class["upload_files_to_server"]="/generalscript/cluploadfiles.php";

$mas_registr_class["eng_main_component_base"]="/script/components/eng_main_component_base.php";
$mas_registr_class["eng_gen_modul_page"]="/moduls/eng_gen_modul_page.php";


include("bbcode.php");
include("bbcode_boxcode.php");

include_once (DIR_CMS."/generalscript/glav_class_connect_baz.php");// файл содержит класс workBaz для покдлючения к базе данных

include_once($dir_cms."/generalscript/general_send_email.php");

require_once($dir_cms."/addapplication/dmk/dmk.class.php");

//подключаем файл функций шаблона главного модуля
require_once($dir_template."/funct_template.php");

include_once(DIR_CMS."/generalscript/eng_answer.php");
include_once(DIR_CMS."/generalscript/eng_db_error.php");

/*
if ( $type_action_part_site == "v_user" )
  {
   include_once(DIR_CMS."/script/funct_obr_err_work.php");
  }
 elseif ( $type_answer == "ajax" )
   {
    include_once(DIR_CMS."/generalscript/funct_proces_ajax_jc.php");
    include_once(DIR_CMS."/generalscript/funct_db_query_ajax_jc.php");
   }
  elseif ( $type_answer == "iframe" )
    {
     include_once(DIR_CMS."/generalscript/funct_proces_js_iframe.php");
     include_once(DIR_CMS."/generalscript/funct_db_query_js_iframe.php");
    }
  elseif ( $type_answer == "html" )
    {
     include_once(DIR_CMS."/generalscript/funct_proces_html.php");
     include_once(DIR_CMS."/generalscript/funct_db_query_html.php");
    }
*/

if ( $type_action_part_site == "v_admin" || $type_action_part_site == "wk_admin" )
  {
   include_once(DIR_ADMIN."/session_admin.php");
  }



$domen_site_url = get_domen_site_url();
$domen_site = $domen_site_url;
$dir_http = set_dir_from_path(get_server_script_name(),$num_level_dir_scr_file);
$url_site = PROTOCOL_URL_CMS."://".$domen_site_url.$dir_http;
$site_request_url = get_site_request_url();
$site_http_referer = get_site_http_referer();
$url_http = $url_site;
$dir_site_http = $dir_http;

$dir_http_template = $dir_http."/templates/".$name_template;

$dir_moduls=DIR_CMS."/moduls/";
$dir_http_moduls = $dir_http."/moduls/";

$dir_site_http_admin = $dir_site_http."/". NAME_DIR_ADMIN;
$url_http_admin_site = $url_http."/". NAME_DIR_ADMIN;

$site_type_referer = get_type_user_referer();//false, current, cross
$on_spam_referer = check_spam_referer();


$GLOBALS["pagenotfound_title"]=isset($masConfig["PAGE_NOT_FOUND_TITLE"]) ? $masConfig["PAGE_NOT_FOUND_TITLE"] : "";
$GLOBALS["pagenotfound_text"]=isset($masConfig["PAGE_NOT_FOUND_TEXT"]) ? replace_perem_texthablon($masConfig["PAGE_NOT_FOUND_TEXT"],"{:",":}",array("dir_http_template"=>$dir_http_template)) : "";

$GLOBALS["dir_moduls"]=$dir_cms."/moduls/";//глобальная переменная содержащая каталог с модулями

$GLOBALS["user_avtoriz"]=false;//авторизация пользователей на сайте (false - нет, true - да)
$GLOBALS["user_to_site"]=false;//авторизован ли пользователь на сайте (false - нет, true - да)
$GLOBALS["name_user_to_site"]="";//имя авторизованного пользователя
$GLOBALS["id_user_to_site"]=-1;//уникальный номер пользователя - поле id_user таблицы users
$GLOBALS["email_user_to_site"]="";//e-mail пользователя авторизованного на сайте
$GLOBALS["access_admin"] = "";
$GLOBALS["data_authorize_user"] = false;

$GLOBALS["user_view_country"] = -1;
$GLOBALS["user_view_region"] = -1;
$GLOBALS["user_view_city"] = -1;
$GLOBALS["user_view_name_country"] = "";
$GLOBALS["user_view_name_region"] = "";
$GLOBALS["user_view_name_city"] = "";
$GLOBALS["user_view_data_country"] = false;
$GLOBALS["user_view_data_region"] = false;
$GLOBALS["user_view_data_city"] = false;
$GLOBALS["set_geo_data_from_url"] = false;
$GLOBALS["geo_type_part"]=array("first" =>"","end"=>"","next"=>"","use"=>"","num"=>array("country"=>0,"region"=>0,"city"=>0),
  "name"=>array("country"=>"","region"=>"","city"=>""),"last_name"=>"","url"=>array("country"=>"","region"=>"","city"=>""),
  "name_list"=>array("country"=>array(),"region"=>array(),"city"=>array()));

// Вторичные ГЕО-данные - эти данные должны быть получены с url-адреса, при этом не влияют выбор основных ГЕО-данных. К примеру, на странице статьи, компании или объявления
// Учитываюся эти данные, к примеру, в модуле СЕО-тексты
$GLOBALS["geo_data_2"] = array(
 "on_set"=>false,
 
 "country_num"=>0,
 "region_num"=>0,
 "city_num"=>0,
 
 "country_name"=>"",
 "region_name"=>"",
 "city_name"=>"",
 
 "country_translit"=>"",
 "region_translit"=>"",
 "city_translit"=>"",
 
 "country_data"=>false,
 "region_data"=>false,
 "city_data"=>false,
);


$GLOBALS["param_open_url_str"]=array();
$GLOBALS["param_open_url_init"]=array();
$GLOBALS["param_open_url_union"]=array();
$GLOBALS["param_open_url_modul"]="";

$masSettings = loadSettings();

$dsOpenModul = false;
$dsOpenKeyComponent = false;
$dsOpenComponentIdent = false;
$dsOpenNumPage = false;
$dsOpenOnGetNumPage = false;
$dsOpenPageIsAddParamUrl = false;

$dsOpenKorekParam = false;

$dsOpenNsrlModul = false;
$dsOpenNsrlKeyComponent = false;
$dsOpenNsrlComponentIdent = false;
$dsOpenNsrlPageOnRelative = false;

$mas_gl_values_cms = array();

$main_cfg_tpl=array();
$main_index_cfg_tpl=array();



$ident_visitor_user="";
$ident_process_cms=generate_id_process_cms();

$mas_init_user_behavior["mainModul"]=[ 
  "user_referer"=>["Переход с сайта"],
  
];

include_once ("class_base_site.php");// файл содержит класс work_site который является главным модулем

if ($type_action_part_site == "v_user")
  {
   //$obj_site->check_param_open_url();
   list($on_addit,$use_list_name_modul)=class_base_site::check_param_open_url();
   if ($on_addit) $type_action_part_site="v_user_addit";
   if ($use_list_name_modul) $incl_name_moduls=$use_list_name_modul;
  }

if ( $type_action_part_site == "v_user" )
  {
   include_once(DIR_CMS."/script/class_base_user_part.php");
  }
 else
   {
    include_once(DIR_CMS."/script/class_base_driver_part.php");
   }


$obj_control_data=new conversion_data_get_post();


if ( ON_USE_SERVICE_MAPS )
  {
   include_once($dir_cms."/generalscript/eng_gen_manager_maps.php");// ( ON_USE_SERVICE_MAPS == "yandex" ? "clmanagermaps.php" : "clmanagermaps_google.php");
   $obj_managerMaps = new eng_gen_manager_maps();
  }



if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
  {
   include_once($dir_cms."/generalscript/clgeodata.php");
   $obj_geoData = new classGeoData();
   include_once (DIR_COMPLEMENT."geodata_site.php");
   $obj_complement_geo_user = new complement_geo_user();
  }


//if ( USE_COMP_PARTNER == 1 )
//  {
//   include_once (DIR_CMS."/generalscript/proc_partner_user.php");
//   $obj_proc_partner_user = new classProcPartnerUser();
//  }


sendheader::main($type_header);

$obj_db_connect = new glav_class_connect_baz();
$obj_baz = &$obj_db_connect;
$dbcnx = false;
if ( !$not_use_connect_db )
  {
   $dbcnx=@$obj_db_connect->connectBaz($dbhost,$dbuser,$dbpasswd,$dbname);
  }

$error=0;$error_text="no";

$GLOBALS["dbcnx"]=$dbcnx;
$GLOBALS["kol_use_db"]=0;

$mas_value_template = array(
  "dir_http" => $dir_http,
  "dir_http_template" => $dir_http_template
 );

$mas_value_template["masConfig"] = $masConfig;

if (( $type_action_part_site == "v_admin" || $type_action_part_site == "wk_admin") && !$not_check_access_rights )
  {
   
   session_admin::general_check_access($type_answer,$type_rights_access);
   
  }

if ($admin_check_contr_code)
  {
    eng_promote_safety::admin_check_code($type_answer);
  }

$tpl = new DmkTemplate;
$tpl->compile_dir = $dir_template."/templates_c/";
$tpl->config_dir = $dir_template."/configs/";
$tpl->cache_dir = $dir_template."/templates_cache/";

$spayment_adapter=array();

$infoUserAgent = info_user_agent();

eng_ident_visitor_user::set_main_ident();
//write_log_cms($ident_visitor_user,"ident visitor");

$obj_eng_cfg_tpl = new engine_cfg_tpl();

$obj_site = new work_site($dbcnx,NAME_SITE);

if ( $type_action_part_site == "v_user" )
  {
   //$obj_site->check_param_open_url();
   $obj_site->init_geo_data();
  }


if (ON_MODULS==1)
  {
   if ( !isset($incl_name_moduls) ) $incl_name_moduls = true;
   
   require (DIR_CMS."/moduls/class_main_modul.php");
   if ( $type_action_part_site == "v_user" )
     {
      require (DIR_CMS."/moduls/class_main_modul_user_part.php");
      //require (DIR_CMS."/moduls/eng_gen_modul_page.php");
     }
    else
      {
       require (DIR_CMS."/moduls/class_main_modul_driver_part.php");
      }
   
   $obj_site->on_moduls=true;
   //global $list_modules;
   $mas_moduls=array();
   $is_moduls=false;
   if ( $incl_name_moduls !== false )
     {
      foreach ($list_modules as $data_obj_modul)
        {
         if ( !($incl_name_moduls === true || ( is_array($incl_name_moduls) && in_array($data_obj_modul[0],$incl_name_moduls) ) ) ) continue;
         
         if ($data_obj_modul[2]==1)
           {
            $file_include=DIR_CMS."/moduls/".$data_obj_modul[0]."/".$data_obj_modul[0].".php";
            $file_include_part_modul = false;
            if ( $type_action_part_site == "v_user" )
              {
               $file_include_part_modul = DIR_CMS."/moduls/".$data_obj_modul[0]."/".$data_obj_modul[0]."_user_part.php";
              }
             else
               {
                $file_include_part_modul = DIR_CMS."/moduls/".$data_obj_modul[0]."/".$data_obj_modul[0]."_driver_part.php";
               }
            if (!file_exists($file_include)) continue;
            
            include_once ($file_include);
            include_once ($file_include_part_modul);
            
            if (empty(${$data_obj_modul[1]})) continue;
            if (!get_class(${$data_obj_modul[1]})) continue;
            
            $mas_moduls[$data_obj_modul[0]]=array ($data_obj_modul[1],-1,-1,$data_obj_modul[3],$data_obj_modul[0],&${$data_obj_modul[1]},$data_obj_modul[5]);
            /*
            массив содержит
            key - название модуля
            0 - имя объекта модуля
            1 - ипользуется ли с главным модулем (0 - нет, 1 - да, "-1" - не определено)
            2 - используется ли при открытии текущей страницы (0 - нет, 1 - да, "-1" - не определено)
            3 - в каком блоке шаблона модуль выводит свою информацию (название), если не выводит то -1
            4 - название модуля
            5 - объект модуля (ссылка на объект)
            */
            $is_moduls=true;
            //подключаем файл с функциями для шаблона
            if ( file_exists($dir_template_moduls."/".$data_obj_modul[0]."/funct_template.php" ) )
              {
               
               include($dir_template_moduls."/".$data_obj_modul[0]."/funct_template.php");
               
              }
            
           }
        }
      }
   
   if ($is_moduls)
     {
      $obj_site->inizial_obj_moduls($mas_moduls);
     }
  }


if ( $not_use_connect_db != true && ($type_action_part_site == "v_user" || $type_action_part_site == "wk_user" || $type_action_part_site == "v_user_addit") )
  {
   $obj_site->opredel_avtoriz();
  }

//ob_end_flush ();
