<?php


// функции для шаблонов


function ft_forming_date( $timestamp, $write_clock = false, $sep_clock = false )
  {
   global $mas_months;
   $t = "";
   $t .= date("d",$timestamp);
   $t .= " ".$mas_months[date("n",$timestamp)];
   $t .= " ".date("Y",$timestamp)." г.";
   if ( $write_clock )
     {
      $clock = date("G",$timestamp).":".date("i",$timestamp);
      $t .= ( $sep_clock ? $sep_clock : ", " ). $clock;
     }
   $t .= " ";
   return( $t );
  }


function ft_forming_date_numeric( $timestamp,$write_clock = false,$sep_clock = false )
  {
   //global $mas_month;
   $t = "";
   $t .= date("d",$timestamp);
   $t .= ".".date("n",$timestamp);
   $t .= ".".date("Y",$timestamp);
   if ( $write_clock )
     {
      $clock = date("G",$timestamp).":".date("i",$timestamp);
      $t .= ( $sep_clock ? $sep_clock : ", " ). $clock;
     }
   return( $t );
  }



function ft_key_words_components($key_words)
  {
   $t="";
   global $dir_http;
   if ( trim( $key_words) && ON_METKS_TEXT == 1)
    {
      $mas_teg=explode(",",$key_words);
      //$text.="<br>Теги: ";
      $raz=" ";
      foreach ($mas_teg as $metka)
        {
         $one_metka=mb_strtolower(trim($metka));
         //$text.=$one_metka;
         $t.=$raz."<a href='".$dir_http."/metka/".str_replace("%","_",RawUrlEncode($one_metka))."/' class=''>".$one_metka."</a>";
         $raz=", ";
        }
    }
   return ($t);
  }



function ft_forming_text_error_from_mas($error_mas,$title_error = "")
  {
   $t="";
   $t.='<div class="block_text_error_processing">';
   if ( $title_error )
     $t.="<div class='block_title_error_processing'>".$title_error."</div>";
   
   foreach ($error_mas as $one_error)
     {
      $t.="<div class='block_one_text_error_processing'> - ".$one_error."</div>";
     }
   $t.='</div>';
   return ($t);
  }

function ft_forming_text_alert($text)
  {
   return ('<div class="block_text_alert_user">'.$text.'</div>');
  }


function ft_text_cut_length($text,$max_length)
  {
   if ( mb_strlen( $text ) > $max_length )
     {
      $text = mb_substr($text,0,$max_length);
      $text .= "...";
     }
   
   return ($text);
  }


function ft_forming_atr_maxlength($max_sim,$quote = "'")
  {
   $t = "";
   if ( $max_sim > 0 )
     $t =  " maxlength=".$quote.$max_sim.$quote." ";
   
   return ( $t );
  }


function ft_forming_date_vd( $timestamp )
  {
   $t = "";
   $on_forming = false;
   
   if ( $timestamp <= $GLOBALS["timeGlobal"] && $timestamp >= ( $GLOBALS["timeGlobal"] - 2*24*3600  ) )
     {
      $masDate = getdate($GLOBALS["timeGlobal"]);
      $timestamp_today = mktime(0,0,0,$masDate["mon"]-0,$masDate["mday"]-0,$masDate["year"]-0);
      
      if ( $timestamp_today <= $timestamp )
        {
         $t = "сегодня";
         $on_forming = true;
        }
       elseif ( $timestamp < $timestamp_today && $timestamp >= ( $timestamp_today - 24*3600 ) )
         {
          $t = "вчера";
          $on_forming = true;
         }
      
     }
   
   if ( !$on_forming )
     {
      $t = date("d.m.Y",$timestamp);
     }
   
   return ($t);
  }


function ft_get_gl_value_cms($name_v,$default_v = "")
  {
   global $obj_site;
   $v = $obj_site->gl_values_cms_get_v($name_v,$default_v);
   
   return ($v);
  }


function ft_forming_bb_part($h)
  {
    $t="";
    //write_log_cms($h);
    $t=preg_replace('#<p>\s*\[code\]\s*</p>#','[code]',$h);
    $t=preg_replace('#<p>\s*\[/code\]\s*</p>#','[/code]',$t);
    
    $t=preg_replace_callback("#\[code\](.*?)\[\/code\]#si",function ($m)
     {
       //write_log_cms($m);
       $tt=preg_replace("#(<code>)(\s*)#","$1",$m[1]);
       $tt=preg_replace("#(\s*)(</code>)#","$2",$tt);
       $tt='<div class="block_code_bbcode_main">'
        .'<div class="block_code_bbcode_title">Код</div>'
        .'<div class="block_code_bbcode_content"><div class="block_code_bbcode_content_contr_pole"><div class="block_code_bbcode_content_contr_pole_2">'
        .$tt
        .'</div></div></div></div>';
       //$tt = str_replace(array("\r","\n"),"",$tt);//"\r\n","\n\r",
       return ($tt);
     },$t);
    
    return ($t);
  }


function ft_forming_atr_checked($param,$value)
  {
    $t="";
    if ($param == $value) $t=' checked="checked"';
    return ($t);
  }


function ft_check_open_page_ident($data)
  {
    //проверяем просматривается страница, заданная с помощью [модуль => [keyComponent, ..], ..], или нет
    global $dsOpenModul,$dsOpenKeyComponent;
    $open=false;
    
    if (isset($data[$dsOpenModul]))
      {
        if ($data[$dsOpenModul] === true || in_array($dsOpenKeyComponent,$data[$dsOpenModul])) $open = true;
      }
    
    return ($open);
  }

function ft_get_path_image_user($data_user)
  {
    //функция вернет путь к изображению пользователя или изображению по умолчанию
    global $dir_http,$dir_http_template;
    
    $path_img=$dir_http_template."/images/img_user_default.jpg";
    
    if ($data_user && $data_user["image_user"])
      {
        $path_img=$dir_http."/".NAME_DIR_LOADFILES. "/user_image/". $data_user["image_user"];
      }
    
    return ($path_img);
  }

function ft_replace_link_target($hcode)
  {
    //write_log_cms($hcode,"text to replace target");
    
    $text=preg_replace_callback('#<a [^>]+>#iu',function($matches){
      
      $t=$matches[0];
      
      $data_tag=eng_parse_text::get_name_mas_params_tag($t);
      //write_log_cms($data_tag,"data tag");
      if (!empty($data_tag[0]))
        {
          $new_atrs=["href"=>"","target"=>"_blank","rel"=>"nofollow"];
          if (!empty($data_tag[1]["href"]))
            {
              //Ссылка есть, проверим адрес
              if (preg_match('#^\s*javascript:#iu',$data_tag[1]["href"]) != 1)
                $new_atrs["href"] = $data_tag[1]["href"];
            }
          $t_param=eng_parse_text::splice_mas_key_params($new_atrs);
          
          $t='<a '.$t_param.'>';
        }
      
      
      return ($t);
      },$hcode);
    
    return ($text);
  }


function ft_convert_text_not_formatted($text,$on_code=false)
  {
    // Проверяем текст на форматирование, если нет тега p (<p>), то добавляем переносы строк и преобразуем текст (функцией codeHtmlText()).
    // Функция нужна для совместимости вывода текста - как оформленного с помощью визуального редактора,
    // так и обычного текста, написанного в обычном текстовом поле формы.
    
    $t=$text;
    $on_formatted=false;
    
    if (preg_match('#<p( [^>]+)?>|<br( [^>]+)?>#iu',$t)) $on_formatted=true;
    
    if (!$on_formatted)
      {
        if ($on_code)
          $t=codeHtmlText($t);
        $t=nl2br($t);
      }
    
    return ($t);
  }


function ft_get_quantity_elms($mas_data,$key,$brackets=false,$tag="",$class="")
  {
    $t="";
    $value="0";
    
    if (isset($mas_data[$key]))
      $value=$mas_data[$key];
    else
      $value="";
    
    $t=$value;
    if ($value !== "")
      {
        if ($brackets) $t = "(".$t.")";
    
        if ($tag)
          {
            $t = "<".$tag.($class ? ' class="'.$class.'"' : "").">".$t."</".$tag.">";
          }
        
        //Добавим пробел вначале
        $t=" ".$t;
      }
    
    return ($t);
  }
